var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
function noop$1() {
}
function assign(tar, src) {
  for (const k2 in src)
    tar[k2] = src[k2];
  return (
    /** @type {T & S} */
    tar
  );
}
function run(fn2) {
  return fn2();
}
function blank_object() {
  return /* @__PURE__ */ Object.create(null);
}
function run_all(fns) {
  fns.forEach(run);
}
function is_function(thing) {
  return typeof thing === "function";
}
function safe_not_equal(a2, b2) {
  return a2 != a2 ? b2 == b2 : a2 !== b2 || a2 && typeof a2 === "object" || typeof a2 === "function";
}
function is_empty(obj) {
  return Object.keys(obj).length === 0;
}
function create_slot(definition, ctx, $$scope, fn2) {
  if (definition) {
    const slot_ctx = get_slot_context(definition, ctx, $$scope, fn2);
    return definition[0](slot_ctx);
  }
}
function get_slot_context(definition, ctx, $$scope, fn2) {
  return definition[1] && fn2 ? assign($$scope.ctx.slice(), definition[1](fn2(ctx))) : $$scope.ctx;
}
function get_slot_changes(definition, $$scope, dirty, fn2) {
  if (definition[2] && fn2) {
    const lets = definition[2](fn2(dirty));
    if ($$scope.dirty === void 0) {
      return lets;
    }
    if (typeof lets === "object") {
      const merged = [];
      const len = Math.max($$scope.dirty.length, lets.length);
      for (let i = 0; i < len; i += 1) {
        merged[i] = $$scope.dirty[i] | lets[i];
      }
      return merged;
    }
    return $$scope.dirty | lets;
  }
  return $$scope.dirty;
}
function update_slot_base(slot, slot_definition, ctx, $$scope, slot_changes, get_slot_context_fn) {
  if (slot_changes) {
    const slot_context = get_slot_context(slot_definition, ctx, $$scope, get_slot_context_fn);
    slot.p(slot_context, slot_changes);
  }
}
function get_all_dirty_from_scope($$scope) {
  if ($$scope.ctx.length > 32) {
    const dirty = [];
    const length = $$scope.ctx.length / 32;
    for (let i = 0; i < length; i++) {
      dirty[i] = -1;
    }
    return dirty;
  }
  return -1;
}
function null_to_empty(value) {
  return value == null ? "" : value;
}
function append(target, node) {
  target.appendChild(node);
}
function append_styles(target, style_sheet_id, styles) {
  const append_styles_to = get_root_for_style(target);
  if (!append_styles_to.getElementById(style_sheet_id)) {
    const style = element("style");
    style.id = style_sheet_id;
    style.textContent = styles;
    append_stylesheet(append_styles_to, style);
  }
}
function get_root_for_style(node) {
  if (!node)
    return document;
  const root = node.getRootNode ? node.getRootNode() : node.ownerDocument;
  if (root && /** @type {ShadowRoot} */
  root.host) {
    return (
      /** @type {ShadowRoot} */
      root
    );
  }
  return node.ownerDocument;
}
function append_stylesheet(node, style) {
  append(
    /** @type {Document} */
    node.head || node,
    style
  );
  return style.sheet;
}
function insert(target, node, anchor) {
  target.insertBefore(node, anchor || null);
}
function detach(node) {
  if (node.parentNode) {
    node.parentNode.removeChild(node);
  }
}
function destroy_each(iterations, detaching) {
  for (let i = 0; i < iterations.length; i += 1) {
    if (iterations[i])
      iterations[i].d(detaching);
  }
}
function element(name) {
  return document.createElement(name);
}
function svg_element(name) {
  return document.createElementNS("http://www.w3.org/2000/svg", name);
}
function text(data) {
  return document.createTextNode(data);
}
function space() {
  return text(" ");
}
function empty() {
  return text("");
}
function listen(node, event, handler, options) {
  node.addEventListener(event, handler, options);
  return () => node.removeEventListener(event, handler, options);
}
function attr(node, attribute, value) {
  if (value == null)
    node.removeAttribute(attribute);
  else if (node.getAttribute(attribute) !== value)
    node.setAttribute(attribute, value);
}
function to_number(value) {
  return value === "" ? null : +value;
}
function children(element2) {
  return Array.from(element2.childNodes);
}
function set_data(text2, data) {
  data = "" + data;
  if (text2.data === data)
    return;
  text2.data = /** @type {string} */
  data;
}
function set_input_value(input, value) {
  input.value = value == null ? "" : value;
}
function set_style(node, key, value, important) {
  if (value == null) {
    node.style.removeProperty(key);
  } else {
    node.style.setProperty(key, value, important ? "important" : "");
  }
}
function toggle_class(element2, name, toggle) {
  element2.classList.toggle(name, !!toggle);
}
function get_custom_elements_slots(element2) {
  const result = {};
  element2.childNodes.forEach(
    /** @param {Element} node */
    (node) => {
      result[node.slot || "default"] = true;
    }
  );
  return result;
}
let current_component;
function set_current_component(component) {
  current_component = component;
}
function get_current_component() {
  if (!current_component)
    throw new Error("Function called outside component initialization");
  return current_component;
}
function onMount(fn2) {
  get_current_component().$$.on_mount.push(fn2);
}
const dirty_components = [];
const binding_callbacks = [];
let render_callbacks = [];
const flush_callbacks = [];
const resolved_promise = /* @__PURE__ */ Promise.resolve();
let update_scheduled = false;
function schedule_update() {
  if (!update_scheduled) {
    update_scheduled = true;
    resolved_promise.then(flush);
  }
}
function tick() {
  schedule_update();
  return resolved_promise;
}
function add_render_callback(fn2) {
  render_callbacks.push(fn2);
}
const seen_callbacks = /* @__PURE__ */ new Set();
let flushidx = 0;
function flush() {
  if (flushidx !== 0) {
    return;
  }
  const saved_component = current_component;
  do {
    try {
      while (flushidx < dirty_components.length) {
        const component = dirty_components[flushidx];
        flushidx++;
        set_current_component(component);
        update(component.$$);
      }
    } catch (e2) {
      dirty_components.length = 0;
      flushidx = 0;
      throw e2;
    }
    set_current_component(null);
    dirty_components.length = 0;
    flushidx = 0;
    while (binding_callbacks.length)
      binding_callbacks.pop()();
    for (let i = 0; i < render_callbacks.length; i += 1) {
      const callback2 = render_callbacks[i];
      if (!seen_callbacks.has(callback2)) {
        seen_callbacks.add(callback2);
        callback2();
      }
    }
    render_callbacks.length = 0;
  } while (dirty_components.length);
  while (flush_callbacks.length) {
    flush_callbacks.pop()();
  }
  update_scheduled = false;
  seen_callbacks.clear();
  set_current_component(saved_component);
}
function update($$) {
  if ($$.fragment !== null) {
    $$.update();
    run_all($$.before_update);
    const dirty = $$.dirty;
    $$.dirty = [-1];
    $$.fragment && $$.fragment.p($$.ctx, dirty);
    $$.after_update.forEach(add_render_callback);
  }
}
function flush_render_callbacks(fns) {
  const filtered = [];
  const targets = [];
  render_callbacks.forEach((c2) => fns.indexOf(c2) === -1 ? filtered.push(c2) : targets.push(c2));
  targets.forEach((c2) => c2());
  render_callbacks = filtered;
}
const outroing = /* @__PURE__ */ new Set();
let outros;
function group_outros() {
  outros = {
    r: 0,
    c: [],
    p: outros
    // parent group
  };
}
function check_outros() {
  if (!outros.r) {
    run_all(outros.c);
  }
  outros = outros.p;
}
function transition_in(block, local) {
  if (block && block.i) {
    outroing.delete(block);
    block.i(local);
  }
}
function transition_out(block, local, detach2, callback2) {
  if (block && block.o) {
    if (outroing.has(block))
      return;
    outroing.add(block);
    outros.c.push(() => {
      outroing.delete(block);
      if (callback2) {
        if (detach2)
          block.d(1);
        callback2();
      }
    });
    block.o(local);
  } else if (callback2) {
    callback2();
  }
}
function ensure_array_like(array_like_or_iterator) {
  return (array_like_or_iterator == null ? void 0 : array_like_or_iterator.length) !== void 0 ? array_like_or_iterator : Array.from(array_like_or_iterator);
}
function destroy_block(block, lookup) {
  block.d(1);
  lookup.delete(block.key);
}
function outro_and_destroy_block(block, lookup) {
  transition_out(block, 1, 1, () => {
    lookup.delete(block.key);
  });
}
function update_keyed_each(old_blocks, dirty, get_key, dynamic, ctx, list, lookup, node, destroy, create_each_block2, next, get_context) {
  let o2 = old_blocks.length;
  let n = list.length;
  let i = o2;
  const old_indexes = {};
  while (i--)
    old_indexes[old_blocks[i].key] = i;
  const new_blocks = [];
  const new_lookup = /* @__PURE__ */ new Map();
  const deltas = /* @__PURE__ */ new Map();
  const updates = [];
  i = n;
  while (i--) {
    const child_ctx = get_context(ctx, list, i);
    const key = get_key(child_ctx);
    let block = lookup.get(key);
    if (!block) {
      block = create_each_block2(key, child_ctx);
      block.c();
    } else if (dynamic) {
      updates.push(() => block.p(child_ctx, dirty));
    }
    new_lookup.set(key, new_blocks[i] = block);
    if (key in old_indexes)
      deltas.set(key, Math.abs(i - old_indexes[key]));
  }
  const will_move = /* @__PURE__ */ new Set();
  const did_move = /* @__PURE__ */ new Set();
  function insert2(block) {
    transition_in(block, 1);
    block.m(node, next);
    lookup.set(block.key, block);
    next = block.first;
    n--;
  }
  while (o2 && n) {
    const new_block = new_blocks[n - 1];
    const old_block = old_blocks[o2 - 1];
    const new_key = new_block.key;
    const old_key = old_block.key;
    if (new_block === old_block) {
      next = new_block.first;
      o2--;
      n--;
    } else if (!new_lookup.has(old_key)) {
      destroy(old_block, lookup);
      o2--;
    } else if (!lookup.has(new_key) || will_move.has(new_key)) {
      insert2(new_block);
    } else if (did_move.has(old_key)) {
      o2--;
    } else if (deltas.get(new_key) > deltas.get(old_key)) {
      did_move.add(new_key);
      insert2(new_block);
    } else {
      will_move.add(old_key);
      o2--;
    }
  }
  while (o2--) {
    const old_block = old_blocks[o2];
    if (!new_lookup.has(old_block.key))
      destroy(old_block, lookup);
  }
  while (n)
    insert2(new_blocks[n - 1]);
  run_all(updates);
  return new_blocks;
}
function create_component(block) {
  block && block.c();
}
function mount_component(component, target, anchor) {
  const { fragment, after_update } = component.$$;
  fragment && fragment.m(target, anchor);
  add_render_callback(() => {
    const new_on_destroy = component.$$.on_mount.map(run).filter(is_function);
    if (component.$$.on_destroy) {
      component.$$.on_destroy.push(...new_on_destroy);
    } else {
      run_all(new_on_destroy);
    }
    component.$$.on_mount = [];
  });
  after_update.forEach(add_render_callback);
}
function destroy_component(component, detaching) {
  const $$ = component.$$;
  if ($$.fragment !== null) {
    flush_render_callbacks($$.after_update);
    run_all($$.on_destroy);
    $$.fragment && $$.fragment.d(detaching);
    $$.on_destroy = $$.fragment = null;
    $$.ctx = [];
  }
}
function make_dirty(component, i) {
  if (component.$$.dirty[0] === -1) {
    dirty_components.push(component);
    schedule_update();
    component.$$.dirty.fill(0);
  }
  component.$$.dirty[i / 31 | 0] |= 1 << i % 31;
}
function init(component, options, instance2, create_fragment2, not_equal, props, append_styles2, dirty = [-1]) {
  const parent_component = current_component;
  set_current_component(component);
  const $$ = component.$$ = {
    fragment: null,
    ctx: [],
    // state
    props,
    update: noop$1,
    not_equal,
    bound: blank_object(),
    // lifecycle
    on_mount: [],
    on_destroy: [],
    on_disconnect: [],
    before_update: [],
    after_update: [],
    context: new Map(options.context || (parent_component ? parent_component.$$.context : [])),
    // everything else
    callbacks: blank_object(),
    dirty,
    skip_bound: false,
    root: options.target || parent_component.$$.root
  };
  append_styles2 && append_styles2($$.root);
  let ready = false;
  $$.ctx = instance2 ? instance2(component, options.props || {}, (i, ret, ...rest) => {
    const value = rest.length ? rest[0] : ret;
    if ($$.ctx && not_equal($$.ctx[i], $$.ctx[i] = value)) {
      if (!$$.skip_bound && $$.bound[i])
        $$.bound[i](value);
      if (ready)
        make_dirty(component, i);
    }
    return ret;
  }) : [];
  $$.update();
  ready = true;
  run_all($$.before_update);
  $$.fragment = create_fragment2 ? create_fragment2($$.ctx) : false;
  if (options.target) {
    if (options.hydrate) {
      const nodes = children(options.target);
      $$.fragment && $$.fragment.l(nodes);
      nodes.forEach(detach);
    } else {
      $$.fragment && $$.fragment.c();
    }
    if (options.intro)
      transition_in(component.$$.fragment);
    mount_component(component, options.target, options.anchor);
    flush();
  }
  set_current_component(parent_component);
}
let SvelteElement;
if (typeof HTMLElement === "function") {
  SvelteElement = class extends HTMLElement {
    constructor($$componentCtor, $$slots, use_shadow_dom) {
      super();
      /** The Svelte component constructor */
      __publicField(this, "$$ctor");
      /** Slots */
      __publicField(this, "$$s");
      /** The Svelte component instance */
      __publicField(this, "$$c");
      /** Whether or not the custom element is connected */
      __publicField(this, "$$cn", false);
      /** Component props data */
      __publicField(this, "$$d", {});
      /** `true` if currently in the process of reflecting component props back to attributes */
      __publicField(this, "$$r", false);
      /** @type {Record<string, CustomElementPropDefinition>} Props definition (name, reflected, type etc) */
      __publicField(this, "$$p_d", {});
      /** @type {Record<string, Function[]>} Event listeners */
      __publicField(this, "$$l", {});
      /** @type {Map<Function, Function>} Event listener unsubscribe functions */
      __publicField(this, "$$l_u", /* @__PURE__ */ new Map());
      this.$$ctor = $$componentCtor;
      this.$$s = $$slots;
      if (use_shadow_dom) {
        this.attachShadow({ mode: "open" });
      }
    }
    addEventListener(type, listener, options) {
      this.$$l[type] = this.$$l[type] || [];
      this.$$l[type].push(listener);
      if (this.$$c) {
        const unsub = this.$$c.$on(type, listener);
        this.$$l_u.set(listener, unsub);
      }
      super.addEventListener(type, listener, options);
    }
    removeEventListener(type, listener, options) {
      super.removeEventListener(type, listener, options);
      if (this.$$c) {
        const unsub = this.$$l_u.get(listener);
        if (unsub) {
          unsub();
          this.$$l_u.delete(listener);
        }
      }
    }
    async connectedCallback() {
      this.$$cn = true;
      if (!this.$$c) {
        let create_slot2 = function(name) {
          return () => {
            let node;
            const obj = {
              c: function create() {
                node = element("slot");
                if (name !== "default") {
                  attr(node, "name", name);
                }
              },
              /**
               * @param {HTMLElement} target
               * @param {HTMLElement} [anchor]
               */
              m: function mount(target, anchor) {
                insert(target, node, anchor);
              },
              d: function destroy(detaching) {
                if (detaching) {
                  detach(node);
                }
              }
            };
            return obj;
          };
        };
        await Promise.resolve();
        if (!this.$$cn) {
          return;
        }
        const $$slots = {};
        const existing_slots = get_custom_elements_slots(this);
        for (const name of this.$$s) {
          if (name in existing_slots) {
            $$slots[name] = [create_slot2(name)];
          }
        }
        for (const attribute of this.attributes) {
          const name = this.$$g_p(attribute.name);
          if (!(name in this.$$d)) {
            this.$$d[name] = get_custom_element_value(name, attribute.value, this.$$p_d, "toProp");
          }
        }
        this.$$c = new this.$$ctor({
          target: this.shadowRoot || this,
          props: {
            ...this.$$d,
            $$slots,
            $$scope: {
              ctx: []
            }
          }
        });
        const reflect_attributes = () => {
          this.$$r = true;
          for (const key in this.$$p_d) {
            this.$$d[key] = this.$$c.$$.ctx[this.$$c.$$.props[key]];
            if (this.$$p_d[key].reflect) {
              const attribute_value = get_custom_element_value(
                key,
                this.$$d[key],
                this.$$p_d,
                "toAttribute"
              );
              if (attribute_value == null) {
                this.removeAttribute(key);
              } else {
                this.setAttribute(this.$$p_d[key].attribute || key, attribute_value);
              }
            }
          }
          this.$$r = false;
        };
        this.$$c.$$.after_update.push(reflect_attributes);
        reflect_attributes();
        for (const type in this.$$l) {
          for (const listener of this.$$l[type]) {
            const unsub = this.$$c.$on(type, listener);
            this.$$l_u.set(listener, unsub);
          }
        }
        this.$$l = {};
      }
    }
    // We don't need this when working within Svelte code, but for compatibility of people using this outside of Svelte
    // and setting attributes through setAttribute etc, this is helpful
    attributeChangedCallback(attr2, _oldValue, newValue) {
      var _a;
      if (this.$$r)
        return;
      attr2 = this.$$g_p(attr2);
      this.$$d[attr2] = get_custom_element_value(attr2, newValue, this.$$p_d, "toProp");
      (_a = this.$$c) == null ? void 0 : _a.$set({ [attr2]: this.$$d[attr2] });
    }
    disconnectedCallback() {
      this.$$cn = false;
      Promise.resolve().then(() => {
        if (!this.$$cn) {
          this.$$c.$destroy();
          this.$$c = void 0;
        }
      });
    }
    $$g_p(attribute_name) {
      return Object.keys(this.$$p_d).find(
        (key) => this.$$p_d[key].attribute === attribute_name || !this.$$p_d[key].attribute && key.toLowerCase() === attribute_name
      ) || attribute_name;
    }
  };
}
function get_custom_element_value(prop, value, props_definition, transform) {
  var _a;
  const type = (_a = props_definition[prop]) == null ? void 0 : _a.type;
  value = type === "Boolean" && typeof value !== "boolean" ? value != null : value;
  if (!transform || !props_definition[prop]) {
    return value;
  } else if (transform === "toAttribute") {
    switch (type) {
      case "Object":
      case "Array":
        return value == null ? null : JSON.stringify(value);
      case "Boolean":
        return value ? "" : null;
      case "Number":
        return value == null ? null : value;
      default:
        return value;
    }
  } else {
    switch (type) {
      case "Object":
      case "Array":
        return value && JSON.parse(value);
      case "Boolean":
        return value;
      case "Number":
        return value != null ? +value : value;
      default:
        return value;
    }
  }
}
function create_custom_element(Component, props_definition, slots, accessors, use_shadow_dom) {
  const Class = class extends SvelteElement {
    constructor() {
      super(Component, slots, use_shadow_dom);
      this.$$p_d = props_definition;
    }
    static get observedAttributes() {
      return Object.keys(props_definition).map(
        (key) => (props_definition[key].attribute || key).toLowerCase()
      );
    }
  };
  Object.keys(props_definition).forEach((prop) => {
    Object.defineProperty(Class.prototype, prop, {
      get() {
        return this.$$c && prop in this.$$c ? this.$$c[prop] : this.$$d[prop];
      },
      set(value) {
        var _a;
        value = get_custom_element_value(prop, value, props_definition);
        this.$$d[prop] = value;
        (_a = this.$$c) == null ? void 0 : _a.$set({ [prop]: value });
      }
    });
  });
  accessors.forEach((accessor) => {
    Object.defineProperty(Class.prototype, accessor, {
      get() {
        var _a;
        return (_a = this.$$c) == null ? void 0 : _a[accessor];
      }
    });
  });
  Component.element = /** @type {any} */
  Class;
  return Class;
}
class SvelteComponent {
  constructor() {
    /**
     * ### PRIVATE API
     *
     * Do not use, may change at any time
     *
     * @type {any}
     */
    __publicField(this, "$$");
    /**
     * ### PRIVATE API
     *
     * Do not use, may change at any time
     *
     * @type {any}
     */
    __publicField(this, "$$set");
  }
  /** @returns {void} */
  $destroy() {
    destroy_component(this, 1);
    this.$destroy = noop$1;
  }
  /**
   * @template {Extract<keyof Events, string>} K
   * @param {K} type
   * @param {((e: Events[K]) => void) | null | undefined} callback
   * @returns {() => void}
   */
  $on(type, callback2) {
    if (!is_function(callback2)) {
      return noop$1;
    }
    const callbacks = this.$$.callbacks[type] || (this.$$.callbacks[type] = []);
    callbacks.push(callback2);
    return () => {
      const index = callbacks.indexOf(callback2);
      if (index !== -1)
        callbacks.splice(index, 1);
    };
  }
  /**
   * @param {Partial<Props>} props
   * @returns {void}
   */
  $set(props) {
    if (this.$$set && !is_empty(props)) {
      this.$$.skip_bound = true;
      this.$$set(props);
      this.$$.skip_bound = false;
    }
  }
}
const PUBLIC_VERSION = "4";
if (typeof window !== "undefined")
  (window.__svelte || (window.__svelte = { v: /* @__PURE__ */ new Set() })).v.add(PUBLIC_VERSION);
const IMetricsKeysOrder = [
  {
    backtest: [
      "startDate",
      "endDate",
      "version",
      "feeRatio",
      "taxRatio",
      "tradeAt",
      "market",
      "freq",
      "updateDate",
      "nextTradingDate",
      "livePerformanceStart",
      "stopLoss",
      "takeProfit"
    ]
  },
  {
    profitability: ["annualReturn", "alpha", "beta", "avgNStock", "maxNStock"]
  },
  {
    risk: ["maxDrawdown", "avgDrawdown", "avgDrawdownDays", "valueAtRisk", "cvalueAtRisk"]
  },
  {
    ratio: ["sharpeRatio", "sortinoRatio", "calmarRatio", "profitFactor", "tailRatio"]
  },
  {
    winrate: ["winRate", "m12WinRate", "expectancy", "mae", "mfe"]
  },
  {
    liquidity: [
      "capacity",
      "disposalStockRatio",
      "warningStockRatio",
      "fullDeliveryStockRatio",
      "buyHigh",
      "sellLow"
    ]
  }
];
function orderMetricsByKeys(obj) {
  const ordered = {};
  const keysOrder = IMetricsKeysOrder;
  for (const item of keysOrder) {
    for (const key in item) {
      ordered[key] = {};
      for (const k2 of item[key]) {
        ordered[key][k2] = obj[key][k2];
      }
    }
  }
  return ordered;
}
const qualityMetrics = {
  // profitability
  profitability: {
    annualReturn: (value) => value > 0.15,
    // Assuming a good annual return is over 8%
    alpha: (value) => value > 0.1,
    // Positive alpha indicates outperformance
    beta: (value) => value < 0.8 && value > 0,
    // Beta between 0 and 1 suggests less volatility than market
    avgNStock: (value) => value >= 5,
    // Assuming holding more than 10 stocks on average is diverse enough
    maxNStock: (value) => value <= 20
    // Assuming holding less than 50 stocks as a cap is ideal
  },
  // risk
  risk: {
    maxDrawdown: (value) => value > -0.3,
    // Less than 20% max drawdown is acceptable
    avgDrawdown: (value) => value > -0.1,
    // Less than 10% average drawdown is acceptable
    avgDrawdownDays: (value) => value < 40,
    // Assuming less than 40 days for recovery is good
    volatility: (value) => value < 0.2,
    // Volatility less than 20% is considered low
    valueAtRisk: (value) => value > -0.07,
    // VaR of less than 5% loss is considered safe
    cvalueAtRisk: (value) => value > -0.1
    // CVaR of less than 10% loss is considered safe
  },
  // ratio
  ratio: {
    sharpeRatio: (value) => value > 1.3,
    // Greater than 1 is generally considered acceptable for Sharpe Ratio
    sortinoRatio: (value) => value > 1.8,
    // Same for Sortino, though context varies
    calmarRatio: (value) => value > 0.9,
    // Calmar Ratio > 1 indicates return is higher than max drawdown
    profitFactor: (value) => value > 1.5,
    // Assuming a profit factor greater than 1.5 is good
    tailRatio: (value) => value > 1
    // Tail Ratio > 0.9 suggests good extreme returns behavior
  },
  // winrate
  winrate: {
    winRate: (value) => value > 0.55,
    // Assuming a 60% win rate is good
    m12WinRate: (value) => value > 0.7,
    // Assuming a 50% win rate over 12 months is good
    expectancy: (value) => value > 0.02,
    // Positive expectancy is crucial for a profitable strategy
    mae: (value) => value > -0.1,
    // Assuming a max adverse excursion of less than 10% is good
    mfe: (value) => value > 0.1
    // Assuming a min favorable excursion of at least 10% is good
  },
  liquidity: {
    capacity: (value) => value > 5e5,
    // Assuming a strategy should handle at least $1M capacity
    disposalStockRatio: (value) => value < 0.05,
    warningStockRatio: (value) => value < 0.05,
    fullDeliveryStockRatio: (value) => value < 0.05,
    buyHigh: (value) => value < 0.05,
    sellLow: (value) => value < 0.05
  }
};
function calculateScores(metrics2) {
  const scores = {
    profitability: 0,
    risk: 0,
    ratio: 0,
    winrate: 0,
    liquidity: 0
  };
  for (const category in qualityMetrics) {
    for (const metric in qualityMetrics[category]) {
      if (qualityMetrics[category][metric](metrics2[category][metric])) {
        scores[category]++;
        if (category === "liquidity" && metric === "capacity") {
          scores[category] += 10;
        }
      }
    }
  }
  for (const category in scores) {
    let l2 = Object.keys(qualityMetrics[category]).length;
    if (category === "liquidity") {
      l2 += 10;
    }
    scores[category] = scores[category] / l2;
  }
  return scores;
}
class MetricDisplay {
  constructor() {
    this.percentage = (v2) => (v2 * 100).toFixed(1);
    this.sign = (v2) => typeof v2 === "string" && v2[0] != "-" || typeof v2 === "number" && v2 > 0 ? "+" + String(v2) : String(v2);
    this.color = (v2) => v2 > 0 ? "text-rise" : "text-fall";
    this.formatter = {
      annualReturn: (v2) => this.sign(this.percentage(v2)),
      alpha: (v2) => this.sign(this.percentage(v2)),
      avgNStock: (value) => value.toFixed(0),
      maxNStock: (value) => value.toFixed(0),
      maxDrawdown: (v2) => this.sign(this.percentage(v2)),
      avgDrawdown: (v2) => this.sign(this.percentage(v2)),
      valueAtRisk: (v2) => this.sign(this.percentage(v2)),
      cvalueAtRisk: (v2) => this.sign(this.percentage(v2)),
      winRate: (v2) => this.percentage(v2),
      m12WinRate: (v2) => this.percentage(v2),
      expectancy: (v2) => this.sign(this.percentage(v2)),
      mae: (v2) => this.sign(this.percentage(v2)),
      mfe: (v2) => this.sign(this.percentage(v2)),
      smallCapRatio: (v2) => this.percentage(v2),
      capacity: (v2) => (v2 / 1e4).toFixed(0),
      disposalStockRatio: (v2) => this.percentage(v2),
      warningStockRatio: (v2) => this.percentage(v2),
      fullDeliveryStockRatio: (v2) => this.percentage(v2),
      buyHigh: (v2) => this.percentage(v2),
      sellLow: (v2) => this.percentage(v2)
    };
    this.units = {
      annualReturn: "%",
      alpha: "%",
      avgNStock: "檔",
      maxNStock: "檔",
      maxDrawdown: "%",
      avgDrawdown: "%",
      avgDrawdownDays: "天",
      valueAtRisk: "%",
      cvalueAtRisk: "%",
      winRate: "%",
      m12WinRate: "%",
      expectancy: "%",
      mae: "%",
      mfe: "%",
      smallCapRatio: "%",
      capacity: "萬",
      disposalStockRatio: "%",
      warningStockRatio: "%",
      fullDeliveryStockRatio: "%",
      buyHigh: "%",
      sellLow: "%"
    };
  }
  format(name, val) {
    if (name in this.formatter) {
      return this.formatter[name](val);
    }
    try {
      return String(val.toFixed(2));
    } catch {
      return val;
    }
  }
  getUnit(name) {
    if (name in this.units) {
      return this.units[name];
    }
    return "";
  }
}
function findNextOrPreviousIndex(arr, target) {
  let left = 0;
  let right = arr.length - 1;
  let result = -1;
  while (left <= right) {
    const mid = Math.ceil((left + right) / 2);
    if (arr[mid] === target) {
      return mid;
    } else if (arr[mid] < target) {
      result = mid;
      left = mid + 1;
    } else {
      result = mid;
      right = mid - 1;
    }
  }
  if (target > arr[result]) {
    result += 1;
  }
  return result;
}
function binaryInsert(value, array, startVal, endVal) {
  let length = array.length;
  let start = typeof startVal != "undefined" ? startVal : 0;
  let end = typeof endVal != "undefined" ? endVal : length - 1;
  let m2 = start + Math.floor((end - start) / 2);
  if (length === 0) {
    array.push(value);
    return;
  }
  if (value >= array[end]) {
    array.splice(end + 1, 0, value);
    return;
  }
  if (value < array[start]) {
    array.splice(start, 0, value);
    return;
  }
  if (start >= end) {
    return;
  }
  if (value <= array[m2]) {
    binaryInsert(value, array, start, m2);
    return;
  }
  if (value > array[m2]) {
    binaryInsert(value, array, m2 + 1, end);
    return;
  }
}
function calculateQuantileSeries(numbers2, quantile2, windowSize) {
  let window2 = [];
  let result = [];
  numbers2.slice(0, windowSize).forEach((n) => binaryInsert(n, window2));
  for (let i = windowSize; i < numbers2.length; i++) {
    result.push(window2[Math.floor(windowSize * quantile2)]);
    window2.splice(window2.indexOf(numbers2[i - windowSize]), 1);
    binaryInsert(numbers2[i], window2);
  }
  result.push(window2[Math.floor(windowSize * quantile2)]);
  return result;
}
class Report {
  constructor(timestamps, creturns, benchmark2, trades, metrics2) {
    this.timestamps = timestamps;
    this.strategy = creturns;
    this.benchmark = benchmark2;
    this.trades = trades;
    this.metrics = metrics2;
  }
  createTradingviewSeries(name, start = 0, end = -1, nlimit = 500) {
    const ret = this.timestamps.map((time, index) => {
      return {
        time,
        value: this[name][index]
      };
    }).slice(this.indexOfTimestamps(start), this.indexOfTimestamps(end) + 1);
    const isPreviousDateDifferentMonth = this.timestamps.map(
      (date, index) => index === 0 || date.substring(0, 7) !== this.timestamps[index - 1].substring(0, 7)
    );
    const n = Math.round(ret.length / nlimit);
    return ret.filter(
      (_2, index) => index % n === 0 || index === ret.length - 1 || isPreviousDateDifferentMonth[index]
    );
  }
  indexOfTimestamps(loc) {
    if (typeof loc === "string") {
      return findNextOrPreviousIndex(this.timestamps, loc);
    }
    if (loc < 0) {
      return Math.min(Math.max(this.timestamps.length + loc, 0), this.timestamps.length - 1);
    }
    return loc;
  }
  calculateAnnualReturn(name) {
    this.timestamps.length != 0;
    const startYear = new Date(this.timestamps[0]).getFullYear();
    const endYear = new Date(this.timestamps[this.timestamps.length - 1]).getFullYear();
    const ret = {};
    for (let year = startYear; year <= endYear; year += 1) {
      let idxStart = this.indexOfTimestamps(String(year) + "-01-01");
      let idxEnd = this.indexOfTimestamps(String(year + 1) + "-01-01");
      if (idxStart < 0)
        idxStart = 0;
      if (idxEnd > this.timestamps.length - 1)
        idxEnd = this.timestamps.length - 1;
      const capStart = this[name][idxStart];
      const capEnd = this[name][idxEnd];
      ret[year] = capEnd / capStart - 1;
    }
    return ret;
  }
  calculateMonthlyReturn(name) {
    const startYear = new Date(this.timestamps[0]).getFullYear();
    const endYear = new Date(this.timestamps[this.timestamps.length - 1]).getFullYear();
    const ret = {};
    for (let year = startYear; year <= endYear; year += 1) {
      for (let month = 1; month <= 12; month += 1) {
        const days = new Date(year, month, 0).getDate();
        const formatMonth = (month < 10 ? "0" : "") + month;
        const idxStart = this.indexOfTimestamps(`${year}-${formatMonth}-1`);
        const idxEnd = this.indexOfTimestamps(`${year}-${formatMonth}-${days}`);
        const capStart = this[name][idxStart];
        const capEnd = this[name][idxEnd];
        ret[`${year}${month}`] = capEnd / capStart - 1;
      }
    }
    return ret;
  }
  calculateMostRecentNDayReturn(name, period) {
    const series = this[name];
    const seriesLength = series.length;
    const ret = {};
    for (const n of period) {
      const nNumber = parseInt(n);
      if (seriesLength < nNumber) {
        continue;
      }
      const endValue = series[seriesLength - 1];
      const startValue = series[seriesLength - nNumber - 1];
      const nDayReturn = (endValue / startValue - 1) * 100;
      ret[n] = nDayReturn;
    }
    return ret;
  }
  createTradingViewDrawdown(name, nlimit = 100) {
    let high = 100;
    let history = [];
    const series = this[name];
    for (let i = 0; i < this.timestamps.length; i += 1) {
      high = Math.max(series[i], high);
      history.push(series[i] / high * 100 - 100);
    }
    const n = Math.round(history.length / nlimit);
    function rollingMin(arr, windowSize) {
      let deque = [];
      let result = [];
      for (let i = 0; i < arr.length; i++) {
        while (deque.length > 0 && arr[i] < arr[deque[deque.length - 1]]) {
          deque.pop();
        }
        deque.push(i);
        if (deque[0] < i - windowSize + 1) {
          deque.shift();
        }
        if (i >= windowSize - 1) {
          result.push(arr[deque[0]]);
        }
      }
      return result;
    }
    const rollingMeanHistory = rollingMin(history, n);
    let ret = this.timestamps.map((time, index) => {
      return {
        time,
        value: rollingMeanHistory[index]
      };
    });
    return ret.filter((_2, index) => index % n === 0 || index === ret.length - 1);
  }
  calculateDrawdown(name) {
    let ts2 = 0;
    let high = 1;
    let drawdown = 1;
    let maxDrawdownTime = 0;
    let records = [];
    const series = this[name];
    for (let i = 0; i < this.timestamps.length; i += 1) {
      const v2 = series[i];
      if (v2 > high) {
        if (i - ts2 >= 2) {
          records.push({
            maxDrawdown: drawdown - 1,
            start: ts2,
            end: i,
            at: maxDrawdownTime
          });
        }
        ts2 = i;
        high = v2;
        drawdown = 1;
        maxDrawdownTime = i;
      } else {
        const newDrawdown = v2 / high;
        if (drawdown > newDrawdown) {
          drawdown = newDrawdown;
          maxDrawdownTime = i;
        }
      }
    }
    records.sort((a2, b2) => -(a2.end - a2.start) + (b2.end - b2.start));
    const top10days = records.slice(0, 5);
    records.sort((a2, b2) => a2.maxDrawdown - b2.maxDrawdown);
    const top10drawdown = records.slice(0, 5);
    return [top10drawdown, top10days];
  }
  calculateSharpe(name, riskFreeReturn, windowSize) {
    let sharpeRatios = [];
    let sum = 0;
    let sqSum = 0;
    let fifoVal = [];
    let fifoSq = [];
    const cumulativeReturns = this[name];
    for (let i = 1; i < cumulativeReturns.length; i++) {
      let val = cumulativeReturns[i] / cumulativeReturns[i - 1] - 1;
      fifoVal.push(val);
      sum += val;
      let mean = sum / windowSize;
      let sq = (val - mean) * (val - mean);
      fifoSq.push(sq);
      sqSum += sq;
      if (i >= windowSize) {
        let outVal = fifoVal.shift();
        let outSq = fifoSq.shift();
        sum -= outVal;
        sqSum -= outSq;
      }
      if (i >= windowSize - 1) {
        let variance = sqSum / windowSize;
        let stdDev = Math.sqrt(variance);
        let sharpeRatio = (mean - riskFreeReturn) / stdDev;
        sharpeRatios.push(sharpeRatio);
      }
    }
    return sharpeRatios.map((val, index) => {
      return {
        time: this.timestamps[index + windowSize - 1],
        value: val * Math.sqrt(windowSize)
      };
    });
  }
  calculateSortino(name, riskFreeReturn, windowSize) {
    let sharpeRatios = [];
    let sum = 0;
    let sqSum = 0;
    let fifoVal = [];
    let fifoSq = [];
    const cumulativeReturns = this[name];
    for (let i = 1; i < cumulativeReturns.length; i++) {
      let val = cumulativeReturns[i] / cumulativeReturns[i - 1] - 1;
      sum += val;
      fifoVal.push(val);
      let mean = sum / windowSize;
      let sq = (val - mean) * (val - mean);
      fifoSq.push(sq);
      if (val < riskFreeReturn) {
        sqSum += sq;
      }
      if (i >= windowSize) {
        let outVal = fifoVal.shift();
        let outSq = fifoSq.shift();
        sum -= outVal;
        if (outVal < riskFreeReturn) {
          sqSum -= outSq;
        }
      }
      if (i >= windowSize - 1) {
        let variance = sqSum / windowSize;
        let stdDev = Math.sqrt(variance);
        let sharpeRatio = (mean - riskFreeReturn) / stdDev;
        sharpeRatios.push(sharpeRatio);
      }
    }
    return sharpeRatios.map((val, index) => {
      return {
        time: this.timestamps[index + windowSize - 1],
        value: val * Math.sqrt(windowSize)
      };
    });
  }
  calculateVolitility(name, riskFreeReturn, windowSize) {
    let sharpeRatios = [];
    let sum = 0;
    let sqSum = 0;
    let fifoVal = [];
    let fifoSq = [];
    const cumulativeReturns = this[name];
    for (let i = 1; i < cumulativeReturns.length; i++) {
      let val = cumulativeReturns[i] / cumulativeReturns[i - 1] - 1;
      sum += val;
      fifoVal.push(val);
      let mean = sum / windowSize;
      let sq = (val - mean) * (val - mean);
      sqSum += sq;
      fifoSq.push(sq);
      if (i >= windowSize) {
        let outVal = fifoVal.shift();
        let outSq = fifoSq.shift();
        sum -= outVal;
        sqSum -= outSq;
      }
      if (i >= windowSize - 1) {
        let variance = sqSum / windowSize;
        let stdDev = Math.sqrt(variance);
        sharpeRatios.push(stdDev);
      }
    }
    return sharpeRatios.map((val, index) => {
      return {
        time: this.timestamps[index + windowSize - 1],
        value: val * Math.sqrt(windowSize)
      };
    });
  }
  calculateTailRatio(name, windowSize) {
    let series = this[name];
    series = series.map((value, index) => value / series[index - 1] - 1);
    series[0] = 0;
    const v1 = calculateQuantileSeries(series, 0.95, windowSize);
    const v2 = calculateQuantileSeries(series, 0.05, windowSize);
    return v1.map((value, index) => Math.abs(value / v2[index])).map((val, index) => {
      return {
        time: this.timestamps[index + windowSize - 1],
        value: val
      };
    });
  }
}
/*!
 * @kurkle/color v0.3.2
 * https://github.com/kurkle/color#readme
 * (c) 2023 Jukka Kurkela
 * Released under the MIT License
 */
function round(v2) {
  return v2 + 0.5 | 0;
}
const lim = (v2, l2, h3) => Math.max(Math.min(v2, h3), l2);
function p2b(v2) {
  return lim(round(v2 * 2.55), 0, 255);
}
function n2b(v2) {
  return lim(round(v2 * 255), 0, 255);
}
function b2n(v2) {
  return lim(round(v2 / 2.55) / 100, 0, 1);
}
function n2p(v2) {
  return lim(round(v2 * 100), 0, 100);
}
const map$1 = { 0: 0, 1: 1, 2: 2, 3: 3, 4: 4, 5: 5, 6: 6, 7: 7, 8: 8, 9: 9, A: 10, B: 11, C: 12, D: 13, E: 14, F: 15, a: 10, b: 11, c: 12, d: 13, e: 14, f: 15 };
const hex = [..."0123456789ABCDEF"];
const h1 = (b2) => hex[b2 & 15];
const h2 = (b2) => hex[(b2 & 240) >> 4] + hex[b2 & 15];
const eq = (b2) => (b2 & 240) >> 4 === (b2 & 15);
const isShort = (v2) => eq(v2.r) && eq(v2.g) && eq(v2.b) && eq(v2.a);
function hexParse(str) {
  var len = str.length;
  var ret;
  if (str[0] === "#") {
    if (len === 4 || len === 5) {
      ret = {
        r: 255 & map$1[str[1]] * 17,
        g: 255 & map$1[str[2]] * 17,
        b: 255 & map$1[str[3]] * 17,
        a: len === 5 ? map$1[str[4]] * 17 : 255
      };
    } else if (len === 7 || len === 9) {
      ret = {
        r: map$1[str[1]] << 4 | map$1[str[2]],
        g: map$1[str[3]] << 4 | map$1[str[4]],
        b: map$1[str[5]] << 4 | map$1[str[6]],
        a: len === 9 ? map$1[str[7]] << 4 | map$1[str[8]] : 255
      };
    }
  }
  return ret;
}
const alpha = (a2, f2) => a2 < 255 ? f2(a2) : "";
function hexString(v2) {
  var f2 = isShort(v2) ? h1 : h2;
  return v2 ? "#" + f2(v2.r) + f2(v2.g) + f2(v2.b) + alpha(v2.a, f2) : void 0;
}
const HUE_RE = /^(hsla?|hwb|hsv)\(\s*([-+.e\d]+)(?:deg)?[\s,]+([-+.e\d]+)%[\s,]+([-+.e\d]+)%(?:[\s,]+([-+.e\d]+)(%)?)?\s*\)$/;
function hsl2rgbn(h3, s, l2) {
  const a2 = s * Math.min(l2, 1 - l2);
  const f2 = (n, k2 = (n + h3 / 30) % 12) => l2 - a2 * Math.max(Math.min(k2 - 3, 9 - k2, 1), -1);
  return [f2(0), f2(8), f2(4)];
}
function hsv2rgbn(h3, s, v2) {
  const f2 = (n, k2 = (n + h3 / 60) % 6) => v2 - v2 * s * Math.max(Math.min(k2, 4 - k2, 1), 0);
  return [f2(5), f2(3), f2(1)];
}
function hwb2rgbn(h3, w2, b2) {
  const rgb = hsl2rgbn(h3, 1, 0.5);
  let i;
  if (w2 + b2 > 1) {
    i = 1 / (w2 + b2);
    w2 *= i;
    b2 *= i;
  }
  for (i = 0; i < 3; i++) {
    rgb[i] *= 1 - w2 - b2;
    rgb[i] += w2;
  }
  return rgb;
}
function hueValue(r2, g2, b2, d2, max) {
  if (r2 === max) {
    return (g2 - b2) / d2 + (g2 < b2 ? 6 : 0);
  }
  if (g2 === max) {
    return (b2 - r2) / d2 + 2;
  }
  return (r2 - g2) / d2 + 4;
}
function rgb2hsl(v2) {
  const range = 255;
  const r2 = v2.r / range;
  const g2 = v2.g / range;
  const b2 = v2.b / range;
  const max = Math.max(r2, g2, b2);
  const min = Math.min(r2, g2, b2);
  const l2 = (max + min) / 2;
  let h3, s, d2;
  if (max !== min) {
    d2 = max - min;
    s = l2 > 0.5 ? d2 / (2 - max - min) : d2 / (max + min);
    h3 = hueValue(r2, g2, b2, d2, max);
    h3 = h3 * 60 + 0.5;
  }
  return [h3 | 0, s || 0, l2];
}
function calln(f2, a2, b2, c2) {
  return (Array.isArray(a2) ? f2(a2[0], a2[1], a2[2]) : f2(a2, b2, c2)).map(n2b);
}
function hsl2rgb(h3, s, l2) {
  return calln(hsl2rgbn, h3, s, l2);
}
function hwb2rgb(h3, w2, b2) {
  return calln(hwb2rgbn, h3, w2, b2);
}
function hsv2rgb(h3, s, v2) {
  return calln(hsv2rgbn, h3, s, v2);
}
function hue(h3) {
  return (h3 % 360 + 360) % 360;
}
function hueParse(str) {
  const m2 = HUE_RE.exec(str);
  let a2 = 255;
  let v2;
  if (!m2) {
    return;
  }
  if (m2[5] !== v2) {
    a2 = m2[6] ? p2b(+m2[5]) : n2b(+m2[5]);
  }
  const h3 = hue(+m2[2]);
  const p1 = +m2[3] / 100;
  const p2 = +m2[4] / 100;
  if (m2[1] === "hwb") {
    v2 = hwb2rgb(h3, p1, p2);
  } else if (m2[1] === "hsv") {
    v2 = hsv2rgb(h3, p1, p2);
  } else {
    v2 = hsl2rgb(h3, p1, p2);
  }
  return {
    r: v2[0],
    g: v2[1],
    b: v2[2],
    a: a2
  };
}
function rotate(v2, deg) {
  var h3 = rgb2hsl(v2);
  h3[0] = hue(h3[0] + deg);
  h3 = hsl2rgb(h3);
  v2.r = h3[0];
  v2.g = h3[1];
  v2.b = h3[2];
}
function hslString(v2) {
  if (!v2) {
    return;
  }
  const a2 = rgb2hsl(v2);
  const h3 = a2[0];
  const s = n2p(a2[1]);
  const l2 = n2p(a2[2]);
  return v2.a < 255 ? `hsla(${h3}, ${s}%, ${l2}%, ${b2n(v2.a)})` : `hsl(${h3}, ${s}%, ${l2}%)`;
}
const map = {
  x: "dark",
  Z: "light",
  Y: "re",
  X: "blu",
  W: "gr",
  V: "medium",
  U: "slate",
  A: "ee",
  T: "ol",
  S: "or",
  B: "ra",
  C: "lateg",
  D: "ights",
  R: "in",
  Q: "turquois",
  E: "hi",
  P: "ro",
  O: "al",
  N: "le",
  M: "de",
  L: "yello",
  F: "en",
  K: "ch",
  G: "arks",
  H: "ea",
  I: "ightg",
  J: "wh"
};
const names$1 = {
  OiceXe: "f0f8ff",
  antiquewEte: "faebd7",
  aqua: "ffff",
  aquamarRe: "7fffd4",
  azuY: "f0ffff",
  beige: "f5f5dc",
  bisque: "ffe4c4",
  black: "0",
  blanKedOmond: "ffebcd",
  Xe: "ff",
  XeviTet: "8a2be2",
  bPwn: "a52a2a",
  burlywood: "deb887",
  caMtXe: "5f9ea0",
  KartYuse: "7fff00",
  KocTate: "d2691e",
  cSO: "ff7f50",
  cSnflowerXe: "6495ed",
  cSnsilk: "fff8dc",
  crimson: "dc143c",
  cyan: "ffff",
  xXe: "8b",
  xcyan: "8b8b",
  xgTMnPd: "b8860b",
  xWay: "a9a9a9",
  xgYF: "6400",
  xgYy: "a9a9a9",
  xkhaki: "bdb76b",
  xmagFta: "8b008b",
  xTivegYF: "556b2f",
  xSange: "ff8c00",
  xScEd: "9932cc",
  xYd: "8b0000",
  xsOmon: "e9967a",
  xsHgYF: "8fbc8f",
  xUXe: "483d8b",
  xUWay: "2f4f4f",
  xUgYy: "2f4f4f",
  xQe: "ced1",
  xviTet: "9400d3",
  dAppRk: "ff1493",
  dApskyXe: "bfff",
  dimWay: "696969",
  dimgYy: "696969",
  dodgerXe: "1e90ff",
  fiYbrick: "b22222",
  flSOwEte: "fffaf0",
  foYstWAn: "228b22",
  fuKsia: "ff00ff",
  gaRsbSo: "dcdcdc",
  ghostwEte: "f8f8ff",
  gTd: "ffd700",
  gTMnPd: "daa520",
  Way: "808080",
  gYF: "8000",
  gYFLw: "adff2f",
  gYy: "808080",
  honeyMw: "f0fff0",
  hotpRk: "ff69b4",
  RdianYd: "cd5c5c",
  Rdigo: "4b0082",
  ivSy: "fffff0",
  khaki: "f0e68c",
  lavFMr: "e6e6fa",
  lavFMrXsh: "fff0f5",
  lawngYF: "7cfc00",
  NmoncEffon: "fffacd",
  ZXe: "add8e6",
  ZcSO: "f08080",
  Zcyan: "e0ffff",
  ZgTMnPdLw: "fafad2",
  ZWay: "d3d3d3",
  ZgYF: "90ee90",
  ZgYy: "d3d3d3",
  ZpRk: "ffb6c1",
  ZsOmon: "ffa07a",
  ZsHgYF: "20b2aa",
  ZskyXe: "87cefa",
  ZUWay: "778899",
  ZUgYy: "778899",
  ZstAlXe: "b0c4de",
  ZLw: "ffffe0",
  lime: "ff00",
  limegYF: "32cd32",
  lRF: "faf0e6",
  magFta: "ff00ff",
  maPon: "800000",
  VaquamarRe: "66cdaa",
  VXe: "cd",
  VScEd: "ba55d3",
  VpurpN: "9370db",
  VsHgYF: "3cb371",
  VUXe: "7b68ee",
  VsprRggYF: "fa9a",
  VQe: "48d1cc",
  VviTetYd: "c71585",
  midnightXe: "191970",
  mRtcYam: "f5fffa",
  mistyPse: "ffe4e1",
  moccasR: "ffe4b5",
  navajowEte: "ffdead",
  navy: "80",
  Tdlace: "fdf5e6",
  Tive: "808000",
  TivedBb: "6b8e23",
  Sange: "ffa500",
  SangeYd: "ff4500",
  ScEd: "da70d6",
  pOegTMnPd: "eee8aa",
  pOegYF: "98fb98",
  pOeQe: "afeeee",
  pOeviTetYd: "db7093",
  papayawEp: "ffefd5",
  pHKpuff: "ffdab9",
  peru: "cd853f",
  pRk: "ffc0cb",
  plum: "dda0dd",
  powMrXe: "b0e0e6",
  purpN: "800080",
  YbeccapurpN: "663399",
  Yd: "ff0000",
  Psybrown: "bc8f8f",
  PyOXe: "4169e1",
  saddNbPwn: "8b4513",
  sOmon: "fa8072",
  sandybPwn: "f4a460",
  sHgYF: "2e8b57",
  sHshell: "fff5ee",
  siFna: "a0522d",
  silver: "c0c0c0",
  skyXe: "87ceeb",
  UXe: "6a5acd",
  UWay: "708090",
  UgYy: "708090",
  snow: "fffafa",
  sprRggYF: "ff7f",
  stAlXe: "4682b4",
  tan: "d2b48c",
  teO: "8080",
  tEstN: "d8bfd8",
  tomato: "ff6347",
  Qe: "40e0d0",
  viTet: "ee82ee",
  JHt: "f5deb3",
  wEte: "ffffff",
  wEtesmoke: "f5f5f5",
  Lw: "ffff00",
  LwgYF: "9acd32"
};
function unpack() {
  const unpacked = {};
  const keys = Object.keys(names$1);
  const tkeys = Object.keys(map);
  let i, j2, k2, ok, nk;
  for (i = 0; i < keys.length; i++) {
    ok = nk = keys[i];
    for (j2 = 0; j2 < tkeys.length; j2++) {
      k2 = tkeys[j2];
      nk = nk.replace(k2, map[k2]);
    }
    k2 = parseInt(names$1[ok], 16);
    unpacked[nk] = [k2 >> 16 & 255, k2 >> 8 & 255, k2 & 255];
  }
  return unpacked;
}
let names;
function nameParse(str) {
  if (!names) {
    names = unpack();
    names.transparent = [0, 0, 0, 0];
  }
  const a2 = names[str.toLowerCase()];
  return a2 && {
    r: a2[0],
    g: a2[1],
    b: a2[2],
    a: a2.length === 4 ? a2[3] : 255
  };
}
const RGB_RE = /^rgba?\(\s*([-+.\d]+)(%)?[\s,]+([-+.e\d]+)(%)?[\s,]+([-+.e\d]+)(%)?(?:[\s,/]+([-+.e\d]+)(%)?)?\s*\)$/;
function rgbParse(str) {
  const m2 = RGB_RE.exec(str);
  let a2 = 255;
  let r2, g2, b2;
  if (!m2) {
    return;
  }
  if (m2[7] !== r2) {
    const v2 = +m2[7];
    a2 = m2[8] ? p2b(v2) : lim(v2 * 255, 0, 255);
  }
  r2 = +m2[1];
  g2 = +m2[3];
  b2 = +m2[5];
  r2 = 255 & (m2[2] ? p2b(r2) : lim(r2, 0, 255));
  g2 = 255 & (m2[4] ? p2b(g2) : lim(g2, 0, 255));
  b2 = 255 & (m2[6] ? p2b(b2) : lim(b2, 0, 255));
  return {
    r: r2,
    g: g2,
    b: b2,
    a: a2
  };
}
function rgbString(v2) {
  return v2 && (v2.a < 255 ? `rgba(${v2.r}, ${v2.g}, ${v2.b}, ${b2n(v2.a)})` : `rgb(${v2.r}, ${v2.g}, ${v2.b})`);
}
const to = (v2) => v2 <= 31308e-7 ? v2 * 12.92 : Math.pow(v2, 1 / 2.4) * 1.055 - 0.055;
const from = (v2) => v2 <= 0.04045 ? v2 / 12.92 : Math.pow((v2 + 0.055) / 1.055, 2.4);
function interpolate$1(rgb1, rgb2, t) {
  const r2 = from(b2n(rgb1.r));
  const g2 = from(b2n(rgb1.g));
  const b2 = from(b2n(rgb1.b));
  return {
    r: n2b(to(r2 + t * (from(b2n(rgb2.r)) - r2))),
    g: n2b(to(g2 + t * (from(b2n(rgb2.g)) - g2))),
    b: n2b(to(b2 + t * (from(b2n(rgb2.b)) - b2))),
    a: rgb1.a + t * (rgb2.a - rgb1.a)
  };
}
function modHSL(v2, i, ratio) {
  if (v2) {
    let tmp = rgb2hsl(v2);
    tmp[i] = Math.max(0, Math.min(tmp[i] + tmp[i] * ratio, i === 0 ? 360 : 1));
    tmp = hsl2rgb(tmp);
    v2.r = tmp[0];
    v2.g = tmp[1];
    v2.b = tmp[2];
  }
}
function clone$1(v2, proto) {
  return v2 ? Object.assign(proto || {}, v2) : v2;
}
function fromObject(input) {
  var v2 = { r: 0, g: 0, b: 0, a: 255 };
  if (Array.isArray(input)) {
    if (input.length >= 3) {
      v2 = { r: input[0], g: input[1], b: input[2], a: 255 };
      if (input.length > 3) {
        v2.a = n2b(input[3]);
      }
    }
  } else {
    v2 = clone$1(input, { r: 0, g: 0, b: 0, a: 1 });
    v2.a = n2b(v2.a);
  }
  return v2;
}
function functionParse(str) {
  if (str.charAt(0) === "r") {
    return rgbParse(str);
  }
  return hueParse(str);
}
class Color {
  constructor(input) {
    if (input instanceof Color) {
      return input;
    }
    const type = typeof input;
    let v2;
    if (type === "object") {
      v2 = fromObject(input);
    } else if (type === "string") {
      v2 = hexParse(input) || nameParse(input) || functionParse(input);
    }
    this._rgb = v2;
    this._valid = !!v2;
  }
  get valid() {
    return this._valid;
  }
  get rgb() {
    var v2 = clone$1(this._rgb);
    if (v2) {
      v2.a = b2n(v2.a);
    }
    return v2;
  }
  set rgb(obj) {
    this._rgb = fromObject(obj);
  }
  rgbString() {
    return this._valid ? rgbString(this._rgb) : void 0;
  }
  hexString() {
    return this._valid ? hexString(this._rgb) : void 0;
  }
  hslString() {
    return this._valid ? hslString(this._rgb) : void 0;
  }
  mix(color2, weight) {
    if (color2) {
      const c1 = this.rgb;
      const c2 = color2.rgb;
      let w2;
      const p2 = weight === w2 ? 0.5 : weight;
      const w3 = 2 * p2 - 1;
      const a2 = c1.a - c2.a;
      const w1 = ((w3 * a2 === -1 ? w3 : (w3 + a2) / (1 + w3 * a2)) + 1) / 2;
      w2 = 1 - w1;
      c1.r = 255 & w1 * c1.r + w2 * c2.r + 0.5;
      c1.g = 255 & w1 * c1.g + w2 * c2.g + 0.5;
      c1.b = 255 & w1 * c1.b + w2 * c2.b + 0.5;
      c1.a = p2 * c1.a + (1 - p2) * c2.a;
      this.rgb = c1;
    }
    return this;
  }
  interpolate(color2, t) {
    if (color2) {
      this._rgb = interpolate$1(this._rgb, color2._rgb, t);
    }
    return this;
  }
  clone() {
    return new Color(this.rgb);
  }
  alpha(a2) {
    this._rgb.a = n2b(a2);
    return this;
  }
  clearer(ratio) {
    const rgb = this._rgb;
    rgb.a *= 1 - ratio;
    return this;
  }
  greyscale() {
    const rgb = this._rgb;
    const val = round(rgb.r * 0.3 + rgb.g * 0.59 + rgb.b * 0.11);
    rgb.r = rgb.g = rgb.b = val;
    return this;
  }
  opaquer(ratio) {
    const rgb = this._rgb;
    rgb.a *= 1 + ratio;
    return this;
  }
  negate() {
    const v2 = this._rgb;
    v2.r = 255 - v2.r;
    v2.g = 255 - v2.g;
    v2.b = 255 - v2.b;
    return this;
  }
  lighten(ratio) {
    modHSL(this._rgb, 2, ratio);
    return this;
  }
  darken(ratio) {
    modHSL(this._rgb, 2, -ratio);
    return this;
  }
  saturate(ratio) {
    modHSL(this._rgb, 1, ratio);
    return this;
  }
  desaturate(ratio) {
    modHSL(this._rgb, 1, -ratio);
    return this;
  }
  rotate(deg) {
    rotate(this._rgb, deg);
    return this;
  }
}
/*!
 * Chart.js v4.4.0
 * https://www.chartjs.org
 * (c) 2023 Chart.js Contributors
 * Released under the MIT License
 */
function noop() {
}
const uid = (() => {
  let id = 0;
  return () => id++;
})();
function isNullOrUndef(value) {
  return value === null || typeof value === "undefined";
}
function isArray(value) {
  if (Array.isArray && Array.isArray(value)) {
    return true;
  }
  const type = Object.prototype.toString.call(value);
  if (type.slice(0, 7) === "[object" && type.slice(-6) === "Array]") {
    return true;
  }
  return false;
}
function isObject(value) {
  return value !== null && Object.prototype.toString.call(value) === "[object Object]";
}
function isNumberFinite(value) {
  return (typeof value === "number" || value instanceof Number) && isFinite(+value);
}
function finiteOrDefault(value, defaultValue) {
  return isNumberFinite(value) ? value : defaultValue;
}
function valueOrDefault(value, defaultValue) {
  return typeof value === "undefined" ? defaultValue : value;
}
const toDimension = (value, dimension) => typeof value === "string" && value.endsWith("%") ? parseFloat(value) / 100 * dimension : +value;
function callback(fn2, args, thisArg) {
  if (fn2 && typeof fn2.call === "function") {
    return fn2.apply(thisArg, args);
  }
}
function each(loopable, fn2, thisArg, reverse) {
  let i, len, keys;
  if (isArray(loopable)) {
    len = loopable.length;
    if (reverse) {
      for (i = len - 1; i >= 0; i--) {
        fn2.call(thisArg, loopable[i], i);
      }
    } else {
      for (i = 0; i < len; i++) {
        fn2.call(thisArg, loopable[i], i);
      }
    }
  } else if (isObject(loopable)) {
    keys = Object.keys(loopable);
    len = keys.length;
    for (i = 0; i < len; i++) {
      fn2.call(thisArg, loopable[keys[i]], keys[i]);
    }
  }
}
function _elementsEqual(a0, a1) {
  let i, ilen, v0, v1;
  if (!a0 || !a1 || a0.length !== a1.length) {
    return false;
  }
  for (i = 0, ilen = a0.length; i < ilen; ++i) {
    v0 = a0[i];
    v1 = a1[i];
    if (v0.datasetIndex !== v1.datasetIndex || v0.index !== v1.index) {
      return false;
    }
  }
  return true;
}
function clone(source) {
  if (isArray(source)) {
    return source.map(clone);
  }
  if (isObject(source)) {
    const target = /* @__PURE__ */ Object.create(null);
    const keys = Object.keys(source);
    const klen = keys.length;
    let k2 = 0;
    for (; k2 < klen; ++k2) {
      target[keys[k2]] = clone(source[keys[k2]]);
    }
    return target;
  }
  return source;
}
function isValidKey(key) {
  return [
    "__proto__",
    "prototype",
    "constructor"
  ].indexOf(key) === -1;
}
function _merger(key, target, source, options) {
  if (!isValidKey(key)) {
    return;
  }
  const tval = target[key];
  const sval = source[key];
  if (isObject(tval) && isObject(sval)) {
    merge(tval, sval, options);
  } else {
    target[key] = clone(sval);
  }
}
function merge(target, source, options) {
  const sources = isArray(source) ? source : [
    source
  ];
  const ilen = sources.length;
  if (!isObject(target)) {
    return target;
  }
  options = options || {};
  const merger = options.merger || _merger;
  let current;
  for (let i = 0; i < ilen; ++i) {
    current = sources[i];
    if (!isObject(current)) {
      continue;
    }
    const keys = Object.keys(current);
    for (let k2 = 0, klen = keys.length; k2 < klen; ++k2) {
      merger(keys[k2], target, current, options);
    }
  }
  return target;
}
function mergeIf(target, source) {
  return merge(target, source, {
    merger: _mergerIf
  });
}
function _mergerIf(key, target, source) {
  if (!isValidKey(key)) {
    return;
  }
  const tval = target[key];
  const sval = source[key];
  if (isObject(tval) && isObject(sval)) {
    mergeIf(tval, sval);
  } else if (!Object.prototype.hasOwnProperty.call(target, key)) {
    target[key] = clone(sval);
  }
}
const keyResolvers = {
  // Chart.helpers.core resolveObjectKey should resolve empty key to root object
  "": (v2) => v2,
  // default resolvers
  x: (o2) => o2.x,
  y: (o2) => o2.y
};
function _splitKey(key) {
  const parts = key.split(".");
  const keys = [];
  let tmp = "";
  for (const part of parts) {
    tmp += part;
    if (tmp.endsWith("\\")) {
      tmp = tmp.slice(0, -1) + ".";
    } else {
      keys.push(tmp);
      tmp = "";
    }
  }
  return keys;
}
function _getKeyResolver(key) {
  const keys = _splitKey(key);
  return (obj) => {
    for (const k2 of keys) {
      if (k2 === "") {
        break;
      }
      obj = obj && obj[k2];
    }
    return obj;
  };
}
function resolveObjectKey(obj, key) {
  const resolver = keyResolvers[key] || (keyResolvers[key] = _getKeyResolver(key));
  return resolver(obj);
}
function _capitalize(str) {
  return str.charAt(0).toUpperCase() + str.slice(1);
}
const defined = (value) => typeof value !== "undefined";
const isFunction = (value) => typeof value === "function";
const setsEqual = (a2, b2) => {
  if (a2.size !== b2.size) {
    return false;
  }
  for (const item of a2) {
    if (!b2.has(item)) {
      return false;
    }
  }
  return true;
};
function _isClickEvent(e2) {
  return e2.type === "mouseup" || e2.type === "click" || e2.type === "contextmenu";
}
const PI = Math.PI;
const TAU = 2 * PI;
const PITAU = TAU + PI;
const INFINITY = Number.POSITIVE_INFINITY;
const RAD_PER_DEG = PI / 180;
const HALF_PI = PI / 2;
const QUARTER_PI = PI / 4;
const TWO_THIRDS_PI = PI * 2 / 3;
const log10 = Math.log10;
const sign$2 = Math.sign;
function almostEquals(x2, y2, epsilon) {
  return Math.abs(x2 - y2) < epsilon;
}
function niceNum(range) {
  const roundedRange = Math.round(range);
  range = almostEquals(range, roundedRange, range / 1e3) ? roundedRange : range;
  const niceRange = Math.pow(10, Math.floor(log10(range)));
  const fraction = range / niceRange;
  const niceFraction = fraction <= 1 ? 1 : fraction <= 2 ? 2 : fraction <= 5 ? 5 : 10;
  return niceFraction * niceRange;
}
function _factorize(value) {
  const result = [];
  const sqrt = Math.sqrt(value);
  let i;
  for (i = 1; i < sqrt; i++) {
    if (value % i === 0) {
      result.push(i);
      result.push(value / i);
    }
  }
  if (sqrt === (sqrt | 0)) {
    result.push(sqrt);
  }
  result.sort((a2, b2) => a2 - b2).pop();
  return result;
}
function isNumber(n) {
  return !isNaN(parseFloat(n)) && isFinite(n);
}
function almostWhole(x2, epsilon) {
  const rounded = Math.round(x2);
  return rounded - epsilon <= x2 && rounded + epsilon >= x2;
}
function _setMinAndMaxByKey(array, target, property) {
  let i, ilen, value;
  for (i = 0, ilen = array.length; i < ilen; i++) {
    value = array[i][property];
    if (!isNaN(value)) {
      target.min = Math.min(target.min, value);
      target.max = Math.max(target.max, value);
    }
  }
}
function toRadians(degrees) {
  return degrees * (PI / 180);
}
function toDegrees(radians) {
  return radians * (180 / PI);
}
function _decimalPlaces(x2) {
  if (!isNumberFinite(x2)) {
    return;
  }
  let e2 = 1;
  let p2 = 0;
  while (Math.round(x2 * e2) / e2 !== x2) {
    e2 *= 10;
    p2++;
  }
  return p2;
}
function getAngleFromPoint(centrePoint, anglePoint) {
  const distanceFromXCenter = anglePoint.x - centrePoint.x;
  const distanceFromYCenter = anglePoint.y - centrePoint.y;
  const radialDistanceFromCenter = Math.sqrt(distanceFromXCenter * distanceFromXCenter + distanceFromYCenter * distanceFromYCenter);
  let angle = Math.atan2(distanceFromYCenter, distanceFromXCenter);
  if (angle < -0.5 * PI) {
    angle += TAU;
  }
  return {
    angle,
    distance: radialDistanceFromCenter
  };
}
function distanceBetweenPoints(pt1, pt2) {
  return Math.sqrt(Math.pow(pt2.x - pt1.x, 2) + Math.pow(pt2.y - pt1.y, 2));
}
function _angleDiff(a2, b2) {
  return (a2 - b2 + PITAU) % TAU - PI;
}
function _normalizeAngle(a2) {
  return (a2 % TAU + TAU) % TAU;
}
function _angleBetween(angle, start, end, sameAngleIsFullCircle) {
  const a2 = _normalizeAngle(angle);
  const s = _normalizeAngle(start);
  const e2 = _normalizeAngle(end);
  const angleToStart = _normalizeAngle(s - a2);
  const angleToEnd = _normalizeAngle(e2 - a2);
  const startToAngle = _normalizeAngle(a2 - s);
  const endToAngle = _normalizeAngle(a2 - e2);
  return a2 === s || a2 === e2 || sameAngleIsFullCircle && s === e2 || angleToStart > angleToEnd && startToAngle < endToAngle;
}
function _limitValue(value, min, max) {
  return Math.max(min, Math.min(max, value));
}
function _int16Range(value) {
  return _limitValue(value, -32768, 32767);
}
function _isBetween(value, start, end, epsilon = 1e-6) {
  return value >= Math.min(start, end) - epsilon && value <= Math.max(start, end) + epsilon;
}
function _lookup(table, value, cmp) {
  cmp = cmp || ((index) => table[index] < value);
  let hi2 = table.length - 1;
  let lo = 0;
  let mid;
  while (hi2 - lo > 1) {
    mid = lo + hi2 >> 1;
    if (cmp(mid)) {
      lo = mid;
    } else {
      hi2 = mid;
    }
  }
  return {
    lo,
    hi: hi2
  };
}
const _lookupByKey = (table, key, value, last) => _lookup(table, value, last ? (index) => {
  const ti2 = table[index][key];
  return ti2 < value || ti2 === value && table[index + 1][key] === value;
} : (index) => table[index][key] < value);
const _rlookupByKey = (table, key, value) => _lookup(table, value, (index) => table[index][key] >= value);
function _filterBetween(values, min, max) {
  let start = 0;
  let end = values.length;
  while (start < end && values[start] < min) {
    start++;
  }
  while (end > start && values[end - 1] > max) {
    end--;
  }
  return start > 0 || end < values.length ? values.slice(start, end) : values;
}
const arrayEvents = [
  "push",
  "pop",
  "shift",
  "splice",
  "unshift"
];
function listenArrayEvents(array, listener) {
  if (array._chartjs) {
    array._chartjs.listeners.push(listener);
    return;
  }
  Object.defineProperty(array, "_chartjs", {
    configurable: true,
    enumerable: false,
    value: {
      listeners: [
        listener
      ]
    }
  });
  arrayEvents.forEach((key) => {
    const method = "_onData" + _capitalize(key);
    const base = array[key];
    Object.defineProperty(array, key, {
      configurable: true,
      enumerable: false,
      value(...args) {
        const res = base.apply(this, args);
        array._chartjs.listeners.forEach((object) => {
          if (typeof object[method] === "function") {
            object[method](...args);
          }
        });
        return res;
      }
    });
  });
}
function unlistenArrayEvents(array, listener) {
  const stub = array._chartjs;
  if (!stub) {
    return;
  }
  const listeners = stub.listeners;
  const index = listeners.indexOf(listener);
  if (index !== -1) {
    listeners.splice(index, 1);
  }
  if (listeners.length > 0) {
    return;
  }
  arrayEvents.forEach((key) => {
    delete array[key];
  });
  delete array._chartjs;
}
function _arrayUnique(items) {
  const set2 = new Set(items);
  if (set2.size === items.length) {
    return items;
  }
  return Array.from(set2);
}
const requestAnimFrame = function() {
  if (typeof window === "undefined") {
    return function(callback2) {
      return callback2();
    };
  }
  return window.requestAnimationFrame;
}();
function throttled(fn2, thisArg) {
  let argsToUse = [];
  let ticking = false;
  return function(...args) {
    argsToUse = args;
    if (!ticking) {
      ticking = true;
      requestAnimFrame.call(window, () => {
        ticking = false;
        fn2.apply(thisArg, argsToUse);
      });
    }
  };
}
function debounce(fn2, delay) {
  let timeout;
  return function(...args) {
    if (delay) {
      clearTimeout(timeout);
      timeout = setTimeout(fn2, delay, args);
    } else {
      fn2.apply(this, args);
    }
    return delay;
  };
}
const _toLeftRightCenter = (align) => align === "start" ? "left" : align === "end" ? "right" : "center";
const _alignStartEnd = (align, start, end) => align === "start" ? start : align === "end" ? end : (start + end) / 2;
function _getStartAndCountOfVisiblePoints(meta, points, animationsDisabled) {
  const pointCount = points.length;
  let start = 0;
  let count = pointCount;
  if (meta._sorted) {
    const { iScale, _parsed } = meta;
    const axis = iScale.axis;
    const { min, max, minDefined, maxDefined } = iScale.getUserBounds();
    if (minDefined) {
      start = _limitValue(Math.min(
        // @ts-expect-error Need to type _parsed
        _lookupByKey(_parsed, axis, min).lo,
        // @ts-expect-error Need to fix types on _lookupByKey
        animationsDisabled ? pointCount : _lookupByKey(points, axis, iScale.getPixelForValue(min)).lo
      ), 0, pointCount - 1);
    }
    if (maxDefined) {
      count = _limitValue(Math.max(
        // @ts-expect-error Need to type _parsed
        _lookupByKey(_parsed, iScale.axis, max, true).hi + 1,
        // @ts-expect-error Need to fix types on _lookupByKey
        animationsDisabled ? 0 : _lookupByKey(points, axis, iScale.getPixelForValue(max), true).hi + 1
      ), start, pointCount) - start;
    } else {
      count = pointCount - start;
    }
  }
  return {
    start,
    count
  };
}
function _scaleRangesChanged(meta) {
  const { xScale, yScale, _scaleRanges } = meta;
  const newRanges = {
    xmin: xScale.min,
    xmax: xScale.max,
    ymin: yScale.min,
    ymax: yScale.max
  };
  if (!_scaleRanges) {
    meta._scaleRanges = newRanges;
    return true;
  }
  const changed = _scaleRanges.xmin !== xScale.min || _scaleRanges.xmax !== xScale.max || _scaleRanges.ymin !== yScale.min || _scaleRanges.ymax !== yScale.max;
  Object.assign(_scaleRanges, newRanges);
  return changed;
}
const atEdge = (t) => t === 0 || t === 1;
const elasticIn = (t, s, p2) => -(Math.pow(2, 10 * (t -= 1)) * Math.sin((t - s) * TAU / p2));
const elasticOut = (t, s, p2) => Math.pow(2, -10 * t) * Math.sin((t - s) * TAU / p2) + 1;
const effects = {
  linear: (t) => t,
  easeInQuad: (t) => t * t,
  easeOutQuad: (t) => -t * (t - 2),
  easeInOutQuad: (t) => (t /= 0.5) < 1 ? 0.5 * t * t : -0.5 * (--t * (t - 2) - 1),
  easeInCubic: (t) => t * t * t,
  easeOutCubic: (t) => (t -= 1) * t * t + 1,
  easeInOutCubic: (t) => (t /= 0.5) < 1 ? 0.5 * t * t * t : 0.5 * ((t -= 2) * t * t + 2),
  easeInQuart: (t) => t * t * t * t,
  easeOutQuart: (t) => -((t -= 1) * t * t * t - 1),
  easeInOutQuart: (t) => (t /= 0.5) < 1 ? 0.5 * t * t * t * t : -0.5 * ((t -= 2) * t * t * t - 2),
  easeInQuint: (t) => t * t * t * t * t,
  easeOutQuint: (t) => (t -= 1) * t * t * t * t + 1,
  easeInOutQuint: (t) => (t /= 0.5) < 1 ? 0.5 * t * t * t * t * t : 0.5 * ((t -= 2) * t * t * t * t + 2),
  easeInSine: (t) => -Math.cos(t * HALF_PI) + 1,
  easeOutSine: (t) => Math.sin(t * HALF_PI),
  easeInOutSine: (t) => -0.5 * (Math.cos(PI * t) - 1),
  easeInExpo: (t) => t === 0 ? 0 : Math.pow(2, 10 * (t - 1)),
  easeOutExpo: (t) => t === 1 ? 1 : -Math.pow(2, -10 * t) + 1,
  easeInOutExpo: (t) => atEdge(t) ? t : t < 0.5 ? 0.5 * Math.pow(2, 10 * (t * 2 - 1)) : 0.5 * (-Math.pow(2, -10 * (t * 2 - 1)) + 2),
  easeInCirc: (t) => t >= 1 ? t : -(Math.sqrt(1 - t * t) - 1),
  easeOutCirc: (t) => Math.sqrt(1 - (t -= 1) * t),
  easeInOutCirc: (t) => (t /= 0.5) < 1 ? -0.5 * (Math.sqrt(1 - t * t) - 1) : 0.5 * (Math.sqrt(1 - (t -= 2) * t) + 1),
  easeInElastic: (t) => atEdge(t) ? t : elasticIn(t, 0.075, 0.3),
  easeOutElastic: (t) => atEdge(t) ? t : elasticOut(t, 0.075, 0.3),
  easeInOutElastic(t) {
    const s = 0.1125;
    const p2 = 0.45;
    return atEdge(t) ? t : t < 0.5 ? 0.5 * elasticIn(t * 2, s, p2) : 0.5 + 0.5 * elasticOut(t * 2 - 1, s, p2);
  },
  easeInBack(t) {
    const s = 1.70158;
    return t * t * ((s + 1) * t - s);
  },
  easeOutBack(t) {
    const s = 1.70158;
    return (t -= 1) * t * ((s + 1) * t + s) + 1;
  },
  easeInOutBack(t) {
    let s = 1.70158;
    if ((t /= 0.5) < 1) {
      return 0.5 * (t * t * (((s *= 1.525) + 1) * t - s));
    }
    return 0.5 * ((t -= 2) * t * (((s *= 1.525) + 1) * t + s) + 2);
  },
  easeInBounce: (t) => 1 - effects.easeOutBounce(1 - t),
  easeOutBounce(t) {
    const m2 = 7.5625;
    const d2 = 2.75;
    if (t < 1 / d2) {
      return m2 * t * t;
    }
    if (t < 2 / d2) {
      return m2 * (t -= 1.5 / d2) * t + 0.75;
    }
    if (t < 2.5 / d2) {
      return m2 * (t -= 2.25 / d2) * t + 0.9375;
    }
    return m2 * (t -= 2.625 / d2) * t + 0.984375;
  },
  easeInOutBounce: (t) => t < 0.5 ? effects.easeInBounce(t * 2) * 0.5 : effects.easeOutBounce(t * 2 - 1) * 0.5 + 0.5
};
function isPatternOrGradient(value) {
  if (value && typeof value === "object") {
    const type = value.toString();
    return type === "[object CanvasPattern]" || type === "[object CanvasGradient]";
  }
  return false;
}
function color(value) {
  return isPatternOrGradient(value) ? value : new Color(value);
}
function getHoverColor(value) {
  return isPatternOrGradient(value) ? value : new Color(value).saturate(0.5).darken(0.1).hexString();
}
const numbers = [
  "x",
  "y",
  "borderWidth",
  "radius",
  "tension"
];
const colors = [
  "color",
  "borderColor",
  "backgroundColor"
];
function applyAnimationsDefaults(defaults2) {
  defaults2.set("animation", {
    delay: void 0,
    duration: 1e3,
    easing: "easeOutQuart",
    fn: void 0,
    from: void 0,
    loop: void 0,
    to: void 0,
    type: void 0
  });
  defaults2.describe("animation", {
    _fallback: false,
    _indexable: false,
    _scriptable: (name) => name !== "onProgress" && name !== "onComplete" && name !== "fn"
  });
  defaults2.set("animations", {
    colors: {
      type: "color",
      properties: colors
    },
    numbers: {
      type: "number",
      properties: numbers
    }
  });
  defaults2.describe("animations", {
    _fallback: "animation"
  });
  defaults2.set("transitions", {
    active: {
      animation: {
        duration: 400
      }
    },
    resize: {
      animation: {
        duration: 0
      }
    },
    show: {
      animations: {
        colors: {
          from: "transparent"
        },
        visible: {
          type: "boolean",
          duration: 0
        }
      }
    },
    hide: {
      animations: {
        colors: {
          to: "transparent"
        },
        visible: {
          type: "boolean",
          easing: "linear",
          fn: (v2) => v2 | 0
        }
      }
    }
  });
}
function applyLayoutsDefaults(defaults2) {
  defaults2.set("layout", {
    autoPadding: true,
    padding: {
      top: 0,
      right: 0,
      bottom: 0,
      left: 0
    }
  });
}
const intlCache = /* @__PURE__ */ new Map();
function getNumberFormat(locale, options) {
  options = options || {};
  const cacheKey = locale + JSON.stringify(options);
  let formatter = intlCache.get(cacheKey);
  if (!formatter) {
    formatter = new Intl.NumberFormat(locale, options);
    intlCache.set(cacheKey, formatter);
  }
  return formatter;
}
function formatNumber(num, locale, options) {
  return getNumberFormat(locale, options).format(num);
}
const formatters = {
  values(value) {
    return isArray(value) ? value : "" + value;
  },
  numeric(tickValue, index, ticks) {
    if (tickValue === 0) {
      return "0";
    }
    const locale = this.chart.options.locale;
    let notation;
    let delta = tickValue;
    if (ticks.length > 1) {
      const maxTick = Math.max(Math.abs(ticks[0].value), Math.abs(ticks[ticks.length - 1].value));
      if (maxTick < 1e-4 || maxTick > 1e15) {
        notation = "scientific";
      }
      delta = calculateDelta(tickValue, ticks);
    }
    const logDelta = log10(Math.abs(delta));
    const numDecimal = isNaN(logDelta) ? 1 : Math.max(Math.min(-1 * Math.floor(logDelta), 20), 0);
    const options = {
      notation,
      minimumFractionDigits: numDecimal,
      maximumFractionDigits: numDecimal
    };
    Object.assign(options, this.options.ticks.format);
    return formatNumber(tickValue, locale, options);
  },
  logarithmic(tickValue, index, ticks) {
    if (tickValue === 0) {
      return "0";
    }
    const remain = ticks[index].significand || tickValue / Math.pow(10, Math.floor(log10(tickValue)));
    if ([
      1,
      2,
      3,
      5,
      10,
      15
    ].includes(remain) || index > 0.8 * ticks.length) {
      return formatters.numeric.call(this, tickValue, index, ticks);
    }
    return "";
  }
};
function calculateDelta(tickValue, ticks) {
  let delta = ticks.length > 3 ? ticks[2].value - ticks[1].value : ticks[1].value - ticks[0].value;
  if (Math.abs(delta) >= 1 && tickValue !== Math.floor(tickValue)) {
    delta = tickValue - Math.floor(tickValue);
  }
  return delta;
}
var Ticks = {
  formatters
};
function applyScaleDefaults(defaults2) {
  defaults2.set("scale", {
    display: true,
    offset: false,
    reverse: false,
    beginAtZero: false,
    bounds: "ticks",
    clip: true,
    grace: 0,
    grid: {
      display: true,
      lineWidth: 1,
      drawOnChartArea: true,
      drawTicks: true,
      tickLength: 8,
      tickWidth: (_ctx, options) => options.lineWidth,
      tickColor: (_ctx, options) => options.color,
      offset: false
    },
    border: {
      display: true,
      dash: [],
      dashOffset: 0,
      width: 1
    },
    title: {
      display: false,
      text: "",
      padding: {
        top: 4,
        bottom: 4
      }
    },
    ticks: {
      minRotation: 0,
      maxRotation: 50,
      mirror: false,
      textStrokeWidth: 0,
      textStrokeColor: "",
      padding: 3,
      display: true,
      autoSkip: true,
      autoSkipPadding: 3,
      labelOffset: 0,
      callback: Ticks.formatters.values,
      minor: {},
      major: {},
      align: "center",
      crossAlign: "near",
      showLabelBackdrop: false,
      backdropColor: "rgba(255, 255, 255, 0.75)",
      backdropPadding: 2
    }
  });
  defaults2.route("scale.ticks", "color", "", "color");
  defaults2.route("scale.grid", "color", "", "borderColor");
  defaults2.route("scale.border", "color", "", "borderColor");
  defaults2.route("scale.title", "color", "", "color");
  defaults2.describe("scale", {
    _fallback: false,
    _scriptable: (name) => !name.startsWith("before") && !name.startsWith("after") && name !== "callback" && name !== "parser",
    _indexable: (name) => name !== "borderDash" && name !== "tickBorderDash" && name !== "dash"
  });
  defaults2.describe("scales", {
    _fallback: "scale"
  });
  defaults2.describe("scale.ticks", {
    _scriptable: (name) => name !== "backdropPadding" && name !== "callback",
    _indexable: (name) => name !== "backdropPadding"
  });
}
const overrides = /* @__PURE__ */ Object.create(null);
const descriptors = /* @__PURE__ */ Object.create(null);
function getScope$1(node, key) {
  if (!key) {
    return node;
  }
  const keys = key.split(".");
  for (let i = 0, n = keys.length; i < n; ++i) {
    const k2 = keys[i];
    node = node[k2] || (node[k2] = /* @__PURE__ */ Object.create(null));
  }
  return node;
}
function set(root, scope, values) {
  if (typeof scope === "string") {
    return merge(getScope$1(root, scope), values);
  }
  return merge(getScope$1(root, ""), scope);
}
class Defaults {
  constructor(_descriptors2, _appliers) {
    this.animation = void 0;
    this.backgroundColor = "rgba(0,0,0,0.1)";
    this.borderColor = "rgba(0,0,0,0.1)";
    this.color = "#666";
    this.datasets = {};
    this.devicePixelRatio = (context) => context.chart.platform.getDevicePixelRatio();
    this.elements = {};
    this.events = [
      "mousemove",
      "mouseout",
      "click",
      "touchstart",
      "touchmove"
    ];
    this.font = {
      family: "'Helvetica Neue', 'Helvetica', 'Arial', sans-serif",
      size: 12,
      style: "normal",
      lineHeight: 1.2,
      weight: null
    };
    this.hover = {};
    this.hoverBackgroundColor = (ctx, options) => getHoverColor(options.backgroundColor);
    this.hoverBorderColor = (ctx, options) => getHoverColor(options.borderColor);
    this.hoverColor = (ctx, options) => getHoverColor(options.color);
    this.indexAxis = "x";
    this.interaction = {
      mode: "nearest",
      intersect: true,
      includeInvisible: false
    };
    this.maintainAspectRatio = true;
    this.onHover = null;
    this.onClick = null;
    this.parsing = true;
    this.plugins = {};
    this.responsive = true;
    this.scale = void 0;
    this.scales = {};
    this.showLine = true;
    this.drawActiveElementsOnTop = true;
    this.describe(_descriptors2);
    this.apply(_appliers);
  }
  set(scope, values) {
    return set(this, scope, values);
  }
  get(scope) {
    return getScope$1(this, scope);
  }
  describe(scope, values) {
    return set(descriptors, scope, values);
  }
  override(scope, values) {
    return set(overrides, scope, values);
  }
  route(scope, name, targetScope, targetName) {
    const scopeObject = getScope$1(this, scope);
    const targetScopeObject = getScope$1(this, targetScope);
    const privateName = "_" + name;
    Object.defineProperties(scopeObject, {
      [privateName]: {
        value: scopeObject[name],
        writable: true
      },
      [name]: {
        enumerable: true,
        get() {
          const local = this[privateName];
          const target = targetScopeObject[targetName];
          if (isObject(local)) {
            return Object.assign({}, target, local);
          }
          return valueOrDefault(local, target);
        },
        set(value) {
          this[privateName] = value;
        }
      }
    });
  }
  apply(appliers) {
    appliers.forEach((apply) => apply(this));
  }
}
var defaults = /* @__PURE__ */ new Defaults({
  _scriptable: (name) => !name.startsWith("on"),
  _indexable: (name) => name !== "events",
  hover: {
    _fallback: "interaction"
  },
  interaction: {
    _scriptable: false,
    _indexable: false
  }
}, [
  applyAnimationsDefaults,
  applyLayoutsDefaults,
  applyScaleDefaults
]);
function toFontString(font) {
  if (!font || isNullOrUndef(font.size) || isNullOrUndef(font.family)) {
    return null;
  }
  return (font.style ? font.style + " " : "") + (font.weight ? font.weight + " " : "") + font.size + "px " + font.family;
}
function _measureText(ctx, data, gc, longest, string) {
  let textWidth = data[string];
  if (!textWidth) {
    textWidth = data[string] = ctx.measureText(string).width;
    gc.push(string);
  }
  if (textWidth > longest) {
    longest = textWidth;
  }
  return longest;
}
function _longestText(ctx, font, arrayOfThings, cache) {
  cache = cache || {};
  let data = cache.data = cache.data || {};
  let gc = cache.garbageCollect = cache.garbageCollect || [];
  if (cache.font !== font) {
    data = cache.data = {};
    gc = cache.garbageCollect = [];
    cache.font = font;
  }
  ctx.save();
  ctx.font = font;
  let longest = 0;
  const ilen = arrayOfThings.length;
  let i, j2, jlen, thing, nestedThing;
  for (i = 0; i < ilen; i++) {
    thing = arrayOfThings[i];
    if (thing !== void 0 && thing !== null && !isArray(thing)) {
      longest = _measureText(ctx, data, gc, longest, thing);
    } else if (isArray(thing)) {
      for (j2 = 0, jlen = thing.length; j2 < jlen; j2++) {
        nestedThing = thing[j2];
        if (nestedThing !== void 0 && nestedThing !== null && !isArray(nestedThing)) {
          longest = _measureText(ctx, data, gc, longest, nestedThing);
        }
      }
    }
  }
  ctx.restore();
  const gcLen = gc.length / 2;
  if (gcLen > arrayOfThings.length) {
    for (i = 0; i < gcLen; i++) {
      delete data[gc[i]];
    }
    gc.splice(0, gcLen);
  }
  return longest;
}
function _alignPixel(chart, pixel, width) {
  const devicePixelRatio = chart.currentDevicePixelRatio;
  const halfWidth = width !== 0 ? Math.max(width / 2, 0.5) : 0;
  return Math.round((pixel - halfWidth) * devicePixelRatio) / devicePixelRatio + halfWidth;
}
function clearCanvas(canvas, ctx) {
  ctx = ctx || canvas.getContext("2d");
  ctx.save();
  ctx.resetTransform();
  ctx.clearRect(0, 0, canvas.width, canvas.height);
  ctx.restore();
}
function drawPoint(ctx, options, x2, y2) {
  drawPointLegend(ctx, options, x2, y2, null);
}
function drawPointLegend(ctx, options, x2, y2, w2) {
  let type, xOffset, yOffset, size2, cornerRadius, width, xOffsetW, yOffsetW;
  const style = options.pointStyle;
  const rotation = options.rotation;
  const radius = options.radius;
  let rad = (rotation || 0) * RAD_PER_DEG;
  if (style && typeof style === "object") {
    type = style.toString();
    if (type === "[object HTMLImageElement]" || type === "[object HTMLCanvasElement]") {
      ctx.save();
      ctx.translate(x2, y2);
      ctx.rotate(rad);
      ctx.drawImage(style, -style.width / 2, -style.height / 2, style.width, style.height);
      ctx.restore();
      return;
    }
  }
  if (isNaN(radius) || radius <= 0) {
    return;
  }
  ctx.beginPath();
  switch (style) {
    default:
      if (w2) {
        ctx.ellipse(x2, y2, w2 / 2, radius, 0, 0, TAU);
      } else {
        ctx.arc(x2, y2, radius, 0, TAU);
      }
      ctx.closePath();
      break;
    case "triangle":
      width = w2 ? w2 / 2 : radius;
      ctx.moveTo(x2 + Math.sin(rad) * width, y2 - Math.cos(rad) * radius);
      rad += TWO_THIRDS_PI;
      ctx.lineTo(x2 + Math.sin(rad) * width, y2 - Math.cos(rad) * radius);
      rad += TWO_THIRDS_PI;
      ctx.lineTo(x2 + Math.sin(rad) * width, y2 - Math.cos(rad) * radius);
      ctx.closePath();
      break;
    case "rectRounded":
      cornerRadius = radius * 0.516;
      size2 = radius - cornerRadius;
      xOffset = Math.cos(rad + QUARTER_PI) * size2;
      xOffsetW = Math.cos(rad + QUARTER_PI) * (w2 ? w2 / 2 - cornerRadius : size2);
      yOffset = Math.sin(rad + QUARTER_PI) * size2;
      yOffsetW = Math.sin(rad + QUARTER_PI) * (w2 ? w2 / 2 - cornerRadius : size2);
      ctx.arc(x2 - xOffsetW, y2 - yOffset, cornerRadius, rad - PI, rad - HALF_PI);
      ctx.arc(x2 + yOffsetW, y2 - xOffset, cornerRadius, rad - HALF_PI, rad);
      ctx.arc(x2 + xOffsetW, y2 + yOffset, cornerRadius, rad, rad + HALF_PI);
      ctx.arc(x2 - yOffsetW, y2 + xOffset, cornerRadius, rad + HALF_PI, rad + PI);
      ctx.closePath();
      break;
    case "rect":
      if (!rotation) {
        size2 = Math.SQRT1_2 * radius;
        width = w2 ? w2 / 2 : size2;
        ctx.rect(x2 - width, y2 - size2, 2 * width, 2 * size2);
        break;
      }
      rad += QUARTER_PI;
    case "rectRot":
      xOffsetW = Math.cos(rad) * (w2 ? w2 / 2 : radius);
      xOffset = Math.cos(rad) * radius;
      yOffset = Math.sin(rad) * radius;
      yOffsetW = Math.sin(rad) * (w2 ? w2 / 2 : radius);
      ctx.moveTo(x2 - xOffsetW, y2 - yOffset);
      ctx.lineTo(x2 + yOffsetW, y2 - xOffset);
      ctx.lineTo(x2 + xOffsetW, y2 + yOffset);
      ctx.lineTo(x2 - yOffsetW, y2 + xOffset);
      ctx.closePath();
      break;
    case "crossRot":
      rad += QUARTER_PI;
    case "cross":
      xOffsetW = Math.cos(rad) * (w2 ? w2 / 2 : radius);
      xOffset = Math.cos(rad) * radius;
      yOffset = Math.sin(rad) * radius;
      yOffsetW = Math.sin(rad) * (w2 ? w2 / 2 : radius);
      ctx.moveTo(x2 - xOffsetW, y2 - yOffset);
      ctx.lineTo(x2 + xOffsetW, y2 + yOffset);
      ctx.moveTo(x2 + yOffsetW, y2 - xOffset);
      ctx.lineTo(x2 - yOffsetW, y2 + xOffset);
      break;
    case "star":
      xOffsetW = Math.cos(rad) * (w2 ? w2 / 2 : radius);
      xOffset = Math.cos(rad) * radius;
      yOffset = Math.sin(rad) * radius;
      yOffsetW = Math.sin(rad) * (w2 ? w2 / 2 : radius);
      ctx.moveTo(x2 - xOffsetW, y2 - yOffset);
      ctx.lineTo(x2 + xOffsetW, y2 + yOffset);
      ctx.moveTo(x2 + yOffsetW, y2 - xOffset);
      ctx.lineTo(x2 - yOffsetW, y2 + xOffset);
      rad += QUARTER_PI;
      xOffsetW = Math.cos(rad) * (w2 ? w2 / 2 : radius);
      xOffset = Math.cos(rad) * radius;
      yOffset = Math.sin(rad) * radius;
      yOffsetW = Math.sin(rad) * (w2 ? w2 / 2 : radius);
      ctx.moveTo(x2 - xOffsetW, y2 - yOffset);
      ctx.lineTo(x2 + xOffsetW, y2 + yOffset);
      ctx.moveTo(x2 + yOffsetW, y2 - xOffset);
      ctx.lineTo(x2 - yOffsetW, y2 + xOffset);
      break;
    case "line":
      xOffset = w2 ? w2 / 2 : Math.cos(rad) * radius;
      yOffset = Math.sin(rad) * radius;
      ctx.moveTo(x2 - xOffset, y2 - yOffset);
      ctx.lineTo(x2 + xOffset, y2 + yOffset);
      break;
    case "dash":
      ctx.moveTo(x2, y2);
      ctx.lineTo(x2 + Math.cos(rad) * (w2 ? w2 / 2 : radius), y2 + Math.sin(rad) * radius);
      break;
    case false:
      ctx.closePath();
      break;
  }
  ctx.fill();
  if (options.borderWidth > 0) {
    ctx.stroke();
  }
}
function _isPointInArea(point, area, margin) {
  margin = margin || 0.5;
  return !area || point && point.x > area.left - margin && point.x < area.right + margin && point.y > area.top - margin && point.y < area.bottom + margin;
}
function clipArea(ctx, area) {
  ctx.save();
  ctx.beginPath();
  ctx.rect(area.left, area.top, area.right - area.left, area.bottom - area.top);
  ctx.clip();
}
function unclipArea(ctx) {
  ctx.restore();
}
function _steppedLineTo(ctx, previous, target, flip, mode) {
  if (!previous) {
    return ctx.lineTo(target.x, target.y);
  }
  if (mode === "middle") {
    const midpoint = (previous.x + target.x) / 2;
    ctx.lineTo(midpoint, previous.y);
    ctx.lineTo(midpoint, target.y);
  } else if (mode === "after" !== !!flip) {
    ctx.lineTo(previous.x, target.y);
  } else {
    ctx.lineTo(target.x, previous.y);
  }
  ctx.lineTo(target.x, target.y);
}
function _bezierCurveTo(ctx, previous, target, flip) {
  if (!previous) {
    return ctx.lineTo(target.x, target.y);
  }
  ctx.bezierCurveTo(flip ? previous.cp1x : previous.cp2x, flip ? previous.cp1y : previous.cp2y, flip ? target.cp2x : target.cp1x, flip ? target.cp2y : target.cp1y, target.x, target.y);
}
function setRenderOpts(ctx, opts) {
  if (opts.translation) {
    ctx.translate(opts.translation[0], opts.translation[1]);
  }
  if (!isNullOrUndef(opts.rotation)) {
    ctx.rotate(opts.rotation);
  }
  if (opts.color) {
    ctx.fillStyle = opts.color;
  }
  if (opts.textAlign) {
    ctx.textAlign = opts.textAlign;
  }
  if (opts.textBaseline) {
    ctx.textBaseline = opts.textBaseline;
  }
}
function decorateText(ctx, x2, y2, line, opts) {
  if (opts.strikethrough || opts.underline) {
    const metrics2 = ctx.measureText(line);
    const left = x2 - metrics2.actualBoundingBoxLeft;
    const right = x2 + metrics2.actualBoundingBoxRight;
    const top = y2 - metrics2.actualBoundingBoxAscent;
    const bottom = y2 + metrics2.actualBoundingBoxDescent;
    const yDecoration = opts.strikethrough ? (top + bottom) / 2 : bottom;
    ctx.strokeStyle = ctx.fillStyle;
    ctx.beginPath();
    ctx.lineWidth = opts.decorationWidth || 2;
    ctx.moveTo(left, yDecoration);
    ctx.lineTo(right, yDecoration);
    ctx.stroke();
  }
}
function drawBackdrop(ctx, opts) {
  const oldColor = ctx.fillStyle;
  ctx.fillStyle = opts.color;
  ctx.fillRect(opts.left, opts.top, opts.width, opts.height);
  ctx.fillStyle = oldColor;
}
function renderText(ctx, text2, x2, y2, font, opts = {}) {
  const lines = isArray(text2) ? text2 : [
    text2
  ];
  const stroke = opts.strokeWidth > 0 && opts.strokeColor !== "";
  let i, line;
  ctx.save();
  ctx.font = font.string;
  setRenderOpts(ctx, opts);
  for (i = 0; i < lines.length; ++i) {
    line = lines[i];
    if (opts.backdrop) {
      drawBackdrop(ctx, opts.backdrop);
    }
    if (stroke) {
      if (opts.strokeColor) {
        ctx.strokeStyle = opts.strokeColor;
      }
      if (!isNullOrUndef(opts.strokeWidth)) {
        ctx.lineWidth = opts.strokeWidth;
      }
      ctx.strokeText(line, x2, y2, opts.maxWidth);
    }
    ctx.fillText(line, x2, y2, opts.maxWidth);
    decorateText(ctx, x2, y2, line, opts);
    y2 += Number(font.lineHeight);
  }
  ctx.restore();
}
function addRoundedRectPath(ctx, rect) {
  const { x: x2, y: y2, w: w2, h: h3, radius } = rect;
  ctx.arc(x2 + radius.topLeft, y2 + radius.topLeft, radius.topLeft, 1.5 * PI, PI, true);
  ctx.lineTo(x2, y2 + h3 - radius.bottomLeft);
  ctx.arc(x2 + radius.bottomLeft, y2 + h3 - radius.bottomLeft, radius.bottomLeft, PI, HALF_PI, true);
  ctx.lineTo(x2 + w2 - radius.bottomRight, y2 + h3);
  ctx.arc(x2 + w2 - radius.bottomRight, y2 + h3 - radius.bottomRight, radius.bottomRight, HALF_PI, 0, true);
  ctx.lineTo(x2 + w2, y2 + radius.topRight);
  ctx.arc(x2 + w2 - radius.topRight, y2 + radius.topRight, radius.topRight, 0, -HALF_PI, true);
  ctx.lineTo(x2 + radius.topLeft, y2);
}
const LINE_HEIGHT = /^(normal|(\d+(?:\.\d+)?)(px|em|%)?)$/;
const FONT_STYLE = /^(normal|italic|initial|inherit|unset|(oblique( -?[0-9]?[0-9]deg)?))$/;
function toLineHeight(value, size2) {
  const matches = ("" + value).match(LINE_HEIGHT);
  if (!matches || matches[1] === "normal") {
    return size2 * 1.2;
  }
  value = +matches[2];
  switch (matches[3]) {
    case "px":
      return value;
    case "%":
      value /= 100;
      break;
  }
  return size2 * value;
}
const numberOrZero = (v2) => +v2 || 0;
function _readValueToProps(value, props) {
  const ret = {};
  const objProps = isObject(props);
  const keys = objProps ? Object.keys(props) : props;
  const read = isObject(value) ? objProps ? (prop) => valueOrDefault(value[prop], value[props[prop]]) : (prop) => value[prop] : () => value;
  for (const prop of keys) {
    ret[prop] = numberOrZero(read(prop));
  }
  return ret;
}
function toTRBL(value) {
  return _readValueToProps(value, {
    top: "y",
    right: "x",
    bottom: "y",
    left: "x"
  });
}
function toTRBLCorners(value) {
  return _readValueToProps(value, [
    "topLeft",
    "topRight",
    "bottomLeft",
    "bottomRight"
  ]);
}
function toPadding(value) {
  const obj = toTRBL(value);
  obj.width = obj.left + obj.right;
  obj.height = obj.top + obj.bottom;
  return obj;
}
function toFont(options, fallback) {
  options = options || {};
  fallback = fallback || defaults.font;
  let size2 = valueOrDefault(options.size, fallback.size);
  if (typeof size2 === "string") {
    size2 = parseInt(size2, 10);
  }
  let style = valueOrDefault(options.style, fallback.style);
  if (style && !("" + style).match(FONT_STYLE)) {
    console.warn('Invalid font style specified: "' + style + '"');
    style = void 0;
  }
  const font = {
    family: valueOrDefault(options.family, fallback.family),
    lineHeight: toLineHeight(valueOrDefault(options.lineHeight, fallback.lineHeight), size2),
    size: size2,
    style,
    weight: valueOrDefault(options.weight, fallback.weight),
    string: ""
  };
  font.string = toFontString(font);
  return font;
}
function resolve(inputs, context, index, info) {
  let cacheable = true;
  let i, ilen, value;
  for (i = 0, ilen = inputs.length; i < ilen; ++i) {
    value = inputs[i];
    if (value === void 0) {
      continue;
    }
    if (context !== void 0 && typeof value === "function") {
      value = value(context);
      cacheable = false;
    }
    if (index !== void 0 && isArray(value)) {
      value = value[index % value.length];
      cacheable = false;
    }
    if (value !== void 0) {
      if (info && !cacheable) {
        info.cacheable = false;
      }
      return value;
    }
  }
}
function _addGrace(minmax, grace, beginAtZero) {
  const { min, max } = minmax;
  const change = toDimension(grace, (max - min) / 2);
  const keepZero = (value, add) => beginAtZero && value === 0 ? 0 : value + add;
  return {
    min: keepZero(min, -Math.abs(change)),
    max: keepZero(max, change)
  };
}
function createContext(parentContext, context) {
  return Object.assign(Object.create(parentContext), context);
}
function _createResolver(scopes, prefixes = [
  ""
], rootScopes, fallback, getTarget = () => scopes[0]) {
  const finalRootScopes = rootScopes || scopes;
  if (typeof fallback === "undefined") {
    fallback = _resolve("_fallback", scopes);
  }
  const cache = {
    [Symbol.toStringTag]: "Object",
    _cacheable: true,
    _scopes: scopes,
    _rootScopes: finalRootScopes,
    _fallback: fallback,
    _getTarget: getTarget,
    override: (scope) => _createResolver([
      scope,
      ...scopes
    ], prefixes, finalRootScopes, fallback)
  };
  return new Proxy(cache, {
    /**
    * A trap for the delete operator.
    */
    deleteProperty(target, prop) {
      delete target[prop];
      delete target._keys;
      delete scopes[0][prop];
      return true;
    },
    /**
    * A trap for getting property values.
    */
    get(target, prop) {
      return _cached(target, prop, () => _resolveWithPrefixes(prop, prefixes, scopes, target));
    },
    /**
    * A trap for Object.getOwnPropertyDescriptor.
    * Also used by Object.hasOwnProperty.
    */
    getOwnPropertyDescriptor(target, prop) {
      return Reflect.getOwnPropertyDescriptor(target._scopes[0], prop);
    },
    /**
    * A trap for Object.getPrototypeOf.
    */
    getPrototypeOf() {
      return Reflect.getPrototypeOf(scopes[0]);
    },
    /**
    * A trap for the in operator.
    */
    has(target, prop) {
      return getKeysFromAllScopes(target).includes(prop);
    },
    /**
    * A trap for Object.getOwnPropertyNames and Object.getOwnPropertySymbols.
    */
    ownKeys(target) {
      return getKeysFromAllScopes(target);
    },
    /**
    * A trap for setting property values.
    */
    set(target, prop, value) {
      const storage = target._storage || (target._storage = getTarget());
      target[prop] = storage[prop] = value;
      delete target._keys;
      return true;
    }
  });
}
function _attachContext(proxy, context, subProxy, descriptorDefaults) {
  const cache = {
    _cacheable: false,
    _proxy: proxy,
    _context: context,
    _subProxy: subProxy,
    _stack: /* @__PURE__ */ new Set(),
    _descriptors: _descriptors(proxy, descriptorDefaults),
    setContext: (ctx) => _attachContext(proxy, ctx, subProxy, descriptorDefaults),
    override: (scope) => _attachContext(proxy.override(scope), context, subProxy, descriptorDefaults)
  };
  return new Proxy(cache, {
    /**
    * A trap for the delete operator.
    */
    deleteProperty(target, prop) {
      delete target[prop];
      delete proxy[prop];
      return true;
    },
    /**
    * A trap for getting property values.
    */
    get(target, prop, receiver) {
      return _cached(target, prop, () => _resolveWithContext(target, prop, receiver));
    },
    /**
    * A trap for Object.getOwnPropertyDescriptor.
    * Also used by Object.hasOwnProperty.
    */
    getOwnPropertyDescriptor(target, prop) {
      return target._descriptors.allKeys ? Reflect.has(proxy, prop) ? {
        enumerable: true,
        configurable: true
      } : void 0 : Reflect.getOwnPropertyDescriptor(proxy, prop);
    },
    /**
    * A trap for Object.getPrototypeOf.
    */
    getPrototypeOf() {
      return Reflect.getPrototypeOf(proxy);
    },
    /**
    * A trap for the in operator.
    */
    has(target, prop) {
      return Reflect.has(proxy, prop);
    },
    /**
    * A trap for Object.getOwnPropertyNames and Object.getOwnPropertySymbols.
    */
    ownKeys() {
      return Reflect.ownKeys(proxy);
    },
    /**
    * A trap for setting property values.
    */
    set(target, prop, value) {
      proxy[prop] = value;
      delete target[prop];
      return true;
    }
  });
}
function _descriptors(proxy, defaults2 = {
  scriptable: true,
  indexable: true
}) {
  const { _scriptable = defaults2.scriptable, _indexable = defaults2.indexable, _allKeys = defaults2.allKeys } = proxy;
  return {
    allKeys: _allKeys,
    scriptable: _scriptable,
    indexable: _indexable,
    isScriptable: isFunction(_scriptable) ? _scriptable : () => _scriptable,
    isIndexable: isFunction(_indexable) ? _indexable : () => _indexable
  };
}
const readKey = (prefix, name) => prefix ? prefix + _capitalize(name) : name;
const needsSubResolver = (prop, value) => isObject(value) && prop !== "adapters" && (Object.getPrototypeOf(value) === null || value.constructor === Object);
function _cached(target, prop, resolve2) {
  if (Object.prototype.hasOwnProperty.call(target, prop)) {
    return target[prop];
  }
  const value = resolve2();
  target[prop] = value;
  return value;
}
function _resolveWithContext(target, prop, receiver) {
  const { _proxy, _context, _subProxy, _descriptors: descriptors2 } = target;
  let value = _proxy[prop];
  if (isFunction(value) && descriptors2.isScriptable(prop)) {
    value = _resolveScriptable(prop, value, target, receiver);
  }
  if (isArray(value) && value.length) {
    value = _resolveArray(prop, value, target, descriptors2.isIndexable);
  }
  if (needsSubResolver(prop, value)) {
    value = _attachContext(value, _context, _subProxy && _subProxy[prop], descriptors2);
  }
  return value;
}
function _resolveScriptable(prop, getValue, target, receiver) {
  const { _proxy, _context, _subProxy, _stack } = target;
  if (_stack.has(prop)) {
    throw new Error("Recursion detected: " + Array.from(_stack).join("->") + "->" + prop);
  }
  _stack.add(prop);
  let value = getValue(_context, _subProxy || receiver);
  _stack.delete(prop);
  if (needsSubResolver(prop, value)) {
    value = createSubResolver(_proxy._scopes, _proxy, prop, value);
  }
  return value;
}
function _resolveArray(prop, value, target, isIndexable) {
  const { _proxy, _context, _subProxy, _descriptors: descriptors2 } = target;
  if (typeof _context.index !== "undefined" && isIndexable(prop)) {
    return value[_context.index % value.length];
  } else if (isObject(value[0])) {
    const arr = value;
    const scopes = _proxy._scopes.filter((s) => s !== arr);
    value = [];
    for (const item of arr) {
      const resolver = createSubResolver(scopes, _proxy, prop, item);
      value.push(_attachContext(resolver, _context, _subProxy && _subProxy[prop], descriptors2));
    }
  }
  return value;
}
function resolveFallback(fallback, prop, value) {
  return isFunction(fallback) ? fallback(prop, value) : fallback;
}
const getScope = (key, parent) => key === true ? parent : typeof key === "string" ? resolveObjectKey(parent, key) : void 0;
function addScopes(set2, parentScopes, key, parentFallback, value) {
  for (const parent of parentScopes) {
    const scope = getScope(key, parent);
    if (scope) {
      set2.add(scope);
      const fallback = resolveFallback(scope._fallback, key, value);
      if (typeof fallback !== "undefined" && fallback !== key && fallback !== parentFallback) {
        return fallback;
      }
    } else if (scope === false && typeof parentFallback !== "undefined" && key !== parentFallback) {
      return null;
    }
  }
  return false;
}
function createSubResolver(parentScopes, resolver, prop, value) {
  const rootScopes = resolver._rootScopes;
  const fallback = resolveFallback(resolver._fallback, prop, value);
  const allScopes = [
    ...parentScopes,
    ...rootScopes
  ];
  const set2 = /* @__PURE__ */ new Set();
  set2.add(value);
  let key = addScopesFromKey(set2, allScopes, prop, fallback || prop, value);
  if (key === null) {
    return false;
  }
  if (typeof fallback !== "undefined" && fallback !== prop) {
    key = addScopesFromKey(set2, allScopes, fallback, key, value);
    if (key === null) {
      return false;
    }
  }
  return _createResolver(Array.from(set2), [
    ""
  ], rootScopes, fallback, () => subGetTarget(resolver, prop, value));
}
function addScopesFromKey(set2, allScopes, key, fallback, item) {
  while (key) {
    key = addScopes(set2, allScopes, key, fallback, item);
  }
  return key;
}
function subGetTarget(resolver, prop, value) {
  const parent = resolver._getTarget();
  if (!(prop in parent)) {
    parent[prop] = {};
  }
  const target = parent[prop];
  if (isArray(target) && isObject(value)) {
    return value;
  }
  return target || {};
}
function _resolveWithPrefixes(prop, prefixes, scopes, proxy) {
  let value;
  for (const prefix of prefixes) {
    value = _resolve(readKey(prefix, prop), scopes);
    if (typeof value !== "undefined") {
      return needsSubResolver(prop, value) ? createSubResolver(scopes, proxy, prop, value) : value;
    }
  }
}
function _resolve(key, scopes) {
  for (const scope of scopes) {
    if (!scope) {
      continue;
    }
    const value = scope[key];
    if (typeof value !== "undefined") {
      return value;
    }
  }
}
function getKeysFromAllScopes(target) {
  let keys = target._keys;
  if (!keys) {
    keys = target._keys = resolveKeysFromAllScopes(target._scopes);
  }
  return keys;
}
function resolveKeysFromAllScopes(scopes) {
  const set2 = /* @__PURE__ */ new Set();
  for (const scope of scopes) {
    for (const key of Object.keys(scope).filter((k2) => !k2.startsWith("_"))) {
      set2.add(key);
    }
  }
  return Array.from(set2);
}
const EPSILON = Number.EPSILON || 1e-14;
const getPoint = (points, i) => i < points.length && !points[i].skip && points[i];
const getValueAxis = (indexAxis) => indexAxis === "x" ? "y" : "x";
function splineCurve(firstPoint, middlePoint, afterPoint, t) {
  const previous = firstPoint.skip ? middlePoint : firstPoint;
  const current = middlePoint;
  const next = afterPoint.skip ? middlePoint : afterPoint;
  const d01 = distanceBetweenPoints(current, previous);
  const d12 = distanceBetweenPoints(next, current);
  let s01 = d01 / (d01 + d12);
  let s12 = d12 / (d01 + d12);
  s01 = isNaN(s01) ? 0 : s01;
  s12 = isNaN(s12) ? 0 : s12;
  const fa = t * s01;
  const fb = t * s12;
  return {
    previous: {
      x: current.x - fa * (next.x - previous.x),
      y: current.y - fa * (next.y - previous.y)
    },
    next: {
      x: current.x + fb * (next.x - previous.x),
      y: current.y + fb * (next.y - previous.y)
    }
  };
}
function monotoneAdjust(points, deltaK, mK) {
  const pointsLen = points.length;
  let alphaK, betaK, tauK, squaredMagnitude, pointCurrent;
  let pointAfter = getPoint(points, 0);
  for (let i = 0; i < pointsLen - 1; ++i) {
    pointCurrent = pointAfter;
    pointAfter = getPoint(points, i + 1);
    if (!pointCurrent || !pointAfter) {
      continue;
    }
    if (almostEquals(deltaK[i], 0, EPSILON)) {
      mK[i] = mK[i + 1] = 0;
      continue;
    }
    alphaK = mK[i] / deltaK[i];
    betaK = mK[i + 1] / deltaK[i];
    squaredMagnitude = Math.pow(alphaK, 2) + Math.pow(betaK, 2);
    if (squaredMagnitude <= 9) {
      continue;
    }
    tauK = 3 / Math.sqrt(squaredMagnitude);
    mK[i] = alphaK * tauK * deltaK[i];
    mK[i + 1] = betaK * tauK * deltaK[i];
  }
}
function monotoneCompute(points, mK, indexAxis = "x") {
  const valueAxis = getValueAxis(indexAxis);
  const pointsLen = points.length;
  let delta, pointBefore, pointCurrent;
  let pointAfter = getPoint(points, 0);
  for (let i = 0; i < pointsLen; ++i) {
    pointBefore = pointCurrent;
    pointCurrent = pointAfter;
    pointAfter = getPoint(points, i + 1);
    if (!pointCurrent) {
      continue;
    }
    const iPixel = pointCurrent[indexAxis];
    const vPixel = pointCurrent[valueAxis];
    if (pointBefore) {
      delta = (iPixel - pointBefore[indexAxis]) / 3;
      pointCurrent[`cp1${indexAxis}`] = iPixel - delta;
      pointCurrent[`cp1${valueAxis}`] = vPixel - delta * mK[i];
    }
    if (pointAfter) {
      delta = (pointAfter[indexAxis] - iPixel) / 3;
      pointCurrent[`cp2${indexAxis}`] = iPixel + delta;
      pointCurrent[`cp2${valueAxis}`] = vPixel + delta * mK[i];
    }
  }
}
function splineCurveMonotone(points, indexAxis = "x") {
  const valueAxis = getValueAxis(indexAxis);
  const pointsLen = points.length;
  const deltaK = Array(pointsLen).fill(0);
  const mK = Array(pointsLen);
  let i, pointBefore, pointCurrent;
  let pointAfter = getPoint(points, 0);
  for (i = 0; i < pointsLen; ++i) {
    pointBefore = pointCurrent;
    pointCurrent = pointAfter;
    pointAfter = getPoint(points, i + 1);
    if (!pointCurrent) {
      continue;
    }
    if (pointAfter) {
      const slopeDelta = pointAfter[indexAxis] - pointCurrent[indexAxis];
      deltaK[i] = slopeDelta !== 0 ? (pointAfter[valueAxis] - pointCurrent[valueAxis]) / slopeDelta : 0;
    }
    mK[i] = !pointBefore ? deltaK[i] : !pointAfter ? deltaK[i - 1] : sign$2(deltaK[i - 1]) !== sign$2(deltaK[i]) ? 0 : (deltaK[i - 1] + deltaK[i]) / 2;
  }
  monotoneAdjust(points, deltaK, mK);
  monotoneCompute(points, mK, indexAxis);
}
function capControlPoint(pt2, min, max) {
  return Math.max(Math.min(pt2, max), min);
}
function capBezierPoints(points, area) {
  let i, ilen, point, inArea, inAreaPrev;
  let inAreaNext = _isPointInArea(points[0], area);
  for (i = 0, ilen = points.length; i < ilen; ++i) {
    inAreaPrev = inArea;
    inArea = inAreaNext;
    inAreaNext = i < ilen - 1 && _isPointInArea(points[i + 1], area);
    if (!inArea) {
      continue;
    }
    point = points[i];
    if (inAreaPrev) {
      point.cp1x = capControlPoint(point.cp1x, area.left, area.right);
      point.cp1y = capControlPoint(point.cp1y, area.top, area.bottom);
    }
    if (inAreaNext) {
      point.cp2x = capControlPoint(point.cp2x, area.left, area.right);
      point.cp2y = capControlPoint(point.cp2y, area.top, area.bottom);
    }
  }
}
function _updateBezierControlPoints(points, options, area, loop, indexAxis) {
  let i, ilen, point, controlPoints;
  if (options.spanGaps) {
    points = points.filter((pt2) => !pt2.skip);
  }
  if (options.cubicInterpolationMode === "monotone") {
    splineCurveMonotone(points, indexAxis);
  } else {
    let prev = loop ? points[points.length - 1] : points[0];
    for (i = 0, ilen = points.length; i < ilen; ++i) {
      point = points[i];
      controlPoints = splineCurve(prev, point, points[Math.min(i + 1, ilen - (loop ? 0 : 1)) % ilen], options.tension);
      point.cp1x = controlPoints.previous.x;
      point.cp1y = controlPoints.previous.y;
      point.cp2x = controlPoints.next.x;
      point.cp2y = controlPoints.next.y;
      prev = point;
    }
  }
  if (options.capBezierPoints) {
    capBezierPoints(points, area);
  }
}
function _isDomSupported() {
  return typeof window !== "undefined" && typeof document !== "undefined";
}
function _getParentNode(domNode) {
  let parent = domNode.parentNode;
  if (parent && parent.toString() === "[object ShadowRoot]") {
    parent = parent.host;
  }
  return parent;
}
function parseMaxStyle(styleValue, node, parentProperty) {
  let valueInPixels;
  if (typeof styleValue === "string") {
    valueInPixels = parseInt(styleValue, 10);
    if (styleValue.indexOf("%") !== -1) {
      valueInPixels = valueInPixels / 100 * node.parentNode[parentProperty];
    }
  } else {
    valueInPixels = styleValue;
  }
  return valueInPixels;
}
const getComputedStyle = (element2) => element2.ownerDocument.defaultView.getComputedStyle(element2, null);
function getStyle(el, property) {
  return getComputedStyle(el).getPropertyValue(property);
}
const positions = [
  "top",
  "right",
  "bottom",
  "left"
];
function getPositionedStyle(styles, style, suffix) {
  const result = {};
  suffix = suffix ? "-" + suffix : "";
  for (let i = 0; i < 4; i++) {
    const pos = positions[i];
    result[pos] = parseFloat(styles[style + "-" + pos + suffix]) || 0;
  }
  result.width = result.left + result.right;
  result.height = result.top + result.bottom;
  return result;
}
const useOffsetPos = (x2, y2, target) => (x2 > 0 || y2 > 0) && (!target || !target.shadowRoot);
function getCanvasPosition(e2, canvas) {
  const touches = e2.touches;
  const source = touches && touches.length ? touches[0] : e2;
  const { offsetX, offsetY } = source;
  let box = false;
  let x2, y2;
  if (useOffsetPos(offsetX, offsetY, e2.target)) {
    x2 = offsetX;
    y2 = offsetY;
  } else {
    const rect = canvas.getBoundingClientRect();
    x2 = source.clientX - rect.left;
    y2 = source.clientY - rect.top;
    box = true;
  }
  return {
    x: x2,
    y: y2,
    box
  };
}
function getRelativePosition(event, chart) {
  if ("native" in event) {
    return event;
  }
  const { canvas, currentDevicePixelRatio } = chart;
  const style = getComputedStyle(canvas);
  const borderBox = style.boxSizing === "border-box";
  const paddings = getPositionedStyle(style, "padding");
  const borders = getPositionedStyle(style, "border", "width");
  const { x: x2, y: y2, box } = getCanvasPosition(event, canvas);
  const xOffset = paddings.left + (box && borders.left);
  const yOffset = paddings.top + (box && borders.top);
  let { width, height } = chart;
  if (borderBox) {
    width -= paddings.width + borders.width;
    height -= paddings.height + borders.height;
  }
  return {
    x: Math.round((x2 - xOffset) / width * canvas.width / currentDevicePixelRatio),
    y: Math.round((y2 - yOffset) / height * canvas.height / currentDevicePixelRatio)
  };
}
function getContainerSize(canvas, width, height) {
  let maxWidth, maxHeight;
  if (width === void 0 || height === void 0) {
    const container = _getParentNode(canvas);
    if (!container) {
      width = canvas.clientWidth;
      height = canvas.clientHeight;
    } else {
      const rect = container.getBoundingClientRect();
      const containerStyle = getComputedStyle(container);
      const containerBorder = getPositionedStyle(containerStyle, "border", "width");
      const containerPadding = getPositionedStyle(containerStyle, "padding");
      width = rect.width - containerPadding.width - containerBorder.width;
      height = rect.height - containerPadding.height - containerBorder.height;
      maxWidth = parseMaxStyle(containerStyle.maxWidth, container, "clientWidth");
      maxHeight = parseMaxStyle(containerStyle.maxHeight, container, "clientHeight");
    }
  }
  return {
    width,
    height,
    maxWidth: maxWidth || INFINITY,
    maxHeight: maxHeight || INFINITY
  };
}
const round1 = (v2) => Math.round(v2 * 10) / 10;
function getMaximumSize(canvas, bbWidth, bbHeight, aspectRatio) {
  const style = getComputedStyle(canvas);
  const margins = getPositionedStyle(style, "margin");
  const maxWidth = parseMaxStyle(style.maxWidth, canvas, "clientWidth") || INFINITY;
  const maxHeight = parseMaxStyle(style.maxHeight, canvas, "clientHeight") || INFINITY;
  const containerSize = getContainerSize(canvas, bbWidth, bbHeight);
  let { width, height } = containerSize;
  if (style.boxSizing === "content-box") {
    const borders = getPositionedStyle(style, "border", "width");
    const paddings = getPositionedStyle(style, "padding");
    width -= paddings.width + borders.width;
    height -= paddings.height + borders.height;
  }
  width = Math.max(0, width - margins.width);
  height = Math.max(0, aspectRatio ? width / aspectRatio : height - margins.height);
  width = round1(Math.min(width, maxWidth, containerSize.maxWidth));
  height = round1(Math.min(height, maxHeight, containerSize.maxHeight));
  if (width && !height) {
    height = round1(width / 2);
  }
  const maintainHeight = bbWidth !== void 0 || bbHeight !== void 0;
  if (maintainHeight && aspectRatio && containerSize.height && height > containerSize.height) {
    height = containerSize.height;
    width = round1(Math.floor(height * aspectRatio));
  }
  return {
    width,
    height
  };
}
function retinaScale(chart, forceRatio, forceStyle) {
  const pixelRatio = forceRatio || 1;
  const deviceHeight = Math.floor(chart.height * pixelRatio);
  const deviceWidth = Math.floor(chart.width * pixelRatio);
  chart.height = Math.floor(chart.height);
  chart.width = Math.floor(chart.width);
  const canvas = chart.canvas;
  if (canvas.style && (forceStyle || !canvas.style.height && !canvas.style.width)) {
    canvas.style.height = `${chart.height}px`;
    canvas.style.width = `${chart.width}px`;
  }
  if (chart.currentDevicePixelRatio !== pixelRatio || canvas.height !== deviceHeight || canvas.width !== deviceWidth) {
    chart.currentDevicePixelRatio = pixelRatio;
    canvas.height = deviceHeight;
    canvas.width = deviceWidth;
    chart.ctx.setTransform(pixelRatio, 0, 0, pixelRatio, 0, 0);
    return true;
  }
  return false;
}
const supportsEventListenerOptions = function() {
  let passiveSupported = false;
  try {
    const options = {
      get passive() {
        passiveSupported = true;
        return false;
      }
    };
    window.addEventListener("test", null, options);
    window.removeEventListener("test", null, options);
  } catch (e2) {
  }
  return passiveSupported;
}();
function readUsedSize(element2, property) {
  const value = getStyle(element2, property);
  const matches = value && value.match(/^(\d+)(\.\d+)?px$/);
  return matches ? +matches[1] : void 0;
}
function _pointInLine(p1, p2, t, mode) {
  return {
    x: p1.x + t * (p2.x - p1.x),
    y: p1.y + t * (p2.y - p1.y)
  };
}
function _steppedInterpolation(p1, p2, t, mode) {
  return {
    x: p1.x + t * (p2.x - p1.x),
    y: mode === "middle" ? t < 0.5 ? p1.y : p2.y : mode === "after" ? t < 1 ? p1.y : p2.y : t > 0 ? p2.y : p1.y
  };
}
function _bezierInterpolation(p1, p2, t, mode) {
  const cp1 = {
    x: p1.cp2x,
    y: p1.cp2y
  };
  const cp2 = {
    x: p2.cp1x,
    y: p2.cp1y
  };
  const a2 = _pointInLine(p1, cp1, t);
  const b2 = _pointInLine(cp1, cp2, t);
  const c2 = _pointInLine(cp2, p2, t);
  const d2 = _pointInLine(a2, b2, t);
  const e2 = _pointInLine(b2, c2, t);
  return _pointInLine(d2, e2, t);
}
const getRightToLeftAdapter = function(rectX, width) {
  return {
    x(x2) {
      return rectX + rectX + width - x2;
    },
    setWidth(w2) {
      width = w2;
    },
    textAlign(align) {
      if (align === "center") {
        return align;
      }
      return align === "right" ? "left" : "right";
    },
    xPlus(x2, value) {
      return x2 - value;
    },
    leftForLtr(x2, itemWidth) {
      return x2 - itemWidth;
    }
  };
};
const getLeftToRightAdapter = function() {
  return {
    x(x2) {
      return x2;
    },
    setWidth(w2) {
    },
    textAlign(align) {
      return align;
    },
    xPlus(x2, value) {
      return x2 + value;
    },
    leftForLtr(x2, _itemWidth) {
      return x2;
    }
  };
};
function getRtlAdapter(rtl, rectX, width) {
  return rtl ? getRightToLeftAdapter(rectX, width) : getLeftToRightAdapter();
}
function overrideTextDirection(ctx, direction) {
  let style, original;
  if (direction === "ltr" || direction === "rtl") {
    style = ctx.canvas.style;
    original = [
      style.getPropertyValue("direction"),
      style.getPropertyPriority("direction")
    ];
    style.setProperty("direction", direction, "important");
    ctx.prevTextDirection = original;
  }
}
function restoreTextDirection(ctx, original) {
  if (original !== void 0) {
    delete ctx.prevTextDirection;
    ctx.canvas.style.setProperty("direction", original[0], original[1]);
  }
}
function propertyFn(property) {
  if (property === "angle") {
    return {
      between: _angleBetween,
      compare: _angleDiff,
      normalize: _normalizeAngle
    };
  }
  return {
    between: _isBetween,
    compare: (a2, b2) => a2 - b2,
    normalize: (x2) => x2
  };
}
function normalizeSegment({ start, end, count, loop, style }) {
  return {
    start: start % count,
    end: end % count,
    loop: loop && (end - start + 1) % count === 0,
    style
  };
}
function getSegment(segment, points, bounds) {
  const { property, start: startBound, end: endBound } = bounds;
  const { between, normalize } = propertyFn(property);
  const count = points.length;
  let { start, end, loop } = segment;
  let i, ilen;
  if (loop) {
    start += count;
    end += count;
    for (i = 0, ilen = count; i < ilen; ++i) {
      if (!between(normalize(points[start % count][property]), startBound, endBound)) {
        break;
      }
      start--;
      end--;
    }
    start %= count;
    end %= count;
  }
  if (end < start) {
    end += count;
  }
  return {
    start,
    end,
    loop,
    style: segment.style
  };
}
function _boundSegment(segment, points, bounds) {
  if (!bounds) {
    return [
      segment
    ];
  }
  const { property, start: startBound, end: endBound } = bounds;
  const count = points.length;
  const { compare, between, normalize } = propertyFn(property);
  const { start, end, loop, style } = getSegment(segment, points, bounds);
  const result = [];
  let inside = false;
  let subStart = null;
  let value, point, prevValue;
  const startIsBefore = () => between(startBound, prevValue, value) && compare(startBound, prevValue) !== 0;
  const endIsBefore = () => compare(endBound, value) === 0 || between(endBound, prevValue, value);
  const shouldStart = () => inside || startIsBefore();
  const shouldStop = () => !inside || endIsBefore();
  for (let i = start, prev = start; i <= end; ++i) {
    point = points[i % count];
    if (point.skip) {
      continue;
    }
    value = normalize(point[property]);
    if (value === prevValue) {
      continue;
    }
    inside = between(value, startBound, endBound);
    if (subStart === null && shouldStart()) {
      subStart = compare(value, startBound) === 0 ? i : prev;
    }
    if (subStart !== null && shouldStop()) {
      result.push(normalizeSegment({
        start: subStart,
        end: i,
        loop,
        count,
        style
      }));
      subStart = null;
    }
    prev = i;
    prevValue = value;
  }
  if (subStart !== null) {
    result.push(normalizeSegment({
      start: subStart,
      end,
      loop,
      count,
      style
    }));
  }
  return result;
}
function _boundSegments(line, bounds) {
  const result = [];
  const segments = line.segments;
  for (let i = 0; i < segments.length; i++) {
    const sub = _boundSegment(segments[i], line.points, bounds);
    if (sub.length) {
      result.push(...sub);
    }
  }
  return result;
}
function findStartAndEnd(points, count, loop, spanGaps) {
  let start = 0;
  let end = count - 1;
  if (loop && !spanGaps) {
    while (start < count && !points[start].skip) {
      start++;
    }
  }
  while (start < count && points[start].skip) {
    start++;
  }
  start %= count;
  if (loop) {
    end += start;
  }
  while (end > start && points[end % count].skip) {
    end--;
  }
  end %= count;
  return {
    start,
    end
  };
}
function solidSegments(points, start, max, loop) {
  const count = points.length;
  const result = [];
  let last = start;
  let prev = points[start];
  let end;
  for (end = start + 1; end <= max; ++end) {
    const cur = points[end % count];
    if (cur.skip || cur.stop) {
      if (!prev.skip) {
        loop = false;
        result.push({
          start: start % count,
          end: (end - 1) % count,
          loop
        });
        start = last = cur.stop ? end : null;
      }
    } else {
      last = end;
      if (prev.skip) {
        start = end;
      }
    }
    prev = cur;
  }
  if (last !== null) {
    result.push({
      start: start % count,
      end: last % count,
      loop
    });
  }
  return result;
}
function _computeSegments(line, segmentOptions) {
  const points = line.points;
  const spanGaps = line.options.spanGaps;
  const count = points.length;
  if (!count) {
    return [];
  }
  const loop = !!line._loop;
  const { start, end } = findStartAndEnd(points, count, loop, spanGaps);
  if (spanGaps === true) {
    return splitByStyles(line, [
      {
        start,
        end,
        loop
      }
    ], points, segmentOptions);
  }
  const max = end < start ? end + count : end;
  const completeLoop = !!line._fullLoop && start === 0 && end === count - 1;
  return splitByStyles(line, solidSegments(points, start, max, completeLoop), points, segmentOptions);
}
function splitByStyles(line, segments, points, segmentOptions) {
  if (!segmentOptions || !segmentOptions.setContext || !points) {
    return segments;
  }
  return doSplitByStyles(line, segments, points, segmentOptions);
}
function doSplitByStyles(line, segments, points, segmentOptions) {
  const chartContext = line._chart.getContext();
  const baseStyle = readStyle(line.options);
  const { _datasetIndex: datasetIndex, options: { spanGaps } } = line;
  const count = points.length;
  const result = [];
  let prevStyle = baseStyle;
  let start = segments[0].start;
  let i = start;
  function addStyle(s, e2, l2, st2) {
    const dir = spanGaps ? -1 : 1;
    if (s === e2) {
      return;
    }
    s += count;
    while (points[s % count].skip) {
      s -= dir;
    }
    while (points[e2 % count].skip) {
      e2 += dir;
    }
    if (s % count !== e2 % count) {
      result.push({
        start: s % count,
        end: e2 % count,
        loop: l2,
        style: st2
      });
      prevStyle = st2;
      start = e2 % count;
    }
  }
  for (const segment of segments) {
    start = spanGaps ? start : segment.start;
    let prev = points[start % count];
    let style;
    for (i = start + 1; i <= segment.end; i++) {
      const pt2 = points[i % count];
      style = readStyle(segmentOptions.setContext(createContext(chartContext, {
        type: "segment",
        p0: prev,
        p1: pt2,
        p0DataIndex: (i - 1) % count,
        p1DataIndex: i % count,
        datasetIndex
      })));
      if (styleChanged(style, prevStyle)) {
        addStyle(start, i - 1, segment.loop, prevStyle);
      }
      prev = pt2;
      prevStyle = style;
    }
    if (start < i - 1) {
      addStyle(start, i - 1, segment.loop, prevStyle);
    }
  }
  return result;
}
function readStyle(options) {
  return {
    backgroundColor: options.backgroundColor,
    borderCapStyle: options.borderCapStyle,
    borderDash: options.borderDash,
    borderDashOffset: options.borderDashOffset,
    borderJoinStyle: options.borderJoinStyle,
    borderWidth: options.borderWidth,
    borderColor: options.borderColor
  };
}
function styleChanged(style, prevStyle) {
  if (!prevStyle) {
    return false;
  }
  const cache = [];
  const replacer = function(key, value) {
    if (!isPatternOrGradient(value)) {
      return value;
    }
    if (!cache.includes(value)) {
      cache.push(value);
    }
    return cache.indexOf(value);
  };
  return JSON.stringify(style, replacer) !== JSON.stringify(prevStyle, replacer);
}
/*!
 * Chart.js v4.4.0
 * https://www.chartjs.org
 * (c) 2023 Chart.js Contributors
 * Released under the MIT License
 */
class Animator {
  constructor() {
    this._request = null;
    this._charts = /* @__PURE__ */ new Map();
    this._running = false;
    this._lastDate = void 0;
  }
  _notify(chart, anims, date, type) {
    const callbacks = anims.listeners[type];
    const numSteps = anims.duration;
    callbacks.forEach((fn2) => fn2({
      chart,
      initial: anims.initial,
      numSteps,
      currentStep: Math.min(date - anims.start, numSteps)
    }));
  }
  _refresh() {
    if (this._request) {
      return;
    }
    this._running = true;
    this._request = requestAnimFrame.call(window, () => {
      this._update();
      this._request = null;
      if (this._running) {
        this._refresh();
      }
    });
  }
  _update(date = Date.now()) {
    let remaining = 0;
    this._charts.forEach((anims, chart) => {
      if (!anims.running || !anims.items.length) {
        return;
      }
      const items = anims.items;
      let i = items.length - 1;
      let draw2 = false;
      let item;
      for (; i >= 0; --i) {
        item = items[i];
        if (item._active) {
          if (item._total > anims.duration) {
            anims.duration = item._total;
          }
          item.tick(date);
          draw2 = true;
        } else {
          items[i] = items[items.length - 1];
          items.pop();
        }
      }
      if (draw2) {
        chart.draw();
        this._notify(chart, anims, date, "progress");
      }
      if (!items.length) {
        anims.running = false;
        this._notify(chart, anims, date, "complete");
        anims.initial = false;
      }
      remaining += items.length;
    });
    this._lastDate = date;
    if (remaining === 0) {
      this._running = false;
    }
  }
  _getAnims(chart) {
    const charts = this._charts;
    let anims = charts.get(chart);
    if (!anims) {
      anims = {
        running: false,
        initial: true,
        items: [],
        listeners: {
          complete: [],
          progress: []
        }
      };
      charts.set(chart, anims);
    }
    return anims;
  }
  listen(chart, event, cb) {
    this._getAnims(chart).listeners[event].push(cb);
  }
  add(chart, items) {
    if (!items || !items.length) {
      return;
    }
    this._getAnims(chart).items.push(...items);
  }
  has(chart) {
    return this._getAnims(chart).items.length > 0;
  }
  start(chart) {
    const anims = this._charts.get(chart);
    if (!anims) {
      return;
    }
    anims.running = true;
    anims.start = Date.now();
    anims.duration = anims.items.reduce((acc, cur) => Math.max(acc, cur._duration), 0);
    this._refresh();
  }
  running(chart) {
    if (!this._running) {
      return false;
    }
    const anims = this._charts.get(chart);
    if (!anims || !anims.running || !anims.items.length) {
      return false;
    }
    return true;
  }
  stop(chart) {
    const anims = this._charts.get(chart);
    if (!anims || !anims.items.length) {
      return;
    }
    const items = anims.items;
    let i = items.length - 1;
    for (; i >= 0; --i) {
      items[i].cancel();
    }
    anims.items = [];
    this._notify(chart, anims, Date.now(), "complete");
  }
  remove(chart) {
    return this._charts.delete(chart);
  }
}
var animator = /* @__PURE__ */ new Animator();
const transparent = "transparent";
const interpolators = {
  boolean(from2, to2, factor) {
    return factor > 0.5 ? to2 : from2;
  },
  color(from2, to2, factor) {
    const c0 = color(from2 || transparent);
    const c1 = c0.valid && color(to2 || transparent);
    return c1 && c1.valid ? c1.mix(c0, factor).hexString() : to2;
  },
  number(from2, to2, factor) {
    return from2 + (to2 - from2) * factor;
  }
};
class Animation {
  constructor(cfg, target, prop, to2) {
    const currentValue = target[prop];
    to2 = resolve([
      cfg.to,
      to2,
      currentValue,
      cfg.from
    ]);
    const from2 = resolve([
      cfg.from,
      currentValue,
      to2
    ]);
    this._active = true;
    this._fn = cfg.fn || interpolators[cfg.type || typeof from2];
    this._easing = effects[cfg.easing] || effects.linear;
    this._start = Math.floor(Date.now() + (cfg.delay || 0));
    this._duration = this._total = Math.floor(cfg.duration);
    this._loop = !!cfg.loop;
    this._target = target;
    this._prop = prop;
    this._from = from2;
    this._to = to2;
    this._promises = void 0;
  }
  active() {
    return this._active;
  }
  update(cfg, to2, date) {
    if (this._active) {
      this._notify(false);
      const currentValue = this._target[this._prop];
      const elapsed = date - this._start;
      const remain = this._duration - elapsed;
      this._start = date;
      this._duration = Math.floor(Math.max(remain, cfg.duration));
      this._total += elapsed;
      this._loop = !!cfg.loop;
      this._to = resolve([
        cfg.to,
        to2,
        currentValue,
        cfg.from
      ]);
      this._from = resolve([
        cfg.from,
        currentValue,
        to2
      ]);
    }
  }
  cancel() {
    if (this._active) {
      this.tick(Date.now());
      this._active = false;
      this._notify(false);
    }
  }
  tick(date) {
    const elapsed = date - this._start;
    const duration = this._duration;
    const prop = this._prop;
    const from2 = this._from;
    const loop = this._loop;
    const to2 = this._to;
    let factor;
    this._active = from2 !== to2 && (loop || elapsed < duration);
    if (!this._active) {
      this._target[prop] = to2;
      this._notify(true);
      return;
    }
    if (elapsed < 0) {
      this._target[prop] = from2;
      return;
    }
    factor = elapsed / duration % 2;
    factor = loop && factor > 1 ? 2 - factor : factor;
    factor = this._easing(Math.min(1, Math.max(0, factor)));
    this._target[prop] = this._fn(from2, to2, factor);
  }
  wait() {
    const promises = this._promises || (this._promises = []);
    return new Promise((res, rej) => {
      promises.push({
        res,
        rej
      });
    });
  }
  _notify(resolved) {
    const method = resolved ? "res" : "rej";
    const promises = this._promises || [];
    for (let i = 0; i < promises.length; i++) {
      promises[i][method]();
    }
  }
}
class Animations {
  constructor(chart, config) {
    this._chart = chart;
    this._properties = /* @__PURE__ */ new Map();
    this.configure(config);
  }
  configure(config) {
    if (!isObject(config)) {
      return;
    }
    const animationOptions = Object.keys(defaults.animation);
    const animatedProps = this._properties;
    Object.getOwnPropertyNames(config).forEach((key) => {
      const cfg = config[key];
      if (!isObject(cfg)) {
        return;
      }
      const resolved = {};
      for (const option of animationOptions) {
        resolved[option] = cfg[option];
      }
      (isArray(cfg.properties) && cfg.properties || [
        key
      ]).forEach((prop) => {
        if (prop === key || !animatedProps.has(prop)) {
          animatedProps.set(prop, resolved);
        }
      });
    });
  }
  _animateOptions(target, values) {
    const newOptions = values.options;
    const options = resolveTargetOptions(target, newOptions);
    if (!options) {
      return [];
    }
    const animations = this._createAnimations(options, newOptions);
    if (newOptions.$shared) {
      awaitAll(target.options.$animations, newOptions).then(() => {
        target.options = newOptions;
      }, () => {
      });
    }
    return animations;
  }
  _createAnimations(target, values) {
    const animatedProps = this._properties;
    const animations = [];
    const running = target.$animations || (target.$animations = {});
    const props = Object.keys(values);
    const date = Date.now();
    let i;
    for (i = props.length - 1; i >= 0; --i) {
      const prop = props[i];
      if (prop.charAt(0) === "$") {
        continue;
      }
      if (prop === "options") {
        animations.push(...this._animateOptions(target, values));
        continue;
      }
      const value = values[prop];
      let animation = running[prop];
      const cfg = animatedProps.get(prop);
      if (animation) {
        if (cfg && animation.active()) {
          animation.update(cfg, value, date);
          continue;
        } else {
          animation.cancel();
        }
      }
      if (!cfg || !cfg.duration) {
        target[prop] = value;
        continue;
      }
      running[prop] = animation = new Animation(cfg, target, prop, value);
      animations.push(animation);
    }
    return animations;
  }
  update(target, values) {
    if (this._properties.size === 0) {
      Object.assign(target, values);
      return;
    }
    const animations = this._createAnimations(target, values);
    if (animations.length) {
      animator.add(this._chart, animations);
      return true;
    }
  }
}
function awaitAll(animations, properties) {
  const running = [];
  const keys = Object.keys(properties);
  for (let i = 0; i < keys.length; i++) {
    const anim = animations[keys[i]];
    if (anim && anim.active()) {
      running.push(anim.wait());
    }
  }
  return Promise.all(running);
}
function resolveTargetOptions(target, newOptions) {
  if (!newOptions) {
    return;
  }
  let options = target.options;
  if (!options) {
    target.options = newOptions;
    return;
  }
  if (options.$shared) {
    target.options = options = Object.assign({}, options, {
      $shared: false,
      $animations: {}
    });
  }
  return options;
}
function scaleClip(scale, allowedOverflow) {
  const opts = scale && scale.options || {};
  const reverse = opts.reverse;
  const min = opts.min === void 0 ? allowedOverflow : 0;
  const max = opts.max === void 0 ? allowedOverflow : 0;
  return {
    start: reverse ? max : min,
    end: reverse ? min : max
  };
}
function defaultClip(xScale, yScale, allowedOverflow) {
  if (allowedOverflow === false) {
    return false;
  }
  const x2 = scaleClip(xScale, allowedOverflow);
  const y2 = scaleClip(yScale, allowedOverflow);
  return {
    top: y2.end,
    right: x2.end,
    bottom: y2.start,
    left: x2.start
  };
}
function toClip(value) {
  let t, r2, b2, l2;
  if (isObject(value)) {
    t = value.top;
    r2 = value.right;
    b2 = value.bottom;
    l2 = value.left;
  } else {
    t = r2 = b2 = l2 = value;
  }
  return {
    top: t,
    right: r2,
    bottom: b2,
    left: l2,
    disabled: value === false
  };
}
function getSortedDatasetIndices(chart, filterVisible) {
  const keys = [];
  const metasets = chart._getSortedDatasetMetas(filterVisible);
  let i, ilen;
  for (i = 0, ilen = metasets.length; i < ilen; ++i) {
    keys.push(metasets[i].index);
  }
  return keys;
}
function applyStack(stack, value, dsIndex, options = {}) {
  const keys = stack.keys;
  const singleMode = options.mode === "single";
  let i, ilen, datasetIndex, otherValue;
  if (value === null) {
    return;
  }
  for (i = 0, ilen = keys.length; i < ilen; ++i) {
    datasetIndex = +keys[i];
    if (datasetIndex === dsIndex) {
      if (options.all) {
        continue;
      }
      break;
    }
    otherValue = stack.values[datasetIndex];
    if (isNumberFinite(otherValue) && (singleMode || value === 0 || sign$2(value) === sign$2(otherValue))) {
      value += otherValue;
    }
  }
  return value;
}
function convertObjectDataToArray(data) {
  const keys = Object.keys(data);
  const adata = new Array(keys.length);
  let i, ilen, key;
  for (i = 0, ilen = keys.length; i < ilen; ++i) {
    key = keys[i];
    adata[i] = {
      x: key,
      y: data[key]
    };
  }
  return adata;
}
function isStacked(scale, meta) {
  const stacked = scale && scale.options.stacked;
  return stacked || stacked === void 0 && meta.stack !== void 0;
}
function getStackKey(indexScale, valueScale, meta) {
  return `${indexScale.id}.${valueScale.id}.${meta.stack || meta.type}`;
}
function getUserBounds(scale) {
  const { min, max, minDefined, maxDefined } = scale.getUserBounds();
  return {
    min: minDefined ? min : Number.NEGATIVE_INFINITY,
    max: maxDefined ? max : Number.POSITIVE_INFINITY
  };
}
function getOrCreateStack(stacks, stackKey, indexValue) {
  const subStack = stacks[stackKey] || (stacks[stackKey] = {});
  return subStack[indexValue] || (subStack[indexValue] = {});
}
function getLastIndexInStack(stack, vScale, positive, type) {
  for (const meta of vScale.getMatchingVisibleMetas(type).reverse()) {
    const value = stack[meta.index];
    if (positive && value > 0 || !positive && value < 0) {
      return meta.index;
    }
  }
  return null;
}
function updateStacks(controller, parsed) {
  const { chart, _cachedMeta: meta } = controller;
  const stacks = chart._stacks || (chart._stacks = {});
  const { iScale, vScale, index: datasetIndex } = meta;
  const iAxis = iScale.axis;
  const vAxis = vScale.axis;
  const key = getStackKey(iScale, vScale, meta);
  const ilen = parsed.length;
  let stack;
  for (let i = 0; i < ilen; ++i) {
    const item = parsed[i];
    const { [iAxis]: index, [vAxis]: value } = item;
    const itemStacks = item._stacks || (item._stacks = {});
    stack = itemStacks[vAxis] = getOrCreateStack(stacks, key, index);
    stack[datasetIndex] = value;
    stack._top = getLastIndexInStack(stack, vScale, true, meta.type);
    stack._bottom = getLastIndexInStack(stack, vScale, false, meta.type);
    const visualValues = stack._visualValues || (stack._visualValues = {});
    visualValues[datasetIndex] = value;
  }
}
function getFirstScaleId(chart, axis) {
  const scales = chart.scales;
  return Object.keys(scales).filter((key) => scales[key].axis === axis).shift();
}
function createDatasetContext(parent, index) {
  return createContext(parent, {
    active: false,
    dataset: void 0,
    datasetIndex: index,
    index,
    mode: "default",
    type: "dataset"
  });
}
function createDataContext(parent, index, element2) {
  return createContext(parent, {
    active: false,
    dataIndex: index,
    parsed: void 0,
    raw: void 0,
    element: element2,
    index,
    mode: "default",
    type: "data"
  });
}
function clearStacks(meta, items) {
  const datasetIndex = meta.controller.index;
  const axis = meta.vScale && meta.vScale.axis;
  if (!axis) {
    return;
  }
  items = items || meta._parsed;
  for (const parsed of items) {
    const stacks = parsed._stacks;
    if (!stacks || stacks[axis] === void 0 || stacks[axis][datasetIndex] === void 0) {
      return;
    }
    delete stacks[axis][datasetIndex];
    if (stacks[axis]._visualValues !== void 0 && stacks[axis]._visualValues[datasetIndex] !== void 0) {
      delete stacks[axis]._visualValues[datasetIndex];
    }
  }
}
const isDirectUpdateMode = (mode) => mode === "reset" || mode === "none";
const cloneIfNotShared = (cached, shared) => shared ? cached : Object.assign({}, cached);
const createStack = (canStack, meta, chart) => canStack && !meta.hidden && meta._stacked && {
  keys: getSortedDatasetIndices(chart, true),
  values: null
};
class DatasetController {
  constructor(chart, datasetIndex) {
    this.chart = chart;
    this._ctx = chart.ctx;
    this.index = datasetIndex;
    this._cachedDataOpts = {};
    this._cachedMeta = this.getMeta();
    this._type = this._cachedMeta.type;
    this.options = void 0;
    this._parsing = false;
    this._data = void 0;
    this._objectData = void 0;
    this._sharedOptions = void 0;
    this._drawStart = void 0;
    this._drawCount = void 0;
    this.enableOptionSharing = false;
    this.supportsDecimation = false;
    this.$context = void 0;
    this._syncList = [];
    this.datasetElementType = new.target.datasetElementType;
    this.dataElementType = new.target.dataElementType;
    this.initialize();
  }
  initialize() {
    const meta = this._cachedMeta;
    this.configure();
    this.linkScales();
    meta._stacked = isStacked(meta.vScale, meta);
    this.addElements();
    if (this.options.fill && !this.chart.isPluginEnabled("filler")) {
      console.warn("Tried to use the 'fill' option without the 'Filler' plugin enabled. Please import and register the 'Filler' plugin and make sure it is not disabled in the options");
    }
  }
  updateIndex(datasetIndex) {
    if (this.index !== datasetIndex) {
      clearStacks(this._cachedMeta);
    }
    this.index = datasetIndex;
  }
  linkScales() {
    const chart = this.chart;
    const meta = this._cachedMeta;
    const dataset = this.getDataset();
    const chooseId = (axis, x2, y2, r2) => axis === "x" ? x2 : axis === "r" ? r2 : y2;
    const xid = meta.xAxisID = valueOrDefault(dataset.xAxisID, getFirstScaleId(chart, "x"));
    const yid = meta.yAxisID = valueOrDefault(dataset.yAxisID, getFirstScaleId(chart, "y"));
    const rid = meta.rAxisID = valueOrDefault(dataset.rAxisID, getFirstScaleId(chart, "r"));
    const indexAxis = meta.indexAxis;
    const iid = meta.iAxisID = chooseId(indexAxis, xid, yid, rid);
    const vid = meta.vAxisID = chooseId(indexAxis, yid, xid, rid);
    meta.xScale = this.getScaleForId(xid);
    meta.yScale = this.getScaleForId(yid);
    meta.rScale = this.getScaleForId(rid);
    meta.iScale = this.getScaleForId(iid);
    meta.vScale = this.getScaleForId(vid);
  }
  getDataset() {
    return this.chart.data.datasets[this.index];
  }
  getMeta() {
    return this.chart.getDatasetMeta(this.index);
  }
  getScaleForId(scaleID) {
    return this.chart.scales[scaleID];
  }
  _getOtherScale(scale) {
    const meta = this._cachedMeta;
    return scale === meta.iScale ? meta.vScale : meta.iScale;
  }
  reset() {
    this._update("reset");
  }
  _destroy() {
    const meta = this._cachedMeta;
    if (this._data) {
      unlistenArrayEvents(this._data, this);
    }
    if (meta._stacked) {
      clearStacks(meta);
    }
  }
  _dataCheck() {
    const dataset = this.getDataset();
    const data = dataset.data || (dataset.data = []);
    const _data = this._data;
    if (isObject(data)) {
      this._data = convertObjectDataToArray(data);
    } else if (_data !== data) {
      if (_data) {
        unlistenArrayEvents(_data, this);
        const meta = this._cachedMeta;
        clearStacks(meta);
        meta._parsed = [];
      }
      if (data && Object.isExtensible(data)) {
        listenArrayEvents(data, this);
      }
      this._syncList = [];
      this._data = data;
    }
  }
  addElements() {
    const meta = this._cachedMeta;
    this._dataCheck();
    if (this.datasetElementType) {
      meta.dataset = new this.datasetElementType();
    }
  }
  buildOrUpdateElements(resetNewElements) {
    const meta = this._cachedMeta;
    const dataset = this.getDataset();
    let stackChanged = false;
    this._dataCheck();
    const oldStacked = meta._stacked;
    meta._stacked = isStacked(meta.vScale, meta);
    if (meta.stack !== dataset.stack) {
      stackChanged = true;
      clearStacks(meta);
      meta.stack = dataset.stack;
    }
    this._resyncElements(resetNewElements);
    if (stackChanged || oldStacked !== meta._stacked) {
      updateStacks(this, meta._parsed);
    }
  }
  configure() {
    const config = this.chart.config;
    const scopeKeys = config.datasetScopeKeys(this._type);
    const scopes = config.getOptionScopes(this.getDataset(), scopeKeys, true);
    this.options = config.createResolver(scopes, this.getContext());
    this._parsing = this.options.parsing;
    this._cachedDataOpts = {};
  }
  parse(start, count) {
    const { _cachedMeta: meta, _data: data } = this;
    const { iScale, _stacked } = meta;
    const iAxis = iScale.axis;
    let sorted = start === 0 && count === data.length ? true : meta._sorted;
    let prev = start > 0 && meta._parsed[start - 1];
    let i, cur, parsed;
    if (this._parsing === false) {
      meta._parsed = data;
      meta._sorted = true;
      parsed = data;
    } else {
      if (isArray(data[start])) {
        parsed = this.parseArrayData(meta, data, start, count);
      } else if (isObject(data[start])) {
        parsed = this.parseObjectData(meta, data, start, count);
      } else {
        parsed = this.parsePrimitiveData(meta, data, start, count);
      }
      const isNotInOrderComparedToPrev = () => cur[iAxis] === null || prev && cur[iAxis] < prev[iAxis];
      for (i = 0; i < count; ++i) {
        meta._parsed[i + start] = cur = parsed[i];
        if (sorted) {
          if (isNotInOrderComparedToPrev()) {
            sorted = false;
          }
          prev = cur;
        }
      }
      meta._sorted = sorted;
    }
    if (_stacked) {
      updateStacks(this, parsed);
    }
  }
  parsePrimitiveData(meta, data, start, count) {
    const { iScale, vScale } = meta;
    const iAxis = iScale.axis;
    const vAxis = vScale.axis;
    const labels = iScale.getLabels();
    const singleScale = iScale === vScale;
    const parsed = new Array(count);
    let i, ilen, index;
    for (i = 0, ilen = count; i < ilen; ++i) {
      index = i + start;
      parsed[i] = {
        [iAxis]: singleScale || iScale.parse(labels[index], index),
        [vAxis]: vScale.parse(data[index], index)
      };
    }
    return parsed;
  }
  parseArrayData(meta, data, start, count) {
    const { xScale, yScale } = meta;
    const parsed = new Array(count);
    let i, ilen, index, item;
    for (i = 0, ilen = count; i < ilen; ++i) {
      index = i + start;
      item = data[index];
      parsed[i] = {
        x: xScale.parse(item[0], index),
        y: yScale.parse(item[1], index)
      };
    }
    return parsed;
  }
  parseObjectData(meta, data, start, count) {
    const { xScale, yScale } = meta;
    const { xAxisKey = "x", yAxisKey = "y" } = this._parsing;
    const parsed = new Array(count);
    let i, ilen, index, item;
    for (i = 0, ilen = count; i < ilen; ++i) {
      index = i + start;
      item = data[index];
      parsed[i] = {
        x: xScale.parse(resolveObjectKey(item, xAxisKey), index),
        y: yScale.parse(resolveObjectKey(item, yAxisKey), index)
      };
    }
    return parsed;
  }
  getParsed(index) {
    return this._cachedMeta._parsed[index];
  }
  getDataElement(index) {
    return this._cachedMeta.data[index];
  }
  applyStack(scale, parsed, mode) {
    const chart = this.chart;
    const meta = this._cachedMeta;
    const value = parsed[scale.axis];
    const stack = {
      keys: getSortedDatasetIndices(chart, true),
      values: parsed._stacks[scale.axis]._visualValues
    };
    return applyStack(stack, value, meta.index, {
      mode
    });
  }
  updateRangeFromParsed(range, scale, parsed, stack) {
    const parsedValue = parsed[scale.axis];
    let value = parsedValue === null ? NaN : parsedValue;
    const values = stack && parsed._stacks[scale.axis];
    if (stack && values) {
      stack.values = values;
      value = applyStack(stack, parsedValue, this._cachedMeta.index);
    }
    range.min = Math.min(range.min, value);
    range.max = Math.max(range.max, value);
  }
  getMinMax(scale, canStack) {
    const meta = this._cachedMeta;
    const _parsed = meta._parsed;
    const sorted = meta._sorted && scale === meta.iScale;
    const ilen = _parsed.length;
    const otherScale = this._getOtherScale(scale);
    const stack = createStack(canStack, meta, this.chart);
    const range = {
      min: Number.POSITIVE_INFINITY,
      max: Number.NEGATIVE_INFINITY
    };
    const { min: otherMin, max: otherMax } = getUserBounds(otherScale);
    let i, parsed;
    function _skip() {
      parsed = _parsed[i];
      const otherValue = parsed[otherScale.axis];
      return !isNumberFinite(parsed[scale.axis]) || otherMin > otherValue || otherMax < otherValue;
    }
    for (i = 0; i < ilen; ++i) {
      if (_skip()) {
        continue;
      }
      this.updateRangeFromParsed(range, scale, parsed, stack);
      if (sorted) {
        break;
      }
    }
    if (sorted) {
      for (i = ilen - 1; i >= 0; --i) {
        if (_skip()) {
          continue;
        }
        this.updateRangeFromParsed(range, scale, parsed, stack);
        break;
      }
    }
    return range;
  }
  getAllParsedValues(scale) {
    const parsed = this._cachedMeta._parsed;
    const values = [];
    let i, ilen, value;
    for (i = 0, ilen = parsed.length; i < ilen; ++i) {
      value = parsed[i][scale.axis];
      if (isNumberFinite(value)) {
        values.push(value);
      }
    }
    return values;
  }
  getMaxOverflow() {
    return false;
  }
  getLabelAndValue(index) {
    const meta = this._cachedMeta;
    const iScale = meta.iScale;
    const vScale = meta.vScale;
    const parsed = this.getParsed(index);
    return {
      label: iScale ? "" + iScale.getLabelForValue(parsed[iScale.axis]) : "",
      value: vScale ? "" + vScale.getLabelForValue(parsed[vScale.axis]) : ""
    };
  }
  _update(mode) {
    const meta = this._cachedMeta;
    this.update(mode || "default");
    meta._clip = toClip(valueOrDefault(this.options.clip, defaultClip(meta.xScale, meta.yScale, this.getMaxOverflow())));
  }
  update(mode) {
  }
  draw() {
    const ctx = this._ctx;
    const chart = this.chart;
    const meta = this._cachedMeta;
    const elements = meta.data || [];
    const area = chart.chartArea;
    const active = [];
    const start = this._drawStart || 0;
    const count = this._drawCount || elements.length - start;
    const drawActiveElementsOnTop = this.options.drawActiveElementsOnTop;
    let i;
    if (meta.dataset) {
      meta.dataset.draw(ctx, area, start, count);
    }
    for (i = start; i < start + count; ++i) {
      const element2 = elements[i];
      if (element2.hidden) {
        continue;
      }
      if (element2.active && drawActiveElementsOnTop) {
        active.push(element2);
      } else {
        element2.draw(ctx, area);
      }
    }
    for (i = 0; i < active.length; ++i) {
      active[i].draw(ctx, area);
    }
  }
  getStyle(index, active) {
    const mode = active ? "active" : "default";
    return index === void 0 && this._cachedMeta.dataset ? this.resolveDatasetElementOptions(mode) : this.resolveDataElementOptions(index || 0, mode);
  }
  getContext(index, active, mode) {
    const dataset = this.getDataset();
    let context;
    if (index >= 0 && index < this._cachedMeta.data.length) {
      const element2 = this._cachedMeta.data[index];
      context = element2.$context || (element2.$context = createDataContext(this.getContext(), index, element2));
      context.parsed = this.getParsed(index);
      context.raw = dataset.data[index];
      context.index = context.dataIndex = index;
    } else {
      context = this.$context || (this.$context = createDatasetContext(this.chart.getContext(), this.index));
      context.dataset = dataset;
      context.index = context.datasetIndex = this.index;
    }
    context.active = !!active;
    context.mode = mode;
    return context;
  }
  resolveDatasetElementOptions(mode) {
    return this._resolveElementOptions(this.datasetElementType.id, mode);
  }
  resolveDataElementOptions(index, mode) {
    return this._resolveElementOptions(this.dataElementType.id, mode, index);
  }
  _resolveElementOptions(elementType, mode = "default", index) {
    const active = mode === "active";
    const cache = this._cachedDataOpts;
    const cacheKey = elementType + "-" + mode;
    const cached = cache[cacheKey];
    const sharing = this.enableOptionSharing && defined(index);
    if (cached) {
      return cloneIfNotShared(cached, sharing);
    }
    const config = this.chart.config;
    const scopeKeys = config.datasetElementScopeKeys(this._type, elementType);
    const prefixes = active ? [
      `${elementType}Hover`,
      "hover",
      elementType,
      ""
    ] : [
      elementType,
      ""
    ];
    const scopes = config.getOptionScopes(this.getDataset(), scopeKeys);
    const names2 = Object.keys(defaults.elements[elementType]);
    const context = () => this.getContext(index, active, mode);
    const values = config.resolveNamedOptions(scopes, names2, context, prefixes);
    if (values.$shared) {
      values.$shared = sharing;
      cache[cacheKey] = Object.freeze(cloneIfNotShared(values, sharing));
    }
    return values;
  }
  _resolveAnimations(index, transition, active) {
    const chart = this.chart;
    const cache = this._cachedDataOpts;
    const cacheKey = `animation-${transition}`;
    const cached = cache[cacheKey];
    if (cached) {
      return cached;
    }
    let options;
    if (chart.options.animation !== false) {
      const config = this.chart.config;
      const scopeKeys = config.datasetAnimationScopeKeys(this._type, transition);
      const scopes = config.getOptionScopes(this.getDataset(), scopeKeys);
      options = config.createResolver(scopes, this.getContext(index, active, transition));
    }
    const animations = new Animations(chart, options && options.animations);
    if (options && options._cacheable) {
      cache[cacheKey] = Object.freeze(animations);
    }
    return animations;
  }
  getSharedOptions(options) {
    if (!options.$shared) {
      return;
    }
    return this._sharedOptions || (this._sharedOptions = Object.assign({}, options));
  }
  includeOptions(mode, sharedOptions) {
    return !sharedOptions || isDirectUpdateMode(mode) || this.chart._animationsDisabled;
  }
  _getSharedOptions(start, mode) {
    const firstOpts = this.resolveDataElementOptions(start, mode);
    const previouslySharedOptions = this._sharedOptions;
    const sharedOptions = this.getSharedOptions(firstOpts);
    const includeOptions = this.includeOptions(mode, sharedOptions) || sharedOptions !== previouslySharedOptions;
    this.updateSharedOptions(sharedOptions, mode, firstOpts);
    return {
      sharedOptions,
      includeOptions
    };
  }
  updateElement(element2, index, properties, mode) {
    if (isDirectUpdateMode(mode)) {
      Object.assign(element2, properties);
    } else {
      this._resolveAnimations(index, mode).update(element2, properties);
    }
  }
  updateSharedOptions(sharedOptions, mode, newOptions) {
    if (sharedOptions && !isDirectUpdateMode(mode)) {
      this._resolveAnimations(void 0, mode).update(sharedOptions, newOptions);
    }
  }
  _setStyle(element2, index, mode, active) {
    element2.active = active;
    const options = this.getStyle(index, active);
    this._resolveAnimations(index, mode, active).update(element2, {
      options: !active && this.getSharedOptions(options) || options
    });
  }
  removeHoverStyle(element2, datasetIndex, index) {
    this._setStyle(element2, index, "active", false);
  }
  setHoverStyle(element2, datasetIndex, index) {
    this._setStyle(element2, index, "active", true);
  }
  _removeDatasetHoverStyle() {
    const element2 = this._cachedMeta.dataset;
    if (element2) {
      this._setStyle(element2, void 0, "active", false);
    }
  }
  _setDatasetHoverStyle() {
    const element2 = this._cachedMeta.dataset;
    if (element2) {
      this._setStyle(element2, void 0, "active", true);
    }
  }
  _resyncElements(resetNewElements) {
    const data = this._data;
    const elements = this._cachedMeta.data;
    for (const [method, arg1, arg2] of this._syncList) {
      this[method](arg1, arg2);
    }
    this._syncList = [];
    const numMeta = elements.length;
    const numData = data.length;
    const count = Math.min(numData, numMeta);
    if (count) {
      this.parse(0, count);
    }
    if (numData > numMeta) {
      this._insertElements(numMeta, numData - numMeta, resetNewElements);
    } else if (numData < numMeta) {
      this._removeElements(numData, numMeta - numData);
    }
  }
  _insertElements(start, count, resetNewElements = true) {
    const meta = this._cachedMeta;
    const data = meta.data;
    const end = start + count;
    let i;
    const move = (arr) => {
      arr.length += count;
      for (i = arr.length - 1; i >= end; i--) {
        arr[i] = arr[i - count];
      }
    };
    move(data);
    for (i = start; i < end; ++i) {
      data[i] = new this.dataElementType();
    }
    if (this._parsing) {
      move(meta._parsed);
    }
    this.parse(start, count);
    if (resetNewElements) {
      this.updateElements(data, start, count, "reset");
    }
  }
  updateElements(element2, start, count, mode) {
  }
  _removeElements(start, count) {
    const meta = this._cachedMeta;
    if (this._parsing) {
      const removed = meta._parsed.splice(start, count);
      if (meta._stacked) {
        clearStacks(meta, removed);
      }
    }
    meta.data.splice(start, count);
  }
  _sync(args) {
    if (this._parsing) {
      this._syncList.push(args);
    } else {
      const [method, arg1, arg2] = args;
      this[method](arg1, arg2);
    }
    this.chart._dataChanges.push([
      this.index,
      ...args
    ]);
  }
  _onDataPush() {
    const count = arguments.length;
    this._sync([
      "_insertElements",
      this.getDataset().data.length - count,
      count
    ]);
  }
  _onDataPop() {
    this._sync([
      "_removeElements",
      this._cachedMeta.data.length - 1,
      1
    ]);
  }
  _onDataShift() {
    this._sync([
      "_removeElements",
      0,
      1
    ]);
  }
  _onDataSplice(start, count) {
    if (count) {
      this._sync([
        "_removeElements",
        start,
        count
      ]);
    }
    const newCount = arguments.length - 2;
    if (newCount) {
      this._sync([
        "_insertElements",
        start,
        newCount
      ]);
    }
  }
  _onDataUnshift() {
    this._sync([
      "_insertElements",
      0,
      arguments.length
    ]);
  }
}
__publicField(DatasetController, "defaults", {});
__publicField(DatasetController, "datasetElementType", null);
__publicField(DatasetController, "dataElementType", null);
function getAllScaleValues(scale, type) {
  if (!scale._cache.$bar) {
    const visibleMetas = scale.getMatchingVisibleMetas(type);
    let values = [];
    for (let i = 0, ilen = visibleMetas.length; i < ilen; i++) {
      values = values.concat(visibleMetas[i].controller.getAllParsedValues(scale));
    }
    scale._cache.$bar = _arrayUnique(values.sort((a2, b2) => a2 - b2));
  }
  return scale._cache.$bar;
}
function computeMinSampleSize(meta) {
  const scale = meta.iScale;
  const values = getAllScaleValues(scale, meta.type);
  let min = scale._length;
  let i, ilen, curr, prev;
  const updateMinAndPrev = () => {
    if (curr === 32767 || curr === -32768) {
      return;
    }
    if (defined(prev)) {
      min = Math.min(min, Math.abs(curr - prev) || min);
    }
    prev = curr;
  };
  for (i = 0, ilen = values.length; i < ilen; ++i) {
    curr = scale.getPixelForValue(values[i]);
    updateMinAndPrev();
  }
  prev = void 0;
  for (i = 0, ilen = scale.ticks.length; i < ilen; ++i) {
    curr = scale.getPixelForTick(i);
    updateMinAndPrev();
  }
  return min;
}
function computeFitCategoryTraits(index, ruler, options, stackCount) {
  const thickness = options.barThickness;
  let size2, ratio;
  if (isNullOrUndef(thickness)) {
    size2 = ruler.min * options.categoryPercentage;
    ratio = options.barPercentage;
  } else {
    size2 = thickness * stackCount;
    ratio = 1;
  }
  return {
    chunk: size2 / stackCount,
    ratio,
    start: ruler.pixels[index] - size2 / 2
  };
}
function computeFlexCategoryTraits(index, ruler, options, stackCount) {
  const pixels = ruler.pixels;
  const curr = pixels[index];
  let prev = index > 0 ? pixels[index - 1] : null;
  let next = index < pixels.length - 1 ? pixels[index + 1] : null;
  const percent = options.categoryPercentage;
  if (prev === null) {
    prev = curr - (next === null ? ruler.end - ruler.start : next - curr);
  }
  if (next === null) {
    next = curr + curr - prev;
  }
  const start = curr - (curr - Math.min(prev, next)) / 2 * percent;
  const size2 = Math.abs(next - prev) / 2 * percent;
  return {
    chunk: size2 / stackCount,
    ratio: options.barPercentage,
    start
  };
}
function parseFloatBar(entry, item, vScale, i) {
  const startValue = vScale.parse(entry[0], i);
  const endValue = vScale.parse(entry[1], i);
  const min = Math.min(startValue, endValue);
  const max = Math.max(startValue, endValue);
  let barStart = min;
  let barEnd = max;
  if (Math.abs(min) > Math.abs(max)) {
    barStart = max;
    barEnd = min;
  }
  item[vScale.axis] = barEnd;
  item._custom = {
    barStart,
    barEnd,
    start: startValue,
    end: endValue,
    min,
    max
  };
}
function parseValue(entry, item, vScale, i) {
  if (isArray(entry)) {
    parseFloatBar(entry, item, vScale, i);
  } else {
    item[vScale.axis] = vScale.parse(entry, i);
  }
  return item;
}
function parseArrayOrPrimitive(meta, data, start, count) {
  const iScale = meta.iScale;
  const vScale = meta.vScale;
  const labels = iScale.getLabels();
  const singleScale = iScale === vScale;
  const parsed = [];
  let i, ilen, item, entry;
  for (i = start, ilen = start + count; i < ilen; ++i) {
    entry = data[i];
    item = {};
    item[iScale.axis] = singleScale || iScale.parse(labels[i], i);
    parsed.push(parseValue(entry, item, vScale, i));
  }
  return parsed;
}
function isFloatBar(custom) {
  return custom && custom.barStart !== void 0 && custom.barEnd !== void 0;
}
function barSign(size2, vScale, actualBase) {
  if (size2 !== 0) {
    return sign$2(size2);
  }
  return (vScale.isHorizontal() ? 1 : -1) * (vScale.min >= actualBase ? 1 : -1);
}
function borderProps(properties) {
  let reverse, start, end, top, bottom;
  if (properties.horizontal) {
    reverse = properties.base > properties.x;
    start = "left";
    end = "right";
  } else {
    reverse = properties.base < properties.y;
    start = "bottom";
    end = "top";
  }
  if (reverse) {
    top = "end";
    bottom = "start";
  } else {
    top = "start";
    bottom = "end";
  }
  return {
    start,
    end,
    reverse,
    top,
    bottom
  };
}
function setBorderSkipped(properties, options, stack, index) {
  let edge = options.borderSkipped;
  const res = {};
  if (!edge) {
    properties.borderSkipped = res;
    return;
  }
  if (edge === true) {
    properties.borderSkipped = {
      top: true,
      right: true,
      bottom: true,
      left: true
    };
    return;
  }
  const { start, end, reverse, top, bottom } = borderProps(properties);
  if (edge === "middle" && stack) {
    properties.enableBorderRadius = true;
    if ((stack._top || 0) === index) {
      edge = top;
    } else if ((stack._bottom || 0) === index) {
      edge = bottom;
    } else {
      res[parseEdge(bottom, start, end, reverse)] = true;
      edge = top;
    }
  }
  res[parseEdge(edge, start, end, reverse)] = true;
  properties.borderSkipped = res;
}
function parseEdge(edge, a2, b2, reverse) {
  if (reverse) {
    edge = swap(edge, a2, b2);
    edge = startEnd(edge, b2, a2);
  } else {
    edge = startEnd(edge, a2, b2);
  }
  return edge;
}
function swap(orig, v1, v2) {
  return orig === v1 ? v2 : orig === v2 ? v1 : orig;
}
function startEnd(v2, start, end) {
  return v2 === "start" ? start : v2 === "end" ? end : v2;
}
function setInflateAmount(properties, { inflateAmount }, ratio) {
  properties.inflateAmount = inflateAmount === "auto" ? ratio === 1 ? 0.33 : 0 : inflateAmount;
}
class BarController extends DatasetController {
  parsePrimitiveData(meta, data, start, count) {
    return parseArrayOrPrimitive(meta, data, start, count);
  }
  parseArrayData(meta, data, start, count) {
    return parseArrayOrPrimitive(meta, data, start, count);
  }
  parseObjectData(meta, data, start, count) {
    const { iScale, vScale } = meta;
    const { xAxisKey = "x", yAxisKey = "y" } = this._parsing;
    const iAxisKey = iScale.axis === "x" ? xAxisKey : yAxisKey;
    const vAxisKey = vScale.axis === "x" ? xAxisKey : yAxisKey;
    const parsed = [];
    let i, ilen, item, obj;
    for (i = start, ilen = start + count; i < ilen; ++i) {
      obj = data[i];
      item = {};
      item[iScale.axis] = iScale.parse(resolveObjectKey(obj, iAxisKey), i);
      parsed.push(parseValue(resolveObjectKey(obj, vAxisKey), item, vScale, i));
    }
    return parsed;
  }
  updateRangeFromParsed(range, scale, parsed, stack) {
    super.updateRangeFromParsed(range, scale, parsed, stack);
    const custom = parsed._custom;
    if (custom && scale === this._cachedMeta.vScale) {
      range.min = Math.min(range.min, custom.min);
      range.max = Math.max(range.max, custom.max);
    }
  }
  getMaxOverflow() {
    return 0;
  }
  getLabelAndValue(index) {
    const meta = this._cachedMeta;
    const { iScale, vScale } = meta;
    const parsed = this.getParsed(index);
    const custom = parsed._custom;
    const value = isFloatBar(custom) ? "[" + custom.start + ", " + custom.end + "]" : "" + vScale.getLabelForValue(parsed[vScale.axis]);
    return {
      label: "" + iScale.getLabelForValue(parsed[iScale.axis]),
      value
    };
  }
  initialize() {
    this.enableOptionSharing = true;
    super.initialize();
    const meta = this._cachedMeta;
    meta.stack = this.getDataset().stack;
  }
  update(mode) {
    const meta = this._cachedMeta;
    this.updateElements(meta.data, 0, meta.data.length, mode);
  }
  updateElements(bars, start, count, mode) {
    const reset = mode === "reset";
    const { index, _cachedMeta: { vScale } } = this;
    const base = vScale.getBasePixel();
    const horizontal = vScale.isHorizontal();
    const ruler = this._getRuler();
    const { sharedOptions, includeOptions } = this._getSharedOptions(start, mode);
    for (let i = start; i < start + count; i++) {
      const parsed = this.getParsed(i);
      const vpixels = reset || isNullOrUndef(parsed[vScale.axis]) ? {
        base,
        head: base
      } : this._calculateBarValuePixels(i);
      const ipixels = this._calculateBarIndexPixels(i, ruler);
      const stack = (parsed._stacks || {})[vScale.axis];
      const properties = {
        horizontal,
        base: vpixels.base,
        enableBorderRadius: !stack || isFloatBar(parsed._custom) || index === stack._top || index === stack._bottom,
        x: horizontal ? vpixels.head : ipixels.center,
        y: horizontal ? ipixels.center : vpixels.head,
        height: horizontal ? ipixels.size : Math.abs(vpixels.size),
        width: horizontal ? Math.abs(vpixels.size) : ipixels.size
      };
      if (includeOptions) {
        properties.options = sharedOptions || this.resolveDataElementOptions(i, bars[i].active ? "active" : mode);
      }
      const options = properties.options || bars[i].options;
      setBorderSkipped(properties, options, stack, index);
      setInflateAmount(properties, options, ruler.ratio);
      this.updateElement(bars[i], i, properties, mode);
    }
  }
  _getStacks(last, dataIndex) {
    const { iScale } = this._cachedMeta;
    const metasets = iScale.getMatchingVisibleMetas(this._type).filter((meta) => meta.controller.options.grouped);
    const stacked = iScale.options.stacked;
    const stacks = [];
    const skipNull = (meta) => {
      const parsed = meta.controller.getParsed(dataIndex);
      const val = parsed && parsed[meta.vScale.axis];
      if (isNullOrUndef(val) || isNaN(val)) {
        return true;
      }
    };
    for (const meta of metasets) {
      if (dataIndex !== void 0 && skipNull(meta)) {
        continue;
      }
      if (stacked === false || stacks.indexOf(meta.stack) === -1 || stacked === void 0 && meta.stack === void 0) {
        stacks.push(meta.stack);
      }
      if (meta.index === last) {
        break;
      }
    }
    if (!stacks.length) {
      stacks.push(void 0);
    }
    return stacks;
  }
  _getStackCount(index) {
    return this._getStacks(void 0, index).length;
  }
  _getStackIndex(datasetIndex, name, dataIndex) {
    const stacks = this._getStacks(datasetIndex, dataIndex);
    const index = name !== void 0 ? stacks.indexOf(name) : -1;
    return index === -1 ? stacks.length - 1 : index;
  }
  _getRuler() {
    const opts = this.options;
    const meta = this._cachedMeta;
    const iScale = meta.iScale;
    const pixels = [];
    let i, ilen;
    for (i = 0, ilen = meta.data.length; i < ilen; ++i) {
      pixels.push(iScale.getPixelForValue(this.getParsed(i)[iScale.axis], i));
    }
    const barThickness = opts.barThickness;
    const min = barThickness || computeMinSampleSize(meta);
    return {
      min,
      pixels,
      start: iScale._startPixel,
      end: iScale._endPixel,
      stackCount: this._getStackCount(),
      scale: iScale,
      grouped: opts.grouped,
      ratio: barThickness ? 1 : opts.categoryPercentage * opts.barPercentage
    };
  }
  _calculateBarValuePixels(index) {
    const { _cachedMeta: { vScale, _stacked, index: datasetIndex }, options: { base: baseValue, minBarLength } } = this;
    const actualBase = baseValue || 0;
    const parsed = this.getParsed(index);
    const custom = parsed._custom;
    const floating = isFloatBar(custom);
    let value = parsed[vScale.axis];
    let start = 0;
    let length = _stacked ? this.applyStack(vScale, parsed, _stacked) : value;
    let head, size2;
    if (length !== value) {
      start = length - value;
      length = value;
    }
    if (floating) {
      value = custom.barStart;
      length = custom.barEnd - custom.barStart;
      if (value !== 0 && sign$2(value) !== sign$2(custom.barEnd)) {
        start = 0;
      }
      start += value;
    }
    const startValue = !isNullOrUndef(baseValue) && !floating ? baseValue : start;
    let base = vScale.getPixelForValue(startValue);
    if (this.chart.getDataVisibility(index)) {
      head = vScale.getPixelForValue(start + length);
    } else {
      head = base;
    }
    size2 = head - base;
    if (Math.abs(size2) < minBarLength) {
      size2 = barSign(size2, vScale, actualBase) * minBarLength;
      if (value === actualBase) {
        base -= size2 / 2;
      }
      const startPixel = vScale.getPixelForDecimal(0);
      const endPixel = vScale.getPixelForDecimal(1);
      const min = Math.min(startPixel, endPixel);
      const max = Math.max(startPixel, endPixel);
      base = Math.max(Math.min(base, max), min);
      head = base + size2;
      if (_stacked && !floating) {
        parsed._stacks[vScale.axis]._visualValues[datasetIndex] = vScale.getValueForPixel(head) - vScale.getValueForPixel(base);
      }
    }
    if (base === vScale.getPixelForValue(actualBase)) {
      const halfGrid = sign$2(size2) * vScale.getLineWidthForValue(actualBase) / 2;
      base += halfGrid;
      size2 -= halfGrid;
    }
    return {
      size: size2,
      base,
      head,
      center: head + size2 / 2
    };
  }
  _calculateBarIndexPixels(index, ruler) {
    const scale = ruler.scale;
    const options = this.options;
    const skipNull = options.skipNull;
    const maxBarThickness = valueOrDefault(options.maxBarThickness, Infinity);
    let center, size2;
    if (ruler.grouped) {
      const stackCount = skipNull ? this._getStackCount(index) : ruler.stackCount;
      const range = options.barThickness === "flex" ? computeFlexCategoryTraits(index, ruler, options, stackCount) : computeFitCategoryTraits(index, ruler, options, stackCount);
      const stackIndex = this._getStackIndex(this.index, this._cachedMeta.stack, skipNull ? index : void 0);
      center = range.start + range.chunk * stackIndex + range.chunk / 2;
      size2 = Math.min(maxBarThickness, range.chunk * range.ratio);
    } else {
      center = scale.getPixelForValue(this.getParsed(index)[scale.axis], index);
      size2 = Math.min(maxBarThickness, ruler.min * ruler.ratio);
    }
    return {
      base: center - size2 / 2,
      head: center + size2 / 2,
      center,
      size: size2
    };
  }
  draw() {
    const meta = this._cachedMeta;
    const vScale = meta.vScale;
    const rects = meta.data;
    const ilen = rects.length;
    let i = 0;
    for (; i < ilen; ++i) {
      if (this.getParsed(i)[vScale.axis] !== null) {
        rects[i].draw(this._ctx);
      }
    }
  }
}
__publicField(BarController, "id", "bar");
__publicField(BarController, "defaults", {
  datasetElementType: false,
  dataElementType: "bar",
  categoryPercentage: 0.8,
  barPercentage: 0.9,
  grouped: true,
  animations: {
    numbers: {
      type: "number",
      properties: [
        "x",
        "y",
        "base",
        "width",
        "height"
      ]
    }
  }
});
__publicField(BarController, "overrides", {
  scales: {
    _index_: {
      type: "category",
      offset: true,
      grid: {
        offset: true
      }
    },
    _value_: {
      type: "linear",
      beginAtZero: true
    }
  }
});
class BubbleController extends DatasetController {
  initialize() {
    this.enableOptionSharing = true;
    super.initialize();
  }
  parsePrimitiveData(meta, data, start, count) {
    const parsed = super.parsePrimitiveData(meta, data, start, count);
    for (let i = 0; i < parsed.length; i++) {
      parsed[i]._custom = this.resolveDataElementOptions(i + start).radius;
    }
    return parsed;
  }
  parseArrayData(meta, data, start, count) {
    const parsed = super.parseArrayData(meta, data, start, count);
    for (let i = 0; i < parsed.length; i++) {
      const item = data[start + i];
      parsed[i]._custom = valueOrDefault(item[2], this.resolveDataElementOptions(i + start).radius);
    }
    return parsed;
  }
  parseObjectData(meta, data, start, count) {
    const parsed = super.parseObjectData(meta, data, start, count);
    for (let i = 0; i < parsed.length; i++) {
      const item = data[start + i];
      parsed[i]._custom = valueOrDefault(item && item.r && +item.r, this.resolveDataElementOptions(i + start).radius);
    }
    return parsed;
  }
  getMaxOverflow() {
    const data = this._cachedMeta.data;
    let max = 0;
    for (let i = data.length - 1; i >= 0; --i) {
      max = Math.max(max, data[i].size(this.resolveDataElementOptions(i)) / 2);
    }
    return max > 0 && max;
  }
  getLabelAndValue(index) {
    const meta = this._cachedMeta;
    const labels = this.chart.data.labels || [];
    const { xScale, yScale } = meta;
    const parsed = this.getParsed(index);
    const x2 = xScale.getLabelForValue(parsed.x);
    const y2 = yScale.getLabelForValue(parsed.y);
    const r2 = parsed._custom;
    return {
      label: labels[index] || "",
      value: "(" + x2 + ", " + y2 + (r2 ? ", " + r2 : "") + ")"
    };
  }
  update(mode) {
    const points = this._cachedMeta.data;
    this.updateElements(points, 0, points.length, mode);
  }
  updateElements(points, start, count, mode) {
    const reset = mode === "reset";
    const { iScale, vScale } = this._cachedMeta;
    const { sharedOptions, includeOptions } = this._getSharedOptions(start, mode);
    const iAxis = iScale.axis;
    const vAxis = vScale.axis;
    for (let i = start; i < start + count; i++) {
      const point = points[i];
      const parsed = !reset && this.getParsed(i);
      const properties = {};
      const iPixel = properties[iAxis] = reset ? iScale.getPixelForDecimal(0.5) : iScale.getPixelForValue(parsed[iAxis]);
      const vPixel = properties[vAxis] = reset ? vScale.getBasePixel() : vScale.getPixelForValue(parsed[vAxis]);
      properties.skip = isNaN(iPixel) || isNaN(vPixel);
      if (includeOptions) {
        properties.options = sharedOptions || this.resolveDataElementOptions(i, point.active ? "active" : mode);
        if (reset) {
          properties.options.radius = 0;
        }
      }
      this.updateElement(point, i, properties, mode);
    }
  }
  resolveDataElementOptions(index, mode) {
    const parsed = this.getParsed(index);
    let values = super.resolveDataElementOptions(index, mode);
    if (values.$shared) {
      values = Object.assign({}, values, {
        $shared: false
      });
    }
    const radius = values.radius;
    if (mode !== "active") {
      values.radius = 0;
    }
    values.radius += valueOrDefault(parsed && parsed._custom, radius);
    return values;
  }
}
__publicField(BubbleController, "id", "bubble");
__publicField(BubbleController, "defaults", {
  datasetElementType: false,
  dataElementType: "point",
  animations: {
    numbers: {
      type: "number",
      properties: [
        "x",
        "y",
        "borderWidth",
        "radius"
      ]
    }
  }
});
__publicField(BubbleController, "overrides", {
  scales: {
    x: {
      type: "linear"
    },
    y: {
      type: "linear"
    }
  }
});
class LineController extends DatasetController {
  initialize() {
    this.enableOptionSharing = true;
    this.supportsDecimation = true;
    super.initialize();
  }
  update(mode) {
    const meta = this._cachedMeta;
    const { dataset: line, data: points = [], _dataset } = meta;
    const animationsDisabled = this.chart._animationsDisabled;
    let { start, count } = _getStartAndCountOfVisiblePoints(meta, points, animationsDisabled);
    this._drawStart = start;
    this._drawCount = count;
    if (_scaleRangesChanged(meta)) {
      start = 0;
      count = points.length;
    }
    line._chart = this.chart;
    line._datasetIndex = this.index;
    line._decimated = !!_dataset._decimated;
    line.points = points;
    const options = this.resolveDatasetElementOptions(mode);
    if (!this.options.showLine) {
      options.borderWidth = 0;
    }
    options.segment = this.options.segment;
    this.updateElement(line, void 0, {
      animated: !animationsDisabled,
      options
    }, mode);
    this.updateElements(points, start, count, mode);
  }
  updateElements(points, start, count, mode) {
    const reset = mode === "reset";
    const { iScale, vScale, _stacked, _dataset } = this._cachedMeta;
    const { sharedOptions, includeOptions } = this._getSharedOptions(start, mode);
    const iAxis = iScale.axis;
    const vAxis = vScale.axis;
    const { spanGaps, segment } = this.options;
    const maxGapLength = isNumber(spanGaps) ? spanGaps : Number.POSITIVE_INFINITY;
    const directUpdate = this.chart._animationsDisabled || reset || mode === "none";
    const end = start + count;
    const pointsCount = points.length;
    let prevParsed = start > 0 && this.getParsed(start - 1);
    for (let i = 0; i < pointsCount; ++i) {
      const point = points[i];
      const properties = directUpdate ? point : {};
      if (i < start || i >= end) {
        properties.skip = true;
        continue;
      }
      const parsed = this.getParsed(i);
      const nullData = isNullOrUndef(parsed[vAxis]);
      const iPixel = properties[iAxis] = iScale.getPixelForValue(parsed[iAxis], i);
      const vPixel = properties[vAxis] = reset || nullData ? vScale.getBasePixel() : vScale.getPixelForValue(_stacked ? this.applyStack(vScale, parsed, _stacked) : parsed[vAxis], i);
      properties.skip = isNaN(iPixel) || isNaN(vPixel) || nullData;
      properties.stop = i > 0 && Math.abs(parsed[iAxis] - prevParsed[iAxis]) > maxGapLength;
      if (segment) {
        properties.parsed = parsed;
        properties.raw = _dataset.data[i];
      }
      if (includeOptions) {
        properties.options = sharedOptions || this.resolveDataElementOptions(i, point.active ? "active" : mode);
      }
      if (!directUpdate) {
        this.updateElement(point, i, properties, mode);
      }
      prevParsed = parsed;
    }
  }
  getMaxOverflow() {
    const meta = this._cachedMeta;
    const dataset = meta.dataset;
    const border = dataset.options && dataset.options.borderWidth || 0;
    const data = meta.data || [];
    if (!data.length) {
      return border;
    }
    const firstPoint = data[0].size(this.resolveDataElementOptions(0));
    const lastPoint = data[data.length - 1].size(this.resolveDataElementOptions(data.length - 1));
    return Math.max(border, firstPoint, lastPoint) / 2;
  }
  draw() {
    const meta = this._cachedMeta;
    meta.dataset.updateControlPoints(this.chart.chartArea, meta.iScale.axis);
    super.draw();
  }
}
__publicField(LineController, "id", "line");
__publicField(LineController, "defaults", {
  datasetElementType: "line",
  dataElementType: "point",
  showLine: true,
  spanGaps: false
});
__publicField(LineController, "overrides", {
  scales: {
    _index_: {
      type: "category"
    },
    _value_: {
      type: "linear"
    }
  }
});
function abstract() {
  throw new Error("This method is not implemented: Check that a complete date adapter is provided.");
}
class DateAdapterBase {
  constructor(options) {
    __publicField(this, "options");
    this.options = options || {};
  }
  /**
  * Override default date adapter methods.
  * Accepts type parameter to define options type.
  * @example
  * Chart._adapters._date.override<{myAdapterOption: string}>({
  *   init() {
  *     console.log(this.options.myAdapterOption);
  *   }
  * })
  */
  static override(members) {
    Object.assign(DateAdapterBase.prototype, members);
  }
  // eslint-disable-next-line @typescript-eslint/no-empty-function
  init() {
  }
  formats() {
    return abstract();
  }
  parse() {
    return abstract();
  }
  format() {
    return abstract();
  }
  add() {
    return abstract();
  }
  diff() {
    return abstract();
  }
  startOf() {
    return abstract();
  }
  endOf() {
    return abstract();
  }
}
var adapters = {
  _date: DateAdapterBase
};
function binarySearch(metaset, axis, value, intersect) {
  const { controller, data, _sorted } = metaset;
  const iScale = controller._cachedMeta.iScale;
  if (iScale && axis === iScale.axis && axis !== "r" && _sorted && data.length) {
    const lookupMethod = iScale._reversePixels ? _rlookupByKey : _lookupByKey;
    if (!intersect) {
      return lookupMethod(data, axis, value);
    } else if (controller._sharedOptions) {
      const el = data[0];
      const range = typeof el.getRange === "function" && el.getRange(axis);
      if (range) {
        const start = lookupMethod(data, axis, value - range);
        const end = lookupMethod(data, axis, value + range);
        return {
          lo: start.lo,
          hi: end.hi
        };
      }
    }
  }
  return {
    lo: 0,
    hi: data.length - 1
  };
}
function evaluateInteractionItems(chart, axis, position2, handler, intersect) {
  const metasets = chart.getSortedVisibleDatasetMetas();
  const value = position2[axis];
  for (let i = 0, ilen = metasets.length; i < ilen; ++i) {
    const { index, data } = metasets[i];
    const { lo, hi: hi2 } = binarySearch(metasets[i], axis, value, intersect);
    for (let j2 = lo; j2 <= hi2; ++j2) {
      const element2 = data[j2];
      if (!element2.skip) {
        handler(element2, index, j2);
      }
    }
  }
}
function getDistanceMetricForAxis(axis) {
  const useX = axis.indexOf("x") !== -1;
  const useY = axis.indexOf("y") !== -1;
  return function(pt1, pt2) {
    const deltaX = useX ? Math.abs(pt1.x - pt2.x) : 0;
    const deltaY = useY ? Math.abs(pt1.y - pt2.y) : 0;
    return Math.sqrt(Math.pow(deltaX, 2) + Math.pow(deltaY, 2));
  };
}
function getIntersectItems(chart, position2, axis, useFinalPosition, includeInvisible) {
  const items = [];
  if (!includeInvisible && !chart.isPointInArea(position2)) {
    return items;
  }
  const evaluationFunc = function(element2, datasetIndex, index) {
    if (!includeInvisible && !_isPointInArea(element2, chart.chartArea, 0)) {
      return;
    }
    if (element2.inRange(position2.x, position2.y, useFinalPosition)) {
      items.push({
        element: element2,
        datasetIndex,
        index
      });
    }
  };
  evaluateInteractionItems(chart, axis, position2, evaluationFunc, true);
  return items;
}
function getNearestRadialItems(chart, position2, axis, useFinalPosition) {
  let items = [];
  function evaluationFunc(element2, datasetIndex, index) {
    const { startAngle, endAngle } = element2.getProps([
      "startAngle",
      "endAngle"
    ], useFinalPosition);
    const { angle } = getAngleFromPoint(element2, {
      x: position2.x,
      y: position2.y
    });
    if (_angleBetween(angle, startAngle, endAngle)) {
      items.push({
        element: element2,
        datasetIndex,
        index
      });
    }
  }
  evaluateInteractionItems(chart, axis, position2, evaluationFunc);
  return items;
}
function getNearestCartesianItems(chart, position2, axis, intersect, useFinalPosition, includeInvisible) {
  let items = [];
  const distanceMetric = getDistanceMetricForAxis(axis);
  let minDistance = Number.POSITIVE_INFINITY;
  function evaluationFunc(element2, datasetIndex, index) {
    const inRange2 = element2.inRange(position2.x, position2.y, useFinalPosition);
    if (intersect && !inRange2) {
      return;
    }
    const center = element2.getCenterPoint(useFinalPosition);
    const pointInArea = !!includeInvisible || chart.isPointInArea(center);
    if (!pointInArea && !inRange2) {
      return;
    }
    const distance = distanceMetric(position2, center);
    if (distance < minDistance) {
      items = [
        {
          element: element2,
          datasetIndex,
          index
        }
      ];
      minDistance = distance;
    } else if (distance === minDistance) {
      items.push({
        element: element2,
        datasetIndex,
        index
      });
    }
  }
  evaluateInteractionItems(chart, axis, position2, evaluationFunc);
  return items;
}
function getNearestItems(chart, position2, axis, intersect, useFinalPosition, includeInvisible) {
  if (!includeInvisible && !chart.isPointInArea(position2)) {
    return [];
  }
  return axis === "r" && !intersect ? getNearestRadialItems(chart, position2, axis, useFinalPosition) : getNearestCartesianItems(chart, position2, axis, intersect, useFinalPosition, includeInvisible);
}
function getAxisItems(chart, position2, axis, intersect, useFinalPosition) {
  const items = [];
  const rangeMethod = axis === "x" ? "inXRange" : "inYRange";
  let intersectsItem = false;
  evaluateInteractionItems(chart, axis, position2, (element2, datasetIndex, index) => {
    if (element2[rangeMethod](position2[axis], useFinalPosition)) {
      items.push({
        element: element2,
        datasetIndex,
        index
      });
      intersectsItem = intersectsItem || element2.inRange(position2.x, position2.y, useFinalPosition);
    }
  });
  if (intersect && !intersectsItem) {
    return [];
  }
  return items;
}
var Interaction = {
  evaluateInteractionItems,
  modes: {
    index(chart, e2, options, useFinalPosition) {
      const position2 = getRelativePosition(e2, chart);
      const axis = options.axis || "x";
      const includeInvisible = options.includeInvisible || false;
      const items = options.intersect ? getIntersectItems(chart, position2, axis, useFinalPosition, includeInvisible) : getNearestItems(chart, position2, axis, false, useFinalPosition, includeInvisible);
      const elements = [];
      if (!items.length) {
        return [];
      }
      chart.getSortedVisibleDatasetMetas().forEach((meta) => {
        const index = items[0].index;
        const element2 = meta.data[index];
        if (element2 && !element2.skip) {
          elements.push({
            element: element2,
            datasetIndex: meta.index,
            index
          });
        }
      });
      return elements;
    },
    dataset(chart, e2, options, useFinalPosition) {
      const position2 = getRelativePosition(e2, chart);
      const axis = options.axis || "xy";
      const includeInvisible = options.includeInvisible || false;
      let items = options.intersect ? getIntersectItems(chart, position2, axis, useFinalPosition, includeInvisible) : getNearestItems(chart, position2, axis, false, useFinalPosition, includeInvisible);
      if (items.length > 0) {
        const datasetIndex = items[0].datasetIndex;
        const data = chart.getDatasetMeta(datasetIndex).data;
        items = [];
        for (let i = 0; i < data.length; ++i) {
          items.push({
            element: data[i],
            datasetIndex,
            index: i
          });
        }
      }
      return items;
    },
    point(chart, e2, options, useFinalPosition) {
      const position2 = getRelativePosition(e2, chart);
      const axis = options.axis || "xy";
      const includeInvisible = options.includeInvisible || false;
      return getIntersectItems(chart, position2, axis, useFinalPosition, includeInvisible);
    },
    nearest(chart, e2, options, useFinalPosition) {
      const position2 = getRelativePosition(e2, chart);
      const axis = options.axis || "xy";
      const includeInvisible = options.includeInvisible || false;
      return getNearestItems(chart, position2, axis, options.intersect, useFinalPosition, includeInvisible);
    },
    x(chart, e2, options, useFinalPosition) {
      const position2 = getRelativePosition(e2, chart);
      return getAxisItems(chart, position2, "x", options.intersect, useFinalPosition);
    },
    y(chart, e2, options, useFinalPosition) {
      const position2 = getRelativePosition(e2, chart);
      return getAxisItems(chart, position2, "y", options.intersect, useFinalPosition);
    }
  }
};
const STATIC_POSITIONS = [
  "left",
  "top",
  "right",
  "bottom"
];
function filterByPosition(array, position2) {
  return array.filter((v2) => v2.pos === position2);
}
function filterDynamicPositionByAxis(array, axis) {
  return array.filter((v2) => STATIC_POSITIONS.indexOf(v2.pos) === -1 && v2.box.axis === axis);
}
function sortByWeight(array, reverse) {
  return array.sort((a2, b2) => {
    const v0 = reverse ? b2 : a2;
    const v1 = reverse ? a2 : b2;
    return v0.weight === v1.weight ? v0.index - v1.index : v0.weight - v1.weight;
  });
}
function wrapBoxes(boxes) {
  const layoutBoxes = [];
  let i, ilen, box, pos, stack, stackWeight;
  for (i = 0, ilen = (boxes || []).length; i < ilen; ++i) {
    box = boxes[i];
    ({ position: pos, options: { stack, stackWeight = 1 } } = box);
    layoutBoxes.push({
      index: i,
      box,
      pos,
      horizontal: box.isHorizontal(),
      weight: box.weight,
      stack: stack && pos + stack,
      stackWeight
    });
  }
  return layoutBoxes;
}
function buildStacks(layouts2) {
  const stacks = {};
  for (const wrap of layouts2) {
    const { stack, pos, stackWeight } = wrap;
    if (!stack || !STATIC_POSITIONS.includes(pos)) {
      continue;
    }
    const _stack = stacks[stack] || (stacks[stack] = {
      count: 0,
      placed: 0,
      weight: 0,
      size: 0
    });
    _stack.count++;
    _stack.weight += stackWeight;
  }
  return stacks;
}
function setLayoutDims(layouts2, params) {
  const stacks = buildStacks(layouts2);
  const { vBoxMaxWidth, hBoxMaxHeight } = params;
  let i, ilen, layout;
  for (i = 0, ilen = layouts2.length; i < ilen; ++i) {
    layout = layouts2[i];
    const { fullSize } = layout.box;
    const stack = stacks[layout.stack];
    const factor = stack && layout.stackWeight / stack.weight;
    if (layout.horizontal) {
      layout.width = factor ? factor * vBoxMaxWidth : fullSize && params.availableWidth;
      layout.height = hBoxMaxHeight;
    } else {
      layout.width = vBoxMaxWidth;
      layout.height = factor ? factor * hBoxMaxHeight : fullSize && params.availableHeight;
    }
  }
  return stacks;
}
function buildLayoutBoxes(boxes) {
  const layoutBoxes = wrapBoxes(boxes);
  const fullSize = sortByWeight(layoutBoxes.filter((wrap) => wrap.box.fullSize), true);
  const left = sortByWeight(filterByPosition(layoutBoxes, "left"), true);
  const right = sortByWeight(filterByPosition(layoutBoxes, "right"));
  const top = sortByWeight(filterByPosition(layoutBoxes, "top"), true);
  const bottom = sortByWeight(filterByPosition(layoutBoxes, "bottom"));
  const centerHorizontal = filterDynamicPositionByAxis(layoutBoxes, "x");
  const centerVertical = filterDynamicPositionByAxis(layoutBoxes, "y");
  return {
    fullSize,
    leftAndTop: left.concat(top),
    rightAndBottom: right.concat(centerVertical).concat(bottom).concat(centerHorizontal),
    chartArea: filterByPosition(layoutBoxes, "chartArea"),
    vertical: left.concat(right).concat(centerVertical),
    horizontal: top.concat(bottom).concat(centerHorizontal)
  };
}
function getCombinedMax(maxPadding, chartArea, a2, b2) {
  return Math.max(maxPadding[a2], chartArea[a2]) + Math.max(maxPadding[b2], chartArea[b2]);
}
function updateMaxPadding(maxPadding, boxPadding) {
  maxPadding.top = Math.max(maxPadding.top, boxPadding.top);
  maxPadding.left = Math.max(maxPadding.left, boxPadding.left);
  maxPadding.bottom = Math.max(maxPadding.bottom, boxPadding.bottom);
  maxPadding.right = Math.max(maxPadding.right, boxPadding.right);
}
function updateDims(chartArea, params, layout, stacks) {
  const { pos, box } = layout;
  const maxPadding = chartArea.maxPadding;
  if (!isObject(pos)) {
    if (layout.size) {
      chartArea[pos] -= layout.size;
    }
    const stack = stacks[layout.stack] || {
      size: 0,
      count: 1
    };
    stack.size = Math.max(stack.size, layout.horizontal ? box.height : box.width);
    layout.size = stack.size / stack.count;
    chartArea[pos] += layout.size;
  }
  if (box.getPadding) {
    updateMaxPadding(maxPadding, box.getPadding());
  }
  const newWidth = Math.max(0, params.outerWidth - getCombinedMax(maxPadding, chartArea, "left", "right"));
  const newHeight = Math.max(0, params.outerHeight - getCombinedMax(maxPadding, chartArea, "top", "bottom"));
  const widthChanged = newWidth !== chartArea.w;
  const heightChanged = newHeight !== chartArea.h;
  chartArea.w = newWidth;
  chartArea.h = newHeight;
  return layout.horizontal ? {
    same: widthChanged,
    other: heightChanged
  } : {
    same: heightChanged,
    other: widthChanged
  };
}
function handleMaxPadding(chartArea) {
  const maxPadding = chartArea.maxPadding;
  function updatePos(pos) {
    const change = Math.max(maxPadding[pos] - chartArea[pos], 0);
    chartArea[pos] += change;
    return change;
  }
  chartArea.y += updatePos("top");
  chartArea.x += updatePos("left");
  updatePos("right");
  updatePos("bottom");
}
function getMargins(horizontal, chartArea) {
  const maxPadding = chartArea.maxPadding;
  function marginForPositions(positions2) {
    const margin = {
      left: 0,
      top: 0,
      right: 0,
      bottom: 0
    };
    positions2.forEach((pos) => {
      margin[pos] = Math.max(chartArea[pos], maxPadding[pos]);
    });
    return margin;
  }
  return horizontal ? marginForPositions([
    "left",
    "right"
  ]) : marginForPositions([
    "top",
    "bottom"
  ]);
}
function fitBoxes(boxes, chartArea, params, stacks) {
  const refitBoxes = [];
  let i, ilen, layout, box, refit, changed;
  for (i = 0, ilen = boxes.length, refit = 0; i < ilen; ++i) {
    layout = boxes[i];
    box = layout.box;
    box.update(layout.width || chartArea.w, layout.height || chartArea.h, getMargins(layout.horizontal, chartArea));
    const { same, other } = updateDims(chartArea, params, layout, stacks);
    refit |= same && refitBoxes.length;
    changed = changed || other;
    if (!box.fullSize) {
      refitBoxes.push(layout);
    }
  }
  return refit && fitBoxes(refitBoxes, chartArea, params, stacks) || changed;
}
function setBoxDims(box, left, top, width, height) {
  box.top = top;
  box.left = left;
  box.right = left + width;
  box.bottom = top + height;
  box.width = width;
  box.height = height;
}
function placeBoxes(boxes, chartArea, params, stacks) {
  const userPadding = params.padding;
  let { x: x2, y: y2 } = chartArea;
  for (const layout of boxes) {
    const box = layout.box;
    const stack = stacks[layout.stack] || {
      count: 1,
      placed: 0,
      weight: 1
    };
    const weight = layout.stackWeight / stack.weight || 1;
    if (layout.horizontal) {
      const width = chartArea.w * weight;
      const height = stack.size || box.height;
      if (defined(stack.start)) {
        y2 = stack.start;
      }
      if (box.fullSize) {
        setBoxDims(box, userPadding.left, y2, params.outerWidth - userPadding.right - userPadding.left, height);
      } else {
        setBoxDims(box, chartArea.left + stack.placed, y2, width, height);
      }
      stack.start = y2;
      stack.placed += width;
      y2 = box.bottom;
    } else {
      const height = chartArea.h * weight;
      const width = stack.size || box.width;
      if (defined(stack.start)) {
        x2 = stack.start;
      }
      if (box.fullSize) {
        setBoxDims(box, x2, userPadding.top, width, params.outerHeight - userPadding.bottom - userPadding.top);
      } else {
        setBoxDims(box, x2, chartArea.top + stack.placed, width, height);
      }
      stack.start = x2;
      stack.placed += height;
      x2 = box.right;
    }
  }
  chartArea.x = x2;
  chartArea.y = y2;
}
var layouts = {
  addBox(chart, item) {
    if (!chart.boxes) {
      chart.boxes = [];
    }
    item.fullSize = item.fullSize || false;
    item.position = item.position || "top";
    item.weight = item.weight || 0;
    item._layers = item._layers || function() {
      return [
        {
          z: 0,
          draw(chartArea) {
            item.draw(chartArea);
          }
        }
      ];
    };
    chart.boxes.push(item);
  },
  removeBox(chart, layoutItem) {
    const index = chart.boxes ? chart.boxes.indexOf(layoutItem) : -1;
    if (index !== -1) {
      chart.boxes.splice(index, 1);
    }
  },
  configure(chart, item, options) {
    item.fullSize = options.fullSize;
    item.position = options.position;
    item.weight = options.weight;
  },
  update(chart, width, height, minPadding) {
    if (!chart) {
      return;
    }
    const padding = toPadding(chart.options.layout.padding);
    const availableWidth = Math.max(width - padding.width, 0);
    const availableHeight = Math.max(height - padding.height, 0);
    const boxes = buildLayoutBoxes(chart.boxes);
    const verticalBoxes = boxes.vertical;
    const horizontalBoxes = boxes.horizontal;
    each(chart.boxes, (box) => {
      if (typeof box.beforeLayout === "function") {
        box.beforeLayout();
      }
    });
    const visibleVerticalBoxCount = verticalBoxes.reduce((total, wrap) => wrap.box.options && wrap.box.options.display === false ? total : total + 1, 0) || 1;
    const params = Object.freeze({
      outerWidth: width,
      outerHeight: height,
      padding,
      availableWidth,
      availableHeight,
      vBoxMaxWidth: availableWidth / 2 / visibleVerticalBoxCount,
      hBoxMaxHeight: availableHeight / 2
    });
    const maxPadding = Object.assign({}, padding);
    updateMaxPadding(maxPadding, toPadding(minPadding));
    const chartArea = Object.assign({
      maxPadding,
      w: availableWidth,
      h: availableHeight,
      x: padding.left,
      y: padding.top
    }, padding);
    const stacks = setLayoutDims(verticalBoxes.concat(horizontalBoxes), params);
    fitBoxes(boxes.fullSize, chartArea, params, stacks);
    fitBoxes(verticalBoxes, chartArea, params, stacks);
    if (fitBoxes(horizontalBoxes, chartArea, params, stacks)) {
      fitBoxes(verticalBoxes, chartArea, params, stacks);
    }
    handleMaxPadding(chartArea);
    placeBoxes(boxes.leftAndTop, chartArea, params, stacks);
    chartArea.x += chartArea.w;
    chartArea.y += chartArea.h;
    placeBoxes(boxes.rightAndBottom, chartArea, params, stacks);
    chart.chartArea = {
      left: chartArea.left,
      top: chartArea.top,
      right: chartArea.left + chartArea.w,
      bottom: chartArea.top + chartArea.h,
      height: chartArea.h,
      width: chartArea.w
    };
    each(boxes.chartArea, (layout) => {
      const box = layout.box;
      Object.assign(box, chart.chartArea);
      box.update(chartArea.w, chartArea.h, {
        left: 0,
        top: 0,
        right: 0,
        bottom: 0
      });
    });
  }
};
class BasePlatform {
  acquireContext(canvas, aspectRatio) {
  }
  releaseContext(context) {
    return false;
  }
  addEventListener(chart, type, listener) {
  }
  removeEventListener(chart, type, listener) {
  }
  getDevicePixelRatio() {
    return 1;
  }
  getMaximumSize(element2, width, height, aspectRatio) {
    width = Math.max(0, width || element2.width);
    height = height || element2.height;
    return {
      width,
      height: Math.max(0, aspectRatio ? Math.floor(width / aspectRatio) : height)
    };
  }
  isAttached(canvas) {
    return true;
  }
  updateConfig(config) {
  }
}
class BasicPlatform extends BasePlatform {
  acquireContext(item) {
    return item && item.getContext && item.getContext("2d") || null;
  }
  updateConfig(config) {
    config.options.animation = false;
  }
}
const EXPANDO_KEY = "$chartjs";
const EVENT_TYPES = {
  touchstart: "mousedown",
  touchmove: "mousemove",
  touchend: "mouseup",
  pointerenter: "mouseenter",
  pointerdown: "mousedown",
  pointermove: "mousemove",
  pointerup: "mouseup",
  pointerleave: "mouseout",
  pointerout: "mouseout"
};
const isNullOrEmpty = (value) => value === null || value === "";
function initCanvas(canvas, aspectRatio) {
  const style = canvas.style;
  const renderHeight = canvas.getAttribute("height");
  const renderWidth = canvas.getAttribute("width");
  canvas[EXPANDO_KEY] = {
    initial: {
      height: renderHeight,
      width: renderWidth,
      style: {
        display: style.display,
        height: style.height,
        width: style.width
      }
    }
  };
  style.display = style.display || "block";
  style.boxSizing = style.boxSizing || "border-box";
  if (isNullOrEmpty(renderWidth)) {
    const displayWidth = readUsedSize(canvas, "width");
    if (displayWidth !== void 0) {
      canvas.width = displayWidth;
    }
  }
  if (isNullOrEmpty(renderHeight)) {
    if (canvas.style.height === "") {
      canvas.height = canvas.width / (aspectRatio || 2);
    } else {
      const displayHeight = readUsedSize(canvas, "height");
      if (displayHeight !== void 0) {
        canvas.height = displayHeight;
      }
    }
  }
  return canvas;
}
const eventListenerOptions = supportsEventListenerOptions ? {
  passive: true
} : false;
function addListener(node, type, listener) {
  node.addEventListener(type, listener, eventListenerOptions);
}
function removeListener(chart, type, listener) {
  chart.canvas.removeEventListener(type, listener, eventListenerOptions);
}
function fromNativeEvent(event, chart) {
  const type = EVENT_TYPES[event.type] || event.type;
  const { x: x2, y: y2 } = getRelativePosition(event, chart);
  return {
    type,
    chart,
    native: event,
    x: x2 !== void 0 ? x2 : null,
    y: y2 !== void 0 ? y2 : null
  };
}
function nodeListContains(nodeList, canvas) {
  for (const node of nodeList) {
    if (node === canvas || node.contains(canvas)) {
      return true;
    }
  }
}
function createAttachObserver(chart, type, listener) {
  const canvas = chart.canvas;
  const observer = new MutationObserver((entries) => {
    let trigger = false;
    for (const entry of entries) {
      trigger = trigger || nodeListContains(entry.addedNodes, canvas);
      trigger = trigger && !nodeListContains(entry.removedNodes, canvas);
    }
    if (trigger) {
      listener();
    }
  });
  observer.observe(document, {
    childList: true,
    subtree: true
  });
  return observer;
}
function createDetachObserver(chart, type, listener) {
  const canvas = chart.canvas;
  const observer = new MutationObserver((entries) => {
    let trigger = false;
    for (const entry of entries) {
      trigger = trigger || nodeListContains(entry.removedNodes, canvas);
      trigger = trigger && !nodeListContains(entry.addedNodes, canvas);
    }
    if (trigger) {
      listener();
    }
  });
  observer.observe(document, {
    childList: true,
    subtree: true
  });
  return observer;
}
const drpListeningCharts = /* @__PURE__ */ new Map();
let oldDevicePixelRatio = 0;
function onWindowResize() {
  const dpr = window.devicePixelRatio;
  if (dpr === oldDevicePixelRatio) {
    return;
  }
  oldDevicePixelRatio = dpr;
  drpListeningCharts.forEach((resize, chart) => {
    if (chart.currentDevicePixelRatio !== dpr) {
      resize();
    }
  });
}
function listenDevicePixelRatioChanges(chart, resize) {
  if (!drpListeningCharts.size) {
    window.addEventListener("resize", onWindowResize);
  }
  drpListeningCharts.set(chart, resize);
}
function unlistenDevicePixelRatioChanges(chart) {
  drpListeningCharts.delete(chart);
  if (!drpListeningCharts.size) {
    window.removeEventListener("resize", onWindowResize);
  }
}
function createResizeObserver(chart, type, listener) {
  const canvas = chart.canvas;
  const container = canvas && _getParentNode(canvas);
  if (!container) {
    return;
  }
  const resize = throttled((width, height) => {
    const w2 = container.clientWidth;
    listener(width, height);
    if (w2 < container.clientWidth) {
      listener();
    }
  }, window);
  const observer = new ResizeObserver((entries) => {
    const entry = entries[0];
    const width = entry.contentRect.width;
    const height = entry.contentRect.height;
    if (width === 0 && height === 0) {
      return;
    }
    resize(width, height);
  });
  observer.observe(container);
  listenDevicePixelRatioChanges(chart, resize);
  return observer;
}
function releaseObserver(chart, type, observer) {
  if (observer) {
    observer.disconnect();
  }
  if (type === "resize") {
    unlistenDevicePixelRatioChanges(chart);
  }
}
function createProxyAndListen(chart, type, listener) {
  const canvas = chart.canvas;
  const proxy = throttled((event) => {
    if (chart.ctx !== null) {
      listener(fromNativeEvent(event, chart));
    }
  }, chart);
  addListener(canvas, type, proxy);
  return proxy;
}
class DomPlatform extends BasePlatform {
  acquireContext(canvas, aspectRatio) {
    const context = canvas && canvas.getContext && canvas.getContext("2d");
    if (context && context.canvas === canvas) {
      initCanvas(canvas, aspectRatio);
      return context;
    }
    return null;
  }
  releaseContext(context) {
    const canvas = context.canvas;
    if (!canvas[EXPANDO_KEY]) {
      return false;
    }
    const initial = canvas[EXPANDO_KEY].initial;
    [
      "height",
      "width"
    ].forEach((prop) => {
      const value = initial[prop];
      if (isNullOrUndef(value)) {
        canvas.removeAttribute(prop);
      } else {
        canvas.setAttribute(prop, value);
      }
    });
    const style = initial.style || {};
    Object.keys(style).forEach((key) => {
      canvas.style[key] = style[key];
    });
    canvas.width = canvas.width;
    delete canvas[EXPANDO_KEY];
    return true;
  }
  addEventListener(chart, type, listener) {
    this.removeEventListener(chart, type);
    const proxies = chart.$proxies || (chart.$proxies = {});
    const handlers = {
      attach: createAttachObserver,
      detach: createDetachObserver,
      resize: createResizeObserver
    };
    const handler = handlers[type] || createProxyAndListen;
    proxies[type] = handler(chart, type, listener);
  }
  removeEventListener(chart, type) {
    const proxies = chart.$proxies || (chart.$proxies = {});
    const proxy = proxies[type];
    if (!proxy) {
      return;
    }
    const handlers = {
      attach: releaseObserver,
      detach: releaseObserver,
      resize: releaseObserver
    };
    const handler = handlers[type] || removeListener;
    handler(chart, type, proxy);
    proxies[type] = void 0;
  }
  getDevicePixelRatio() {
    return window.devicePixelRatio;
  }
  getMaximumSize(canvas, width, height, aspectRatio) {
    return getMaximumSize(canvas, width, height, aspectRatio);
  }
  isAttached(canvas) {
    const container = _getParentNode(canvas);
    return !!(container && container.isConnected);
  }
}
function _detectPlatform(canvas) {
  if (!_isDomSupported() || typeof OffscreenCanvas !== "undefined" && canvas instanceof OffscreenCanvas) {
    return BasicPlatform;
  }
  return DomPlatform;
}
class Element {
  constructor() {
    __publicField(this, "x");
    __publicField(this, "y");
    __publicField(this, "active", false);
    __publicField(this, "options");
    __publicField(this, "$animations");
  }
  tooltipPosition(useFinalPosition) {
    const { x: x2, y: y2 } = this.getProps([
      "x",
      "y"
    ], useFinalPosition);
    return {
      x: x2,
      y: y2
    };
  }
  hasValue() {
    return isNumber(this.x) && isNumber(this.y);
  }
  getProps(props, final) {
    const anims = this.$animations;
    if (!final || !anims) {
      return this;
    }
    const ret = {};
    props.forEach((prop) => {
      ret[prop] = anims[prop] && anims[prop].active() ? anims[prop]._to : this[prop];
    });
    return ret;
  }
}
__publicField(Element, "defaults", {});
__publicField(Element, "defaultRoutes");
function autoSkip(scale, ticks) {
  const tickOpts = scale.options.ticks;
  const determinedMaxTicks = determineMaxTicks(scale);
  const ticksLimit = Math.min(tickOpts.maxTicksLimit || determinedMaxTicks, determinedMaxTicks);
  const majorIndices = tickOpts.major.enabled ? getMajorIndices(ticks) : [];
  const numMajorIndices = majorIndices.length;
  const first = majorIndices[0];
  const last = majorIndices[numMajorIndices - 1];
  const newTicks = [];
  if (numMajorIndices > ticksLimit) {
    skipMajors(ticks, newTicks, majorIndices, numMajorIndices / ticksLimit);
    return newTicks;
  }
  const spacing = calculateSpacing(majorIndices, ticks, ticksLimit);
  if (numMajorIndices > 0) {
    let i, ilen;
    const avgMajorSpacing = numMajorIndices > 1 ? Math.round((last - first) / (numMajorIndices - 1)) : null;
    skip(ticks, newTicks, spacing, isNullOrUndef(avgMajorSpacing) ? 0 : first - avgMajorSpacing, first);
    for (i = 0, ilen = numMajorIndices - 1; i < ilen; i++) {
      skip(ticks, newTicks, spacing, majorIndices[i], majorIndices[i + 1]);
    }
    skip(ticks, newTicks, spacing, last, isNullOrUndef(avgMajorSpacing) ? ticks.length : last + avgMajorSpacing);
    return newTicks;
  }
  skip(ticks, newTicks, spacing);
  return newTicks;
}
function determineMaxTicks(scale) {
  const offset = scale.options.offset;
  const tickLength = scale._tickSize();
  const maxScale = scale._length / tickLength + (offset ? 0 : 1);
  const maxChart = scale._maxLength / tickLength;
  return Math.floor(Math.min(maxScale, maxChart));
}
function calculateSpacing(majorIndices, ticks, ticksLimit) {
  const evenMajorSpacing = getEvenSpacing(majorIndices);
  const spacing = ticks.length / ticksLimit;
  if (!evenMajorSpacing) {
    return Math.max(spacing, 1);
  }
  const factors = _factorize(evenMajorSpacing);
  for (let i = 0, ilen = factors.length - 1; i < ilen; i++) {
    const factor = factors[i];
    if (factor > spacing) {
      return factor;
    }
  }
  return Math.max(spacing, 1);
}
function getMajorIndices(ticks) {
  const result = [];
  let i, ilen;
  for (i = 0, ilen = ticks.length; i < ilen; i++) {
    if (ticks[i].major) {
      result.push(i);
    }
  }
  return result;
}
function skipMajors(ticks, newTicks, majorIndices, spacing) {
  let count = 0;
  let next = majorIndices[0];
  let i;
  spacing = Math.ceil(spacing);
  for (i = 0; i < ticks.length; i++) {
    if (i === next) {
      newTicks.push(ticks[i]);
      count++;
      next = majorIndices[count * spacing];
    }
  }
}
function skip(ticks, newTicks, spacing, majorStart, majorEnd) {
  const start = valueOrDefault(majorStart, 0);
  const end = Math.min(valueOrDefault(majorEnd, ticks.length), ticks.length);
  let count = 0;
  let length, i, next;
  spacing = Math.ceil(spacing);
  if (majorEnd) {
    length = majorEnd - majorStart;
    spacing = length / Math.floor(length / spacing);
  }
  next = start;
  while (next < 0) {
    count++;
    next = Math.round(start + count * spacing);
  }
  for (i = Math.max(start, 0); i < end; i++) {
    if (i === next) {
      newTicks.push(ticks[i]);
      count++;
      next = Math.round(start + count * spacing);
    }
  }
}
function getEvenSpacing(arr) {
  const len = arr.length;
  let i, diff;
  if (len < 2) {
    return false;
  }
  for (diff = arr[0], i = 1; i < len; ++i) {
    if (arr[i] - arr[i - 1] !== diff) {
      return false;
    }
  }
  return diff;
}
const reverseAlign = (align) => align === "left" ? "right" : align === "right" ? "left" : align;
const offsetFromEdge = (scale, edge, offset) => edge === "top" || edge === "left" ? scale[edge] + offset : scale[edge] - offset;
const getTicksLimit = (ticksLength, maxTicksLimit) => Math.min(maxTicksLimit || ticksLength, ticksLength);
function sample(arr, numItems) {
  const result = [];
  const increment = arr.length / numItems;
  const len = arr.length;
  let i = 0;
  for (; i < len; i += increment) {
    result.push(arr[Math.floor(i)]);
  }
  return result;
}
function getPixelForGridLine(scale, index, offsetGridLines) {
  const length = scale.ticks.length;
  const validIndex2 = Math.min(index, length - 1);
  const start = scale._startPixel;
  const end = scale._endPixel;
  const epsilon = 1e-6;
  let lineValue = scale.getPixelForTick(validIndex2);
  let offset;
  if (offsetGridLines) {
    if (length === 1) {
      offset = Math.max(lineValue - start, end - lineValue);
    } else if (index === 0) {
      offset = (scale.getPixelForTick(1) - lineValue) / 2;
    } else {
      offset = (lineValue - scale.getPixelForTick(validIndex2 - 1)) / 2;
    }
    lineValue += validIndex2 < index ? offset : -offset;
    if (lineValue < start - epsilon || lineValue > end + epsilon) {
      return;
    }
  }
  return lineValue;
}
function garbageCollect(caches, length) {
  each(caches, (cache) => {
    const gc = cache.gc;
    const gcLen = gc.length / 2;
    let i;
    if (gcLen > length) {
      for (i = 0; i < gcLen; ++i) {
        delete cache.data[gc[i]];
      }
      gc.splice(0, gcLen);
    }
  });
}
function getTickMarkLength(options) {
  return options.drawTicks ? options.tickLength : 0;
}
function getTitleHeight(options, fallback) {
  if (!options.display) {
    return 0;
  }
  const font = toFont(options.font, fallback);
  const padding = toPadding(options.padding);
  const lines = isArray(options.text) ? options.text.length : 1;
  return lines * font.lineHeight + padding.height;
}
function createScaleContext(parent, scale) {
  return createContext(parent, {
    scale,
    type: "scale"
  });
}
function createTickContext(parent, index, tick2) {
  return createContext(parent, {
    tick: tick2,
    index,
    type: "tick"
  });
}
function titleAlign(align, position2, reverse) {
  let ret = _toLeftRightCenter(align);
  if (reverse && position2 !== "right" || !reverse && position2 === "right") {
    ret = reverseAlign(ret);
  }
  return ret;
}
function titleArgs(scale, offset, position2, align) {
  const { top, left, bottom, right, chart } = scale;
  const { chartArea, scales } = chart;
  let rotation = 0;
  let maxWidth, titleX, titleY;
  const height = bottom - top;
  const width = right - left;
  if (scale.isHorizontal()) {
    titleX = _alignStartEnd(align, left, right);
    if (isObject(position2)) {
      const positionAxisID = Object.keys(position2)[0];
      const value = position2[positionAxisID];
      titleY = scales[positionAxisID].getPixelForValue(value) + height - offset;
    } else if (position2 === "center") {
      titleY = (chartArea.bottom + chartArea.top) / 2 + height - offset;
    } else {
      titleY = offsetFromEdge(scale, position2, offset);
    }
    maxWidth = right - left;
  } else {
    if (isObject(position2)) {
      const positionAxisID = Object.keys(position2)[0];
      const value = position2[positionAxisID];
      titleX = scales[positionAxisID].getPixelForValue(value) - width + offset;
    } else if (position2 === "center") {
      titleX = (chartArea.left + chartArea.right) / 2 - width + offset;
    } else {
      titleX = offsetFromEdge(scale, position2, offset);
    }
    titleY = _alignStartEnd(align, bottom, top);
    rotation = position2 === "left" ? -HALF_PI : HALF_PI;
  }
  return {
    titleX,
    titleY,
    maxWidth,
    rotation
  };
}
class Scale extends Element {
  constructor(cfg) {
    super();
    this.id = cfg.id;
    this.type = cfg.type;
    this.options = void 0;
    this.ctx = cfg.ctx;
    this.chart = cfg.chart;
    this.top = void 0;
    this.bottom = void 0;
    this.left = void 0;
    this.right = void 0;
    this.width = void 0;
    this.height = void 0;
    this._margins = {
      left: 0,
      right: 0,
      top: 0,
      bottom: 0
    };
    this.maxWidth = void 0;
    this.maxHeight = void 0;
    this.paddingTop = void 0;
    this.paddingBottom = void 0;
    this.paddingLeft = void 0;
    this.paddingRight = void 0;
    this.axis = void 0;
    this.labelRotation = void 0;
    this.min = void 0;
    this.max = void 0;
    this._range = void 0;
    this.ticks = [];
    this._gridLineItems = null;
    this._labelItems = null;
    this._labelSizes = null;
    this._length = 0;
    this._maxLength = 0;
    this._longestTextCache = {};
    this._startPixel = void 0;
    this._endPixel = void 0;
    this._reversePixels = false;
    this._userMax = void 0;
    this._userMin = void 0;
    this._suggestedMax = void 0;
    this._suggestedMin = void 0;
    this._ticksLength = 0;
    this._borderValue = 0;
    this._cache = {};
    this._dataLimitsCached = false;
    this.$context = void 0;
  }
  init(options) {
    this.options = options.setContext(this.getContext());
    this.axis = options.axis;
    this._userMin = this.parse(options.min);
    this._userMax = this.parse(options.max);
    this._suggestedMin = this.parse(options.suggestedMin);
    this._suggestedMax = this.parse(options.suggestedMax);
  }
  parse(raw, index) {
    return raw;
  }
  getUserBounds() {
    let { _userMin, _userMax, _suggestedMin, _suggestedMax } = this;
    _userMin = finiteOrDefault(_userMin, Number.POSITIVE_INFINITY);
    _userMax = finiteOrDefault(_userMax, Number.NEGATIVE_INFINITY);
    _suggestedMin = finiteOrDefault(_suggestedMin, Number.POSITIVE_INFINITY);
    _suggestedMax = finiteOrDefault(_suggestedMax, Number.NEGATIVE_INFINITY);
    return {
      min: finiteOrDefault(_userMin, _suggestedMin),
      max: finiteOrDefault(_userMax, _suggestedMax),
      minDefined: isNumberFinite(_userMin),
      maxDefined: isNumberFinite(_userMax)
    };
  }
  getMinMax(canStack) {
    let { min, max, minDefined, maxDefined } = this.getUserBounds();
    let range;
    if (minDefined && maxDefined) {
      return {
        min,
        max
      };
    }
    const metas = this.getMatchingVisibleMetas();
    for (let i = 0, ilen = metas.length; i < ilen; ++i) {
      range = metas[i].controller.getMinMax(this, canStack);
      if (!minDefined) {
        min = Math.min(min, range.min);
      }
      if (!maxDefined) {
        max = Math.max(max, range.max);
      }
    }
    min = maxDefined && min > max ? max : min;
    max = minDefined && min > max ? min : max;
    return {
      min: finiteOrDefault(min, finiteOrDefault(max, min)),
      max: finiteOrDefault(max, finiteOrDefault(min, max))
    };
  }
  getPadding() {
    return {
      left: this.paddingLeft || 0,
      top: this.paddingTop || 0,
      right: this.paddingRight || 0,
      bottom: this.paddingBottom || 0
    };
  }
  getTicks() {
    return this.ticks;
  }
  getLabels() {
    const data = this.chart.data;
    return this.options.labels || (this.isHorizontal() ? data.xLabels : data.yLabels) || data.labels || [];
  }
  getLabelItems(chartArea = this.chart.chartArea) {
    const items = this._labelItems || (this._labelItems = this._computeLabelItems(chartArea));
    return items;
  }
  beforeLayout() {
    this._cache = {};
    this._dataLimitsCached = false;
  }
  beforeUpdate() {
    callback(this.options.beforeUpdate, [
      this
    ]);
  }
  update(maxWidth, maxHeight, margins) {
    const { beginAtZero, grace, ticks: tickOpts } = this.options;
    const sampleSize = tickOpts.sampleSize;
    this.beforeUpdate();
    this.maxWidth = maxWidth;
    this.maxHeight = maxHeight;
    this._margins = margins = Object.assign({
      left: 0,
      right: 0,
      top: 0,
      bottom: 0
    }, margins);
    this.ticks = null;
    this._labelSizes = null;
    this._gridLineItems = null;
    this._labelItems = null;
    this.beforeSetDimensions();
    this.setDimensions();
    this.afterSetDimensions();
    this._maxLength = this.isHorizontal() ? this.width + margins.left + margins.right : this.height + margins.top + margins.bottom;
    if (!this._dataLimitsCached) {
      this.beforeDataLimits();
      this.determineDataLimits();
      this.afterDataLimits();
      this._range = _addGrace(this, grace, beginAtZero);
      this._dataLimitsCached = true;
    }
    this.beforeBuildTicks();
    this.ticks = this.buildTicks() || [];
    this.afterBuildTicks();
    const samplingEnabled = sampleSize < this.ticks.length;
    this._convertTicksToLabels(samplingEnabled ? sample(this.ticks, sampleSize) : this.ticks);
    this.configure();
    this.beforeCalculateLabelRotation();
    this.calculateLabelRotation();
    this.afterCalculateLabelRotation();
    if (tickOpts.display && (tickOpts.autoSkip || tickOpts.source === "auto")) {
      this.ticks = autoSkip(this, this.ticks);
      this._labelSizes = null;
      this.afterAutoSkip();
    }
    if (samplingEnabled) {
      this._convertTicksToLabels(this.ticks);
    }
    this.beforeFit();
    this.fit();
    this.afterFit();
    this.afterUpdate();
  }
  configure() {
    let reversePixels = this.options.reverse;
    let startPixel, endPixel;
    if (this.isHorizontal()) {
      startPixel = this.left;
      endPixel = this.right;
    } else {
      startPixel = this.top;
      endPixel = this.bottom;
      reversePixels = !reversePixels;
    }
    this._startPixel = startPixel;
    this._endPixel = endPixel;
    this._reversePixels = reversePixels;
    this._length = endPixel - startPixel;
    this._alignToPixels = this.options.alignToPixels;
  }
  afterUpdate() {
    callback(this.options.afterUpdate, [
      this
    ]);
  }
  beforeSetDimensions() {
    callback(this.options.beforeSetDimensions, [
      this
    ]);
  }
  setDimensions() {
    if (this.isHorizontal()) {
      this.width = this.maxWidth;
      this.left = 0;
      this.right = this.width;
    } else {
      this.height = this.maxHeight;
      this.top = 0;
      this.bottom = this.height;
    }
    this.paddingLeft = 0;
    this.paddingTop = 0;
    this.paddingRight = 0;
    this.paddingBottom = 0;
  }
  afterSetDimensions() {
    callback(this.options.afterSetDimensions, [
      this
    ]);
  }
  _callHooks(name) {
    this.chart.notifyPlugins(name, this.getContext());
    callback(this.options[name], [
      this
    ]);
  }
  beforeDataLimits() {
    this._callHooks("beforeDataLimits");
  }
  determineDataLimits() {
  }
  afterDataLimits() {
    this._callHooks("afterDataLimits");
  }
  beforeBuildTicks() {
    this._callHooks("beforeBuildTicks");
  }
  buildTicks() {
    return [];
  }
  afterBuildTicks() {
    this._callHooks("afterBuildTicks");
  }
  beforeTickToLabelConversion() {
    callback(this.options.beforeTickToLabelConversion, [
      this
    ]);
  }
  generateTickLabels(ticks) {
    const tickOpts = this.options.ticks;
    let i, ilen, tick2;
    for (i = 0, ilen = ticks.length; i < ilen; i++) {
      tick2 = ticks[i];
      tick2.label = callback(tickOpts.callback, [
        tick2.value,
        i,
        ticks
      ], this);
    }
  }
  afterTickToLabelConversion() {
    callback(this.options.afterTickToLabelConversion, [
      this
    ]);
  }
  beforeCalculateLabelRotation() {
    callback(this.options.beforeCalculateLabelRotation, [
      this
    ]);
  }
  calculateLabelRotation() {
    const options = this.options;
    const tickOpts = options.ticks;
    const numTicks = getTicksLimit(this.ticks.length, options.ticks.maxTicksLimit);
    const minRotation = tickOpts.minRotation || 0;
    const maxRotation = tickOpts.maxRotation;
    let labelRotation = minRotation;
    let tickWidth, maxHeight, maxLabelDiagonal;
    if (!this._isVisible() || !tickOpts.display || minRotation >= maxRotation || numTicks <= 1 || !this.isHorizontal()) {
      this.labelRotation = minRotation;
      return;
    }
    const labelSizes = this._getLabelSizes();
    const maxLabelWidth = labelSizes.widest.width;
    const maxLabelHeight = labelSizes.highest.height;
    const maxWidth = _limitValue(this.chart.width - maxLabelWidth, 0, this.maxWidth);
    tickWidth = options.offset ? this.maxWidth / numTicks : maxWidth / (numTicks - 1);
    if (maxLabelWidth + 6 > tickWidth) {
      tickWidth = maxWidth / (numTicks - (options.offset ? 0.5 : 1));
      maxHeight = this.maxHeight - getTickMarkLength(options.grid) - tickOpts.padding - getTitleHeight(options.title, this.chart.options.font);
      maxLabelDiagonal = Math.sqrt(maxLabelWidth * maxLabelWidth + maxLabelHeight * maxLabelHeight);
      labelRotation = toDegrees(Math.min(Math.asin(_limitValue((labelSizes.highest.height + 6) / tickWidth, -1, 1)), Math.asin(_limitValue(maxHeight / maxLabelDiagonal, -1, 1)) - Math.asin(_limitValue(maxLabelHeight / maxLabelDiagonal, -1, 1))));
      labelRotation = Math.max(minRotation, Math.min(maxRotation, labelRotation));
    }
    this.labelRotation = labelRotation;
  }
  afterCalculateLabelRotation() {
    callback(this.options.afterCalculateLabelRotation, [
      this
    ]);
  }
  afterAutoSkip() {
  }
  beforeFit() {
    callback(this.options.beforeFit, [
      this
    ]);
  }
  fit() {
    const minSize = {
      width: 0,
      height: 0
    };
    const { chart, options: { ticks: tickOpts, title: titleOpts, grid: gridOpts } } = this;
    const display = this._isVisible();
    const isHorizontal = this.isHorizontal();
    if (display) {
      const titleHeight = getTitleHeight(titleOpts, chart.options.font);
      if (isHorizontal) {
        minSize.width = this.maxWidth;
        minSize.height = getTickMarkLength(gridOpts) + titleHeight;
      } else {
        minSize.height = this.maxHeight;
        minSize.width = getTickMarkLength(gridOpts) + titleHeight;
      }
      if (tickOpts.display && this.ticks.length) {
        const { first, last, widest, highest } = this._getLabelSizes();
        const tickPadding = tickOpts.padding * 2;
        const angleRadians = toRadians(this.labelRotation);
        const cos = Math.cos(angleRadians);
        const sin = Math.sin(angleRadians);
        if (isHorizontal) {
          const labelHeight = tickOpts.mirror ? 0 : sin * widest.width + cos * highest.height;
          minSize.height = Math.min(this.maxHeight, minSize.height + labelHeight + tickPadding);
        } else {
          const labelWidth = tickOpts.mirror ? 0 : cos * widest.width + sin * highest.height;
          minSize.width = Math.min(this.maxWidth, minSize.width + labelWidth + tickPadding);
        }
        this._calculatePadding(first, last, sin, cos);
      }
    }
    this._handleMargins();
    if (isHorizontal) {
      this.width = this._length = chart.width - this._margins.left - this._margins.right;
      this.height = minSize.height;
    } else {
      this.width = minSize.width;
      this.height = this._length = chart.height - this._margins.top - this._margins.bottom;
    }
  }
  _calculatePadding(first, last, sin, cos) {
    const { ticks: { align, padding }, position: position2 } = this.options;
    const isRotated = this.labelRotation !== 0;
    const labelsBelowTicks = position2 !== "top" && this.axis === "x";
    if (this.isHorizontal()) {
      const offsetLeft = this.getPixelForTick(0) - this.left;
      const offsetRight = this.right - this.getPixelForTick(this.ticks.length - 1);
      let paddingLeft = 0;
      let paddingRight = 0;
      if (isRotated) {
        if (labelsBelowTicks) {
          paddingLeft = cos * first.width;
          paddingRight = sin * last.height;
        } else {
          paddingLeft = sin * first.height;
          paddingRight = cos * last.width;
        }
      } else if (align === "start") {
        paddingRight = last.width;
      } else if (align === "end") {
        paddingLeft = first.width;
      } else if (align !== "inner") {
        paddingLeft = first.width / 2;
        paddingRight = last.width / 2;
      }
      this.paddingLeft = Math.max((paddingLeft - offsetLeft + padding) * this.width / (this.width - offsetLeft), 0);
      this.paddingRight = Math.max((paddingRight - offsetRight + padding) * this.width / (this.width - offsetRight), 0);
    } else {
      let paddingTop = last.height / 2;
      let paddingBottom = first.height / 2;
      if (align === "start") {
        paddingTop = 0;
        paddingBottom = first.height;
      } else if (align === "end") {
        paddingTop = last.height;
        paddingBottom = 0;
      }
      this.paddingTop = paddingTop + padding;
      this.paddingBottom = paddingBottom + padding;
    }
  }
  _handleMargins() {
    if (this._margins) {
      this._margins.left = Math.max(this.paddingLeft, this._margins.left);
      this._margins.top = Math.max(this.paddingTop, this._margins.top);
      this._margins.right = Math.max(this.paddingRight, this._margins.right);
      this._margins.bottom = Math.max(this.paddingBottom, this._margins.bottom);
    }
  }
  afterFit() {
    callback(this.options.afterFit, [
      this
    ]);
  }
  isHorizontal() {
    const { axis, position: position2 } = this.options;
    return position2 === "top" || position2 === "bottom" || axis === "x";
  }
  isFullSize() {
    return this.options.fullSize;
  }
  _convertTicksToLabels(ticks) {
    this.beforeTickToLabelConversion();
    this.generateTickLabels(ticks);
    let i, ilen;
    for (i = 0, ilen = ticks.length; i < ilen; i++) {
      if (isNullOrUndef(ticks[i].label)) {
        ticks.splice(i, 1);
        ilen--;
        i--;
      }
    }
    this.afterTickToLabelConversion();
  }
  _getLabelSizes() {
    let labelSizes = this._labelSizes;
    if (!labelSizes) {
      const sampleSize = this.options.ticks.sampleSize;
      let ticks = this.ticks;
      if (sampleSize < ticks.length) {
        ticks = sample(ticks, sampleSize);
      }
      this._labelSizes = labelSizes = this._computeLabelSizes(ticks, ticks.length, this.options.ticks.maxTicksLimit);
    }
    return labelSizes;
  }
  _computeLabelSizes(ticks, length, maxTicksLimit) {
    const { ctx, _longestTextCache: caches } = this;
    const widths = [];
    const heights = [];
    const increment = Math.floor(length / getTicksLimit(length, maxTicksLimit));
    let widestLabelSize = 0;
    let highestLabelSize = 0;
    let i, j2, jlen, label, tickFont, fontString, cache, lineHeight, width, height, nestedLabel;
    for (i = 0; i < length; i += increment) {
      label = ticks[i].label;
      tickFont = this._resolveTickFontOptions(i);
      ctx.font = fontString = tickFont.string;
      cache = caches[fontString] = caches[fontString] || {
        data: {},
        gc: []
      };
      lineHeight = tickFont.lineHeight;
      width = height = 0;
      if (!isNullOrUndef(label) && !isArray(label)) {
        width = _measureText(ctx, cache.data, cache.gc, width, label);
        height = lineHeight;
      } else if (isArray(label)) {
        for (j2 = 0, jlen = label.length; j2 < jlen; ++j2) {
          nestedLabel = label[j2];
          if (!isNullOrUndef(nestedLabel) && !isArray(nestedLabel)) {
            width = _measureText(ctx, cache.data, cache.gc, width, nestedLabel);
            height += lineHeight;
          }
        }
      }
      widths.push(width);
      heights.push(height);
      widestLabelSize = Math.max(width, widestLabelSize);
      highestLabelSize = Math.max(height, highestLabelSize);
    }
    garbageCollect(caches, length);
    const widest = widths.indexOf(widestLabelSize);
    const highest = heights.indexOf(highestLabelSize);
    const valueAt = (idx) => ({
      width: widths[idx] || 0,
      height: heights[idx] || 0
    });
    return {
      first: valueAt(0),
      last: valueAt(length - 1),
      widest: valueAt(widest),
      highest: valueAt(highest),
      widths,
      heights
    };
  }
  getLabelForValue(value) {
    return value;
  }
  getPixelForValue(value, index) {
    return NaN;
  }
  getValueForPixel(pixel) {
  }
  getPixelForTick(index) {
    const ticks = this.ticks;
    if (index < 0 || index > ticks.length - 1) {
      return null;
    }
    return this.getPixelForValue(ticks[index].value);
  }
  getPixelForDecimal(decimal) {
    if (this._reversePixels) {
      decimal = 1 - decimal;
    }
    const pixel = this._startPixel + decimal * this._length;
    return _int16Range(this._alignToPixels ? _alignPixel(this.chart, pixel, 0) : pixel);
  }
  getDecimalForPixel(pixel) {
    const decimal = (pixel - this._startPixel) / this._length;
    return this._reversePixels ? 1 - decimal : decimal;
  }
  getBasePixel() {
    return this.getPixelForValue(this.getBaseValue());
  }
  getBaseValue() {
    const { min, max } = this;
    return min < 0 && max < 0 ? max : min > 0 && max > 0 ? min : 0;
  }
  getContext(index) {
    const ticks = this.ticks || [];
    if (index >= 0 && index < ticks.length) {
      const tick2 = ticks[index];
      return tick2.$context || (tick2.$context = createTickContext(this.getContext(), index, tick2));
    }
    return this.$context || (this.$context = createScaleContext(this.chart.getContext(), this));
  }
  _tickSize() {
    const optionTicks = this.options.ticks;
    const rot = toRadians(this.labelRotation);
    const cos = Math.abs(Math.cos(rot));
    const sin = Math.abs(Math.sin(rot));
    const labelSizes = this._getLabelSizes();
    const padding = optionTicks.autoSkipPadding || 0;
    const w2 = labelSizes ? labelSizes.widest.width + padding : 0;
    const h3 = labelSizes ? labelSizes.highest.height + padding : 0;
    return this.isHorizontal() ? h3 * cos > w2 * sin ? w2 / cos : h3 / sin : h3 * sin < w2 * cos ? h3 / cos : w2 / sin;
  }
  _isVisible() {
    const display = this.options.display;
    if (display !== "auto") {
      return !!display;
    }
    return this.getMatchingVisibleMetas().length > 0;
  }
  _computeGridLineItems(chartArea) {
    const axis = this.axis;
    const chart = this.chart;
    const options = this.options;
    const { grid, position: position2, border } = options;
    const offset = grid.offset;
    const isHorizontal = this.isHorizontal();
    const ticks = this.ticks;
    const ticksLength = ticks.length + (offset ? 1 : 0);
    const tl = getTickMarkLength(grid);
    const items = [];
    const borderOpts = border.setContext(this.getContext());
    const axisWidth = borderOpts.display ? borderOpts.width : 0;
    const axisHalfWidth = axisWidth / 2;
    const alignBorderValue = function(pixel) {
      return _alignPixel(chart, pixel, axisWidth);
    };
    let borderValue, i, lineValue, alignedLineValue;
    let tx1, ty1, tx2, ty2, x1, y1, x2, y2;
    if (position2 === "top") {
      borderValue = alignBorderValue(this.bottom);
      ty1 = this.bottom - tl;
      ty2 = borderValue - axisHalfWidth;
      y1 = alignBorderValue(chartArea.top) + axisHalfWidth;
      y2 = chartArea.bottom;
    } else if (position2 === "bottom") {
      borderValue = alignBorderValue(this.top);
      y1 = chartArea.top;
      y2 = alignBorderValue(chartArea.bottom) - axisHalfWidth;
      ty1 = borderValue + axisHalfWidth;
      ty2 = this.top + tl;
    } else if (position2 === "left") {
      borderValue = alignBorderValue(this.right);
      tx1 = this.right - tl;
      tx2 = borderValue - axisHalfWidth;
      x1 = alignBorderValue(chartArea.left) + axisHalfWidth;
      x2 = chartArea.right;
    } else if (position2 === "right") {
      borderValue = alignBorderValue(this.left);
      x1 = chartArea.left;
      x2 = alignBorderValue(chartArea.right) - axisHalfWidth;
      tx1 = borderValue + axisHalfWidth;
      tx2 = this.left + tl;
    } else if (axis === "x") {
      if (position2 === "center") {
        borderValue = alignBorderValue((chartArea.top + chartArea.bottom) / 2 + 0.5);
      } else if (isObject(position2)) {
        const positionAxisID = Object.keys(position2)[0];
        const value = position2[positionAxisID];
        borderValue = alignBorderValue(this.chart.scales[positionAxisID].getPixelForValue(value));
      }
      y1 = chartArea.top;
      y2 = chartArea.bottom;
      ty1 = borderValue + axisHalfWidth;
      ty2 = ty1 + tl;
    } else if (axis === "y") {
      if (position2 === "center") {
        borderValue = alignBorderValue((chartArea.left + chartArea.right) / 2);
      } else if (isObject(position2)) {
        const positionAxisID = Object.keys(position2)[0];
        const value = position2[positionAxisID];
        borderValue = alignBorderValue(this.chart.scales[positionAxisID].getPixelForValue(value));
      }
      tx1 = borderValue - axisHalfWidth;
      tx2 = tx1 - tl;
      x1 = chartArea.left;
      x2 = chartArea.right;
    }
    const limit = valueOrDefault(options.ticks.maxTicksLimit, ticksLength);
    const step = Math.max(1, Math.ceil(ticksLength / limit));
    for (i = 0; i < ticksLength; i += step) {
      const context = this.getContext(i);
      const optsAtIndex = grid.setContext(context);
      const optsAtIndexBorder = border.setContext(context);
      const lineWidth = optsAtIndex.lineWidth;
      const lineColor = optsAtIndex.color;
      const borderDash = optsAtIndexBorder.dash || [];
      const borderDashOffset = optsAtIndexBorder.dashOffset;
      const tickWidth = optsAtIndex.tickWidth;
      const tickColor = optsAtIndex.tickColor;
      const tickBorderDash = optsAtIndex.tickBorderDash || [];
      const tickBorderDashOffset = optsAtIndex.tickBorderDashOffset;
      lineValue = getPixelForGridLine(this, i, offset);
      if (lineValue === void 0) {
        continue;
      }
      alignedLineValue = _alignPixel(chart, lineValue, lineWidth);
      if (isHorizontal) {
        tx1 = tx2 = x1 = x2 = alignedLineValue;
      } else {
        ty1 = ty2 = y1 = y2 = alignedLineValue;
      }
      items.push({
        tx1,
        ty1,
        tx2,
        ty2,
        x1,
        y1,
        x2,
        y2,
        width: lineWidth,
        color: lineColor,
        borderDash,
        borderDashOffset,
        tickWidth,
        tickColor,
        tickBorderDash,
        tickBorderDashOffset
      });
    }
    this._ticksLength = ticksLength;
    this._borderValue = borderValue;
    return items;
  }
  _computeLabelItems(chartArea) {
    const axis = this.axis;
    const options = this.options;
    const { position: position2, ticks: optionTicks } = options;
    const isHorizontal = this.isHorizontal();
    const ticks = this.ticks;
    const { align, crossAlign, padding, mirror } = optionTicks;
    const tl = getTickMarkLength(options.grid);
    const tickAndPadding = tl + padding;
    const hTickAndPadding = mirror ? -padding : tickAndPadding;
    const rotation = -toRadians(this.labelRotation);
    const items = [];
    let i, ilen, tick2, label, x2, y2, textAlign, pixel, font, lineHeight, lineCount, textOffset;
    let textBaseline = "middle";
    if (position2 === "top") {
      y2 = this.bottom - hTickAndPadding;
      textAlign = this._getXAxisLabelAlignment();
    } else if (position2 === "bottom") {
      y2 = this.top + hTickAndPadding;
      textAlign = this._getXAxisLabelAlignment();
    } else if (position2 === "left") {
      const ret = this._getYAxisLabelAlignment(tl);
      textAlign = ret.textAlign;
      x2 = ret.x;
    } else if (position2 === "right") {
      const ret = this._getYAxisLabelAlignment(tl);
      textAlign = ret.textAlign;
      x2 = ret.x;
    } else if (axis === "x") {
      if (position2 === "center") {
        y2 = (chartArea.top + chartArea.bottom) / 2 + tickAndPadding;
      } else if (isObject(position2)) {
        const positionAxisID = Object.keys(position2)[0];
        const value = position2[positionAxisID];
        y2 = this.chart.scales[positionAxisID].getPixelForValue(value) + tickAndPadding;
      }
      textAlign = this._getXAxisLabelAlignment();
    } else if (axis === "y") {
      if (position2 === "center") {
        x2 = (chartArea.left + chartArea.right) / 2 - tickAndPadding;
      } else if (isObject(position2)) {
        const positionAxisID = Object.keys(position2)[0];
        const value = position2[positionAxisID];
        x2 = this.chart.scales[positionAxisID].getPixelForValue(value);
      }
      textAlign = this._getYAxisLabelAlignment(tl).textAlign;
    }
    if (axis === "y") {
      if (align === "start") {
        textBaseline = "top";
      } else if (align === "end") {
        textBaseline = "bottom";
      }
    }
    const labelSizes = this._getLabelSizes();
    for (i = 0, ilen = ticks.length; i < ilen; ++i) {
      tick2 = ticks[i];
      label = tick2.label;
      const optsAtIndex = optionTicks.setContext(this.getContext(i));
      pixel = this.getPixelForTick(i) + optionTicks.labelOffset;
      font = this._resolveTickFontOptions(i);
      lineHeight = font.lineHeight;
      lineCount = isArray(label) ? label.length : 1;
      const halfCount = lineCount / 2;
      const color2 = optsAtIndex.color;
      const strokeColor = optsAtIndex.textStrokeColor;
      const strokeWidth = optsAtIndex.textStrokeWidth;
      let tickTextAlign = textAlign;
      if (isHorizontal) {
        x2 = pixel;
        if (textAlign === "inner") {
          if (i === ilen - 1) {
            tickTextAlign = !this.options.reverse ? "right" : "left";
          } else if (i === 0) {
            tickTextAlign = !this.options.reverse ? "left" : "right";
          } else {
            tickTextAlign = "center";
          }
        }
        if (position2 === "top") {
          if (crossAlign === "near" || rotation !== 0) {
            textOffset = -lineCount * lineHeight + lineHeight / 2;
          } else if (crossAlign === "center") {
            textOffset = -labelSizes.highest.height / 2 - halfCount * lineHeight + lineHeight;
          } else {
            textOffset = -labelSizes.highest.height + lineHeight / 2;
          }
        } else {
          if (crossAlign === "near" || rotation !== 0) {
            textOffset = lineHeight / 2;
          } else if (crossAlign === "center") {
            textOffset = labelSizes.highest.height / 2 - halfCount * lineHeight;
          } else {
            textOffset = labelSizes.highest.height - lineCount * lineHeight;
          }
        }
        if (mirror) {
          textOffset *= -1;
        }
        if (rotation !== 0 && !optsAtIndex.showLabelBackdrop) {
          x2 += lineHeight / 2 * Math.sin(rotation);
        }
      } else {
        y2 = pixel;
        textOffset = (1 - lineCount) * lineHeight / 2;
      }
      let backdrop;
      if (optsAtIndex.showLabelBackdrop) {
        const labelPadding = toPadding(optsAtIndex.backdropPadding);
        const height = labelSizes.heights[i];
        const width = labelSizes.widths[i];
        let top = textOffset - labelPadding.top;
        let left = 0 - labelPadding.left;
        switch (textBaseline) {
          case "middle":
            top -= height / 2;
            break;
          case "bottom":
            top -= height;
            break;
        }
        switch (textAlign) {
          case "center":
            left -= width / 2;
            break;
          case "right":
            left -= width;
            break;
        }
        backdrop = {
          left,
          top,
          width: width + labelPadding.width,
          height: height + labelPadding.height,
          color: optsAtIndex.backdropColor
        };
      }
      items.push({
        label,
        font,
        textOffset,
        options: {
          rotation,
          color: color2,
          strokeColor,
          strokeWidth,
          textAlign: tickTextAlign,
          textBaseline,
          translation: [
            x2,
            y2
          ],
          backdrop
        }
      });
    }
    return items;
  }
  _getXAxisLabelAlignment() {
    const { position: position2, ticks } = this.options;
    const rotation = -toRadians(this.labelRotation);
    if (rotation) {
      return position2 === "top" ? "left" : "right";
    }
    let align = "center";
    if (ticks.align === "start") {
      align = "left";
    } else if (ticks.align === "end") {
      align = "right";
    } else if (ticks.align === "inner") {
      align = "inner";
    }
    return align;
  }
  _getYAxisLabelAlignment(tl) {
    const { position: position2, ticks: { crossAlign, mirror, padding } } = this.options;
    const labelSizes = this._getLabelSizes();
    const tickAndPadding = tl + padding;
    const widest = labelSizes.widest.width;
    let textAlign;
    let x2;
    if (position2 === "left") {
      if (mirror) {
        x2 = this.right + padding;
        if (crossAlign === "near") {
          textAlign = "left";
        } else if (crossAlign === "center") {
          textAlign = "center";
          x2 += widest / 2;
        } else {
          textAlign = "right";
          x2 += widest;
        }
      } else {
        x2 = this.right - tickAndPadding;
        if (crossAlign === "near") {
          textAlign = "right";
        } else if (crossAlign === "center") {
          textAlign = "center";
          x2 -= widest / 2;
        } else {
          textAlign = "left";
          x2 = this.left;
        }
      }
    } else if (position2 === "right") {
      if (mirror) {
        x2 = this.left + padding;
        if (crossAlign === "near") {
          textAlign = "right";
        } else if (crossAlign === "center") {
          textAlign = "center";
          x2 -= widest / 2;
        } else {
          textAlign = "left";
          x2 -= widest;
        }
      } else {
        x2 = this.left + tickAndPadding;
        if (crossAlign === "near") {
          textAlign = "left";
        } else if (crossAlign === "center") {
          textAlign = "center";
          x2 += widest / 2;
        } else {
          textAlign = "right";
          x2 = this.right;
        }
      }
    } else {
      textAlign = "right";
    }
    return {
      textAlign,
      x: x2
    };
  }
  _computeLabelArea() {
    if (this.options.ticks.mirror) {
      return;
    }
    const chart = this.chart;
    const position2 = this.options.position;
    if (position2 === "left" || position2 === "right") {
      return {
        top: 0,
        left: this.left,
        bottom: chart.height,
        right: this.right
      };
    }
    if (position2 === "top" || position2 === "bottom") {
      return {
        top: this.top,
        left: 0,
        bottom: this.bottom,
        right: chart.width
      };
    }
  }
  drawBackground() {
    const { ctx, options: { backgroundColor }, left, top, width, height } = this;
    if (backgroundColor) {
      ctx.save();
      ctx.fillStyle = backgroundColor;
      ctx.fillRect(left, top, width, height);
      ctx.restore();
    }
  }
  getLineWidthForValue(value) {
    const grid = this.options.grid;
    if (!this._isVisible() || !grid.display) {
      return 0;
    }
    const ticks = this.ticks;
    const index = ticks.findIndex((t) => t.value === value);
    if (index >= 0) {
      const opts = grid.setContext(this.getContext(index));
      return opts.lineWidth;
    }
    return 0;
  }
  drawGrid(chartArea) {
    const grid = this.options.grid;
    const ctx = this.ctx;
    const items = this._gridLineItems || (this._gridLineItems = this._computeGridLineItems(chartArea));
    let i, ilen;
    const drawLine = (p1, p2, style) => {
      if (!style.width || !style.color) {
        return;
      }
      ctx.save();
      ctx.lineWidth = style.width;
      ctx.strokeStyle = style.color;
      ctx.setLineDash(style.borderDash || []);
      ctx.lineDashOffset = style.borderDashOffset;
      ctx.beginPath();
      ctx.moveTo(p1.x, p1.y);
      ctx.lineTo(p2.x, p2.y);
      ctx.stroke();
      ctx.restore();
    };
    if (grid.display) {
      for (i = 0, ilen = items.length; i < ilen; ++i) {
        const item = items[i];
        if (grid.drawOnChartArea) {
          drawLine({
            x: item.x1,
            y: item.y1
          }, {
            x: item.x2,
            y: item.y2
          }, item);
        }
        if (grid.drawTicks) {
          drawLine({
            x: item.tx1,
            y: item.ty1
          }, {
            x: item.tx2,
            y: item.ty2
          }, {
            color: item.tickColor,
            width: item.tickWidth,
            borderDash: item.tickBorderDash,
            borderDashOffset: item.tickBorderDashOffset
          });
        }
      }
    }
  }
  drawBorder() {
    const { chart, ctx, options: { border, grid } } = this;
    const borderOpts = border.setContext(this.getContext());
    const axisWidth = border.display ? borderOpts.width : 0;
    if (!axisWidth) {
      return;
    }
    const lastLineWidth = grid.setContext(this.getContext(0)).lineWidth;
    const borderValue = this._borderValue;
    let x1, x2, y1, y2;
    if (this.isHorizontal()) {
      x1 = _alignPixel(chart, this.left, axisWidth) - axisWidth / 2;
      x2 = _alignPixel(chart, this.right, lastLineWidth) + lastLineWidth / 2;
      y1 = y2 = borderValue;
    } else {
      y1 = _alignPixel(chart, this.top, axisWidth) - axisWidth / 2;
      y2 = _alignPixel(chart, this.bottom, lastLineWidth) + lastLineWidth / 2;
      x1 = x2 = borderValue;
    }
    ctx.save();
    ctx.lineWidth = borderOpts.width;
    ctx.strokeStyle = borderOpts.color;
    ctx.beginPath();
    ctx.moveTo(x1, y1);
    ctx.lineTo(x2, y2);
    ctx.stroke();
    ctx.restore();
  }
  drawLabels(chartArea) {
    const optionTicks = this.options.ticks;
    if (!optionTicks.display) {
      return;
    }
    const ctx = this.ctx;
    const area = this._computeLabelArea();
    if (area) {
      clipArea(ctx, area);
    }
    const items = this.getLabelItems(chartArea);
    for (const item of items) {
      const renderTextOptions = item.options;
      const tickFont = item.font;
      const label = item.label;
      const y2 = item.textOffset;
      renderText(ctx, label, 0, y2, tickFont, renderTextOptions);
    }
    if (area) {
      unclipArea(ctx);
    }
  }
  drawTitle() {
    const { ctx, options: { position: position2, title: title2, reverse } } = this;
    if (!title2.display) {
      return;
    }
    const font = toFont(title2.font);
    const padding = toPadding(title2.padding);
    const align = title2.align;
    let offset = font.lineHeight / 2;
    if (position2 === "bottom" || position2 === "center" || isObject(position2)) {
      offset += padding.bottom;
      if (isArray(title2.text)) {
        offset += font.lineHeight * (title2.text.length - 1);
      }
    } else {
      offset += padding.top;
    }
    const { titleX, titleY, maxWidth, rotation } = titleArgs(this, offset, position2, align);
    renderText(ctx, title2.text, 0, 0, font, {
      color: title2.color,
      maxWidth,
      rotation,
      textAlign: titleAlign(align, position2, reverse),
      textBaseline: "middle",
      translation: [
        titleX,
        titleY
      ]
    });
  }
  draw(chartArea) {
    if (!this._isVisible()) {
      return;
    }
    this.drawBackground();
    this.drawGrid(chartArea);
    this.drawBorder();
    this.drawTitle();
    this.drawLabels(chartArea);
  }
  _layers() {
    const opts = this.options;
    const tz = opts.ticks && opts.ticks.z || 0;
    const gz = valueOrDefault(opts.grid && opts.grid.z, -1);
    const bz = valueOrDefault(opts.border && opts.border.z, 0);
    if (!this._isVisible() || this.draw !== Scale.prototype.draw) {
      return [
        {
          z: tz,
          draw: (chartArea) => {
            this.draw(chartArea);
          }
        }
      ];
    }
    return [
      {
        z: gz,
        draw: (chartArea) => {
          this.drawBackground();
          this.drawGrid(chartArea);
          this.drawTitle();
        }
      },
      {
        z: bz,
        draw: () => {
          this.drawBorder();
        }
      },
      {
        z: tz,
        draw: (chartArea) => {
          this.drawLabels(chartArea);
        }
      }
    ];
  }
  getMatchingVisibleMetas(type) {
    const metas = this.chart.getSortedVisibleDatasetMetas();
    const axisID = this.axis + "AxisID";
    const result = [];
    let i, ilen;
    for (i = 0, ilen = metas.length; i < ilen; ++i) {
      const meta = metas[i];
      if (meta[axisID] === this.id && (!type || meta.type === type)) {
        result.push(meta);
      }
    }
    return result;
  }
  _resolveTickFontOptions(index) {
    const opts = this.options.ticks.setContext(this.getContext(index));
    return toFont(opts.font);
  }
  _maxDigits() {
    const fontSize = this._resolveTickFontOptions(0).lineHeight;
    return (this.isHorizontal() ? this.width : this.height) / fontSize;
  }
}
class TypedRegistry {
  constructor(type, scope, override) {
    this.type = type;
    this.scope = scope;
    this.override = override;
    this.items = /* @__PURE__ */ Object.create(null);
  }
  isForType(type) {
    return Object.prototype.isPrototypeOf.call(this.type.prototype, type.prototype);
  }
  register(item) {
    const proto = Object.getPrototypeOf(item);
    let parentScope;
    if (isIChartComponent(proto)) {
      parentScope = this.register(proto);
    }
    const items = this.items;
    const id = item.id;
    const scope = this.scope + "." + id;
    if (!id) {
      throw new Error("class does not have id: " + item);
    }
    if (id in items) {
      return scope;
    }
    items[id] = item;
    registerDefaults(item, scope, parentScope);
    if (this.override) {
      defaults.override(item.id, item.overrides);
    }
    return scope;
  }
  get(id) {
    return this.items[id];
  }
  unregister(item) {
    const items = this.items;
    const id = item.id;
    const scope = this.scope;
    if (id in items) {
      delete items[id];
    }
    if (scope && id in defaults[scope]) {
      delete defaults[scope][id];
      if (this.override) {
        delete overrides[id];
      }
    }
  }
}
function registerDefaults(item, scope, parentScope) {
  const itemDefaults = merge(/* @__PURE__ */ Object.create(null), [
    parentScope ? defaults.get(parentScope) : {},
    defaults.get(scope),
    item.defaults
  ]);
  defaults.set(scope, itemDefaults);
  if (item.defaultRoutes) {
    routeDefaults(scope, item.defaultRoutes);
  }
  if (item.descriptors) {
    defaults.describe(scope, item.descriptors);
  }
}
function routeDefaults(scope, routes) {
  Object.keys(routes).forEach((property) => {
    const propertyParts = property.split(".");
    const sourceName = propertyParts.pop();
    const sourceScope = [
      scope
    ].concat(propertyParts).join(".");
    const parts = routes[property].split(".");
    const targetName = parts.pop();
    const targetScope = parts.join(".");
    defaults.route(sourceScope, sourceName, targetScope, targetName);
  });
}
function isIChartComponent(proto) {
  return "id" in proto && "defaults" in proto;
}
class Registry {
  constructor() {
    this.controllers = new TypedRegistry(DatasetController, "datasets", true);
    this.elements = new TypedRegistry(Element, "elements");
    this.plugins = new TypedRegistry(Object, "plugins");
    this.scales = new TypedRegistry(Scale, "scales");
    this._typedRegistries = [
      this.controllers,
      this.scales,
      this.elements
    ];
  }
  add(...args) {
    this._each("register", args);
  }
  remove(...args) {
    this._each("unregister", args);
  }
  addControllers(...args) {
    this._each("register", args, this.controllers);
  }
  addElements(...args) {
    this._each("register", args, this.elements);
  }
  addPlugins(...args) {
    this._each("register", args, this.plugins);
  }
  addScales(...args) {
    this._each("register", args, this.scales);
  }
  getController(id) {
    return this._get(id, this.controllers, "controller");
  }
  getElement(id) {
    return this._get(id, this.elements, "element");
  }
  getPlugin(id) {
    return this._get(id, this.plugins, "plugin");
  }
  getScale(id) {
    return this._get(id, this.scales, "scale");
  }
  removeControllers(...args) {
    this._each("unregister", args, this.controllers);
  }
  removeElements(...args) {
    this._each("unregister", args, this.elements);
  }
  removePlugins(...args) {
    this._each("unregister", args, this.plugins);
  }
  removeScales(...args) {
    this._each("unregister", args, this.scales);
  }
  _each(method, args, typedRegistry) {
    [
      ...args
    ].forEach((arg) => {
      const reg = typedRegistry || this._getRegistryForType(arg);
      if (typedRegistry || reg.isForType(arg) || reg === this.plugins && arg.id) {
        this._exec(method, reg, arg);
      } else {
        each(arg, (item) => {
          const itemReg = typedRegistry || this._getRegistryForType(item);
          this._exec(method, itemReg, item);
        });
      }
    });
  }
  _exec(method, registry2, component) {
    const camelMethod = _capitalize(method);
    callback(component["before" + camelMethod], [], component);
    registry2[method](component);
    callback(component["after" + camelMethod], [], component);
  }
  _getRegistryForType(type) {
    for (let i = 0; i < this._typedRegistries.length; i++) {
      const reg = this._typedRegistries[i];
      if (reg.isForType(type)) {
        return reg;
      }
    }
    return this.plugins;
  }
  _get(id, typedRegistry, type) {
    const item = typedRegistry.get(id);
    if (item === void 0) {
      throw new Error('"' + id + '" is not a registered ' + type + ".");
    }
    return item;
  }
}
var registry = /* @__PURE__ */ new Registry();
class PluginService {
  constructor() {
    this._init = [];
  }
  notify(chart, hook, args, filter) {
    if (hook === "beforeInit") {
      this._init = this._createDescriptors(chart, true);
      this._notify(this._init, chart, "install");
    }
    const descriptors2 = filter ? this._descriptors(chart).filter(filter) : this._descriptors(chart);
    const result = this._notify(descriptors2, chart, hook, args);
    if (hook === "afterDestroy") {
      this._notify(descriptors2, chart, "stop");
      this._notify(this._init, chart, "uninstall");
    }
    return result;
  }
  _notify(descriptors2, chart, hook, args) {
    args = args || {};
    for (const descriptor of descriptors2) {
      const plugin = descriptor.plugin;
      const method = plugin[hook];
      const params = [
        chart,
        args,
        descriptor.options
      ];
      if (callback(method, params, plugin) === false && args.cancelable) {
        return false;
      }
    }
    return true;
  }
  invalidate() {
    if (!isNullOrUndef(this._cache)) {
      this._oldCache = this._cache;
      this._cache = void 0;
    }
  }
  _descriptors(chart) {
    if (this._cache) {
      return this._cache;
    }
    const descriptors2 = this._cache = this._createDescriptors(chart);
    this._notifyStateChanges(chart);
    return descriptors2;
  }
  _createDescriptors(chart, all) {
    const config = chart && chart.config;
    const options = valueOrDefault(config.options && config.options.plugins, {});
    const plugins = allPlugins(config);
    return options === false && !all ? [] : createDescriptors(chart, plugins, options, all);
  }
  _notifyStateChanges(chart) {
    const previousDescriptors = this._oldCache || [];
    const descriptors2 = this._cache;
    const diff = (a2, b2) => a2.filter((x2) => !b2.some((y2) => x2.plugin.id === y2.plugin.id));
    this._notify(diff(previousDescriptors, descriptors2), chart, "stop");
    this._notify(diff(descriptors2, previousDescriptors), chart, "start");
  }
}
function allPlugins(config) {
  const localIds = {};
  const plugins = [];
  const keys = Object.keys(registry.plugins.items);
  for (let i = 0; i < keys.length; i++) {
    plugins.push(registry.getPlugin(keys[i]));
  }
  const local = config.plugins || [];
  for (let i = 0; i < local.length; i++) {
    const plugin = local[i];
    if (plugins.indexOf(plugin) === -1) {
      plugins.push(plugin);
      localIds[plugin.id] = true;
    }
  }
  return {
    plugins,
    localIds
  };
}
function getOpts(options, all) {
  if (!all && options === false) {
    return null;
  }
  if (options === true) {
    return {};
  }
  return options;
}
function createDescriptors(chart, { plugins, localIds }, options, all) {
  const result = [];
  const context = chart.getContext();
  for (const plugin of plugins) {
    const id = plugin.id;
    const opts = getOpts(options[id], all);
    if (opts === null) {
      continue;
    }
    result.push({
      plugin,
      options: pluginOpts(chart.config, {
        plugin,
        local: localIds[id]
      }, opts, context)
    });
  }
  return result;
}
function pluginOpts(config, { plugin, local }, opts, context) {
  const keys = config.pluginScopeKeys(plugin);
  const scopes = config.getOptionScopes(opts, keys);
  if (local && plugin.defaults) {
    scopes.push(plugin.defaults);
  }
  return config.createResolver(scopes, context, [
    ""
  ], {
    scriptable: false,
    indexable: false,
    allKeys: true
  });
}
function getIndexAxis(type, options) {
  const datasetDefaults = defaults.datasets[type] || {};
  const datasetOptions = (options.datasets || {})[type] || {};
  return datasetOptions.indexAxis || options.indexAxis || datasetDefaults.indexAxis || "x";
}
function getAxisFromDefaultScaleID(id, indexAxis) {
  let axis = id;
  if (id === "_index_") {
    axis = indexAxis;
  } else if (id === "_value_") {
    axis = indexAxis === "x" ? "y" : "x";
  }
  return axis;
}
function getDefaultScaleIDFromAxis(axis, indexAxis) {
  return axis === indexAxis ? "_index_" : "_value_";
}
function idMatchesAxis(id) {
  if (id === "x" || id === "y" || id === "r") {
    return id;
  }
}
function axisFromPosition(position2) {
  if (position2 === "top" || position2 === "bottom") {
    return "x";
  }
  if (position2 === "left" || position2 === "right") {
    return "y";
  }
}
function determineAxis(id, ...scaleOptions) {
  if (idMatchesAxis(id)) {
    return id;
  }
  for (const opts of scaleOptions) {
    const axis = opts.axis || axisFromPosition(opts.position) || id.length > 1 && idMatchesAxis(id[0].toLowerCase());
    if (axis) {
      return axis;
    }
  }
  throw new Error(`Cannot determine type of '${id}' axis. Please provide 'axis' or 'position' option.`);
}
function getAxisFromDataset(id, axis, dataset) {
  if (dataset[axis + "AxisID"] === id) {
    return {
      axis
    };
  }
}
function retrieveAxisFromDatasets(id, config) {
  if (config.data && config.data.datasets) {
    const boundDs = config.data.datasets.filter((d2) => d2.xAxisID === id || d2.yAxisID === id);
    if (boundDs.length) {
      return getAxisFromDataset(id, "x", boundDs[0]) || getAxisFromDataset(id, "y", boundDs[0]);
    }
  }
  return {};
}
function mergeScaleConfig(config, options) {
  const chartDefaults = overrides[config.type] || {
    scales: {}
  };
  const configScales = options.scales || {};
  const chartIndexAxis = getIndexAxis(config.type, options);
  const scales = /* @__PURE__ */ Object.create(null);
  Object.keys(configScales).forEach((id) => {
    const scaleConf = configScales[id];
    if (!isObject(scaleConf)) {
      return console.error(`Invalid scale configuration for scale: ${id}`);
    }
    if (scaleConf._proxy) {
      return console.warn(`Ignoring resolver passed as options for scale: ${id}`);
    }
    const axis = determineAxis(id, scaleConf, retrieveAxisFromDatasets(id, config), defaults.scales[scaleConf.type]);
    const defaultId = getDefaultScaleIDFromAxis(axis, chartIndexAxis);
    const defaultScaleOptions = chartDefaults.scales || {};
    scales[id] = mergeIf(/* @__PURE__ */ Object.create(null), [
      {
        axis
      },
      scaleConf,
      defaultScaleOptions[axis],
      defaultScaleOptions[defaultId]
    ]);
  });
  config.data.datasets.forEach((dataset) => {
    const type = dataset.type || config.type;
    const indexAxis = dataset.indexAxis || getIndexAxis(type, options);
    const datasetDefaults = overrides[type] || {};
    const defaultScaleOptions = datasetDefaults.scales || {};
    Object.keys(defaultScaleOptions).forEach((defaultID) => {
      const axis = getAxisFromDefaultScaleID(defaultID, indexAxis);
      const id = dataset[axis + "AxisID"] || axis;
      scales[id] = scales[id] || /* @__PURE__ */ Object.create(null);
      mergeIf(scales[id], [
        {
          axis
        },
        configScales[id],
        defaultScaleOptions[defaultID]
      ]);
    });
  });
  Object.keys(scales).forEach((key) => {
    const scale = scales[key];
    mergeIf(scale, [
      defaults.scales[scale.type],
      defaults.scale
    ]);
  });
  return scales;
}
function initOptions(config) {
  const options = config.options || (config.options = {});
  options.plugins = valueOrDefault(options.plugins, {});
  options.scales = mergeScaleConfig(config, options);
}
function initData(data) {
  data = data || {};
  data.datasets = data.datasets || [];
  data.labels = data.labels || [];
  return data;
}
function initConfig(config) {
  config = config || {};
  config.data = initData(config.data);
  initOptions(config);
  return config;
}
const keyCache = /* @__PURE__ */ new Map();
const keysCached = /* @__PURE__ */ new Set();
function cachedKeys(cacheKey, generate) {
  let keys = keyCache.get(cacheKey);
  if (!keys) {
    keys = generate();
    keyCache.set(cacheKey, keys);
    keysCached.add(keys);
  }
  return keys;
}
const addIfFound = (set2, obj, key) => {
  const opts = resolveObjectKey(obj, key);
  if (opts !== void 0) {
    set2.add(opts);
  }
};
class Config {
  constructor(config) {
    this._config = initConfig(config);
    this._scopeCache = /* @__PURE__ */ new Map();
    this._resolverCache = /* @__PURE__ */ new Map();
  }
  get platform() {
    return this._config.platform;
  }
  get type() {
    return this._config.type;
  }
  set type(type) {
    this._config.type = type;
  }
  get data() {
    return this._config.data;
  }
  set data(data) {
    this._config.data = initData(data);
  }
  get options() {
    return this._config.options;
  }
  set options(options) {
    this._config.options = options;
  }
  get plugins() {
    return this._config.plugins;
  }
  update() {
    const config = this._config;
    this.clearCache();
    initOptions(config);
  }
  clearCache() {
    this._scopeCache.clear();
    this._resolverCache.clear();
  }
  datasetScopeKeys(datasetType) {
    return cachedKeys(datasetType, () => [
      [
        `datasets.${datasetType}`,
        ""
      ]
    ]);
  }
  datasetAnimationScopeKeys(datasetType, transition) {
    return cachedKeys(`${datasetType}.transition.${transition}`, () => [
      [
        `datasets.${datasetType}.transitions.${transition}`,
        `transitions.${transition}`
      ],
      [
        `datasets.${datasetType}`,
        ""
      ]
    ]);
  }
  datasetElementScopeKeys(datasetType, elementType) {
    return cachedKeys(`${datasetType}-${elementType}`, () => [
      [
        `datasets.${datasetType}.elements.${elementType}`,
        `datasets.${datasetType}`,
        `elements.${elementType}`,
        ""
      ]
    ]);
  }
  pluginScopeKeys(plugin) {
    const id = plugin.id;
    const type = this.type;
    return cachedKeys(`${type}-plugin-${id}`, () => [
      [
        `plugins.${id}`,
        ...plugin.additionalOptionScopes || []
      ]
    ]);
  }
  _cachedScopes(mainScope, resetCache) {
    const _scopeCache = this._scopeCache;
    let cache = _scopeCache.get(mainScope);
    if (!cache || resetCache) {
      cache = /* @__PURE__ */ new Map();
      _scopeCache.set(mainScope, cache);
    }
    return cache;
  }
  getOptionScopes(mainScope, keyLists, resetCache) {
    const { options, type } = this;
    const cache = this._cachedScopes(mainScope, resetCache);
    const cached = cache.get(keyLists);
    if (cached) {
      return cached;
    }
    const scopes = /* @__PURE__ */ new Set();
    keyLists.forEach((keys) => {
      if (mainScope) {
        scopes.add(mainScope);
        keys.forEach((key) => addIfFound(scopes, mainScope, key));
      }
      keys.forEach((key) => addIfFound(scopes, options, key));
      keys.forEach((key) => addIfFound(scopes, overrides[type] || {}, key));
      keys.forEach((key) => addIfFound(scopes, defaults, key));
      keys.forEach((key) => addIfFound(scopes, descriptors, key));
    });
    const array = Array.from(scopes);
    if (array.length === 0) {
      array.push(/* @__PURE__ */ Object.create(null));
    }
    if (keysCached.has(keyLists)) {
      cache.set(keyLists, array);
    }
    return array;
  }
  chartOptionScopes() {
    const { options, type } = this;
    return [
      options,
      overrides[type] || {},
      defaults.datasets[type] || {},
      {
        type
      },
      defaults,
      descriptors
    ];
  }
  resolveNamedOptions(scopes, names2, context, prefixes = [
    ""
  ]) {
    const result = {
      $shared: true
    };
    const { resolver, subPrefixes } = getResolver(this._resolverCache, scopes, prefixes);
    let options = resolver;
    if (needContext(resolver, names2)) {
      result.$shared = false;
      context = isFunction(context) ? context() : context;
      const subResolver = this.createResolver(scopes, context, subPrefixes);
      options = _attachContext(resolver, context, subResolver);
    }
    for (const prop of names2) {
      result[prop] = options[prop];
    }
    return result;
  }
  createResolver(scopes, context, prefixes = [
    ""
  ], descriptorDefaults) {
    const { resolver } = getResolver(this._resolverCache, scopes, prefixes);
    return isObject(context) ? _attachContext(resolver, context, void 0, descriptorDefaults) : resolver;
  }
}
function getResolver(resolverCache, scopes, prefixes) {
  let cache = resolverCache.get(scopes);
  if (!cache) {
    cache = /* @__PURE__ */ new Map();
    resolverCache.set(scopes, cache);
  }
  const cacheKey = prefixes.join();
  let cached = cache.get(cacheKey);
  if (!cached) {
    const resolver = _createResolver(scopes, prefixes);
    cached = {
      resolver,
      subPrefixes: prefixes.filter((p2) => !p2.toLowerCase().includes("hover"))
    };
    cache.set(cacheKey, cached);
  }
  return cached;
}
const hasFunction = (value) => isObject(value) && Object.getOwnPropertyNames(value).reduce((acc, key) => acc || isFunction(value[key]), false);
function needContext(proxy, names2) {
  const { isScriptable, isIndexable } = _descriptors(proxy);
  for (const prop of names2) {
    const scriptable = isScriptable(prop);
    const indexable = isIndexable(prop);
    const value = (indexable || scriptable) && proxy[prop];
    if (scriptable && (isFunction(value) || hasFunction(value)) || indexable && isArray(value)) {
      return true;
    }
  }
  return false;
}
var version = "4.4.0";
const KNOWN_POSITIONS = [
  "top",
  "bottom",
  "left",
  "right",
  "chartArea"
];
function positionIsHorizontal(position2, axis) {
  return position2 === "top" || position2 === "bottom" || KNOWN_POSITIONS.indexOf(position2) === -1 && axis === "x";
}
function compare2Level(l1, l2) {
  return function(a2, b2) {
    return a2[l1] === b2[l1] ? a2[l2] - b2[l2] : a2[l1] - b2[l1];
  };
}
function onAnimationsComplete(context) {
  const chart = context.chart;
  const animationOptions = chart.options.animation;
  chart.notifyPlugins("afterRender");
  callback(animationOptions && animationOptions.onComplete, [
    context
  ], chart);
}
function onAnimationProgress(context) {
  const chart = context.chart;
  const animationOptions = chart.options.animation;
  callback(animationOptions && animationOptions.onProgress, [
    context
  ], chart);
}
function getCanvas(item) {
  if (_isDomSupported() && typeof item === "string") {
    item = document.getElementById(item);
  } else if (item && item.length) {
    item = item[0];
  }
  if (item && item.canvas) {
    item = item.canvas;
  }
  return item;
}
const instances = {};
const getChart = (key) => {
  const canvas = getCanvas(key);
  return Object.values(instances).filter((c2) => c2.canvas === canvas).pop();
};
function moveNumericKeys(obj, start, move) {
  const keys = Object.keys(obj);
  for (const key of keys) {
    const intKey = +key;
    if (intKey >= start) {
      const value = obj[key];
      delete obj[key];
      if (move > 0 || intKey > start) {
        obj[intKey + move] = value;
      }
    }
  }
}
function determineLastEvent(e2, lastEvent, inChartArea, isClick) {
  if (!inChartArea || e2.type === "mouseout") {
    return null;
  }
  if (isClick) {
    return lastEvent;
  }
  return e2;
}
function getSizeForArea(scale, chartArea, field) {
  return scale.options.clip ? scale[field] : chartArea[field];
}
function getDatasetArea(meta, chartArea) {
  const { xScale, yScale } = meta;
  if (xScale && yScale) {
    return {
      left: getSizeForArea(xScale, chartArea, "left"),
      right: getSizeForArea(xScale, chartArea, "right"),
      top: getSizeForArea(yScale, chartArea, "top"),
      bottom: getSizeForArea(yScale, chartArea, "bottom")
    };
  }
  return chartArea;
}
class Chart {
  static register(...items) {
    registry.add(...items);
    invalidatePlugins();
  }
  static unregister(...items) {
    registry.remove(...items);
    invalidatePlugins();
  }
  constructor(item, userConfig) {
    const config = this.config = new Config(userConfig);
    const initialCanvas = getCanvas(item);
    const existingChart = getChart(initialCanvas);
    if (existingChart) {
      throw new Error("Canvas is already in use. Chart with ID '" + existingChart.id + "' must be destroyed before the canvas with ID '" + existingChart.canvas.id + "' can be reused.");
    }
    const options = config.createResolver(config.chartOptionScopes(), this.getContext());
    this.platform = new (config.platform || _detectPlatform(initialCanvas))();
    this.platform.updateConfig(config);
    const context = this.platform.acquireContext(initialCanvas, options.aspectRatio);
    const canvas = context && context.canvas;
    const height = canvas && canvas.height;
    const width = canvas && canvas.width;
    this.id = uid();
    this.ctx = context;
    this.canvas = canvas;
    this.width = width;
    this.height = height;
    this._options = options;
    this._aspectRatio = this.aspectRatio;
    this._layers = [];
    this._metasets = [];
    this._stacks = void 0;
    this.boxes = [];
    this.currentDevicePixelRatio = void 0;
    this.chartArea = void 0;
    this._active = [];
    this._lastEvent = void 0;
    this._listeners = {};
    this._responsiveListeners = void 0;
    this._sortedMetasets = [];
    this.scales = {};
    this._plugins = new PluginService();
    this.$proxies = {};
    this._hiddenIndices = {};
    this.attached = false;
    this._animationsDisabled = void 0;
    this.$context = void 0;
    this._doResize = debounce((mode) => this.update(mode), options.resizeDelay || 0);
    this._dataChanges = [];
    instances[this.id] = this;
    if (!context || !canvas) {
      console.error("Failed to create chart: can't acquire context from the given item");
      return;
    }
    animator.listen(this, "complete", onAnimationsComplete);
    animator.listen(this, "progress", onAnimationProgress);
    this._initialize();
    if (this.attached) {
      this.update();
    }
  }
  get aspectRatio() {
    const { options: { aspectRatio, maintainAspectRatio }, width, height, _aspectRatio } = this;
    if (!isNullOrUndef(aspectRatio)) {
      return aspectRatio;
    }
    if (maintainAspectRatio && _aspectRatio) {
      return _aspectRatio;
    }
    return height ? width / height : null;
  }
  get data() {
    return this.config.data;
  }
  set data(data) {
    this.config.data = data;
  }
  get options() {
    return this._options;
  }
  set options(options) {
    this.config.options = options;
  }
  get registry() {
    return registry;
  }
  _initialize() {
    this.notifyPlugins("beforeInit");
    if (this.options.responsive) {
      this.resize();
    } else {
      retinaScale(this, this.options.devicePixelRatio);
    }
    this.bindEvents();
    this.notifyPlugins("afterInit");
    return this;
  }
  clear() {
    clearCanvas(this.canvas, this.ctx);
    return this;
  }
  stop() {
    animator.stop(this);
    return this;
  }
  resize(width, height) {
    if (!animator.running(this)) {
      this._resize(width, height);
    } else {
      this._resizeBeforeDraw = {
        width,
        height
      };
    }
  }
  _resize(width, height) {
    const options = this.options;
    const canvas = this.canvas;
    const aspectRatio = options.maintainAspectRatio && this.aspectRatio;
    const newSize = this.platform.getMaximumSize(canvas, width, height, aspectRatio);
    const newRatio = options.devicePixelRatio || this.platform.getDevicePixelRatio();
    const mode = this.width ? "resize" : "attach";
    this.width = newSize.width;
    this.height = newSize.height;
    this._aspectRatio = this.aspectRatio;
    if (!retinaScale(this, newRatio, true)) {
      return;
    }
    this.notifyPlugins("resize", {
      size: newSize
    });
    callback(options.onResize, [
      this,
      newSize
    ], this);
    if (this.attached) {
      if (this._doResize(mode)) {
        this.render();
      }
    }
  }
  ensureScalesHaveIDs() {
    const options = this.options;
    const scalesOptions = options.scales || {};
    each(scalesOptions, (axisOptions, axisID) => {
      axisOptions.id = axisID;
    });
  }
  buildOrUpdateScales() {
    const options = this.options;
    const scaleOpts = options.scales;
    const scales = this.scales;
    const updated = Object.keys(scales).reduce((obj, id) => {
      obj[id] = false;
      return obj;
    }, {});
    let items = [];
    if (scaleOpts) {
      items = items.concat(Object.keys(scaleOpts).map((id) => {
        const scaleOptions = scaleOpts[id];
        const axis = determineAxis(id, scaleOptions);
        const isRadial = axis === "r";
        const isHorizontal = axis === "x";
        return {
          options: scaleOptions,
          dposition: isRadial ? "chartArea" : isHorizontal ? "bottom" : "left",
          dtype: isRadial ? "radialLinear" : isHorizontal ? "category" : "linear"
        };
      }));
    }
    each(items, (item) => {
      const scaleOptions = item.options;
      const id = scaleOptions.id;
      const axis = determineAxis(id, scaleOptions);
      const scaleType = valueOrDefault(scaleOptions.type, item.dtype);
      if (scaleOptions.position === void 0 || positionIsHorizontal(scaleOptions.position, axis) !== positionIsHorizontal(item.dposition)) {
        scaleOptions.position = item.dposition;
      }
      updated[id] = true;
      let scale = null;
      if (id in scales && scales[id].type === scaleType) {
        scale = scales[id];
      } else {
        const scaleClass = registry.getScale(scaleType);
        scale = new scaleClass({
          id,
          type: scaleType,
          ctx: this.ctx,
          chart: this
        });
        scales[scale.id] = scale;
      }
      scale.init(scaleOptions, options);
    });
    each(updated, (hasUpdated, id) => {
      if (!hasUpdated) {
        delete scales[id];
      }
    });
    each(scales, (scale) => {
      layouts.configure(this, scale, scale.options);
      layouts.addBox(this, scale);
    });
  }
  _updateMetasets() {
    const metasets = this._metasets;
    const numData = this.data.datasets.length;
    const numMeta = metasets.length;
    metasets.sort((a2, b2) => a2.index - b2.index);
    if (numMeta > numData) {
      for (let i = numData; i < numMeta; ++i) {
        this._destroyDatasetMeta(i);
      }
      metasets.splice(numData, numMeta - numData);
    }
    this._sortedMetasets = metasets.slice(0).sort(compare2Level("order", "index"));
  }
  _removeUnreferencedMetasets() {
    const { _metasets: metasets, data: { datasets } } = this;
    if (metasets.length > datasets.length) {
      delete this._stacks;
    }
    metasets.forEach((meta, index) => {
      if (datasets.filter((x2) => x2 === meta._dataset).length === 0) {
        this._destroyDatasetMeta(index);
      }
    });
  }
  buildOrUpdateControllers() {
    const newControllers = [];
    const datasets = this.data.datasets;
    let i, ilen;
    this._removeUnreferencedMetasets();
    for (i = 0, ilen = datasets.length; i < ilen; i++) {
      const dataset = datasets[i];
      let meta = this.getDatasetMeta(i);
      const type = dataset.type || this.config.type;
      if (meta.type && meta.type !== type) {
        this._destroyDatasetMeta(i);
        meta = this.getDatasetMeta(i);
      }
      meta.type = type;
      meta.indexAxis = dataset.indexAxis || getIndexAxis(type, this.options);
      meta.order = dataset.order || 0;
      meta.index = i;
      meta.label = "" + dataset.label;
      meta.visible = this.isDatasetVisible(i);
      if (meta.controller) {
        meta.controller.updateIndex(i);
        meta.controller.linkScales();
      } else {
        const ControllerClass = registry.getController(type);
        const { datasetElementType, dataElementType } = defaults.datasets[type];
        Object.assign(ControllerClass, {
          dataElementType: registry.getElement(dataElementType),
          datasetElementType: datasetElementType && registry.getElement(datasetElementType)
        });
        meta.controller = new ControllerClass(this, i);
        newControllers.push(meta.controller);
      }
    }
    this._updateMetasets();
    return newControllers;
  }
  _resetElements() {
    each(this.data.datasets, (dataset, datasetIndex) => {
      this.getDatasetMeta(datasetIndex).controller.reset();
    }, this);
  }
  reset() {
    this._resetElements();
    this.notifyPlugins("reset");
  }
  update(mode) {
    const config = this.config;
    config.update();
    const options = this._options = config.createResolver(config.chartOptionScopes(), this.getContext());
    const animsDisabled = this._animationsDisabled = !options.animation;
    this._updateScales();
    this._checkEventBindings();
    this._updateHiddenIndices();
    this._plugins.invalidate();
    if (this.notifyPlugins("beforeUpdate", {
      mode,
      cancelable: true
    }) === false) {
      return;
    }
    const newControllers = this.buildOrUpdateControllers();
    this.notifyPlugins("beforeElementsUpdate");
    let minPadding = 0;
    for (let i = 0, ilen = this.data.datasets.length; i < ilen; i++) {
      const { controller } = this.getDatasetMeta(i);
      const reset = !animsDisabled && newControllers.indexOf(controller) === -1;
      controller.buildOrUpdateElements(reset);
      minPadding = Math.max(+controller.getMaxOverflow(), minPadding);
    }
    minPadding = this._minPadding = options.layout.autoPadding ? minPadding : 0;
    this._updateLayout(minPadding);
    if (!animsDisabled) {
      each(newControllers, (controller) => {
        controller.reset();
      });
    }
    this._updateDatasets(mode);
    this.notifyPlugins("afterUpdate", {
      mode
    });
    this._layers.sort(compare2Level("z", "_idx"));
    const { _active, _lastEvent } = this;
    if (_lastEvent) {
      this._eventHandler(_lastEvent, true);
    } else if (_active.length) {
      this._updateHoverStyles(_active, _active, true);
    }
    this.render();
  }
  _updateScales() {
    each(this.scales, (scale) => {
      layouts.removeBox(this, scale);
    });
    this.ensureScalesHaveIDs();
    this.buildOrUpdateScales();
  }
  _checkEventBindings() {
    const options = this.options;
    const existingEvents = new Set(Object.keys(this._listeners));
    const newEvents = new Set(options.events);
    if (!setsEqual(existingEvents, newEvents) || !!this._responsiveListeners !== options.responsive) {
      this.unbindEvents();
      this.bindEvents();
    }
  }
  _updateHiddenIndices() {
    const { _hiddenIndices } = this;
    const changes = this._getUniformDataChanges() || [];
    for (const { method, start, count } of changes) {
      const move = method === "_removeElements" ? -count : count;
      moveNumericKeys(_hiddenIndices, start, move);
    }
  }
  _getUniformDataChanges() {
    const _dataChanges = this._dataChanges;
    if (!_dataChanges || !_dataChanges.length) {
      return;
    }
    this._dataChanges = [];
    const datasetCount = this.data.datasets.length;
    const makeSet = (idx) => new Set(_dataChanges.filter((c2) => c2[0] === idx).map((c2, i) => i + "," + c2.splice(1).join(",")));
    const changeSet = makeSet(0);
    for (let i = 1; i < datasetCount; i++) {
      if (!setsEqual(changeSet, makeSet(i))) {
        return;
      }
    }
    return Array.from(changeSet).map((c2) => c2.split(",")).map((a2) => ({
      method: a2[1],
      start: +a2[2],
      count: +a2[3]
    }));
  }
  _updateLayout(minPadding) {
    if (this.notifyPlugins("beforeLayout", {
      cancelable: true
    }) === false) {
      return;
    }
    layouts.update(this, this.width, this.height, minPadding);
    const area = this.chartArea;
    const noArea = area.width <= 0 || area.height <= 0;
    this._layers = [];
    each(this.boxes, (box) => {
      if (noArea && box.position === "chartArea") {
        return;
      }
      if (box.configure) {
        box.configure();
      }
      this._layers.push(...box._layers());
    }, this);
    this._layers.forEach((item, index) => {
      item._idx = index;
    });
    this.notifyPlugins("afterLayout");
  }
  _updateDatasets(mode) {
    if (this.notifyPlugins("beforeDatasetsUpdate", {
      mode,
      cancelable: true
    }) === false) {
      return;
    }
    for (let i = 0, ilen = this.data.datasets.length; i < ilen; ++i) {
      this.getDatasetMeta(i).controller.configure();
    }
    for (let i = 0, ilen = this.data.datasets.length; i < ilen; ++i) {
      this._updateDataset(i, isFunction(mode) ? mode({
        datasetIndex: i
      }) : mode);
    }
    this.notifyPlugins("afterDatasetsUpdate", {
      mode
    });
  }
  _updateDataset(index, mode) {
    const meta = this.getDatasetMeta(index);
    const args = {
      meta,
      index,
      mode,
      cancelable: true
    };
    if (this.notifyPlugins("beforeDatasetUpdate", args) === false) {
      return;
    }
    meta.controller._update(mode);
    args.cancelable = false;
    this.notifyPlugins("afterDatasetUpdate", args);
  }
  render() {
    if (this.notifyPlugins("beforeRender", {
      cancelable: true
    }) === false) {
      return;
    }
    if (animator.has(this)) {
      if (this.attached && !animator.running(this)) {
        animator.start(this);
      }
    } else {
      this.draw();
      onAnimationsComplete({
        chart: this
      });
    }
  }
  draw() {
    let i;
    if (this._resizeBeforeDraw) {
      const { width, height } = this._resizeBeforeDraw;
      this._resize(width, height);
      this._resizeBeforeDraw = null;
    }
    this.clear();
    if (this.width <= 0 || this.height <= 0) {
      return;
    }
    if (this.notifyPlugins("beforeDraw", {
      cancelable: true
    }) === false) {
      return;
    }
    const layers = this._layers;
    for (i = 0; i < layers.length && layers[i].z <= 0; ++i) {
      layers[i].draw(this.chartArea);
    }
    this._drawDatasets();
    for (; i < layers.length; ++i) {
      layers[i].draw(this.chartArea);
    }
    this.notifyPlugins("afterDraw");
  }
  _getSortedDatasetMetas(filterVisible) {
    const metasets = this._sortedMetasets;
    const result = [];
    let i, ilen;
    for (i = 0, ilen = metasets.length; i < ilen; ++i) {
      const meta = metasets[i];
      if (!filterVisible || meta.visible) {
        result.push(meta);
      }
    }
    return result;
  }
  getSortedVisibleDatasetMetas() {
    return this._getSortedDatasetMetas(true);
  }
  _drawDatasets() {
    if (this.notifyPlugins("beforeDatasetsDraw", {
      cancelable: true
    }) === false) {
      return;
    }
    const metasets = this.getSortedVisibleDatasetMetas();
    for (let i = metasets.length - 1; i >= 0; --i) {
      this._drawDataset(metasets[i]);
    }
    this.notifyPlugins("afterDatasetsDraw");
  }
  _drawDataset(meta) {
    const ctx = this.ctx;
    const clip = meta._clip;
    const useClip = !clip.disabled;
    const area = getDatasetArea(meta, this.chartArea);
    const args = {
      meta,
      index: meta.index,
      cancelable: true
    };
    if (this.notifyPlugins("beforeDatasetDraw", args) === false) {
      return;
    }
    if (useClip) {
      clipArea(ctx, {
        left: clip.left === false ? 0 : area.left - clip.left,
        right: clip.right === false ? this.width : area.right + clip.right,
        top: clip.top === false ? 0 : area.top - clip.top,
        bottom: clip.bottom === false ? this.height : area.bottom + clip.bottom
      });
    }
    meta.controller.draw();
    if (useClip) {
      unclipArea(ctx);
    }
    args.cancelable = false;
    this.notifyPlugins("afterDatasetDraw", args);
  }
  isPointInArea(point) {
    return _isPointInArea(point, this.chartArea, this._minPadding);
  }
  getElementsAtEventForMode(e2, mode, options, useFinalPosition) {
    const method = Interaction.modes[mode];
    if (typeof method === "function") {
      return method(this, e2, options, useFinalPosition);
    }
    return [];
  }
  getDatasetMeta(datasetIndex) {
    const dataset = this.data.datasets[datasetIndex];
    const metasets = this._metasets;
    let meta = metasets.filter((x2) => x2 && x2._dataset === dataset).pop();
    if (!meta) {
      meta = {
        type: null,
        data: [],
        dataset: null,
        controller: null,
        hidden: null,
        xAxisID: null,
        yAxisID: null,
        order: dataset && dataset.order || 0,
        index: datasetIndex,
        _dataset: dataset,
        _parsed: [],
        _sorted: false
      };
      metasets.push(meta);
    }
    return meta;
  }
  getContext() {
    return this.$context || (this.$context = createContext(null, {
      chart: this,
      type: "chart"
    }));
  }
  getVisibleDatasetCount() {
    return this.getSortedVisibleDatasetMetas().length;
  }
  isDatasetVisible(datasetIndex) {
    const dataset = this.data.datasets[datasetIndex];
    if (!dataset) {
      return false;
    }
    const meta = this.getDatasetMeta(datasetIndex);
    return typeof meta.hidden === "boolean" ? !meta.hidden : !dataset.hidden;
  }
  setDatasetVisibility(datasetIndex, visible) {
    const meta = this.getDatasetMeta(datasetIndex);
    meta.hidden = !visible;
  }
  toggleDataVisibility(index) {
    this._hiddenIndices[index] = !this._hiddenIndices[index];
  }
  getDataVisibility(index) {
    return !this._hiddenIndices[index];
  }
  _updateVisibility(datasetIndex, dataIndex, visible) {
    const mode = visible ? "show" : "hide";
    const meta = this.getDatasetMeta(datasetIndex);
    const anims = meta.controller._resolveAnimations(void 0, mode);
    if (defined(dataIndex)) {
      meta.data[dataIndex].hidden = !visible;
      this.update();
    } else {
      this.setDatasetVisibility(datasetIndex, visible);
      anims.update(meta, {
        visible
      });
      this.update((ctx) => ctx.datasetIndex === datasetIndex ? mode : void 0);
    }
  }
  hide(datasetIndex, dataIndex) {
    this._updateVisibility(datasetIndex, dataIndex, false);
  }
  show(datasetIndex, dataIndex) {
    this._updateVisibility(datasetIndex, dataIndex, true);
  }
  _destroyDatasetMeta(datasetIndex) {
    const meta = this._metasets[datasetIndex];
    if (meta && meta.controller) {
      meta.controller._destroy();
    }
    delete this._metasets[datasetIndex];
  }
  _stop() {
    let i, ilen;
    this.stop();
    animator.remove(this);
    for (i = 0, ilen = this.data.datasets.length; i < ilen; ++i) {
      this._destroyDatasetMeta(i);
    }
  }
  destroy() {
    this.notifyPlugins("beforeDestroy");
    const { canvas, ctx } = this;
    this._stop();
    this.config.clearCache();
    if (canvas) {
      this.unbindEvents();
      clearCanvas(canvas, ctx);
      this.platform.releaseContext(ctx);
      this.canvas = null;
      this.ctx = null;
    }
    delete instances[this.id];
    this.notifyPlugins("afterDestroy");
  }
  toBase64Image(...args) {
    return this.canvas.toDataURL(...args);
  }
  bindEvents() {
    this.bindUserEvents();
    if (this.options.responsive) {
      this.bindResponsiveEvents();
    } else {
      this.attached = true;
    }
  }
  bindUserEvents() {
    const listeners = this._listeners;
    const platform = this.platform;
    const _add = (type, listener2) => {
      platform.addEventListener(this, type, listener2);
      listeners[type] = listener2;
    };
    const listener = (e2, x2, y2) => {
      e2.offsetX = x2;
      e2.offsetY = y2;
      this._eventHandler(e2);
    };
    each(this.options.events, (type) => _add(type, listener));
  }
  bindResponsiveEvents() {
    if (!this._responsiveListeners) {
      this._responsiveListeners = {};
    }
    const listeners = this._responsiveListeners;
    const platform = this.platform;
    const _add = (type, listener2) => {
      platform.addEventListener(this, type, listener2);
      listeners[type] = listener2;
    };
    const _remove = (type, listener2) => {
      if (listeners[type]) {
        platform.removeEventListener(this, type, listener2);
        delete listeners[type];
      }
    };
    const listener = (width, height) => {
      if (this.canvas) {
        this.resize(width, height);
      }
    };
    let detached;
    const attached = () => {
      _remove("attach", attached);
      this.attached = true;
      this.resize();
      _add("resize", listener);
      _add("detach", detached);
    };
    detached = () => {
      this.attached = false;
      _remove("resize", listener);
      this._stop();
      this._resize(0, 0);
      _add("attach", attached);
    };
    if (platform.isAttached(this.canvas)) {
      attached();
    } else {
      detached();
    }
  }
  unbindEvents() {
    each(this._listeners, (listener, type) => {
      this.platform.removeEventListener(this, type, listener);
    });
    this._listeners = {};
    each(this._responsiveListeners, (listener, type) => {
      this.platform.removeEventListener(this, type, listener);
    });
    this._responsiveListeners = void 0;
  }
  updateHoverStyle(items, mode, enabled) {
    const prefix = enabled ? "set" : "remove";
    let meta, item, i, ilen;
    if (mode === "dataset") {
      meta = this.getDatasetMeta(items[0].datasetIndex);
      meta.controller["_" + prefix + "DatasetHoverStyle"]();
    }
    for (i = 0, ilen = items.length; i < ilen; ++i) {
      item = items[i];
      const controller = item && this.getDatasetMeta(item.datasetIndex).controller;
      if (controller) {
        controller[prefix + "HoverStyle"](item.element, item.datasetIndex, item.index);
      }
    }
  }
  getActiveElements() {
    return this._active || [];
  }
  setActiveElements(activeElements) {
    const lastActive = this._active || [];
    const active = activeElements.map(({ datasetIndex, index }) => {
      const meta = this.getDatasetMeta(datasetIndex);
      if (!meta) {
        throw new Error("No dataset found at index " + datasetIndex);
      }
      return {
        datasetIndex,
        element: meta.data[index],
        index
      };
    });
    const changed = !_elementsEqual(active, lastActive);
    if (changed) {
      this._active = active;
      this._lastEvent = null;
      this._updateHoverStyles(active, lastActive);
    }
  }
  notifyPlugins(hook, args, filter) {
    return this._plugins.notify(this, hook, args, filter);
  }
  isPluginEnabled(pluginId) {
    return this._plugins._cache.filter((p2) => p2.plugin.id === pluginId).length === 1;
  }
  _updateHoverStyles(active, lastActive, replay) {
    const hoverOptions = this.options.hover;
    const diff = (a2, b2) => a2.filter((x2) => !b2.some((y2) => x2.datasetIndex === y2.datasetIndex && x2.index === y2.index));
    const deactivated = diff(lastActive, active);
    const activated = replay ? active : diff(active, lastActive);
    if (deactivated.length) {
      this.updateHoverStyle(deactivated, hoverOptions.mode, false);
    }
    if (activated.length && hoverOptions.mode) {
      this.updateHoverStyle(activated, hoverOptions.mode, true);
    }
  }
  _eventHandler(e2, replay) {
    const args = {
      event: e2,
      replay,
      cancelable: true,
      inChartArea: this.isPointInArea(e2)
    };
    const eventFilter = (plugin) => (plugin.options.events || this.options.events).includes(e2.native.type);
    if (this.notifyPlugins("beforeEvent", args, eventFilter) === false) {
      return;
    }
    const changed = this._handleEvent(e2, replay, args.inChartArea);
    args.cancelable = false;
    this.notifyPlugins("afterEvent", args, eventFilter);
    if (changed || args.changed) {
      this.render();
    }
    return this;
  }
  _handleEvent(e2, replay, inChartArea) {
    const { _active: lastActive = [], options } = this;
    const useFinalPosition = replay;
    const active = this._getActiveElements(e2, lastActive, inChartArea, useFinalPosition);
    const isClick = _isClickEvent(e2);
    const lastEvent = determineLastEvent(e2, this._lastEvent, inChartArea, isClick);
    if (inChartArea) {
      this._lastEvent = null;
      callback(options.onHover, [
        e2,
        active,
        this
      ], this);
      if (isClick) {
        callback(options.onClick, [
          e2,
          active,
          this
        ], this);
      }
    }
    const changed = !_elementsEqual(active, lastActive);
    if (changed || replay) {
      this._active = active;
      this._updateHoverStyles(active, lastActive, replay);
    }
    this._lastEvent = lastEvent;
    return changed;
  }
  _getActiveElements(e2, lastActive, inChartArea, useFinalPosition) {
    if (e2.type === "mouseout") {
      return [];
    }
    if (!inChartArea) {
      return lastActive;
    }
    const hoverOptions = this.options.hover;
    return this.getElementsAtEventForMode(e2, hoverOptions.mode, hoverOptions, useFinalPosition);
  }
}
__publicField(Chart, "defaults", defaults);
__publicField(Chart, "instances", instances);
__publicField(Chart, "overrides", overrides);
__publicField(Chart, "registry", registry);
__publicField(Chart, "version", version);
__publicField(Chart, "getChart", getChart);
function invalidatePlugins() {
  return each(Chart.instances, (chart) => chart._plugins.invalidate());
}
function setStyle(ctx, options, style = options) {
  ctx.lineCap = valueOrDefault(style.borderCapStyle, options.borderCapStyle);
  ctx.setLineDash(valueOrDefault(style.borderDash, options.borderDash));
  ctx.lineDashOffset = valueOrDefault(style.borderDashOffset, options.borderDashOffset);
  ctx.lineJoin = valueOrDefault(style.borderJoinStyle, options.borderJoinStyle);
  ctx.lineWidth = valueOrDefault(style.borderWidth, options.borderWidth);
  ctx.strokeStyle = valueOrDefault(style.borderColor, options.borderColor);
}
function lineTo(ctx, previous, target) {
  ctx.lineTo(target.x, target.y);
}
function getLineMethod(options) {
  if (options.stepped) {
    return _steppedLineTo;
  }
  if (options.tension || options.cubicInterpolationMode === "monotone") {
    return _bezierCurveTo;
  }
  return lineTo;
}
function pathVars(points, segment, params = {}) {
  const count = points.length;
  const { start: paramsStart = 0, end: paramsEnd = count - 1 } = params;
  const { start: segmentStart, end: segmentEnd } = segment;
  const start = Math.max(paramsStart, segmentStart);
  const end = Math.min(paramsEnd, segmentEnd);
  const outside = paramsStart < segmentStart && paramsEnd < segmentStart || paramsStart > segmentEnd && paramsEnd > segmentEnd;
  return {
    count,
    start,
    loop: segment.loop,
    ilen: end < start && !outside ? count + end - start : end - start
  };
}
function pathSegment(ctx, line, segment, params) {
  const { points, options } = line;
  const { count, start, loop, ilen } = pathVars(points, segment, params);
  const lineMethod = getLineMethod(options);
  let { move = true, reverse } = params || {};
  let i, point, prev;
  for (i = 0; i <= ilen; ++i) {
    point = points[(start + (reverse ? ilen - i : i)) % count];
    if (point.skip) {
      continue;
    } else if (move) {
      ctx.moveTo(point.x, point.y);
      move = false;
    } else {
      lineMethod(ctx, prev, point, reverse, options.stepped);
    }
    prev = point;
  }
  if (loop) {
    point = points[(start + (reverse ? ilen : 0)) % count];
    lineMethod(ctx, prev, point, reverse, options.stepped);
  }
  return !!loop;
}
function fastPathSegment(ctx, line, segment, params) {
  const points = line.points;
  const { count, start, ilen } = pathVars(points, segment, params);
  const { move = true, reverse } = params || {};
  let avgX = 0;
  let countX = 0;
  let i, point, prevX, minY, maxY, lastY;
  const pointIndex = (index) => (start + (reverse ? ilen - index : index)) % count;
  const drawX = () => {
    if (minY !== maxY) {
      ctx.lineTo(avgX, maxY);
      ctx.lineTo(avgX, minY);
      ctx.lineTo(avgX, lastY);
    }
  };
  if (move) {
    point = points[pointIndex(0)];
    ctx.moveTo(point.x, point.y);
  }
  for (i = 0; i <= ilen; ++i) {
    point = points[pointIndex(i)];
    if (point.skip) {
      continue;
    }
    const x2 = point.x;
    const y2 = point.y;
    const truncX = x2 | 0;
    if (truncX === prevX) {
      if (y2 < minY) {
        minY = y2;
      } else if (y2 > maxY) {
        maxY = y2;
      }
      avgX = (countX * avgX + x2) / ++countX;
    } else {
      drawX();
      ctx.lineTo(x2, y2);
      prevX = truncX;
      countX = 0;
      minY = maxY = y2;
    }
    lastY = y2;
  }
  drawX();
}
function _getSegmentMethod(line) {
  const opts = line.options;
  const borderDash = opts.borderDash && opts.borderDash.length;
  const useFastPath = !line._decimated && !line._loop && !opts.tension && opts.cubicInterpolationMode !== "monotone" && !opts.stepped && !borderDash;
  return useFastPath ? fastPathSegment : pathSegment;
}
function _getInterpolationMethod(options) {
  if (options.stepped) {
    return _steppedInterpolation;
  }
  if (options.tension || options.cubicInterpolationMode === "monotone") {
    return _bezierInterpolation;
  }
  return _pointInLine;
}
function strokePathWithCache(ctx, line, start, count) {
  let path = line._path;
  if (!path) {
    path = line._path = new Path2D();
    if (line.path(path, start, count)) {
      path.closePath();
    }
  }
  setStyle(ctx, line.options);
  ctx.stroke(path);
}
function strokePathDirect(ctx, line, start, count) {
  const { segments, options } = line;
  const segmentMethod = _getSegmentMethod(line);
  for (const segment of segments) {
    setStyle(ctx, options, segment.style);
    ctx.beginPath();
    if (segmentMethod(ctx, line, segment, {
      start,
      end: start + count - 1
    })) {
      ctx.closePath();
    }
    ctx.stroke();
  }
}
const usePath2D = typeof Path2D === "function";
function draw(ctx, line, start, count) {
  if (usePath2D && !line.options.segment) {
    strokePathWithCache(ctx, line, start, count);
  } else {
    strokePathDirect(ctx, line, start, count);
  }
}
class LineElement extends Element {
  constructor(cfg) {
    super();
    this.animated = true;
    this.options = void 0;
    this._chart = void 0;
    this._loop = void 0;
    this._fullLoop = void 0;
    this._path = void 0;
    this._points = void 0;
    this._segments = void 0;
    this._decimated = false;
    this._pointsUpdated = false;
    this._datasetIndex = void 0;
    if (cfg) {
      Object.assign(this, cfg);
    }
  }
  updateControlPoints(chartArea, indexAxis) {
    const options = this.options;
    if ((options.tension || options.cubicInterpolationMode === "monotone") && !options.stepped && !this._pointsUpdated) {
      const loop = options.spanGaps ? this._loop : this._fullLoop;
      _updateBezierControlPoints(this._points, options, chartArea, loop, indexAxis);
      this._pointsUpdated = true;
    }
  }
  set points(points) {
    this._points = points;
    delete this._segments;
    delete this._path;
    this._pointsUpdated = false;
  }
  get points() {
    return this._points;
  }
  get segments() {
    return this._segments || (this._segments = _computeSegments(this, this.options.segment));
  }
  first() {
    const segments = this.segments;
    const points = this.points;
    return segments.length && points[segments[0].start];
  }
  last() {
    const segments = this.segments;
    const points = this.points;
    const count = segments.length;
    return count && points[segments[count - 1].end];
  }
  interpolate(point, property) {
    const options = this.options;
    const value = point[property];
    const points = this.points;
    const segments = _boundSegments(this, {
      property,
      start: value,
      end: value
    });
    if (!segments.length) {
      return;
    }
    const result = [];
    const _interpolate = _getInterpolationMethod(options);
    let i, ilen;
    for (i = 0, ilen = segments.length; i < ilen; ++i) {
      const { start, end } = segments[i];
      const p1 = points[start];
      const p2 = points[end];
      if (p1 === p2) {
        result.push(p1);
        continue;
      }
      const t = Math.abs((value - p1[property]) / (p2[property] - p1[property]));
      const interpolated = _interpolate(p1, p2, t, options.stepped);
      interpolated[property] = point[property];
      result.push(interpolated);
    }
    return result.length === 1 ? result[0] : result;
  }
  pathSegment(ctx, segment, params) {
    const segmentMethod = _getSegmentMethod(this);
    return segmentMethod(ctx, this, segment, params);
  }
  path(ctx, start, count) {
    const segments = this.segments;
    const segmentMethod = _getSegmentMethod(this);
    let loop = this._loop;
    start = start || 0;
    count = count || this.points.length - start;
    for (const segment of segments) {
      loop &= segmentMethod(ctx, this, segment, {
        start,
        end: start + count - 1
      });
    }
    return !!loop;
  }
  draw(ctx, chartArea, start, count) {
    const options = this.options || {};
    const points = this.points || [];
    if (points.length && options.borderWidth) {
      ctx.save();
      draw(ctx, this, start, count);
      ctx.restore();
    }
    if (this.animated) {
      this._pointsUpdated = false;
      this._path = void 0;
    }
  }
}
__publicField(LineElement, "id", "line");
__publicField(LineElement, "defaults", {
  borderCapStyle: "butt",
  borderDash: [],
  borderDashOffset: 0,
  borderJoinStyle: "miter",
  borderWidth: 3,
  capBezierPoints: true,
  cubicInterpolationMode: "default",
  fill: false,
  spanGaps: false,
  stepped: false,
  tension: 0
});
__publicField(LineElement, "defaultRoutes", {
  backgroundColor: "backgroundColor",
  borderColor: "borderColor"
});
__publicField(LineElement, "descriptors", {
  _scriptable: true,
  _indexable: (name) => name !== "borderDash" && name !== "fill"
});
function inRange$1(el, pos, axis, useFinalPosition) {
  const options = el.options;
  const { [axis]: value } = el.getProps([
    axis
  ], useFinalPosition);
  return Math.abs(pos - value) < options.radius + options.hitRadius;
}
class PointElement extends Element {
  constructor(cfg) {
    super();
    __publicField(this, "parsed");
    __publicField(this, "skip");
    __publicField(this, "stop");
    this.options = void 0;
    this.parsed = void 0;
    this.skip = void 0;
    this.stop = void 0;
    if (cfg) {
      Object.assign(this, cfg);
    }
  }
  inRange(mouseX, mouseY, useFinalPosition) {
    const options = this.options;
    const { x: x2, y: y2 } = this.getProps([
      "x",
      "y"
    ], useFinalPosition);
    return Math.pow(mouseX - x2, 2) + Math.pow(mouseY - y2, 2) < Math.pow(options.hitRadius + options.radius, 2);
  }
  inXRange(mouseX, useFinalPosition) {
    return inRange$1(this, mouseX, "x", useFinalPosition);
  }
  inYRange(mouseY, useFinalPosition) {
    return inRange$1(this, mouseY, "y", useFinalPosition);
  }
  getCenterPoint(useFinalPosition) {
    const { x: x2, y: y2 } = this.getProps([
      "x",
      "y"
    ], useFinalPosition);
    return {
      x: x2,
      y: y2
    };
  }
  size(options) {
    options = options || this.options || {};
    let radius = options.radius || 0;
    radius = Math.max(radius, radius && options.hoverRadius || 0);
    const borderWidth = radius && options.borderWidth || 0;
    return (radius + borderWidth) * 2;
  }
  draw(ctx, area) {
    const options = this.options;
    if (this.skip || options.radius < 0.1 || !_isPointInArea(this, area, this.size(options) / 2)) {
      return;
    }
    ctx.strokeStyle = options.borderColor;
    ctx.lineWidth = options.borderWidth;
    ctx.fillStyle = options.backgroundColor;
    drawPoint(ctx, options, this.x, this.y);
  }
  getRange() {
    const options = this.options || {};
    return options.radius + options.hitRadius;
  }
}
__publicField(PointElement, "id", "point");
/**
* @type {any}
*/
__publicField(PointElement, "defaults", {
  borderWidth: 1,
  hitRadius: 1,
  hoverBorderWidth: 1,
  hoverRadius: 4,
  pointStyle: "circle",
  radius: 3,
  rotation: 0
});
/**
* @type {any}
*/
__publicField(PointElement, "defaultRoutes", {
  backgroundColor: "backgroundColor",
  borderColor: "borderColor"
});
function getBarBounds(bar, useFinalPosition) {
  const { x: x2, y: y2, base, width, height } = bar.getProps([
    "x",
    "y",
    "base",
    "width",
    "height"
  ], useFinalPosition);
  let left, right, top, bottom, half;
  if (bar.horizontal) {
    half = height / 2;
    left = Math.min(x2, base);
    right = Math.max(x2, base);
    top = y2 - half;
    bottom = y2 + half;
  } else {
    half = width / 2;
    left = x2 - half;
    right = x2 + half;
    top = Math.min(y2, base);
    bottom = Math.max(y2, base);
  }
  return {
    left,
    top,
    right,
    bottom
  };
}
function skipOrLimit(skip2, value, min, max) {
  return skip2 ? 0 : _limitValue(value, min, max);
}
function parseBorderWidth(bar, maxW, maxH) {
  const value = bar.options.borderWidth;
  const skip2 = bar.borderSkipped;
  const o2 = toTRBL(value);
  return {
    t: skipOrLimit(skip2.top, o2.top, 0, maxH),
    r: skipOrLimit(skip2.right, o2.right, 0, maxW),
    b: skipOrLimit(skip2.bottom, o2.bottom, 0, maxH),
    l: skipOrLimit(skip2.left, o2.left, 0, maxW)
  };
}
function parseBorderRadius(bar, maxW, maxH) {
  const { enableBorderRadius } = bar.getProps([
    "enableBorderRadius"
  ]);
  const value = bar.options.borderRadius;
  const o2 = toTRBLCorners(value);
  const maxR = Math.min(maxW, maxH);
  const skip2 = bar.borderSkipped;
  const enableBorder = enableBorderRadius || isObject(value);
  return {
    topLeft: skipOrLimit(!enableBorder || skip2.top || skip2.left, o2.topLeft, 0, maxR),
    topRight: skipOrLimit(!enableBorder || skip2.top || skip2.right, o2.topRight, 0, maxR),
    bottomLeft: skipOrLimit(!enableBorder || skip2.bottom || skip2.left, o2.bottomLeft, 0, maxR),
    bottomRight: skipOrLimit(!enableBorder || skip2.bottom || skip2.right, o2.bottomRight, 0, maxR)
  };
}
function boundingRects(bar) {
  const bounds = getBarBounds(bar);
  const width = bounds.right - bounds.left;
  const height = bounds.bottom - bounds.top;
  const border = parseBorderWidth(bar, width / 2, height / 2);
  const radius = parseBorderRadius(bar, width / 2, height / 2);
  return {
    outer: {
      x: bounds.left,
      y: bounds.top,
      w: width,
      h: height,
      radius
    },
    inner: {
      x: bounds.left + border.l,
      y: bounds.top + border.t,
      w: width - border.l - border.r,
      h: height - border.t - border.b,
      radius: {
        topLeft: Math.max(0, radius.topLeft - Math.max(border.t, border.l)),
        topRight: Math.max(0, radius.topRight - Math.max(border.t, border.r)),
        bottomLeft: Math.max(0, radius.bottomLeft - Math.max(border.b, border.l)),
        bottomRight: Math.max(0, radius.bottomRight - Math.max(border.b, border.r))
      }
    }
  };
}
function inRange(bar, x2, y2, useFinalPosition) {
  const skipX = x2 === null;
  const skipY = y2 === null;
  const skipBoth = skipX && skipY;
  const bounds = bar && !skipBoth && getBarBounds(bar, useFinalPosition);
  return bounds && (skipX || _isBetween(x2, bounds.left, bounds.right)) && (skipY || _isBetween(y2, bounds.top, bounds.bottom));
}
function hasRadius(radius) {
  return radius.topLeft || radius.topRight || radius.bottomLeft || radius.bottomRight;
}
function addNormalRectPath(ctx, rect) {
  ctx.rect(rect.x, rect.y, rect.w, rect.h);
}
function inflateRect(rect, amount, refRect = {}) {
  const x2 = rect.x !== refRect.x ? -amount : 0;
  const y2 = rect.y !== refRect.y ? -amount : 0;
  const w2 = (rect.x + rect.w !== refRect.x + refRect.w ? amount : 0) - x2;
  const h3 = (rect.y + rect.h !== refRect.y + refRect.h ? amount : 0) - y2;
  return {
    x: rect.x + x2,
    y: rect.y + y2,
    w: rect.w + w2,
    h: rect.h + h3,
    radius: rect.radius
  };
}
class BarElement extends Element {
  constructor(cfg) {
    super();
    this.options = void 0;
    this.horizontal = void 0;
    this.base = void 0;
    this.width = void 0;
    this.height = void 0;
    this.inflateAmount = void 0;
    if (cfg) {
      Object.assign(this, cfg);
    }
  }
  draw(ctx) {
    const { inflateAmount, options: { borderColor, backgroundColor } } = this;
    const { inner, outer } = boundingRects(this);
    const addRectPath = hasRadius(outer.radius) ? addRoundedRectPath : addNormalRectPath;
    ctx.save();
    if (outer.w !== inner.w || outer.h !== inner.h) {
      ctx.beginPath();
      addRectPath(ctx, inflateRect(outer, inflateAmount, inner));
      ctx.clip();
      addRectPath(ctx, inflateRect(inner, -inflateAmount, outer));
      ctx.fillStyle = borderColor;
      ctx.fill("evenodd");
    }
    ctx.beginPath();
    addRectPath(ctx, inflateRect(inner, inflateAmount));
    ctx.fillStyle = backgroundColor;
    ctx.fill();
    ctx.restore();
  }
  inRange(mouseX, mouseY, useFinalPosition) {
    return inRange(this, mouseX, mouseY, useFinalPosition);
  }
  inXRange(mouseX, useFinalPosition) {
    return inRange(this, mouseX, null, useFinalPosition);
  }
  inYRange(mouseY, useFinalPosition) {
    return inRange(this, null, mouseY, useFinalPosition);
  }
  getCenterPoint(useFinalPosition) {
    const { x: x2, y: y2, base, horizontal } = this.getProps([
      "x",
      "y",
      "base",
      "horizontal"
    ], useFinalPosition);
    return {
      x: horizontal ? (x2 + base) / 2 : x2,
      y: horizontal ? y2 : (y2 + base) / 2
    };
  }
  getRange(axis) {
    return axis === "x" ? this.width / 2 : this.height / 2;
  }
}
__publicField(BarElement, "id", "bar");
__publicField(BarElement, "defaults", {
  borderSkipped: "start",
  borderWidth: 0,
  borderRadius: 0,
  inflateAmount: "auto",
  pointStyle: void 0
});
__publicField(BarElement, "defaultRoutes", {
  backgroundColor: "backgroundColor",
  borderColor: "borderColor"
});
const positioners = {
  average(items) {
    if (!items.length) {
      return false;
    }
    let i, len;
    let x2 = 0;
    let y2 = 0;
    let count = 0;
    for (i = 0, len = items.length; i < len; ++i) {
      const el = items[i].element;
      if (el && el.hasValue()) {
        const pos = el.tooltipPosition();
        x2 += pos.x;
        y2 += pos.y;
        ++count;
      }
    }
    return {
      x: x2 / count,
      y: y2 / count
    };
  },
  nearest(items, eventPosition) {
    if (!items.length) {
      return false;
    }
    let x2 = eventPosition.x;
    let y2 = eventPosition.y;
    let minDistance = Number.POSITIVE_INFINITY;
    let i, len, nearestElement;
    for (i = 0, len = items.length; i < len; ++i) {
      const el = items[i].element;
      if (el && el.hasValue()) {
        const center = el.getCenterPoint();
        const d2 = distanceBetweenPoints(eventPosition, center);
        if (d2 < minDistance) {
          minDistance = d2;
          nearestElement = el;
        }
      }
    }
    if (nearestElement) {
      const tp = nearestElement.tooltipPosition();
      x2 = tp.x;
      y2 = tp.y;
    }
    return {
      x: x2,
      y: y2
    };
  }
};
function pushOrConcat(base, toPush) {
  if (toPush) {
    if (isArray(toPush)) {
      Array.prototype.push.apply(base, toPush);
    } else {
      base.push(toPush);
    }
  }
  return base;
}
function splitNewlines(str) {
  if ((typeof str === "string" || str instanceof String) && str.indexOf("\n") > -1) {
    return str.split("\n");
  }
  return str;
}
function createTooltipItem(chart, item) {
  const { element: element2, datasetIndex, index } = item;
  const controller = chart.getDatasetMeta(datasetIndex).controller;
  const { label, value } = controller.getLabelAndValue(index);
  return {
    chart,
    label,
    parsed: controller.getParsed(index),
    raw: chart.data.datasets[datasetIndex].data[index],
    formattedValue: value,
    dataset: controller.getDataset(),
    dataIndex: index,
    datasetIndex,
    element: element2
  };
}
function getTooltipSize(tooltip, options) {
  const ctx = tooltip.chart.ctx;
  const { body, footer, title: title2 } = tooltip;
  const { boxWidth, boxHeight } = options;
  const bodyFont = toFont(options.bodyFont);
  const titleFont = toFont(options.titleFont);
  const footerFont = toFont(options.footerFont);
  const titleLineCount = title2.length;
  const footerLineCount = footer.length;
  const bodyLineItemCount = body.length;
  const padding = toPadding(options.padding);
  let height = padding.height;
  let width = 0;
  let combinedBodyLength = body.reduce((count, bodyItem) => count + bodyItem.before.length + bodyItem.lines.length + bodyItem.after.length, 0);
  combinedBodyLength += tooltip.beforeBody.length + tooltip.afterBody.length;
  if (titleLineCount) {
    height += titleLineCount * titleFont.lineHeight + (titleLineCount - 1) * options.titleSpacing + options.titleMarginBottom;
  }
  if (combinedBodyLength) {
    const bodyLineHeight = options.displayColors ? Math.max(boxHeight, bodyFont.lineHeight) : bodyFont.lineHeight;
    height += bodyLineItemCount * bodyLineHeight + (combinedBodyLength - bodyLineItemCount) * bodyFont.lineHeight + (combinedBodyLength - 1) * options.bodySpacing;
  }
  if (footerLineCount) {
    height += options.footerMarginTop + footerLineCount * footerFont.lineHeight + (footerLineCount - 1) * options.footerSpacing;
  }
  let widthPadding = 0;
  const maxLineWidth = function(line) {
    width = Math.max(width, ctx.measureText(line).width + widthPadding);
  };
  ctx.save();
  ctx.font = titleFont.string;
  each(tooltip.title, maxLineWidth);
  ctx.font = bodyFont.string;
  each(tooltip.beforeBody.concat(tooltip.afterBody), maxLineWidth);
  widthPadding = options.displayColors ? boxWidth + 2 + options.boxPadding : 0;
  each(body, (bodyItem) => {
    each(bodyItem.before, maxLineWidth);
    each(bodyItem.lines, maxLineWidth);
    each(bodyItem.after, maxLineWidth);
  });
  widthPadding = 0;
  ctx.font = footerFont.string;
  each(tooltip.footer, maxLineWidth);
  ctx.restore();
  width += padding.width;
  return {
    width,
    height
  };
}
function determineYAlign(chart, size2) {
  const { y: y2, height } = size2;
  if (y2 < height / 2) {
    return "top";
  } else if (y2 > chart.height - height / 2) {
    return "bottom";
  }
  return "center";
}
function doesNotFitWithAlign(xAlign, chart, options, size2) {
  const { x: x2, width } = size2;
  const caret = options.caretSize + options.caretPadding;
  if (xAlign === "left" && x2 + width + caret > chart.width) {
    return true;
  }
  if (xAlign === "right" && x2 - width - caret < 0) {
    return true;
  }
}
function determineXAlign(chart, options, size2, yAlign) {
  const { x: x2, width } = size2;
  const { width: chartWidth, chartArea: { left, right } } = chart;
  let xAlign = "center";
  if (yAlign === "center") {
    xAlign = x2 <= (left + right) / 2 ? "left" : "right";
  } else if (x2 <= width / 2) {
    xAlign = "left";
  } else if (x2 >= chartWidth - width / 2) {
    xAlign = "right";
  }
  if (doesNotFitWithAlign(xAlign, chart, options, size2)) {
    xAlign = "center";
  }
  return xAlign;
}
function determineAlignment(chart, options, size2) {
  const yAlign = size2.yAlign || options.yAlign || determineYAlign(chart, size2);
  return {
    xAlign: size2.xAlign || options.xAlign || determineXAlign(chart, options, size2, yAlign),
    yAlign
  };
}
function alignX(size2, xAlign) {
  let { x: x2, width } = size2;
  if (xAlign === "right") {
    x2 -= width;
  } else if (xAlign === "center") {
    x2 -= width / 2;
  }
  return x2;
}
function alignY(size2, yAlign, paddingAndSize) {
  let { y: y2, height } = size2;
  if (yAlign === "top") {
    y2 += paddingAndSize;
  } else if (yAlign === "bottom") {
    y2 -= height + paddingAndSize;
  } else {
    y2 -= height / 2;
  }
  return y2;
}
function getBackgroundPoint(options, size2, alignment, chart) {
  const { caretSize, caretPadding, cornerRadius } = options;
  const { xAlign, yAlign } = alignment;
  const paddingAndSize = caretSize + caretPadding;
  const { topLeft, topRight, bottomLeft, bottomRight } = toTRBLCorners(cornerRadius);
  let x2 = alignX(size2, xAlign);
  const y2 = alignY(size2, yAlign, paddingAndSize);
  if (yAlign === "center") {
    if (xAlign === "left") {
      x2 += paddingAndSize;
    } else if (xAlign === "right") {
      x2 -= paddingAndSize;
    }
  } else if (xAlign === "left") {
    x2 -= Math.max(topLeft, bottomLeft) + caretSize;
  } else if (xAlign === "right") {
    x2 += Math.max(topRight, bottomRight) + caretSize;
  }
  return {
    x: _limitValue(x2, 0, chart.width - size2.width),
    y: _limitValue(y2, 0, chart.height - size2.height)
  };
}
function getAlignedX(tooltip, align, options) {
  const padding = toPadding(options.padding);
  return align === "center" ? tooltip.x + tooltip.width / 2 : align === "right" ? tooltip.x + tooltip.width - padding.right : tooltip.x + padding.left;
}
function getBeforeAfterBodyLines(callback2) {
  return pushOrConcat([], splitNewlines(callback2));
}
function createTooltipContext(parent, tooltip, tooltipItems) {
  return createContext(parent, {
    tooltip,
    tooltipItems,
    type: "tooltip"
  });
}
function overrideCallbacks(callbacks, context) {
  const override = context && context.dataset && context.dataset.tooltip && context.dataset.tooltip.callbacks;
  return override ? callbacks.override(override) : callbacks;
}
const defaultCallbacks = {
  beforeTitle: noop,
  title(tooltipItems) {
    if (tooltipItems.length > 0) {
      const item = tooltipItems[0];
      const labels = item.chart.data.labels;
      const labelCount = labels ? labels.length : 0;
      if (this && this.options && this.options.mode === "dataset") {
        return item.dataset.label || "";
      } else if (item.label) {
        return item.label;
      } else if (labelCount > 0 && item.dataIndex < labelCount) {
        return labels[item.dataIndex];
      }
    }
    return "";
  },
  afterTitle: noop,
  beforeBody: noop,
  beforeLabel: noop,
  label(tooltipItem) {
    if (this && this.options && this.options.mode === "dataset") {
      return tooltipItem.label + ": " + tooltipItem.formattedValue || tooltipItem.formattedValue;
    }
    let label = tooltipItem.dataset.label || "";
    if (label) {
      label += ": ";
    }
    const value = tooltipItem.formattedValue;
    if (!isNullOrUndef(value)) {
      label += value;
    }
    return label;
  },
  labelColor(tooltipItem) {
    const meta = tooltipItem.chart.getDatasetMeta(tooltipItem.datasetIndex);
    const options = meta.controller.getStyle(tooltipItem.dataIndex);
    return {
      borderColor: options.borderColor,
      backgroundColor: options.backgroundColor,
      borderWidth: options.borderWidth,
      borderDash: options.borderDash,
      borderDashOffset: options.borderDashOffset,
      borderRadius: 0
    };
  },
  labelTextColor() {
    return this.options.bodyColor;
  },
  labelPointStyle(tooltipItem) {
    const meta = tooltipItem.chart.getDatasetMeta(tooltipItem.datasetIndex);
    const options = meta.controller.getStyle(tooltipItem.dataIndex);
    return {
      pointStyle: options.pointStyle,
      rotation: options.rotation
    };
  },
  afterLabel: noop,
  afterBody: noop,
  beforeFooter: noop,
  footer: noop,
  afterFooter: noop
};
function invokeCallbackWithFallback(callbacks, name, ctx, arg) {
  const result = callbacks[name].call(ctx, arg);
  if (typeof result === "undefined") {
    return defaultCallbacks[name].call(ctx, arg);
  }
  return result;
}
class Tooltip extends Element {
  constructor(config) {
    super();
    this.opacity = 0;
    this._active = [];
    this._eventPosition = void 0;
    this._size = void 0;
    this._cachedAnimations = void 0;
    this._tooltipItems = [];
    this.$animations = void 0;
    this.$context = void 0;
    this.chart = config.chart;
    this.options = config.options;
    this.dataPoints = void 0;
    this.title = void 0;
    this.beforeBody = void 0;
    this.body = void 0;
    this.afterBody = void 0;
    this.footer = void 0;
    this.xAlign = void 0;
    this.yAlign = void 0;
    this.x = void 0;
    this.y = void 0;
    this.height = void 0;
    this.width = void 0;
    this.caretX = void 0;
    this.caretY = void 0;
    this.labelColors = void 0;
    this.labelPointStyles = void 0;
    this.labelTextColors = void 0;
  }
  initialize(options) {
    this.options = options;
    this._cachedAnimations = void 0;
    this.$context = void 0;
  }
  _resolveAnimations() {
    const cached = this._cachedAnimations;
    if (cached) {
      return cached;
    }
    const chart = this.chart;
    const options = this.options.setContext(this.getContext());
    const opts = options.enabled && chart.options.animation && options.animations;
    const animations = new Animations(this.chart, opts);
    if (opts._cacheable) {
      this._cachedAnimations = Object.freeze(animations);
    }
    return animations;
  }
  getContext() {
    return this.$context || (this.$context = createTooltipContext(this.chart.getContext(), this, this._tooltipItems));
  }
  getTitle(context, options) {
    const { callbacks } = options;
    const beforeTitle = invokeCallbackWithFallback(callbacks, "beforeTitle", this, context);
    const title2 = invokeCallbackWithFallback(callbacks, "title", this, context);
    const afterTitle = invokeCallbackWithFallback(callbacks, "afterTitle", this, context);
    let lines = [];
    lines = pushOrConcat(lines, splitNewlines(beforeTitle));
    lines = pushOrConcat(lines, splitNewlines(title2));
    lines = pushOrConcat(lines, splitNewlines(afterTitle));
    return lines;
  }
  getBeforeBody(tooltipItems, options) {
    return getBeforeAfterBodyLines(invokeCallbackWithFallback(options.callbacks, "beforeBody", this, tooltipItems));
  }
  getBody(tooltipItems, options) {
    const { callbacks } = options;
    const bodyItems = [];
    each(tooltipItems, (context) => {
      const bodyItem = {
        before: [],
        lines: [],
        after: []
      };
      const scoped = overrideCallbacks(callbacks, context);
      pushOrConcat(bodyItem.before, splitNewlines(invokeCallbackWithFallback(scoped, "beforeLabel", this, context)));
      pushOrConcat(bodyItem.lines, invokeCallbackWithFallback(scoped, "label", this, context));
      pushOrConcat(bodyItem.after, splitNewlines(invokeCallbackWithFallback(scoped, "afterLabel", this, context)));
      bodyItems.push(bodyItem);
    });
    return bodyItems;
  }
  getAfterBody(tooltipItems, options) {
    return getBeforeAfterBodyLines(invokeCallbackWithFallback(options.callbacks, "afterBody", this, tooltipItems));
  }
  getFooter(tooltipItems, options) {
    const { callbacks } = options;
    const beforeFooter = invokeCallbackWithFallback(callbacks, "beforeFooter", this, tooltipItems);
    const footer = invokeCallbackWithFallback(callbacks, "footer", this, tooltipItems);
    const afterFooter = invokeCallbackWithFallback(callbacks, "afterFooter", this, tooltipItems);
    let lines = [];
    lines = pushOrConcat(lines, splitNewlines(beforeFooter));
    lines = pushOrConcat(lines, splitNewlines(footer));
    lines = pushOrConcat(lines, splitNewlines(afterFooter));
    return lines;
  }
  _createItems(options) {
    const active = this._active;
    const data = this.chart.data;
    const labelColors = [];
    const labelPointStyles = [];
    const labelTextColors = [];
    let tooltipItems = [];
    let i, len;
    for (i = 0, len = active.length; i < len; ++i) {
      tooltipItems.push(createTooltipItem(this.chart, active[i]));
    }
    if (options.filter) {
      tooltipItems = tooltipItems.filter((element2, index, array) => options.filter(element2, index, array, data));
    }
    if (options.itemSort) {
      tooltipItems = tooltipItems.sort((a2, b2) => options.itemSort(a2, b2, data));
    }
    each(tooltipItems, (context) => {
      const scoped = overrideCallbacks(options.callbacks, context);
      labelColors.push(invokeCallbackWithFallback(scoped, "labelColor", this, context));
      labelPointStyles.push(invokeCallbackWithFallback(scoped, "labelPointStyle", this, context));
      labelTextColors.push(invokeCallbackWithFallback(scoped, "labelTextColor", this, context));
    });
    this.labelColors = labelColors;
    this.labelPointStyles = labelPointStyles;
    this.labelTextColors = labelTextColors;
    this.dataPoints = tooltipItems;
    return tooltipItems;
  }
  update(changed, replay) {
    const options = this.options.setContext(this.getContext());
    const active = this._active;
    let properties;
    let tooltipItems = [];
    if (!active.length) {
      if (this.opacity !== 0) {
        properties = {
          opacity: 0
        };
      }
    } else {
      const position2 = positioners[options.position].call(this, active, this._eventPosition);
      tooltipItems = this._createItems(options);
      this.title = this.getTitle(tooltipItems, options);
      this.beforeBody = this.getBeforeBody(tooltipItems, options);
      this.body = this.getBody(tooltipItems, options);
      this.afterBody = this.getAfterBody(tooltipItems, options);
      this.footer = this.getFooter(tooltipItems, options);
      const size2 = this._size = getTooltipSize(this, options);
      const positionAndSize = Object.assign({}, position2, size2);
      const alignment = determineAlignment(this.chart, options, positionAndSize);
      const backgroundPoint = getBackgroundPoint(options, positionAndSize, alignment, this.chart);
      this.xAlign = alignment.xAlign;
      this.yAlign = alignment.yAlign;
      properties = {
        opacity: 1,
        x: backgroundPoint.x,
        y: backgroundPoint.y,
        width: size2.width,
        height: size2.height,
        caretX: position2.x,
        caretY: position2.y
      };
    }
    this._tooltipItems = tooltipItems;
    this.$context = void 0;
    if (properties) {
      this._resolveAnimations().update(this, properties);
    }
    if (changed && options.external) {
      options.external.call(this, {
        chart: this.chart,
        tooltip: this,
        replay
      });
    }
  }
  drawCaret(tooltipPoint, ctx, size2, options) {
    const caretPosition = this.getCaretPosition(tooltipPoint, size2, options);
    ctx.lineTo(caretPosition.x1, caretPosition.y1);
    ctx.lineTo(caretPosition.x2, caretPosition.y2);
    ctx.lineTo(caretPosition.x3, caretPosition.y3);
  }
  getCaretPosition(tooltipPoint, size2, options) {
    const { xAlign, yAlign } = this;
    const { caretSize, cornerRadius } = options;
    const { topLeft, topRight, bottomLeft, bottomRight } = toTRBLCorners(cornerRadius);
    const { x: ptX, y: ptY } = tooltipPoint;
    const { width, height } = size2;
    let x1, x2, x3, y1, y2, y3;
    if (yAlign === "center") {
      y2 = ptY + height / 2;
      if (xAlign === "left") {
        x1 = ptX;
        x2 = x1 - caretSize;
        y1 = y2 + caretSize;
        y3 = y2 - caretSize;
      } else {
        x1 = ptX + width;
        x2 = x1 + caretSize;
        y1 = y2 - caretSize;
        y3 = y2 + caretSize;
      }
      x3 = x1;
    } else {
      if (xAlign === "left") {
        x2 = ptX + Math.max(topLeft, bottomLeft) + caretSize;
      } else if (xAlign === "right") {
        x2 = ptX + width - Math.max(topRight, bottomRight) - caretSize;
      } else {
        x2 = this.caretX;
      }
      if (yAlign === "top") {
        y1 = ptY;
        y2 = y1 - caretSize;
        x1 = x2 - caretSize;
        x3 = x2 + caretSize;
      } else {
        y1 = ptY + height;
        y2 = y1 + caretSize;
        x1 = x2 + caretSize;
        x3 = x2 - caretSize;
      }
      y3 = y1;
    }
    return {
      x1,
      x2,
      x3,
      y1,
      y2,
      y3
    };
  }
  drawTitle(pt2, ctx, options) {
    const title2 = this.title;
    const length = title2.length;
    let titleFont, titleSpacing, i;
    if (length) {
      const rtlHelper = getRtlAdapter(options.rtl, this.x, this.width);
      pt2.x = getAlignedX(this, options.titleAlign, options);
      ctx.textAlign = rtlHelper.textAlign(options.titleAlign);
      ctx.textBaseline = "middle";
      titleFont = toFont(options.titleFont);
      titleSpacing = options.titleSpacing;
      ctx.fillStyle = options.titleColor;
      ctx.font = titleFont.string;
      for (i = 0; i < length; ++i) {
        ctx.fillText(title2[i], rtlHelper.x(pt2.x), pt2.y + titleFont.lineHeight / 2);
        pt2.y += titleFont.lineHeight + titleSpacing;
        if (i + 1 === length) {
          pt2.y += options.titleMarginBottom - titleSpacing;
        }
      }
    }
  }
  _drawColorBox(ctx, pt2, i, rtlHelper, options) {
    const labelColor = this.labelColors[i];
    const labelPointStyle = this.labelPointStyles[i];
    const { boxHeight, boxWidth } = options;
    const bodyFont = toFont(options.bodyFont);
    const colorX = getAlignedX(this, "left", options);
    const rtlColorX = rtlHelper.x(colorX);
    const yOffSet = boxHeight < bodyFont.lineHeight ? (bodyFont.lineHeight - boxHeight) / 2 : 0;
    const colorY = pt2.y + yOffSet;
    if (options.usePointStyle) {
      const drawOptions = {
        radius: Math.min(boxWidth, boxHeight) / 2,
        pointStyle: labelPointStyle.pointStyle,
        rotation: labelPointStyle.rotation,
        borderWidth: 1
      };
      const centerX = rtlHelper.leftForLtr(rtlColorX, boxWidth) + boxWidth / 2;
      const centerY = colorY + boxHeight / 2;
      ctx.strokeStyle = options.multiKeyBackground;
      ctx.fillStyle = options.multiKeyBackground;
      drawPoint(ctx, drawOptions, centerX, centerY);
      ctx.strokeStyle = labelColor.borderColor;
      ctx.fillStyle = labelColor.backgroundColor;
      drawPoint(ctx, drawOptions, centerX, centerY);
    } else {
      ctx.lineWidth = isObject(labelColor.borderWidth) ? Math.max(...Object.values(labelColor.borderWidth)) : labelColor.borderWidth || 1;
      ctx.strokeStyle = labelColor.borderColor;
      ctx.setLineDash(labelColor.borderDash || []);
      ctx.lineDashOffset = labelColor.borderDashOffset || 0;
      const outerX = rtlHelper.leftForLtr(rtlColorX, boxWidth);
      const innerX = rtlHelper.leftForLtr(rtlHelper.xPlus(rtlColorX, 1), boxWidth - 2);
      const borderRadius = toTRBLCorners(labelColor.borderRadius);
      if (Object.values(borderRadius).some((v2) => v2 !== 0)) {
        ctx.beginPath();
        ctx.fillStyle = options.multiKeyBackground;
        addRoundedRectPath(ctx, {
          x: outerX,
          y: colorY,
          w: boxWidth,
          h: boxHeight,
          radius: borderRadius
        });
        ctx.fill();
        ctx.stroke();
        ctx.fillStyle = labelColor.backgroundColor;
        ctx.beginPath();
        addRoundedRectPath(ctx, {
          x: innerX,
          y: colorY + 1,
          w: boxWidth - 2,
          h: boxHeight - 2,
          radius: borderRadius
        });
        ctx.fill();
      } else {
        ctx.fillStyle = options.multiKeyBackground;
        ctx.fillRect(outerX, colorY, boxWidth, boxHeight);
        ctx.strokeRect(outerX, colorY, boxWidth, boxHeight);
        ctx.fillStyle = labelColor.backgroundColor;
        ctx.fillRect(innerX, colorY + 1, boxWidth - 2, boxHeight - 2);
      }
    }
    ctx.fillStyle = this.labelTextColors[i];
  }
  drawBody(pt2, ctx, options) {
    const { body } = this;
    const { bodySpacing, bodyAlign, displayColors, boxHeight, boxWidth, boxPadding } = options;
    const bodyFont = toFont(options.bodyFont);
    let bodyLineHeight = bodyFont.lineHeight;
    let xLinePadding = 0;
    const rtlHelper = getRtlAdapter(options.rtl, this.x, this.width);
    const fillLineOfText = function(line) {
      ctx.fillText(line, rtlHelper.x(pt2.x + xLinePadding), pt2.y + bodyLineHeight / 2);
      pt2.y += bodyLineHeight + bodySpacing;
    };
    const bodyAlignForCalculation = rtlHelper.textAlign(bodyAlign);
    let bodyItem, textColor, lines, i, j2, ilen, jlen;
    ctx.textAlign = bodyAlign;
    ctx.textBaseline = "middle";
    ctx.font = bodyFont.string;
    pt2.x = getAlignedX(this, bodyAlignForCalculation, options);
    ctx.fillStyle = options.bodyColor;
    each(this.beforeBody, fillLineOfText);
    xLinePadding = displayColors && bodyAlignForCalculation !== "right" ? bodyAlign === "center" ? boxWidth / 2 + boxPadding : boxWidth + 2 + boxPadding : 0;
    for (i = 0, ilen = body.length; i < ilen; ++i) {
      bodyItem = body[i];
      textColor = this.labelTextColors[i];
      ctx.fillStyle = textColor;
      each(bodyItem.before, fillLineOfText);
      lines = bodyItem.lines;
      if (displayColors && lines.length) {
        this._drawColorBox(ctx, pt2, i, rtlHelper, options);
        bodyLineHeight = Math.max(bodyFont.lineHeight, boxHeight);
      }
      for (j2 = 0, jlen = lines.length; j2 < jlen; ++j2) {
        fillLineOfText(lines[j2]);
        bodyLineHeight = bodyFont.lineHeight;
      }
      each(bodyItem.after, fillLineOfText);
    }
    xLinePadding = 0;
    bodyLineHeight = bodyFont.lineHeight;
    each(this.afterBody, fillLineOfText);
    pt2.y -= bodySpacing;
  }
  drawFooter(pt2, ctx, options) {
    const footer = this.footer;
    const length = footer.length;
    let footerFont, i;
    if (length) {
      const rtlHelper = getRtlAdapter(options.rtl, this.x, this.width);
      pt2.x = getAlignedX(this, options.footerAlign, options);
      pt2.y += options.footerMarginTop;
      ctx.textAlign = rtlHelper.textAlign(options.footerAlign);
      ctx.textBaseline = "middle";
      footerFont = toFont(options.footerFont);
      ctx.fillStyle = options.footerColor;
      ctx.font = footerFont.string;
      for (i = 0; i < length; ++i) {
        ctx.fillText(footer[i], rtlHelper.x(pt2.x), pt2.y + footerFont.lineHeight / 2);
        pt2.y += footerFont.lineHeight + options.footerSpacing;
      }
    }
  }
  drawBackground(pt2, ctx, tooltipSize, options) {
    const { xAlign, yAlign } = this;
    const { x: x2, y: y2 } = pt2;
    const { width, height } = tooltipSize;
    const { topLeft, topRight, bottomLeft, bottomRight } = toTRBLCorners(options.cornerRadius);
    ctx.fillStyle = options.backgroundColor;
    ctx.strokeStyle = options.borderColor;
    ctx.lineWidth = options.borderWidth;
    ctx.beginPath();
    ctx.moveTo(x2 + topLeft, y2);
    if (yAlign === "top") {
      this.drawCaret(pt2, ctx, tooltipSize, options);
    }
    ctx.lineTo(x2 + width - topRight, y2);
    ctx.quadraticCurveTo(x2 + width, y2, x2 + width, y2 + topRight);
    if (yAlign === "center" && xAlign === "right") {
      this.drawCaret(pt2, ctx, tooltipSize, options);
    }
    ctx.lineTo(x2 + width, y2 + height - bottomRight);
    ctx.quadraticCurveTo(x2 + width, y2 + height, x2 + width - bottomRight, y2 + height);
    if (yAlign === "bottom") {
      this.drawCaret(pt2, ctx, tooltipSize, options);
    }
    ctx.lineTo(x2 + bottomLeft, y2 + height);
    ctx.quadraticCurveTo(x2, y2 + height, x2, y2 + height - bottomLeft);
    if (yAlign === "center" && xAlign === "left") {
      this.drawCaret(pt2, ctx, tooltipSize, options);
    }
    ctx.lineTo(x2, y2 + topLeft);
    ctx.quadraticCurveTo(x2, y2, x2 + topLeft, y2);
    ctx.closePath();
    ctx.fill();
    if (options.borderWidth > 0) {
      ctx.stroke();
    }
  }
  _updateAnimationTarget(options) {
    const chart = this.chart;
    const anims = this.$animations;
    const animX = anims && anims.x;
    const animY = anims && anims.y;
    if (animX || animY) {
      const position2 = positioners[options.position].call(this, this._active, this._eventPosition);
      if (!position2) {
        return;
      }
      const size2 = this._size = getTooltipSize(this, options);
      const positionAndSize = Object.assign({}, position2, this._size);
      const alignment = determineAlignment(chart, options, positionAndSize);
      const point = getBackgroundPoint(options, positionAndSize, alignment, chart);
      if (animX._to !== point.x || animY._to !== point.y) {
        this.xAlign = alignment.xAlign;
        this.yAlign = alignment.yAlign;
        this.width = size2.width;
        this.height = size2.height;
        this.caretX = position2.x;
        this.caretY = position2.y;
        this._resolveAnimations().update(this, point);
      }
    }
  }
  _willRender() {
    return !!this.opacity;
  }
  draw(ctx) {
    const options = this.options.setContext(this.getContext());
    let opacity = this.opacity;
    if (!opacity) {
      return;
    }
    this._updateAnimationTarget(options);
    const tooltipSize = {
      width: this.width,
      height: this.height
    };
    const pt2 = {
      x: this.x,
      y: this.y
    };
    opacity = Math.abs(opacity) < 1e-3 ? 0 : opacity;
    const padding = toPadding(options.padding);
    const hasTooltipContent = this.title.length || this.beforeBody.length || this.body.length || this.afterBody.length || this.footer.length;
    if (options.enabled && hasTooltipContent) {
      ctx.save();
      ctx.globalAlpha = opacity;
      this.drawBackground(pt2, ctx, tooltipSize, options);
      overrideTextDirection(ctx, options.textDirection);
      pt2.y += padding.top;
      this.drawTitle(pt2, ctx, options);
      this.drawBody(pt2, ctx, options);
      this.drawFooter(pt2, ctx, options);
      restoreTextDirection(ctx, options.textDirection);
      ctx.restore();
    }
  }
  getActiveElements() {
    return this._active || [];
  }
  setActiveElements(activeElements, eventPosition) {
    const lastActive = this._active;
    const active = activeElements.map(({ datasetIndex, index }) => {
      const meta = this.chart.getDatasetMeta(datasetIndex);
      if (!meta) {
        throw new Error("Cannot find a dataset at index " + datasetIndex);
      }
      return {
        datasetIndex,
        element: meta.data[index],
        index
      };
    });
    const changed = !_elementsEqual(lastActive, active);
    const positionChanged = this._positionChanged(active, eventPosition);
    if (changed || positionChanged) {
      this._active = active;
      this._eventPosition = eventPosition;
      this._ignoreReplayEvents = true;
      this.update(true);
    }
  }
  handleEvent(e2, replay, inChartArea = true) {
    if (replay && this._ignoreReplayEvents) {
      return false;
    }
    this._ignoreReplayEvents = false;
    const options = this.options;
    const lastActive = this._active || [];
    const active = this._getActiveElements(e2, lastActive, replay, inChartArea);
    const positionChanged = this._positionChanged(active, e2);
    const changed = replay || !_elementsEqual(active, lastActive) || positionChanged;
    if (changed) {
      this._active = active;
      if (options.enabled || options.external) {
        this._eventPosition = {
          x: e2.x,
          y: e2.y
        };
        this.update(true, replay);
      }
    }
    return changed;
  }
  _getActiveElements(e2, lastActive, replay, inChartArea) {
    const options = this.options;
    if (e2.type === "mouseout") {
      return [];
    }
    if (!inChartArea) {
      return lastActive;
    }
    const active = this.chart.getElementsAtEventForMode(e2, options.mode, options, replay);
    if (options.reverse) {
      active.reverse();
    }
    return active;
  }
  _positionChanged(active, e2) {
    const { caretX, caretY, options } = this;
    const position2 = positioners[options.position].call(this, active, e2);
    return position2 !== false && (caretX !== position2.x || caretY !== position2.y);
  }
}
__publicField(Tooltip, "positioners", positioners);
var plugin_tooltip = {
  id: "tooltip",
  _element: Tooltip,
  positioners,
  afterInit(chart, _args, options) {
    if (options) {
      chart.tooltip = new Tooltip({
        chart,
        options
      });
    }
  },
  beforeUpdate(chart, _args, options) {
    if (chart.tooltip) {
      chart.tooltip.initialize(options);
    }
  },
  reset(chart, _args, options) {
    if (chart.tooltip) {
      chart.tooltip.initialize(options);
    }
  },
  afterDraw(chart) {
    const tooltip = chart.tooltip;
    if (tooltip && tooltip._willRender()) {
      const args = {
        tooltip
      };
      if (chart.notifyPlugins("beforeTooltipDraw", {
        ...args,
        cancelable: true
      }) === false) {
        return;
      }
      tooltip.draw(chart.ctx);
      chart.notifyPlugins("afterTooltipDraw", args);
    }
  },
  afterEvent(chart, args) {
    if (chart.tooltip) {
      const useFinalPosition = args.replay;
      if (chart.tooltip.handleEvent(args.event, useFinalPosition, args.inChartArea)) {
        args.changed = true;
      }
    }
  },
  defaults: {
    enabled: true,
    external: null,
    position: "average",
    backgroundColor: "rgba(0,0,0,0.8)",
    titleColor: "#fff",
    titleFont: {
      weight: "bold"
    },
    titleSpacing: 2,
    titleMarginBottom: 6,
    titleAlign: "left",
    bodyColor: "#fff",
    bodySpacing: 2,
    bodyFont: {},
    bodyAlign: "left",
    footerColor: "#fff",
    footerSpacing: 2,
    footerMarginTop: 6,
    footerFont: {
      weight: "bold"
    },
    footerAlign: "left",
    padding: 6,
    caretPadding: 2,
    caretSize: 5,
    cornerRadius: 6,
    boxHeight: (ctx, opts) => opts.bodyFont.size,
    boxWidth: (ctx, opts) => opts.bodyFont.size,
    multiKeyBackground: "#fff",
    displayColors: true,
    boxPadding: 0,
    borderColor: "rgba(0,0,0,0)",
    borderWidth: 0,
    animation: {
      duration: 400,
      easing: "easeOutQuart"
    },
    animations: {
      numbers: {
        type: "number",
        properties: [
          "x",
          "y",
          "width",
          "height",
          "caretX",
          "caretY"
        ]
      },
      opacity: {
        easing: "linear",
        duration: 200
      }
    },
    callbacks: defaultCallbacks
  },
  defaultRoutes: {
    bodyFont: "font",
    footerFont: "font",
    titleFont: "font"
  },
  descriptors: {
    _scriptable: (name) => name !== "filter" && name !== "itemSort" && name !== "external",
    _indexable: false,
    callbacks: {
      _scriptable: false,
      _indexable: false
    },
    animation: {
      _fallback: false
    },
    animations: {
      _fallback: "animation"
    }
  },
  additionalOptionScopes: [
    "interaction"
  ]
};
const addIfString = (labels, raw, index, addedLabels) => {
  if (typeof raw === "string") {
    index = labels.push(raw) - 1;
    addedLabels.unshift({
      index,
      label: raw
    });
  } else if (isNaN(raw)) {
    index = null;
  }
  return index;
};
function findOrAddLabel(labels, raw, index, addedLabels) {
  const first = labels.indexOf(raw);
  if (first === -1) {
    return addIfString(labels, raw, index, addedLabels);
  }
  const last = labels.lastIndexOf(raw);
  return first !== last ? index : first;
}
const validIndex = (index, max) => index === null ? null : _limitValue(Math.round(index), 0, max);
function _getLabelForValue(value) {
  const labels = this.getLabels();
  if (value >= 0 && value < labels.length) {
    return labels[value];
  }
  return value;
}
class CategoryScale extends Scale {
  constructor(cfg) {
    super(cfg);
    this._startValue = void 0;
    this._valueRange = 0;
    this._addedLabels = [];
  }
  init(scaleOptions) {
    const added = this._addedLabels;
    if (added.length) {
      const labels = this.getLabels();
      for (const { index, label } of added) {
        if (labels[index] === label) {
          labels.splice(index, 1);
        }
      }
      this._addedLabels = [];
    }
    super.init(scaleOptions);
  }
  parse(raw, index) {
    if (isNullOrUndef(raw)) {
      return null;
    }
    const labels = this.getLabels();
    index = isFinite(index) && labels[index] === raw ? index : findOrAddLabel(labels, raw, valueOrDefault(index, raw), this._addedLabels);
    return validIndex(index, labels.length - 1);
  }
  determineDataLimits() {
    const { minDefined, maxDefined } = this.getUserBounds();
    let { min, max } = this.getMinMax(true);
    if (this.options.bounds === "ticks") {
      if (!minDefined) {
        min = 0;
      }
      if (!maxDefined) {
        max = this.getLabels().length - 1;
      }
    }
    this.min = min;
    this.max = max;
  }
  buildTicks() {
    const min = this.min;
    const max = this.max;
    const offset = this.options.offset;
    const ticks = [];
    let labels = this.getLabels();
    labels = min === 0 && max === labels.length - 1 ? labels : labels.slice(min, max + 1);
    this._valueRange = Math.max(labels.length - (offset ? 0 : 1), 1);
    this._startValue = this.min - (offset ? 0.5 : 0);
    for (let value = min; value <= max; value++) {
      ticks.push({
        value
      });
    }
    return ticks;
  }
  getLabelForValue(value) {
    return _getLabelForValue.call(this, value);
  }
  configure() {
    super.configure();
    if (!this.isHorizontal()) {
      this._reversePixels = !this._reversePixels;
    }
  }
  getPixelForValue(value) {
    if (typeof value !== "number") {
      value = this.parse(value);
    }
    return value === null ? NaN : this.getPixelForDecimal((value - this._startValue) / this._valueRange);
  }
  getPixelForTick(index) {
    const ticks = this.ticks;
    if (index < 0 || index > ticks.length - 1) {
      return null;
    }
    return this.getPixelForValue(ticks[index].value);
  }
  getValueForPixel(pixel) {
    return Math.round(this._startValue + this.getDecimalForPixel(pixel) * this._valueRange);
  }
  getBasePixel() {
    return this.bottom;
  }
}
__publicField(CategoryScale, "id", "category");
__publicField(CategoryScale, "defaults", {
  ticks: {
    callback: _getLabelForValue
  }
});
function generateTicks$1(generationOptions, dataRange) {
  const ticks = [];
  const MIN_SPACING = 1e-14;
  const { bounds, step, min, max, precision, count, maxTicks, maxDigits, includeBounds } = generationOptions;
  const unit = step || 1;
  const maxSpaces = maxTicks - 1;
  const { min: rmin, max: rmax } = dataRange;
  const minDefined = !isNullOrUndef(min);
  const maxDefined = !isNullOrUndef(max);
  const countDefined = !isNullOrUndef(count);
  const minSpacing = (rmax - rmin) / (maxDigits + 1);
  let spacing = niceNum((rmax - rmin) / maxSpaces / unit) * unit;
  let factor, niceMin, niceMax, numSpaces;
  if (spacing < MIN_SPACING && !minDefined && !maxDefined) {
    return [
      {
        value: rmin
      },
      {
        value: rmax
      }
    ];
  }
  numSpaces = Math.ceil(rmax / spacing) - Math.floor(rmin / spacing);
  if (numSpaces > maxSpaces) {
    spacing = niceNum(numSpaces * spacing / maxSpaces / unit) * unit;
  }
  if (!isNullOrUndef(precision)) {
    factor = Math.pow(10, precision);
    spacing = Math.ceil(spacing * factor) / factor;
  }
  if (bounds === "ticks") {
    niceMin = Math.floor(rmin / spacing) * spacing;
    niceMax = Math.ceil(rmax / spacing) * spacing;
  } else {
    niceMin = rmin;
    niceMax = rmax;
  }
  if (minDefined && maxDefined && step && almostWhole((max - min) / step, spacing / 1e3)) {
    numSpaces = Math.round(Math.min((max - min) / spacing, maxTicks));
    spacing = (max - min) / numSpaces;
    niceMin = min;
    niceMax = max;
  } else if (countDefined) {
    niceMin = minDefined ? min : niceMin;
    niceMax = maxDefined ? max : niceMax;
    numSpaces = count - 1;
    spacing = (niceMax - niceMin) / numSpaces;
  } else {
    numSpaces = (niceMax - niceMin) / spacing;
    if (almostEquals(numSpaces, Math.round(numSpaces), spacing / 1e3)) {
      numSpaces = Math.round(numSpaces);
    } else {
      numSpaces = Math.ceil(numSpaces);
    }
  }
  const decimalPlaces = Math.max(_decimalPlaces(spacing), _decimalPlaces(niceMin));
  factor = Math.pow(10, isNullOrUndef(precision) ? decimalPlaces : precision);
  niceMin = Math.round(niceMin * factor) / factor;
  niceMax = Math.round(niceMax * factor) / factor;
  let j2 = 0;
  if (minDefined) {
    if (includeBounds && niceMin !== min) {
      ticks.push({
        value: min
      });
      if (niceMin < min) {
        j2++;
      }
      if (almostEquals(Math.round((niceMin + j2 * spacing) * factor) / factor, min, relativeLabelSize(min, minSpacing, generationOptions))) {
        j2++;
      }
    } else if (niceMin < min) {
      j2++;
    }
  }
  for (; j2 < numSpaces; ++j2) {
    const tickValue = Math.round((niceMin + j2 * spacing) * factor) / factor;
    if (maxDefined && tickValue > max) {
      break;
    }
    ticks.push({
      value: tickValue
    });
  }
  if (maxDefined && includeBounds && niceMax !== max) {
    if (ticks.length && almostEquals(ticks[ticks.length - 1].value, max, relativeLabelSize(max, minSpacing, generationOptions))) {
      ticks[ticks.length - 1].value = max;
    } else {
      ticks.push({
        value: max
      });
    }
  } else if (!maxDefined || niceMax === max) {
    ticks.push({
      value: niceMax
    });
  }
  return ticks;
}
function relativeLabelSize(value, minSpacing, { horizontal, minRotation }) {
  const rad = toRadians(minRotation);
  const ratio = (horizontal ? Math.sin(rad) : Math.cos(rad)) || 1e-3;
  const length = 0.75 * minSpacing * ("" + value).length;
  return Math.min(minSpacing / ratio, length);
}
class LinearScaleBase extends Scale {
  constructor(cfg) {
    super(cfg);
    this.start = void 0;
    this.end = void 0;
    this._startValue = void 0;
    this._endValue = void 0;
    this._valueRange = 0;
  }
  parse(raw, index) {
    if (isNullOrUndef(raw)) {
      return null;
    }
    if ((typeof raw === "number" || raw instanceof Number) && !isFinite(+raw)) {
      return null;
    }
    return +raw;
  }
  handleTickRangeOptions() {
    const { beginAtZero } = this.options;
    const { minDefined, maxDefined } = this.getUserBounds();
    let { min, max } = this;
    const setMin = (v2) => min = minDefined ? min : v2;
    const setMax = (v2) => max = maxDefined ? max : v2;
    if (beginAtZero) {
      const minSign = sign$2(min);
      const maxSign = sign$2(max);
      if (minSign < 0 && maxSign < 0) {
        setMax(0);
      } else if (minSign > 0 && maxSign > 0) {
        setMin(0);
      }
    }
    if (min === max) {
      let offset = max === 0 ? 1 : Math.abs(max * 0.05);
      setMax(max + offset);
      if (!beginAtZero) {
        setMin(min - offset);
      }
    }
    this.min = min;
    this.max = max;
  }
  getTickLimit() {
    const tickOpts = this.options.ticks;
    let { maxTicksLimit, stepSize } = tickOpts;
    let maxTicks;
    if (stepSize) {
      maxTicks = Math.ceil(this.max / stepSize) - Math.floor(this.min / stepSize) + 1;
      if (maxTicks > 1e3) {
        console.warn(`scales.${this.id}.ticks.stepSize: ${stepSize} would result generating up to ${maxTicks} ticks. Limiting to 1000.`);
        maxTicks = 1e3;
      }
    } else {
      maxTicks = this.computeTickLimit();
      maxTicksLimit = maxTicksLimit || 11;
    }
    if (maxTicksLimit) {
      maxTicks = Math.min(maxTicksLimit, maxTicks);
    }
    return maxTicks;
  }
  computeTickLimit() {
    return Number.POSITIVE_INFINITY;
  }
  buildTicks() {
    const opts = this.options;
    const tickOpts = opts.ticks;
    let maxTicks = this.getTickLimit();
    maxTicks = Math.max(2, maxTicks);
    const numericGeneratorOptions = {
      maxTicks,
      bounds: opts.bounds,
      min: opts.min,
      max: opts.max,
      precision: tickOpts.precision,
      step: tickOpts.stepSize,
      count: tickOpts.count,
      maxDigits: this._maxDigits(),
      horizontal: this.isHorizontal(),
      minRotation: tickOpts.minRotation || 0,
      includeBounds: tickOpts.includeBounds !== false
    };
    const dataRange = this._range || this;
    const ticks = generateTicks$1(numericGeneratorOptions, dataRange);
    if (opts.bounds === "ticks") {
      _setMinAndMaxByKey(ticks, this, "value");
    }
    if (opts.reverse) {
      ticks.reverse();
      this.start = this.max;
      this.end = this.min;
    } else {
      this.start = this.min;
      this.end = this.max;
    }
    return ticks;
  }
  configure() {
    const ticks = this.ticks;
    let start = this.min;
    let end = this.max;
    super.configure();
    if (this.options.offset && ticks.length) {
      const offset = (end - start) / Math.max(ticks.length - 1, 1) / 2;
      start -= offset;
      end += offset;
    }
    this._startValue = start;
    this._endValue = end;
    this._valueRange = end - start;
  }
  getLabelForValue(value) {
    return formatNumber(value, this.chart.options.locale, this.options.ticks.format);
  }
}
class LinearScale extends LinearScaleBase {
  determineDataLimits() {
    const { min, max } = this.getMinMax(true);
    this.min = isNumberFinite(min) ? min : 0;
    this.max = isNumberFinite(max) ? max : 1;
    this.handleTickRangeOptions();
  }
  computeTickLimit() {
    const horizontal = this.isHorizontal();
    const length = horizontal ? this.width : this.height;
    const minRotation = toRadians(this.options.ticks.minRotation);
    const ratio = (horizontal ? Math.sin(minRotation) : Math.cos(minRotation)) || 1e-3;
    const tickFont = this._resolveTickFontOptions(0);
    return Math.ceil(length / Math.min(40, tickFont.lineHeight / ratio));
  }
  getPixelForValue(value) {
    return value === null ? NaN : this.getPixelForDecimal((value - this._startValue) / this._valueRange);
  }
  getValueForPixel(pixel) {
    return this._startValue + this.getDecimalForPixel(pixel) * this._valueRange;
  }
}
__publicField(LinearScale, "id", "linear");
__publicField(LinearScale, "defaults", {
  ticks: {
    callback: Ticks.formatters.numeric
  }
});
const log10Floor = (v2) => Math.floor(log10(v2));
const changeExponent = (v2, m2) => Math.pow(10, log10Floor(v2) + m2);
function isMajor(tickVal) {
  const remain = tickVal / Math.pow(10, log10Floor(tickVal));
  return remain === 1;
}
function steps(min, max, rangeExp) {
  const rangeStep = Math.pow(10, rangeExp);
  const start = Math.floor(min / rangeStep);
  const end = Math.ceil(max / rangeStep);
  return end - start;
}
function startExp(min, max) {
  const range = max - min;
  let rangeExp = log10Floor(range);
  while (steps(min, max, rangeExp) > 10) {
    rangeExp++;
  }
  while (steps(min, max, rangeExp) < 10) {
    rangeExp--;
  }
  return Math.min(rangeExp, log10Floor(min));
}
function generateTicks(generationOptions, { min, max }) {
  min = finiteOrDefault(generationOptions.min, min);
  const ticks = [];
  const minExp = log10Floor(min);
  let exp = startExp(min, max);
  let precision = exp < 0 ? Math.pow(10, Math.abs(exp)) : 1;
  const stepSize = Math.pow(10, exp);
  const base = minExp > exp ? Math.pow(10, minExp) : 0;
  const start = Math.round((min - base) * precision) / precision;
  const offset = Math.floor((min - base) / stepSize / 10) * stepSize * 10;
  let significand = Math.floor((start - offset) / Math.pow(10, exp));
  let value = finiteOrDefault(generationOptions.min, Math.round((base + offset + significand * Math.pow(10, exp)) * precision) / precision);
  while (value < max) {
    ticks.push({
      value,
      major: isMajor(value),
      significand
    });
    if (significand >= 10) {
      significand = significand < 15 ? 15 : 20;
    } else {
      significand++;
    }
    if (significand >= 20) {
      exp++;
      significand = 2;
      precision = exp >= 0 ? 1 : precision;
    }
    value = Math.round((base + offset + significand * Math.pow(10, exp)) * precision) / precision;
  }
  const lastTick = finiteOrDefault(generationOptions.max, value);
  ticks.push({
    value: lastTick,
    major: isMajor(lastTick),
    significand
  });
  return ticks;
}
class LogarithmicScale extends Scale {
  constructor(cfg) {
    super(cfg);
    this.start = void 0;
    this.end = void 0;
    this._startValue = void 0;
    this._valueRange = 0;
  }
  parse(raw, index) {
    const value = LinearScaleBase.prototype.parse.apply(this, [
      raw,
      index
    ]);
    if (value === 0) {
      this._zero = true;
      return void 0;
    }
    return isNumberFinite(value) && value > 0 ? value : null;
  }
  determineDataLimits() {
    const { min, max } = this.getMinMax(true);
    this.min = isNumberFinite(min) ? Math.max(0, min) : null;
    this.max = isNumberFinite(max) ? Math.max(0, max) : null;
    if (this.options.beginAtZero) {
      this._zero = true;
    }
    if (this._zero && this.min !== this._suggestedMin && !isNumberFinite(this._userMin)) {
      this.min = min === changeExponent(this.min, 0) ? changeExponent(this.min, -1) : changeExponent(this.min, 0);
    }
    this.handleTickRangeOptions();
  }
  handleTickRangeOptions() {
    const { minDefined, maxDefined } = this.getUserBounds();
    let min = this.min;
    let max = this.max;
    const setMin = (v2) => min = minDefined ? min : v2;
    const setMax = (v2) => max = maxDefined ? max : v2;
    if (min === max) {
      if (min <= 0) {
        setMin(1);
        setMax(10);
      } else {
        setMin(changeExponent(min, -1));
        setMax(changeExponent(max, 1));
      }
    }
    if (min <= 0) {
      setMin(changeExponent(max, -1));
    }
    if (max <= 0) {
      setMax(changeExponent(min, 1));
    }
    this.min = min;
    this.max = max;
  }
  buildTicks() {
    const opts = this.options;
    const generationOptions = {
      min: this._userMin,
      max: this._userMax
    };
    const ticks = generateTicks(generationOptions, this);
    if (opts.bounds === "ticks") {
      _setMinAndMaxByKey(ticks, this, "value");
    }
    if (opts.reverse) {
      ticks.reverse();
      this.start = this.max;
      this.end = this.min;
    } else {
      this.start = this.min;
      this.end = this.max;
    }
    return ticks;
  }
  getLabelForValue(value) {
    return value === void 0 ? "0" : formatNumber(value, this.chart.options.locale, this.options.ticks.format);
  }
  configure() {
    const start = this.min;
    super.configure();
    this._startValue = log10(start);
    this._valueRange = log10(this.max) - log10(start);
  }
  getPixelForValue(value) {
    if (value === void 0 || value === 0) {
      value = this.min;
    }
    if (value === null || isNaN(value)) {
      return NaN;
    }
    return this.getPixelForDecimal(value === this.min ? 0 : (log10(value) - this._startValue) / this._valueRange);
  }
  getValueForPixel(pixel) {
    const decimal = this.getDecimalForPixel(pixel);
    return Math.pow(10, this._startValue + decimal * this._valueRange);
  }
}
__publicField(LogarithmicScale, "id", "logarithmic");
__publicField(LogarithmicScale, "defaults", {
  ticks: {
    callback: Ticks.formatters.logarithmic,
    major: {
      enabled: true
    }
  }
});
function getTickBackdropHeight(opts) {
  const tickOpts = opts.ticks;
  if (tickOpts.display && opts.display) {
    const padding = toPadding(tickOpts.backdropPadding);
    return valueOrDefault(tickOpts.font && tickOpts.font.size, defaults.font.size) + padding.height;
  }
  return 0;
}
function measureLabelSize(ctx, font, label) {
  label = isArray(label) ? label : [
    label
  ];
  return {
    w: _longestText(ctx, font.string, label),
    h: label.length * font.lineHeight
  };
}
function determineLimits(angle, pos, size2, min, max) {
  if (angle === min || angle === max) {
    return {
      start: pos - size2 / 2,
      end: pos + size2 / 2
    };
  } else if (angle < min || angle > max) {
    return {
      start: pos - size2,
      end: pos
    };
  }
  return {
    start: pos,
    end: pos + size2
  };
}
function fitWithPointLabels(scale) {
  const orig = {
    l: scale.left + scale._padding.left,
    r: scale.right - scale._padding.right,
    t: scale.top + scale._padding.top,
    b: scale.bottom - scale._padding.bottom
  };
  const limits = Object.assign({}, orig);
  const labelSizes = [];
  const padding = [];
  const valueCount = scale._pointLabels.length;
  const pointLabelOpts = scale.options.pointLabels;
  const additionalAngle = pointLabelOpts.centerPointLabels ? PI / valueCount : 0;
  for (let i = 0; i < valueCount; i++) {
    const opts = pointLabelOpts.setContext(scale.getPointLabelContext(i));
    padding[i] = opts.padding;
    const pointPosition = scale.getPointPosition(i, scale.drawingArea + padding[i], additionalAngle);
    const plFont = toFont(opts.font);
    const textSize = measureLabelSize(scale.ctx, plFont, scale._pointLabels[i]);
    labelSizes[i] = textSize;
    const angleRadians = _normalizeAngle(scale.getIndexAngle(i) + additionalAngle);
    const angle = Math.round(toDegrees(angleRadians));
    const hLimits = determineLimits(angle, pointPosition.x, textSize.w, 0, 180);
    const vLimits = determineLimits(angle, pointPosition.y, textSize.h, 90, 270);
    updateLimits(limits, orig, angleRadians, hLimits, vLimits);
  }
  scale.setCenterPoint(orig.l - limits.l, limits.r - orig.r, orig.t - limits.t, limits.b - orig.b);
  scale._pointLabelItems = buildPointLabelItems(scale, labelSizes, padding);
}
function updateLimits(limits, orig, angle, hLimits, vLimits) {
  const sin = Math.abs(Math.sin(angle));
  const cos = Math.abs(Math.cos(angle));
  let x2 = 0;
  let y2 = 0;
  if (hLimits.start < orig.l) {
    x2 = (orig.l - hLimits.start) / sin;
    limits.l = Math.min(limits.l, orig.l - x2);
  } else if (hLimits.end > orig.r) {
    x2 = (hLimits.end - orig.r) / sin;
    limits.r = Math.max(limits.r, orig.r + x2);
  }
  if (vLimits.start < orig.t) {
    y2 = (orig.t - vLimits.start) / cos;
    limits.t = Math.min(limits.t, orig.t - y2);
  } else if (vLimits.end > orig.b) {
    y2 = (vLimits.end - orig.b) / cos;
    limits.b = Math.max(limits.b, orig.b + y2);
  }
}
function createPointLabelItem(scale, index, itemOpts) {
  const outerDistance = scale.drawingArea;
  const { extra, additionalAngle, padding, size: size2 } = itemOpts;
  const pointLabelPosition = scale.getPointPosition(index, outerDistance + extra + padding, additionalAngle);
  const angle = Math.round(toDegrees(_normalizeAngle(pointLabelPosition.angle + HALF_PI)));
  const y2 = yForAngle(pointLabelPosition.y, size2.h, angle);
  const textAlign = getTextAlignForAngle(angle);
  const left = leftForTextAlign(pointLabelPosition.x, size2.w, textAlign);
  return {
    visible: true,
    x: pointLabelPosition.x,
    y: y2,
    textAlign,
    left,
    top: y2,
    right: left + size2.w,
    bottom: y2 + size2.h
  };
}
function isNotOverlapped(item, area) {
  if (!area) {
    return true;
  }
  const { left, top, right, bottom } = item;
  const apexesInArea = _isPointInArea({
    x: left,
    y: top
  }, area) || _isPointInArea({
    x: left,
    y: bottom
  }, area) || _isPointInArea({
    x: right,
    y: top
  }, area) || _isPointInArea({
    x: right,
    y: bottom
  }, area);
  return !apexesInArea;
}
function buildPointLabelItems(scale, labelSizes, padding) {
  const items = [];
  const valueCount = scale._pointLabels.length;
  const opts = scale.options;
  const { centerPointLabels, display } = opts.pointLabels;
  const itemOpts = {
    extra: getTickBackdropHeight(opts) / 2,
    additionalAngle: centerPointLabels ? PI / valueCount : 0
  };
  let area;
  for (let i = 0; i < valueCount; i++) {
    itemOpts.padding = padding[i];
    itemOpts.size = labelSizes[i];
    const item = createPointLabelItem(scale, i, itemOpts);
    items.push(item);
    if (display === "auto") {
      item.visible = isNotOverlapped(item, area);
      if (item.visible) {
        area = item;
      }
    }
  }
  return items;
}
function getTextAlignForAngle(angle) {
  if (angle === 0 || angle === 180) {
    return "center";
  } else if (angle < 180) {
    return "left";
  }
  return "right";
}
function leftForTextAlign(x2, w2, align) {
  if (align === "right") {
    x2 -= w2;
  } else if (align === "center") {
    x2 -= w2 / 2;
  }
  return x2;
}
function yForAngle(y2, h3, angle) {
  if (angle === 90 || angle === 270) {
    y2 -= h3 / 2;
  } else if (angle > 270 || angle < 90) {
    y2 -= h3;
  }
  return y2;
}
function drawPointLabelBox(ctx, opts, item) {
  const { left, top, right, bottom } = item;
  const { backdropColor } = opts;
  if (!isNullOrUndef(backdropColor)) {
    const borderRadius = toTRBLCorners(opts.borderRadius);
    const padding = toPadding(opts.backdropPadding);
    ctx.fillStyle = backdropColor;
    const backdropLeft = left - padding.left;
    const backdropTop = top - padding.top;
    const backdropWidth = right - left + padding.width;
    const backdropHeight = bottom - top + padding.height;
    if (Object.values(borderRadius).some((v2) => v2 !== 0)) {
      ctx.beginPath();
      addRoundedRectPath(ctx, {
        x: backdropLeft,
        y: backdropTop,
        w: backdropWidth,
        h: backdropHeight,
        radius: borderRadius
      });
      ctx.fill();
    } else {
      ctx.fillRect(backdropLeft, backdropTop, backdropWidth, backdropHeight);
    }
  }
}
function drawPointLabels(scale, labelCount) {
  const { ctx, options: { pointLabels } } = scale;
  for (let i = labelCount - 1; i >= 0; i--) {
    const item = scale._pointLabelItems[i];
    if (!item.visible) {
      continue;
    }
    const optsAtIndex = pointLabels.setContext(scale.getPointLabelContext(i));
    drawPointLabelBox(ctx, optsAtIndex, item);
    const plFont = toFont(optsAtIndex.font);
    const { x: x2, y: y2, textAlign } = item;
    renderText(ctx, scale._pointLabels[i], x2, y2 + plFont.lineHeight / 2, plFont, {
      color: optsAtIndex.color,
      textAlign,
      textBaseline: "middle"
    });
  }
}
function pathRadiusLine(scale, radius, circular, labelCount) {
  const { ctx } = scale;
  if (circular) {
    ctx.arc(scale.xCenter, scale.yCenter, radius, 0, TAU);
  } else {
    let pointPosition = scale.getPointPosition(0, radius);
    ctx.moveTo(pointPosition.x, pointPosition.y);
    for (let i = 1; i < labelCount; i++) {
      pointPosition = scale.getPointPosition(i, radius);
      ctx.lineTo(pointPosition.x, pointPosition.y);
    }
  }
}
function drawRadiusLine(scale, gridLineOpts, radius, labelCount, borderOpts) {
  const ctx = scale.ctx;
  const circular = gridLineOpts.circular;
  const { color: color2, lineWidth } = gridLineOpts;
  if (!circular && !labelCount || !color2 || !lineWidth || radius < 0) {
    return;
  }
  ctx.save();
  ctx.strokeStyle = color2;
  ctx.lineWidth = lineWidth;
  ctx.setLineDash(borderOpts.dash);
  ctx.lineDashOffset = borderOpts.dashOffset;
  ctx.beginPath();
  pathRadiusLine(scale, radius, circular, labelCount);
  ctx.closePath();
  ctx.stroke();
  ctx.restore();
}
function createPointLabelContext(parent, index, label) {
  return createContext(parent, {
    label,
    index,
    type: "pointLabel"
  });
}
class RadialLinearScale extends LinearScaleBase {
  constructor(cfg) {
    super(cfg);
    this.xCenter = void 0;
    this.yCenter = void 0;
    this.drawingArea = void 0;
    this._pointLabels = [];
    this._pointLabelItems = [];
  }
  setDimensions() {
    const padding = this._padding = toPadding(getTickBackdropHeight(this.options) / 2);
    const w2 = this.width = this.maxWidth - padding.width;
    const h3 = this.height = this.maxHeight - padding.height;
    this.xCenter = Math.floor(this.left + w2 / 2 + padding.left);
    this.yCenter = Math.floor(this.top + h3 / 2 + padding.top);
    this.drawingArea = Math.floor(Math.min(w2, h3) / 2);
  }
  determineDataLimits() {
    const { min, max } = this.getMinMax(false);
    this.min = isNumberFinite(min) && !isNaN(min) ? min : 0;
    this.max = isNumberFinite(max) && !isNaN(max) ? max : 0;
    this.handleTickRangeOptions();
  }
  computeTickLimit() {
    return Math.ceil(this.drawingArea / getTickBackdropHeight(this.options));
  }
  generateTickLabels(ticks) {
    LinearScaleBase.prototype.generateTickLabels.call(this, ticks);
    this._pointLabels = this.getLabels().map((value, index) => {
      const label = callback(this.options.pointLabels.callback, [
        value,
        index
      ], this);
      return label || label === 0 ? label : "";
    }).filter((v2, i) => this.chart.getDataVisibility(i));
  }
  fit() {
    const opts = this.options;
    if (opts.display && opts.pointLabels.display) {
      fitWithPointLabels(this);
    } else {
      this.setCenterPoint(0, 0, 0, 0);
    }
  }
  setCenterPoint(leftMovement, rightMovement, topMovement, bottomMovement) {
    this.xCenter += Math.floor((leftMovement - rightMovement) / 2);
    this.yCenter += Math.floor((topMovement - bottomMovement) / 2);
    this.drawingArea -= Math.min(this.drawingArea / 2, Math.max(leftMovement, rightMovement, topMovement, bottomMovement));
  }
  getIndexAngle(index) {
    const angleMultiplier = TAU / (this._pointLabels.length || 1);
    const startAngle = this.options.startAngle || 0;
    return _normalizeAngle(index * angleMultiplier + toRadians(startAngle));
  }
  getDistanceFromCenterForValue(value) {
    if (isNullOrUndef(value)) {
      return NaN;
    }
    const scalingFactor = this.drawingArea / (this.max - this.min);
    if (this.options.reverse) {
      return (this.max - value) * scalingFactor;
    }
    return (value - this.min) * scalingFactor;
  }
  getValueForDistanceFromCenter(distance) {
    if (isNullOrUndef(distance)) {
      return NaN;
    }
    const scaledDistance = distance / (this.drawingArea / (this.max - this.min));
    return this.options.reverse ? this.max - scaledDistance : this.min + scaledDistance;
  }
  getPointLabelContext(index) {
    const pointLabels = this._pointLabels || [];
    if (index >= 0 && index < pointLabels.length) {
      const pointLabel = pointLabels[index];
      return createPointLabelContext(this.getContext(), index, pointLabel);
    }
  }
  getPointPosition(index, distanceFromCenter, additionalAngle = 0) {
    const angle = this.getIndexAngle(index) - HALF_PI + additionalAngle;
    return {
      x: Math.cos(angle) * distanceFromCenter + this.xCenter,
      y: Math.sin(angle) * distanceFromCenter + this.yCenter,
      angle
    };
  }
  getPointPositionForValue(index, value) {
    return this.getPointPosition(index, this.getDistanceFromCenterForValue(value));
  }
  getBasePosition(index) {
    return this.getPointPositionForValue(index || 0, this.getBaseValue());
  }
  getPointLabelPosition(index) {
    const { left, top, right, bottom } = this._pointLabelItems[index];
    return {
      left,
      top,
      right,
      bottom
    };
  }
  drawBackground() {
    const { backgroundColor, grid: { circular } } = this.options;
    if (backgroundColor) {
      const ctx = this.ctx;
      ctx.save();
      ctx.beginPath();
      pathRadiusLine(this, this.getDistanceFromCenterForValue(this._endValue), circular, this._pointLabels.length);
      ctx.closePath();
      ctx.fillStyle = backgroundColor;
      ctx.fill();
      ctx.restore();
    }
  }
  drawGrid() {
    const ctx = this.ctx;
    const opts = this.options;
    const { angleLines, grid, border } = opts;
    const labelCount = this._pointLabels.length;
    let i, offset, position2;
    if (opts.pointLabels.display) {
      drawPointLabels(this, labelCount);
    }
    if (grid.display) {
      this.ticks.forEach((tick2, index) => {
        if (index !== 0) {
          offset = this.getDistanceFromCenterForValue(tick2.value);
          const context = this.getContext(index);
          const optsAtIndex = grid.setContext(context);
          const optsAtIndexBorder = border.setContext(context);
          drawRadiusLine(this, optsAtIndex, offset, labelCount, optsAtIndexBorder);
        }
      });
    }
    if (angleLines.display) {
      ctx.save();
      for (i = labelCount - 1; i >= 0; i--) {
        const optsAtIndex = angleLines.setContext(this.getPointLabelContext(i));
        const { color: color2, lineWidth } = optsAtIndex;
        if (!lineWidth || !color2) {
          continue;
        }
        ctx.lineWidth = lineWidth;
        ctx.strokeStyle = color2;
        ctx.setLineDash(optsAtIndex.borderDash);
        ctx.lineDashOffset = optsAtIndex.borderDashOffset;
        offset = this.getDistanceFromCenterForValue(opts.ticks.reverse ? this.min : this.max);
        position2 = this.getPointPosition(i, offset);
        ctx.beginPath();
        ctx.moveTo(this.xCenter, this.yCenter);
        ctx.lineTo(position2.x, position2.y);
        ctx.stroke();
      }
      ctx.restore();
    }
  }
  drawBorder() {
  }
  drawLabels() {
    const ctx = this.ctx;
    const opts = this.options;
    const tickOpts = opts.ticks;
    if (!tickOpts.display) {
      return;
    }
    const startAngle = this.getIndexAngle(0);
    let offset, width;
    ctx.save();
    ctx.translate(this.xCenter, this.yCenter);
    ctx.rotate(startAngle);
    ctx.textAlign = "center";
    ctx.textBaseline = "middle";
    this.ticks.forEach((tick2, index) => {
      if (index === 0 && !opts.reverse) {
        return;
      }
      const optsAtIndex = tickOpts.setContext(this.getContext(index));
      const tickFont = toFont(optsAtIndex.font);
      offset = this.getDistanceFromCenterForValue(this.ticks[index].value);
      if (optsAtIndex.showLabelBackdrop) {
        ctx.font = tickFont.string;
        width = ctx.measureText(tick2.label).width;
        ctx.fillStyle = optsAtIndex.backdropColor;
        const padding = toPadding(optsAtIndex.backdropPadding);
        ctx.fillRect(-width / 2 - padding.left, -offset - tickFont.size / 2 - padding.top, width + padding.width, tickFont.size + padding.height);
      }
      renderText(ctx, tick2.label, 0, -offset, tickFont, {
        color: optsAtIndex.color,
        strokeColor: optsAtIndex.textStrokeColor,
        strokeWidth: optsAtIndex.textStrokeWidth
      });
    });
    ctx.restore();
  }
  drawTitle() {
  }
}
__publicField(RadialLinearScale, "id", "radialLinear");
__publicField(RadialLinearScale, "defaults", {
  display: true,
  animate: true,
  position: "chartArea",
  angleLines: {
    display: true,
    lineWidth: 1,
    borderDash: [],
    borderDashOffset: 0
  },
  grid: {
    circular: false
  },
  startAngle: 0,
  ticks: {
    showLabelBackdrop: true,
    callback: Ticks.formatters.numeric
  },
  pointLabels: {
    backdropColor: void 0,
    backdropPadding: 2,
    display: true,
    font: {
      size: 10
    },
    callback(label) {
      return label;
    },
    padding: 5,
    centerPointLabels: false
  }
});
__publicField(RadialLinearScale, "defaultRoutes", {
  "angleLines.color": "borderColor",
  "pointLabels.color": "color",
  "ticks.color": "color"
});
__publicField(RadialLinearScale, "descriptors", {
  angleLines: {
    _fallback: "grid"
  }
});
const INTERVALS = {
  millisecond: {
    common: true,
    size: 1,
    steps: 1e3
  },
  second: {
    common: true,
    size: 1e3,
    steps: 60
  },
  minute: {
    common: true,
    size: 6e4,
    steps: 60
  },
  hour: {
    common: true,
    size: 36e5,
    steps: 24
  },
  day: {
    common: true,
    size: 864e5,
    steps: 30
  },
  week: {
    common: false,
    size: 6048e5,
    steps: 4
  },
  month: {
    common: true,
    size: 2628e6,
    steps: 12
  },
  quarter: {
    common: false,
    size: 7884e6,
    steps: 4
  },
  year: {
    common: true,
    size: 3154e7
  }
};
const UNITS = /* @__PURE__ */ Object.keys(INTERVALS);
function sorter(a2, b2) {
  return a2 - b2;
}
function parse(scale, input) {
  if (isNullOrUndef(input)) {
    return null;
  }
  const adapter = scale._adapter;
  const { parser, round: round2, isoWeekday } = scale._parseOpts;
  let value = input;
  if (typeof parser === "function") {
    value = parser(value);
  }
  if (!isNumberFinite(value)) {
    value = typeof parser === "string" ? adapter.parse(value, parser) : adapter.parse(value);
  }
  if (value === null) {
    return null;
  }
  if (round2) {
    value = round2 === "week" && (isNumber(isoWeekday) || isoWeekday === true) ? adapter.startOf(value, "isoWeek", isoWeekday) : adapter.startOf(value, round2);
  }
  return +value;
}
function determineUnitForAutoTicks(minUnit, min, max, capacity) {
  const ilen = UNITS.length;
  for (let i = UNITS.indexOf(minUnit); i < ilen - 1; ++i) {
    const interval = INTERVALS[UNITS[i]];
    const factor = interval.steps ? interval.steps : Number.MAX_SAFE_INTEGER;
    if (interval.common && Math.ceil((max - min) / (factor * interval.size)) <= capacity) {
      return UNITS[i];
    }
  }
  return UNITS[ilen - 1];
}
function determineUnitForFormatting(scale, numTicks, minUnit, min, max) {
  for (let i = UNITS.length - 1; i >= UNITS.indexOf(minUnit); i--) {
    const unit = UNITS[i];
    if (INTERVALS[unit].common && scale._adapter.diff(max, min, unit) >= numTicks - 1) {
      return unit;
    }
  }
  return UNITS[minUnit ? UNITS.indexOf(minUnit) : 0];
}
function determineMajorUnit(unit) {
  for (let i = UNITS.indexOf(unit) + 1, ilen = UNITS.length; i < ilen; ++i) {
    if (INTERVALS[UNITS[i]].common) {
      return UNITS[i];
    }
  }
}
function addTick(ticks, time, timestamps) {
  if (!timestamps) {
    ticks[time] = true;
  } else if (timestamps.length) {
    const { lo, hi: hi2 } = _lookup(timestamps, time);
    const timestamp = timestamps[lo] >= time ? timestamps[lo] : timestamps[hi2];
    ticks[timestamp] = true;
  }
}
function setMajorTicks(scale, ticks, map2, majorUnit) {
  const adapter = scale._adapter;
  const first = +adapter.startOf(ticks[0].value, majorUnit);
  const last = ticks[ticks.length - 1].value;
  let major, index;
  for (major = first; major <= last; major = +adapter.add(major, 1, majorUnit)) {
    index = map2[major];
    if (index >= 0) {
      ticks[index].major = true;
    }
  }
  return ticks;
}
function ticksFromTimestamps(scale, values, majorUnit) {
  const ticks = [];
  const map2 = {};
  const ilen = values.length;
  let i, value;
  for (i = 0; i < ilen; ++i) {
    value = values[i];
    map2[value] = i;
    ticks.push({
      value,
      major: false
    });
  }
  return ilen === 0 || !majorUnit ? ticks : setMajorTicks(scale, ticks, map2, majorUnit);
}
class TimeScale extends Scale {
  constructor(props) {
    super(props);
    this._cache = {
      data: [],
      labels: [],
      all: []
    };
    this._unit = "day";
    this._majorUnit = void 0;
    this._offsets = {};
    this._normalized = false;
    this._parseOpts = void 0;
  }
  init(scaleOpts, opts = {}) {
    const time = scaleOpts.time || (scaleOpts.time = {});
    const adapter = this._adapter = new adapters._date(scaleOpts.adapters.date);
    adapter.init(opts);
    mergeIf(time.displayFormats, adapter.formats());
    this._parseOpts = {
      parser: time.parser,
      round: time.round,
      isoWeekday: time.isoWeekday
    };
    super.init(scaleOpts);
    this._normalized = opts.normalized;
  }
  parse(raw, index) {
    if (raw === void 0) {
      return null;
    }
    return parse(this, raw);
  }
  beforeLayout() {
    super.beforeLayout();
    this._cache = {
      data: [],
      labels: [],
      all: []
    };
  }
  determineDataLimits() {
    const options = this.options;
    const adapter = this._adapter;
    const unit = options.time.unit || "day";
    let { min, max, minDefined, maxDefined } = this.getUserBounds();
    function _applyBounds(bounds) {
      if (!minDefined && !isNaN(bounds.min)) {
        min = Math.min(min, bounds.min);
      }
      if (!maxDefined && !isNaN(bounds.max)) {
        max = Math.max(max, bounds.max);
      }
    }
    if (!minDefined || !maxDefined) {
      _applyBounds(this._getLabelBounds());
      if (options.bounds !== "ticks" || options.ticks.source !== "labels") {
        _applyBounds(this.getMinMax(false));
      }
    }
    min = isNumberFinite(min) && !isNaN(min) ? min : +adapter.startOf(Date.now(), unit);
    max = isNumberFinite(max) && !isNaN(max) ? max : +adapter.endOf(Date.now(), unit) + 1;
    this.min = Math.min(min, max - 1);
    this.max = Math.max(min + 1, max);
  }
  _getLabelBounds() {
    const arr = this.getLabelTimestamps();
    let min = Number.POSITIVE_INFINITY;
    let max = Number.NEGATIVE_INFINITY;
    if (arr.length) {
      min = arr[0];
      max = arr[arr.length - 1];
    }
    return {
      min,
      max
    };
  }
  buildTicks() {
    const options = this.options;
    const timeOpts = options.time;
    const tickOpts = options.ticks;
    const timestamps = tickOpts.source === "labels" ? this.getLabelTimestamps() : this._generate();
    if (options.bounds === "ticks" && timestamps.length) {
      this.min = this._userMin || timestamps[0];
      this.max = this._userMax || timestamps[timestamps.length - 1];
    }
    const min = this.min;
    const max = this.max;
    const ticks = _filterBetween(timestamps, min, max);
    this._unit = timeOpts.unit || (tickOpts.autoSkip ? determineUnitForAutoTicks(timeOpts.minUnit, this.min, this.max, this._getLabelCapacity(min)) : determineUnitForFormatting(this, ticks.length, timeOpts.minUnit, this.min, this.max));
    this._majorUnit = !tickOpts.major.enabled || this._unit === "year" ? void 0 : determineMajorUnit(this._unit);
    this.initOffsets(timestamps);
    if (options.reverse) {
      ticks.reverse();
    }
    return ticksFromTimestamps(this, ticks, this._majorUnit);
  }
  afterAutoSkip() {
    if (this.options.offsetAfterAutoskip) {
      this.initOffsets(this.ticks.map((tick2) => +tick2.value));
    }
  }
  initOffsets(timestamps = []) {
    let start = 0;
    let end = 0;
    let first, last;
    if (this.options.offset && timestamps.length) {
      first = this.getDecimalForValue(timestamps[0]);
      if (timestamps.length === 1) {
        start = 1 - first;
      } else {
        start = (this.getDecimalForValue(timestamps[1]) - first) / 2;
      }
      last = this.getDecimalForValue(timestamps[timestamps.length - 1]);
      if (timestamps.length === 1) {
        end = last;
      } else {
        end = (last - this.getDecimalForValue(timestamps[timestamps.length - 2])) / 2;
      }
    }
    const limit = timestamps.length < 3 ? 0.5 : 0.25;
    start = _limitValue(start, 0, limit);
    end = _limitValue(end, 0, limit);
    this._offsets = {
      start,
      end,
      factor: 1 / (start + 1 + end)
    };
  }
  _generate() {
    const adapter = this._adapter;
    const min = this.min;
    const max = this.max;
    const options = this.options;
    const timeOpts = options.time;
    const minor = timeOpts.unit || determineUnitForAutoTicks(timeOpts.minUnit, min, max, this._getLabelCapacity(min));
    const stepSize = valueOrDefault(options.ticks.stepSize, 1);
    const weekday = minor === "week" ? timeOpts.isoWeekday : false;
    const hasWeekday = isNumber(weekday) || weekday === true;
    const ticks = {};
    let first = min;
    let time, count;
    if (hasWeekday) {
      first = +adapter.startOf(first, "isoWeek", weekday);
    }
    first = +adapter.startOf(first, hasWeekday ? "day" : minor);
    if (adapter.diff(max, min, minor) > 1e5 * stepSize) {
      throw new Error(min + " and " + max + " are too far apart with stepSize of " + stepSize + " " + minor);
    }
    const timestamps = options.ticks.source === "data" && this.getDataTimestamps();
    for (time = first, count = 0; time < max; time = +adapter.add(time, stepSize, minor), count++) {
      addTick(ticks, time, timestamps);
    }
    if (time === max || options.bounds === "ticks" || count === 1) {
      addTick(ticks, time, timestamps);
    }
    return Object.keys(ticks).sort(sorter).map((x2) => +x2);
  }
  getLabelForValue(value) {
    const adapter = this._adapter;
    const timeOpts = this.options.time;
    if (timeOpts.tooltipFormat) {
      return adapter.format(value, timeOpts.tooltipFormat);
    }
    return adapter.format(value, timeOpts.displayFormats.datetime);
  }
  format(value, format) {
    const options = this.options;
    const formats = options.time.displayFormats;
    const unit = this._unit;
    const fmt = format || formats[unit];
    return this._adapter.format(value, fmt);
  }
  _tickFormatFunction(time, index, ticks, format) {
    const options = this.options;
    const formatter = options.ticks.callback;
    if (formatter) {
      return callback(formatter, [
        time,
        index,
        ticks
      ], this);
    }
    const formats = options.time.displayFormats;
    const unit = this._unit;
    const majorUnit = this._majorUnit;
    const minorFormat = unit && formats[unit];
    const majorFormat = majorUnit && formats[majorUnit];
    const tick2 = ticks[index];
    const major = majorUnit && majorFormat && tick2 && tick2.major;
    return this._adapter.format(time, format || (major ? majorFormat : minorFormat));
  }
  generateTickLabels(ticks) {
    let i, ilen, tick2;
    for (i = 0, ilen = ticks.length; i < ilen; ++i) {
      tick2 = ticks[i];
      tick2.label = this._tickFormatFunction(tick2.value, i, ticks);
    }
  }
  getDecimalForValue(value) {
    return value === null ? NaN : (value - this.min) / (this.max - this.min);
  }
  getPixelForValue(value) {
    const offsets = this._offsets;
    const pos = this.getDecimalForValue(value);
    return this.getPixelForDecimal((offsets.start + pos) * offsets.factor);
  }
  getValueForPixel(pixel) {
    const offsets = this._offsets;
    const pos = this.getDecimalForPixel(pixel) / offsets.factor - offsets.end;
    return this.min + pos * (this.max - this.min);
  }
  _getLabelSize(label) {
    const ticksOpts = this.options.ticks;
    const tickLabelWidth = this.ctx.measureText(label).width;
    const angle = toRadians(this.isHorizontal() ? ticksOpts.maxRotation : ticksOpts.minRotation);
    const cosRotation = Math.cos(angle);
    const sinRotation = Math.sin(angle);
    const tickFontSize = this._resolveTickFontOptions(0).size;
    return {
      w: tickLabelWidth * cosRotation + tickFontSize * sinRotation,
      h: tickLabelWidth * sinRotation + tickFontSize * cosRotation
    };
  }
  _getLabelCapacity(exampleTime) {
    const timeOpts = this.options.time;
    const displayFormats = timeOpts.displayFormats;
    const format = displayFormats[timeOpts.unit] || displayFormats.millisecond;
    const exampleLabel = this._tickFormatFunction(exampleTime, 0, ticksFromTimestamps(this, [
      exampleTime
    ], this._majorUnit), format);
    const size2 = this._getLabelSize(exampleLabel);
    const capacity = Math.floor(this.isHorizontal() ? this.width / size2.w : this.height / size2.h) - 1;
    return capacity > 0 ? capacity : 1;
  }
  getDataTimestamps() {
    let timestamps = this._cache.data || [];
    let i, ilen;
    if (timestamps.length) {
      return timestamps;
    }
    const metas = this.getMatchingVisibleMetas();
    if (this._normalized && metas.length) {
      return this._cache.data = metas[0].controller.getAllParsedValues(this);
    }
    for (i = 0, ilen = metas.length; i < ilen; ++i) {
      timestamps = timestamps.concat(metas[i].controller.getAllParsedValues(this));
    }
    return this._cache.data = this.normalize(timestamps);
  }
  getLabelTimestamps() {
    const timestamps = this._cache.labels || [];
    let i, ilen;
    if (timestamps.length) {
      return timestamps;
    }
    const labels = this.getLabels();
    for (i = 0, ilen = labels.length; i < ilen; ++i) {
      timestamps.push(parse(this, labels[i]));
    }
    return this._cache.labels = this._normalized ? timestamps : this.normalize(timestamps);
  }
  normalize(values) {
    return _arrayUnique(values.sort(sorter));
  }
}
__publicField(TimeScale, "id", "time");
__publicField(TimeScale, "defaults", {
  bounds: "data",
  adapters: {},
  time: {
    parser: false,
    unit: false,
    round: false,
    isoWeekday: false,
    minUnit: "millisecond",
    displayFormats: {}
  },
  ticks: {
    source: "auto",
    callback: false,
    major: {
      enabled: false
    }
  }
});
function interpolate(table, val, reverse) {
  let lo = 0;
  let hi2 = table.length - 1;
  let prevSource, nextSource, prevTarget, nextTarget;
  if (reverse) {
    if (val >= table[lo].pos && val <= table[hi2].pos) {
      ({ lo, hi: hi2 } = _lookupByKey(table, "pos", val));
    }
    ({ pos: prevSource, time: prevTarget } = table[lo]);
    ({ pos: nextSource, time: nextTarget } = table[hi2]);
  } else {
    if (val >= table[lo].time && val <= table[hi2].time) {
      ({ lo, hi: hi2 } = _lookupByKey(table, "time", val));
    }
    ({ time: prevSource, pos: prevTarget } = table[lo]);
    ({ time: nextSource, pos: nextTarget } = table[hi2]);
  }
  const span = nextSource - prevSource;
  return span ? prevTarget + (nextTarget - prevTarget) * (val - prevSource) / span : prevTarget;
}
class TimeSeriesScale extends TimeScale {
  constructor(props) {
    super(props);
    this._table = [];
    this._minPos = void 0;
    this._tableRange = void 0;
  }
  initOffsets() {
    const timestamps = this._getTimestampsForTable();
    const table = this._table = this.buildLookupTable(timestamps);
    this._minPos = interpolate(table, this.min);
    this._tableRange = interpolate(table, this.max) - this._minPos;
    super.initOffsets(timestamps);
  }
  buildLookupTable(timestamps) {
    const { min, max } = this;
    const items = [];
    const table = [];
    let i, ilen, prev, curr, next;
    for (i = 0, ilen = timestamps.length; i < ilen; ++i) {
      curr = timestamps[i];
      if (curr >= min && curr <= max) {
        items.push(curr);
      }
    }
    if (items.length < 2) {
      return [
        {
          time: min,
          pos: 0
        },
        {
          time: max,
          pos: 1
        }
      ];
    }
    for (i = 0, ilen = items.length; i < ilen; ++i) {
      next = items[i + 1];
      prev = items[i - 1];
      curr = items[i];
      if (Math.round((next + prev) / 2) !== curr) {
        table.push({
          time: curr,
          pos: i / (ilen - 1)
        });
      }
    }
    return table;
  }
  _generate() {
    const min = this.min;
    const max = this.max;
    let timestamps = super.getDataTimestamps();
    if (!timestamps.includes(min) || !timestamps.length) {
      timestamps.splice(0, 0, min);
    }
    if (!timestamps.includes(max) || timestamps.length === 1) {
      timestamps.push(max);
    }
    return timestamps.sort((a2, b2) => a2 - b2);
  }
  _getTimestampsForTable() {
    let timestamps = this._cache.all || [];
    if (timestamps.length) {
      return timestamps;
    }
    const data = this.getDataTimestamps();
    const label = this.getLabelTimestamps();
    if (data.length && label.length) {
      timestamps = this.normalize(data.concat(label));
    } else {
      timestamps = data.length ? data : label;
    }
    timestamps = this._cache.all = timestamps;
    return timestamps;
  }
  getDecimalForValue(value) {
    return (interpolate(this._table, value) - this._minPos) / this._tableRange;
  }
  getValueForPixel(pixel) {
    const offsets = this._offsets;
    const decimal = this.getDecimalForPixel(pixel) / offsets.factor - offsets.end;
    return interpolate(this._table, decimal * this._tableRange + this._minPos, true);
  }
}
__publicField(TimeSeriesScale, "id", "timeseries");
__publicField(TimeSeriesScale, "defaults", TimeScale.defaults);
const welcome$1 = "Welcome to inlang";
const title$1 = "Data Driven, Scientific Investment";
const subtitle$1 = "Technology-driven investment revolution. Jump on the tech wave now and create passive income!";
const actionButton$1 = "start revolution";
const profitability$1 = {
  historicalReturn: "Historical Performance",
  stockList: "Stock Returns",
  monthlyReturn: "Monthly Return",
  monthlyWinRatio: "Monthly Win Rate",
  avgMonthlyReturn: "Average Monthly Return"
};
const strategy$1 = "Strategy";
const benchmark$1 = "Benchmark";
const average$1 = "Average";
const tabs$1 = {
  profitability: "Profitability",
  risk: "Risk Resistance",
  ratio: "Risk-Reward Ratio",
  winrate: "Trade Analaysis",
  liquidity: "Stock Liquidity"
};
const metrics$1 = {
  backtest: {
    startDate: "Start Date",
    endDate: "End Date",
    version: "Version",
    feeRatio: "Fee Ratio",
    taxRatio: "Tax Ratio",
    tradeAt: "Trade At (Close or Open)",
    market: "Market",
    freq: "Frequency",
    updateDate: "Update Date",
    nextTradingDate: "Next Trading Date",
    livePerformanceStart: "Live Performance Start Date",
    stopLoss: "Stop Loss Percentage",
    takeProfit: "Take Profit Percentage"
  },
  profitability: {
    annualReturn: "Annual Return",
    alpha: "Alpha",
    beta: "Beta",
    avgNStock: "Average Number of Stocks",
    maxNStock: "Maximum Number of Stocks"
  },
  risk: {
    maxDrawdown: "Maximum Drawdown",
    avgDrawdown: "Average Drawdown",
    avgDrawdownDays: "Average Drawdown Duration (Days)",
    volatility: "Volatility",
    valueAtRisk: "Value At Risk (VaR)",
    cvalueAtRisk: "Conditional Value At Risk (CVaR)",
    days: "days"
  },
  ratio: {
    sharpeRatio: "Sharpe Ratio",
    sortinoRatio: "Sortino Ratio",
    calmarRatio: "Calmar Ratio",
    profitFactor: "Profit Factor",
    tailRatio: "Tail Ratio",
    worseThanBenchmark: "Underperform Benchmark:"
  },
  winrate: {
    winRate: "Win Rate Percentage",
    m12WinRate: "12-Month Win Rate",
    expectancy: "Expectancy",
    mae: "Maximum Adverse Excursion",
    mfe: "Maximum Favorable Excursion"
  },
  liquidity: {
    smallCapRatio: "Small Cap Ratio",
    capacity: "Capacity",
    disposalStockRatio: "Disposal Stock Ratio",
    warningStockRatio: "Warning Stock Ratio",
    fullDeliveryStockRatio: "Full Delivery Stock Ratio",
    buyHigh: "Buy High",
    sellLow: "sell Low"
  },
  stocks: {
    stockId: "Stock ID",
    "return": "Return",
    entry: "Entry",
    exit: "Exit",
    position: "Position",
    entryPrice: "Entry Price",
    exitPrice: "Exit Price",
    entrySig: "Entry Signal",
    exitSig: "Exit Signal",
    mae: "MAE",
    gmfe: "MFE",
    bmfe: "BMFE",
    mdd: "Maximum Drawdown",
    pdays: "Holding Days"
  }
};
const position$1 = {
  sl: "Stop Loss",
  tp: "Take Profit",
  resample: "Resample Frequency",
  entryTradePrice: "Entry Price",
  exitTradePrice: "Exit Price",
  scheduled: "Scheduled Resample Date",
  dataFreq: "Backtest Frequency",
  created: "Updated Time",
  entryDate: "Entry Date",
  exitDate: "Exit Date",
  currentPrice: "Price",
  profit: "Profit/Loss",
  currentWeight: "Holding Percentage",
  RSV: "Bullish/Bearish Power",
  resampleValue: {
    "30M": "Every 30 Minutes",
    H: "Every 1 Hour",
    "4H": "Every 4 Hours",
    D: "Every Day",
    W: "Every Week",
    "W-Mon": "Every Monday",
    "W-Tue": "Every Tuesday",
    "W-Wed": "Every Wednesday",
    "W-Thu": "Every Thursday",
    "W-Fri": "Every Friday",
    M: "Every Month",
    "2M": "Every 2 Months",
    MRE: "Monthly Earnings Release Date",
    Q: "Every Quarter",
    HY: "Every Half Year",
    Y: "Every Year",
    "null": "None"
  },
  open: "Open",
  close: "Close",
  type: {
    entry: "Entry",
    entry_f: "Will Enter",
    exit: "Exit",
    exit_p: "Exited",
    hold: "Hold",
    sl: "Stop Loss",
    tp: "Take Profit",
    sl_: "Stopped Out",
    tp_: "Took Profit"
  }
};
const en$1 = {
  welcome: welcome$1,
  title: title$1,
  subtitle: subtitle$1,
  actionButton: actionButton$1,
  profitability: profitability$1,
  "profitability.YearlyCompareWithBenchmark": "Annual Return Relative to the Benchmark",
  "profitability.yearlyWinRate": "Outperformed Benchmark:",
  strategy: strategy$1,
  benchmark: benchmark$1,
  "profitability.exceedReturn": "Excess Return",
  average: average$1,
  "risk.drawdownPercentage": "Historical Drawdown Percentage",
  "risk.drawdowPeriods": "Loss Historical Performance",
  tabs: tabs$1,
  metrics: metrics$1,
  "metrics.risk.worst10Benchmark": "Worst benchmark periods",
  "metrics.risk.worst10Strategy": "Worst strategy periods",
  "metrics.risk.newHighTimeRank": "Longest Drawdown Periods",
  "metrics.ratio.sharpeRatio": "Rolling Sharpe Ratio",
  position: position$1,
  "position.assetName": "Asset Name",
  "position.action": "Action",
  "metrics.ratio.yearlySharpeRatio": "Annual Sharpe Ratio Compared to Benchmark",
  "metrics.ratio.betterThanBenchmark": "Outperformed Benchmark:",
  "metrics.ratio.year": "Year",
  "metrics.ratio.timeBetterThanBenchmark": "Outperformed Benchmark:",
  "metrics.ratio.yearlyTailRatio": "Annual Tail Risk Ratio Compared to Benchmark",
  "metrics.ratio.volatility": "Strategy Return Volatility",
  "metrics.winrate.returnDistribution": "Return Distribution",
  "metrics.winrate.distributionInfo1": "There's a 5% chance that the trade will have",
  "metrics.winrate.distributionInfo2": " % or more loss",
  "metrics.winrate.return": "Return Rate",
  "metrics.winrate.maemfe": "Trade Maximum Excursion",
  "metrics.winrate.stoploss": "Stop Loss Setting:",
  "metrics.winrate.none": "None",
  "metrics.winrate.extraProfitLoss": "Extra Profit/Loss Due to Stop Loss:",
  "metrics.winrate.stoplossRatio": "Trade Ratio with Stop Loss:",
  "metrics.winrate.maeReturn": "Return vs. Maximum Adverse Excursion",
  "metrics.winrate.simulatedStopLoss": "Simulated Stop Loss",
  "metrics.winrate.simulatedTakeProfit": "Simulated Take Profit",
  "metrics.winrate.takeProfit": "Take Profit Setting:",
  "metrics.winrate.extraProfitLossTakingProfit": "Extra Profit/Loss Due to Take Profit:",
  "metrics.winrate.takeProfitRatio": "Trade Ratio with Take Profit:",
  "metrics.winrate.mfeReturn": "Return vs. Maximum Favorable Excursion",
  "metrics.liquidity.portfolioCapacity": "Portfolio Capacity",
  "metrics.liquidity.safeLiquidityTradeRatio": "Safe Liquidity Trade Ratio",
  "metrics.liquidity.averageReturn": "Average Return",
  "metrics.liquidity.totalInvestment": "Total Investment",
  "metrics.liquidity.marketCap": "Trading Asset Market Cap",
  "metrics.liquidity.tradeRatio": "Trade Ratio",
  "metrics.liquidity.tradeRatioMarketCap": "Market Cap Threshold",
  "metrics.liquidity.tradeRatioEntryVolume": "Entry Volume Threshold",
  "metrics.liquidity.tradeRatioExitVolume": "Exit Volume Threshold",
  "metrics.liquidity.volumeThreshold": "Entry Day Volume",
  "metrics.liquidity.exitVolume": "Exit Day Volume",
  "metrics.liquidity.entryVolume": "Entry Day Volume",
  "metrics.liquidity.marketCapThreshold": "Market Cap Threshold",
  "metrics.liquidity.portfolioCapacityDescription": "When the fund amount reaches {v1}, there's a {v2}% chance of buying stocks with low liquidity (Low daily volume, wide spread, price volatility).",
  "metrics.liquidity.marketCapDescription": "Trades with a market cap above {v1} account for {v2}%.",
  "metrics.liquidity.entryVolumeDescription": "Trades with an entry volume above {v1} shares account for {v2}%.",
  "metrics.liquidity.exitVolumeDescription": "Trades with an exit volume above {v1} shares account for {v2}%.",
  "metrics.ratio.rollingTailRatio": "Rolling Tail Ratio",
  "profitability.yearlyReturn": "Yearly Return",
  "profitability.benchmarkYearlyReturn": "Benchmark Yearly Return",
  "profitability.year": "years",
  "metrics.risk.worstDrawdownPeriod": "Worst Drawdown",
  "profitability.all": "All",
  "profitability.recent": "Recent",
  "metric.description": {
    backtest: {
      startDate: "The starting date of the backtest",
      endDate: "The ending date of the backtest",
      version: "Version of the backtest",
      feeRatio: "Ratio of fees applied to trades",
      taxRatio: "Ratio of taxes applied to trades",
      tradeAt: "Whether trades are executed at the close or open of the market",
      market: "The market in which the backtest is conducted",
      freq: "Frequency of data used in the backtest",
      updateDate: "The date the backtest was last updated",
      nextTradingDate: "The next trading date after the backtest",
      livePerformanceStart: "The date when live performance tracking starts",
      stopLoss: "The maximum loss allowed before stopping a trade",
      takeProfit: "The profit target to exit a trade"
    },
    profitability: {
      annualReturn: "The yearly return of the strategy",
      alpha: "Measure of the strategy's performance on a risk-adjusted basis relative to a benchmark",
      beta: "Measure of the strategy's sensitivity to market movements",
      avgNStock: "Average number of stocks held in the portfolio",
      maxNStock: "Maximum number of stocks held in the portfolio"
    },
    risk: {
      maxDrawdown: "The maximum percentage decline from a peak to a trough",
      avgDrawdown: "The average percentage decline from a peak to a trough",
      avgDrawdownDays: "Average number of days for a drawdown",
      volatility: "Standard deviation of the strategy's returns",
      valueAtRisk: "The maximum loss expected over a specified period for a given confidence interval",
      cvalueAtRisk: "Conditional Value at Risk, or the expected loss given that a specified bad event has occurred"
    },
    ratio: {
      sharpeRatio: "Measure of risk-adjusted performance",
      sortinoRatio: "Measure of risk-adjusted performance that only considers downside volatility",
      calmarRatio: "Ratio of annual return to maximum drawdown",
      profitFactor: "Ratio of gross profit to gross loss",
      tailRatio: "Ratio of the right tail (wins) to the left tail (losses)"
    },
    winrate: {
      winRate: "Percentage of trades that were profitable",
      m12WinRate: "12-month rolling win rate",
      expectancy: "Average amount that can be expected to be won (or lost) per trade",
      mae: "Maximum Adverse Excursion, or the maximum loss before a trade becomes profitable",
      mfe: "Maximum Favorable Excursion, or the maximum profit before a trade turns into a loss"
    },
    liquidity: {
      capacity: "The maximum amount of capital that can be deployed without affecting market prices",
      disposalStockRatio: "Ratio of stocks that can be easily sold",
      warningStockRatio: "Ratio of stocks that may present liquidity issues",
      fullDeliveryStockRatio: "Ratio of stocks that require full delivery",
      buyHigh: "Measure of the tendency to buy stocks at high prices",
      sellLow: "Measure of the tendency to sell stocks at low prices"
    }
  },
  "metrics.condition": "Criteria",
  "strategy.code": "Code",
  "strategy.return": "Return",
  "strategy.betterThanBenchmark": "Outperformed Benchmark",
  "strategy.worseThanBenchmark": "Underperform Benchmark",
  "strategy.annualReturn": "Annual Return",
  "strategy.maxDrawdown": "Maximum Drawdown",
  "strategy.sharpeRatio": "Sharpe Ratio",
  "strategy.period": {
    W: "W",
    M: "M",
    Q: "Q",
    HY: "HY",
    Y: "Y",
    All: "All"
  },
  "strategy.tabs": {
    position: "Position",
    analyze: "Analysis",
    course: "Course"
  }
};
const welcome = "Welcome to inlang";
const title = "相信數據。科學投資";
const subtitle = "科技驅動投資革命，數據分析引領市場趨勢，現在就跳上科技潮流，創造真正的被動收入！";
const actionButton = "我要掀起投資革命";
const profitability = {
  historicalReturn: "歷史績效",
  stockList: "持股報酬",
  monthlyReturn: "月報酬",
  monthlyWinRatio: "月勝率",
  avgMonthlyReturn: "平均月報酬"
};
const strategy = "策略";
const benchmark = "大盤";
const average = "平均";
const tabs = {
  profitability: "獲利能力",
  risk: "抗風險能力",
  ratio: "風險報酬比",
  winrate: "勝率期望值",
  liquidity: "交易流動性"
};
const metrics = {
  backtest: {
    startDate: "開始日期",
    endDate: "結束日期",
    version: "版本",
    feeRatio: "費用比率",
    taxRatio: "稅收比率",
    tradeAt: "交易於（收盤或開盤）",
    market: "市場",
    freq: "頻率",
    updateDate: "更新日期",
    nextTradingDate: "下一交易日",
    livePerformanceStart: "實時表現開始日期",
    stopLoss: "止損百分比",
    takeProfit: "獲利百分比"
  },
  profitability: {
    annualReturn: "年度回報",
    alpha: "阿爾法（Alpha）",
    beta: "貝塔（Beta）",
    avgNStock: "平均持有股票數",
    maxNStock: "最大持有股票數"
  },
  risk: {
    maxDrawdown: "最大回檔",
    avgDrawdown: "平均回檔",
    avgDrawdownDays: "平均回檔時間（天）",
    volatility: "波動性",
    valueAtRisk: "價值風險（VaR）",
    cvalueAtRisk: "條件價值風險（CVaR）",
    newHighTimeRank: "再次創新高時間排名",
    worst10Strategy: "策略前十大",
    worst10Benchmark: "大盤前十大",
    days: "days"
  },
  ratio: {
    sharpeRatio: "Sharpe Ratio",
    sortinoRatio: "Sortino Ratio",
    calmarRatio: "Calmar Ratio",
    profitFactor: "Profit Factor",
    tailRatio: "Tail Ratio",
    worseThanBenchmark: "小於大盤"
  },
  winrate: {
    winRate: "逐筆交易勝率",
    m12WinRate: "使用策略12個月勝大盤",
    expectancy: "期望值",
    mae: "最大不利偏移",
    mfe: "最大有利偏移"
  },
  liquidity: {
    smallCapRatio: "小市值比率",
    capacity: "胃納量",
    disposalStockRatio: "處置股",
    warningStockRatio: "警告股",
    fullDeliveryStockRatio: "全額交付股",
    buyHigh: "買在漲停",
    sellLow: "賣在跌停"
  },
  stocks: {
    stockId: "名稱代號",
    "return": "報酬",
    entry: "進場",
    exit: "出場",
    position: "持倉",
    entryPrice: "進場價格",
    exitPrice: "出場價格",
    entrySig: "進場訊號",
    exitSig: "出場訊號",
    mae: "不利偏移",
    gmfe: "有利偏移",
    bmfe: "虧損前有利偏移",
    mdd: "最大回檔",
    pdays: "持倉天数"
  }
};
const position = {
  sl: "停損",
  tp: "停利",
  resample: "換股頻率",
  entryTradePrice: "進場時機",
  exitTradePrice: "出場時機",
  scheduled: "預定換股日",
  dataFreq: "回測頻率",
  created: "更新時間",
  entryDate: "進場日期",
  exitDate: "出場日期",
  currentPrice: "價格",
  profit: "盈虧",
  currentWeight: "持股比例",
  RSV: "多空力道",
  resampleValue: {
    "30M": "每30分鐘",
    H: "每1小時",
    "4H": "每4小時",
    D: "每1天",
    W: "每1週",
    "W-Mon": "每週一",
    "W-Tue": "每週二",
    "W-Wed": "每週三",
    "W-Thu": "每週四",
    "W-Fri": "每週五",
    M: "每個月",
    "2M": "每2個月",
    MRE: "每月收入公佈日",
    Q: "每1季度",
    HY: "每半年",
    Y: "每1年",
    "null": "無"
  },
  open: "開盤",
  close: "收盤",
  type: {
    entry: "進場",
    entry_f: "將進場",
    exit: "出場",
    exit_p: "已出場",
    hold: "持有",
    sl: "停損",
    tp: "停利",
    sl_: "已停損",
    tp_: "已停利"
  }
};
const tw = {
  welcome,
  title,
  subtitle,
  actionButton,
  profitability,
  "profitability.YearlyCompareWithBenchmark": "與大盤年報酬比較",
  "profitability.yearlyWinRate": "贏大盤",
  strategy,
  benchmark,
  "profitability.exceedReturn": "超額報酬",
  average,
  "risk.drawdownPercentage": "回檔幅度",
  "risk.drawdowPeriods": "虧損歷史",
  tabs,
  metrics,
  "metrics.ratio.tailRatio": "極端風報比 (Tail Ratio)",
  "metrics.ratio.sharpeRatio": "夏普比率(Sharpe Ratio)",
  "notebook.private_draft": "儲存草稿",
  "notebook.save_draft": "儲存",
  "notebook.go_public": "準備發布",
  "notebook.update_public": "更新發布",
  "notebook.category.python": "Python",
  "notebook.category.market": "股市",
  "notebook.category.algorithm": "演算法",
  "notebook.category.tool": "工具",
  "notebook.category.metric": "策略指標",
  "notebook.category.indicator": "財經指標",
  "notebook.category.ai": "機器學習AI",
  position,
  "position.assetName": "標的名稱",
  "position.action": "動作",
  "metrics.ratio.yearlySharpeRatio": "每年夏普與大盤比較",
  "metrics.ratio.betterThanBenchmark": "大於大盤：",
  "metrics.ratio.year": "年",
  "metrics.ratio.timeBetterThanBenchmark": "大於大盤的時間：",
  "metrics.ratio.yearlyTailRatio": "每年極端風報比與大盤比較",
  "metrics.ratio.volatility": "策略報酬率波動 (Volitility)",
  "metrics.winrate.returnDistribution": "報酬分布",
  "metrics.winrate.distributionInfo1": "有 5% 的機率，交易將有",
  "metrics.winrate.distributionInfo2": " % 以上的虧損",
  "metrics.winrate.return": "報酬率",
  "metrics.winrate.maemfe": "交易最大偏移",
  "metrics.winrate.stoploss": "停損設定：",
  "metrics.winrate.none": "無",
  "metrics.winrate.extraProfitLoss": "停損造成的額外盈虧：",
  "metrics.winrate.stoplossRatio": "停損的交易比例：",
  "metrics.winrate.maeReturn": "報酬與最大不利偏移",
  "metrics.winrate.simulatedStopLoss": "模擬停損",
  "metrics.winrate.simulatedTakeProfit": "模擬停利",
  "metrics.winrate.takeProfit": "停利設定：",
  "metrics.winrate.extraProfitLossTakingProfit": "停利造成的額外盈虧：",
  "metrics.winrate.takeProfitRatio": "停利的交易比例：",
  "metrics.winrate.mfeReturn": "報酬與最大有利偏移",
  "metrics.liquidity.portfolioCapacity": "投資組合胃納量",
  "metrics.liquidity.safeLiquidityTradeRatio": "安全流動性交易的佔比",
  "metrics.liquidity.averageReturn": "平均報酬",
  "metrics.liquidity.totalInvestment": "投資總資金",
  "metrics.liquidity.marketCap": "交易標的的市值",
  "metrics.liquidity.tradeRatio": "交易的佔比",
  "metrics.liquidity.tradeRatioMarketCap": "市值門檻",
  "metrics.liquidity.tradeRatioEntryVolume": "買進成交量門檻",
  "metrics.liquidity.tradeRatioExitVolume": "交易的佔比",
  "metrics.liquidity.volumeThreshold": "當天成交量",
  "metrics.liquidity.exitVolume": "出場當天成交量",
  "metrics.liquidity.entryVolume": "進場當天成交量",
  "metrics.liquidity.marketCapThreshold": "市值門檻",
  "metrics.liquidity.portfolioCapacityDescription": "當資金量達到 {v1} 時，將有 {v2}%的機率，買到流動性低的股票(低成交量、價差大、價格易波動)。",
  "metrics.liquidity.marketCapDescription": "市值 {v1} 以上的交易佔 {v2}%。",
  "metrics.liquidity.entryVolumeDescription": "買入當天成交量 {v1} 張以上的交易佔 {v2}%。",
  "metrics.liquidity.exitVolumeDescription": "賣出當天成交量 {v1} 張以上的交易佔 {v2}%。",
  "metrics.ratio.rollingTailRatio": "每年極端風報比 (Tail Ratio)",
  "profitability.yearlyReturn": "年報酬",
  "profitability.benchmarkYearlyReturn": "大盤年報酬",
  "profitability.year": "年",
  "metrics.risk.worstDrawdownPeriod": "跌幅排名",
  "profitability.all": "全部",
  "profitability.recent": "近年",
  "metric.description": {
    backtest: {
      startDate: "回測的開始日期",
      endDate: "回測的結束日期",
      version: "回測的版本",
      feeRatio: "交易的手續費比率",
      taxRatio: "交易的稅率",
      tradeAt: "交易是在市場收盤還是開盤時執行",
      market: "進行回測的市場",
      freq: "回測使用的數據頻率",
      updateDate: "回測最後更新的日期",
      nextTradingDate: "回測後的下一個交易日期",
      livePerformanceStart: "實時性能跟踪開始的日期",
      stopLoss: "允許的最大損失以停止交易",
      takeProfit: "退出交易的利潤目標"
    },
    profitability: {
      annualReturn: "策略的年度回報",
      alpha: "相對於基準的策略的風險調整後表現的衡量",
      beta: "策略對市場變動的敏感性的衡量",
      avgNStock: "投資組合中持有的平均股票數",
      maxNStock: "投資組合中持有的最大股票數"
    },
    risk: {
      maxDrawdown: "從高點到低谷的最大百分比下降",
      avgDrawdown: "從高點到低谷的平均百分比下降",
      avgDrawdownDays: "平均回撤天數",
      volatility: "策略回報的標準差",
      valueAtRisk: "給定信心區間的指定期間內預期的最大損失",
      cvalueAtRisk: "發生指定不良事件後的預期損失"
    },
    ratio: {
      sharpeRatio: "風險調整後表現的衡量",
      sortinoRatio: "只考慮下行波動性的風險調整後表現的衡量",
      calmarRatio: "年度回報與最大回撤的比率",
      profitFactor: "總利潤與總損失的比率",
      tailRatio: "右尾（贏）與左尾（輸）的比率"
    },
    winrate: {
      winRate: "盈利交易的百分比",
      m12WinRate: "12個月滾動勝率",
      expectancy: "每筆交易預期贏得（或損失）的平均金額",
      mae: "最大不利運動，或交易盈利前的最大損失",
      mfe: "最大有利運動，或交易變成損失前的最大利潤"
    },
    liquidity: {
      capacity: "不影響市場價格可以部署的最大資本金額",
      disposalStockRatio: "可以輕易出售的股票比率",
      warningStockRatio: "可能存在流動性問題的股票比率",
      fullDeliveryStockRatio: "需要全額交付的股票比率",
      buyHigh: "購買高價股票的傾向",
      sellLow: "賣出低價股票的傾向"
    }
  },
  "metrics.condition": "達成條件",
  "strategy.code": "程式碼",
  "strategy.return": "報酬",
  "strategy.betterThanBenchmark": "贏大盤",
  "strategy.worseThanBenchmark": "輸大盤",
  "strategy.annualReturn": "年度報酬",
  "strategy.maxDrawdown": "最大回檔",
  "strategy.sharpeRatio": "夏普比率",
  "strategy.period": {
    W: "週",
    M: "月",
    Q: "季",
    HY: "半年",
    Y: "年",
    All: "全部"
  },
  "strategy.tabs": {
    position: "選股",
    analyze: "分析",
    course: "教學"
  }
};
function flattenObject(obj, prefix = "") {
  let flattened = {};
  for (let key in obj) {
    if (typeof obj[key] === "object" && obj[key] !== null) {
      Object.assign(flattened, flattenObject(obj[key], prefix + key + "."));
    } else {
      flattened[prefix + key] = obj[key];
    }
  }
  return flattened;
}
const flat_en = flattenObject(en$1);
const flat_tw = flattenObject(tw);
const ien = (key) => flat_en[key];
const itw = (key) => flat_tw[key];
function create_fragment$a(ctx) {
  let div12;
  let div2;
  let h30;
  let t0_value = (
    /*i*/
    ctx[1]("metrics.liquidity.portfolioCapacity") + ""
  );
  let t0;
  let t1;
  let p0;
  let t2_value = (
    /*i*/
    ctx[1]("metrics.liquidity.portfolioCapacityDescription").replace(
      "{v1}",
      /*formatNumber*/
      ctx[2](Object.keys(
        /*moneyFlow*/
        ctx[3].mean
      )[1], "zh")
    ).replace("{v2}", ((1 - Object.values(
      /*moneyFlow*/
      ctx[3].portion
    )[1]) * 100).toFixed(1)) + ""
  );
  let t2;
  let t3;
  let div1;
  let p1;
  let t4_value = (
    /*i*/
    ctx[1]("metrics.liquidity.safeLiquidityTradeRatio") + ""
  );
  let t4;
  let t5;
  let div0;
  let t6;
  let p2;
  let t7_value = (
    /*i*/
    ctx[1]("metrics.liquidity.averageReturn") + ""
  );
  let t7;
  let t8;
  let canvas0;
  let t9;
  let p3;
  let t10_value = (
    /*i*/
    ctx[1]("metrics.liquidity.totalInvestment") + ""
  );
  let t10;
  let t11;
  let div5;
  let h31;
  let t12_value = (
    /*i*/
    ctx[1]("metrics.liquidity.marketCap") + ""
  );
  let t12;
  let t13;
  let p4;
  let t14_value = (
    /*i*/
    ctx[1]("metrics.liquidity.marketCapDescription").replace(
      "{v1}",
      /*formatNumber*/
      ctx[2](Object.keys(
        /*marketValue*/
        ctx[4].mean
      )[2], "zh")
    ).replace("{v2}", (Object.values(
      /*marketValue*/
      ctx[4].portion
    )[2] * 100).toFixed(1)) + ""
  );
  let t14;
  let t15;
  let div4;
  let p5;
  let t16_value = (
    /*i*/
    ctx[1]("metrics.liquidity.tradeRatio") + ""
  );
  let t16;
  let t17;
  let div3;
  let t18;
  let p6;
  let t19_value = (
    /*i*/
    ctx[1]("metrics.liquidity.averageReturn") + ""
  );
  let t19;
  let t20;
  let canvas1;
  let t21;
  let p7;
  let t22_value = (
    /*i*/
    ctx[1]("metrics.liquidity.marketCapThreshold") + ""
  );
  let t22;
  let t23;
  let div8;
  let h32;
  let t24_value = (
    /*i*/
    ctx[1]("metrics.liquidity.entryVolume") + ""
  );
  let t24;
  let t25;
  let p8;
  let t26_value = (
    /*i*/
    ctx[1]("metrics.liquidity.entryVolumeDescription").replace(
      "{v1}",
      /*formatNumber*/
      ctx[2](Object.keys(
        /*entryVolume*/
        ctx[5].mean
      )[2], "zh")
    ).replace("{v2}", (Object.values(
      /*entryVolume*/
      ctx[5].portion
    )[2] * 100).toFixed(1)) + ""
  );
  let t26;
  let t27;
  let div7;
  let p9;
  let t28_value = (
    /*i*/
    ctx[1]("metrics.liquidity.tradeRatio") + ""
  );
  let t28;
  let t29;
  let div6;
  let t30;
  let p10;
  let t31_value = (
    /*i*/
    ctx[1]("metrics.liquidity.averageReturn") + ""
  );
  let t31;
  let t32;
  let canvas2;
  let t33;
  let p11;
  let t34_value = (
    /*i*/
    ctx[1]("metrics.liquidity.volumeThreshold") + ""
  );
  let t34;
  let t35;
  let div11;
  let h33;
  let t36_value = (
    /*i*/
    ctx[1]("metrics.liquidity.exitVolume") + ""
  );
  let t36;
  let t37;
  let p12;
  let t38_value = (
    /*i*/
    ctx[1]("metrics.liquidity.exitVolumeDescription").replace(
      "{v1}",
      /*formatNumber*/
      ctx[2](Object.keys(
        /*exitVolume*/
        ctx[6].mean
      )[2], "zh")
    ).replace("{v2}", (Object.values(
      /*exitVolume*/
      ctx[6].portion
    )[2] * 100).toFixed(1)) + ""
  );
  let t38;
  let t39;
  let div10;
  let p13;
  let t40_value = (
    /*i*/
    ctx[1]("metrics.liquidity.tradeRatioExitVolume") + ""
  );
  let t40;
  let t41;
  let div9;
  let t42;
  let p14;
  let t43_value = (
    /*i*/
    ctx[1]("metrics.liquidity.averageReturn") + ""
  );
  let t43;
  let t44;
  let canvas3;
  let t45;
  let p15;
  let t46_value = (
    /*i*/
    ctx[1]("metrics.liquidity.volumeThreshold") + ""
  );
  let t46;
  return {
    c() {
      div12 = element("div");
      div2 = element("div");
      h30 = element("h3");
      t0 = text(t0_value);
      t1 = space();
      p0 = element("p");
      t2 = text(t2_value);
      t3 = space();
      div1 = element("div");
      p1 = element("p");
      t4 = text(t4_value);
      t5 = space();
      div0 = element("div");
      t6 = space();
      p2 = element("p");
      t7 = text(t7_value);
      t8 = space();
      canvas0 = element("canvas");
      t9 = space();
      p3 = element("p");
      t10 = text(t10_value);
      t11 = space();
      div5 = element("div");
      h31 = element("h3");
      t12 = text(t12_value);
      t13 = space();
      p4 = element("p");
      t14 = text(t14_value);
      t15 = space();
      div4 = element("div");
      p5 = element("p");
      t16 = text(t16_value);
      t17 = space();
      div3 = element("div");
      t18 = space();
      p6 = element("p");
      t19 = text(t19_value);
      t20 = space();
      canvas1 = element("canvas");
      t21 = space();
      p7 = element("p");
      t22 = text(t22_value);
      t23 = space();
      div8 = element("div");
      h32 = element("h3");
      t24 = text(t24_value);
      t25 = space();
      p8 = element("p");
      t26 = text(t26_value);
      t27 = space();
      div7 = element("div");
      p9 = element("p");
      t28 = text(t28_value);
      t29 = space();
      div6 = element("div");
      t30 = space();
      p10 = element("p");
      t31 = text(t31_value);
      t32 = space();
      canvas2 = element("canvas");
      t33 = space();
      p11 = element("p");
      t34 = text(t34_value);
      t35 = space();
      div11 = element("div");
      h33 = element("h3");
      t36 = text(t36_value);
      t37 = space();
      p12 = element("p");
      t38 = text(t38_value);
      t39 = space();
      div10 = element("div");
      p13 = element("p");
      t40 = text(t40_value);
      t41 = space();
      div9 = element("div");
      t42 = space();
      p14 = element("p");
      t43 = text(t43_value);
      t44 = space();
      canvas3 = element("canvas");
      t45 = space();
      p15 = element("p");
      t46 = text(t46_value);
      attr(h30, "class", "font-bold text-3xl text-center text-base-content-200");
      attr(p0, "class", "mt-1 text-center");
      attr(p1, "class", "text-primary");
      attr(div0, "class", "flex-grow");
      attr(p2, "class", "text-secondary");
      attr(div1, "class", "flex mt-6");
      attr(canvas0, "width", "400");
      attr(canvas0, "height", "200");
      attr(p3, "class", "text-center mt-4");
      attr(div2, "class", "col-span-2 md:col-span-1 p-2 md:p-8 pt-8 md:border rounded-xl");
      attr(h31, "class", "font-bold text-3xl text-center text-base-content-200");
      attr(p4, "class", "mt-1 text-center");
      attr(p5, "class", "text-primary");
      attr(div3, "class", "flex-grow");
      attr(p6, "class", "text-secondary");
      attr(div4, "class", "flex mt-6");
      attr(canvas1, "width", "400");
      attr(canvas1, "height", "200");
      attr(p7, "class", "text-center mt-4");
      attr(div5, "class", "col-span-2 md:col-span-1 p-2 md:p-8 pt-8 md:border rounded-xl");
      attr(h32, "class", "font-bold text-3xl text-cneter text-center");
      attr(p8, "class", "mt-1 text-center text-base-content-200");
      attr(p9, "class", "text-primary");
      attr(div6, "class", "flex-grow");
      attr(p10, "class", "text-secondary");
      attr(div7, "class", "flex mt-6");
      attr(canvas2, "width", "400");
      attr(canvas2, "height", "200");
      attr(p11, "class", "text-center mt-4");
      attr(div8, "class", "col-span-2 md:col-span-1 p-2 md:p-8 pt-8 md:border rounded-xl");
      attr(h33, "class", "font-bold text-3xl text-center text-base-content-200");
      attr(p12, "class", "mt-1 text-center");
      attr(p13, "class", "text-primary");
      attr(div9, "class", "flex-grow");
      attr(p14, "class", "text-secondary");
      attr(div10, "class", "flex mt-6");
      attr(canvas3, "width", "400");
      attr(canvas3, "height", "200");
      attr(p15, "class", "text-center mt-4");
      attr(div11, "class", "col-span-2 md:col-span-1 p-2 md:p-8 pt-8 md:border rounded-xl");
      attr(div12, "class", "grid grid-cols-2 text-base-content-200 gap-4");
    },
    m(target, anchor) {
      insert(target, div12, anchor);
      append(div12, div2);
      append(div2, h30);
      append(h30, t0);
      append(div2, t1);
      append(div2, p0);
      append(p0, t2);
      append(div2, t3);
      append(div2, div1);
      append(div1, p1);
      append(p1, t4);
      append(div1, t5);
      append(div1, div0);
      append(div1, t6);
      append(div1, p2);
      append(p2, t7);
      append(div2, t8);
      append(div2, canvas0);
      ctx[11](canvas0);
      append(div2, t9);
      append(div2, p3);
      append(p3, t10);
      append(div12, t11);
      append(div12, div5);
      append(div5, h31);
      append(h31, t12);
      append(div5, t13);
      append(div5, p4);
      append(p4, t14);
      append(div5, t15);
      append(div5, div4);
      append(div4, p5);
      append(p5, t16);
      append(div4, t17);
      append(div4, div3);
      append(div4, t18);
      append(div4, p6);
      append(p6, t19);
      append(div5, t20);
      append(div5, canvas1);
      ctx[12](canvas1);
      append(div5, t21);
      append(div5, p7);
      append(p7, t22);
      append(div12, t23);
      append(div12, div8);
      append(div8, h32);
      append(h32, t24);
      append(div8, t25);
      append(div8, p8);
      append(p8, t26);
      append(div8, t27);
      append(div8, div7);
      append(div7, p9);
      append(p9, t28);
      append(div7, t29);
      append(div7, div6);
      append(div7, t30);
      append(div7, p10);
      append(p10, t31);
      append(div8, t32);
      append(div8, canvas2);
      ctx[13](canvas2);
      append(div8, t33);
      append(div8, p11);
      append(p11, t34);
      append(div12, t35);
      append(div12, div11);
      append(div11, h33);
      append(h33, t36);
      append(div11, t37);
      append(div11, p12);
      append(p12, t38);
      append(div11, t39);
      append(div11, div10);
      append(div10, p13);
      append(p13, t40);
      append(div10, t41);
      append(div10, div9);
      append(div10, t42);
      append(div10, p14);
      append(p14, t43);
      append(div11, t44);
      append(div11, canvas3);
      ctx[14](canvas3);
      append(div11, t45);
      append(div11, p15);
      append(p15, t46);
    },
    p(ctx2, [dirty]) {
      if (dirty & /*i*/
      2 && t0_value !== (t0_value = /*i*/
      ctx2[1]("metrics.liquidity.portfolioCapacity") + ""))
        set_data(t0, t0_value);
      if (dirty & /*i*/
      2 && t2_value !== (t2_value = /*i*/
      ctx2[1]("metrics.liquidity.portfolioCapacityDescription").replace(
        "{v1}",
        /*formatNumber*/
        ctx2[2](Object.keys(
          /*moneyFlow*/
          ctx2[3].mean
        )[1], "zh")
      ).replace("{v2}", ((1 - Object.values(
        /*moneyFlow*/
        ctx2[3].portion
      )[1]) * 100).toFixed(1)) + ""))
        set_data(t2, t2_value);
      if (dirty & /*i*/
      2 && t4_value !== (t4_value = /*i*/
      ctx2[1]("metrics.liquidity.safeLiquidityTradeRatio") + ""))
        set_data(t4, t4_value);
      if (dirty & /*i*/
      2 && t7_value !== (t7_value = /*i*/
      ctx2[1]("metrics.liquidity.averageReturn") + ""))
        set_data(t7, t7_value);
      if (dirty & /*i*/
      2 && t10_value !== (t10_value = /*i*/
      ctx2[1]("metrics.liquidity.totalInvestment") + ""))
        set_data(t10, t10_value);
      if (dirty & /*i*/
      2 && t12_value !== (t12_value = /*i*/
      ctx2[1]("metrics.liquidity.marketCap") + ""))
        set_data(t12, t12_value);
      if (dirty & /*i*/
      2 && t14_value !== (t14_value = /*i*/
      ctx2[1]("metrics.liquidity.marketCapDescription").replace(
        "{v1}",
        /*formatNumber*/
        ctx2[2](Object.keys(
          /*marketValue*/
          ctx2[4].mean
        )[2], "zh")
      ).replace("{v2}", (Object.values(
        /*marketValue*/
        ctx2[4].portion
      )[2] * 100).toFixed(1)) + ""))
        set_data(t14, t14_value);
      if (dirty & /*i*/
      2 && t16_value !== (t16_value = /*i*/
      ctx2[1]("metrics.liquidity.tradeRatio") + ""))
        set_data(t16, t16_value);
      if (dirty & /*i*/
      2 && t19_value !== (t19_value = /*i*/
      ctx2[1]("metrics.liquidity.averageReturn") + ""))
        set_data(t19, t19_value);
      if (dirty & /*i*/
      2 && t22_value !== (t22_value = /*i*/
      ctx2[1]("metrics.liquidity.marketCapThreshold") + ""))
        set_data(t22, t22_value);
      if (dirty & /*i*/
      2 && t24_value !== (t24_value = /*i*/
      ctx2[1]("metrics.liquidity.entryVolume") + ""))
        set_data(t24, t24_value);
      if (dirty & /*i*/
      2 && t26_value !== (t26_value = /*i*/
      ctx2[1]("metrics.liquidity.entryVolumeDescription").replace(
        "{v1}",
        /*formatNumber*/
        ctx2[2](Object.keys(
          /*entryVolume*/
          ctx2[5].mean
        )[2], "zh")
      ).replace("{v2}", (Object.values(
        /*entryVolume*/
        ctx2[5].portion
      )[2] * 100).toFixed(1)) + ""))
        set_data(t26, t26_value);
      if (dirty & /*i*/
      2 && t28_value !== (t28_value = /*i*/
      ctx2[1]("metrics.liquidity.tradeRatio") + ""))
        set_data(t28, t28_value);
      if (dirty & /*i*/
      2 && t31_value !== (t31_value = /*i*/
      ctx2[1]("metrics.liquidity.averageReturn") + ""))
        set_data(t31, t31_value);
      if (dirty & /*i*/
      2 && t34_value !== (t34_value = /*i*/
      ctx2[1]("metrics.liquidity.volumeThreshold") + ""))
        set_data(t34, t34_value);
      if (dirty & /*i*/
      2 && t36_value !== (t36_value = /*i*/
      ctx2[1]("metrics.liquidity.exitVolume") + ""))
        set_data(t36, t36_value);
      if (dirty & /*i*/
      2 && t38_value !== (t38_value = /*i*/
      ctx2[1]("metrics.liquidity.exitVolumeDescription").replace(
        "{v1}",
        /*formatNumber*/
        ctx2[2](Object.keys(
          /*exitVolume*/
          ctx2[6].mean
        )[2], "zh")
      ).replace("{v2}", (Object.values(
        /*exitVolume*/
        ctx2[6].portion
      )[2] * 100).toFixed(1)) + ""))
        set_data(t38, t38_value);
      if (dirty & /*i*/
      2 && t40_value !== (t40_value = /*i*/
      ctx2[1]("metrics.liquidity.tradeRatioExitVolume") + ""))
        set_data(t40, t40_value);
      if (dirty & /*i*/
      2 && t43_value !== (t43_value = /*i*/
      ctx2[1]("metrics.liquidity.averageReturn") + ""))
        set_data(t43, t43_value);
      if (dirty & /*i*/
      2 && t46_value !== (t46_value = /*i*/
      ctx2[1]("metrics.liquidity.volumeThreshold") + ""))
        set_data(t46, t46_value);
    },
    i: noop$1,
    o: noop$1,
    d(detaching) {
      if (detaching) {
        detach(div12);
      }
      ctx[11](null);
      ctx[12](null);
      ctx[13](null);
      ctx[14](null);
    }
  };
}
const percentageOfVolume = 0.05;
function quantile(arr, q2) {
  const filteredArr = arr.filter((value) => value !== null);
  if (filteredArr.length === 0) {
    return 0;
  }
  const sorted = filteredArr.sort((a2, b2) => a2 - b2);
  const pos = (sorted.length - 1) * q2;
  const base = Math.floor(pos);
  const rest = pos - base;
  if (sorted[base + 1] !== void 0) {
    return sorted[base] + rest * (sorted[base + 1] - sorted[base]);
  } else {
    return sorted[base];
  }
}
function generateList(length, exponent = 5) {
  let result = [];
  let baseValues = [5, 10];
  while (result.length < length) {
    for (let base of baseValues) {
      result.push(base * Math.pow(10, exponent));
      if (result.length === length) {
        break;
      }
    }
    exponent += 1;
  }
  return result;
}
function calculatePortionAndMean(trades, col, exponent = 5) {
  let portion = {};
  let mean = {};
  trades = trades.filter((trade) => trade[col] !== null && trade[col] !== void 0);
  for (let m2 of generateList(100, exponent)) {
    let s = trades.map((trade) => trade[col]);
    s.sort((a2, b2) => a2 - b2);
    let dropRatio = s.findIndex((value) => value > m2) / s.length;
    let filteredReturns = trades.filter((trade) => trade[col] > m2).map((trade) => trade["return"]);
    if (dropRatio === 0) {
      mean = {};
      portion = {};
    }
    mean[m2] = quantile(filteredReturns, 0.5);
    portion[m2] = 1 - dropRatio;
    if (portion[m2] < 0.2) {
      break;
    }
  }
  return { portion, mean };
}
function instance$a($$self, $$props, $$invalidate) {
  let i;
  let { lang = "en" } = $$props;
  Chart.register(LinearScale, BarController, CategoryScale, BarElement, LineController, LineElement, PointElement, plugin_tooltip);
  Chart.defaults.font.color = "red";
  let { browser } = $$props;
  let { report } = $$props;
  let { theme = "light" } = $$props;
  function formatNumber2(value, language = "zh") {
    if (lang === "en") {
      if (Math.abs(value) >= 1e9)
        return value / 1e9 + "B";
      if (Math.abs(value) >= 1e6)
        return value / 1e6 + "M";
      if (Math.abs(value) >= 1e3)
        return value / 1e3 + "K";
      return value;
    } else if (language === "zh") {
      if (Math.abs(value) >= 1e8)
        return value / 1e8 + "億";
      if (Math.abs(value) >= 1e7)
        return value / 1e7 + "千萬";
      if (Math.abs(value) >= 1e6)
        return value / 1e6 + "百萬";
      if (Math.abs(value) >= 1e4)
        return value / 1e4 + "萬";
      return value;
    }
  }
  function createChart(series, ctx, unit) {
    new Chart(
      ctx,
      {
        type: "bar",
        data: {
          labels: Object.keys(series.portion),
          datasets: [
            {
              label: "Data",
              data: Object.values(series.portion),
              backgroundColor: theme === "light" ? "#725bf5" : "#7a64f5",
              yAxisID: "y-axis-1",
              barPercentage: 0.2,
              order: 1
            },
            {
              label: "Line Data",
              data: Object.values(series.mean),
              type: "line",
              fill: false,
              borderColor: "#f16365",
              borderWidth: 5,
              pointBackgroundColor: "#f16365",
              pointBorderColor: "#f16365",
              yAxisID: "y-axis-2",
              order: 0
            }
          ]
        },
        options: {
          responsive: true,
          maintainAspectRatio: true,
          scales: {
            x: {
              type: "category",
              ticks: {
                color: theme === "light" ? "#000000aa" : "#FFFFFFaa",
                callback(value) {
                  return formatNumber2(Object.keys(series.portion)[value], "zh") + unit + "以上";
                }
              },
              grid: {
                color: "#77777755",
                // This will set the x-axis grid color to a light red.
                tickBorderDash: [2, 2]
              }
            },
            "y-axis-1": {
              display: true,
              position: "left",
              beginAtZero: true,
              ticks: {
                callback(value) {
                  return (value * 100).toFixed(0) + "%";
                },
                color: theme === "light" ? "#000000aa" : "#FFFFFFaa"
              },
              grid: {
                color: "#77777755",
                // This will set the x-axis grid color to a light red.
                tickBorderDash: [2, 2]
              }
            },
            "y-axis-2": {
              display: true,
              position: "right",
              ticks: {
                callback(value) {
                  return (value * 100).toFixed(1) + "%";
                },
                color: theme === "light" ? "#000000aa" : "#FFFFFFaa"
              },
              // grid line settings
              grid: {
                drawOnChartArea: false,
                // only want the grid lines for one axis to show up
                color: "#77777755",
                // This will set the x-axis grid color to a light red.
                tickBorderDash: [2, 2]
              }
            }
          }
        }
      }
    );
  }
  report.trades.forEach((trade) => {
    trade.acceptMoneyFlow = (trade["turnover@entry_date"] * percentageOfVolume / trade.position + trade["turnover@entry_date"] * percentageOfVolume / trade.position) / 2;
    if (lang === "zh-tw") {
      trade["volume_@entry_date"] = trade["volume@entry_date"] / 1e3;
      trade["volume_@exit_date"] = trade["volume@exit_date"] / 1e3;
    } else {
      trade["volume_@entry_date"] = trade["volume@entry_date"];
      trade["volume_@exit_date"] = trade["volume@exit_date"];
    }
  });
  const moneyFlow = calculatePortionAndMean(report.trades, "acceptMoneyFlow", 5);
  const marketValue = calculatePortionAndMean(report.trades, "market_value@entry_date", 5);
  const entryVolume = calculatePortionAndMean(report.trades, "volume_@entry_date", 1);
  const exitVolume = calculatePortionAndMean(report.trades, "volume_@exit_date", 1);
  let canvas = {};
  onMount(() => {
    if (!browser)
      return;
    const ctx = canvas["moneyFlow"].getContext("2d");
    createChart(moneyFlow, ctx, "元");
    const ctx2 = canvas["marketValue"].getContext("2d");
    createChart(marketValue, ctx2, "元");
    const ctx3 = canvas["entryVolume"].getContext("2d");
    createChart(entryVolume, ctx3, "張");
    const ctx4 = canvas["exitVolume"].getContext("2d");
    createChart(exitVolume, ctx4, "張");
  });
  function canvas0_binding($$value) {
    binding_callbacks[$$value ? "unshift" : "push"](() => {
      canvas["moneyFlow"] = $$value;
      $$invalidate(0, canvas);
    });
  }
  function canvas1_binding($$value) {
    binding_callbacks[$$value ? "unshift" : "push"](() => {
      canvas["marketValue"] = $$value;
      $$invalidate(0, canvas);
    });
  }
  function canvas2_binding($$value) {
    binding_callbacks[$$value ? "unshift" : "push"](() => {
      canvas["entryVolume"] = $$value;
      $$invalidate(0, canvas);
    });
  }
  function canvas3_binding($$value) {
    binding_callbacks[$$value ? "unshift" : "push"](() => {
      canvas["exitVolume"] = $$value;
      $$invalidate(0, canvas);
    });
  }
  $$self.$$set = ($$props2) => {
    if ("lang" in $$props2)
      $$invalidate(7, lang = $$props2.lang);
    if ("browser" in $$props2)
      $$invalidate(8, browser = $$props2.browser);
    if ("report" in $$props2)
      $$invalidate(9, report = $$props2.report);
    if ("theme" in $$props2)
      $$invalidate(10, theme = $$props2.theme);
  };
  $$self.$$.update = () => {
    if ($$self.$$.dirty & /*lang*/
    128) {
      $$invalidate(1, i = (key) => lang === "en" ? ien(key) : itw(key));
    }
  };
  return [
    canvas,
    i,
    formatNumber2,
    moneyFlow,
    marketValue,
    entryVolume,
    exitVolume,
    lang,
    browser,
    report,
    theme,
    canvas0_binding,
    canvas1_binding,
    canvas2_binding,
    canvas3_binding
  ];
}
class Liquidity extends SvelteComponent {
  constructor(options) {
    super();
    init(this, options, instance$a, create_fragment$a, safe_not_equal, {
      lang: 7,
      browser: 8,
      report: 9,
      theme: 10
    });
  }
  get lang() {
    return this.$$.ctx[7];
  }
  set lang(lang) {
    this.$$set({ lang });
    flush();
  }
  get browser() {
    return this.$$.ctx[8];
  }
  set browser(browser) {
    this.$$set({ browser });
    flush();
  }
  get report() {
    return this.$$.ctx[9];
  }
  set report(report) {
    this.$$set({ report });
    flush();
  }
  get theme() {
    return this.$$.ctx[10];
  }
  set theme(theme) {
    this.$$set({ theme });
    flush();
  }
}
create_custom_element(Liquidity, { "lang": {}, "browser": {}, "report": {}, "theme": {} }, [], [], true);
function size(_a) {
  var width = _a.width, height = _a.height;
  if (width < 0) {
    throw new Error("Negative width is not allowed for Size");
  }
  if (height < 0) {
    throw new Error("Negative height is not allowed for Size");
  }
  return {
    width,
    height
  };
}
function equalSizes(first, second) {
  return first.width === second.width && first.height === second.height;
}
var Observable = (
  /** @class */
  function() {
    function Observable2(win) {
      var _this = this;
      this._resolutionListener = function() {
        return _this._onResolutionChanged();
      };
      this._resolutionMediaQueryList = null;
      this._observers = [];
      this._window = win;
      this._installResolutionListener();
    }
    Observable2.prototype.dispose = function() {
      this._uninstallResolutionListener();
      this._window = null;
    };
    Object.defineProperty(Observable2.prototype, "value", {
      get: function() {
        return this._window.devicePixelRatio;
      },
      enumerable: false,
      configurable: true
    });
    Observable2.prototype.subscribe = function(next) {
      var _this = this;
      var observer = { next };
      this._observers.push(observer);
      return {
        unsubscribe: function() {
          _this._observers = _this._observers.filter(function(o2) {
            return o2 !== observer;
          });
        }
      };
    };
    Observable2.prototype._installResolutionListener = function() {
      if (this._resolutionMediaQueryList !== null) {
        throw new Error("Resolution listener is already installed");
      }
      var dppx = this._window.devicePixelRatio;
      this._resolutionMediaQueryList = this._window.matchMedia("all and (resolution: ".concat(dppx, "dppx)"));
      this._resolutionMediaQueryList.addListener(this._resolutionListener);
    };
    Observable2.prototype._uninstallResolutionListener = function() {
      if (this._resolutionMediaQueryList !== null) {
        this._resolutionMediaQueryList.removeListener(this._resolutionListener);
        this._resolutionMediaQueryList = null;
      }
    };
    Observable2.prototype._reinstallResolutionListener = function() {
      this._uninstallResolutionListener();
      this._installResolutionListener();
    };
    Observable2.prototype._onResolutionChanged = function() {
      var _this = this;
      this._observers.forEach(function(observer) {
        return observer.next(_this._window.devicePixelRatio);
      });
      this._reinstallResolutionListener();
    };
    return Observable2;
  }()
);
function createObservable(win) {
  return new Observable(win);
}
var DevicePixelContentBoxBinding = (
  /** @class */
  function() {
    function DevicePixelContentBoxBinding2(canvasElement, transformBitmapSize, options) {
      var _a;
      this._canvasElement = null;
      this._bitmapSizeChangedListeners = [];
      this._suggestedBitmapSize = null;
      this._suggestedBitmapSizeChangedListeners = [];
      this._devicePixelRatioObservable = null;
      this._canvasElementResizeObserver = null;
      this._canvasElement = canvasElement;
      this._canvasElementClientSize = size({
        width: this._canvasElement.clientWidth,
        height: this._canvasElement.clientHeight
      });
      this._transformBitmapSize = transformBitmapSize !== null && transformBitmapSize !== void 0 ? transformBitmapSize : function(size2) {
        return size2;
      };
      this._allowResizeObserver = (_a = options === null || options === void 0 ? void 0 : options.allowResizeObserver) !== null && _a !== void 0 ? _a : true;
      this._chooseAndInitObserver();
    }
    DevicePixelContentBoxBinding2.prototype.dispose = function() {
      var _a, _b;
      if (this._canvasElement === null) {
        throw new Error("Object is disposed");
      }
      (_a = this._canvasElementResizeObserver) === null || _a === void 0 ? void 0 : _a.disconnect();
      this._canvasElementResizeObserver = null;
      (_b = this._devicePixelRatioObservable) === null || _b === void 0 ? void 0 : _b.dispose();
      this._devicePixelRatioObservable = null;
      this._suggestedBitmapSizeChangedListeners.length = 0;
      this._bitmapSizeChangedListeners.length = 0;
      this._canvasElement = null;
    };
    Object.defineProperty(DevicePixelContentBoxBinding2.prototype, "canvasElement", {
      get: function() {
        if (this._canvasElement === null) {
          throw new Error("Object is disposed");
        }
        return this._canvasElement;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(DevicePixelContentBoxBinding2.prototype, "canvasElementClientSize", {
      get: function() {
        return this._canvasElementClientSize;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(DevicePixelContentBoxBinding2.prototype, "bitmapSize", {
      get: function() {
        return size({
          width: this.canvasElement.width,
          height: this.canvasElement.height
        });
      },
      enumerable: false,
      configurable: true
    });
    DevicePixelContentBoxBinding2.prototype.resizeCanvasElement = function(clientSize) {
      this._canvasElementClientSize = size(clientSize);
      this.canvasElement.style.width = "".concat(this._canvasElementClientSize.width, "px");
      this.canvasElement.style.height = "".concat(this._canvasElementClientSize.height, "px");
      this._invalidateBitmapSize();
    };
    DevicePixelContentBoxBinding2.prototype.subscribeBitmapSizeChanged = function(listener) {
      this._bitmapSizeChangedListeners.push(listener);
    };
    DevicePixelContentBoxBinding2.prototype.unsubscribeBitmapSizeChanged = function(listener) {
      this._bitmapSizeChangedListeners = this._bitmapSizeChangedListeners.filter(function(l2) {
        return l2 !== listener;
      });
    };
    Object.defineProperty(DevicePixelContentBoxBinding2.prototype, "suggestedBitmapSize", {
      get: function() {
        return this._suggestedBitmapSize;
      },
      enumerable: false,
      configurable: true
    });
    DevicePixelContentBoxBinding2.prototype.subscribeSuggestedBitmapSizeChanged = function(listener) {
      this._suggestedBitmapSizeChangedListeners.push(listener);
    };
    DevicePixelContentBoxBinding2.prototype.unsubscribeSuggestedBitmapSizeChanged = function(listener) {
      this._suggestedBitmapSizeChangedListeners = this._suggestedBitmapSizeChangedListeners.filter(function(l2) {
        return l2 !== listener;
      });
    };
    DevicePixelContentBoxBinding2.prototype.applySuggestedBitmapSize = function() {
      if (this._suggestedBitmapSize === null) {
        return;
      }
      var oldSuggestedSize = this._suggestedBitmapSize;
      this._suggestedBitmapSize = null;
      this._resizeBitmap(oldSuggestedSize);
      this._emitSuggestedBitmapSizeChanged(oldSuggestedSize, this._suggestedBitmapSize);
    };
    DevicePixelContentBoxBinding2.prototype._resizeBitmap = function(newSize) {
      var oldSize = this.bitmapSize;
      if (equalSizes(oldSize, newSize)) {
        return;
      }
      this.canvasElement.width = newSize.width;
      this.canvasElement.height = newSize.height;
      this._emitBitmapSizeChanged(oldSize, newSize);
    };
    DevicePixelContentBoxBinding2.prototype._emitBitmapSizeChanged = function(oldSize, newSize) {
      var _this = this;
      this._bitmapSizeChangedListeners.forEach(function(listener) {
        return listener.call(_this, oldSize, newSize);
      });
    };
    DevicePixelContentBoxBinding2.prototype._suggestNewBitmapSize = function(newSize) {
      var oldSuggestedSize = this._suggestedBitmapSize;
      var finalNewSize = size(this._transformBitmapSize(newSize, this._canvasElementClientSize));
      var newSuggestedSize = equalSizes(this.bitmapSize, finalNewSize) ? null : finalNewSize;
      if (oldSuggestedSize === null && newSuggestedSize === null) {
        return;
      }
      if (oldSuggestedSize !== null && newSuggestedSize !== null && equalSizes(oldSuggestedSize, newSuggestedSize)) {
        return;
      }
      this._suggestedBitmapSize = newSuggestedSize;
      this._emitSuggestedBitmapSizeChanged(oldSuggestedSize, newSuggestedSize);
    };
    DevicePixelContentBoxBinding2.prototype._emitSuggestedBitmapSizeChanged = function(oldSize, newSize) {
      var _this = this;
      this._suggestedBitmapSizeChangedListeners.forEach(function(listener) {
        return listener.call(_this, oldSize, newSize);
      });
    };
    DevicePixelContentBoxBinding2.prototype._chooseAndInitObserver = function() {
      var _this = this;
      if (!this._allowResizeObserver) {
        this._initDevicePixelRatioObservable();
        return;
      }
      isDevicePixelContentBoxSupported().then(function(isSupported) {
        return isSupported ? _this._initResizeObserver() : _this._initDevicePixelRatioObservable();
      });
    };
    DevicePixelContentBoxBinding2.prototype._initDevicePixelRatioObservable = function() {
      var _this = this;
      if (this._canvasElement === null) {
        return;
      }
      var win = canvasElementWindow(this._canvasElement);
      if (win === null) {
        throw new Error("No window is associated with the canvas");
      }
      this._devicePixelRatioObservable = createObservable(win);
      this._devicePixelRatioObservable.subscribe(function() {
        return _this._invalidateBitmapSize();
      });
      this._invalidateBitmapSize();
    };
    DevicePixelContentBoxBinding2.prototype._invalidateBitmapSize = function() {
      var _a, _b;
      if (this._canvasElement === null) {
        return;
      }
      var win = canvasElementWindow(this._canvasElement);
      if (win === null) {
        return;
      }
      var ratio = (_b = (_a = this._devicePixelRatioObservable) === null || _a === void 0 ? void 0 : _a.value) !== null && _b !== void 0 ? _b : win.devicePixelRatio;
      var canvasRects = this._canvasElement.getClientRects();
      var newSize = (
        // eslint-disable-next-line no-negated-condition
        canvasRects[0] !== void 0 ? predictedBitmapSize(canvasRects[0], ratio) : size({
          width: this._canvasElementClientSize.width * ratio,
          height: this._canvasElementClientSize.height * ratio
        })
      );
      this._suggestNewBitmapSize(newSize);
    };
    DevicePixelContentBoxBinding2.prototype._initResizeObserver = function() {
      var _this = this;
      if (this._canvasElement === null) {
        return;
      }
      this._canvasElementResizeObserver = new ResizeObserver(function(entries) {
        var entry = entries.find(function(entry2) {
          return entry2.target === _this._canvasElement;
        });
        if (!entry || !entry.devicePixelContentBoxSize || !entry.devicePixelContentBoxSize[0]) {
          return;
        }
        var entrySize = entry.devicePixelContentBoxSize[0];
        var newSize = size({
          width: entrySize.inlineSize,
          height: entrySize.blockSize
        });
        _this._suggestNewBitmapSize(newSize);
      });
      this._canvasElementResizeObserver.observe(this._canvasElement, { box: "device-pixel-content-box" });
    };
    return DevicePixelContentBoxBinding2;
  }()
);
function bindTo(canvasElement, target) {
  if (target.type === "device-pixel-content-box") {
    return new DevicePixelContentBoxBinding(canvasElement, target.transform, target.options);
  }
  throw new Error("Unsupported binding target");
}
function canvasElementWindow(canvasElement) {
  return canvasElement.ownerDocument.defaultView;
}
function isDevicePixelContentBoxSupported() {
  return new Promise(function(resolve2) {
    var ro = new ResizeObserver(function(entries) {
      resolve2(entries.every(function(entry) {
        return "devicePixelContentBoxSize" in entry;
      }));
      ro.disconnect();
    });
    ro.observe(document.body, { box: "device-pixel-content-box" });
  }).catch(function() {
    return false;
  });
}
function predictedBitmapSize(canvasRect, ratio) {
  return size({
    width: Math.round(canvasRect.left * ratio + canvasRect.width * ratio) - Math.round(canvasRect.left * ratio),
    height: Math.round(canvasRect.top * ratio + canvasRect.height * ratio) - Math.round(canvasRect.top * ratio)
  });
}
var CanvasRenderingTarget2D = (
  /** @class */
  function() {
    function CanvasRenderingTarget2D2(context, mediaSize, bitmapSize) {
      if (mediaSize.width === 0 || mediaSize.height === 0) {
        throw new TypeError("Rendering target could only be created on a media with positive width and height");
      }
      this._mediaSize = mediaSize;
      if (bitmapSize.width === 0 || bitmapSize.height === 0) {
        throw new TypeError("Rendering target could only be created using a bitmap with positive integer width and height");
      }
      this._bitmapSize = bitmapSize;
      this._context = context;
    }
    CanvasRenderingTarget2D2.prototype.useMediaCoordinateSpace = function(f2) {
      try {
        this._context.save();
        this._context.setTransform(1, 0, 0, 1, 0, 0);
        this._context.scale(this._horizontalPixelRatio, this._verticalPixelRatio);
        return f2({
          context: this._context,
          mediaSize: this._mediaSize
        });
      } finally {
        this._context.restore();
      }
    };
    CanvasRenderingTarget2D2.prototype.useBitmapCoordinateSpace = function(f2) {
      try {
        this._context.save();
        this._context.setTransform(1, 0, 0, 1, 0, 0);
        return f2({
          context: this._context,
          mediaSize: this._mediaSize,
          bitmapSize: this._bitmapSize,
          horizontalPixelRatio: this._horizontalPixelRatio,
          verticalPixelRatio: this._verticalPixelRatio
        });
      } finally {
        this._context.restore();
      }
    };
    Object.defineProperty(CanvasRenderingTarget2D2.prototype, "_horizontalPixelRatio", {
      get: function() {
        return this._bitmapSize.width / this._mediaSize.width;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(CanvasRenderingTarget2D2.prototype, "_verticalPixelRatio", {
      get: function() {
        return this._bitmapSize.height / this._mediaSize.height;
      },
      enumerable: false,
      configurable: true
    });
    return CanvasRenderingTarget2D2;
  }()
);
function tryCreateCanvasRenderingTarget2D(binding, contextOptions) {
  var mediaSize = binding.canvasElementClientSize;
  if (mediaSize.width === 0 || mediaSize.height === 0) {
    return null;
  }
  var bitmapSize = binding.bitmapSize;
  if (bitmapSize.width === 0 || bitmapSize.height === 0) {
    return null;
  }
  var context = binding.canvasElement.getContext("2d", contextOptions);
  if (context === null) {
    return null;
  }
  return new CanvasRenderingTarget2D(context, mediaSize, bitmapSize);
}
/*!
 * @license
 * TradingView Lightweight Charts™ v4.0.1
 * Copyright (c) 2023 TradingView, Inc.
 * Licensed under Apache License 2.0 https://www.apache.org/licenses/LICENSE-2.0
 */
var e, r;
function h(t, i) {
  const n = { 0: [], 1: [t.lineWidth, t.lineWidth], 2: [2 * t.lineWidth, 2 * t.lineWidth], 3: [6 * t.lineWidth, 6 * t.lineWidth], 4: [t.lineWidth, 4 * t.lineWidth] }[i];
  t.setLineDash(n);
}
function l(t, i, n, s) {
  t.beginPath();
  const e2 = t.lineWidth % 2 ? 0.5 : 0;
  t.moveTo(n, i + e2), t.lineTo(s, i + e2), t.stroke();
}
function a(t, i) {
  if (!t)
    throw new Error("Assertion failed" + (i ? ": " + i : ""));
}
function o(t) {
  if (void 0 === t)
    throw new Error("Value is undefined");
  return t;
}
function _(t) {
  if (null === t)
    throw new Error("Value is null");
  return t;
}
function u(t) {
  return _(o(t));
}
!function(t) {
  t[t.Simple = 0] = "Simple", t[t.WithSteps = 1] = "WithSteps", t[t.Curved = 2] = "Curved";
}(e || (e = {})), function(t) {
  t[t.Solid = 0] = "Solid", t[t.Dotted = 1] = "Dotted", t[t.Dashed = 2] = "Dashed", t[t.LargeDashed = 3] = "LargeDashed", t[t.SparseDotted = 4] = "SparseDotted";
}(r || (r = {}));
const c = { khaki: "#f0e68c", azure: "#f0ffff", aliceblue: "#f0f8ff", ghostwhite: "#f8f8ff", gold: "#ffd700", goldenrod: "#daa520", gainsboro: "#dcdcdc", gray: "#808080", green: "#008000", honeydew: "#f0fff0", floralwhite: "#fffaf0", lightblue: "#add8e6", lightcoral: "#f08080", lemonchiffon: "#fffacd", hotpink: "#ff69b4", lightyellow: "#ffffe0", greenyellow: "#adff2f", lightgoldenrodyellow: "#fafad2", limegreen: "#32cd32", linen: "#faf0e6", lightcyan: "#e0ffff", magenta: "#f0f", maroon: "#800000", olive: "#808000", orange: "#ffa500", oldlace: "#fdf5e6", mediumblue: "#0000cd", transparent: "#0000", lime: "#0f0", lightpink: "#ffb6c1", mistyrose: "#ffe4e1", moccasin: "#ffe4b5", midnightblue: "#191970", orchid: "#da70d6", mediumorchid: "#ba55d3", mediumturquoise: "#48d1cc", orangered: "#ff4500", royalblue: "#4169e1", powderblue: "#b0e0e6", red: "#f00", coral: "#ff7f50", turquoise: "#40e0d0", white: "#fff", whitesmoke: "#f5f5f5", wheat: "#f5deb3", teal: "#008080", steelblue: "#4682b4", bisque: "#ffe4c4", aquamarine: "#7fffd4", aqua: "#0ff", sienna: "#a0522d", silver: "#c0c0c0", springgreen: "#00ff7f", antiquewhite: "#faebd7", burlywood: "#deb887", brown: "#a52a2a", beige: "#f5f5dc", chocolate: "#d2691e", chartreuse: "#7fff00", cornflowerblue: "#6495ed", cornsilk: "#fff8dc", crimson: "#dc143c", cadetblue: "#5f9ea0", tomato: "#ff6347", fuchsia: "#f0f", blue: "#00f", salmon: "#fa8072", blanchedalmond: "#ffebcd", slateblue: "#6a5acd", slategray: "#708090", thistle: "#d8bfd8", tan: "#d2b48c", cyan: "#0ff", darkblue: "#00008b", darkcyan: "#008b8b", darkgoldenrod: "#b8860b", darkgray: "#a9a9a9", blueviolet: "#8a2be2", black: "#000", darkmagenta: "#8b008b", darkslateblue: "#483d8b", darkkhaki: "#bdb76b", darkorchid: "#9932cc", darkorange: "#ff8c00", darkgreen: "#006400", darkred: "#8b0000", dodgerblue: "#1e90ff", darkslategray: "#2f4f4f", dimgray: "#696969", deepskyblue: "#00bfff", firebrick: "#b22222", forestgreen: "#228b22", indigo: "#4b0082", ivory: "#fffff0", lavenderblush: "#fff0f5", feldspar: "#d19275", indianred: "#cd5c5c", lightgreen: "#90ee90", lightgrey: "#d3d3d3", lightskyblue: "#87cefa", lightslategray: "#789", lightslateblue: "#8470ff", snow: "#fffafa", lightseagreen: "#20b2aa", lightsalmon: "#ffa07a", darksalmon: "#e9967a", darkviolet: "#9400d3", mediumpurple: "#9370d8", mediumaquamarine: "#66cdaa", skyblue: "#87ceeb", lavender: "#e6e6fa", lightsteelblue: "#b0c4de", mediumvioletred: "#c71585", mintcream: "#f5fffa", navajowhite: "#ffdead", navy: "#000080", olivedrab: "#6b8e23", palevioletred: "#d87093", violetred: "#d02090", yellow: "#ff0", yellowgreen: "#9acd32", lawngreen: "#7cfc00", pink: "#ffc0cb", paleturquoise: "#afeeee", palegoldenrod: "#eee8aa", darkolivegreen: "#556b2f", darkseagreen: "#8fbc8f", darkturquoise: "#00ced1", peachpuff: "#ffdab9", deeppink: "#ff1493", violet: "#ee82ee", palegreen: "#98fb98", mediumseagreen: "#3cb371", peru: "#cd853f", saddlebrown: "#8b4513", sandybrown: "#f4a460", rosybrown: "#bc8f8f", purple: "#800080", seagreen: "#2e8b57", seashell: "#fff5ee", papayawhip: "#ffefd5", mediumslateblue: "#7b68ee", plum: "#dda0dd", mediumspringgreen: "#00fa9a" };
function d(t) {
  return t < 0 ? 0 : t > 255 ? 255 : Math.round(t) || 0;
}
function f(t) {
  return t <= 0 || t > 0 ? t < 0 ? 0 : t > 1 ? 1 : Math.round(1e4 * t) / 1e4 : 0;
}
const p = /^#([0-9a-f])([0-9a-f])([0-9a-f])([0-9a-f])?$/i, v = /^#([0-9a-f]{2})([0-9a-f]{2})([0-9a-f]{2})([0-9a-f]{2})?$/i, m = /^rgb\(\s*(-?\d{1,10})\s*,\s*(-?\d{1,10})\s*,\s*(-?\d{1,10})\s*\)$/, b = /^rgba\(\s*(-?\d{1,10})\s*,\s*(-?\d{1,10})\s*,\s*(-?\d{1,10})\s*,\s*(-?[\d]{0,10}(?:\.\d+)?)\s*\)$/;
function g(t) {
  (t = t.toLowerCase()) in c && (t = c[t]);
  {
    const i = b.exec(t) || m.exec(t);
    if (i)
      return [d(parseInt(i[1], 10)), d(parseInt(i[2], 10)), d(parseInt(i[3], 10)), f(i.length < 5 ? 1 : parseFloat(i[4]))];
  }
  {
    const i = v.exec(t);
    if (i)
      return [d(parseInt(i[1], 16)), d(parseInt(i[2], 16)), d(parseInt(i[3], 16)), 1];
  }
  {
    const i = p.exec(t);
    if (i)
      return [d(17 * parseInt(i[1], 16)), d(17 * parseInt(i[2], 16)), d(17 * parseInt(i[3], 16)), 1];
  }
  throw new Error(`Cannot parse color: ${t}`);
}
function w(t) {
  const i = g(t);
  return { t: `rgb(${i[0]}, ${i[1]}, ${i[2]})`, i: (n = i, 0.199 * n[0] + 0.687 * n[1] + 0.114 * n[2] > 160 ? "black" : "white") };
  var n;
}
class M {
  constructor() {
    this.h = [];
  }
  l(t, i, n) {
    const s = { o: t, _: i, u: true === n };
    this.h.push(s);
  }
  p(t) {
    const i = this.h.findIndex((i2) => t === i2.o);
    i > -1 && this.h.splice(i, 1);
  }
  v(t) {
    this.h = this.h.filter((i) => i._ !== t);
  }
  m(t, i, n) {
    const s = [...this.h];
    this.h = this.h.filter((t2) => !t2.u), s.forEach((s2) => s2.o(t, i, n));
  }
  g() {
    return this.h.length > 0;
  }
  M() {
    this.h = [];
  }
}
function S(t, ...i) {
  for (const n of i)
    for (const i2 in n)
      void 0 !== n[i2] && ("object" != typeof n[i2] || void 0 === t[i2] ? t[i2] = n[i2] : S(t[i2], n[i2]));
  return t;
}
function x(t) {
  return "number" == typeof t && isFinite(t);
}
function y(t) {
  return "number" == typeof t && t % 1 == 0;
}
function k(t) {
  return "string" == typeof t;
}
function C(t) {
  return "boolean" == typeof t;
}
function T(t) {
  const i = t;
  if (!i || "object" != typeof i)
    return i;
  let n, s, e2;
  for (s in n = Array.isArray(i) ? [] : {}, i)
    i.hasOwnProperty(s) && (e2 = i[s], n[s] = e2 && "object" == typeof e2 ? T(e2) : e2);
  return n;
}
function P(t) {
  return null !== t;
}
function R(t) {
  return null === t ? void 0 : t;
}
const D = "-apple-system, BlinkMacSystemFont, 'Trebuchet MS', Roboto, Ubuntu, sans-serif";
function B(t, i, n) {
  return void 0 === i && (i = D), `${n = void 0 !== n ? `${n} ` : ""}${t}px ${i}`;
}
class A {
  constructor(t) {
    this.S = { k: 1, C: 5, T: NaN, P: "", R: "", D: "", B: "", A: 0, O: 0, L: 0, I: 0, V: 0 }, this.N = t;
  }
  F() {
    const t = this.S, i = this.W(), n = this.j();
    return t.T === i && t.R === n || (t.T = i, t.R = n, t.P = B(i, n), t.I = 2.5 / 12 * i, t.A = t.I, t.O = i / 12 * t.C, t.L = i / 12 * t.C, t.V = 0), t.D = this.$(), t.B = this.H(), this.S;
  }
  $() {
    return this.N.F().layout.textColor;
  }
  H() {
    return this.N.U();
  }
  W() {
    return this.N.F().layout.fontSize;
  }
  j() {
    return this.N.F().layout.fontFamily;
  }
}
class O {
  constructor() {
    this.q = [];
  }
  Y(t) {
    this.q = t;
  }
  X(t, i, n) {
    this.q.forEach((s) => {
      s.X(t, i, n);
    });
  }
}
class L {
  X(t, i, n) {
    t.useMediaCoordinateSpace((t2) => this.Z(t2, i, n));
  }
  K(t, i, n) {
    t.useMediaCoordinateSpace((t2) => this.G(t2, i, n));
  }
  G(t, i, n) {
  }
}
class I extends L {
  constructor() {
    super(...arguments), this.J = null;
  }
  tt(t) {
    this.J = t;
  }
  Z({ context: t }) {
    if (null === this.J || null === this.J.it)
      return;
    const i = this.J.it, n = this.J, s = (s2) => {
      t.beginPath();
      for (let e2 = i.to - 1; e2 >= i.from; --e2) {
        const i2 = n.nt[e2];
        t.moveTo(i2.st, i2.et), t.arc(i2.st, i2.et, s2, 0, 2 * Math.PI);
      }
      t.fill();
    };
    n.rt > 0 && (t.fillStyle = n.ht, s(n.lt + n.rt)), t.fillStyle = n.ot, s(n.lt);
  }
}
function E() {
  return { nt: [{ st: 0, et: 0, _t: 0, ut: 0 }], ot: "", ht: "", lt: 0, rt: 0, it: null };
}
const z = { from: 0, to: 1 };
class V {
  constructor(t, i) {
    this.ct = new O(), this.dt = [], this.ft = [], this.vt = true, this.N = t, this.bt = i, this.ct.Y(this.dt);
  }
  gt(t) {
    const i = this.N.wt();
    i.length !== this.dt.length && (this.ft = i.map(E), this.dt = this.ft.map((t2) => {
      const i2 = new I();
      return i2.tt(t2), i2;
    }), this.ct.Y(this.dt)), this.vt = true;
  }
  Mt() {
    return this.vt && (this.St(), this.vt = false), this.ct;
  }
  St() {
    const t = this.N.wt(), i = this.bt.xt(), n = this.N.yt();
    t.forEach((t2, s) => {
      var e2;
      const r2 = this.ft[s], h3 = t2.kt(i);
      if (null === h3 || !t2.Ct())
        return void (r2.it = null);
      const l2 = _(t2.Tt());
      r2.ot = h3.Pt, r2.lt = h3.lt, r2.rt = h3.Rt, r2.nt[0].ut = h3.ut, r2.nt[0].et = t2.Bt().Dt(h3.ut, l2.At), r2.ht = null !== (e2 = h3.Ot) && void 0 !== e2 ? e2 : this.N.Lt(r2.nt[0].et / t2.Bt().It()), r2.nt[0]._t = i, r2.nt[0].st = n.Et(i), r2.it = z;
    });
  }
}
class N {
  X(t, i, n) {
    t.useBitmapCoordinateSpace((t2) => this.Z(t2, i, n));
  }
}
class F extends N {
  constructor(t) {
    super(), this.zt = t;
  }
  Z({ context: t, bitmapSize: i, horizontalPixelRatio: n, verticalPixelRatio: s }) {
    if (null === this.zt)
      return;
    const e2 = this.zt.Vt.Ct, r2 = this.zt.Nt.Ct;
    if (!e2 && !r2)
      return;
    const a2 = Math.round(this.zt.st * n), o2 = Math.round(this.zt.et * s);
    t.lineCap = "butt", e2 && a2 >= 0 && (t.lineWidth = Math.floor(this.zt.Vt.rt * n), t.strokeStyle = this.zt.Vt.D, t.fillStyle = this.zt.Vt.D, h(t, this.zt.Vt.Ft), function(t2, i2, n2, s2) {
      t2.beginPath();
      const e3 = t2.lineWidth % 2 ? 0.5 : 0;
      t2.moveTo(i2 + e3, n2), t2.lineTo(i2 + e3, s2), t2.stroke();
    }(t, a2, 0, i.height)), r2 && o2 >= 0 && (t.lineWidth = Math.floor(this.zt.Nt.rt * s), t.strokeStyle = this.zt.Nt.D, t.fillStyle = this.zt.Nt.D, h(t, this.zt.Nt.Ft), l(t, o2, 0, i.width));
  }
}
class W {
  constructor(t) {
    this.vt = true, this.Wt = { Vt: { rt: 1, Ft: 0, D: "", Ct: false }, Nt: { rt: 1, Ft: 0, D: "", Ct: false }, st: 0, et: 0 }, this.jt = new F(this.Wt), this.$t = t;
  }
  gt() {
    this.vt = true;
  }
  Mt() {
    return this.vt && (this.St(), this.vt = false), this.jt;
  }
  St() {
    const t = this.$t.Ct(), i = _(this.$t.Ht()), n = i.Ut().F().crosshair, s = this.Wt;
    s.Nt.Ct = t && this.$t.qt(i), s.Vt.Ct = t && this.$t.Yt(), s.Nt.rt = n.horzLine.width, s.Nt.Ft = n.horzLine.style, s.Nt.D = n.horzLine.color, s.Vt.rt = n.vertLine.width, s.Vt.Ft = n.vertLine.style, s.Vt.D = n.vertLine.color, s.st = this.$t.Xt(), s.et = this.$t.Zt();
  }
}
function j(t, i, n, s, e2, r2) {
  t.fillRect(i + r2, n, s - 2 * r2, r2), t.fillRect(i + r2, n + e2 - r2, s - 2 * r2, r2), t.fillRect(i, n, r2, e2), t.fillRect(i + s - r2, n, r2, e2);
}
function $(t, i, n, s, e2, r2) {
  t.save(), t.globalCompositeOperation = "copy", t.fillStyle = r2, t.fillRect(i, n, s, e2), t.restore();
}
function H(t, i) {
  return Array.isArray(t) ? t.map((t2) => 0 === t2 ? t2 : t2 + i) : t + i;
}
function U(t, i, n, s, e2, r2) {
  let h3, l2, a2, o2;
  if (Array.isArray(r2))
    if (2 === r2.length) {
      const t2 = Math.max(0, r2[0]), i2 = Math.max(0, r2[1]);
      h3 = t2, l2 = t2, a2 = i2, o2 = i2;
    } else {
      if (4 !== r2.length)
        throw new Error("Wrong border radius - it should be like css border radius");
      h3 = Math.max(0, r2[0]), l2 = Math.max(0, r2[1]), a2 = Math.max(0, r2[2]), o2 = Math.max(0, r2[3]);
    }
  else {
    const t2 = Math.max(0, r2);
    h3 = t2, l2 = t2, a2 = t2, o2 = t2;
  }
  t.beginPath(), t.moveTo(i + h3, n), t.lineTo(i + s - l2, n), 0 !== l2 && t.arcTo(i + s, n, i + s, n + l2, l2), t.lineTo(i + s, n + e2 - a2), 0 !== a2 && t.arcTo(i + s, n + e2, i + s - a2, n + e2, a2), t.lineTo(i + o2, n + e2), 0 !== o2 && t.arcTo(i, n + e2, i, n + e2 - o2, o2), t.lineTo(i, n + h3), 0 !== h3 && t.arcTo(i, n, i + h3, n, h3);
}
function q(t, i, n, s, e2, r2, h3 = 0, l2 = 0, a2 = "") {
  if (t.save(), !h3 || !a2 || a2 === r2)
    return U(t, i, n, s, e2, l2), t.fillStyle = r2, t.fill(), void t.restore();
  const o2 = h3 / 2;
  if ("transparent" !== r2) {
    U(t, i + h3, n + h3, s - 2 * h3, e2 - 2 * h3, H(l2, -h3)), t.fillStyle = r2, t.fill();
  }
  if ("transparent" !== a2) {
    U(t, i + o2, n + o2, s - h3, e2 - h3, H(l2, -o2)), t.lineWidth = h3, t.strokeStyle = a2, t.closePath(), t.stroke();
  }
  t.restore();
}
function Y(t, i, n, s, e2, r2, h3) {
  t.save(), t.globalCompositeOperation = "copy";
  const l2 = t.createLinearGradient(0, 0, 0, e2);
  l2.addColorStop(0, r2), l2.addColorStop(1, h3), t.fillStyle = l2, t.fillRect(i, n, s, e2), t.restore();
}
class X {
  constructor(t, i) {
    this.tt(t, i);
  }
  tt(t, i) {
    this.zt = t, this.Kt = i;
  }
  It(t, i) {
    return this.zt.Ct ? t.T + t.I + t.A : 0;
  }
  X(t, i, n, s) {
    if (!this.zt.Ct || 0 === this.zt.Gt.length)
      return;
    const e2 = this.zt.D, r2 = this.Kt.t, h3 = t.useBitmapCoordinateSpace((t2) => {
      const h4 = t2.context;
      h4.font = i.P;
      const l2 = this.Jt(t2, i, n, s), a2 = l2.Qt, o2 = (t3, i2) => {
        l2.ti ? q(h4, a2.ii, a2.ni, a2.si, a2.ei, t3, a2.ri, [a2.lt, 0, 0, a2.lt], i2) : q(h4, a2.hi, a2.ni, a2.si, a2.ei, t3, a2.ri, [0, a2.lt, a2.lt, 0], i2);
      };
      return o2(r2, "transparent"), this.zt.li && (h4.fillStyle = e2, h4.fillRect(a2.hi, a2.ai, a2.oi - a2.hi, a2._i)), o2("transparent", r2), this.zt.ui && (h4.fillStyle = i.B, h4.fillRect(l2.ti ? a2.ci - a2.ri : 0, a2.ni, a2.ri, a2.di - a2.ni)), l2;
    });
    t.useMediaCoordinateSpace(({ context: t2 }) => {
      const n2 = h3.fi;
      t2.font = i.P, t2.textAlign = h3.ti ? "right" : "left", t2.textBaseline = "middle", t2.fillStyle = e2, t2.fillText(this.zt.Gt, n2.pi, (n2.ni + n2.di) / 2 + n2.vi);
    });
  }
  Jt(t, i, n, s) {
    var e2;
    const { context: r2, bitmapSize: h3, mediaSize: l2, horizontalPixelRatio: a2, verticalPixelRatio: o2 } = t, _2 = this.zt.li || !this.zt.mi ? i.C : 0, u2 = this.zt.bi ? i.k : 0, c2 = i.I + this.Kt.gi, d2 = i.A + this.Kt.wi, f2 = i.O, p2 = i.L, v2 = this.zt.Gt, m2 = i.T, b2 = n.Mi(r2, v2), g2 = Math.ceil(n.Si(r2, v2)), w2 = m2 + c2 + d2, M2 = i.k + f2 + p2 + g2 + _2, S2 = Math.max(1, Math.floor(o2));
    let x2 = Math.round(w2 * o2);
    x2 % 2 != S2 % 2 && (x2 += 1);
    const y2 = u2 > 0 ? Math.max(1, Math.floor(u2 * a2)) : 0, k2 = Math.round(M2 * a2), C2 = Math.round(_2 * a2), T2 = null !== (e2 = this.Kt.xi) && void 0 !== e2 ? e2 : this.Kt.yi, P2 = Math.round(T2 * o2) - Math.floor(0.5 * o2), R2 = Math.floor(P2 + S2 / 2 - x2 / 2), D2 = R2 + x2, B2 = "right" === s, A2 = B2 ? l2.width - u2 : u2, O2 = B2 ? h3.width - y2 : y2;
    let L2, I2, E2;
    return B2 ? (L2 = O2 - k2, I2 = O2 - C2, E2 = A2 - _2 - f2 - u2) : (L2 = O2 + k2, I2 = O2 + C2, E2 = A2 + _2 + f2), { ti: B2, Qt: { ni: R2, ai: P2, di: D2, si: k2, ei: x2, lt: 2 * a2, ri: y2, ii: L2, hi: O2, oi: I2, _i: S2, ci: h3.width }, fi: { ni: R2 / o2, di: D2 / o2, pi: E2, vi: b2 } };
  }
}
class Z {
  constructor(t) {
    this.ki = { yi: 0, t: "#000", wi: 0, gi: 0 }, this.Ci = { Gt: "", Ct: false, li: true, mi: false, Ot: "", D: "#FFF", ui: false, bi: false }, this.Ti = { Gt: "", Ct: false, li: false, mi: true, Ot: "", D: "#FFF", ui: true, bi: true }, this.vt = true, this.Pi = new (t || X)(this.Ci, this.ki), this.Ri = new (t || X)(this.Ti, this.ki);
  }
  Gt() {
    return this.Di(), this.Ci.Gt;
  }
  yi() {
    return this.Di(), this.ki.yi;
  }
  gt() {
    this.vt = true;
  }
  It(t, i = false) {
    return Math.max(this.Pi.It(t, i), this.Ri.It(t, i));
  }
  Bi() {
    return this.ki.xi || 0;
  }
  Ai(t) {
    this.ki.xi = t;
  }
  Oi() {
    return this.Di(), this.Ci.Ct || this.Ti.Ct;
  }
  Li() {
    return this.Di(), this.Ci.Ct;
  }
  Mt(t) {
    return this.Di(), this.Ci.li = this.Ci.li && t.F().ticksVisible, this.Ti.li = this.Ti.li && t.F().ticksVisible, this.Pi.tt(this.Ci, this.ki), this.Ri.tt(this.Ti, this.ki), this.Pi;
  }
  Ii() {
    return this.Di(), this.Pi.tt(this.Ci, this.ki), this.Ri.tt(this.Ti, this.ki), this.Ri;
  }
  Di() {
    this.vt && (this.Ci.li = true, this.Ti.li = false, this.Ei(this.Ci, this.Ti, this.ki));
  }
}
class K extends Z {
  constructor(t, i, n) {
    super(), this.$t = t, this.zi = i, this.Vi = n;
  }
  Ei(t, i, n) {
    t.Ct = false;
    const s = this.$t.F().horzLine;
    if (!s.labelVisible)
      return;
    const e2 = this.zi.Tt();
    if (!this.$t.Ct() || this.zi.Ni() || null === e2)
      return;
    const r2 = w(s.labelBackgroundColor);
    n.t = r2.t, t.D = r2.i;
    const h3 = 2 / 12 * this.zi.T();
    n.gi = h3, n.wi = h3;
    const l2 = this.Vi(this.zi);
    n.yi = l2.yi, t.Gt = this.zi.Fi(l2.ut, e2), t.Ct = true;
  }
}
const G = /[1-9]/g;
class J {
  constructor() {
    this.zt = null;
  }
  tt(t) {
    this.zt = t;
  }
  X(t, i) {
    if (null === this.zt || false === this.zt.Ct || 0 === this.zt.Gt.length)
      return;
    const n = t.useMediaCoordinateSpace(({ context: t2 }) => (t2.font = i.P, Math.round(i.Wi.Si(t2, _(this.zt).Gt, G))));
    if (n <= 0)
      return;
    const s = i.ji, e2 = n + 2 * s, r2 = e2 / 2, h3 = this.zt.$i;
    let l2 = this.zt.yi, a2 = Math.floor(l2 - r2) + 0.5;
    a2 < 0 ? (l2 += Math.abs(0 - a2), a2 = Math.floor(l2 - r2) + 0.5) : a2 + e2 > h3 && (l2 -= Math.abs(h3 - (a2 + e2)), a2 = Math.floor(l2 - r2) + 0.5);
    const o2 = a2 + e2, u2 = Math.ceil(0 + i.k + i.C + i.I + i.T + i.A);
    t.useBitmapCoordinateSpace(({ context: t2, horizontalPixelRatio: n2, verticalPixelRatio: s2 }) => {
      const e3 = _(this.zt);
      t2.fillStyle = e3.t;
      const r3 = Math.round(a2 * n2), h4 = Math.round(0 * s2), l3 = Math.round(o2 * n2), c2 = Math.round(u2 * s2), d2 = Math.round(2 * n2);
      if (t2.beginPath(), t2.moveTo(r3, h4), t2.lineTo(r3, c2 - d2), t2.arcTo(r3, c2, r3 + d2, c2, d2), t2.lineTo(l3 - d2, c2), t2.arcTo(l3, c2, l3, c2 - d2, d2), t2.lineTo(l3, h4), t2.fill(), e3.li) {
        const r4 = Math.round(e3.yi * n2), l4 = h4, a3 = Math.round((l4 + i.C) * s2);
        t2.fillStyle = e3.D;
        const o3 = Math.max(1, Math.floor(n2)), _2 = Math.floor(0.5 * n2);
        t2.fillRect(r4 - _2, l4, o3, a3 - l4);
      }
    }), t.useMediaCoordinateSpace(({ context: t2 }) => {
      const n2 = _(this.zt), e3 = 0 + i.k + i.C + i.I + i.T / 2;
      t2.font = i.P, t2.textAlign = "left", t2.textBaseline = "middle", t2.fillStyle = n2.D;
      const r3 = i.Wi.Mi(t2, "Apr0");
      t2.translate(a2 + s, e3 + r3), t2.fillText(n2.Gt, 0, 0);
    });
  }
}
class Q {
  constructor(t, i, n) {
    this.vt = true, this.jt = new J(), this.Wt = { Ct: false, t: "#4c525e", D: "white", Gt: "", $i: 0, yi: NaN, li: true }, this.bt = t, this.Hi = i, this.Vi = n;
  }
  gt() {
    this.vt = true;
  }
  Mt() {
    return this.vt && (this.St(), this.vt = false), this.jt.tt(this.Wt), this.jt;
  }
  St() {
    const t = this.Wt;
    t.Ct = false;
    const i = this.bt.F().vertLine;
    if (!i.labelVisible)
      return;
    const n = this.Hi.yt();
    if (n.Ni())
      return;
    t.$i = n.$i();
    const s = this.Vi();
    if (null === s)
      return;
    t.yi = s.yi;
    const e2 = n.Ui(this.bt.xt());
    t.Gt = n.qi(_(e2)), t.Ct = true;
    const r2 = w(i.labelBackgroundColor);
    t.t = r2.t, t.D = r2.i, t.li = n.F().ticksVisible;
  }
}
class tt {
  constructor() {
    this.Yi = null, this.Xi = 0;
  }
  Zi() {
    return this.Xi;
  }
  Ki(t) {
    this.Xi = t;
  }
  Bt() {
    return this.Yi;
  }
  Gi(t) {
    this.Yi = t;
  }
  Ji(t) {
    return [];
  }
  Qi() {
    return [];
  }
  Ct() {
    return true;
  }
}
var it;
!function(t) {
  t[t.Normal = 0] = "Normal", t[t.Magnet = 1] = "Magnet";
}(it || (it = {}));
class nt extends tt {
  constructor(t, i) {
    super(), this.tn = null, this.nn = NaN, this.sn = 0, this.en = true, this.rn = /* @__PURE__ */ new Map(), this.hn = false, this.ln = NaN, this.an = NaN, this.on = NaN, this._n = NaN, this.Hi = t, this.un = i, this.cn = new V(t, this);
    this.dn = ((t2, i2) => (n2) => {
      const s = i2(), e2 = t2();
      if (n2 === _(this.tn).fn())
        return { ut: e2, yi: s };
      {
        const t3 = _(n2.Tt());
        return { ut: n2.pn(s, t3), yi: s };
      }
    })(() => this.nn, () => this.an);
    const n = ((t2, i2) => () => {
      const n2 = this.Hi.yt().vn(t2()), s = i2();
      return n2 && Number.isFinite(s) ? { _t: n2, yi: s } : null;
    })(() => this.sn, () => this.Xt());
    this.mn = new Q(this, t, n), this.bn = new W(this);
  }
  F() {
    return this.un;
  }
  gn(t, i) {
    this.on = t, this._n = i;
  }
  wn() {
    this.on = NaN, this._n = NaN;
  }
  Mn() {
    return this.on;
  }
  Sn() {
    return this._n;
  }
  xn(t, i, n) {
    this.hn || (this.hn = true), this.en = true, this.yn(t, i, n);
  }
  xt() {
    return this.sn;
  }
  Xt() {
    return this.ln;
  }
  Zt() {
    return this.an;
  }
  Ct() {
    return this.en;
  }
  kn() {
    this.en = false, this.Cn(), this.nn = NaN, this.ln = NaN, this.an = NaN, this.tn = null, this.wn();
  }
  Tn(t) {
    return null !== this.tn ? [this.bn, this.cn] : [];
  }
  qt(t) {
    return t === this.tn && this.un.horzLine.visible;
  }
  Yt() {
    return this.un.vertLine.visible;
  }
  Pn(t, i) {
    this.en && this.tn === t || this.rn.clear();
    const n = [];
    return this.tn === t && n.push(this.Rn(this.rn, i, this.dn)), n;
  }
  Qi() {
    return this.en ? [this.mn] : [];
  }
  Ht() {
    return this.tn;
  }
  Dn() {
    this.bn.gt(), this.rn.forEach((t) => t.gt()), this.mn.gt(), this.cn.gt();
  }
  Bn(t) {
    return t && !t.fn().Ni() ? t.fn() : null;
  }
  yn(t, i, n) {
    this.An(t, i, n) && this.Dn();
  }
  An(t, i, n) {
    const s = this.ln, e2 = this.an, r2 = this.nn, h3 = this.sn, l2 = this.tn, a2 = this.Bn(n);
    this.sn = t, this.ln = isNaN(t) ? NaN : this.Hi.yt().Et(t), this.tn = n;
    const o2 = null !== a2 ? a2.Tt() : null;
    return null !== a2 && null !== o2 ? (this.nn = i, this.an = a2.Dt(i, o2)) : (this.nn = NaN, this.an = NaN), s !== this.ln || e2 !== this.an || h3 !== this.sn || r2 !== this.nn || l2 !== this.tn;
  }
  Cn() {
    const t = this.Hi.wt().map((t2) => t2.Ln().On()).filter(P), i = 0 === t.length ? null : Math.max(...t);
    this.sn = null !== i ? i : NaN;
  }
  Rn(t, i, n) {
    let s = t.get(i);
    return void 0 === s && (s = new K(this, i, n), t.set(i, s)), s;
  }
}
function st(t) {
  return "left" === t || "right" === t;
}
class et {
  constructor(t) {
    this.In = /* @__PURE__ */ new Map(), this.En = [], this.zn = t;
  }
  Vn(t, i) {
    const n = function(t2, i2) {
      return void 0 === t2 ? i2 : { Nn: Math.max(t2.Nn, i2.Nn), Fn: t2.Fn || i2.Fn };
    }(this.In.get(t), i);
    this.In.set(t, n);
  }
  Wn() {
    return this.zn;
  }
  jn(t) {
    const i = this.In.get(t);
    return void 0 === i ? { Nn: this.zn } : { Nn: Math.max(this.zn, i.Nn), Fn: i.Fn };
  }
  $n() {
    this.Hn(), this.En = [{ Un: 0 }];
  }
  qn(t) {
    this.Hn(), this.En = [{ Un: 1, At: t }];
  }
  Yn(t) {
    this.Xn(), this.En.push({ Un: 5, At: t });
  }
  Hn() {
    this.Xn(), this.En.push({ Un: 6 });
  }
  Zn() {
    this.Hn(), this.En = [{ Un: 4 }];
  }
  Kn(t) {
    this.Hn(), this.En.push({ Un: 2, At: t });
  }
  Gn(t) {
    this.Hn(), this.En.push({ Un: 3, At: t });
  }
  Jn() {
    return this.En;
  }
  Qn(t) {
    for (const i of t.En)
      this.ts(i);
    this.zn = Math.max(this.zn, t.zn), t.In.forEach((t2, i) => {
      this.Vn(i, t2);
    });
  }
  static ns() {
    return new et(2);
  }
  static ss() {
    return new et(3);
  }
  ts(t) {
    switch (t.Un) {
      case 0:
        this.$n();
        break;
      case 1:
        this.qn(t.At);
        break;
      case 2:
        this.Kn(t.At);
        break;
      case 3:
        this.Gn(t.At);
        break;
      case 4:
        this.Zn();
        break;
      case 5:
        this.Yn(t.At);
        break;
      case 6:
        this.Xn();
    }
  }
  Xn() {
    const t = this.En.findIndex((t2) => 5 === t2.Un);
    -1 !== t && this.En.splice(t, 1);
  }
}
const rt = ".";
function ht(t, i) {
  if (!x(t))
    return "n/a";
  if (!y(i))
    throw new TypeError("invalid length");
  if (i < 0 || i > 16)
    throw new TypeError("invalid length");
  if (0 === i)
    return t.toString();
  return ("0000000000000000" + t.toString()).slice(-i);
}
class lt {
  constructor(t, i) {
    if (i || (i = 1), x(t) && y(t) || (t = 100), t < 0)
      throw new TypeError("invalid base");
    this.zi = t, this.es = i, this.rs();
  }
  format(t) {
    const i = t < 0 ? "−" : "";
    return t = Math.abs(t), i + this.hs(t);
  }
  rs() {
    if (this.ls = 0, this.zi > 0 && this.es > 0) {
      let t = this.zi;
      for (; t > 1; )
        t /= 10, this.ls++;
    }
  }
  hs(t) {
    const i = this.zi / this.es;
    let n = Math.floor(t), s = "";
    const e2 = void 0 !== this.ls ? this.ls : NaN;
    if (i > 1) {
      let r2 = +(Math.round(t * i) - n * i).toFixed(this.ls);
      r2 >= i && (r2 -= i, n += 1), s = rt + ht(+r2.toFixed(this.ls) * this.es, e2);
    } else
      n = Math.round(n * i) / i, e2 > 0 && (s = rt + ht(0, e2));
    return n.toFixed(0) + s;
  }
}
class at extends lt {
  constructor(t = 100) {
    super(t);
  }
  format(t) {
    return `${super.format(t)}%`;
  }
}
class ot {
  constructor(t) {
    this.os = t;
  }
  format(t) {
    let i = "";
    return t < 0 && (i = "-", t = -t), t < 995 ? i + this._s(t) : t < 999995 ? i + this._s(t / 1e3) + "K" : t < 999999995 ? (t = 1e3 * Math.round(t / 1e3), i + this._s(t / 1e6) + "M") : (t = 1e6 * Math.round(t / 1e6), i + this._s(t / 1e9) + "B");
  }
  _s(t) {
    let i;
    const n = Math.pow(10, this.os);
    return i = (t = Math.round(t * n) / n) >= 1e-15 && t < 1 ? t.toFixed(this.os).replace(/\.?0+$/, "") : String(t), i.replace(/(\.[1-9]*)0+$/, (t2, i2) => i2);
  }
}
function _t(t, i, n, s, e2, r2, h3) {
  if (0 === i.length || s.from >= i.length || s.to <= 0)
    return;
  const l2 = t.context, a2 = i[s.from];
  let o2 = r2(t, a2), _2 = a2;
  if (s.to - s.from < 2) {
    const t2 = e2 / 2;
    l2.beginPath();
    const i2 = { st: a2.st - t2, et: a2.et }, n2 = { st: a2.st + t2, et: a2.et };
    return l2.moveTo(i2.st, i2.et), l2.lineTo(n2.st, n2.et), void h3(l2, o2, i2, n2);
  }
  const u2 = (t2, i2) => {
    h3(l2, o2, _2, i2), l2.beginPath(), o2 = t2, _2 = i2;
  };
  let c2 = _2;
  l2.beginPath(), l2.moveTo(a2.st, a2.et);
  for (let e3 = s.from + 1; e3 < s.to; ++e3) {
    c2 = i[e3];
    const s2 = r2(t, c2);
    switch (n) {
      case 0:
        l2.lineTo(c2.st, c2.et);
        break;
      case 1:
        l2.lineTo(c2.st, i[e3 - 1].et), s2 !== o2 && (u2(s2, c2), l2.lineTo(c2.st, i[e3 - 1].et)), l2.lineTo(c2.st, c2.et);
        break;
      case 2: {
        const [t2, n2] = ft(i, e3 - 1, e3);
        l2.bezierCurveTo(t2.st, t2.et, n2.st, n2.et, c2.st, c2.et);
        break;
      }
    }
    1 !== n && s2 !== o2 && (u2(s2, c2), l2.moveTo(c2.st, c2.et));
  }
  (_2 !== c2 || _2 === c2 && 1 === n) && h3(l2, o2, _2, c2);
}
const ut = 6;
function ct(t, i) {
  return { st: t.st - i.st, et: t.et - i.et };
}
function dt(t, i) {
  return { st: t.st / i, et: t.et / i };
}
function ft(t, i, n) {
  const s = Math.max(0, i - 1), e2 = Math.min(t.length - 1, n + 1);
  var r2, h3;
  return [(r2 = t[i], h3 = dt(ct(t[n], t[s]), ut), { st: r2.st + h3.st, et: r2.et + h3.et }), ct(t[n], dt(ct(t[e2], t[i]), ut))];
}
function pt(t, i, n, s, e2) {
  i.lineTo(e2.st, t), i.lineTo(s.st, t), i.closePath(), i.fillStyle = n, i.fill();
}
class vt extends L {
  constructor() {
    super(...arguments), this.J = null;
  }
  tt(t) {
    this.J = t;
  }
  Z(t) {
    var i;
    if (null === this.J)
      return;
    const { nt: n, it: s, us: e2, rt: r2, Ft: l2, cs: a2 } = this.J, o2 = null !== (i = this.J.ds) && void 0 !== i ? i : this.J.fs ? 0 : t.mediaSize.height;
    if (null === s)
      return;
    const _2 = t.context;
    _2.lineCap = "butt", _2.lineJoin = "round", _2.lineWidth = r2, h(_2, l2), _2.lineWidth = 1, _t(t, n, a2, s, e2, this.ps.bind(this), pt.bind(null, o2));
  }
}
class mt extends vt {
  constructor() {
    super(...arguments), this.vs = null;
  }
  ps(t, i) {
    const { context: n, mediaSize: s } = t, { bs: e2, gs: r2 } = i, h3 = s.height;
    if (null !== this.vs && this.vs.topColor === e2 && this.vs.bottomColor === r2 && this.vs.bottom === h3)
      return this.vs.fillStyle;
    const l2 = n.createLinearGradient(0, 0, 0, h3);
    return l2.addColorStop(0, e2), l2.addColorStop(1, r2), this.vs = { topColor: e2, bottomColor: r2, fillStyle: l2, bottom: h3 }, l2;
  }
}
function bt(t, i) {
  t.strokeStyle = i, t.stroke();
}
class gt extends L {
  constructor() {
    super(...arguments), this.J = null;
  }
  tt(t) {
    this.J = t;
  }
  Z(t) {
    if (null === this.J)
      return;
    const { nt: i, it: n, us: s, cs: e2, rt: r2, Ft: l2 } = this.J;
    if (null === n)
      return;
    const a2 = t.context;
    a2.lineCap = "butt", a2.lineWidth = r2, h(a2, l2), a2.lineJoin = "round", _t(t, i, e2, n, s, this.ws.bind(this), bt);
  }
}
class wt extends gt {
  ws(t, i) {
    return i.ot;
  }
}
function Mt(t, i, n, s = 0, e2 = t.length) {
  let r2 = e2 - s;
  for (; 0 < r2; ) {
    const e3 = r2 >> 1, h3 = s + e3;
    n(t[h3], i) ? (s = h3 + 1, r2 -= e3 + 1) : r2 = e3;
  }
  return s;
}
function St(t, i, n, s = 0, e2 = t.length) {
  let r2 = e2 - s;
  for (; 0 < r2; ) {
    const e3 = r2 >> 1, h3 = s + e3;
    n(i, t[h3]) ? r2 = e3 : (s = h3 + 1, r2 -= e3 + 1);
  }
  return s;
}
function xt(t, i) {
  return t._t < i;
}
function yt(t, i) {
  return t < i._t;
}
function kt(t, i, n) {
  const s = i.Ms(), e2 = i.ci(), r2 = Mt(t, s, xt), h3 = St(t, e2, yt);
  if (!n)
    return { from: r2, to: h3 };
  let l2 = r2, a2 = h3;
  return r2 > 0 && r2 < t.length && t[r2]._t >= s && (l2 = r2 - 1), h3 > 0 && h3 < t.length && t[h3 - 1]._t <= e2 && (a2 = h3 + 1), { from: l2, to: a2 };
}
class Ct {
  constructor(t, i, n) {
    this.Ss = true, this.xs = true, this.ys = true, this.ks = [], this.Cs = null, this.Ts = t, this.Ps = i, this.Rs = n;
  }
  gt(t) {
    this.Ss = true, "data" === t && (this.xs = true), "options" === t && (this.ys = true);
  }
  Mt() {
    return this.Ts.Ct() ? (this.Ds(), null === this.Cs ? null : this.Bs) : null;
  }
  As() {
    this.ks = this.ks.map((t) => Object.assign(Object.assign({}, t), this.Ts.Ls().Os(t._t)));
  }
  Is() {
    this.Cs = null;
  }
  Ds() {
    this.xs && (this.Es(), this.xs = false), this.ys && (this.As(), this.ys = false), this.Ss && (this.zs(), this.Ss = false);
  }
  zs() {
    const t = this.Ts.Bt(), i = this.Ps.yt();
    if (this.Is(), i.Ni() || t.Ni())
      return;
    const n = i.Vs();
    if (null === n)
      return;
    if (0 === this.Ts.Ln().Ns())
      return;
    const s = this.Ts.Tt();
    null !== s && (this.Cs = kt(this.ks, n, this.Rs), this.Fs(t, i, s.At), this.Ws());
  }
}
class Tt extends Ct {
  constructor(t, i) {
    super(t, i, true);
  }
  Fs(t, i, n) {
    i.js(this.ks, R(this.Cs)), t.$s(this.ks, n, R(this.Cs));
  }
  Hs(t, i) {
    return { _t: t, ut: i, st: NaN, et: NaN };
  }
  Es() {
    const t = this.Ts.Ls();
    this.ks = this.Ts.Ln().Us().map((i) => {
      const n = i.At[3];
      return this.qs(i.Ys, n, t);
    });
  }
}
class Pt extends Tt {
  constructor(t, i) {
    super(t, i), this.Bs = new O(), this.Xs = new mt(), this.Zs = new wt(), this.Bs.Y([this.Xs, this.Zs]);
  }
  qs(t, i, n) {
    return Object.assign(Object.assign({}, this.Hs(t, i)), n.Os(t));
  }
  Ws() {
    const t = this.Ts.F();
    this.Xs.tt({ cs: t.lineType, nt: this.ks, Ft: t.lineStyle, rt: t.lineWidth, ds: null, fs: t.invertFilledArea, it: this.Cs, us: this.Ps.yt().Ks() }), this.Zs.tt({ cs: t.lineType, nt: this.ks, Ft: t.lineStyle, rt: t.lineWidth, it: this.Cs, us: this.Ps.yt().Ks() });
  }
}
class Rt extends N {
  constructor() {
    super(...arguments), this.zt = null, this.Gs = 0, this.Js = 0;
  }
  tt(t) {
    this.zt = t;
  }
  Z({ context: t, horizontalPixelRatio: i, verticalPixelRatio: n }) {
    if (null === this.zt || 0 === this.zt.Ln.length || null === this.zt.it)
      return;
    if (this.Gs = this.Qs(i), this.Gs >= 2) {
      Math.max(1, Math.floor(i)) % 2 != this.Gs % 2 && this.Gs--;
    }
    this.Js = this.zt.te ? Math.min(this.Gs, Math.floor(i)) : this.Gs;
    let s = null;
    const e2 = this.Js <= this.Gs && this.zt.Ks >= Math.floor(1.5 * i);
    for (let r2 = this.zt.it.from; r2 < this.zt.it.to; ++r2) {
      const h3 = this.zt.Ln[r2];
      s !== h3.ie && (t.fillStyle = h3.ie, s = h3.ie);
      const l2 = Math.floor(0.5 * this.Js), a2 = Math.round(h3.st * i), o2 = a2 - l2, _2 = this.Js, u2 = o2 + _2 - 1, c2 = Math.min(h3.ne, h3.se), d2 = Math.max(h3.ne, h3.se), f2 = Math.round(c2 * n) - l2, p2 = Math.round(d2 * n) + l2, v2 = Math.max(p2 - f2, this.Js);
      t.fillRect(o2, f2, _2, v2);
      const m2 = Math.ceil(1.5 * this.Gs);
      if (e2) {
        if (this.zt.ee) {
          const i3 = a2 - m2;
          let s3 = Math.max(f2, Math.round(h3.re * n) - l2), e4 = s3 + _2 - 1;
          e4 > f2 + v2 - 1 && (e4 = f2 + v2 - 1, s3 = e4 - _2 + 1), t.fillRect(i3, s3, o2 - i3, e4 - s3 + 1);
        }
        const i2 = a2 + m2;
        let s2 = Math.max(f2, Math.round(h3.he * n) - l2), e3 = s2 + _2 - 1;
        e3 > f2 + v2 - 1 && (e3 = f2 + v2 - 1, s2 = e3 - _2 + 1), t.fillRect(u2 + 1, s2, i2 - u2, e3 - s2 + 1);
      }
    }
  }
  Qs(t) {
    const i = Math.floor(t);
    return Math.max(i, Math.floor(function(t2, i2) {
      return Math.floor(0.3 * t2 * i2);
    }(_(this.zt).Ks, t)));
  }
}
class Dt extends Ct {
  constructor(t, i) {
    super(t, i, false);
  }
  Fs(t, i, n) {
    i.js(this.ks, R(this.Cs)), t.le(this.ks, n, R(this.Cs));
  }
  ae(t, i, n) {
    return { _t: t, oe: i.At[0], _e: i.At[1], ue: i.At[2], ce: i.At[3], st: NaN, re: NaN, ne: NaN, se: NaN, he: NaN };
  }
  Es() {
    const t = this.Ts.Ls();
    this.ks = this.Ts.Ln().Us().map((i) => this.qs(i.Ys, i, t));
  }
}
class Bt extends Dt {
  constructor() {
    super(...arguments), this.Bs = new Rt();
  }
  qs(t, i, n) {
    return Object.assign(Object.assign({}, this.ae(t, i, n)), n.Os(t));
  }
  Ws() {
    const t = this.Ts.F();
    this.Bs.tt({ Ln: this.ks, Ks: this.Ps.yt().Ks(), ee: t.openVisible, te: t.thinBars, it: this.Cs });
  }
}
function At(t, i, n) {
  return Math.min(Math.max(t, i), n);
}
function Ot(t, i, n) {
  return i - t <= n;
}
function Lt(t) {
  return t <= 0 ? NaN : Math.log(t) / Math.log(10);
}
function It(t) {
  const i = Math.ceil(t);
  return i % 2 == 0 ? i - 1 : i;
}
class Et extends vt {
  constructor() {
    super(...arguments), this.vs = null;
  }
  ps(t, i) {
    var n;
    const { context: s, mediaSize: e2 } = t, r2 = this.J, { de: h3, fe: l2, pe: a2, ve: o2 } = i, _2 = null !== (n = r2.ds) && void 0 !== n ? n : e2.height, u2 = e2.height;
    if (null !== this.vs && this.vs.topFillColor1 === h3 && this.vs.topFillColor2 === l2 && this.vs.bottomFillColor1 === a2 && this.vs.bottomFillColor2 === o2 && this.vs.baseLevelCoordinate === _2 && this.vs.bottom === u2)
      return this.vs.fillStyle;
    const c2 = s.createLinearGradient(0, 0, 0, u2), d2 = At(_2 / u2, 0, 1);
    return c2.addColorStop(0, h3), c2.addColorStop(d2, l2), c2.addColorStop(d2, a2), c2.addColorStop(1, o2), this.vs = { topFillColor1: h3, topFillColor2: l2, bottomFillColor1: a2, bottomFillColor2: o2, fillStyle: c2, baseLevelCoordinate: _2, bottom: u2 }, c2;
  }
}
class zt extends gt {
  constructor() {
    super(...arguments), this.me = null;
  }
  ws(t, i) {
    const { context: n, mediaSize: s } = t, e2 = this.J, { be: r2, ge: h3 } = i, { ds: l2 } = e2, a2 = s.height;
    if (null !== this.me && this.me.topLineColor === r2 && this.me.bottomLineColor === h3 && this.me.baseLevelCoordinate === l2 && this.me.bottom === a2)
      return this.me.strokeStyle;
    const o2 = n.createLinearGradient(0, 0, 0, a2), _2 = At(l2 / a2, 0, 1);
    return o2.addColorStop(0, r2), o2.addColorStop(_2, r2), o2.addColorStop(_2, h3), o2.addColorStop(1, h3), this.me = { topLineColor: r2, bottomLineColor: h3, strokeStyle: o2, baseLevelCoordinate: l2, bottom: a2 }, o2;
  }
}
class Vt extends Tt {
  constructor(t, i) {
    super(t, i), this.Bs = new O(), this.we = new Et(), this.Me = new zt(), this.Bs.Y([this.we, this.Me]);
  }
  qs(t, i, n) {
    return Object.assign(Object.assign({}, this.Hs(t, i)), n.Os(t));
  }
  Ws() {
    const t = this.Ts.Tt();
    if (null === t)
      return;
    const i = this.Ts.F(), n = this.Ts.Bt().Dt(i.baseValue.price, t.At), s = this.Ps.yt().Ks();
    this.we.tt({ nt: this.ks, rt: i.lineWidth, Ft: i.lineStyle, cs: i.lineType, ds: n, fs: false, it: this.Cs, us: s }), this.Me.tt({ nt: this.ks, rt: i.lineWidth, Ft: i.lineStyle, cs: i.lineType, ds: n, it: this.Cs, us: s });
  }
}
class Nt extends N {
  constructor() {
    super(...arguments), this.zt = null, this.Gs = 0;
  }
  tt(t) {
    this.zt = t;
  }
  Z(t) {
    if (null === this.zt || 0 === this.zt.Ln.length || null === this.zt.it)
      return;
    const { horizontalPixelRatio: i } = t;
    if (this.Gs = function(t2, i2) {
      if (t2 >= 2.5 && t2 <= 4)
        return Math.floor(3 * i2);
      const n2 = 1 - 0.2 * Math.atan(Math.max(4, t2) - 4) / (0.5 * Math.PI), s2 = Math.floor(t2 * n2 * i2), e2 = Math.floor(t2 * i2), r2 = Math.min(s2, e2);
      return Math.max(Math.floor(i2), r2);
    }(this.zt.Ks, i), this.Gs >= 2) {
      Math.floor(i) % 2 != this.Gs % 2 && this.Gs--;
    }
    const n = this.zt.Ln;
    this.zt.Se && this.xe(t, n, this.zt.it), this.zt.ui && this.ye(t, n, this.zt.it);
    const s = this.ke(i);
    (!this.zt.ui || this.Gs > 2 * s) && this.Ce(t, n, this.zt.it);
  }
  xe(t, i, n) {
    if (null === this.zt)
      return;
    const { context: s, horizontalPixelRatio: e2, verticalPixelRatio: r2 } = t;
    let h3 = "", l2 = Math.min(Math.floor(e2), Math.floor(this.zt.Ks * e2));
    l2 = Math.max(Math.floor(e2), Math.min(l2, this.Gs));
    const a2 = Math.floor(0.5 * l2);
    let o2 = null;
    for (let t2 = n.from; t2 < n.to; t2++) {
      const n2 = i[t2];
      n2.Te !== h3 && (s.fillStyle = n2.Te, h3 = n2.Te);
      const _2 = Math.round(Math.min(n2.re, n2.he) * r2), u2 = Math.round(Math.max(n2.re, n2.he) * r2), c2 = Math.round(n2.ne * r2), d2 = Math.round(n2.se * r2);
      let f2 = Math.round(e2 * n2.st) - a2;
      const p2 = f2 + l2 - 1;
      null !== o2 && (f2 = Math.max(o2 + 1, f2), f2 = Math.min(f2, p2));
      const v2 = p2 - f2 + 1;
      s.fillRect(f2, c2, v2, _2 - c2), s.fillRect(f2, u2 + 1, v2, d2 - u2), o2 = p2;
    }
  }
  ke(t) {
    let i = Math.floor(1 * t);
    this.Gs <= 2 * i && (i = Math.floor(0.5 * (this.Gs - 1)));
    const n = Math.max(Math.floor(t), i);
    return this.Gs <= 2 * n ? Math.max(Math.floor(t), Math.floor(1 * t)) : n;
  }
  ye(t, i, n) {
    if (null === this.zt)
      return;
    const { context: s, horizontalPixelRatio: e2, verticalPixelRatio: r2 } = t;
    let h3 = "";
    const l2 = this.ke(e2);
    let a2 = null;
    for (let t2 = n.from; t2 < n.to; t2++) {
      const n2 = i[t2];
      n2.Pe !== h3 && (s.fillStyle = n2.Pe, h3 = n2.Pe);
      let o2 = Math.round(n2.st * e2) - Math.floor(0.5 * this.Gs);
      const _2 = o2 + this.Gs - 1, u2 = Math.round(Math.min(n2.re, n2.he) * r2), c2 = Math.round(Math.max(n2.re, n2.he) * r2);
      if (null !== a2 && (o2 = Math.max(a2 + 1, o2), o2 = Math.min(o2, _2)), this.zt.Ks * e2 > 2 * l2)
        j(s, o2, u2, _2 - o2 + 1, c2 - u2 + 1, l2);
      else {
        const t3 = _2 - o2 + 1;
        s.fillRect(o2, u2, t3, c2 - u2 + 1);
      }
      a2 = _2;
    }
  }
  Ce(t, i, n) {
    if (null === this.zt)
      return;
    const { context: s, horizontalPixelRatio: e2, verticalPixelRatio: r2 } = t;
    let h3 = "";
    const l2 = this.ke(e2);
    for (let t2 = n.from; t2 < n.to; t2++) {
      const n2 = i[t2];
      let a2 = Math.round(Math.min(n2.re, n2.he) * r2), o2 = Math.round(Math.max(n2.re, n2.he) * r2), _2 = Math.round(n2.st * e2) - Math.floor(0.5 * this.Gs), u2 = _2 + this.Gs - 1;
      if (n2.ie !== h3) {
        const t3 = n2.ie;
        s.fillStyle = t3, h3 = t3;
      }
      this.zt.ui && (_2 += l2, a2 += l2, u2 -= l2, o2 -= l2), a2 > o2 || s.fillRect(_2, a2, u2 - _2 + 1, o2 - a2 + 1);
    }
  }
}
class Ft extends Dt {
  constructor() {
    super(...arguments), this.Bs = new Nt();
  }
  qs(t, i, n) {
    return Object.assign(Object.assign({}, this.ae(t, i, n)), n.Os(t));
  }
  Ws() {
    const t = this.Ts.F();
    this.Bs.tt({ Ln: this.ks, Ks: this.Ps.yt().Ks(), Se: t.wickVisible, ui: t.borderVisible, it: this.Cs });
  }
}
class Wt extends N {
  constructor() {
    super(...arguments), this.zt = null, this.Re = [];
  }
  tt(t) {
    this.zt = t, this.Re = [];
  }
  Z({ context: t, horizontalPixelRatio: i, verticalPixelRatio: n }) {
    if (null === this.zt || 0 === this.zt.nt.length || null === this.zt.it)
      return;
    this.Re.length || this.De(i);
    const s = Math.max(1, Math.floor(n)), e2 = Math.round(this.zt.Be * n) - Math.floor(s / 2), r2 = e2 + s;
    for (let i2 = this.zt.it.from; i2 < this.zt.it.to; i2++) {
      const h3 = this.zt.nt[i2], l2 = this.Re[i2 - this.zt.it.from], a2 = Math.round(h3.et * n);
      let o2, _2;
      t.fillStyle = h3.ie, a2 <= e2 ? (o2 = a2, _2 = r2) : (o2 = e2, _2 = a2 - Math.floor(s / 2) + s), t.fillRect(l2.Ms, o2, l2.ci - l2.Ms + 1, _2 - o2);
    }
  }
  De(t) {
    if (null === this.zt || 0 === this.zt.nt.length || null === this.zt.it)
      return void (this.Re = []);
    const i = Math.ceil(this.zt.Ks * t) <= 1 ? 0 : Math.max(1, Math.floor(t)), n = Math.round(this.zt.Ks * t) - i;
    this.Re = new Array(this.zt.it.to - this.zt.it.from);
    for (let i2 = this.zt.it.from; i2 < this.zt.it.to; i2++) {
      const s2 = this.zt.nt[i2], e2 = Math.round(s2.st * t);
      let r2, h3;
      if (n % 2) {
        const t2 = (n - 1) / 2;
        r2 = e2 - t2, h3 = e2 + t2;
      } else {
        const t2 = n / 2;
        r2 = e2 - t2, h3 = e2 + t2 - 1;
      }
      this.Re[i2 - this.zt.it.from] = { Ms: r2, ci: h3, Ae: e2, Oe: s2.st * t, _t: s2._t };
    }
    for (let t2 = this.zt.it.from + 1; t2 < this.zt.it.to; t2++) {
      const n2 = this.Re[t2 - this.zt.it.from], s2 = this.Re[t2 - this.zt.it.from - 1];
      n2._t === s2._t + 1 && (n2.Ms - s2.ci !== i + 1 && (s2.Ae > s2.Oe ? s2.ci = n2.Ms - i - 1 : n2.Ms = s2.ci + i + 1));
    }
    let s = Math.ceil(this.zt.Ks * t);
    for (let t2 = this.zt.it.from; t2 < this.zt.it.to; t2++) {
      const i2 = this.Re[t2 - this.zt.it.from];
      i2.ci < i2.Ms && (i2.ci = i2.Ms);
      const n2 = i2.ci - i2.Ms + 1;
      s = Math.min(n2, s);
    }
    if (i > 0 && s < 4)
      for (let t2 = this.zt.it.from; t2 < this.zt.it.to; t2++) {
        const i2 = this.Re[t2 - this.zt.it.from];
        i2.ci - i2.Ms + 1 > s && (i2.Ae > i2.Oe ? i2.ci -= 1 : i2.Ms += 1);
      }
  }
}
class jt extends Tt {
  constructor() {
    super(...arguments), this.Bs = new Wt();
  }
  qs(t, i, n) {
    return Object.assign(Object.assign({}, this.Hs(t, i)), n.Os(t));
  }
  Ws() {
    const t = { nt: this.ks, Ks: this.Ps.yt().Ks(), it: this.Cs, Be: this.Ts.Bt().Dt(this.Ts.F().base, _(this.Ts.Tt()).At) };
    this.Bs.tt(t);
  }
}
class $t extends Tt {
  constructor() {
    super(...arguments), this.Bs = new wt();
  }
  qs(t, i, n) {
    return Object.assign(Object.assign({}, this.Hs(t, i)), n.Os(t));
  }
  Ws() {
    const t = this.Ts.F(), i = { nt: this.ks, Ft: t.lineStyle, cs: t.lineType, rt: t.lineWidth, it: this.Cs, us: this.Ps.yt().Ks() };
    this.Bs.tt(i);
  }
}
const Ht = /[2-9]/g;
class Ut {
  constructor(t = 50) {
    this.Le = 0, this.Ie = 1, this.Ee = 1, this.ze = {}, this.Ve = /* @__PURE__ */ new Map(), this.Ne = t;
  }
  Fe() {
    this.Le = 0, this.Ve.clear(), this.Ie = 1, this.Ee = 1, this.ze = {};
  }
  Si(t, i, n) {
    return this.We(t, i, n).width;
  }
  Mi(t, i, n) {
    const s = this.We(t, i, n);
    return ((s.actualBoundingBoxAscent || 0) - (s.actualBoundingBoxDescent || 0)) / 2;
  }
  We(t, i, n) {
    const s = n || Ht, e2 = String(i).replace(s, "0");
    if (this.Ve.has(e2))
      return o(this.Ve.get(e2)).je;
    if (this.Le === this.Ne) {
      const t2 = this.ze[this.Ee];
      delete this.ze[this.Ee], this.Ve.delete(t2), this.Ee++, this.Le--;
    }
    t.save(), t.textBaseline = "middle";
    const r2 = t.measureText(e2);
    return t.restore(), 0 === r2.width && i.length || (this.Ve.set(e2, { je: r2, $e: this.Ie }), this.ze[this.Ie] = e2, this.Le++, this.Ie++), r2;
  }
}
class qt {
  constructor(t) {
    this.He = null, this.S = null, this.Ue = "right", this.qe = t;
  }
  Ye(t, i, n) {
    this.He = t, this.S = i, this.Ue = n;
  }
  X(t) {
    null !== this.S && null !== this.He && this.He.X(t, this.S, this.qe, this.Ue);
  }
}
class Yt {
  constructor(t, i, n) {
    this.Xe = t, this.qe = new Ut(50), this.Ze = i, this.N = n, this.W = -1, this.jt = new qt(this.qe);
  }
  Mt() {
    const t = this.N.Ke(this.Ze);
    if (null === t)
      return null;
    const i = t.Ge(this.Ze) ? t.Je() : this.Ze.Bt();
    if (null === i)
      return null;
    const n = t.Qe(i);
    if ("overlay" === n)
      return null;
    const s = this.N.tr();
    return s.T !== this.W && (this.W = s.T, this.qe.Fe()), this.jt.Ye(this.Xe.Ii(), s, n), this.jt;
  }
}
class Xt extends N {
  constructor() {
    super(...arguments), this.zt = null;
  }
  tt(t) {
    this.zt = t;
  }
  ir(t, i) {
    var n;
    if (!(null === (n = this.zt) || void 0 === n ? void 0 : n.Ct))
      return null;
    const { et: s, rt: e2, nr: r2 } = this.zt;
    return i >= s - e2 - 7 && i <= s + e2 + 7 ? { sr: this.zt, nr: r2 } : null;
  }
  Z({ context: t, bitmapSize: i, horizontalPixelRatio: n, verticalPixelRatio: s }) {
    if (null === this.zt)
      return;
    if (false === this.zt.Ct)
      return;
    const e2 = Math.round(this.zt.et * s);
    e2 < 0 || e2 > i.height || (t.lineCap = "butt", t.strokeStyle = this.zt.D, t.lineWidth = Math.floor(this.zt.rt * n), h(t, this.zt.Ft), l(t, e2, 0, i.width));
  }
}
class Zt {
  constructor(t) {
    this.er = { et: 0, D: "rgba(0, 0, 0, 0)", rt: 1, Ft: 0, Ct: false }, this.rr = new Xt(), this.vt = true, this.Ts = t, this.Ps = t.Ut(), this.rr.tt(this.er);
  }
  gt() {
    this.vt = true;
  }
  Mt() {
    return this.Ts.Ct() ? (this.vt && (this.hr(), this.vt = false), this.rr) : null;
  }
}
class Kt extends Zt {
  constructor(t) {
    super(t);
  }
  hr() {
    this.er.Ct = false;
    const t = this.Ts.Bt(), i = t.lr().lr;
    if (2 !== i && 3 !== i)
      return;
    const n = this.Ts.F();
    if (!n.baseLineVisible || !this.Ts.Ct())
      return;
    const s = this.Ts.Tt();
    null !== s && (this.er.Ct = true, this.er.et = t.Dt(s.At, s.At), this.er.D = n.baseLineColor, this.er.rt = n.baseLineWidth, this.er.Ft = n.baseLineStyle);
  }
}
class Gt extends N {
  constructor() {
    super(...arguments), this.zt = null;
  }
  tt(t) {
    this.zt = t;
  }
  ar() {
    return this.zt;
  }
  Z({ context: t, horizontalPixelRatio: i, verticalPixelRatio: n }) {
    const s = this.zt;
    if (null === s)
      return;
    const e2 = Math.max(1, Math.floor(i)), r2 = e2 % 2 / 2, h3 = Math.round(s.Oe.x * i) + r2, l2 = s.Oe.y * n;
    t.fillStyle = s._r, t.beginPath();
    const a2 = Math.max(2, 1.5 * s.ur) * i;
    t.arc(h3, l2, a2, 0, 2 * Math.PI, false), t.fill(), t.fillStyle = s.cr, t.beginPath(), t.arc(h3, l2, s.lt * i, 0, 2 * Math.PI, false), t.fill(), t.lineWidth = e2, t.strokeStyle = s.dr, t.beginPath(), t.arc(h3, l2, s.lt * i + e2 / 2, 0, 2 * Math.PI, false), t.stroke();
  }
}
const Jt = [{ pr: 0, vr: 0.25, mr: 4, br: 10, gr: 0.25, wr: 0, Mr: 0.4, Sr: 0.8 }, { pr: 0.25, vr: 0.525, mr: 10, br: 14, gr: 0, wr: 0, Mr: 0.8, Sr: 0 }, { pr: 0.525, vr: 1, mr: 14, br: 14, gr: 0, wr: 0, Mr: 0, Sr: 0 }];
function Qt(t, i, n, s) {
  return function(t2, i2) {
    if ("transparent" === t2)
      return t2;
    const n2 = g(t2), s2 = n2[3];
    return `rgba(${n2[0]}, ${n2[1]}, ${n2[2]}, ${i2 * s2})`;
  }(t, n + (s - n) * i);
}
function ti(t, i) {
  const n = t % 2600 / 2600;
  let s;
  for (const t2 of Jt)
    if (n >= t2.pr && n <= t2.vr) {
      s = t2;
      break;
    }
  a(void 0 !== s, "Last price animation internal logic error");
  const e2 = (n - s.pr) / (s.vr - s.pr);
  return { cr: Qt(i, e2, s.gr, s.wr), dr: Qt(i, e2, s.Mr, s.Sr), lt: (r2 = e2, h3 = s.mr, l2 = s.br, h3 + (l2 - h3) * r2) };
  var r2, h3, l2;
}
class ii {
  constructor(t) {
    this.jt = new Gt(), this.vt = true, this.yr = true, this.kr = performance.now(), this.Cr = this.kr - 1, this.Tr = t;
  }
  Pr() {
    this.Cr = this.kr - 1, this.gt();
  }
  Rr() {
    if (this.gt(), 2 === this.Tr.F().lastPriceAnimation) {
      const t = performance.now(), i = this.Cr - t;
      if (i > 0)
        return void (i < 650 && (this.Cr += 2600));
      this.kr = t, this.Cr = t + 2600;
    }
  }
  gt() {
    this.vt = true;
  }
  Dr() {
    this.yr = true;
  }
  Ct() {
    return 0 !== this.Tr.F().lastPriceAnimation;
  }
  Br() {
    switch (this.Tr.F().lastPriceAnimation) {
      case 0:
        return false;
      case 1:
        return true;
      case 2:
        return performance.now() <= this.Cr;
    }
  }
  Mt() {
    return this.vt ? (this.St(), this.vt = false, this.yr = false) : this.yr && (this.Ar(), this.yr = false), this.jt;
  }
  St() {
    this.jt.tt(null);
    const t = this.Tr.Ut().yt(), i = t.Vs(), n = this.Tr.Tt();
    if (null === i || null === n)
      return;
    const s = this.Tr.Or(true);
    if (s.Lr || !i.Ir(s.Ys))
      return;
    const e2 = { x: t.Et(s.Ys), y: this.Tr.Bt().Dt(s.ut, n.At) }, r2 = s.D, h3 = this.Tr.F().lineWidth, l2 = ti(this.Er(), r2);
    this.jt.tt({ _r: r2, ur: h3, cr: l2.cr, dr: l2.dr, lt: l2.lt, Oe: e2 });
  }
  Ar() {
    const t = this.jt.ar();
    if (null !== t) {
      const i = ti(this.Er(), t._r);
      t.cr = i.cr, t.dr = i.dr, t.lt = i.lt;
    }
  }
  Er() {
    return this.Br() ? performance.now() - this.kr : 2599;
  }
}
function ni(t, i) {
  return It(Math.min(Math.max(t, 12), 30) * i);
}
function si(t, i) {
  switch (t) {
    case "arrowDown":
    case "arrowUp":
      return ni(i, 1);
    case "circle":
      return ni(i, 0.8);
    case "square":
      return ni(i, 0.7);
  }
}
function ei(t) {
  return function(t2) {
    const i = Math.ceil(t2);
    return i % 2 != 0 ? i - 1 : i;
  }(ni(t, 1));
}
function ri(t) {
  return Math.max(ni(t, 0.1), 3);
}
function hi(t, i, n, s, e2) {
  const r2 = si("square", n), h3 = (r2 - 1) / 2, l2 = t - h3, a2 = i - h3;
  return s >= l2 && s <= l2 + r2 && e2 >= a2 && e2 <= a2 + r2;
}
function li(t, i, n, s, e2) {
  const r2 = (si("arrowUp", e2) - 1) / 2, h3 = (It(e2 / 2) - 1) / 2;
  i.beginPath(), t ? (i.moveTo(n - r2, s), i.lineTo(n, s - r2), i.lineTo(n + r2, s), i.lineTo(n + h3, s), i.lineTo(n + h3, s + r2), i.lineTo(n - h3, s + r2), i.lineTo(n - h3, s)) : (i.moveTo(n - r2, s), i.lineTo(n, s + r2), i.lineTo(n + r2, s), i.lineTo(n + h3, s), i.lineTo(n + h3, s - r2), i.lineTo(n - h3, s - r2), i.lineTo(n - h3, s)), i.fill();
}
function ai(t, i, n, s, e2, r2) {
  return hi(i, n, s, e2, r2);
}
class oi extends L {
  constructor() {
    super(...arguments), this.zt = null, this.qe = new Ut(), this.W = -1, this.j = "", this.zr = "";
  }
  tt(t) {
    this.zt = t;
  }
  Ye(t, i) {
    this.W === t && this.j === i || (this.W = t, this.j = i, this.zr = B(t, i), this.qe.Fe());
  }
  ir(t, i) {
    if (null === this.zt || null === this.zt.it)
      return null;
    for (let n = this.zt.it.from; n < this.zt.it.to; n++) {
      const s = this.zt.nt[n];
      if (ui(s, t, i))
        return { sr: s.Vr, nr: s.nr };
    }
    return null;
  }
  Z({ context: t }, i, n) {
    if (null !== this.zt && null !== this.zt.it) {
      t.textBaseline = "middle", t.font = this.zr;
      for (let i2 = this.zt.it.from; i2 < this.zt.it.to; i2++) {
        const n2 = this.zt.nt[i2];
        void 0 !== n2.Gt && (n2.Gt.$i = this.qe.Si(t, n2.Gt.Nr), n2.Gt.It = this.W, n2.Gt.st = n2.st - n2.Gt.$i / 2), _i(n2, t);
      }
    }
  }
}
function _i(t, i) {
  i.fillStyle = t.D, void 0 !== t.Gt && function(t2, i2, n, s) {
    t2.fillText(i2, n, s);
  }(i, t.Gt.Nr, t.Gt.st, t.Gt.et), function(t2, i2) {
    if (0 === t2.Ns)
      return;
    switch (t2.Fr) {
      case "arrowDown":
        return void li(false, i2, t2.st, t2.et, t2.Ns);
      case "arrowUp":
        return void li(true, i2, t2.st, t2.et, t2.Ns);
      case "circle":
        return void function(t3, i3, n, s) {
          const e2 = (si("circle", s) - 1) / 2;
          t3.beginPath(), t3.arc(i3, n, e2, 0, 2 * Math.PI, false), t3.fill();
        }(i2, t2.st, t2.et, t2.Ns);
      case "square":
        return void function(t3, i3, n, s) {
          const e2 = si("square", s), r2 = (e2 - 1) / 2, h3 = i3 - r2, l2 = n - r2;
          t3.fillRect(h3, l2, e2, e2);
        }(i2, t2.st, t2.et, t2.Ns);
    }
    t2.Fr;
  }(t, i);
}
function ui(t, i, n) {
  return !(void 0 === t.Gt || !function(t2, i2, n2, s, e2, r2) {
    const h3 = s / 2;
    return e2 >= t2 && e2 <= t2 + n2 && r2 >= i2 - h3 && r2 <= i2 + h3;
  }(t.Gt.st, t.Gt.et, t.Gt.$i, t.Gt.It, i, n)) || function(t2, i2, n2) {
    if (0 === t2.Ns)
      return false;
    switch (t2.Fr) {
      case "arrowDown":
      case "arrowUp":
        return ai(0, t2.st, t2.et, t2.Ns, i2, n2);
      case "circle":
        return function(t3, i3, n3, s, e2) {
          const r2 = 2 + si("circle", n3) / 2, h3 = t3 - s, l2 = i3 - e2;
          return Math.sqrt(h3 * h3 + l2 * l2) <= r2;
        }(t2.st, t2.et, t2.Ns, i2, n2);
      case "square":
        return hi(t2.st, t2.et, t2.Ns, i2, n2);
    }
  }(t, i, n);
}
function ci(t, i, n, s, e2, r2, h3, l2, a2) {
  const o2 = x(n) ? n : n.ce, _2 = x(n) ? n : n._e, u2 = x(n) ? n : n.ue, c2 = x(i.size) ? Math.max(i.size, 0) : 1, d2 = ei(l2.Ks()) * c2, f2 = d2 / 2;
  switch (t.Ns = d2, i.position) {
    case "inBar":
      return t.et = h3.Dt(o2, a2), void (void 0 !== t.Gt && (t.Gt.et = t.et + f2 + r2 + 0.6 * e2));
    case "aboveBar":
      return t.et = h3.Dt(_2, a2) - f2 - s.Wr, void 0 !== t.Gt && (t.Gt.et = t.et - f2 - 0.6 * e2, s.Wr += 1.2 * e2), void (s.Wr += d2 + r2);
    case "belowBar":
      return t.et = h3.Dt(u2, a2) + f2 + s.jr, void 0 !== t.Gt && (t.Gt.et = t.et + f2 + r2 + 0.6 * e2, s.jr += 1.2 * e2), void (s.jr += d2 + r2);
  }
  i.position;
}
class di {
  constructor(t, i) {
    this.vt = true, this.$r = true, this.Hr = true, this.Ur = null, this.jt = new oi(), this.Tr = t, this.Hi = i, this.zt = { nt: [], it: null };
  }
  gt(t) {
    this.vt = true, this.Hr = true, "data" === t && (this.$r = true);
  }
  Mt(t) {
    if (!this.Tr.Ct())
      return null;
    this.vt && this.qr();
    const i = this.Hi.F().layout;
    return this.jt.Ye(i.fontSize, i.fontFamily), this.jt.tt(this.zt), this.jt;
  }
  Yr() {
    if (this.Hr) {
      if (this.Tr.Xr().length > 0) {
        const t = this.Hi.yt().Ks(), i = ri(t), n = 1.5 * ei(t) + 2 * i;
        this.Ur = { above: n, below: n };
      } else
        this.Ur = null;
      this.Hr = false;
    }
    return this.Ur;
  }
  qr() {
    const t = this.Tr.Bt(), i = this.Hi.yt(), n = this.Tr.Xr();
    this.$r && (this.zt.nt = n.map((t2) => ({ _t: t2.time, st: 0, et: 0, Ns: 0, Fr: t2.shape, D: t2.color, Vr: t2.internalId, nr: t2.id, Gt: void 0 })), this.$r = false);
    const s = this.Hi.F().layout;
    this.zt.it = null;
    const e2 = i.Vs();
    if (null === e2)
      return;
    const r2 = this.Tr.Tt();
    if (null === r2)
      return;
    if (0 === this.zt.nt.length)
      return;
    let h3 = NaN;
    const l2 = ri(i.Ks()), a2 = { Wr: l2, jr: l2 };
    this.zt.it = kt(this.zt.nt, e2, true);
    for (let e3 = this.zt.it.from; e3 < this.zt.it.to; e3++) {
      const o2 = n[e3];
      o2.time !== h3 && (a2.Wr = l2, a2.jr = l2, h3 = o2.time);
      const _2 = this.zt.nt[e3];
      _2.st = i.Et(o2.time), void 0 !== o2.text && o2.text.length > 0 && (_2.Gt = { Nr: o2.text, st: 0, et: 0, $i: 0, It: 0 });
      const u2 = this.Tr.Zr(o2.time);
      null !== u2 && ci(_2, o2, u2, a2, s.fontSize, l2, t, i, r2.At);
    }
    this.vt = false;
  }
}
class fi extends Zt {
  constructor(t) {
    super(t);
  }
  hr() {
    const t = this.er;
    t.Ct = false;
    const i = this.Ts.F();
    if (!i.priceLineVisible || !this.Ts.Ct())
      return;
    const n = this.Ts.Or(0 === i.priceLineSource);
    n.Lr || (t.Ct = true, t.et = n.yi, t.D = this.Ts.Kr(n.D), t.rt = i.priceLineWidth, t.Ft = i.priceLineStyle);
  }
}
class pi extends Z {
  constructor(t) {
    super(), this.$t = t;
  }
  Ei(t, i, n) {
    t.Ct = false, i.Ct = false;
    const s = this.$t;
    if (!s.Ct())
      return;
    const e2 = s.F(), r2 = e2.lastValueVisible, h3 = "" !== s.Gr(), l2 = 0 === e2.seriesLastValueMode, a2 = s.Or(false);
    if (a2.Lr)
      return;
    r2 && (t.Gt = this.Jr(a2, r2, l2), t.Ct = 0 !== t.Gt.length), (h3 || l2) && (i.Gt = this.Qr(a2, r2, h3, l2), i.Ct = i.Gt.length > 0);
    const o2 = s.Kr(a2.D), _2 = w(o2);
    n.t = _2.t, n.yi = a2.yi, i.Ot = s.Ut().Lt(a2.yi / s.Bt().It()), t.Ot = o2, t.D = _2.i, i.D = _2.i;
  }
  Qr(t, i, n, s) {
    let e2 = "";
    const r2 = this.$t.Gr();
    return n && 0 !== r2.length && (e2 += `${r2} `), i && s && (e2 += this.$t.Bt().th() ? t.ih : t.nh), e2.trim();
  }
  Jr(t, i, n) {
    return i ? n ? this.$t.Bt().th() ? t.nh : t.ih : t.Gt : "";
  }
}
class vi {
  constructor(t, i) {
    this.sh = t, this.eh = i;
  }
  rh(t) {
    return null !== t && (this.sh === t.sh && this.eh === t.eh);
  }
  hh() {
    return new vi(this.sh, this.eh);
  }
  lh() {
    return this.sh;
  }
  ah() {
    return this.eh;
  }
  oh() {
    return this.eh - this.sh;
  }
  Ni() {
    return this.eh === this.sh || Number.isNaN(this.eh) || Number.isNaN(this.sh);
  }
  Qn(t) {
    return null === t ? this : new vi(Math.min(this.lh(), t.lh()), Math.max(this.ah(), t.ah()));
  }
  _h(t) {
    if (!x(t))
      return;
    if (0 === this.eh - this.sh)
      return;
    const i = 0.5 * (this.eh + this.sh);
    let n = this.eh - i, s = this.sh - i;
    n *= t, s *= t, this.eh = i + n, this.sh = i + s;
  }
  uh(t) {
    x(t) && (this.eh += t, this.sh += t);
  }
  dh() {
    return { minValue: this.sh, maxValue: this.eh };
  }
  static fh(t) {
    return null === t ? null : new vi(t.minValue, t.maxValue);
  }
}
class mi {
  constructor(t, i) {
    this.ph = t, this.mh = i || null;
  }
  bh() {
    return this.ph;
  }
  gh() {
    return this.mh;
  }
  dh() {
    return null === this.ph ? null : { priceRange: this.ph.dh(), margins: this.mh || void 0 };
  }
  static fh(t) {
    return null === t ? null : new mi(vi.fh(t.priceRange), t.margins);
  }
}
class bi extends Zt {
  constructor(t, i) {
    super(t), this.wh = i;
  }
  hr() {
    const t = this.er;
    t.Ct = false;
    const i = this.wh.F();
    if (!this.Ts.Ct() || !i.lineVisible)
      return;
    const n = this.wh.Mh();
    null !== n && (t.Ct = true, t.et = n, t.D = i.color, t.rt = i.lineWidth, t.Ft = i.lineStyle, t.nr = this.wh.F().id);
  }
}
class gi extends Z {
  constructor(t, i) {
    super(), this.Tr = t, this.wh = i;
  }
  Ei(t, i, n) {
    t.Ct = false, i.Ct = false;
    const s = this.wh.F(), e2 = s.axisLabelVisible, r2 = "" !== s.title, h3 = this.Tr;
    if (!e2 || !h3.Ct())
      return;
    const l2 = this.wh.Mh();
    if (null === l2)
      return;
    r2 && (i.Gt = s.title, i.Ct = true), i.Ot = h3.Ut().Lt(l2 / h3.Bt().It()), t.Gt = this.Sh(s.price), t.Ct = true;
    const a2 = w(s.axisLabelColor || s.color);
    n.t = a2.t;
    const o2 = s.axisLabelTextColor || a2.i;
    t.D = o2, i.D = o2, n.yi = l2;
  }
  Sh(t) {
    const i = this.Tr.Tt();
    return null === i ? "" : this.Tr.Bt().Fi(t, i.At);
  }
}
class wi {
  constructor(t, i) {
    this.Tr = t, this.un = i, this.xh = new bi(t, this), this.Xe = new gi(t, this), this.yh = new Yt(this.Xe, t, t.Ut());
  }
  kh(t) {
    S(this.un, t), this.gt(), this.Tr.Ut().Ch();
  }
  F() {
    return this.un;
  }
  Th() {
    return this.xh;
  }
  Ph() {
    return this.yh;
  }
  Rh() {
    return this.Xe;
  }
  gt() {
    this.xh.gt(), this.Xe.gt();
  }
  Mh() {
    const t = this.Tr, i = t.Bt();
    if (t.Ut().yt().Ni() || i.Ni())
      return null;
    const n = t.Tt();
    return null === n ? null : i.Dt(this.un.price, n.At);
  }
}
class Mi extends tt {
  constructor(t) {
    super(), this.Hi = t;
  }
  Ut() {
    return this.Hi;
  }
}
const Si = { Bar: (t, i, n, s) => {
  var e2;
  const r2 = i.upColor, h3 = i.downColor, l2 = _(t(n, s)), a2 = u(l2.At[0]) <= u(l2.At[3]);
  return { ie: null !== (e2 = l2.D) && void 0 !== e2 ? e2 : a2 ? r2 : h3 };
}, Candlestick: (t, i, n, s) => {
  var e2, r2, h3;
  const l2 = i.upColor, a2 = i.downColor, o2 = i.borderUpColor, c2 = i.borderDownColor, d2 = i.wickUpColor, f2 = i.wickDownColor, p2 = _(t(n, s)), v2 = u(p2.At[0]) <= u(p2.At[3]);
  return { ie: null !== (e2 = p2.D) && void 0 !== e2 ? e2 : v2 ? l2 : a2, Pe: null !== (r2 = p2.Ot) && void 0 !== r2 ? r2 : v2 ? o2 : c2, Te: null !== (h3 = p2.Dh) && void 0 !== h3 ? h3 : v2 ? d2 : f2 };
}, Area: (t, i, n, s) => {
  var e2, r2, h3, l2;
  const a2 = _(t(n, s));
  return { ie: null !== (e2 = a2.ot) && void 0 !== e2 ? e2 : i.lineColor, ot: null !== (r2 = a2.ot) && void 0 !== r2 ? r2 : i.lineColor, bs: null !== (h3 = a2.bs) && void 0 !== h3 ? h3 : i.topColor, gs: null !== (l2 = a2.gs) && void 0 !== l2 ? l2 : i.bottomColor };
}, Baseline: (t, i, n, s) => {
  var e2, r2, h3, l2, a2, o2;
  const u2 = _(t(n, s));
  return { ie: u2.At[3] >= i.baseValue.price ? i.topLineColor : i.bottomLineColor, be: null !== (e2 = u2.be) && void 0 !== e2 ? e2 : i.topLineColor, ge: null !== (r2 = u2.ge) && void 0 !== r2 ? r2 : i.bottomLineColor, de: null !== (h3 = u2.de) && void 0 !== h3 ? h3 : i.topFillColor1, fe: null !== (l2 = u2.fe) && void 0 !== l2 ? l2 : i.topFillColor2, pe: null !== (a2 = u2.pe) && void 0 !== a2 ? a2 : i.bottomFillColor1, ve: null !== (o2 = u2.ve) && void 0 !== o2 ? o2 : i.bottomFillColor2 };
}, Line: (t, i, n, s) => {
  var e2, r2;
  const h3 = _(t(n, s));
  return { ie: null !== (e2 = h3.D) && void 0 !== e2 ? e2 : i.color, ot: null !== (r2 = h3.D) && void 0 !== r2 ? r2 : i.color };
}, Histogram: (t, i, n, s) => {
  var e2;
  return { ie: null !== (e2 = _(t(n, s)).D) && void 0 !== e2 ? e2 : i.color };
} };
class xi {
  constructor(t) {
    this.Bh = (t2, i) => void 0 !== i ? i.At : this.Tr.Ln().Ah(t2), this.Tr = t, this.Oh = Si[t.Lh()];
  }
  Os(t, i) {
    return this.Oh(this.Bh, this.Tr.F(), t, i);
  }
}
var yi;
!function(t) {
  t[t.NearestLeft = -1] = "NearestLeft", t[t.None = 0] = "None", t[t.NearestRight = 1] = "NearestRight";
}(yi || (yi = {}));
const ki = 30;
class Ci {
  constructor() {
    this.Ih = [], this.Eh = /* @__PURE__ */ new Map(), this.zh = /* @__PURE__ */ new Map();
  }
  Vh() {
    return this.Ns() > 0 ? this.Ih[this.Ih.length - 1] : null;
  }
  Nh() {
    return this.Ns() > 0 ? this.Fh(0) : null;
  }
  On() {
    return this.Ns() > 0 ? this.Fh(this.Ih.length - 1) : null;
  }
  Ns() {
    return this.Ih.length;
  }
  Ni() {
    return 0 === this.Ns();
  }
  Ir(t) {
    return null !== this.Wh(t, 0);
  }
  Ah(t) {
    return this.jh(t);
  }
  jh(t, i = 0) {
    const n = this.Wh(t, i);
    return null === n ? null : Object.assign(Object.assign({}, this.$h(n)), { Ys: this.Fh(n) });
  }
  Us() {
    return this.Ih;
  }
  Hh(t, i, n) {
    if (this.Ni())
      return null;
    let s = null;
    for (const e2 of n) {
      s = Ti(s, this.Uh(t, i, e2));
    }
    return s;
  }
  tt(t) {
    this.zh.clear(), this.Eh.clear(), this.Ih = t;
  }
  Fh(t) {
    return this.Ih[t].Ys;
  }
  $h(t) {
    return this.Ih[t];
  }
  Wh(t, i) {
    const n = this.qh(t);
    if (null === n && 0 !== i)
      switch (i) {
        case -1:
          return this.Yh(t);
        case 1:
          return this.Xh(t);
        default:
          throw new TypeError("Unknown search mode");
      }
    return n;
  }
  Yh(t) {
    let i = this.Zh(t);
    return i > 0 && (i -= 1), i !== this.Ih.length && this.Fh(i) < t ? i : null;
  }
  Xh(t) {
    const i = this.Kh(t);
    return i !== this.Ih.length && t < this.Fh(i) ? i : null;
  }
  qh(t) {
    const i = this.Zh(t);
    return i === this.Ih.length || t < this.Ih[i].Ys ? null : i;
  }
  Zh(t) {
    return Mt(this.Ih, t, (t2, i) => t2.Ys < i);
  }
  Kh(t) {
    return St(this.Ih, t, (t2, i) => i.Ys > t2);
  }
  Gh(t, i, n) {
    let s = null;
    for (let e2 = t; e2 < i; e2++) {
      const t2 = this.Ih[e2].At[n];
      Number.isNaN(t2) || (null === s ? s = { Jh: t2, Qh: t2 } : (t2 < s.Jh && (s.Jh = t2), t2 > s.Qh && (s.Qh = t2)));
    }
    return s;
  }
  Uh(t, i, n) {
    if (this.Ni())
      return null;
    let s = null;
    const e2 = _(this.Nh()), r2 = _(this.On()), h3 = Math.max(t, e2), l2 = Math.min(i, r2), a2 = Math.ceil(h3 / ki) * ki, o2 = Math.max(a2, Math.floor(l2 / ki) * ki);
    {
      const t2 = this.Zh(h3), e3 = this.Kh(Math.min(l2, a2, i));
      s = Ti(s, this.Gh(t2, e3, n));
    }
    let u2 = this.Eh.get(n);
    void 0 === u2 && (u2 = /* @__PURE__ */ new Map(), this.Eh.set(n, u2));
    for (let t2 = Math.max(a2 + 1, h3); t2 < o2; t2 += ki) {
      const i2 = Math.floor(t2 / ki);
      let e3 = u2.get(i2);
      if (void 0 === e3) {
        const t3 = this.Zh(i2 * ki), s2 = this.Kh((i2 + 1) * ki - 1);
        e3 = this.Gh(t3, s2, n), u2.set(i2, e3);
      }
      s = Ti(s, e3);
    }
    {
      const t2 = this.Zh(o2), i2 = this.Kh(l2);
      s = Ti(s, this.Gh(t2, i2, n));
    }
    return s;
  }
}
function Ti(t, i) {
  if (null === t)
    return i;
  if (null === i)
    return t;
  return { Jh: Math.min(t.Jh, i.Jh), Qh: Math.max(t.Qh, i.Qh) };
}
class Pi extends Mi {
  constructor(t, i, n) {
    super(t), this.zt = new Ci(), this.xh = new fi(this), this.tl = [], this.il = new Kt(this), this.nl = null, this.sl = null, this.el = [], this.rl = [], this.hl = null, this.un = i, this.ll = n;
    const s = new pi(this);
    this.rn = [s], this.yh = new Yt(s, this, t), "Area" !== n && "Line" !== n && "Baseline" !== n || (this.nl = new ii(this)), this.al(), this.ol();
  }
  M() {
    null !== this.hl && clearTimeout(this.hl);
  }
  Kr(t) {
    return this.un.priceLineColor || t;
  }
  Or(t) {
    const i = { Lr: true }, n = this.Bt();
    if (this.Ut().yt().Ni() || n.Ni() || this.zt.Ni())
      return i;
    const s = this.Ut().yt().Vs(), e2 = this.Tt();
    if (null === s || null === e2)
      return i;
    let r2, h3;
    if (t) {
      const t2 = this.zt.Vh();
      if (null === t2)
        return i;
      r2 = t2, h3 = t2.Ys;
    } else {
      const t2 = this.zt.jh(s.ci(), -1);
      if (null === t2)
        return i;
      if (r2 = this.zt.Ah(t2.Ys), null === r2)
        return i;
      h3 = t2.Ys;
    }
    const l2 = r2.At[3], a2 = this.Ls().Os(h3, { At: r2 }), o2 = n.Dt(l2, e2.At);
    return { Lr: false, ut: l2, Gt: n.Fi(l2, e2.At), ih: n._l(l2), nh: n.ul(l2, e2.At), D: a2.ie, yi: o2, Ys: h3 };
  }
  Ls() {
    return null !== this.sl || (this.sl = new xi(this)), this.sl;
  }
  F() {
    return this.un;
  }
  kh(t) {
    const i = t.priceScaleId;
    void 0 !== i && i !== this.un.priceScaleId && this.Ut().cl(this, i), S(this.un, t), void 0 !== t.priceFormat && (this.al(), this.Ut().dl()), this.Ut().fl(this), this.Ut().pl(), this.bn.gt("options");
  }
  tt(t, i) {
    this.zt.tt(t), this.vl(), this.bn.gt("data"), this.cn.gt("data"), null !== this.nl && (i && i.ml ? this.nl.Rr() : 0 === t.length && this.nl.Pr());
    const n = this.Ut().Ke(this);
    this.Ut().bl(n), this.Ut().fl(this), this.Ut().pl(), this.Ut().Ch();
  }
  gl(t) {
    this.el = t, this.vl();
    const i = this.Ut().Ke(this);
    this.cn.gt("data"), this.Ut().bl(i), this.Ut().fl(this), this.Ut().pl(), this.Ut().Ch();
  }
  wl() {
    return this.el;
  }
  Xr() {
    return this.rl;
  }
  Ml(t) {
    const i = new wi(this, t);
    return this.tl.push(i), this.Ut().fl(this), i;
  }
  Sl(t) {
    const i = this.tl.indexOf(t);
    -1 !== i && this.tl.splice(i, 1), this.Ut().fl(this);
  }
  Lh() {
    return this.ll;
  }
  Tt() {
    const t = this.xl();
    return null === t ? null : { At: t.At[3], yl: t._t };
  }
  xl() {
    const t = this.Ut().yt().Vs();
    if (null === t)
      return null;
    const i = t.Ms();
    return this.zt.jh(i, 1);
  }
  Ln() {
    return this.zt;
  }
  Zr(t) {
    const i = this.zt.Ah(t);
    return null === i ? null : "Bar" === this.ll || "Candlestick" === this.ll ? { oe: i.At[0], _e: i.At[1], ue: i.At[2], ce: i.At[3] } : i.At[3];
  }
  kl(t) {
    const i = this.nl;
    return null !== i && i.Ct() ? (null === this.hl && i.Br() && (this.hl = setTimeout(() => {
      this.hl = null, this.Ut().Cl();
    }, 0)), i.Dr(), [i]) : [];
  }
  Tn() {
    const t = [];
    this.Tl() || t.push(this.il), t.push(this.bn, this.xh, this.cn);
    const i = this.tl.map((t2) => t2.Th());
    return t.push(...i), t;
  }
  Ji(t) {
    return [this.yh, ...this.tl.map((t2) => t2.Ph())];
  }
  Pn(t, i) {
    if (i !== this.Yi && !this.Tl())
      return [];
    const n = [...this.rn];
    for (const t2 of this.tl)
      n.push(t2.Rh());
    return n;
  }
  Pl(t, i) {
    if (void 0 !== this.un.autoscaleInfoProvider) {
      const n = this.un.autoscaleInfoProvider(() => {
        const n2 = this.Rl(t, i);
        return null === n2 ? null : n2.dh();
      });
      return mi.fh(n);
    }
    return this.Rl(t, i);
  }
  Dl() {
    return this.un.priceFormat.minMove;
  }
  Bl() {
    return this.Al;
  }
  Dn() {
    var t;
    this.bn.gt(), this.cn.gt();
    for (const t2 of this.rn)
      t2.gt();
    for (const t2 of this.tl)
      t2.gt();
    this.xh.gt(), this.il.gt(), null === (t = this.nl) || void 0 === t || t.gt();
  }
  Bt() {
    return _(super.Bt());
  }
  kt(t) {
    if (!(("Line" === this.ll || "Area" === this.ll || "Baseline" === this.ll) && this.un.crosshairMarkerVisible))
      return null;
    const i = this.zt.Ah(t);
    if (null === i)
      return null;
    return { ut: i.At[3], lt: this.Ol(), Ot: this.Ll(), Rt: this.Il(), Pt: this.El(t) };
  }
  Gr() {
    return this.un.title;
  }
  Ct() {
    return this.un.visible;
  }
  Tl() {
    return !st(this.Bt().zl());
  }
  Rl(t, i) {
    if (!y(t) || !y(i) || this.zt.Ni())
      return null;
    const n = "Line" === this.ll || "Area" === this.ll || "Baseline" === this.ll || "Histogram" === this.ll ? [3] : [2, 1], s = this.zt.Hh(t, i, n);
    let e2 = null !== s ? new vi(s.Jh, s.Qh) : null;
    if ("Histogram" === this.Lh()) {
      const t2 = this.un.base, i2 = new vi(t2, t2);
      e2 = null !== e2 ? e2.Qn(i2) : i2;
    }
    return new mi(e2, this.cn.Yr());
  }
  Ol() {
    switch (this.ll) {
      case "Line":
      case "Area":
      case "Baseline":
        return this.un.crosshairMarkerRadius;
    }
    return 0;
  }
  Ll() {
    switch (this.ll) {
      case "Line":
      case "Area":
      case "Baseline": {
        const t = this.un.crosshairMarkerBorderColor;
        if (0 !== t.length)
          return t;
      }
    }
    return null;
  }
  Il() {
    switch (this.ll) {
      case "Line":
      case "Area":
      case "Baseline":
        return this.un.crosshairMarkerBorderWidth;
    }
    return 0;
  }
  El(t) {
    switch (this.ll) {
      case "Line":
      case "Area":
      case "Baseline": {
        const t2 = this.un.crosshairMarkerBackgroundColor;
        if (0 !== t2.length)
          return t2;
      }
    }
    return this.Ls().Os(t).ie;
  }
  al() {
    switch (this.un.priceFormat.type) {
      case "custom":
        this.Al = { format: this.un.priceFormat.formatter };
        break;
      case "volume":
        this.Al = new ot(this.un.priceFormat.precision);
        break;
      case "percent":
        this.Al = new at(this.un.priceFormat.precision);
        break;
      default: {
        const t = Math.pow(10, this.un.priceFormat.precision);
        this.Al = new lt(t, this.un.priceFormat.minMove * t);
      }
    }
    null !== this.Yi && this.Yi.Vl();
  }
  vl() {
    const t = this.Ut().yt();
    if (!t.Nl() || this.zt.Ni())
      return void (this.rl = []);
    const i = _(this.zt.Nh());
    this.rl = this.el.map((n, s) => {
      const e2 = _(t.Fl(n.time, true)), r2 = e2 < i ? 1 : -1;
      return { time: _(this.zt.jh(e2, r2)).Ys, position: n.position, shape: n.shape, color: n.color, id: n.id, internalId: s, text: n.text, size: n.size };
    });
  }
  ol() {
    switch (this.cn = new di(this, this.Ut()), this.ll) {
      case "Bar":
        this.bn = new Bt(this, this.Ut());
        break;
      case "Candlestick":
        this.bn = new Ft(this, this.Ut());
        break;
      case "Line":
        this.bn = new $t(this, this.Ut());
        break;
      case "Area":
        this.bn = new Pt(this, this.Ut());
        break;
      case "Baseline":
        this.bn = new Vt(this, this.Ut());
        break;
      case "Histogram":
        this.bn = new jt(this, this.Ut());
        break;
      default:
        throw Error("Unknown chart style assigned: " + this.ll);
    }
  }
}
class Ri {
  constructor(t) {
    this.un = t;
  }
  Wl(t, i, n) {
    let s = t;
    if (0 === this.un.mode)
      return s;
    const e2 = n.fn(), r2 = e2.Tt();
    if (null === r2)
      return s;
    const h3 = e2.Dt(t, r2), l2 = n.jl().filter((t2) => t2 instanceof Pi).reduce((t2, s2) => {
      if (n.Ge(s2) || !s2.Ct())
        return t2;
      const e3 = s2.Bt(), r3 = s2.Ln();
      if (e3.Ni() || !r3.Ir(i))
        return t2;
      const h4 = r3.Ah(i);
      if (null === h4)
        return t2;
      const l3 = u(s2.Tt());
      return t2.concat([e3.Dt(h4.At[3], l3.At)]);
    }, []);
    if (0 === l2.length)
      return s;
    l2.sort((t2, i2) => Math.abs(t2 - h3) - Math.abs(i2 - h3));
    const a2 = l2[0];
    return s = e2.pn(a2, r2), s;
  }
}
class Di extends N {
  constructor() {
    super(...arguments), this.zt = null;
  }
  tt(t) {
    this.zt = t;
  }
  Z({ context: t, bitmapSize: i, horizontalPixelRatio: n, verticalPixelRatio: s }) {
    if (null === this.zt)
      return;
    const e2 = Math.max(1, Math.floor(n));
    t.lineWidth = e2, function(t2, i2) {
      t2.save(), t2.lineWidth % 2 && t2.translate(0.5, 0.5), i2(), t2.restore();
    }(t, () => {
      const r2 = _(this.zt);
      if (r2.$l) {
        t.strokeStyle = r2.Hl, h(t, r2.Ul), t.beginPath();
        for (const s2 of r2.ql) {
          const r3 = Math.round(s2.Yl * n);
          t.moveTo(r3, -e2), t.lineTo(r3, i.height + e2);
        }
        t.stroke();
      }
      if (r2.Xl) {
        t.strokeStyle = r2.Zl, h(t, r2.Kl), t.beginPath();
        for (const n2 of r2.Gl) {
          const r3 = Math.round(n2.Yl * s);
          t.moveTo(-e2, r3), t.lineTo(i.width + e2, r3);
        }
        t.stroke();
      }
    });
  }
}
class Bi {
  constructor(t) {
    this.jt = new Di(), this.vt = true, this.tn = t;
  }
  gt() {
    this.vt = true;
  }
  Mt() {
    if (this.vt) {
      const t = this.tn.Ut().F().grid, i = { Xl: t.horzLines.visible, $l: t.vertLines.visible, Zl: t.horzLines.color, Hl: t.vertLines.color, Kl: t.horzLines.style, Ul: t.vertLines.style, Gl: this.tn.fn().Jl(), ql: this.tn.Ut().yt().Jl() || [] };
      this.jt.tt(i), this.vt = false;
    }
    return this.jt;
  }
}
class Ai {
  constructor(t) {
    this.bn = new Bi(t);
  }
  Th() {
    return this.bn;
  }
}
const Oi = { Ql: 4, ta: 1e-4 };
function Li(t, i) {
  const n = 100 * (t - i) / i;
  return i < 0 ? -n : n;
}
function Ii(t, i) {
  const n = Li(t.lh(), i), s = Li(t.ah(), i);
  return new vi(n, s);
}
function Ei(t, i) {
  const n = 100 * (t - i) / i + 100;
  return i < 0 ? -n : n;
}
function zi(t, i) {
  const n = Ei(t.lh(), i), s = Ei(t.ah(), i);
  return new vi(n, s);
}
function Vi(t, i) {
  const n = Math.abs(t);
  if (n < 1e-15)
    return 0;
  const s = Lt(n + i.ta) + i.Ql;
  return t < 0 ? -s : s;
}
function Ni(t, i) {
  const n = Math.abs(t);
  if (n < 1e-15)
    return 0;
  const s = Math.pow(10, n - i.Ql) - i.ta;
  return t < 0 ? -s : s;
}
function Fi(t, i) {
  if (null === t)
    return null;
  const n = Vi(t.lh(), i), s = Vi(t.ah(), i);
  return new vi(n, s);
}
function Wi(t, i) {
  if (null === t)
    return null;
  const n = Ni(t.lh(), i), s = Ni(t.ah(), i);
  return new vi(n, s);
}
function ji(t) {
  if (null === t)
    return Oi;
  const i = Math.abs(t.ah() - t.lh());
  if (i >= 1 || i < 1e-15)
    return Oi;
  const n = Math.ceil(Math.abs(Math.log10(i))), s = Oi.Ql + n;
  return { Ql: s, ta: 1 / Math.pow(10, s) };
}
class $i {
  constructor(t, i) {
    if (this.ia = t, this.na = i, function(t2) {
      if (t2 < 0)
        return false;
      for (let i2 = t2; i2 > 1; i2 /= 10)
        if (i2 % 10 != 0)
          return false;
      return true;
    }(this.ia))
      this.sa = [2, 2.5, 2];
    else {
      this.sa = [];
      for (let t2 = this.ia; 1 !== t2; ) {
        if (t2 % 2 == 0)
          this.sa.push(2), t2 /= 2;
        else {
          if (t2 % 5 != 0)
            throw new Error("unexpected base");
          this.sa.push(2, 2.5), t2 /= 5;
        }
        if (this.sa.length > 100)
          throw new Error("something wrong with base");
      }
    }
  }
  ea(t, i, n) {
    const s = 0 === this.ia ? 0 : 1 / this.ia;
    let e2 = Math.pow(10, Math.max(0, Math.ceil(Lt(t - i)))), r2 = 0, h3 = this.na[0];
    for (; ; ) {
      const t2 = Ot(e2, s, 1e-14) && e2 > s + 1e-14, i2 = Ot(e2, n * h3, 1e-14), l3 = Ot(e2, 1, 1e-14);
      if (!(t2 && i2 && l3))
        break;
      e2 /= h3, h3 = this.na[++r2 % this.na.length];
    }
    if (e2 <= s + 1e-14 && (e2 = s), e2 = Math.max(1, e2), this.sa.length > 0 && (l2 = e2, a2 = 1, o2 = 1e-14, Math.abs(l2 - a2) < o2))
      for (r2 = 0, h3 = this.sa[0]; Ot(e2, n * h3, 1e-14) && e2 > s + 1e-14; )
        e2 /= h3, h3 = this.sa[++r2 % this.sa.length];
    var l2, a2, o2;
    return e2;
  }
}
class Hi {
  constructor(t, i, n, s) {
    this.ra = [], this.zi = t, this.ia = i, this.ha = n, this.la = s;
  }
  ea(t, i) {
    if (t < i)
      throw new Error("high < low");
    const n = this.zi.It(), s = (t - i) * this.aa() / n, e2 = new $i(this.ia, [2, 2.5, 2]), r2 = new $i(this.ia, [2, 2, 2.5]), h3 = new $i(this.ia, [2.5, 2, 2]), l2 = [];
    return l2.push(e2.ea(t, i, s), r2.ea(t, i, s), h3.ea(t, i, s)), function(t2) {
      if (t2.length < 1)
        throw Error("array is empty");
      let i2 = t2[0];
      for (let n2 = 1; n2 < t2.length; ++n2)
        t2[n2] < i2 && (i2 = t2[n2]);
      return i2;
    }(l2);
  }
  oa() {
    const t = this.zi, i = t.Tt();
    if (null === i)
      return void (this.ra = []);
    const n = t.It(), s = this.ha(n - 1, i), e2 = this.ha(0, i), r2 = this.zi.F().entireTextOnly ? this._a() / 2 : 0, h3 = r2, l2 = n - 1 - r2, a2 = Math.max(s, e2), o2 = Math.min(s, e2);
    if (a2 === o2)
      return void (this.ra = []);
    let _2 = this.ea(a2, o2), u2 = a2 % _2;
    u2 += u2 < 0 ? _2 : 0;
    const c2 = a2 >= o2 ? 1 : -1;
    let d2 = null, f2 = 0;
    for (let n2 = a2 - u2; n2 > o2; n2 -= _2) {
      const s2 = this.la(n2, i, true);
      null !== d2 && Math.abs(s2 - d2) < this.aa() || (s2 < h3 || s2 > l2 || (f2 < this.ra.length ? (this.ra[f2].Yl = s2, this.ra[f2].ua = t.ca(n2)) : this.ra.push({ Yl: s2, ua: t.ca(n2) }), f2++, d2 = s2, t.da() && (_2 = this.ea(n2 * c2, o2))));
    }
    this.ra.length = f2;
  }
  Jl() {
    return this.ra;
  }
  _a() {
    return this.zi.T();
  }
  aa() {
    return Math.ceil(2.5 * this._a());
  }
}
function Ui(t) {
  return t.slice().sort((t2, i) => _(t2.Zi()) - _(i.Zi()));
}
var qi;
!function(t) {
  t[t.Normal = 0] = "Normal", t[t.Logarithmic = 1] = "Logarithmic", t[t.Percentage = 2] = "Percentage", t[t.IndexedTo100 = 3] = "IndexedTo100";
}(qi || (qi = {}));
const Yi = new at(), Xi = new lt(100, 1);
class Zi {
  constructor(t, i, n, s) {
    this.fa = 0, this.pa = null, this.ph = null, this.va = null, this.ma = { ba: false, ga: null }, this.wa = 0, this.Ma = 0, this.Sa = new M(), this.xa = new M(), this.ya = [], this.ka = null, this.Ca = null, this.Ta = null, this.Pa = null, this.Al = Xi, this.Ra = ji(null), this.Da = t, this.un = i, this.Ba = n, this.Aa = s, this.Oa = new Hi(this, 100, this.La.bind(this), this.Ia.bind(this));
  }
  zl() {
    return this.Da;
  }
  F() {
    return this.un;
  }
  kh(t) {
    if (S(this.un, t), this.Vl(), void 0 !== t.mode && this.Ea({ lr: t.mode }), void 0 !== t.scaleMargins) {
      const i = o(t.scaleMargins.top), n = o(t.scaleMargins.bottom);
      if (i < 0 || i > 1)
        throw new Error(`Invalid top margin - expect value between 0 and 1, given=${i}`);
      if (n < 0 || n > 1 || i + n > 1)
        throw new Error(`Invalid bottom margin - expect value between 0 and 1, given=${n}`);
      if (i + n > 1)
        throw new Error(`Invalid margins - sum of margins must be less than 1, given=${i + n}`);
      this.za(), this.Ca = null;
    }
  }
  Va() {
    return this.un.autoScale;
  }
  da() {
    return 1 === this.un.mode;
  }
  th() {
    return 2 === this.un.mode;
  }
  Na() {
    return 3 === this.un.mode;
  }
  lr() {
    return { Fn: this.un.autoScale, Fa: this.un.invertScale, lr: this.un.mode };
  }
  Ea(t) {
    const i = this.lr();
    let n = null;
    void 0 !== t.Fn && (this.un.autoScale = t.Fn), void 0 !== t.lr && (this.un.mode = t.lr, 2 !== t.lr && 3 !== t.lr || (this.un.autoScale = true), this.ma.ba = false), 1 === i.lr && t.lr !== i.lr && (!function(t2, i2) {
      if (null === t2)
        return false;
      const n2 = Ni(t2.lh(), i2), s2 = Ni(t2.ah(), i2);
      return isFinite(n2) && isFinite(s2);
    }(this.ph, this.Ra) ? this.un.autoScale = true : (n = Wi(this.ph, this.Ra), null !== n && this.Wa(n))), 1 === t.lr && t.lr !== i.lr && (n = Fi(this.ph, this.Ra), null !== n && this.Wa(n));
    const s = i.lr !== this.un.mode;
    s && (2 === i.lr || this.th()) && this.Vl(), s && (3 === i.lr || this.Na()) && this.Vl(), void 0 !== t.Fa && i.Fa !== t.Fa && (this.un.invertScale = t.Fa, this.ja()), this.xa.m(i, this.lr());
  }
  $a() {
    return this.xa;
  }
  T() {
    return this.Ba.fontSize;
  }
  It() {
    return this.fa;
  }
  Ha(t) {
    this.fa !== t && (this.fa = t, this.za(), this.Ca = null);
  }
  Ua() {
    if (this.pa)
      return this.pa;
    const t = this.It() - this.qa() - this.Ya();
    return this.pa = t, t;
  }
  bh() {
    return this.Xa(), this.ph;
  }
  Wa(t, i) {
    const n = this.ph;
    (i || null === n && null !== t || null !== n && !n.rh(t)) && (this.Ca = null, this.ph = t);
  }
  Ni() {
    return this.Xa(), 0 === this.fa || !this.ph || this.ph.Ni();
  }
  Za(t) {
    return this.Fa() ? t : this.It() - 1 - t;
  }
  Dt(t, i) {
    return this.th() ? t = Li(t, i) : this.Na() && (t = Ei(t, i)), this.Ia(t, i);
  }
  $s(t, i, n) {
    this.Xa();
    const s = this.Ya(), e2 = _(this.bh()), r2 = e2.lh(), h3 = e2.ah(), l2 = this.Ua() - 1, a2 = this.Fa(), o2 = l2 / (h3 - r2), u2 = void 0 === n ? 0 : n.from, c2 = void 0 === n ? t.length : n.to, d2 = this.Ka();
    for (let n2 = u2; n2 < c2; n2++) {
      const e3 = t[n2], h4 = e3.ut;
      if (isNaN(h4))
        continue;
      let l3 = h4;
      null !== d2 && (l3 = d2(e3.ut, i));
      const _2 = s + o2 * (l3 - r2), u3 = a2 ? _2 : this.fa - 1 - _2;
      e3.et = u3;
    }
  }
  le(t, i, n) {
    this.Xa();
    const s = this.Ya(), e2 = _(this.bh()), r2 = e2.lh(), h3 = e2.ah(), l2 = this.Ua() - 1, a2 = this.Fa(), o2 = l2 / (h3 - r2), u2 = void 0 === n ? 0 : n.from, c2 = void 0 === n ? t.length : n.to, d2 = this.Ka();
    for (let n2 = u2; n2 < c2; n2++) {
      const e3 = t[n2];
      let h4 = e3.oe, l3 = e3._e, _2 = e3.ue, u3 = e3.ce;
      null !== d2 && (h4 = d2(e3.oe, i), l3 = d2(e3._e, i), _2 = d2(e3.ue, i), u3 = d2(e3.ce, i));
      let c3 = s + o2 * (h4 - r2), f2 = a2 ? c3 : this.fa - 1 - c3;
      e3.re = f2, c3 = s + o2 * (l3 - r2), f2 = a2 ? c3 : this.fa - 1 - c3, e3.ne = f2, c3 = s + o2 * (_2 - r2), f2 = a2 ? c3 : this.fa - 1 - c3, e3.se = f2, c3 = s + o2 * (u3 - r2), f2 = a2 ? c3 : this.fa - 1 - c3, e3.he = f2;
    }
  }
  pn(t, i) {
    const n = this.La(t, i);
    return this.Ga(n, i);
  }
  Ga(t, i) {
    let n = t;
    return this.th() ? n = function(t2, i2) {
      return i2 < 0 && (t2 = -t2), t2 / 100 * i2 + i2;
    }(n, i) : this.Na() && (n = function(t2, i2) {
      return t2 -= 100, i2 < 0 && (t2 = -t2), t2 / 100 * i2 + i2;
    }(n, i)), n;
  }
  jl() {
    return this.ya;
  }
  Ja() {
    if (this.ka)
      return this.ka;
    let t = [];
    for (let i = 0; i < this.ya.length; i++) {
      const n = this.ya[i];
      null === n.Zi() && n.Ki(i + 1), t.push(n);
    }
    return t = Ui(t), this.ka = t, this.ka;
  }
  Qa(t) {
    -1 === this.ya.indexOf(t) && (this.ya.push(t), this.Vl(), this.io());
  }
  no(t) {
    const i = this.ya.indexOf(t);
    if (-1 === i)
      throw new Error("source is not attached to scale");
    this.ya.splice(i, 1), 0 === this.ya.length && (this.Ea({ Fn: true }), this.Wa(null)), this.Vl(), this.io();
  }
  Tt() {
    let t = null;
    for (const i of this.ya) {
      const n = i.Tt();
      null !== n && ((null === t || n.yl < t.yl) && (t = n));
    }
    return null === t ? null : t.At;
  }
  Fa() {
    return this.un.invertScale;
  }
  Jl() {
    const t = null === this.Tt();
    if (null !== this.Ca && (t || this.Ca.so === t))
      return this.Ca.Jl;
    this.Oa.oa();
    const i = this.Oa.Jl();
    return this.Ca = { Jl: i, so: t }, this.Sa.m(), i;
  }
  eo() {
    return this.Sa;
  }
  ro(t) {
    this.th() || this.Na() || null === this.Ta && null === this.va && (this.Ni() || (this.Ta = this.fa - t, this.va = _(this.bh()).hh()));
  }
  ho(t) {
    if (this.th() || this.Na())
      return;
    if (null === this.Ta)
      return;
    this.Ea({ Fn: false }), (t = this.fa - t) < 0 && (t = 0);
    let i = (this.Ta + 0.2 * (this.fa - 1)) / (t + 0.2 * (this.fa - 1));
    const n = _(this.va).hh();
    i = Math.max(i, 0.1), n._h(i), this.Wa(n);
  }
  lo() {
    this.th() || this.Na() || (this.Ta = null, this.va = null);
  }
  ao(t) {
    this.Va() || null === this.Pa && null === this.va && (this.Ni() || (this.Pa = t, this.va = _(this.bh()).hh()));
  }
  oo(t) {
    if (this.Va())
      return;
    if (null === this.Pa)
      return;
    const i = _(this.bh()).oh() / (this.Ua() - 1);
    let n = t - this.Pa;
    this.Fa() && (n *= -1);
    const s = n * i, e2 = _(this.va).hh();
    e2.uh(s), this.Wa(e2, true), this.Ca = null;
  }
  _o() {
    this.Va() || null !== this.Pa && (this.Pa = null, this.va = null);
  }
  Bl() {
    return this.Al || this.Vl(), this.Al;
  }
  Fi(t, i) {
    switch (this.un.mode) {
      case 2:
        return this.Bl().format(Li(t, i));
      case 3:
        return this.Bl().format(Ei(t, i));
      default:
        return this.Sh(t);
    }
  }
  ca(t) {
    switch (this.un.mode) {
      case 2:
      case 3:
        return this.Bl().format(t);
      default:
        return this.Sh(t);
    }
  }
  _l(t) {
    return this.Sh(t, _(this.uo()).Bl());
  }
  ul(t, i) {
    return t = Li(t, i), Yi.format(t);
  }
  co() {
    return this.ya;
  }
  do(t) {
    this.ma = { ga: t, ba: false };
  }
  Dn() {
    this.ya.forEach((t) => t.Dn());
  }
  Vl() {
    this.Ca = null;
    const t = this.uo();
    let i = 100;
    null !== t && (i = Math.round(1 / t.Dl())), this.Al = Xi, this.th() ? (this.Al = Yi, i = 100) : this.Na() ? (this.Al = new lt(100, 1), i = 100) : null !== t && (this.Al = t.Bl()), this.Oa = new Hi(this, i, this.La.bind(this), this.Ia.bind(this)), this.Oa.oa();
  }
  io() {
    this.ka = null;
  }
  uo() {
    return this.ya[0] || null;
  }
  qa() {
    return this.Fa() ? this.un.scaleMargins.bottom * this.It() + this.Ma : this.un.scaleMargins.top * this.It() + this.wa;
  }
  Ya() {
    return this.Fa() ? this.un.scaleMargins.top * this.It() + this.wa : this.un.scaleMargins.bottom * this.It() + this.Ma;
  }
  Xa() {
    this.ma.ba || (this.ma.ba = true, this.fo());
  }
  za() {
    this.pa = null;
  }
  Ia(t, i) {
    if (this.Xa(), this.Ni())
      return 0;
    t = this.da() && t ? Vi(t, this.Ra) : t;
    const n = _(this.bh()), s = this.Ya() + (this.Ua() - 1) * (t - n.lh()) / n.oh();
    return this.Za(s);
  }
  La(t, i) {
    if (this.Xa(), this.Ni())
      return 0;
    const n = this.Za(t), s = _(this.bh()), e2 = s.lh() + s.oh() * ((n - this.Ya()) / (this.Ua() - 1));
    return this.da() ? Ni(e2, this.Ra) : e2;
  }
  ja() {
    this.Ca = null, this.Oa.oa();
  }
  fo() {
    const t = this.ma.ga;
    if (null === t)
      return;
    let i = null;
    const n = this.co();
    let s = 0, e2 = 0;
    for (const r3 of n) {
      if (!r3.Ct())
        continue;
      const n2 = r3.Tt();
      if (null === n2)
        continue;
      const h4 = r3.Pl(t.Ms(), t.ci());
      let l2 = h4 && h4.bh();
      if (null !== l2) {
        switch (this.un.mode) {
          case 1:
            l2 = Fi(l2, this.Ra);
            break;
          case 2:
            l2 = Ii(l2, n2.At);
            break;
          case 3:
            l2 = zi(l2, n2.At);
        }
        if (i = null === i ? l2 : i.Qn(_(l2)), null !== h4) {
          const t2 = h4.gh();
          null !== t2 && (s = Math.max(s, t2.above), e2 = Math.max(s, t2.below));
        }
      }
    }
    if (s === this.wa && e2 === this.Ma || (this.wa = s, this.Ma = e2, this.Ca = null, this.za()), null !== i) {
      if (i.lh() === i.ah()) {
        const t2 = this.uo(), n2 = 5 * (null === t2 || this.th() || this.Na() ? 1 : t2.Dl());
        this.da() && (i = Wi(i, this.Ra)), i = new vi(i.lh() - n2, i.ah() + n2), this.da() && (i = Fi(i, this.Ra));
      }
      if (this.da()) {
        const t2 = Wi(i, this.Ra), n2 = ji(t2);
        if (r2 = n2, h3 = this.Ra, r2.Ql !== h3.Ql || r2.ta !== h3.ta) {
          const s2 = null !== this.va ? Wi(this.va, this.Ra) : null;
          this.Ra = n2, i = Fi(t2, n2), null !== s2 && (this.va = Fi(s2, n2));
        }
      }
      this.Wa(i);
    } else
      null === this.ph && (this.Wa(new vi(-0.5, 0.5)), this.Ra = ji(null));
    var r2, h3;
    this.ma.ba = true;
  }
  Ka() {
    return this.th() ? Li : this.Na() ? Ei : this.da() ? (t) => Vi(t, this.Ra) : null;
  }
  Sh(t, i) {
    return void 0 === this.Aa.priceFormatter ? (void 0 === i && (i = this.Bl()), i.format(t)) : this.Aa.priceFormatter(t);
  }
}
class Ki {
  constructor(t, i) {
    this.ya = [], this.po = /* @__PURE__ */ new Map(), this.fa = 0, this.vo = 0, this.mo = 1e3, this.ka = null, this.bo = new M(), this.wo = t, this.Hi = i, this.Mo = new Ai(this);
    const n = i.F();
    this.So = this.xo("left", n.leftPriceScale), this.yo = this.xo("right", n.rightPriceScale), this.So.$a().l(this.ko.bind(this, this.So), this), this.yo.$a().l(this.ko.bind(this, this.yo), this), this.Co(n);
  }
  Co(t) {
    if (t.leftPriceScale && this.So.kh(t.leftPriceScale), t.rightPriceScale && this.yo.kh(t.rightPriceScale), t.localization && (this.So.Vl(), this.yo.Vl()), t.overlayPriceScales) {
      const i = Array.from(this.po.values());
      for (const n of i) {
        const i2 = _(n[0].Bt());
        i2.kh(t.overlayPriceScales), t.localization && i2.Vl();
      }
    }
  }
  To(t) {
    switch (t) {
      case "left":
        return this.So;
      case "right":
        return this.yo;
    }
    return this.po.has(t) ? o(this.po.get(t))[0].Bt() : null;
  }
  M() {
    this.Ut().Po().v(this), this.So.$a().v(this), this.yo.$a().v(this), this.ya.forEach((t) => {
      t.M && t.M();
    }), this.bo.m();
  }
  Ro() {
    return this.mo;
  }
  Do(t) {
    this.mo = t;
  }
  Ut() {
    return this.Hi;
  }
  $i() {
    return this.vo;
  }
  It() {
    return this.fa;
  }
  Bo(t) {
    this.vo = t, this.Ao();
  }
  Ha(t) {
    this.fa = t, this.So.Ha(t), this.yo.Ha(t), this.ya.forEach((i) => {
      if (this.Ge(i)) {
        const n = i.Bt();
        null !== n && n.Ha(t);
      }
    }), this.Ao();
  }
  jl() {
    return this.ya;
  }
  Ge(t) {
    const i = t.Bt();
    return null === i || this.So !== i && this.yo !== i;
  }
  Qa(t, i, n) {
    const s = void 0 !== n ? n : this.Lo().Oo + 1;
    this.Io(t, i, s);
  }
  no(t) {
    const i = this.ya.indexOf(t);
    a(-1 !== i, "removeDataSource: invalid data source"), this.ya.splice(i, 1);
    const n = _(t.Bt()).zl();
    if (this.po.has(n)) {
      const i2 = o(this.po.get(n)), s2 = i2.indexOf(t);
      -1 !== s2 && (i2.splice(s2, 1), 0 === i2.length && this.po.delete(n));
    }
    const s = t.Bt();
    s && s.jl().indexOf(t) >= 0 && s.no(t), null !== s && (s.io(), this.Eo(s)), this.ka = null;
  }
  Qe(t) {
    return t === this.So ? "left" : t === this.yo ? "right" : "overlay";
  }
  zo() {
    return this.So;
  }
  Vo() {
    return this.yo;
  }
  No(t, i) {
    t.ro(i);
  }
  Fo(t, i) {
    t.ho(i), this.Ao();
  }
  Wo(t) {
    t.lo();
  }
  jo(t, i) {
    t.ao(i);
  }
  $o(t, i) {
    t.oo(i), this.Ao();
  }
  Ho(t) {
    t._o();
  }
  Ao() {
    this.ya.forEach((t) => {
      t.Dn();
    });
  }
  fn() {
    let t = null;
    return this.Hi.F().rightPriceScale.visible && 0 !== this.yo.jl().length ? t = this.yo : this.Hi.F().leftPriceScale.visible && 0 !== this.So.jl().length ? t = this.So : 0 !== this.ya.length && (t = this.ya[0].Bt()), null === t && (t = this.yo), t;
  }
  Je() {
    let t = null;
    return this.Hi.F().rightPriceScale.visible ? t = this.yo : this.Hi.F().leftPriceScale.visible && (t = this.So), t;
  }
  Eo(t) {
    null !== t && t.Va() && this.Uo(t);
  }
  qo(t) {
    const i = this.wo.Vs();
    t.Ea({ Fn: true }), null !== i && t.do(i), this.Ao();
  }
  Yo() {
    this.Uo(this.So), this.Uo(this.yo);
  }
  Xo() {
    this.Eo(this.So), this.Eo(this.yo), this.ya.forEach((t) => {
      this.Ge(t) && this.Eo(t.Bt());
    }), this.Ao(), this.Hi.Ch();
  }
  Ja() {
    return null === this.ka && (this.ka = Ui(this.ya)), this.ka;
  }
  Zo() {
    return this.bo;
  }
  Ko() {
    return this.Mo;
  }
  Uo(t) {
    const i = t.co();
    if (i && i.length > 0 && !this.wo.Ni()) {
      const i2 = this.wo.Vs();
      null !== i2 && t.do(i2);
    }
    t.Dn();
  }
  Lo() {
    const t = this.Ja();
    if (0 === t.length)
      return { Go: 0, Oo: 0 };
    let i = 0, n = 0;
    for (let s = 0; s < t.length; s++) {
      const e2 = t[s].Zi();
      null !== e2 && (e2 < i && (i = e2), e2 > n && (n = e2));
    }
    return { Go: i, Oo: n };
  }
  Io(t, i, n) {
    let s = this.To(i);
    if (null === s && (s = this.xo(i, this.Hi.F().overlayPriceScales)), this.ya.push(t), !st(i)) {
      const n2 = this.po.get(i) || [];
      n2.push(t), this.po.set(i, n2);
    }
    s.Qa(t), t.Gi(s), t.Ki(n), this.Eo(s), this.ka = null;
  }
  ko(t, i, n) {
    i.lr !== n.lr && this.Uo(t);
  }
  xo(t, i) {
    const n = Object.assign({ visible: true, autoScale: true }, T(i)), s = new Zi(t, n, this.Hi.F().layout, this.Hi.F().localization);
    return s.Ha(this.It()), s;
  }
}
const Gi = (t) => t.getUTCFullYear(), Ji = (t) => ht(((t2) => t2.getUTCDate())(t), 2), Qi = (t, i) => new Date(t.getUTCFullYear(), t.getUTCMonth(), 1).toLocaleString(i, { month: "long" }), tn = (t, i) => new Date(t.getUTCFullYear(), t.getUTCMonth(), 1).toLocaleString(i, { month: "short" }), nn = (t) => ht(((t2) => t2.getUTCMonth() + 1)(t), 2), sn = (t) => ht(Gi(t) % 100, 2), en = (t) => ht(Gi(t), 4);
class rn {
  constructor(t = "yyyy-MM-dd", i = "default") {
    this.Jo = t, this.Qo = i;
  }
  t_(t) {
    return function(t2, i, n) {
      return i.replace(/yyyy/g, en(t2)).replace(/yy/g, sn(t2)).replace(/MMMM/g, Qi(t2, n)).replace(/MMM/g, tn(t2, n)).replace(/MM/g, nn(t2)).replace(/dd/g, Ji(t2));
    }(t, this.Jo, this.Qo);
  }
}
class hn {
  constructor(t) {
    this.i_ = t || "%h:%m:%s";
  }
  t_(t) {
    return this.i_.replace("%h", ht(t.getUTCHours(), 2)).replace("%m", ht(t.getUTCMinutes(), 2)).replace("%s", ht(t.getUTCSeconds(), 2));
  }
}
const ln = { n_: "yyyy-MM-dd", s_: "%h:%m:%s", e_: " ", r_: "default" };
class an {
  constructor(t = {}) {
    const i = Object.assign(Object.assign({}, ln), t);
    this.h_ = new rn(i.n_, i.r_), this.l_ = new hn(i.s_), this.a_ = i.e_;
  }
  t_(t) {
    return `${this.h_.t_(t)}${this.a_}${this.l_.t_(t)}`;
  }
}
class on {
  constructor(t, i = 50) {
    this.Le = 0, this.Ie = 1, this.Ee = 1, this.Ve = /* @__PURE__ */ new Map(), this.ze = /* @__PURE__ */ new Map(), this.o_ = t, this.Ne = i;
  }
  t_(t) {
    const i = t._t, n = void 0 === i.__ ? new Date(1e3 * i.u_).getTime() : new Date(Date.UTC(i.__.year, i.__.month - 1, i.__.day)).getTime(), s = this.Ve.get(n);
    if (void 0 !== s)
      return s.c_;
    if (this.Le === this.Ne) {
      const t2 = this.ze.get(this.Ee);
      this.ze.delete(this.Ee), this.Ve.delete(o(t2)), this.Ee++, this.Le--;
    }
    const e2 = this.o_(t);
    return this.Ve.set(n, { c_: e2, $e: this.Ie }), this.ze.set(this.Ie, n), this.Le++, this.Ie++, e2;
  }
}
class _n {
  constructor(t, i) {
    a(t <= i, "right should be >= left"), this.d_ = t, this.f_ = i;
  }
  Ms() {
    return this.d_;
  }
  ci() {
    return this.f_;
  }
  p_() {
    return this.f_ - this.d_ + 1;
  }
  Ir(t) {
    return this.d_ <= t && t <= this.f_;
  }
  rh(t) {
    return this.d_ === t.Ms() && this.f_ === t.ci();
  }
}
function un(t, i) {
  return null === t || null === i ? t === i : t.rh(i);
}
class cn {
  constructor() {
    this.v_ = /* @__PURE__ */ new Map(), this.Ve = null;
  }
  m_(t, i) {
    this.b_(i), this.Ve = null;
    for (let n = i; n < t.length; ++n) {
      const i2 = t[n];
      let s = this.v_.get(i2.g_);
      void 0 === s && (s = [], this.v_.set(i2.g_, s)), s.push({ Ys: n, _t: i2._t, w_: i2.g_, M_: i2.M_ });
    }
  }
  S_(t, i) {
    const n = Math.ceil(i / t);
    return null !== this.Ve && this.Ve.x_ === n || (this.Ve = { Jl: this.y_(n), x_: n }), this.Ve.Jl;
  }
  b_(t) {
    if (0 === t)
      return void this.v_.clear();
    const i = [];
    this.v_.forEach((n, s) => {
      t <= n[0].Ys ? i.push(s) : n.splice(Mt(n, t, (i2) => i2.Ys < t), 1 / 0);
    });
    for (const t2 of i)
      this.v_.delete(t2);
  }
  y_(t) {
    let i = [];
    for (const n of Array.from(this.v_.keys()).sort((t2, i2) => i2 - t2)) {
      if (!this.v_.get(n))
        continue;
      const s = i;
      i = [];
      const e2 = s.length;
      let r2 = 0;
      const h3 = o(this.v_.get(n)), l2 = h3.length;
      let a2 = 1 / 0, _2 = -1 / 0;
      for (let n2 = 0; n2 < l2; n2++) {
        const l3 = h3[n2], o2 = l3.Ys;
        for (; r2 < e2; ) {
          const t2 = s[r2], n3 = t2.Ys;
          if (!(n3 < o2)) {
            a2 = n3;
            break;
          }
          r2++, i.push(t2), _2 = n3, a2 = 1 / 0;
        }
        a2 - o2 >= t && o2 - _2 >= t && (i.push(l3), _2 = o2);
      }
      for (; r2 < e2; r2++)
        i.push(s[r2]);
    }
    return i;
  }
}
class dn {
  constructor(t) {
    this.k_ = t;
  }
  C_() {
    return null === this.k_ ? null : new _n(Math.floor(this.k_.Ms()), Math.ceil(this.k_.ci()));
  }
  T_() {
    return this.k_;
  }
  static P_() {
    return new dn(null);
  }
}
var fn, pn, vn, mn, bn;
!function(t) {
  t[t.Year = 0] = "Year", t[t.Month = 1] = "Month", t[t.DayOfMonth = 2] = "DayOfMonth", t[t.Time = 3] = "Time", t[t.TimeWithSeconds = 4] = "TimeWithSeconds";
}(fn || (fn = {}));
class gn {
  constructor(t, i, n) {
    this.vo = 0, this.R_ = null, this.D_ = [], this.Pa = null, this.Ta = null, this.B_ = new cn(), this.A_ = /* @__PURE__ */ new Map(), this.O_ = dn.P_(), this.L_ = true, this.I_ = new M(), this.E_ = new M(), this.z_ = new M(), this.V_ = null, this.N_ = null, this.F_ = [], this.un = i, this.Aa = n, this.W_ = i.rightOffset, this.j_ = i.barSpacing, this.Hi = t, this.H_();
  }
  F() {
    return this.un;
  }
  U_(t) {
    S(this.Aa, t), this.q_(), this.H_();
  }
  kh(t, i) {
    var n;
    S(this.un, t), this.un.fixLeftEdge && this.Y_(), this.un.fixRightEdge && this.X_(), void 0 !== t.barSpacing && this.Hi.Kn(t.barSpacing), void 0 !== t.rightOffset && this.Hi.Gn(t.rightOffset), void 0 !== t.minBarSpacing && this.Hi.Kn(null !== (n = t.barSpacing) && void 0 !== n ? n : this.j_), this.q_(), this.H_(), this.z_.m();
  }
  vn(t) {
    var i, n;
    return null !== (n = null === (i = this.D_[t]) || void 0 === i ? void 0 : i._t) && void 0 !== n ? n : null;
  }
  Ui(t) {
    var i;
    return null !== (i = this.D_[t]) && void 0 !== i ? i : null;
  }
  Fl(t, i) {
    if (this.D_.length < 1)
      return null;
    if (t.u_ > this.D_[this.D_.length - 1]._t.u_)
      return i ? this.D_.length - 1 : null;
    const n = Mt(this.D_, t.u_, (t2, i2) => t2._t.u_ < i2);
    return t.u_ < this.D_[n]._t.u_ ? i ? n : null : n;
  }
  Ni() {
    return 0 === this.vo || 0 === this.D_.length || null === this.R_;
  }
  Nl() {
    return this.D_.length > 0;
  }
  Vs() {
    return this.Z_(), this.O_.C_();
  }
  K_() {
    return this.Z_(), this.O_.T_();
  }
  G_() {
    const t = this.Vs();
    if (null === t)
      return null;
    const i = { from: t.Ms(), to: t.ci() };
    return this.J_(i);
  }
  J_(t) {
    const i = Math.round(t.from), n = Math.round(t.to), s = _(this.Q_()), e2 = _(this.tu());
    return { from: _(this.vn(Math.max(s, i))), to: _(this.vn(Math.min(e2, n))) };
  }
  iu(t) {
    return { from: _(this.Fl(t.from, true)), to: _(this.Fl(t.to, true)) };
  }
  $i() {
    return this.vo;
  }
  Bo(t) {
    if (!isFinite(t) || t <= 0)
      return;
    if (this.vo === t)
      return;
    const i = this.K_(), n = this.vo;
    if (this.vo = t, this.L_ = true, this.un.lockVisibleTimeRangeOnResize && 0 !== n) {
      const i2 = this.j_ * t / n;
      this.j_ = i2;
    }
    if (this.un.fixLeftEdge && null !== i && i.Ms() <= 0) {
      const i2 = n - t;
      this.W_ -= Math.round(i2 / this.j_) + 1, this.L_ = true;
    }
    this.nu(), this.su();
  }
  Et(t) {
    if (this.Ni() || !y(t))
      return 0;
    const i = this.eu() + this.W_ - t;
    return this.vo - (i + 0.5) * this.j_ - 1;
  }
  js(t, i) {
    const n = this.eu(), s = void 0 === i ? 0 : i.from, e2 = void 0 === i ? t.length : i.to;
    for (let i2 = s; i2 < e2; i2++) {
      const s2 = t[i2]._t, e3 = n + this.W_ - s2, r2 = this.vo - (e3 + 0.5) * this.j_ - 1;
      t[i2].st = r2;
    }
  }
  ru(t) {
    return Math.ceil(this.hu(t));
  }
  Gn(t) {
    this.L_ = true, this.W_ = t, this.su(), this.Hi.lu(), this.Hi.Ch();
  }
  Ks() {
    return this.j_;
  }
  Kn(t) {
    this.au(t), this.su(), this.Hi.lu(), this.Hi.Ch();
  }
  ou() {
    return this.W_;
  }
  Jl() {
    if (this.Ni())
      return null;
    if (null !== this.N_)
      return this.N_;
    const t = this.j_, i = 5 * (this.Hi.F().layout.fontSize + 4), n = Math.round(i / t), s = _(this.Vs()), e2 = Math.max(s.Ms(), s.Ms() - n), r2 = Math.max(s.ci(), s.ci() - n), h3 = this.B_.S_(t, i), l2 = this.Q_() + n, a2 = this.tu() - n, o2 = this._u(), u2 = this.un.fixLeftEdge || o2, c2 = this.un.fixRightEdge || o2;
    let d2 = 0;
    for (const t2 of h3) {
      if (!(e2 <= t2.Ys && t2.Ys <= r2))
        continue;
      let n2;
      d2 < this.F_.length ? (n2 = this.F_[d2], n2.Yl = this.Et(t2.Ys), n2.ua = this.uu(t2), n2.w_ = t2.w_) : (n2 = { cu: false, Yl: this.Et(t2.Ys), ua: this.uu(t2), w_: t2.w_ }, this.F_.push(n2)), this.j_ > i / 2 && !o2 ? n2.cu = false : n2.cu = u2 && t2.Ys <= l2 || c2 && t2.Ys >= a2, d2++;
    }
    return this.F_.length = d2, this.N_ = this.F_, this.F_;
  }
  du() {
    this.L_ = true, this.Kn(this.un.barSpacing), this.Gn(this.un.rightOffset);
  }
  fu(t) {
    this.L_ = true, this.R_ = t, this.su(), this.Y_();
  }
  pu(t, i) {
    const n = this.hu(t), s = this.Ks(), e2 = s + i * (s / 10);
    this.Kn(e2), this.un.rightBarStaysOnScroll || this.Gn(this.ou() + (n - this.hu(t)));
  }
  ro(t) {
    this.Pa && this._o(), null === this.Ta && null === this.V_ && (this.Ni() || (this.Ta = t, this.vu()));
  }
  ho(t) {
    if (null === this.V_)
      return;
    const i = At(this.vo - t, 0, this.vo), n = At(this.vo - _(this.Ta), 0, this.vo);
    0 !== i && 0 !== n && this.Kn(this.V_.Ks * i / n);
  }
  lo() {
    null !== this.Ta && (this.Ta = null, this.mu());
  }
  ao(t) {
    null === this.Pa && null === this.V_ && (this.Ni() || (this.Pa = t, this.vu()));
  }
  oo(t) {
    if (null === this.Pa)
      return;
    const i = (this.Pa - t) / this.Ks();
    this.W_ = _(this.V_).ou + i, this.L_ = true, this.su();
  }
  _o() {
    null !== this.Pa && (this.Pa = null, this.mu());
  }
  bu() {
    this.gu(this.un.rightOffset);
  }
  gu(t, i = 400) {
    if (!isFinite(t))
      throw new RangeError("offset is required and must be finite number");
    if (!isFinite(i) || i <= 0)
      throw new RangeError("animationDuration (optional) must be finite positive number");
    const n = this.W_, s = performance.now();
    this.Hi.Yn({ wu: (t2) => (t2 - s) / i >= 1, Mu: (e2) => {
      const r2 = (e2 - s) / i;
      return r2 >= 1 ? t : n + (t - n) * r2;
    } });
  }
  gt(t, i) {
    this.L_ = true, this.D_ = t, this.B_.m_(t, i), this.su();
  }
  Su() {
    return this.I_;
  }
  xu() {
    return this.E_;
  }
  yu() {
    return this.z_;
  }
  eu() {
    return this.R_ || 0;
  }
  ku(t) {
    const i = t.p_();
    this.au(this.vo / i), this.W_ = t.ci() - this.eu(), this.su(), this.L_ = true, this.Hi.lu(), this.Hi.Ch();
  }
  Cu() {
    const t = this.Q_(), i = this.tu();
    null !== t && null !== i && this.ku(new _n(t, i + this.un.rightOffset));
  }
  Tu(t) {
    const i = new _n(t.from, t.to);
    this.ku(i);
  }
  qi(t) {
    return void 0 !== this.Aa.timeFormatter ? this.Aa.timeFormatter(t.M_) : this.Pu.t_(new Date(1e3 * t._t.u_));
  }
  _u() {
    const { handleScroll: t, handleScale: i } = this.Hi.F();
    return !(t.horzTouchDrag || t.mouseWheel || t.pressedMouseMove || t.vertTouchDrag || i.axisDoubleClickReset.time || i.axisPressedMouseMove.time || i.mouseWheel || i.pinch);
  }
  Q_() {
    return 0 === this.D_.length ? null : 0;
  }
  tu() {
    return 0 === this.D_.length ? null : this.D_.length - 1;
  }
  Ru(t) {
    return (this.vo - 1 - t) / this.j_;
  }
  hu(t) {
    const i = this.Ru(t), n = this.eu() + this.W_ - i;
    return Math.round(1e6 * n) / 1e6;
  }
  au(t) {
    const i = this.j_;
    this.j_ = t, this.nu(), i !== this.j_ && (this.L_ = true, this.Du());
  }
  Z_() {
    if (!this.L_)
      return;
    if (this.L_ = false, this.Ni())
      return void this.Bu(dn.P_());
    const t = this.eu(), i = this.vo / this.j_, n = this.W_ + t, s = new _n(n - i + 1, n);
    this.Bu(new dn(s));
  }
  nu() {
    const t = this.Au();
    if (this.j_ < t && (this.j_ = t, this.L_ = true), 0 !== this.vo) {
      const t2 = 0.5 * this.vo;
      this.j_ > t2 && (this.j_ = t2, this.L_ = true);
    }
  }
  Au() {
    return this.un.fixLeftEdge && this.un.fixRightEdge && 0 !== this.D_.length ? this.vo / this.D_.length : this.un.minBarSpacing;
  }
  su() {
    const t = this.Ou();
    this.W_ > t && (this.W_ = t, this.L_ = true);
    const i = this.Lu();
    null !== i && this.W_ < i && (this.W_ = i, this.L_ = true);
  }
  Lu() {
    const t = this.Q_(), i = this.R_;
    if (null === t || null === i)
      return null;
    return t - i - 1 + (this.un.fixLeftEdge ? this.vo / this.j_ : Math.min(2, this.D_.length));
  }
  Ou() {
    return this.un.fixRightEdge ? 0 : this.vo / this.j_ - Math.min(2, this.D_.length);
  }
  vu() {
    this.V_ = { Ks: this.Ks(), ou: this.ou() };
  }
  mu() {
    this.V_ = null;
  }
  uu(t) {
    let i = this.A_.get(t.w_);
    return void 0 === i && (i = new on((t2) => this.Iu(t2)), this.A_.set(t.w_, i)), i.t_(t);
  }
  Iu(t) {
    const i = function(t2, i2, n) {
      switch (t2) {
        case 0:
        case 10:
          return i2 ? n ? 4 : 3 : 2;
        case 20:
        case 21:
        case 22:
        case 30:
        case 31:
        case 32:
        case 33:
          return i2 ? 3 : 2;
        case 50:
          return 2;
        case 60:
          return 1;
        case 70:
          return 0;
      }
    }(t.w_, this.un.timeVisible, this.un.secondsVisible);
    if (void 0 !== this.un.tickMarkFormatter) {
      const n = this.un.tickMarkFormatter(t.M_, i, this.Aa.locale);
      if (null !== n)
        return n;
    }
    return function(t2, i2, n) {
      const s = {};
      switch (i2) {
        case 0:
          s.year = "numeric";
          break;
        case 1:
          s.month = "short";
          break;
        case 2:
          s.day = "numeric";
          break;
        case 3:
          s.hour12 = false, s.hour = "2-digit", s.minute = "2-digit";
          break;
        case 4:
          s.hour12 = false, s.hour = "2-digit", s.minute = "2-digit", s.second = "2-digit";
      }
      const e2 = void 0 === t2.__ ? new Date(1e3 * t2.u_) : new Date(Date.UTC(t2.__.year, t2.__.month - 1, t2.__.day));
      return new Date(e2.getUTCFullYear(), e2.getUTCMonth(), e2.getUTCDate(), e2.getUTCHours(), e2.getUTCMinutes(), e2.getUTCSeconds(), e2.getUTCMilliseconds()).toLocaleString(n, s);
    }(t._t, i, this.Aa.locale);
  }
  Bu(t) {
    const i = this.O_;
    this.O_ = t, un(i.C_(), this.O_.C_()) || this.I_.m(), un(i.T_(), this.O_.T_()) || this.E_.m(), this.Du();
  }
  Du() {
    this.N_ = null;
  }
  q_() {
    this.Du(), this.A_.clear();
  }
  H_() {
    const t = this.Aa.dateFormat;
    this.un.timeVisible ? this.Pu = new an({ n_: t, s_: this.un.secondsVisible ? "%h:%m:%s" : "%h:%m", e_: "   ", r_: this.Aa.locale }) : this.Pu = new rn(t, this.Aa.locale);
  }
  Y_() {
    if (!this.un.fixLeftEdge)
      return;
    const t = this.Q_();
    if (null === t)
      return;
    const i = this.Vs();
    if (null === i)
      return;
    const n = i.Ms() - t;
    if (n < 0) {
      const t2 = this.W_ - n - 1;
      this.Gn(t2);
    }
    this.nu();
  }
  X_() {
    this.su(), this.nu();
  }
}
class wn extends L {
  constructor(t) {
    super(), this.Eu = /* @__PURE__ */ new Map(), this.zt = t;
  }
  Z(t) {
  }
  G(t) {
    if (!this.zt.Ct)
      return;
    const { context: i, mediaSize: n } = t;
    let s = 0;
    for (const t2 of this.zt.zu) {
      if (0 === t2.Gt.length)
        continue;
      i.font = t2.P;
      const e3 = this.Vu(i, t2.Gt);
      e3 > n.width ? t2.pu = n.width / e3 : t2.pu = 1, s += t2.Nu * t2.pu;
    }
    let e2 = 0;
    switch (this.zt.Fu) {
      case "top":
        e2 = 0;
        break;
      case "center":
        e2 = Math.max((n.height - s) / 2, 0);
        break;
      case "bottom":
        e2 = Math.max(n.height - s, 0);
    }
    i.fillStyle = this.zt.D;
    for (const t2 of this.zt.zu) {
      i.save();
      let s2 = 0;
      switch (this.zt.Wu) {
        case "left":
          i.textAlign = "left", s2 = t2.Nu / 2;
          break;
        case "center":
          i.textAlign = "center", s2 = n.width / 2;
          break;
        case "right":
          i.textAlign = "right", s2 = n.width - 1 - t2.Nu / 2;
      }
      i.translate(s2, e2), i.textBaseline = "top", i.font = t2.P, i.scale(t2.pu, t2.pu), i.fillText(t2.Gt, 0, t2.ju), i.restore(), e2 += t2.Nu * t2.pu;
    }
  }
  Vu(t, i) {
    const n = this.$u(t.font);
    let s = n.get(i);
    return void 0 === s && (s = t.measureText(i).width, n.set(i, s)), s;
  }
  $u(t) {
    let i = this.Eu.get(t);
    return void 0 === i && (i = /* @__PURE__ */ new Map(), this.Eu.set(t, i)), i;
  }
}
class Mn {
  constructor(t) {
    this.vt = true, this.Wt = { Ct: false, D: "", zu: [], Fu: "center", Wu: "center" }, this.jt = new wn(this.Wt), this.$t = t;
  }
  gt() {
    this.vt = true;
  }
  Mt() {
    return this.vt && (this.St(), this.vt = false), this.jt;
  }
  St() {
    const t = this.$t.F(), i = this.Wt;
    i.Ct = t.visible, i.Ct && (i.D = t.color, i.Wu = t.horzAlign, i.Fu = t.vertAlign, i.zu = [{ Gt: t.text, P: B(t.fontSize, t.fontFamily, t.fontStyle), Nu: 1.2 * t.fontSize, ju: 0, pu: 0 }]);
  }
}
class Sn extends tt {
  constructor(t, i) {
    super(), this.un = i, this.bn = new Mn(this);
  }
  Pn() {
    return [];
  }
  Tn() {
    return [this.bn];
  }
  F() {
    return this.un;
  }
  Dn() {
    this.bn.gt();
  }
}
!function(t) {
  t[t.OnTouchEnd = 0] = "OnTouchEnd", t[t.OnNextTap = 1] = "OnNextTap";
}(pn || (pn = {}));
class xn {
  constructor(t, i) {
    this.Hu = [], this.Uu = [], this.vo = 0, this.qu = null, this.Yu = new M(), this.Xu = new M(), this.Zu = null, this.Ku = t, this.un = i, this.Gu = new A(this), this.wo = new gn(this, i.timeScale, this.un.localization), this.bt = new nt(this, i.crosshair), this.Ju = new Ri(i.crosshair), this.Qu = new Sn(this, i.watermark), this.tc(), this.Hu[0].Do(2e3), this.ic = this.nc(0), this.sc = this.nc(1);
  }
  dl() {
    this.ec(et.ss());
  }
  Ch() {
    this.ec(et.ns());
  }
  Cl() {
    this.ec(new et(1));
  }
  fl(t) {
    const i = this.rc(t);
    this.ec(i);
  }
  hc() {
    return this.qu;
  }
  lc(t) {
    const i = this.qu;
    this.qu = t, null !== i && this.fl(i.ac), null !== t && this.fl(t.ac);
  }
  F() {
    return this.un;
  }
  kh(t) {
    S(this.un, t), this.Hu.forEach((i) => i.Co(t)), void 0 !== t.timeScale && this.wo.kh(t.timeScale), void 0 !== t.localization && this.wo.U_(t.localization), (t.leftPriceScale || t.rightPriceScale) && this.Yu.m(), this.ic = this.nc(0), this.sc = this.nc(1), this.dl();
  }
  oc(t, i) {
    if ("left" === t)
      return void this.kh({ leftPriceScale: i });
    if ("right" === t)
      return void this.kh({ rightPriceScale: i });
    const n = this._c(t);
    null !== n && (n.Bt.kh(i), this.Yu.m());
  }
  _c(t) {
    for (const i of this.Hu) {
      const n = i.To(t);
      if (null !== n)
        return { Ht: i, Bt: n };
    }
    return null;
  }
  yt() {
    return this.wo;
  }
  uc() {
    return this.Hu;
  }
  cc() {
    return this.Qu;
  }
  dc() {
    return this.bt;
  }
  fc() {
    return this.Xu;
  }
  vc(t, i) {
    t.Ha(i), this.lu();
  }
  Bo(t) {
    this.vo = t, this.wo.Bo(this.vo), this.Hu.forEach((i) => i.Bo(t)), this.lu();
  }
  tc(t) {
    const i = new Ki(this.wo, this);
    void 0 !== t ? this.Hu.splice(t, 0, i) : this.Hu.push(i);
    const n = void 0 === t ? this.Hu.length - 1 : t, s = et.ss();
    return s.Vn(n, { Nn: 0, Fn: true }), this.ec(s), i;
  }
  No(t, i, n) {
    t.No(i, n);
  }
  Fo(t, i, n) {
    t.Fo(i, n), this.pl(), this.ec(this.mc(t, 2));
  }
  Wo(t, i) {
    t.Wo(i), this.ec(this.mc(t, 2));
  }
  jo(t, i, n) {
    i.Va() || t.jo(i, n);
  }
  $o(t, i, n) {
    i.Va() || (t.$o(i, n), this.pl(), this.ec(this.mc(t, 2)));
  }
  Ho(t, i) {
    i.Va() || (t.Ho(i), this.ec(this.mc(t, 2)));
  }
  qo(t, i) {
    t.qo(i), this.ec(this.mc(t, 2));
  }
  bc(t) {
    this.wo.ro(t);
  }
  gc(t, i) {
    const n = this.yt();
    if (n.Ni() || 0 === i)
      return;
    const s = n.$i();
    t = Math.max(1, Math.min(t, s)), n.pu(t, i), this.lu();
  }
  wc(t) {
    this.Mc(0), this.Sc(t), this.xc();
  }
  yc(t) {
    this.wo.ho(t), this.lu();
  }
  kc() {
    this.wo.lo(), this.Ch();
  }
  Mc(t) {
    this.wo.ao(t);
  }
  Sc(t) {
    this.wo.oo(t), this.lu();
  }
  xc() {
    this.wo._o(), this.Ch();
  }
  wt() {
    return this.Uu;
  }
  Cc(t, i, n, s) {
    this.bt.gn(t, i);
    let e2 = NaN, r2 = this.wo.ru(t);
    const h3 = this.wo.Vs();
    null !== h3 && (r2 = Math.min(Math.max(h3.Ms(), r2), h3.ci()));
    const l2 = s.fn(), a2 = l2.Tt();
    null !== a2 && (e2 = l2.pn(i, a2)), e2 = this.Ju.Wl(e2, r2, s), this.bt.xn(r2, e2, s), this.Cl(), this.Xu.m(this.bt.xt(), { x: t, y: i }, n);
  }
  Tc() {
    this.dc().kn(), this.Cl(), this.Xu.m(null, null, null);
  }
  pl() {
    const t = this.bt.Ht();
    if (null !== t) {
      const i = this.bt.Mn(), n = this.bt.Sn();
      this.Cc(i, n, null, t);
    }
    this.bt.Dn();
  }
  Pc(t, i, n) {
    const s = this.wo.vn(0);
    void 0 !== i && void 0 !== n && this.wo.gt(i, n);
    const e2 = this.wo.vn(0), r2 = this.wo.eu(), h3 = this.wo.Vs();
    if (null !== h3 && null !== s && null !== e2) {
      const i2 = h3.Ir(r2), n2 = s.u_ > e2.u_, l2 = null !== t && t > r2 && !n2, a2 = i2 && this.wo.F().shiftVisibleRangeOnNewBar;
      if (l2 && !a2) {
        const i3 = t - r2;
        this.wo.Gn(this.wo.ou() - i3);
      }
    }
    this.wo.fu(t);
  }
  bl(t) {
    null !== t && t.Xo();
  }
  Ke(t) {
    const i = this.Hu.find((i2) => i2.Ja().includes(t));
    return void 0 === i ? null : i;
  }
  lu() {
    this.Qu.Dn(), this.Hu.forEach((t) => t.Xo()), this.pl();
  }
  M() {
    this.Hu.forEach((t) => t.M()), this.Hu.length = 0, this.un.localization.priceFormatter = void 0, this.un.localization.timeFormatter = void 0;
  }
  Rc() {
    return this.Gu;
  }
  tr() {
    return this.Gu.F();
  }
  Po() {
    return this.Yu;
  }
  Dc(t, i) {
    const n = this.Hu[0], s = this.Bc(i, t, n);
    return this.Uu.push(s), 1 === this.Uu.length ? this.dl() : this.Ch(), s;
  }
  Ac(t) {
    const i = this.Ke(t), n = this.Uu.indexOf(t);
    a(-1 !== n, "Series not found"), this.Uu.splice(n, 1), _(i).no(t), t.M && t.M();
  }
  cl(t, i) {
    const n = _(this.Ke(t));
    n.no(t);
    const s = this._c(i);
    if (null === s) {
      const s2 = t.Zi();
      n.Qa(t, i, s2);
    } else {
      const e2 = s.Ht === n ? t.Zi() : void 0;
      s.Ht.Qa(t, i, e2);
    }
  }
  Cu() {
    const t = et.ns();
    t.$n(), this.ec(t);
  }
  Oc(t) {
    const i = et.ns();
    i.qn(t), this.ec(i);
  }
  Zn() {
    const t = et.ns();
    t.Zn(), this.ec(t);
  }
  Kn(t) {
    const i = et.ns();
    i.Kn(t), this.ec(i);
  }
  Gn(t) {
    const i = et.ns();
    i.Gn(t), this.ec(i);
  }
  Yn(t) {
    const i = et.ns();
    i.Yn(t), this.ec(i);
  }
  Hn() {
    const t = et.ns();
    t.Hn(), this.ec(t);
  }
  Lc() {
    return this.un.rightPriceScale.visible ? "right" : "left";
  }
  Ic() {
    return this.sc;
  }
  U() {
    return this.ic;
  }
  Lt(t) {
    const i = this.sc, n = this.ic;
    if (i === n)
      return i;
    if (t = Math.max(0, Math.min(100, Math.round(100 * t))), null === this.Zu || this.Zu.bs !== n || this.Zu.gs !== i)
      this.Zu = { bs: n, gs: i, Ec: /* @__PURE__ */ new Map() };
    else {
      const i2 = this.Zu.Ec.get(t);
      if (void 0 !== i2)
        return i2;
    }
    const s = function(t2, i2, n2) {
      const [s2, e2, r2, h3] = g(t2), [l2, a2, o2, _2] = g(i2), u2 = [d(s2 + n2 * (l2 - s2)), d(e2 + n2 * (a2 - e2)), d(r2 + n2 * (o2 - r2)), f(h3 + n2 * (_2 - h3))];
      return `rgba(${u2[0]}, ${u2[1]}, ${u2[2]}, ${u2[3]})`;
    }(n, i, t / 100);
    return this.Zu.Ec.set(t, s), s;
  }
  mc(t, i) {
    const n = new et(i);
    if (null !== t) {
      const s = this.Hu.indexOf(t);
      n.Vn(s, { Nn: i });
    }
    return n;
  }
  rc(t, i) {
    return void 0 === i && (i = 2), this.mc(this.Ke(t), i);
  }
  ec(t) {
    this.Ku && this.Ku(t), this.Hu.forEach((t2) => t2.Ko().Th().gt());
  }
  Bc(t, i, n) {
    const s = new Pi(this, t, i), e2 = void 0 !== t.priceScaleId ? t.priceScaleId : this.Lc();
    return n.Qa(s, e2), st(e2) || s.kh(t), s;
  }
  nc(t) {
    const i = this.un.layout;
    return "gradient" === i.background.type ? 0 === t ? i.background.topColor : i.background.bottomColor : i.background.color;
  }
}
function yn(t) {
  return !x(t) && !k(t);
}
function kn(t) {
  return x(t);
}
!function(t) {
  t[t.Disabled = 0] = "Disabled", t[t.Continuous = 1] = "Continuous", t[t.OnDataUpdate = 2] = "OnDataUpdate";
}(vn || (vn = {})), function(t) {
  t[t.LastBar = 0] = "LastBar", t[t.LastVisible = 1] = "LastVisible";
}(mn || (mn = {})), function(t) {
  t.Solid = "solid", t.VerticalGradient = "gradient";
}(bn || (bn = {}));
const Cn = "undefined" != typeof window;
function Tn() {
  return !!Cn && window.navigator.userAgent.toLowerCase().indexOf("firefox") > -1;
}
function Pn() {
  return !!Cn && /iPhone|iPad|iPod/.test(window.navigator.platform);
}
function Rn(t) {
  return t + t % 2;
}
function Dn(t, i) {
  return t.zc - i.zc;
}
function Bn(t, i, n) {
  const s = (t.zc - i.zc) / (t._t - i._t);
  return Math.sign(s) * Math.min(Math.abs(s), n);
}
class An {
  constructor(t, i, n, s) {
    this.Vc = null, this.Nc = null, this.Fc = null, this.Wc = null, this.jc = null, this.$c = 0, this.Hc = 0, this.Uc = t, this.qc = i, this.Yc = n, this.es = s;
  }
  Xc(t, i) {
    if (null !== this.Vc) {
      if (this.Vc._t === i)
        return void (this.Vc.zc = t);
      if (Math.abs(this.Vc.zc - t) < this.es)
        return;
    }
    this.Wc = this.Fc, this.Fc = this.Nc, this.Nc = this.Vc, this.Vc = { _t: i, zc: t };
  }
  pr(t, i) {
    if (null === this.Vc || null === this.Nc)
      return;
    if (i - this.Vc._t > 50)
      return;
    let n = 0;
    const s = Bn(this.Vc, this.Nc, this.qc), e2 = Dn(this.Vc, this.Nc), r2 = [s], h3 = [e2];
    if (n += e2, null !== this.Fc) {
      const t2 = Bn(this.Nc, this.Fc, this.qc);
      if (Math.sign(t2) === Math.sign(s)) {
        const i2 = Dn(this.Nc, this.Fc);
        if (r2.push(t2), h3.push(i2), n += i2, null !== this.Wc) {
          const t3 = Bn(this.Fc, this.Wc, this.qc);
          if (Math.sign(t3) === Math.sign(s)) {
            const i3 = Dn(this.Fc, this.Wc);
            r2.push(t3), h3.push(i3), n += i3;
          }
        }
      }
    }
    let l2 = 0;
    for (let t2 = 0; t2 < r2.length; ++t2)
      l2 += h3[t2] / n * r2[t2];
    Math.abs(l2) < this.Uc || (this.jc = { zc: t, _t: i }, this.Hc = l2, this.$c = function(t2, i2) {
      const n2 = Math.log(i2);
      return Math.log(1 * n2 / -t2) / n2;
    }(Math.abs(l2), this.Yc));
  }
  Mu(t) {
    const i = _(this.jc), n = t - i._t;
    return i.zc + this.Hc * (Math.pow(this.Yc, n) - 1) / Math.log(this.Yc);
  }
  wu(t) {
    return null === this.jc || this.Zc(t) === this.$c;
  }
  Zc(t) {
    const i = t - _(this.jc)._t;
    return Math.min(i, this.$c);
  }
}
function On(t, n) {
  const s = _(t.ownerDocument).createElement("canvas");
  t.appendChild(s);
  const e2 = bindTo(s, { type: "device-pixel-content-box", options: { allowResizeObserver: false }, transform: (t2, i) => ({ width: Math.max(t2.width, i.width), height: Math.max(t2.height, i.height) }) });
  return e2.resizeCanvasElement(n), e2;
}
function Ln(t) {
  Cn && void 0 !== window.chrome && t.addEventListener("mousedown", (t2) => {
    if (1 === t2.button)
      return t2.preventDefault(), false;
  });
}
class In {
  constructor(t, i, n) {
    this.Kc = 0, this.Gc = null, this.Jc = { st: Number.NEGATIVE_INFINITY, et: Number.POSITIVE_INFINITY }, this.Qc = 0, this.td = null, this.nd = { st: Number.NEGATIVE_INFINITY, et: Number.POSITIVE_INFINITY }, this.sd = null, this.ed = false, this.rd = null, this.hd = null, this.ld = false, this.ad = false, this.od = false, this._d = null, this.ud = null, this.dd = null, this.fd = null, this.pd = null, this.vd = null, this.md = null, this.bd = 0, this.gd = false, this.wd = false, this.Md = false, this.Sd = 0, this.xd = null, this.yd = !Pn(), this.kd = (t2) => {
      this.Cd(t2);
    }, this.Td = (t2) => {
      if (this.Pd(t2)) {
        const i2 = this.Rd(t2);
        if (++this.Qc, this.td && this.Qc > 1) {
          const { Dd: n2 } = this.Bd(Vn(t2), this.nd);
          n2 < 30 && !this.od && this.Ad(i2, this.Ld.Od), this.Id();
        }
      } else {
        const i2 = this.Rd(t2);
        if (++this.Kc, this.Gc && this.Kc > 1) {
          const { Dd: n2 } = this.Bd(Vn(t2), this.Jc);
          n2 < 5 && !this.ad && this.Ed(i2, this.Ld.zd), this.Vd();
        }
      }
    }, this.Nd = t, this.Ld = i, this.un = n, this.Fd();
  }
  M() {
    null !== this._d && (this._d(), this._d = null), null !== this.ud && (this.ud(), this.ud = null), null !== this.fd && (this.fd(), this.fd = null), null !== this.pd && (this.pd(), this.pd = null), null !== this.vd && (this.vd(), this.vd = null), null !== this.dd && (this.dd(), this.dd = null), this.Wd(), this.Vd();
  }
  jd(t) {
    this.fd && this.fd();
    const i = this.$d.bind(this);
    if (this.fd = () => {
      this.Nd.removeEventListener("mousemove", i);
    }, this.Nd.addEventListener("mousemove", i), this.Pd(t))
      return;
    const n = this.Rd(t);
    this.Ed(n, this.Ld.Hd), this.yd = true;
  }
  Vd() {
    null !== this.Gc && clearTimeout(this.Gc), this.Kc = 0, this.Gc = null, this.Jc = { st: Number.NEGATIVE_INFINITY, et: Number.POSITIVE_INFINITY };
  }
  Id() {
    null !== this.td && clearTimeout(this.td), this.Qc = 0, this.td = null, this.nd = { st: Number.NEGATIVE_INFINITY, et: Number.POSITIVE_INFINITY };
  }
  $d(t) {
    if (this.Md || null !== this.hd)
      return;
    if (this.Pd(t))
      return;
    const i = this.Rd(t);
    this.Ed(i, this.Ld.Ud), this.yd = true;
  }
  qd(t) {
    const i = Fn(t.changedTouches, _(this.xd));
    if (null === i)
      return;
    if (this.Sd = Nn(t), null !== this.md)
      return;
    if (this.wd)
      return;
    this.gd = true;
    const n = this.Bd(Vn(i), _(this.hd)), { Yd: s, Xd: e2, Dd: r2 } = n;
    if (this.ld || !(r2 < 5)) {
      if (!this.ld) {
        const t2 = 0.5 * s, i2 = e2 >= t2 && !this.un.Zd(), n2 = t2 > e2 && !this.un.Kd();
        i2 || n2 || (this.wd = true), this.ld = true, this.od = true, this.Wd(), this.Id();
      }
      if (!this.wd) {
        const n2 = this.Rd(t, i);
        this.Ad(n2, this.Ld.Gd), zn(t);
      }
    }
  }
  Jd(t) {
    if (0 !== t.button)
      return;
    const i = this.Bd(Vn(t), _(this.rd)), { Dd: n } = i;
    if (n >= 5 && (this.ad = true, this.Vd()), this.ad) {
      const i2 = this.Rd(t);
      this.Ed(i2, this.Ld.Qd);
    }
  }
  Bd(t, i) {
    const n = Math.abs(i.st - t.st), s = Math.abs(i.et - t.et);
    return { Yd: n, Xd: s, Dd: n + s };
  }
  tf(t) {
    let i = Fn(t.changedTouches, _(this.xd));
    if (null === i && 0 === t.touches.length && (i = t.changedTouches[0]), null === i)
      return;
    this.xd = null, this.Sd = Nn(t), this.Wd(), this.hd = null, this.vd && (this.vd(), this.vd = null);
    const n = this.Rd(t, i);
    if (this.Ad(n, this.Ld.if), ++this.Qc, this.td && this.Qc > 1) {
      const { Dd: t2 } = this.Bd(Vn(i), this.nd);
      t2 < 30 && !this.od && this.Ad(n, this.Ld.Od), this.Id();
    } else
      this.od || (this.Ad(n, this.Ld.nf), this.Ld.nf && zn(t));
    0 === this.Qc && zn(t), 0 === t.touches.length && this.ed && (this.ed = false, zn(t));
  }
  Cd(t) {
    if (0 !== t.button)
      return;
    const i = this.Rd(t);
    if (this.rd = null, this.Md = false, this.pd && (this.pd(), this.pd = null), Tn()) {
      this.Nd.ownerDocument.documentElement.removeEventListener("mouseleave", this.kd);
    }
    if (!this.Pd(t))
      if (this.Ed(i, this.Ld.sf), ++this.Kc, this.Gc && this.Kc > 1) {
        const { Dd: n } = this.Bd(Vn(t), this.Jc);
        n < 5 && !this.ad && this.Ed(i, this.Ld.zd), this.Vd();
      } else
        this.ad || this.Ed(i, this.Ld.ef);
  }
  Wd() {
    null !== this.sd && (clearTimeout(this.sd), this.sd = null);
  }
  rf(t) {
    if (null !== this.xd)
      return;
    const i = t.changedTouches[0];
    this.xd = i.identifier, this.Sd = Nn(t);
    const n = this.Nd.ownerDocument.documentElement;
    this.od = false, this.ld = false, this.wd = false, this.hd = Vn(i), this.vd && (this.vd(), this.vd = null);
    {
      const i2 = this.qd.bind(this), s2 = this.tf.bind(this);
      this.vd = () => {
        n.removeEventListener("touchmove", i2), n.removeEventListener("touchend", s2);
      }, n.addEventListener("touchmove", i2, { passive: false }), n.addEventListener("touchend", s2, { passive: false }), this.Wd(), this.sd = setTimeout(this.hf.bind(this, t), 240);
    }
    const s = this.Rd(t, i);
    this.Ad(s, this.Ld.lf), this.td || (this.Qc = 0, this.td = setTimeout(this.Id.bind(this), 500), this.nd = Vn(i));
  }
  af(t) {
    if (0 !== t.button)
      return;
    const i = this.Nd.ownerDocument.documentElement;
    Tn() && i.addEventListener("mouseleave", this.kd), this.ad = false, this.rd = Vn(t), this.pd && (this.pd(), this.pd = null);
    {
      const t2 = this.Jd.bind(this), n2 = this.Cd.bind(this);
      this.pd = () => {
        i.removeEventListener("mousemove", t2), i.removeEventListener("mouseup", n2);
      }, i.addEventListener("mousemove", t2), i.addEventListener("mouseup", n2);
    }
    if (this.Md = true, this.Pd(t))
      return;
    const n = this.Rd(t);
    this.Ed(n, this.Ld._f), this.Gc || (this.Kc = 0, this.Gc = setTimeout(this.Vd.bind(this), 500), this.Jc = Vn(t));
  }
  Fd() {
    this.Nd.addEventListener("mouseenter", this.jd.bind(this)), this.Nd.addEventListener("touchcancel", this.Wd.bind(this));
    {
      const t = this.Nd.ownerDocument, i = (t2) => {
        this.Ld.uf && (t2.composed && this.Nd.contains(t2.composedPath()[0]) || t2.target && this.Nd.contains(t2.target) || this.Ld.uf());
      };
      this.ud = () => {
        t.removeEventListener("touchstart", i);
      }, this._d = () => {
        t.removeEventListener("mousedown", i);
      }, t.addEventListener("mousedown", i), t.addEventListener("touchstart", i, { passive: true });
    }
    Pn() && (this.dd = () => {
      this.Nd.removeEventListener("dblclick", this.Td);
    }, this.Nd.addEventListener("dblclick", this.Td)), this.Nd.addEventListener("mouseleave", this.cf.bind(this)), this.Nd.addEventListener("touchstart", this.rf.bind(this), { passive: true }), Ln(this.Nd), this.Nd.addEventListener("mousedown", this.af.bind(this)), this.df(), this.Nd.addEventListener("touchmove", () => {
    }, { passive: false });
  }
  df() {
    void 0 === this.Ld.ff && void 0 === this.Ld.pf && void 0 === this.Ld.vf || (this.Nd.addEventListener("touchstart", (t) => this.mf(t.touches), { passive: true }), this.Nd.addEventListener("touchmove", (t) => {
      if (2 === t.touches.length && null !== this.md && void 0 !== this.Ld.pf) {
        const i = En(t.touches[0], t.touches[1]) / this.bd;
        this.Ld.pf(this.md, i), zn(t);
      }
    }, { passive: false }), this.Nd.addEventListener("touchend", (t) => {
      this.mf(t.touches);
    }));
  }
  mf(t) {
    1 === t.length && (this.gd = false), 2 !== t.length || this.gd || this.ed ? this.bf() : this.gf(t);
  }
  gf(t) {
    const i = this.Nd.getBoundingClientRect() || { left: 0, top: 0 };
    this.md = { st: (t[0].clientX - i.left + (t[1].clientX - i.left)) / 2, et: (t[0].clientY - i.top + (t[1].clientY - i.top)) / 2 }, this.bd = En(t[0], t[1]), void 0 !== this.Ld.ff && this.Ld.ff(), this.Wd();
  }
  bf() {
    null !== this.md && (this.md = null, void 0 !== this.Ld.vf && this.Ld.vf());
  }
  cf(t) {
    if (this.fd && this.fd(), this.Pd(t))
      return;
    if (!this.yd)
      return;
    const i = this.Rd(t);
    this.Ed(i, this.Ld.wf), this.yd = !Pn();
  }
  hf(t) {
    const i = Fn(t.touches, _(this.xd));
    if (null === i)
      return;
    const n = this.Rd(t, i);
    this.Ad(n, this.Ld.Mf), this.od = true, this.ed = true;
  }
  Pd(t) {
    return t.sourceCapabilities && void 0 !== t.sourceCapabilities.firesTouchEvents ? t.sourceCapabilities.firesTouchEvents : Nn(t) < this.Sd + 500;
  }
  Ad(t, i) {
    i && i.call(this.Ld, t);
  }
  Ed(t, i) {
    i && i.call(this.Ld, t);
  }
  Rd(t, i) {
    const n = i || t, s = this.Nd.getBoundingClientRect() || { left: 0, top: 0 };
    return { clientX: n.clientX, clientY: n.clientY, pageX: n.pageX, pageY: n.pageY, screenX: n.screenX, screenY: n.screenY, localX: n.clientX - s.left, localY: n.clientY - s.top, ctrlKey: t.ctrlKey, altKey: t.altKey, shiftKey: t.shiftKey, metaKey: t.metaKey, Sf: !t.type.startsWith("mouse") && "contextmenu" !== t.type && "click" !== t.type, xf: t.type, yf: n.target, kf: t.view, Cf: () => {
      "touchstart" !== t.type && zn(t);
    } };
  }
}
function En(t, i) {
  const n = t.clientX - i.clientX, s = t.clientY - i.clientY;
  return Math.sqrt(n * n + s * s);
}
function zn(t) {
  t.cancelable && t.preventDefault();
}
function Vn(t) {
  return { st: t.pageX, et: t.pageY };
}
function Nn(t) {
  return t.timeStamp || performance.now();
}
function Fn(t, i) {
  for (let n = 0; n < t.length; ++n)
    if (t[n].identifier === i)
      return t[n];
  return null;
}
class Wn {
  constructor(i, n, s, e2) {
    this.zi = null, this.Tf = null, this.Pf = false, this.Rf = new Ut(200), this.zr = null, this.Df = 0, this.Bf = false, this.Af = () => {
      this.Bf || this.tn.Of().Ut().Ch();
    }, this.Lf = () => {
      this.Bf || this.tn.Of().Ut().Ch();
    }, this.tn = i, this.un = n, this.Ba = n.layout, this.Gu = s, this.If = "left" === e2, this.Ef = document.createElement("div"), this.Ef.style.height = "100%", this.Ef.style.overflow = "hidden", this.Ef.style.width = "25px", this.Ef.style.left = "0", this.Ef.style.position = "relative", this.zf = On(this.Ef, size({ width: 16, height: 16 })), this.zf.subscribeSuggestedBitmapSizeChanged(this.Af);
    const r2 = this.zf.canvasElement;
    r2.style.position = "absolute", r2.style.zIndex = "1", r2.style.left = "0", r2.style.top = "0", this.Vf = On(this.Ef, size({ width: 16, height: 16 })), this.Vf.subscribeSuggestedBitmapSizeChanged(this.Lf);
    const h3 = this.Vf.canvasElement;
    h3.style.position = "absolute", h3.style.zIndex = "2", h3.style.left = "0", h3.style.top = "0";
    const l2 = { _f: this.Nf.bind(this), lf: this.Nf.bind(this), Qd: this.Ff.bind(this), Gd: this.Ff.bind(this), uf: this.Wf.bind(this), sf: this.jf.bind(this), if: this.jf.bind(this), zd: this.$f.bind(this), Od: this.$f.bind(this), Hd: this.Hf.bind(this), wf: this.Uf.bind(this) };
    this.qf = new In(this.Vf.canvasElement, l2, { Zd: () => false, Kd: () => true });
  }
  M() {
    this.qf.M(), this.Vf.unsubscribeSuggestedBitmapSizeChanged(this.Lf), this.Vf.dispose(), this.zf.unsubscribeSuggestedBitmapSizeChanged(this.Af), this.zf.dispose(), null !== this.zi && this.zi.eo().v(this), this.zi = null;
  }
  Yf() {
    return this.Ef;
  }
  T() {
    return this.Ba.fontSize;
  }
  Xf() {
    const t = this.Gu.F();
    return this.zr !== t.P && (this.Rf.Fe(), this.zr = t.P), t;
  }
  Zf() {
    if (null === this.zi)
      return 0;
    let t = 0;
    const i = this.Xf(), n = _(this.zf.canvasElement.getContext("2d"));
    n.save();
    const s = this.zi.Jl();
    n.font = this.Kf(), s.length > 0 && (t = Math.max(this.Rf.Si(n, s[0].ua), this.Rf.Si(n, s[s.length - 1].ua)));
    const e2 = this.Gf();
    for (let i2 = e2.length; i2--; ) {
      const s2 = this.Rf.Si(n, e2[i2].Gt());
      s2 > t && (t = s2);
    }
    const r2 = this.zi.Tt();
    if (null !== r2 && null !== this.Tf) {
      const i2 = this.zi.pn(1, r2), s2 = this.zi.pn(this.Tf.height - 2, r2);
      t = Math.max(t, this.Rf.Si(n, this.zi.Fi(Math.floor(Math.min(i2, s2)) + 0.11111111111111, r2)), this.Rf.Si(n, this.zi.Fi(Math.ceil(Math.max(i2, s2)) - 0.11111111111111, r2)));
    }
    n.restore();
    const h3 = t || 34;
    return Rn(Math.ceil(i.k + i.C + i.O + i.L + 5 + h3));
  }
  Jf(t) {
    null !== this.Tf && equalSizes(this.Tf, t) || (this.Tf = t, this.Bf = true, this.zf.resizeCanvasElement(t), this.Vf.resizeCanvasElement(t), this.Bf = false, this.Ef.style.width = `${t.width}px`, this.Ef.style.height = `${t.height}px`);
  }
  Qf() {
    return _(this.Tf).width;
  }
  Gi(t) {
    this.zi !== t && (null !== this.zi && this.zi.eo().v(this), this.zi = t, t.eo().l(this.Sa.bind(this), this));
  }
  Bt() {
    return this.zi;
  }
  Fe() {
    const t = this.tn.tp();
    this.tn.Of().Ut().qo(t, _(this.Bt()));
  }
  ip(t) {
    if (null === this.Tf)
      return;
    if (1 !== t) {
      this.np(), this.zf.applySuggestedBitmapSize();
      const t2 = tryCreateCanvasRenderingTarget2D(this.zf);
      null !== t2 && (t2.useBitmapCoordinateSpace((t3) => {
        this.sp(t3), this.ye(t3);
      }), this.ep(t2), this.rp(t2));
    }
    this.Vf.applySuggestedBitmapSize();
    const i = tryCreateCanvasRenderingTarget2D(this.Vf);
    null !== i && (i.useBitmapCoordinateSpace(({ context: t2, bitmapSize: i2 }) => {
      t2.clearRect(0, 0, i2.width, i2.height);
    }), this.hp(i));
  }
  lp() {
    return this.zf.bitmapSize;
  }
  ap(t, i, n) {
    const s = this.lp();
    s.width > 0 && s.height > 0 && t.drawImage(this.zf.canvasElement, i, n);
  }
  gt() {
    var t;
    null === (t = this.zi) || void 0 === t || t.Jl();
  }
  Nf(t) {
    if (null === this.zi || this.zi.Ni() || !this.un.handleScale.axisPressedMouseMove.price)
      return;
    const i = this.tn.Of().Ut(), n = this.tn.tp();
    this.Pf = true, i.No(n, this.zi, t.localY);
  }
  Ff(t) {
    if (null === this.zi || !this.un.handleScale.axisPressedMouseMove.price)
      return;
    const i = this.tn.Of().Ut(), n = this.tn.tp(), s = this.zi;
    i.Fo(n, s, t.localY);
  }
  Wf() {
    if (null === this.zi || !this.un.handleScale.axisPressedMouseMove.price)
      return;
    const t = this.tn.Of().Ut(), i = this.tn.tp(), n = this.zi;
    this.Pf && (this.Pf = false, t.Wo(i, n));
  }
  jf(t) {
    if (null === this.zi || !this.un.handleScale.axisPressedMouseMove.price)
      return;
    const i = this.tn.Of().Ut(), n = this.tn.tp();
    this.Pf = false, i.Wo(n, this.zi);
  }
  $f(t) {
    this.un.handleScale.axisDoubleClickReset.price && this.Fe();
  }
  Hf(t) {
    if (null === this.zi)
      return;
    !this.tn.Of().Ut().F().handleScale.axisPressedMouseMove.price || this.zi.th() || this.zi.Na() || this.op(1);
  }
  Uf(t) {
    this.op(0);
  }
  Gf() {
    const t = [], i = null === this.zi ? void 0 : this.zi;
    return ((n) => {
      for (let s = 0; s < n.length; ++s) {
        const e2 = n[s].Pn(this.tn.tp(), i);
        for (let i2 = 0; i2 < e2.length; i2++)
          t.push(e2[i2]);
      }
    })(this.tn.tp().Ja()), t;
  }
  sp({ context: t, bitmapSize: i }) {
    const { width: n, height: s } = i, e2 = this.tn.tp().Ut(), r2 = e2.U(), h3 = e2.Ic();
    r2 === h3 ? $(t, 0, 0, n, s, r2) : Y(t, 0, 0, n, s, r2, h3);
  }
  ye({ context: t, bitmapSize: i, horizontalPixelRatio: n }) {
    if (null === this.Tf || null === this.zi || !this.zi.F().borderVisible)
      return;
    t.fillStyle = this.zi.F().borderColor;
    const s = Math.max(1, Math.floor(this.Xf().k * n));
    let e2;
    e2 = this.If ? i.width - s : 0, t.fillRect(e2, 0, s, i.height);
  }
  ep(t) {
    if (null === this.Tf || null === this.zi)
      return;
    const i = this.zi.Jl(), n = this.zi.F(), s = this.Xf(), e2 = this.If ? this.Tf.width - s.C : 0;
    n.borderVisible && n.ticksVisible && t.useBitmapCoordinateSpace(({ context: t2, horizontalPixelRatio: r2, verticalPixelRatio: h3 }) => {
      t2.fillStyle = n.borderColor;
      const l2 = Math.max(1, Math.floor(h3)), a2 = Math.floor(0.5 * h3), o2 = Math.round(s.C * r2);
      t2.beginPath();
      for (const n2 of i)
        t2.rect(Math.floor(e2 * r2), Math.round(n2.Yl * h3) - a2, o2, l2);
      t2.fill();
    }), t.useMediaCoordinateSpace(({ context: t2 }) => {
      var r2;
      t2.font = this.Kf(), t2.fillStyle = null !== (r2 = n.textColor) && void 0 !== r2 ? r2 : this.Ba.textColor, t2.textAlign = this.If ? "right" : "left", t2.textBaseline = "middle";
      const h3 = this.If ? Math.round(e2 - s.O) : Math.round(e2 + s.C + s.O), l2 = i.map((i2) => this.Rf.Mi(t2, i2.ua));
      for (let n2 = i.length; n2--; ) {
        const s2 = i[n2];
        t2.fillText(s2.ua, h3, s2.Yl + l2[n2]);
      }
    });
  }
  np() {
    if (null === this.Tf || null === this.zi)
      return;
    let t = this.Tf.height / 2;
    const i = [], n = this.zi.Ja().slice(), s = this.tn.tp(), e2 = this.Xf();
    this.zi === s.Je() && this.tn.tp().Ja().forEach((t2) => {
      s.Ge(t2) && n.push(t2);
    });
    const r2 = this.zi.jl()[0], h3 = this.zi;
    n.forEach((n2) => {
      const e3 = n2.Pn(s, h3);
      e3.forEach((t2) => {
        t2.Ai(null), t2.Oi() && i.push(t2);
      }), r2 === n2 && e3.length > 0 && (t = e3[0].yi());
    }), i.forEach((t2) => t2.Ai(t2.yi()));
    this.zi.F().alignLabels && this._p(i, e2, t);
  }
  _p(t, i, n) {
    if (null === this.Tf)
      return;
    const s = t.filter((t2) => t2.yi() <= n), e2 = t.filter((t2) => t2.yi() > n);
    s.sort((t2, i2) => i2.yi() - t2.yi()), s.length && e2.length && e2.push(s[0]), e2.sort((t2, i2) => t2.yi() - i2.yi());
    for (const n2 of t) {
      const t2 = Math.floor(n2.It(i) / 2), s2 = n2.yi();
      s2 > -t2 && s2 < t2 && n2.Ai(t2), s2 > this.Tf.height - t2 && s2 < this.Tf.height + t2 && n2.Ai(this.Tf.height - t2);
    }
    for (let t2 = 1; t2 < s.length; t2++) {
      const n2 = s[t2], e3 = s[t2 - 1], r2 = e3.It(i, false), h3 = n2.yi(), l2 = e3.Bi();
      h3 > l2 - r2 && n2.Ai(l2 - r2);
    }
    for (let t2 = 1; t2 < e2.length; t2++) {
      const n2 = e2[t2], s2 = e2[t2 - 1], r2 = s2.It(i, true), h3 = n2.yi(), l2 = s2.Bi();
      h3 < l2 + r2 && n2.Ai(l2 + r2);
    }
  }
  rp(t) {
    if (null === this.Tf)
      return;
    const i = this.Gf(), n = this.Xf(), s = this.If ? "right" : "left";
    i.forEach((i2) => {
      if (i2.Li()) {
        i2.Mt(_(this.zi)).X(t, n, this.Rf, s);
      }
    });
  }
  hp(t) {
    if (null === this.Tf || null === this.zi)
      return;
    const i = this.tn.Of().Ut(), n = [], s = this.tn.tp(), e2 = i.dc().Pn(s, this.zi);
    e2.length && n.push(e2);
    const r2 = this.Xf(), h3 = this.If ? "right" : "left";
    n.forEach((i2) => {
      i2.forEach((i3) => {
        i3.Mt(_(this.zi)).X(t, r2, this.Rf, h3);
      });
    });
  }
  op(t) {
    this.Ef.style.cursor = 1 === t ? "ns-resize" : "default";
  }
  Sa() {
    const t = this.Zf();
    this.Df < t && this.tn.Of().Ut().dl(), this.Df = t;
  }
  Kf() {
    return B(this.Ba.fontSize, this.Ba.fontFamily);
  }
}
function jn(t, i, n, s) {
  t.K && t.K(i, n, s);
}
function $n(t, i, n, s) {
  t.X(i, n, s);
}
function Hn(t, i) {
  return t.Tn(i);
}
function Un(t, i) {
  return t.Ji(i);
}
function qn(t, i) {
  return void 0 !== t.kl ? t.kl(i) : [];
}
class Yn {
  constructor(i, n) {
    this.Tf = size({ width: 0, height: 0 }), this.up = null, this.cp = null, this.dp = null, this.fp = false, this.pp = new M(), this.vp = 0, this.mp = false, this.bp = null, this.gp = false, this.wp = null, this.Mp = null, this.Bf = false, this.Af = () => {
      this.Bf || null === this.Sp || this.Hi().Ch();
    }, this.Lf = () => {
      this.Bf || null === this.Sp || this.Hi().Ch();
    }, this.xp = i, this.Sp = n, this.Sp.Zo().l(this.yp.bind(this), this, true), this.kp = document.createElement("td"), this.kp.style.padding = "0", this.kp.style.position = "relative";
    const s = document.createElement("div");
    s.style.width = "100%", s.style.height = "100%", s.style.position = "relative", s.style.overflow = "hidden", this.Cp = document.createElement("td"), this.Cp.style.padding = "0", this.Tp = document.createElement("td"), this.Tp.style.padding = "0", this.kp.appendChild(s), this.zf = On(s, size({ width: 16, height: 16 })), this.zf.subscribeSuggestedBitmapSizeChanged(this.Af);
    const e2 = this.zf.canvasElement;
    e2.style.position = "absolute", e2.style.zIndex = "1", e2.style.left = "0", e2.style.top = "0", this.Vf = On(s, size({ width: 16, height: 16 })), this.Vf.subscribeSuggestedBitmapSizeChanged(this.Lf);
    const r2 = this.Vf.canvasElement;
    r2.style.position = "absolute", r2.style.zIndex = "2", r2.style.left = "0", r2.style.top = "0", this.Pp = document.createElement("tr"), this.Pp.appendChild(this.Cp), this.Pp.appendChild(this.kp), this.Pp.appendChild(this.Tp), this.Rp(), this.qf = new In(this.Vf.canvasElement, this, { Zd: () => null === this.bp && !this.xp.F().handleScroll.vertTouchDrag, Kd: () => null === this.bp && !this.xp.F().handleScroll.horzTouchDrag });
  }
  M() {
    null !== this.up && this.up.M(), null !== this.cp && this.cp.M(), this.Vf.unsubscribeSuggestedBitmapSizeChanged(this.Lf), this.Vf.dispose(), this.zf.unsubscribeSuggestedBitmapSizeChanged(this.Af), this.zf.dispose(), null !== this.Sp && this.Sp.Zo().v(this), this.qf.M();
  }
  tp() {
    return _(this.Sp);
  }
  Dp(t) {
    null !== this.Sp && this.Sp.Zo().v(this), this.Sp = t, null !== this.Sp && this.Sp.Zo().l(Yn.prototype.yp.bind(this), this, true), this.Rp();
  }
  Of() {
    return this.xp;
  }
  Yf() {
    return this.Pp;
  }
  Rp() {
    if (null !== this.Sp && (this.Bp(), 0 !== this.Hi().wt().length)) {
      if (null !== this.up) {
        const t = this.Sp.zo();
        this.up.Gi(_(t));
      }
      if (null !== this.cp) {
        const t = this.Sp.Vo();
        this.cp.Gi(_(t));
      }
    }
  }
  Ap() {
    null !== this.up && this.up.gt(), null !== this.cp && this.cp.gt();
  }
  Ro() {
    return null !== this.Sp ? this.Sp.Ro() : 0;
  }
  Do(t) {
    this.Sp && this.Sp.Do(t);
  }
  Hd(t) {
    if (!this.Sp)
      return;
    this.Op();
    const i = t.localX, n = t.localY;
    this.Lp(i, n, t);
  }
  _f(t) {
    this.Op(), this.Ip(), this.Lp(t.localX, t.localY, t);
  }
  Ud(t) {
    if (!this.Sp)
      return;
    this.Op();
    const i = t.localX, n = t.localY;
    this.Lp(i, n, t);
    const s = this.ir(i, n);
    this.Hi().lc(s && { ac: s.ac, Ep: s.Ep });
  }
  ef(t) {
    null !== this.Sp && (this.Op(), this.zp(t));
  }
  Qd(t) {
    this.Op(), this.Vp(t), this.Lp(t.localX, t.localY, t);
  }
  sf(t) {
    null !== this.Sp && (this.Op(), this.mp = false, this.Np(t));
  }
  nf(t) {
    null !== this.Sp && this.zp(t);
  }
  Mf(t) {
    if (this.mp = true, null === this.bp) {
      const i = { x: t.localX, y: t.localY };
      this.Fp(i, i, t);
    }
  }
  wf(t) {
    null !== this.Sp && (this.Op(), this.Sp.Ut().lc(null), this.Wp());
  }
  jp() {
    return this.pp;
  }
  ff() {
    this.vp = 1, this.Hi().Hn();
  }
  pf(t, i) {
    if (!this.xp.F().handleScale.pinch)
      return;
    const n = 5 * (i - this.vp);
    this.vp = i, this.Hi().gc(t.st, n);
  }
  lf(t) {
    if (this.mp = false, this.gp = null !== this.bp, this.Ip(), null !== this.bp) {
      const i = this.Hi().dc();
      this.wp = { x: i.Xt(), y: i.Zt() }, this.bp = { x: t.localX, y: t.localY };
    }
  }
  Gd(t) {
    if (null === this.Sp)
      return;
    const i = t.localX, n = t.localY;
    if (null === this.bp)
      this.Vp(t);
    else {
      this.gp = false;
      const s = _(this.wp), e2 = s.x + (i - this.bp.x), r2 = s.y + (n - this.bp.y);
      this.Lp(e2, r2, t);
    }
  }
  if(t) {
    0 === this.Of().F().trackingMode.exitMode && (this.gp = true), this.$p(), this.Np(t);
  }
  ir(t, i) {
    const n = this.Sp;
    if (null === n)
      return null;
    const s = n.Ja();
    for (const e2 of s) {
      const s2 = this.Hp(e2.Tn(n), t, i);
      if (null !== s2)
        return { ac: e2, kf: s2.kf, Ep: s2.Ep };
    }
    return null;
  }
  Up(i, n) {
    _("left" === n ? this.up : this.cp).Jf(size({ width: i, height: this.Tf.height }));
  }
  qp() {
    return this.Tf;
  }
  Jf(t) {
    equalSizes(this.Tf, t) || (this.Tf = t, this.Bf = true, this.zf.resizeCanvasElement(t), this.Vf.resizeCanvasElement(t), this.Bf = false, this.kp.style.width = t.width + "px", this.kp.style.height = t.height + "px");
  }
  Yp() {
    const t = _(this.Sp);
    t.Eo(t.zo()), t.Eo(t.Vo());
    for (const i of t.jl())
      if (t.Ge(i)) {
        const n = i.Bt();
        null !== n && t.Eo(n), i.Dn();
      }
  }
  lp() {
    return this.zf.bitmapSize;
  }
  ap(t, i, n) {
    const s = this.lp();
    s.width > 0 && s.height > 0 && t.drawImage(this.zf.canvasElement, i, n);
  }
  ip(t) {
    if (0 === t)
      return;
    if (null === this.Sp)
      return;
    if (t > 1 && this.Yp(), null !== this.up && this.up.ip(t), null !== this.cp && this.cp.ip(t), 1 !== t) {
      this.zf.applySuggestedBitmapSize();
      const t2 = tryCreateCanvasRenderingTarget2D(this.zf);
      null !== t2 && (t2.useBitmapCoordinateSpace((t3) => {
        this.sp(t3);
      }), this.Sp && (this.Xp(t2), this.Zp(t2), this.Kp(t2, Hn), this.Kp(t2, Un)));
    }
    this.Vf.applySuggestedBitmapSize();
    const i = tryCreateCanvasRenderingTarget2D(this.Vf);
    null !== i && (i.useBitmapCoordinateSpace(({ context: t2, bitmapSize: i2 }) => {
      t2.clearRect(0, 0, i2.width, i2.height);
    }), this.Kp(i, qn), this.Gp(i));
  }
  Jp() {
    return this.up;
  }
  Qp() {
    return this.cp;
  }
  yp() {
    null !== this.Sp && this.Sp.Zo().v(this), this.Sp = null;
  }
  zp(t) {
    const i = t.localX, n = t.localY;
    this.pp.g() && this.pp.m(this.Hi().yt().ru(i), { x: i, y: n }, t);
  }
  sp({ context: t, bitmapSize: i }) {
    const { width: n, height: s } = i, e2 = this.Hi(), r2 = e2.U(), h3 = e2.Ic();
    r2 === h3 ? $(t, 0, 0, n, s, h3) : Y(t, 0, 0, n, s, r2, h3);
  }
  Xp(t) {
    const i = _(this.Sp).Ko().Th().Mt();
    null !== i && i.X(t, false);
  }
  Zp(t) {
    const i = this.Hi().cc();
    this.tv(t, Hn, jn, i), this.tv(t, Hn, $n, i);
  }
  Gp(t) {
    this.tv(t, Hn, $n, this.Hi().dc());
  }
  Kp(t, i) {
    const n = _(this.Sp).Ja();
    for (const s of n)
      this.tv(t, i, jn, s);
    for (const s of n)
      this.tv(t, i, $n, s);
  }
  tv(t, i, n, s) {
    const e2 = _(this.Sp), r2 = i(s, e2), h3 = e2.Ut().hc(), l2 = null !== h3 && h3.ac === s, a2 = null !== h3 && l2 && void 0 !== h3.Ep ? h3.Ep.sr : void 0;
    for (const i2 of r2) {
      const s2 = i2.Mt();
      null !== s2 && n(s2, t, l2, a2);
    }
  }
  Hp(t, i, n) {
    for (const s of t) {
      const t2 = s.Mt();
      if (null !== t2 && t2.ir) {
        const e2 = t2.ir(i, n);
        if (null !== e2)
          return { kf: s, Ep: e2 };
      }
    }
    return null;
  }
  Bp() {
    if (null === this.Sp)
      return;
    const t = this.xp, i = this.Sp.zo().F().visible, n = this.Sp.Vo().F().visible;
    i || null === this.up || (this.Cp.removeChild(this.up.Yf()), this.up.M(), this.up = null), n || null === this.cp || (this.Tp.removeChild(this.cp.Yf()), this.cp.M(), this.cp = null);
    const s = t.Ut().Rc();
    i && null === this.up && (this.up = new Wn(this, t.F(), s, "left"), this.Cp.appendChild(this.up.Yf())), n && null === this.cp && (this.cp = new Wn(this, t.F(), s, "right"), this.Tp.appendChild(this.cp.Yf()));
  }
  iv(t) {
    return t.Sf && this.mp || null !== this.bp;
  }
  nv(t) {
    return Math.max(0, Math.min(t, this.Tf.width - 1));
  }
  sv(t) {
    return Math.max(0, Math.min(t, this.Tf.height - 1));
  }
  Lp(t, i, n) {
    this.Hi().Cc(this.nv(t), this.sv(i), n, _(this.Sp));
  }
  Wp() {
    this.Hi().Tc();
  }
  $p() {
    this.gp && (this.bp = null, this.Wp());
  }
  Fp(t, i, n) {
    this.bp = t, this.gp = false, this.Lp(i.x, i.y, n);
    const s = this.Hi().dc();
    this.wp = { x: s.Xt(), y: s.Zt() };
  }
  Hi() {
    return this.xp.Ut();
  }
  Np(t) {
    if (!this.fp)
      return;
    const i = this.Hi(), n = this.tp();
    if (i.Ho(n, n.fn()), this.dp = null, this.fp = false, i.xc(), null !== this.Mp) {
      const t2 = performance.now(), n2 = i.yt();
      this.Mp.pr(n2.ou(), t2), this.Mp.wu(t2) || i.Yn(this.Mp);
    }
  }
  Op() {
    this.bp = null;
  }
  Ip() {
    if (!this.Sp)
      return;
    if (this.Hi().Hn(), document.activeElement !== document.body && document.activeElement !== document.documentElement)
      _(document.activeElement).blur();
    else {
      const t = document.getSelection();
      null !== t && t.removeAllRanges();
    }
    !this.Sp.fn().Ni() && this.Hi().yt().Ni();
  }
  Vp(t) {
    if (null === this.Sp)
      return;
    const i = this.Hi(), n = i.yt();
    if (n.Ni())
      return;
    const s = this.xp.F(), e2 = s.handleScroll, r2 = s.kineticScroll;
    if ((!e2.pressedMouseMove || t.Sf) && (!e2.horzTouchDrag && !e2.vertTouchDrag || !t.Sf))
      return;
    const h3 = this.Sp.fn(), l2 = performance.now();
    if (null !== this.dp || this.iv(t) || (this.dp = { x: t.clientX, y: t.clientY, u_: l2, ev: t.localX, rv: t.localY }), null !== this.dp && !this.fp && (this.dp.x !== t.clientX || this.dp.y !== t.clientY)) {
      if (t.Sf && r2.touch || !t.Sf && r2.mouse) {
        const t2 = n.Ks();
        this.Mp = new An(0.2 / t2, 7 / t2, 0.997, 15 / t2), this.Mp.Xc(n.ou(), this.dp.u_);
      } else
        this.Mp = null;
      h3.Ni() || i.jo(this.Sp, h3, t.localY), i.Mc(t.localX), this.fp = true;
    }
    this.fp && (h3.Ni() || i.$o(this.Sp, h3, t.localY), i.Sc(t.localX), null !== this.Mp && this.Mp.Xc(n.ou(), l2));
  }
}
class Xn {
  constructor(i, n, s, e2, r2) {
    this.vt = true, this.Tf = size({ width: 0, height: 0 }), this.Af = () => this.ip(3), this.If = "left" === i, this.Gu = s.Rc, this.un = n, this.hv = e2, this.lv = r2, this.Ef = document.createElement("div"), this.Ef.style.width = "25px", this.Ef.style.height = "100%", this.Ef.style.overflow = "hidden", this.zf = On(this.Ef, size({ width: 16, height: 16 })), this.zf.subscribeSuggestedBitmapSizeChanged(this.Af);
  }
  M() {
    this.zf.unsubscribeSuggestedBitmapSizeChanged(this.Af), this.zf.dispose();
  }
  Yf() {
    return this.Ef;
  }
  qp() {
    return this.Tf;
  }
  Jf(t) {
    equalSizes(this.Tf, t) || (this.Tf = t, this.zf.resizeCanvasElement(t), this.Ef.style.width = `${t.width}px`, this.Ef.style.height = `${t.height}px`, this.vt = true);
  }
  ip(t) {
    if (t < 3 && !this.vt)
      return;
    if (0 === this.Tf.width || 0 === this.Tf.height)
      return;
    this.vt = false, this.zf.applySuggestedBitmapSize();
    const i = tryCreateCanvasRenderingTarget2D(this.zf);
    null !== i && i.useBitmapCoordinateSpace((t2) => {
      this.sp(t2), this.ye(t2);
    });
  }
  lp() {
    return this.zf.bitmapSize;
  }
  ap(t, i, n) {
    const s = this.lp();
    s.width > 0 && s.height > 0 && t.drawImage(this.zf.canvasElement, i, n);
  }
  ye({ context: t, bitmapSize: i, horizontalPixelRatio: n, verticalPixelRatio: s }) {
    if (!this.hv())
      return;
    t.fillStyle = this.un.timeScale.borderColor;
    const e2 = Math.floor(this.Gu.F().k * n), r2 = Math.floor(this.Gu.F().k * s), h3 = this.If ? i.width - e2 : 0;
    t.fillRect(h3, 0, e2, r2);
  }
  sp({ context: t, bitmapSize: i }) {
    $(t, 0, 0, i.width, i.height, this.lv());
  }
}
function Zn(t, i) {
  return t.w_ > i.w_ ? t : i;
}
class Kn {
  constructor(i) {
    this.av = null, this.ov = null, this.S = null, this._v = false, this.Tf = size({ width: 0, height: 0 }), this.uv = new M(), this.Rf = new Ut(5), this.Bf = false, this.Af = () => {
      this.Bf || this.xp.Ut().Ch();
    }, this.Lf = () => {
      this.Bf || this.xp.Ut().Ch();
    }, this.xp = i, this.un = i.F().layout, this.cv = document.createElement("tr"), this.dv = document.createElement("td"), this.dv.style.padding = "0", this.fv = document.createElement("td"), this.fv.style.padding = "0", this.Ef = document.createElement("td"), this.Ef.style.height = "25px", this.Ef.style.padding = "0", this.pv = document.createElement("div"), this.pv.style.width = "100%", this.pv.style.height = "100%", this.pv.style.position = "relative", this.pv.style.overflow = "hidden", this.Ef.appendChild(this.pv), this.zf = On(this.pv, size({ width: 16, height: 16 })), this.zf.subscribeSuggestedBitmapSizeChanged(this.Af);
    const n = this.zf.canvasElement;
    n.style.position = "absolute", n.style.zIndex = "1", n.style.left = "0", n.style.top = "0", this.Vf = On(this.pv, size({ width: 16, height: 16 })), this.Vf.subscribeSuggestedBitmapSizeChanged(this.Lf);
    const s = this.Vf.canvasElement;
    s.style.position = "absolute", s.style.zIndex = "2", s.style.left = "0", s.style.top = "0", this.cv.appendChild(this.dv), this.cv.appendChild(this.Ef), this.cv.appendChild(this.fv), this.vv(), this.xp.Ut().Po().l(this.vv.bind(this), this), this.qf = new In(this.Vf.canvasElement, this, { Zd: () => true, Kd: () => false });
  }
  M() {
    this.qf.M(), null !== this.av && this.av.M(), null !== this.ov && this.ov.M(), this.Vf.unsubscribeSuggestedBitmapSizeChanged(this.Lf), this.Vf.dispose(), this.zf.unsubscribeSuggestedBitmapSizeChanged(this.Af), this.zf.dispose();
  }
  Yf() {
    return this.cv;
  }
  mv() {
    return this.av;
  }
  bv() {
    return this.ov;
  }
  _f(t) {
    if (this._v)
      return;
    this._v = true;
    const i = this.xp.Ut();
    !i.yt().Ni() && this.xp.F().handleScale.axisPressedMouseMove.time && i.bc(t.localX);
  }
  lf(t) {
    this._f(t);
  }
  uf() {
    const t = this.xp.Ut();
    !t.yt().Ni() && this._v && (this._v = false, this.xp.F().handleScale.axisPressedMouseMove.time && t.kc());
  }
  Qd(t) {
    const i = this.xp.Ut();
    !i.yt().Ni() && this.xp.F().handleScale.axisPressedMouseMove.time && i.yc(t.localX);
  }
  Gd(t) {
    this.Qd(t);
  }
  sf() {
    this._v = false;
    const t = this.xp.Ut();
    t.yt().Ni() && !this.xp.F().handleScale.axisPressedMouseMove.time || t.kc();
  }
  if() {
    this.sf();
  }
  zd() {
    this.xp.F().handleScale.axisDoubleClickReset.time && this.xp.Ut().Zn();
  }
  Od() {
    this.zd();
  }
  Hd() {
    this.xp.Ut().F().handleScale.axisPressedMouseMove.time && this.op(1);
  }
  wf() {
    this.op(0);
  }
  qp() {
    return this.Tf;
  }
  gv() {
    return this.uv;
  }
  wv(i, s, e2) {
    equalSizes(this.Tf, i) || (this.Tf = i, this.Bf = true, this.zf.resizeCanvasElement(i), this.Vf.resizeCanvasElement(i), this.Bf = false, this.Ef.style.width = `${i.width}px`, this.Ef.style.height = `${i.height}px`, this.uv.m(i)), null !== this.av && this.av.Jf(size({ width: s, height: i.height })), null !== this.ov && this.ov.Jf(size({ width: e2, height: i.height }));
  }
  Mv() {
    const t = this.Sv();
    return Math.ceil(t.k + t.C + t.T + t.I + t.A + t.xv);
  }
  gt() {
    this.xp.Ut().yt().Jl();
  }
  lp() {
    return this.zf.bitmapSize;
  }
  ap(t, i, n) {
    const s = this.lp();
    s.width > 0 && s.height > 0 && t.drawImage(this.zf.canvasElement, i, n);
  }
  ip(t) {
    if (0 === t)
      return;
    if (1 !== t) {
      this.zf.applySuggestedBitmapSize();
      const i2 = tryCreateCanvasRenderingTarget2D(this.zf);
      null !== i2 && (i2.useBitmapCoordinateSpace((t2) => {
        this.sp(t2), this.ye(t2);
      }), this.ep(i2)), null !== this.av && this.av.ip(t), null !== this.ov && this.ov.ip(t);
    }
    this.Vf.applySuggestedBitmapSize();
    const i = tryCreateCanvasRenderingTarget2D(this.Vf);
    null !== i && (i.useBitmapCoordinateSpace(({ context: t2, bitmapSize: i2 }) => {
      t2.clearRect(0, 0, i2.width, i2.height);
    }), this.yv([this.xp.Ut().dc()], i));
  }
  sp({ context: t, bitmapSize: i }) {
    $(t, 0, 0, i.width, i.height, this.xp.Ut().Ic());
  }
  ye({ context: t, bitmapSize: i, verticalPixelRatio: n }) {
    if (this.xp.F().timeScale.borderVisible) {
      t.fillStyle = this.kv();
      const s = Math.max(1, Math.floor(this.Sv().k * n));
      t.fillRect(0, 0, i.width, s);
    }
  }
  ep(t) {
    const i = this.xp.Ut().yt(), n = i.Jl();
    if (!n || 0 === n.length)
      return;
    let s = n.reduce(Zn, n[0]).w_;
    s > 30 && s < 50 && (s = 30);
    const e2 = this.Sv(), r2 = i.F();
    r2.borderVisible && r2.ticksVisible && t.useBitmapCoordinateSpace(({ context: t2, horizontalPixelRatio: i2, verticalPixelRatio: s2 }) => {
      t2.strokeStyle = this.kv(), t2.fillStyle = this.kv();
      const r3 = Math.max(1, Math.floor(i2)), h3 = Math.floor(0.5 * i2);
      t2.beginPath();
      const l2 = Math.round(e2.C * s2);
      for (let s3 = n.length; s3--; ) {
        const e3 = Math.round(n[s3].Yl * i2);
        t2.rect(e3 - h3, 0, r3, l2);
      }
      t2.fill();
    }), t.useMediaCoordinateSpace(({ context: t2 }) => {
      const i2 = e2.k + e2.C + e2.I + e2.T / 2;
      t2.textAlign = "center", t2.textBaseline = "middle", t2.fillStyle = this.$(), t2.font = this.Kf();
      for (const e3 of n)
        if (e3.w_ < s) {
          const n2 = e3.cu ? this.Cv(t2, e3.Yl, e3.ua) : e3.Yl;
          t2.fillText(e3.ua, n2, i2);
        }
      t2.font = this.Tv();
      for (const e3 of n)
        if (e3.w_ >= s) {
          const n2 = e3.cu ? this.Cv(t2, e3.Yl, e3.ua) : e3.Yl;
          t2.fillText(e3.ua, n2, i2);
        }
    });
  }
  Cv(t, i, n) {
    const s = this.Rf.Si(t, n), e2 = s / 2, r2 = Math.floor(i - e2) + 0.5;
    return r2 < 0 ? i += Math.abs(0 - r2) : r2 + s > this.Tf.width && (i -= Math.abs(this.Tf.width - (r2 + s))), i;
  }
  yv(t, i) {
    const n = this.Sv();
    for (const s of t)
      for (const t2 of s.Qi())
        t2.Mt().X(i, n);
  }
  kv() {
    return this.xp.F().timeScale.borderColor;
  }
  $() {
    return this.un.textColor;
  }
  W() {
    return this.un.fontSize;
  }
  Kf() {
    return B(this.W(), this.un.fontFamily);
  }
  Tv() {
    return B(this.W(), this.un.fontFamily, "bold");
  }
  Sv() {
    null === this.S && (this.S = { k: 1, V: NaN, I: NaN, A: NaN, ji: NaN, C: 5, T: NaN, P: "", Wi: new Ut(), xv: 0 });
    const t = this.S, i = this.Kf();
    if (t.P !== i) {
      const n = this.W();
      t.T = n, t.P = i, t.I = 3 * n / 12, t.A = 3 * n / 12, t.ji = 9 * n / 12, t.V = 0, t.xv = 4 * n / 12, t.Wi.Fe();
    }
    return this.S;
  }
  op(t) {
    this.Ef.style.cursor = 1 === t ? "ew-resize" : "default";
  }
  vv() {
    const t = this.xp.Ut(), i = t.F();
    i.leftPriceScale.visible || null === this.av || (this.dv.removeChild(this.av.Yf()), this.av.M(), this.av = null), i.rightPriceScale.visible || null === this.ov || (this.fv.removeChild(this.ov.Yf()), this.ov.M(), this.ov = null);
    const n = { Rc: this.xp.Ut().Rc() }, s = () => i.leftPriceScale.borderVisible && t.yt().F().borderVisible, e2 = () => t.Ic();
    i.leftPriceScale.visible && null === this.av && (this.av = new Xn("left", i, n, s, e2), this.dv.appendChild(this.av.Yf())), i.rightPriceScale.visible && null === this.ov && (this.ov = new Xn("right", i, n, s, e2), this.fv.appendChild(this.ov.Yf()));
  }
}
const Gn = !!Cn && !!navigator.userAgentData && navigator.userAgentData.brands.some((t) => t.brand.includes("Chromium")) && !!Cn && ((null === (Jn = null === navigator || void 0 === navigator ? void 0 : navigator.userAgentData) || void 0 === Jn ? void 0 : Jn.platform) ? "Windows" === navigator.userAgentData.platform : navigator.userAgent.toLowerCase().indexOf("win") >= 0);
var Jn;
class Qn {
  constructor(t, i) {
    var n;
    this.Pv = [], this.Rv = 0, this.fa = 0, this.vo = 0, this.Dv = 0, this.Bv = 0, this.Av = null, this.Ov = false, this.pp = new M(), this.Xu = new M(), this.Lv = null, this.Iv = t, this.un = i, this.cv = document.createElement("div"), this.cv.classList.add("tv-lightweight-charts"), this.cv.style.overflow = "hidden", this.cv.style.width = "100%", this.cv.style.height = "100%", (n = this.cv).style.userSelect = "none", n.style.webkitUserSelect = "none", n.style.msUserSelect = "none", n.style.MozUserSelect = "none", n.style.webkitTapHighlightColor = "transparent", this.Ev = document.createElement("table"), this.Ev.setAttribute("cellspacing", "0"), this.cv.appendChild(this.Ev), this.zv = this.Vv.bind(this), ts(this.un) && this.Nv(true), this.Hi = new xn(this.Ku.bind(this), this.un), this.Ut().fc().l(this.Fv.bind(this), this), this.Wv = new Kn(this), this.Ev.appendChild(this.Wv.Yf());
    const s = i.autoSize && this.jv();
    let e2 = this.un.width, r2 = this.un.height;
    if (s || 0 === e2 || 0 === r2) {
      const i2 = t.getBoundingClientRect();
      e2 = e2 || i2.width, r2 = r2 || i2.height;
    }
    this.$v(e2, r2), this.Hv(), t.appendChild(this.cv), this.Uv(), this.Hi.yt().yu().l(this.Hi.dl.bind(this.Hi), this), this.Hi.Po().l(this.Hi.dl.bind(this.Hi), this);
  }
  Ut() {
    return this.Hi;
  }
  F() {
    return this.un;
  }
  qv() {
    return this.Pv;
  }
  Yv() {
    return this.Wv;
  }
  M() {
    this.Nv(false), 0 !== this.Rv && window.cancelAnimationFrame(this.Rv), this.Hi.fc().v(this), this.Hi.yt().yu().v(this), this.Hi.Po().v(this), this.Hi.M();
    for (const t of this.Pv)
      this.Ev.removeChild(t.Yf()), t.jp().v(this), t.M();
    this.Pv = [], _(this.Wv).M(), null !== this.cv.parentElement && this.cv.parentElement.removeChild(this.cv), this.Xu.M(), this.pp.M(), this.Xv();
  }
  $v(i, n, s = false) {
    if (this.fa === n && this.vo === i)
      return;
    const e2 = function(i2) {
      const n2 = Math.floor(i2.width), s2 = Math.floor(i2.height);
      return size({ width: n2 - n2 % 2, height: s2 - s2 % 2 });
    }(size({ width: i, height: n }));
    this.fa = e2.height, this.vo = e2.width;
    const r2 = this.fa + "px", h3 = this.vo + "px";
    _(this.cv).style.height = r2, _(this.cv).style.width = h3, this.Ev.style.height = r2, this.Ev.style.width = h3, s ? this.Zv(et.ss(), performance.now()) : this.Hi.dl();
  }
  ip(t) {
    void 0 === t && (t = et.ss());
    for (let i = 0; i < this.Pv.length; i++)
      this.Pv[i].ip(t.jn(i).Nn);
    this.un.timeScale.visible && this.Wv.ip(t.Wn());
  }
  kh(t) {
    const i = ts(this.un);
    this.Hi.kh(t);
    const n = ts(this.un);
    n !== i && this.Nv(n), this.Uv(), this.Kv(t);
  }
  jp() {
    return this.pp;
  }
  fc() {
    return this.Xu;
  }
  Gv() {
    null !== this.Av && (this.Zv(this.Av, performance.now()), this.Av = null);
    const t = this.Jv(null), i = document.createElement("canvas");
    i.width = t.width, i.height = t.height;
    const n = _(i.getContext("2d"));
    return this.Jv(n), i;
  }
  Qv(t) {
    if ("left" === t && !this.tm())
      return 0;
    if ("right" === t && !this.im())
      return 0;
    if (0 === this.Pv.length)
      return 0;
    return _("left" === t ? this.Pv[0].Jp() : this.Pv[0].Qp()).Qf();
  }
  nm() {
    return this.un.autoSize && null !== this.Lv;
  }
  Kv(t) {
    (void 0 !== t.autoSize || !this.Lv || void 0 === t.width && void 0 === t.height) && (t.autoSize && !this.Lv && this.jv(), false === t.autoSize && null !== this.Lv && this.Xv(), t.autoSize || void 0 === t.width && void 0 === t.height || this.$v(t.width || this.vo, t.height || this.fa));
  }
  Jv(i) {
    let n = 0, s = 0;
    const e2 = this.Pv[0], r2 = (t, n2) => {
      let s2 = 0;
      for (let e3 = 0; e3 < this.Pv.length; e3++) {
        const r3 = this.Pv[e3], h4 = _("left" === t ? r3.Jp() : r3.Qp()), l2 = h4.lp();
        null !== i && h4.ap(i, n2, s2), s2 += l2.height;
      }
    };
    if (this.tm()) {
      r2("left", 0);
      n += _(e2.Jp()).lp().width;
    }
    for (let t = 0; t < this.Pv.length; t++) {
      const e3 = this.Pv[t], r3 = e3.lp();
      null !== i && e3.ap(i, n, s), s += r3.height;
    }
    if (n += e2.lp().width, this.im()) {
      r2("right", n);
      n += _(e2.Qp()).lp().width;
    }
    const h3 = (t, n2, s2) => {
      _("left" === t ? this.Wv.mv() : this.Wv.bv()).ap(_(i), n2, s2);
    };
    if (this.un.timeScale.visible) {
      const t = this.Wv.lp();
      if (null !== i) {
        let n2 = 0;
        this.tm() && (h3("left", n2, s), n2 = _(e2.Jp()).lp().width), this.Wv.ap(i, n2, s), n2 += t.width, this.im() && h3("right", n2, s);
      }
      s += t.height;
    }
    return size({ width: n, height: s });
  }
  sm() {
    let i = 0, n = 0, s = 0;
    for (const t of this.Pv)
      this.tm() && (n = Math.max(n, _(t.Jp()).Zf())), this.im() && (s = Math.max(s, _(t.Qp()).Zf())), i += t.Ro();
    n = Rn(n), s = Rn(s);
    const e2 = this.vo, r2 = this.fa, h3 = Math.max(e2 - n - s, 0), l2 = this.un.timeScale.visible;
    let a2 = l2 ? this.Wv.Mv() : 0;
    var o2;
    a2 = (o2 = a2) + o2 % 2;
    const u2 = 0 + a2, c2 = r2 < u2 ? 0 : r2 - u2, d2 = c2 / i;
    let f2 = 0;
    for (let i2 = 0; i2 < this.Pv.length; ++i2) {
      const e3 = this.Pv[i2];
      e3.Dp(this.Hi.uc()[i2]);
      let r3 = 0, l3 = 0;
      l3 = i2 === this.Pv.length - 1 ? c2 - f2 : Math.round(e3.Ro() * d2), r3 = Math.max(l3, 2), f2 += r3, e3.Jf(size({ width: h3, height: r3 })), this.tm() && e3.Up(n, "left"), this.im() && e3.Up(s, "right"), e3.tp() && this.Hi.vc(e3.tp(), r3);
    }
    this.Wv.wv(size({ width: l2 ? h3 : 0, height: a2 }), l2 ? n : 0, l2 ? s : 0), this.Hi.Bo(h3), this.Dv !== n && (this.Dv = n), this.Bv !== s && (this.Bv = s);
  }
  Nv(t) {
    t ? this.cv.addEventListener("wheel", this.zv, { passive: false }) : this.cv.removeEventListener("wheel", this.zv);
  }
  rm(t) {
    switch (t.deltaMode) {
      case t.DOM_DELTA_PAGE:
        return 120;
      case t.DOM_DELTA_LINE:
        return 32;
    }
    return Gn ? 1 / window.devicePixelRatio : 1;
  }
  Vv(t) {
    if (!(0 !== t.deltaX && this.un.handleScroll.mouseWheel || 0 !== t.deltaY && this.un.handleScale.mouseWheel))
      return;
    const i = this.rm(t), n = i * t.deltaX / 100, s = -i * t.deltaY / 100;
    if (t.cancelable && t.preventDefault(), 0 !== s && this.un.handleScale.mouseWheel) {
      const i2 = Math.sign(s) * Math.min(1, Math.abs(s)), n2 = t.clientX - this.cv.getBoundingClientRect().left;
      this.Ut().gc(n2, i2);
    }
    0 !== n && this.un.handleScroll.mouseWheel && this.Ut().wc(-80 * n);
  }
  Zv(t, i) {
    var n;
    const s = t.Wn();
    3 === s && this.hm(), 3 !== s && 2 !== s || (this.lm(t), this.am(t, i), this.Wv.gt(), this.Pv.forEach((t2) => {
      t2.Ap();
    }), 3 === (null === (n = this.Av) || void 0 === n ? void 0 : n.Wn()) && (this.Av.Qn(t), this.hm(), this.lm(this.Av), this.am(this.Av, i), t = this.Av, this.Av = null)), this.ip(t);
  }
  am(t, i) {
    for (const n of t.Jn())
      this.ts(n, i);
  }
  lm(t) {
    const i = this.Hi.uc();
    for (let n = 0; n < i.length; n++)
      t.jn(n).Fn && i[n].Yo();
  }
  ts(t, i) {
    const n = this.Hi.yt();
    switch (t.Un) {
      case 0:
        n.Cu();
        break;
      case 1:
        n.Tu(t.At);
        break;
      case 2:
        n.Kn(t.At);
        break;
      case 3:
        n.Gn(t.At);
        break;
      case 4:
        n.du();
        break;
      case 5:
        t.At.wu(i) || n.Gn(t.At.Mu(i));
    }
  }
  Ku(t) {
    null !== this.Av ? this.Av.Qn(t) : this.Av = t, this.Ov || (this.Ov = true, this.Rv = window.requestAnimationFrame((t2) => {
      if (this.Ov = false, this.Rv = 0, null !== this.Av) {
        const i = this.Av;
        this.Av = null, this.Zv(i, t2);
        for (const n of i.Jn())
          if (5 === n.Un && !n.At.wu(t2)) {
            this.Ut().Yn(n.At);
            break;
          }
      }
    }));
  }
  hm() {
    this.Hv();
  }
  Hv() {
    const t = this.Hi.uc(), i = t.length, n = this.Pv.length;
    for (let t2 = i; t2 < n; t2++) {
      const t3 = o(this.Pv.pop());
      this.Ev.removeChild(t3.Yf()), t3.jp().v(this), t3.M();
    }
    for (let s = n; s < i; s++) {
      const i2 = new Yn(this, t[s]);
      i2.jp().l(this.om.bind(this), this), this.Pv.push(i2), this.Ev.insertBefore(i2.Yf(), this.Wv.Yf());
    }
    for (let n2 = 0; n2 < i; n2++) {
      const i2 = t[n2], s = this.Pv[n2];
      s.tp() !== i2 ? s.Dp(i2) : s.Rp();
    }
    this.Uv(), this.sm();
  }
  _m(t, i, n) {
    var s;
    const e2 = /* @__PURE__ */ new Map();
    if (null !== t) {
      this.Hi.wt().forEach((i2) => {
        const n2 = i2.Ln().jh(t);
        null !== n2 && e2.set(i2, n2);
      });
    }
    let r2;
    if (null !== t) {
      const i2 = null === (s = this.Hi.yt().Ui(t)) || void 0 === s ? void 0 : s.M_;
      void 0 !== i2 && (r2 = i2);
    }
    const h3 = this.Ut().hc(), l2 = null !== h3 && h3.ac instanceof Pi ? h3.ac : void 0, a2 = null !== h3 && void 0 !== h3.Ep ? h3.Ep.nr : void 0;
    return { _t: r2, Ys: null != t ? t : void 0, um: null != i ? i : void 0, dm: l2, fm: e2, pm: a2, vm: null != n ? n : void 0 };
  }
  om(t, i, n) {
    this.pp.m(() => this._m(t, i, n));
  }
  Fv(t, i, n) {
    this.Xu.m(() => this._m(t, i, n));
  }
  Uv() {
    const t = this.un.timeScale.visible ? "" : "none";
    this.Wv.Yf().style.display = t;
  }
  tm() {
    return this.Pv[0].tp().zo().F().visible;
  }
  im() {
    return this.Pv[0].tp().Vo().F().visible;
  }
  jv() {
    return "ResizeObserver" in window && (this.Lv = new ResizeObserver((t) => {
      const i = t.find((t2) => t2.target === this.Iv);
      i && this.$v(i.contentRect.width, i.contentRect.height);
    }), this.Lv.observe(this.Iv, { box: "border-box" }), true);
  }
  Xv() {
    null !== this.Lv && this.Lv.disconnect();
  }
}
function ts(t) {
  return Boolean(t.handleScroll.mouseWheel || t.handleScale.mouseWheel);
}
function is(t, i, n, s) {
  const e2 = n.value, r2 = { Ys: i, _t: t, At: [e2, e2, e2, e2], M_: s };
  return void 0 !== n.color && (r2.D = n.color), r2;
}
function ns(t) {
  return void 0 !== t.At;
}
function ss(t) {
  return (i, n, s, e2) => {
    return void 0 === (r2 = s).open && void 0 === r2.value ? { _t: i, Ys: n, M_: e2 } : t(i, n, s, e2);
    var r2;
  };
}
const es = { Candlestick: ss(function(t, i, n, s) {
  const e2 = { Ys: i, _t: t, At: [n.open, n.high, n.low, n.close], M_: s };
  return void 0 !== n.color && (e2.D = n.color), void 0 !== n.borderColor && (e2.Ot = n.borderColor), void 0 !== n.wickColor && (e2.Dh = n.wickColor), e2;
}), Bar: ss(function(t, i, n, s) {
  const e2 = { Ys: i, _t: t, At: [n.open, n.high, n.low, n.close], M_: s };
  return void 0 !== n.color && (e2.D = n.color), e2;
}), Area: ss(function(t, i, n, s) {
  const e2 = n.value, r2 = { Ys: i, _t: t, At: [e2, e2, e2, e2], M_: s };
  return void 0 !== n.lineColor && (r2.ot = n.lineColor), void 0 !== n.topColor && (r2.bs = n.topColor), void 0 !== n.bottomColor && (r2.gs = n.bottomColor), r2;
}), Baseline: ss(function(t, i, n, s) {
  const e2 = n.value, r2 = { Ys: i, _t: t, At: [e2, e2, e2, e2], M_: s };
  return void 0 !== n.topLineColor && (r2.be = n.topLineColor), void 0 !== n.bottomLineColor && (r2.ge = n.bottomLineColor), void 0 !== n.topFillColor1 && (r2.de = n.topFillColor1), void 0 !== n.topFillColor2 && (r2.fe = n.topFillColor2), void 0 !== n.bottomFillColor1 && (r2.pe = n.bottomFillColor1), void 0 !== n.bottomFillColor2 && (r2.ve = n.bottomFillColor2), r2;
}), Histogram: ss(is), Line: ss(is) };
function rs(t) {
  return es[t];
}
function hs(t) {
  return 60 * t * 60 * 1e3;
}
function ls(t) {
  return 60 * t * 1e3;
}
const as = [{ bm: (os = 1, 1e3 * os), w_: 10 }, { bm: ls(1), w_: 20 }, { bm: ls(5), w_: 21 }, { bm: ls(30), w_: 22 }, { bm: hs(1), w_: 30 }, { bm: hs(3), w_: 31 }, { bm: hs(6), w_: 32 }, { bm: hs(12), w_: 33 }];
var os;
function _s(t, i) {
  if (t.getUTCFullYear() !== i.getUTCFullYear())
    return 70;
  if (t.getUTCMonth() !== i.getUTCMonth())
    return 60;
  if (t.getUTCDate() !== i.getUTCDate())
    return 50;
  for (let n = as.length - 1; n >= 0; --n)
    if (Math.floor(i.getTime() / as[n].bm) !== Math.floor(t.getTime() / as[n].bm))
      return as[n].w_;
  return 0;
}
function us(t, i = 0) {
  if (0 === t.length)
    return;
  let n = 0 === i ? null : t[i - 1]._t.u_, s = null !== n ? new Date(1e3 * n) : null, e2 = 0;
  for (let r2 = i; r2 < t.length; ++r2) {
    const i2 = t[r2], h3 = new Date(1e3 * i2._t.u_);
    null !== s && (i2.g_ = _s(h3, s)), e2 += i2._t.u_ - (n || i2._t.u_), n = i2._t.u_, s = h3;
  }
  if (0 === i && t.length > 1) {
    const i2 = Math.ceil(e2 / (t.length - 1)), n2 = new Date(1e3 * (t[0]._t.u_ - i2));
    t[0].g_ = _s(new Date(1e3 * t[0]._t.u_), n2);
  }
}
function cs(t) {
  if (!yn(t))
    throw new Error("time must be of type BusinessDay");
  const i = new Date(Date.UTC(t.year, t.month - 1, t.day, 0, 0, 0, 0));
  return { u_: Math.round(i.getTime() / 1e3), __: t };
}
function ds(t) {
  if (!kn(t))
    throw new Error("time must be of type isUTCTimestamp");
  return { u_: t };
}
function fs(t) {
  return 0 === t.length ? null : yn(t[0].time) ? cs : ds;
}
function ps(t) {
  return kn(t) ? ds(t) : yn(t) ? cs(t) : cs(vs(t));
}
function vs(t) {
  const i = new Date(t);
  if (isNaN(i.getTime()))
    throw new Error(`Invalid date string=${t}, expected format=yyyy-mm-dd`);
  return { day: i.getUTCDate(), month: i.getUTCMonth() + 1, year: i.getUTCFullYear() };
}
function ms(t) {
  k(t.time) && (t.time = vs(t.time));
}
function bs(t) {
  return { Ys: 0, gm: /* @__PURE__ */ new Map(), yl: t };
}
function gs(t) {
  if (void 0 !== t && 0 !== t.length)
    return { wm: t[0]._t.u_, Mm: t[t.length - 1]._t.u_ };
}
function ws(t) {
  let i;
  return t.forEach((t2) => {
    void 0 === i && (i = t2.M_);
  }), o(i);
}
function Ms(t) {
  void 0 === t.M_ && (t.M_ = t.time);
}
class Ss {
  constructor() {
    this.Sm = /* @__PURE__ */ new Map(), this.xm = /* @__PURE__ */ new Map(), this.ym = /* @__PURE__ */ new Map(), this.km = [];
  }
  M() {
    this.Sm.clear(), this.xm.clear(), this.ym.clear(), this.km = [];
  }
  Cm(t, i) {
    let n = 0 !== this.Sm.size, s = false;
    const e2 = this.xm.get(t);
    if (void 0 !== e2)
      if (1 === this.xm.size)
        n = false, s = true, this.Sm.clear();
      else
        for (const i2 of this.km)
          i2.pointData.gm.delete(t) && (s = true);
    let r2 = [];
    if (0 !== i.length) {
      const n2 = i;
      n2.forEach((t2) => Ms(t2)), function(t2) {
        t2.forEach(ms);
      }(i);
      const e3 = _(fs(i)), h4 = rs(t.Lh());
      r2 = n2.map((i2) => {
        const n3 = e3(i2.time);
        let r3 = this.Sm.get(n3.u_);
        void 0 === r3 && (r3 = bs(n3), this.Sm.set(n3.u_, r3), s = true);
        const l2 = h4(n3, r3.Ys, i2, i2.M_);
        return r3.gm.set(t, l2), l2;
      });
    }
    n && this.Tm(), this.Pm(t, r2);
    let h3 = -1;
    if (s) {
      const t2 = [];
      this.Sm.forEach((i2) => {
        t2.push({ g_: 0, _t: i2.yl, pointData: i2, M_: ws(i2.gm) });
      }), t2.sort((t3, i2) => t3._t.u_ - i2._t.u_), h3 = this.Rm(t2);
    }
    return this.Dm(t, h3, function(t2, i2) {
      const n2 = gs(t2), s2 = gs(i2);
      if (void 0 !== n2 && void 0 !== s2)
        return { ml: n2.Mm >= s2.Mm && n2.wm >= s2.wm };
    }(this.xm.get(t), e2));
  }
  Ac(t) {
    return this.Cm(t, []);
  }
  Bm(t, i) {
    const n = i;
    Ms(n), ms(i);
    const s = _(fs([i]))(i.time), e2 = this.ym.get(t);
    if (void 0 !== e2 && s.u_ < e2.u_)
      throw new Error(`Cannot update oldest data, last time=${e2.u_}, new time=${s.u_}`);
    let r2 = this.Sm.get(s.u_);
    const h3 = void 0 === r2;
    void 0 === r2 && (r2 = bs(s), this.Sm.set(s.u_, r2));
    const l2 = rs(t.Lh())(s, r2.Ys, i, n.M_);
    r2.gm.set(t, l2), this.Am(t, l2);
    const a2 = { ml: ns(l2) };
    if (!h3)
      return this.Dm(t, -1, a2);
    const o2 = { g_: 0, _t: r2.yl, pointData: r2, M_: ws(r2.gm) }, u2 = Mt(this.km, o2._t.u_, (t2, i2) => t2._t.u_ < i2);
    this.km.splice(u2, 0, o2);
    for (let t2 = u2; t2 < this.km.length; ++t2)
      xs(this.km[t2].pointData, t2);
    return us(this.km, u2), this.Dm(t, u2, a2);
  }
  Am(t, i) {
    let n = this.xm.get(t);
    void 0 === n && (n = [], this.xm.set(t, n));
    const s = 0 !== n.length ? n[n.length - 1] : null;
    null === s || i._t.u_ > s._t.u_ ? ns(i) && n.push(i) : ns(i) ? n[n.length - 1] = i : n.splice(-1, 1), this.ym.set(t, i._t);
  }
  Pm(t, i) {
    0 !== i.length ? (this.xm.set(t, i.filter(ns)), this.ym.set(t, i[i.length - 1]._t)) : (this.xm.delete(t), this.ym.delete(t));
  }
  Tm() {
    for (const t of this.km)
      0 === t.pointData.gm.size && this.Sm.delete(t._t.u_);
  }
  Rm(t) {
    let i = -1;
    for (let n = 0; n < this.km.length && n < t.length; ++n) {
      const s = this.km[n], e2 = t[n];
      if (s._t.u_ !== e2._t.u_) {
        i = n;
        break;
      }
      e2.g_ = s.g_, xs(e2.pointData, n);
    }
    if (-1 === i && this.km.length !== t.length && (i = Math.min(this.km.length, t.length)), -1 === i)
      return -1;
    for (let n = i; n < t.length; ++n)
      xs(t[n].pointData, n);
    return us(t, i), this.km = t, i;
  }
  Om() {
    if (0 === this.xm.size)
      return null;
    let t = 0;
    return this.xm.forEach((i) => {
      0 !== i.length && (t = Math.max(t, i[i.length - 1].Ys));
    }), t;
  }
  Dm(t, i, n) {
    const s = { Lm: /* @__PURE__ */ new Map(), yt: { eu: this.Om() } };
    if (-1 !== i)
      this.xm.forEach((i2, e2) => {
        s.Lm.set(e2, { ar: i2, Im: e2 === t ? n : void 0 });
      }), this.xm.has(t) || s.Lm.set(t, { ar: [], Im: n }), s.yt.Em = this.km, s.yt.zm = i;
    else {
      const i2 = this.xm.get(t);
      s.Lm.set(t, { ar: i2 || [], Im: n });
    }
    return s;
  }
}
function xs(t, i) {
  t.Ys = i, t.gm.forEach((t2) => {
    t2.Ys = i;
  });
}
function ys(t) {
  return { value: t.At[3], time: t.M_ };
}
function ks(t) {
  const i = ys(t);
  return void 0 !== t.D && (i.color = t.D), i;
}
function Cs(t) {
  return { open: t.At[0], high: t.At[1], low: t.At[2], close: t.At[3], time: t.M_ };
}
const Ts = { Area: function(t) {
  const i = ys(t);
  return void 0 !== t.ot && (i.lineColor = t.ot), void 0 !== t.bs && (i.topColor = t.bs), void 0 !== t.gs && (i.bottomColor = t.gs), i;
}, Line: ks, Baseline: function(t) {
  const i = ys(t);
  return void 0 !== t.be && (i.topLineColor = t.be), void 0 !== t.ge && (i.bottomLineColor = t.ge), void 0 !== t.de && (i.topFillColor1 = t.de), void 0 !== t.fe && (i.topFillColor2 = t.fe), void 0 !== t.pe && (i.bottomFillColor1 = t.pe), void 0 !== t.ve && (i.bottomFillColor2 = t.ve), i;
}, Histogram: ks, Bar: function(t) {
  const i = Cs(t);
  return void 0 !== t.D && (i.color = t.D), i;
}, Candlestick: function(t) {
  const i = Cs(t), { D: n, Ot: s, Dh: e2 } = t;
  return void 0 !== n && (i.color = n), void 0 !== s && (i.borderColor = s), void 0 !== e2 && (i.wickColor = e2), i;
} };
function Ps(t) {
  return Ts[t];
}
const Rs = { autoScale: true, mode: 0, invertScale: false, alignLabels: true, borderVisible: true, borderColor: "#2B2B43", entireTextOnly: false, visible: false, ticksVisible: false, scaleMargins: { bottom: 0.1, top: 0.2 } }, Ds = { color: "rgba(0, 0, 0, 0)", visible: false, fontSize: 48, fontFamily: D, fontStyle: "", text: "", horzAlign: "center", vertAlign: "center" }, Bs = { width: 0, height: 0, autoSize: false, layout: { background: { type: "solid", color: "#FFFFFF" }, textColor: "#191919", fontSize: 12, fontFamily: D }, crosshair: { vertLine: { color: "#9598A1", width: 1, style: 3, visible: true, labelVisible: true, labelBackgroundColor: "#131722" }, horzLine: { color: "#9598A1", width: 1, style: 3, visible: true, labelVisible: true, labelBackgroundColor: "#131722" }, mode: 1 }, grid: { vertLines: { color: "#D6DCDE", style: 0, visible: true }, horzLines: { color: "#D6DCDE", style: 0, visible: true } }, overlayPriceScales: Object.assign({}, Rs), leftPriceScale: Object.assign(Object.assign({}, Rs), { visible: false }), rightPriceScale: Object.assign(Object.assign({}, Rs), { visible: true }), timeScale: { rightOffset: 0, barSpacing: 6, minBarSpacing: 0.5, fixLeftEdge: false, fixRightEdge: false, lockVisibleTimeRangeOnResize: false, rightBarStaysOnScroll: false, borderVisible: true, borderColor: "#2B2B43", visible: true, timeVisible: false, secondsVisible: true, shiftVisibleRangeOnNewBar: true, ticksVisible: false }, watermark: Ds, localization: { locale: Cn ? navigator.language : "", dateFormat: "dd MMM 'yy" }, handleScroll: { mouseWheel: true, pressedMouseMove: true, horzTouchDrag: true, vertTouchDrag: true }, handleScale: { axisPressedMouseMove: { time: true, price: true }, axisDoubleClickReset: { time: true, price: true }, mouseWheel: true, pinch: true }, kineticScroll: { mouse: false, touch: true }, trackingMode: { exitMode: 1 } }, As = { upColor: "#26a69a", downColor: "#ef5350", wickVisible: true, borderVisible: true, borderColor: "#378658", borderUpColor: "#26a69a", borderDownColor: "#ef5350", wickColor: "#737375", wickUpColor: "#26a69a", wickDownColor: "#ef5350" }, Os = { upColor: "#26a69a", downColor: "#ef5350", openVisible: true, thinBars: true }, Ls = { color: "#2196f3", lineStyle: 0, lineWidth: 3, lineType: 0, crosshairMarkerVisible: true, crosshairMarkerRadius: 4, crosshairMarkerBorderColor: "", crosshairMarkerBorderWidth: 2, crosshairMarkerBackgroundColor: "", lastPriceAnimation: 0 }, Is = { topColor: "rgba( 46, 220, 135, 0.4)", bottomColor: "rgba( 40, 221, 100, 0)", invertFilledArea: false, lineColor: "#33D778", lineStyle: 0, lineWidth: 3, lineType: 0, crosshairMarkerVisible: true, crosshairMarkerRadius: 4, crosshairMarkerBorderColor: "", crosshairMarkerBorderWidth: 2, crosshairMarkerBackgroundColor: "", lastPriceAnimation: 0 }, Es = { baseValue: { type: "price", price: 0 }, topFillColor1: "rgba(38, 166, 154, 0.28)", topFillColor2: "rgba(38, 166, 154, 0.05)", topLineColor: "rgba(38, 166, 154, 1)", bottomFillColor1: "rgba(239, 83, 80, 0.05)", bottomFillColor2: "rgba(239, 83, 80, 0.28)", bottomLineColor: "rgba(239, 83, 80, 1)", lineWidth: 3, lineStyle: 0, lineType: 0, crosshairMarkerVisible: true, crosshairMarkerRadius: 4, crosshairMarkerBorderColor: "", crosshairMarkerBorderWidth: 2, crosshairMarkerBackgroundColor: "", lastPriceAnimation: 0 }, zs = { color: "#26a69a", base: 0 }, Vs = { title: "", visible: true, lastValueVisible: true, priceLineVisible: true, priceLineSource: 0, priceLineWidth: 1, priceLineColor: "", priceLineStyle: 2, baseLineVisible: true, baseLineWidth: 1, baseLineColor: "#B2B5BE", baseLineStyle: 0, priceFormat: { type: "price", precision: 2, minMove: 0.01 } };
class Ns {
  constructor(t, i) {
    this.Vm = t, this.Nm = i;
  }
  applyOptions(t) {
    this.Vm.Ut().oc(this.Nm, t);
  }
  options() {
    return this.zi().F();
  }
  width() {
    return st(this.Nm) ? this.Vm.Qv(this.Nm) : 0;
  }
  zi() {
    return _(this.Vm.Ut()._c(this.Nm)).Bt;
  }
}
const Fs = { color: "#FF0000", price: 0, lineStyle: 2, lineWidth: 1, lineVisible: true, axisLabelVisible: true, title: "", axisLabelColor: "", axisLabelTextColor: "" };
class Ws {
  constructor(t) {
    this.wh = t;
  }
  applyOptions(t) {
    this.wh.kh(t);
  }
  options() {
    return this.wh.F();
  }
  Fm() {
    return this.wh;
  }
}
class js {
  constructor(t, i, n) {
    this.Ts = t, this.Wm = i, this.jm = n;
  }
  priceFormatter() {
    return this.Ts.Bl();
  }
  priceToCoordinate(t) {
    const i = this.Ts.Tt();
    return null === i ? null : this.Ts.Bt().Dt(t, i.At);
  }
  coordinateToPrice(t) {
    const i = this.Ts.Tt();
    return null === i ? null : this.Ts.Bt().pn(t, i.At);
  }
  barsInLogicalRange(t) {
    if (null === t)
      return null;
    const i = new dn(new _n(t.from, t.to)).C_(), n = this.Ts.Ln();
    if (n.Ni())
      return null;
    const s = n.jh(i.Ms(), 1), e2 = n.jh(i.ci(), -1), r2 = _(n.Nh()), h3 = _(n.On());
    if (null !== s && null !== e2 && s.Ys > e2.Ys)
      return { barsBefore: t.from - r2, barsAfter: h3 - t.to };
    const l2 = { barsBefore: null === s || s.Ys === r2 ? t.from - r2 : s.Ys - r2, barsAfter: null === e2 || e2.Ys === h3 ? h3 - t.to : h3 - e2.Ys };
    return null !== s && null !== e2 && (l2.from = s._t.__ || s._t.u_, l2.to = e2._t.__ || e2._t.u_), l2;
  }
  setData(t) {
    this.Ts.Lh(), this.Wm.$m(this.Ts, t);
  }
  update(t) {
    this.Ts.Lh(), this.Wm.Hm(this.Ts, t);
  }
  dataByIndex(t, i) {
    const n = this.Ts.Ln().jh(t, i);
    return null === n ? null : Ps(this.seriesType())(n);
  }
  setMarkers(t) {
    const i = t.map((t2) => Object.assign(Object.assign({}, t2), { originalTime: t2.time, time: ps(t2.time) }));
    this.Ts.gl(i);
  }
  markers() {
    return this.Ts.wl().map((t) => {
      const { originalTime: i, time: n } = t, s = function(t2, i2) {
        var n2 = {};
        for (var s2 in t2)
          Object.prototype.hasOwnProperty.call(t2, s2) && i2.indexOf(s2) < 0 && (n2[s2] = t2[s2]);
        if (null != t2 && "function" == typeof Object.getOwnPropertySymbols) {
          var e2 = 0;
          for (s2 = Object.getOwnPropertySymbols(t2); e2 < s2.length; e2++)
            i2.indexOf(s2[e2]) < 0 && Object.prototype.propertyIsEnumerable.call(t2, s2[e2]) && (n2[s2[e2]] = t2[s2[e2]]);
        }
        return n2;
      }(t, ["originalTime", "time"]);
      return Object.assign({ time: i }, s);
    });
  }
  applyOptions(t) {
    this.Ts.kh(t);
  }
  options() {
    return T(this.Ts.F());
  }
  priceScale() {
    return this.jm.priceScale(this.Ts.Bt().zl());
  }
  createPriceLine(t) {
    const i = S(T(Fs), t), n = this.Ts.Ml(i);
    return new Ws(n);
  }
  removePriceLine(t) {
    this.Ts.Sl(t.Fm());
  }
  seriesType() {
    return this.Ts.Lh();
  }
}
class $s {
  constructor(t, i) {
    this.Um = new M(), this.E_ = new M(), this.uv = new M(), this.Hi = t, this.wo = t.yt(), this.Wv = i, this.wo.Su().l(this.qm.bind(this)), this.wo.xu().l(this.Ym.bind(this)), this.Wv.gv().l(this.Xm.bind(this));
  }
  M() {
    this.wo.Su().v(this), this.wo.xu().v(this), this.Wv.gv().v(this), this.Um.M(), this.E_.M(), this.uv.M();
  }
  scrollPosition() {
    return this.wo.ou();
  }
  scrollToPosition(t, i) {
    i ? this.wo.gu(t, 1e3) : this.Hi.Gn(t);
  }
  scrollToRealTime() {
    this.wo.bu();
  }
  getVisibleRange() {
    var t, i;
    const n = this.wo.G_();
    return null === n ? null : { from: null !== (t = n.from.__) && void 0 !== t ? t : n.from.u_, to: null !== (i = n.to.__) && void 0 !== i ? i : n.to.u_ };
  }
  setVisibleRange(t) {
    const i = { from: ps(t.from), to: ps(t.to) }, n = this.wo.iu(i);
    this.Hi.Oc(n);
  }
  getVisibleLogicalRange() {
    const t = this.wo.K_();
    return null === t ? null : { from: t.Ms(), to: t.ci() };
  }
  setVisibleLogicalRange(t) {
    a(t.from <= t.to, "The from index cannot be after the to index."), this.Hi.Oc(t);
  }
  resetTimeScale() {
    this.Hi.Zn();
  }
  fitContent() {
    this.Hi.Cu();
  }
  logicalToCoordinate(t) {
    const i = this.Hi.yt();
    return i.Ni() ? null : i.Et(t);
  }
  coordinateToLogical(t) {
    return this.wo.Ni() ? null : this.wo.ru(t);
  }
  timeToCoordinate(t) {
    const i = ps(t), n = this.wo.Fl(i, false);
    return null === n ? null : this.wo.Et(n);
  }
  coordinateToTime(t) {
    var i;
    const n = this.Hi.yt(), s = n.ru(t), e2 = n.vn(s);
    return null === e2 ? null : null !== (i = e2.__) && void 0 !== i ? i : e2.u_;
  }
  width() {
    return this.Wv.qp().width;
  }
  height() {
    return this.Wv.qp().height;
  }
  subscribeVisibleTimeRangeChange(t) {
    this.Um.l(t);
  }
  unsubscribeVisibleTimeRangeChange(t) {
    this.Um.p(t);
  }
  subscribeVisibleLogicalRangeChange(t) {
    this.E_.l(t);
  }
  unsubscribeVisibleLogicalRangeChange(t) {
    this.E_.p(t);
  }
  subscribeSizeChange(t) {
    this.uv.l(t);
  }
  unsubscribeSizeChange(t) {
    this.uv.p(t);
  }
  applyOptions(t) {
    this.wo.kh(t);
  }
  options() {
    return T(this.wo.F());
  }
  qm() {
    this.Um.g() && this.Um.m(this.getVisibleRange());
  }
  Ym() {
    this.E_.g() && this.E_.m(this.getVisibleLogicalRange());
  }
  Xm(t) {
    this.uv.m(t.width, t.height);
  }
}
function Hs(t) {
  if (void 0 === t || "custom" === t.type)
    return;
  const i = t;
  void 0 !== i.minMove && void 0 === i.precision && (i.precision = function(t2) {
    if (t2 >= 1)
      return 0;
    let i2 = 0;
    for (; i2 < 8; i2++) {
      const n = Math.round(t2);
      if (Math.abs(n - t2) < 1e-8)
        return i2;
      t2 *= 10;
    }
    return i2;
  }(i.minMove));
}
function Us(t) {
  return function(t2) {
    if (C(t2.handleScale)) {
      const i2 = t2.handleScale;
      t2.handleScale = { axisDoubleClickReset: { time: i2, price: i2 }, axisPressedMouseMove: { time: i2, price: i2 }, mouseWheel: i2, pinch: i2 };
    } else if (void 0 !== t2.handleScale) {
      const { axisPressedMouseMove: i2, axisDoubleClickReset: n } = t2.handleScale;
      C(i2) && (t2.handleScale.axisPressedMouseMove = { time: i2, price: i2 }), C(n) && (t2.handleScale.axisDoubleClickReset = { time: n, price: n });
    }
    const i = t2.handleScroll;
    C(i) && (t2.handleScroll = { horzTouchDrag: i, vertTouchDrag: i, mouseWheel: i, pressedMouseMove: i });
  }(t), t;
}
class qs {
  constructor(t, i) {
    this.Zm = new Ss(), this.Km = /* @__PURE__ */ new Map(), this.Gm = /* @__PURE__ */ new Map(), this.Jm = new M(), this.Qm = new M();
    const n = void 0 === i ? T(Bs) : S(T(Bs), Us(i));
    this.Vm = new Qn(t, n), this.Vm.jp().l((t2) => {
      this.Jm.g() && this.Jm.m(this.tb(t2()));
    }, this), this.Vm.fc().l((t2) => {
      this.Qm.g() && this.Qm.m(this.tb(t2()));
    }, this);
    const s = this.Vm.Ut();
    this.ib = new $s(s, this.Vm.Yv());
  }
  remove() {
    this.Vm.jp().v(this), this.Vm.fc().v(this), this.ib.M(), this.Vm.M(), this.Km.clear(), this.Gm.clear(), this.Jm.M(), this.Qm.M(), this.Zm.M();
  }
  resize(t, i, n) {
    this.autoSizeActive() || this.Vm.$v(t, i, n);
  }
  addAreaSeries(t) {
    return this.nb("Area", Is, t);
  }
  addBaselineSeries(t) {
    return this.nb("Baseline", Es, t);
  }
  addBarSeries(t) {
    return this.nb("Bar", Os, t);
  }
  addCandlestickSeries(t = {}) {
    return function(t2) {
      void 0 !== t2.borderColor && (t2.borderUpColor = t2.borderColor, t2.borderDownColor = t2.borderColor), void 0 !== t2.wickColor && (t2.wickUpColor = t2.wickColor, t2.wickDownColor = t2.wickColor);
    }(t), this.nb("Candlestick", As, t);
  }
  addHistogramSeries(t) {
    return this.nb("Histogram", zs, t);
  }
  addLineSeries(t) {
    return this.nb("Line", Ls, t);
  }
  removeSeries(t) {
    const i = o(this.Km.get(t)), n = this.Zm.Ac(i);
    this.Vm.Ut().Ac(i), this.sb(n), this.Km.delete(t), this.Gm.delete(i);
  }
  $m(t, i) {
    this.sb(this.Zm.Cm(t, i));
  }
  Hm(t, i) {
    this.sb(this.Zm.Bm(t, i));
  }
  subscribeClick(t) {
    this.Jm.l(t);
  }
  unsubscribeClick(t) {
    this.Jm.p(t);
  }
  subscribeCrosshairMove(t) {
    this.Qm.l(t);
  }
  unsubscribeCrosshairMove(t) {
    this.Qm.p(t);
  }
  priceScale(t) {
    return new Ns(this.Vm, t);
  }
  timeScale() {
    return this.ib;
  }
  applyOptions(t) {
    this.Vm.kh(Us(t));
  }
  options() {
    return this.Vm.F();
  }
  takeScreenshot() {
    return this.Vm.Gv();
  }
  autoSizeActive() {
    return this.Vm.nm();
  }
  nb(t, i, n = {}) {
    Hs(n.priceFormat);
    const s = S(T(Vs), T(i), n), e2 = this.Vm.Ut().Dc(t, s), r2 = new js(e2, this, this);
    return this.Km.set(r2, e2), this.Gm.set(e2, r2), r2;
  }
  sb(t) {
    const i = this.Vm.Ut();
    i.Pc(t.yt.eu, t.yt.Em, t.yt.zm), t.Lm.forEach((t2, i2) => i2.tt(t2.ar, t2.Im)), i.lu();
  }
  eb(t) {
    return o(this.Gm.get(t));
  }
  tb(t) {
    const i = /* @__PURE__ */ new Map();
    t.fm.forEach((t2, n2) => {
      const s = Ps(n2.Lh())(t2);
      a(function(t3) {
        return void 0 !== t3.open || void 0 !== t3.value;
      }(s)), i.set(this.eb(n2), s);
    });
    const n = void 0 === t.dm ? void 0 : this.eb(t.dm);
    return { time: t._t, logical: t.Ys, point: t.um, hoveredSeries: n, hoveredObjectId: t.pm, seriesData: i, sourceEvent: t.vm };
  }
}
function Ys(t, i) {
  let n;
  if (k(t)) {
    const i2 = document.getElementById(t);
    a(null !== i2, `Cannot find element in DOM with id=${t}`), n = i2;
  } else
    n = t;
  return new qs(n, i);
}
const createChartOptions = () => {
  return {
    autoSize: true,
    localization: {
      locale: "zh-TW",
      dateFormat: "yyyy-MM-dd",
      priceFormatter: (p2) => p2.toFixed(1)
    },
    rightPriceScale: {
      scaleMargins: {
        top: 0.1,
        bottom: 0.1
      },
      // visible: false,
      mode: qi.Percentage,
      borderVisible: false,
      // entireTextOnly: true,
      ticksVisible: true,
      borderColor: "rgba(197, 203, 206, 1)"
    },
    timeScale: {
      borderColor: "rgba(197, 203, 206, 1)",
      borderVisible: false
    },
    handleScroll: {
      pressedMouseMove: true,
      mouseWheel: false
    },
    handleScale: {
      mouseWheel: false,
      pinch: true
    },
    layout: {
      background: {
        type: bn.Solid,
        color: "transparent"
      },
      textColor: "black"
    },
    // rightPriceScale: {
    // 	ticksVisible: false
    // },
    grid: {
      vertLines: {
        color: "rgba(197, 203, 206, 0.0)",
        style: r.Dotted,
        visible: false
      },
      horzLines: {
        color: "rgba(197, 203, 206, 0.0)",
        style: r.Dotted,
        visible: false
      }
    },
    crosshair: {
      horzLine: {
        visible: false,
        labelVisible: true
      },
      vertLine: {
        visible: false,
        style: 0,
        width: 2,
        color: "rgba(32, 38, 46, 0.1)",
        labelVisible: true
      }
    }
  };
};
class TwChart {
  constructor(htmlEle, pct) {
    this.series = [];
    this.colors = [
      "#725bf5",
      // primary
      "#777777",
      // secondary
      "#1dcdbc",
      // accent
      "#2b3440",
      // neutral
      "#ffffff",
      // base-100
      "#3abff8",
      // info
      "#36d399",
      // success
      "#fbbd23",
      // warning
      "#f87272"
      // error
    ];
    this.lightTheme = {
      layout: {
        textColor: "rgba(0, 0, 0, 0.5)"
      }
    };
    this.darkTheme = {
      layout: {
        textColor: "rgba(255, 255, 255, 0.3)"
      }
    };
    this.selectTheme = {
      light: this.lightTheme,
      dark: this.darkTheme
    };
    this.htmlEle = htmlEle;
    this.series = [];
    let options = createChartOptions();
    if (!pct) {
      options.rightPriceScale.mode = qi.Normal;
    }
    this.chart = Ys(this.htmlEle, options);
  }
  setTheme(theme) {
    if (theme) {
      this.chart.applyOptions(this.selectTheme[theme]);
    }
  }
  resetAreaSeries(i) {
    if (this.series[i]) {
      this.chart.removeSeries(this.series[i]);
    }
    const color2 = this.colors[i];
    this.series[i] = this.chart.addAreaSeries({
      lineColor: color2,
      topColor: color2 + "77",
      bottomColor: color2 + "00",
      priceLineVisible: false
      // lineWidth: 2,
    });
  }
  setTimeScale(tStart, tEnd) {
    this.chart.timeScale().setVisibleRange({ from: tStart.getTime() / 1e3, to: tEnd.getTime() / 1e3 });
  }
}
function riseHex(candle) {
  const c2 = candle || "red";
  if (c2 === "red") {
    return "#f16365";
  }
  return "#1dcdbc";
}
function fallHex(candle) {
  const c2 = candle || "red";
  if (c2 === "red") {
    return "#1dcdbc";
  }
  return "#f16365";
}
function get_each_context$5(ctx, list, i) {
  const child_ctx = ctx.slice();
  child_ctx[19] = list[i];
  return child_ctx;
}
function get_each_context_1$5(ctx, list, i) {
  const child_ctx = ctx.slice();
  child_ctx[22] = list[i];
  return child_ctx;
}
function get_each_context_2$5(ctx, list, i) {
  const child_ctx = ctx.slice();
  child_ctx[22] = list[i];
  return child_ctx;
}
function create_if_block$4(ctx) {
  let div;
  let table;
  let thead;
  let tr;
  let t;
  let tbody;
  let each_value_2 = ensure_array_like(
    /*keys*/
    ctx[8]
  );
  let each_blocks_1 = [];
  for (let i = 0; i < each_value_2.length; i += 1) {
    each_blocks_1[i] = create_each_block_2$5(get_each_context_2$5(ctx, each_value_2, i));
  }
  let each_value = ensure_array_like(
    /*trades*/
    ctx[4]
  );
  let each_blocks = [];
  for (let i = 0; i < each_value.length; i += 1) {
    each_blocks[i] = create_each_block$5(get_each_context$5(ctx, each_value, i));
  }
  return {
    c() {
      div = element("div");
      table = element("table");
      thead = element("thead");
      tr = element("tr");
      for (let i = 0; i < each_blocks_1.length; i += 1) {
        each_blocks_1[i].c();
      }
      t = space();
      tbody = element("tbody");
      for (let i = 0; i < each_blocks.length; i += 1) {
        each_blocks[i].c();
      }
      attr(thead, "class", "sticky top-0 z-20");
      attr(tbody, "class", "w-full overflow-x-scroll");
      attr(table, "class", "table divide-y divide-gray-400 max-h-full overflow-x-auto");
      attr(div, "class", "");
    },
    m(target, anchor) {
      insert(target, div, anchor);
      append(div, table);
      append(table, thead);
      append(thead, tr);
      for (let i = 0; i < each_blocks_1.length; i += 1) {
        if (each_blocks_1[i]) {
          each_blocks_1[i].m(tr, null);
        }
      }
      append(table, t);
      append(table, tbody);
      for (let i = 0; i < each_blocks.length; i += 1) {
        if (each_blocks[i]) {
          each_blocks[i].m(tbody, null);
        }
      }
    },
    p(ctx2, dirty) {
      if (dirty & /*keys, keySorted, direction, theme, i*/
      302) {
        each_value_2 = ensure_array_like(
          /*keys*/
          ctx2[8]
        );
        let i;
        for (i = 0; i < each_value_2.length; i += 1) {
          const child_ctx = get_each_context_2$5(ctx2, each_value_2, i);
          if (each_blocks_1[i]) {
            each_blocks_1[i].p(child_ctx, dirty);
          } else {
            each_blocks_1[i] = create_each_block_2$5(child_ctx);
            each_blocks_1[i].c();
            each_blocks_1[i].m(tr, null);
          }
        }
        for (; i < each_blocks_1.length; i += 1) {
          each_blocks_1[i].d(1);
        }
        each_blocks_1.length = each_value_2.length;
      }
      if (dirty & /*keys, formatClass, trades, formatter*/
      464) {
        each_value = ensure_array_like(
          /*trades*/
          ctx2[4]
        );
        let i;
        for (i = 0; i < each_value.length; i += 1) {
          const child_ctx = get_each_context$5(ctx2, each_value, i);
          if (each_blocks[i]) {
            each_blocks[i].p(child_ctx, dirty);
          } else {
            each_blocks[i] = create_each_block$5(child_ctx);
            each_blocks[i].c();
            each_blocks[i].m(tbody, null);
          }
        }
        for (; i < each_blocks.length; i += 1) {
          each_blocks[i].d(1);
        }
        each_blocks.length = each_value.length;
      }
    },
    d(detaching) {
      if (detaching) {
        detach(div);
      }
      destroy_each(each_blocks_1, detaching);
      destroy_each(each_blocks, detaching);
    }
  };
}
function create_if_block_2$3(ctx) {
  let svg;
  let g0;
  let g1;
  let g2;
  let path0;
  let path0_fill_value;
  let path1;
  let path1_fill_value;
  return {
    c() {
      svg = svg_element("svg");
      g0 = svg_element("g");
      g1 = svg_element("g");
      g2 = svg_element("g");
      path0 = svg_element("path");
      path1 = svg_element("path");
      attr(g0, "id", "SVGRepo_bgCarrier");
      attr(g0, "stroke-width", "0");
      attr(g1, "id", "SVGRepo_tracerCarrier");
      attr(g1, "stroke-linecap", "round");
      attr(g1, "stroke-linejoin", "round");
      attr(path0, "d", "M4 2C3.44772 2 3 2.44772 3 3C3 3.55228 3.44772 4 4 4H20C20.5523 4 21 3.55228 21 3C21 2.44772 20.5523 2 20 2H4Z");
      attr(path0, "fill", path0_fill_value = /*theme*/
      ctx[1] === "dark" ? `#ffffff` : "black");
      attr(path1, "d", "M7.70711 15.2929L11 18.5858L11 8C11 7.44771 11.4477 7 12 7C12.5523 7 13 7.44771 13 8L13 18.5858L16.2929 15.2929C16.6834 14.9024 17.3166 14.9024 17.7071 15.2929C18.0976 15.6834 18.0976 16.3166 17.7071 16.7071L12.7071 21.7071C12.3166 22.0976 11.6834 22.0976 11.2929 21.7071L6.29289 16.7071C5.90237 16.3166 5.90237 15.6834 6.29289 15.2929C6.68342 14.9024 7.31658 14.9024 7.70711 15.2929Z");
      attr(path1, "fill", path1_fill_value = /*theme*/
      ctx[1] === "dark" ? `#ffffff` : "black");
      attr(g2, "id", "SVGRepo_iconCarrier");
      attr(svg, "width", "12px");
      attr(svg, "height", "12px");
      attr(svg, "viewBox", "0 0 24 24");
      attr(svg, "fill", "none");
      attr(svg, "xmlns", "http://www.w3.org/2000/svg");
    },
    m(target, anchor) {
      insert(target, svg, anchor);
      append(svg, g0);
      append(svg, g1);
      append(svg, g2);
      append(g2, path0);
      append(g2, path1);
    },
    p(ctx2, dirty) {
      if (dirty & /*theme*/
      2 && path0_fill_value !== (path0_fill_value = /*theme*/
      ctx2[1] === "dark" ? `#ffffff` : "black")) {
        attr(path0, "fill", path0_fill_value);
      }
      if (dirty & /*theme*/
      2 && path1_fill_value !== (path1_fill_value = /*theme*/
      ctx2[1] === "dark" ? `#ffffff` : "black")) {
        attr(path1, "fill", path1_fill_value);
      }
    },
    d(detaching) {
      if (detaching) {
        detach(svg);
      }
    }
  };
}
function create_if_block_1$3(ctx) {
  let svg;
  let g0;
  let g1;
  let g2;
  let path0;
  let path0_fill_value;
  let path1;
  let path1_fill_value;
  return {
    c() {
      svg = svg_element("svg");
      g0 = svg_element("g");
      g1 = svg_element("g");
      g2 = svg_element("g");
      path0 = svg_element("path");
      path1 = svg_element("path");
      attr(g0, "id", "SVGRepo_bgCarrier");
      attr(g0, "stroke-width", "0");
      attr(g1, "id", "SVGRepo_tracerCarrier");
      attr(path0, "d", "M6.29289 8.70711C6.68342 9.09763 7.31658 9.09763 7.70711 8.70711L11 5.41421L11 16C11 16.5523 11.4477 17 12 17C12.5523 17 13 16.5523 13 16L13 5.41421L16.2929 8.70711C16.6834 9.09763 17.3166 9.09763 17.7071 8.70711C18.0976 8.31658 18.0976 7.68342 17.7071 7.29289L12.7071 2.29289C12.3166 1.90237 11.6834 1.90237 11.2929 2.29289L6.29289 7.29289C5.90237 7.68342 5.90237 8.31658 6.29289 8.70711Z");
      attr(path0, "fill", path0_fill_value = /*theme*/
      ctx[1] === "dark" ? `#ffffff` : "black");
      attr(path1, "d", "M4 22C3.44772 22 3 21.5523 3 21C3 20.4477 3.44772 20 4 20H20C20.5523 20 21 20.4477 21 21C21 21.5523 20.5523 22 20 22H4Z");
      attr(path1, "fill", path1_fill_value = /*theme*/
      ctx[1] === "dark" ? `#ffffff` : "black");
      attr(g2, "id", "SVGRepo_iconCarrier");
      attr(svg, "width", "12px");
      attr(svg, "height", "12px");
      attr(svg, "viewBox", "0 0 24 24");
      attr(svg, "fill", "none");
      attr(svg, "xmlns", "http://www.w3.org/2000/svg");
    },
    m(target, anchor) {
      insert(target, svg, anchor);
      append(svg, g0);
      append(svg, g1);
      append(svg, g2);
      append(g2, path0);
      append(g2, path1);
    },
    p(ctx2, dirty) {
      if (dirty & /*theme*/
      2 && path0_fill_value !== (path0_fill_value = /*theme*/
      ctx2[1] === "dark" ? `#ffffff` : "black")) {
        attr(path0, "fill", path0_fill_value);
      }
      if (dirty & /*theme*/
      2 && path1_fill_value !== (path1_fill_value = /*theme*/
      ctx2[1] === "dark" ? `#ffffff` : "black")) {
        attr(path1, "fill", path1_fill_value);
      }
    },
    d(detaching) {
      if (detaching) {
        detach(svg);
      }
    }
  };
}
function create_each_block_2$5(ctx) {
  let th;
  let button;
  let span1;
  let t0_value = (
    /*i*/
    ctx[5]("metrics.stocks." + /*key*/
    ctx[22]) + ""
  );
  let t0;
  let t1;
  let span0;
  let t2;
  let mounted;
  let dispose;
  function select_block_type(ctx2, dirty) {
    if (
      /*direction*/
      ctx2[3] === "dn" && /*keySorted*/
      ctx2[2] === /*key*/
      ctx2[22]
    )
      return create_if_block_1$3;
    if (
      /*direction*/
      ctx2[3] === "up" && /*keySorted*/
      ctx2[2] === /*key*/
      ctx2[22]
    )
      return create_if_block_2$3;
  }
  let current_block_type = select_block_type(ctx);
  let if_block = current_block_type && current_block_type(ctx);
  function click_handler() {
    return (
      /*click_handler*/
      ctx[14](
        /*key*/
        ctx[22]
      )
    );
  }
  return {
    c() {
      th = element("th");
      button = element("button");
      span1 = element("span");
      t0 = text(t0_value);
      t1 = space();
      span0 = element("span");
      if (if_block)
        if_block.c();
      t2 = space();
      attr(span0, "class", "ml-1");
      attr(span1, "class", "break-keep flex cursor-pointer");
      attr(button, "class", `badge badge-xs border-0 select-none hover:badge-primary hover:text-white p-3 ml-0 m-3 cursor-pointer rounded-md`);
      attr(th, "class", `whitespace-nowrap p-0 bg-base-200 ${/*key*/
      ctx[22] === "stockId" ? "text-left sticky left-0" : "text-center"}`);
    },
    m(target, anchor) {
      insert(target, th, anchor);
      append(th, button);
      append(button, span1);
      append(span1, t0);
      append(span1, t1);
      append(span1, span0);
      if (if_block)
        if_block.m(span0, null);
      append(th, t2);
      if (!mounted) {
        dispose = listen(button, "click", click_handler);
        mounted = true;
      }
    },
    p(new_ctx, dirty) {
      ctx = new_ctx;
      if (dirty & /*i*/
      32 && t0_value !== (t0_value = /*i*/
      ctx[5]("metrics.stocks." + /*key*/
      ctx[22]) + ""))
        set_data(t0, t0_value);
      if (current_block_type === (current_block_type = select_block_type(ctx)) && if_block) {
        if_block.p(ctx, dirty);
      } else {
        if (if_block)
          if_block.d(1);
        if_block = current_block_type && current_block_type(ctx);
        if (if_block) {
          if_block.c();
          if_block.m(span0, null);
        }
      }
    },
    d(detaching) {
      if (detaching) {
        detach(th);
      }
      if (if_block) {
        if_block.d();
      }
      mounted = false;
      dispose();
    }
  };
}
function create_each_block_1$5(ctx) {
  let td;
  let t_value = (
    /*key*/
    (ctx[22] in /*formatter*/
    ctx[6] ? (
      /*formatter*/
      ctx[6][
        /*key*/
        ctx[22]
      ](
        /*trade*/
        ctx[19][
          /*key*/
          ctx[22]
        ]
      )
    ) : (
      /*trade*/
      ctx[19][
        /*key*/
        ctx[22]
      ]
    )) + ""
  );
  let t;
  let td_style_value;
  return {
    c() {
      td = element("td");
      t = text(t_value);
      attr(td, "class", `whitespace-nowrap w-24 pr-2 py-1 p-0 ${/*key*/
      ctx[22] === "stockId" ? "text-left sticky left-0 z-10 bg-base-200" : "text-center"} `);
      attr(td, "style", td_style_value = `color: ${/*key*/
      ctx[22] in /*formatClass*/
      ctx[7] ? (
        /*formatClass*/
        ctx[7][
          /*key*/
          ctx[22]
        ](
          /*trade*/
          ctx[19][
            /*key*/
            ctx[22]
          ]
        )
      ) : ""}`);
    },
    m(target, anchor) {
      insert(target, td, anchor);
      append(td, t);
    },
    p(ctx2, dirty) {
      if (dirty & /*trades*/
      16 && t_value !== (t_value = /*key*/
      (ctx2[22] in /*formatter*/
      ctx2[6] ? (
        /*formatter*/
        ctx2[6][
          /*key*/
          ctx2[22]
        ](
          /*trade*/
          ctx2[19][
            /*key*/
            ctx2[22]
          ]
        )
      ) : (
        /*trade*/
        ctx2[19][
          /*key*/
          ctx2[22]
        ]
      )) + ""))
        set_data(t, t_value);
      if (dirty & /*trades*/
      16 && td_style_value !== (td_style_value = `color: ${/*key*/
      ctx2[22] in /*formatClass*/
      ctx2[7] ? (
        /*formatClass*/
        ctx2[7][
          /*key*/
          ctx2[22]
        ](
          /*trade*/
          ctx2[19][
            /*key*/
            ctx2[22]
          ]
        )
      ) : ""}`)) {
        attr(td, "style", td_style_value);
      }
    },
    d(detaching) {
      if (detaching) {
        detach(td);
      }
    }
  };
}
function create_each_block$5(ctx) {
  let tr;
  let t;
  let each_value_1 = ensure_array_like(
    /*keys*/
    ctx[8]
  );
  let each_blocks = [];
  for (let i = 0; i < each_value_1.length; i += 1) {
    each_blocks[i] = create_each_block_1$5(get_each_context_1$5(ctx, each_value_1, i));
  }
  return {
    c() {
      tr = element("tr");
      for (let i = 0; i < each_blocks.length; i += 1) {
        each_blocks[i].c();
      }
      t = space();
      attr(tr, "class", `hover py-0 pl-0`);
    },
    m(target, anchor) {
      insert(target, tr, anchor);
      for (let i = 0; i < each_blocks.length; i += 1) {
        if (each_blocks[i]) {
          each_blocks[i].m(tr, null);
        }
      }
      append(tr, t);
    },
    p(ctx2, dirty) {
      if (dirty & /*keys, formatClass, trades, formatter*/
      464) {
        each_value_1 = ensure_array_like(
          /*keys*/
          ctx2[8]
        );
        let i;
        for (i = 0; i < each_value_1.length; i += 1) {
          const child_ctx = get_each_context_1$5(ctx2, each_value_1, i);
          if (each_blocks[i]) {
            each_blocks[i].p(child_ctx, dirty);
          } else {
            each_blocks[i] = create_each_block_1$5(child_ctx);
            each_blocks[i].c();
            each_blocks[i].m(tr, t);
          }
        }
        for (; i < each_blocks.length; i += 1) {
          each_blocks[i].d(1);
        }
        each_blocks.length = each_value_1.length;
      }
    },
    d(detaching) {
      if (detaching) {
        detach(tr);
      }
      destroy_each(each_blocks, detaching);
    }
  };
}
function create_fragment$9(ctx) {
  let if_block_anchor;
  let if_block = (
    /*report*/
    ctx[0] && /*report*/
    ctx[0].trades.length != 0 && create_if_block$4(ctx)
  );
  return {
    c() {
      if (if_block)
        if_block.c();
      if_block_anchor = empty();
    },
    m(target, anchor) {
      if (if_block)
        if_block.m(target, anchor);
      insert(target, if_block_anchor, anchor);
    },
    p(ctx2, [dirty]) {
      if (
        /*report*/
        ctx2[0] && /*report*/
        ctx2[0].trades.length != 0
      ) {
        if (if_block) {
          if_block.p(ctx2, dirty);
        } else {
          if_block = create_if_block$4(ctx2);
          if_block.c();
          if_block.m(if_block_anchor.parentNode, if_block_anchor);
        }
      } else if (if_block) {
        if_block.d(1);
        if_block = null;
      }
    },
    i: noop$1,
    o: noop$1,
    d(detaching) {
      if (detaching) {
        detach(if_block_anchor);
      }
      if (if_block)
        if_block.d(detaching);
    }
  };
}
function instance$9($$self, $$props, $$invalidate) {
  let i;
  let { lang = "en" } = $$props;
  let { browser } = $$props;
  let { report } = $$props;
  let { theme = "light" } = $$props;
  let { candle = "red" } = $$props;
  let { tstart = null } = $$props;
  let { tend = null } = $$props;
  onMount(() => {
    if (!browser)
      return;
  });
  const dateFormatter = (d2) => d2 ? d2 == null ? void 0 : d2.toLocaleDateString() : null;
  const percentageFormatter = (d2) => (d2 * 100).toFixed(1) + "%";
  const formatter = {
    entry: dateFormatter,
    exit: dateFormatter,
    entrySig: dateFormatter,
    exitSig: dateFormatter,
    position: percentageFormatter,
    return: percentageFormatter,
    mae: percentageFormatter,
    gmfe: percentageFormatter,
    bmfe: percentageFormatter,
    mdd: percentageFormatter
  };
  const colorPercentage = (v2) => v2 > 0 ? riseHex(candle) : fallHex(candle);
  const dateWithinRange = (d2) => tstart <= d2 && d2 <= tend ? "underline" : "";
  const formatClass = {
    entry: dateWithinRange,
    exit: dateWithinRange,
    position: colorPercentage,
    return: colorPercentage,
    mae: colorPercentage,
    mfe: colorPercentage,
    mdd: colorPercentage,
    gmfe: colorPercentage,
    bmfe: colorPercentage
  };
  const keys = [
    "stockId",
    "return",
    "entry",
    "exit",
    "position",
    "entryPrice",
    "exitPrice",
    "entrySig",
    "exitSig",
    "mae",
    "gmfe",
    "bmfe",
    "mdd"
  ];
  let keySorted = "entry";
  let direction = "dn";
  let trades = [];
  const click_handler = (key) => {
    if (keySorted !== key) {
      $$invalidate(2, keySorted = key);
    } else {
      $$invalidate(3, direction = { up: "dn", dn: "up" }[direction]);
    }
  };
  $$self.$$set = ($$props2) => {
    if ("lang" in $$props2)
      $$invalidate(9, lang = $$props2.lang);
    if ("browser" in $$props2)
      $$invalidate(10, browser = $$props2.browser);
    if ("report" in $$props2)
      $$invalidate(0, report = $$props2.report);
    if ("theme" in $$props2)
      $$invalidate(1, theme = $$props2.theme);
    if ("candle" in $$props2)
      $$invalidate(11, candle = $$props2.candle);
    if ("tstart" in $$props2)
      $$invalidate(12, tstart = $$props2.tstart);
    if ("tend" in $$props2)
      $$invalidate(13, tend = $$props2.tend);
  };
  $$self.$$.update = () => {
    if ($$self.$$.dirty & /*lang*/
    512) {
      $$invalidate(5, i = (key) => lang === "en" ? ien(key) : itw(key));
    }
    if ($$self.$$.dirty & /*report, tstart, tend, direction, keySorted, trades*/
    12317) {
      if (report || tstart || tend) {
        $$invalidate(4, trades = report.trades.sort((a2, b2) => {
          if (direction === "up") {
            return a2[keySorted] > b2[keySorted] ? 1 : -1;
          } else {
            return a2[keySorted] < b2[keySorted] ? 1 : -1;
          }
        }));
        if (tstart && tend) {
          $$invalidate(4, trades = trades.filter((obj) => {
            const ret = obj.entry && obj.exit && (obj.entry <= tstart && tstart <= obj.exit || obj.entry <= tend && tend <= obj.exit);
            return ret;
          }));
        }
        $$invalidate(4, trades = trades.slice(0, 50).filter((obj) => Object.values(obj).every((val) => val !== null)));
      }
    }
  };
  return [
    report,
    theme,
    keySorted,
    direction,
    trades,
    i,
    formatter,
    formatClass,
    keys,
    lang,
    browser,
    candle,
    tstart,
    tend,
    click_handler
  ];
}
class Stocks extends SvelteComponent {
  constructor(options) {
    super();
    init(this, options, instance$9, create_fragment$9, safe_not_equal, {
      lang: 9,
      browser: 10,
      report: 0,
      theme: 1,
      candle: 11,
      tstart: 12,
      tend: 13
    });
  }
  get lang() {
    return this.$$.ctx[9];
  }
  set lang(lang) {
    this.$$set({ lang });
    flush();
  }
  get browser() {
    return this.$$.ctx[10];
  }
  set browser(browser) {
    this.$$set({ browser });
    flush();
  }
  get report() {
    return this.$$.ctx[0];
  }
  set report(report) {
    this.$$set({ report });
    flush();
  }
  get theme() {
    return this.$$.ctx[1];
  }
  set theme(theme) {
    this.$$set({ theme });
    flush();
  }
  get candle() {
    return this.$$.ctx[11];
  }
  set candle(candle) {
    this.$$set({ candle });
    flush();
  }
  get tstart() {
    return this.$$.ctx[12];
  }
  set tstart(tstart) {
    this.$$set({ tstart });
    flush();
  }
  get tend() {
    return this.$$.ctx[13];
  }
  set tend(tend) {
    this.$$set({ tend });
    flush();
  }
}
create_custom_element(Stocks, { "lang": {}, "browser": {}, "report": {}, "theme": {}, "candle": {}, "tstart": {}, "tend": {} }, [], [], true);
function create_fragment$8(ctx) {
  let svg;
  let use;
  return {
    c() {
      svg = svg_element("svg");
      use = svg_element("use");
      attr(
        use,
        "href",
        /*symbolId*/
        ctx[3]
      );
      attr(
        use,
        "fill",
        /*color*/
        ctx[0]
      );
      attr(
        use,
        "stroke",
        /*strokeColor*/
        ctx[1]
      );
      attr(
        svg,
        "class",
        /*className*/
        ctx[2]
      );
      attr(svg, "aria-hidden", "true");
    },
    m(target, anchor) {
      insert(target, svg, anchor);
      append(svg, use);
    },
    p(ctx2, [dirty]) {
      if (dirty & /*symbolId*/
      8) {
        attr(
          use,
          "href",
          /*symbolId*/
          ctx2[3]
        );
      }
      if (dirty & /*color*/
      1) {
        attr(
          use,
          "fill",
          /*color*/
          ctx2[0]
        );
      }
      if (dirty & /*strokeColor*/
      2) {
        attr(
          use,
          "stroke",
          /*strokeColor*/
          ctx2[1]
        );
      }
      if (dirty & /*className*/
      4) {
        attr(
          svg,
          "class",
          /*className*/
          ctx2[2]
        );
      }
    },
    i: noop$1,
    o: noop$1,
    d(detaching) {
      if (detaching) {
        detach(svg);
      }
    }
  };
}
function instance$8($$self, $$props, $$invalidate) {
  let symbolId;
  let { prefix = "icon" } = $$props;
  let { name = "" } = $$props;
  let { color: color2 = "#333" } = $$props;
  let { strokeColor = "" } = $$props;
  let { className = "" } = $$props;
  $$self.$$set = ($$props2) => {
    if ("prefix" in $$props2)
      $$invalidate(4, prefix = $$props2.prefix);
    if ("name" in $$props2)
      $$invalidate(5, name = $$props2.name);
    if ("color" in $$props2)
      $$invalidate(0, color2 = $$props2.color);
    if ("strokeColor" in $$props2)
      $$invalidate(1, strokeColor = $$props2.strokeColor);
    if ("className" in $$props2)
      $$invalidate(2, className = $$props2.className);
  };
  $$self.$$.update = () => {
    if ($$self.$$.dirty & /*prefix, name*/
    48) {
      $$invalidate(3, symbolId = `#${prefix}-${name}`);
    }
  };
  return [color2, strokeColor, className, symbolId, prefix, name];
}
let Svgicon$1 = class Svgicon extends SvelteComponent {
  constructor(options) {
    super();
    init(this, options, instance$8, create_fragment$8, safe_not_equal, {
      prefix: 4,
      name: 5,
      color: 0,
      strokeColor: 1,
      className: 2
    });
  }
  get prefix() {
    return this.$$.ctx[4];
  }
  set prefix(prefix) {
    this.$$set({ prefix });
    flush();
  }
  get name() {
    return this.$$.ctx[5];
  }
  set name(name) {
    this.$$set({ name });
    flush();
  }
  get color() {
    return this.$$.ctx[0];
  }
  set color(color2) {
    this.$$set({ color: color2 });
    flush();
  }
  get strokeColor() {
    return this.$$.ctx[1];
  }
  set strokeColor(strokeColor) {
    this.$$set({ strokeColor });
    flush();
  }
  get className() {
    return this.$$.ctx[2];
  }
  set className(className) {
    this.$$set({ className });
    flush();
  }
};
create_custom_element(Svgicon$1, { "prefix": {}, "name": {}, "color": {}, "strokeColor": {}, "className": {} }, [], [], true);
function isMobile() {
  const userAgent = navigator.userAgent || navigator.vendor;
  return /iPad|iPhone|iPod|android/i.test(userAgent);
}
function add_css$1(target) {
  append_styles(target, "svelte-13tqbdu", ".grid-cols-14.svelte-13tqbdu{grid-template-columns:repeat(14, minmax(0, 1fr))}");
}
function get_each_context$4(ctx, list, i) {
  const child_ctx = ctx.slice();
  child_ctx[48] = list[i];
  return child_ctx;
}
function get_each_context_1$4(ctx, list, i) {
  const child_ctx = ctx.slice();
  child_ctx[51] = list[i];
  return child_ctx;
}
function get_each_context_2$4(ctx, list, i) {
  const child_ctx = ctx.slice();
  child_ctx[51] = list[i];
  return child_ctx;
}
function get_each_context_3$1(ctx, list, i) {
  const child_ctx = ctx.slice();
  child_ctx[48] = list[i];
  return child_ctx;
}
function create_each_block_3$1(ctx) {
  let div;
  let span;
  let t0_value = (
    /*y*/
    ctx[48] + ""
  );
  let t0;
  let t1;
  let button;
  let t2_value = (100 * /*yearlyReturn*/
  ctx[6][
    /*y*/
    ctx[48]
  ] || 0).toFixed(1) + "";
  let t2;
  let t3;
  let button_style_value;
  let mounted;
  let dispose;
  function click_handler() {
    return (
      /*click_handler*/
      ctx[35](
        /*y*/
        ctx[48]
      )
    );
  }
  return {
    c() {
      div = element("div");
      span = element("span");
      t0 = text(t0_value);
      t1 = space();
      button = element("button");
      t2 = text(t2_value);
      t3 = text("%");
      attr(span, "class", "text-sm border-l pl-1");
      attr(button, "class", "w-full py-1 px-2 text-sm");
      attr(button, "style", button_style_value = `background:${/*yearlyReturnColor*/
      ctx[13][`${/*y*/
      ctx[48]}`]}`);
      attr(div, "class", "flex-l");
    },
    m(target, anchor) {
      insert(target, div, anchor);
      append(div, span);
      append(span, t0);
      append(div, t1);
      append(div, button);
      append(button, t2);
      append(button, t3);
      if (!mounted) {
        dispose = listen(button, "click", click_handler);
        mounted = true;
      }
    },
    p(new_ctx, dirty) {
      ctx = new_ctx;
      if (dirty[0] & /*endYear, startYear*/
      50331648 && t0_value !== (t0_value = /*y*/
      ctx[48] + ""))
        set_data(t0, t0_value);
      if (dirty[0] & /*yearlyReturn, endYear, startYear*/
      50331712 && t2_value !== (t2_value = (100 * /*yearlyReturn*/
      ctx[6][
        /*y*/
        ctx[48]
      ] || 0).toFixed(1) + ""))
        set_data(t2, t2_value);
      if (dirty[0] & /*yearlyReturnColor, endYear, startYear*/
      50339840 && button_style_value !== (button_style_value = `background:${/*yearlyReturnColor*/
      ctx[13][`${/*y*/
      ctx[48]}`]}`)) {
        attr(button, "style", button_style_value);
      }
    },
    d(detaching) {
      if (detaching) {
        detach(div);
      }
      mounted = false;
      dispose();
    }
  };
}
function create_each_block_2$4(ctx) {
  let div;
  return {
    c() {
      div = element("div");
      div.textContent = `${/*m*/
      ctx[51]} 月`;
      attr(div, "class", "flex justify-center items-center");
    },
    m(target, anchor) {
      insert(target, div, anchor);
    },
    p: noop$1,
    d(detaching) {
      if (detaching) {
        detach(div);
      }
    }
  };
}
function create_each_block_1$4(ctx) {
  let div;
  let t0_value = sign$1(
    /*monthlyReturn*/
    ((ctx[7][`${/*y*/
    ctx[48]}${/*m*/
    ctx[51]}`] || 0) * 100).toFixed(1)
  ) + "";
  let t0;
  let t1;
  let div_class_value;
  let div_style_value;
  let mounted;
  let dispose;
  function click_handler_2() {
    return (
      /*click_handler_2*/
      ctx[37](
        /*y*/
        ctx[48],
        /*m*/
        ctx[51]
      )
    );
  }
  return {
    c() {
      div = element("div");
      t0 = text(t0_value);
      t1 = text("%");
      attr(div, "class", div_class_value = null_to_empty(`cursor-pointer flex justify-center items-center hover:text-base-content-300 hover:z-20 hover:outline hover:shadow-primary hover:outline-2 hover:outline-primary hover:border-none hover:rounded-lg hover:font-bold hover:text-2xl hover:-m-3 hover:shadow-lg 
								${/*y*/
      ctx[48] === /*hoverYear*/
      ctx[10] ? "border-t-2 border-b-2 border-primary" : ""} 								${/*y*/
      ctx[48] === /*hoverYear*/
      ctx[10] && /*m*/
      ctx[51] == 1 ? "border-l-2 border-primary rounded-l-lg" : ""} 								${/*y*/
      ctx[48] === /*hoverYear*/
      ctx[10] && /*m*/
      ctx[51] == 12 ? "border-r-2 border-primary rounded-r-lg" : ""} 								${/*m*/
      ctx[51] === /*hoverMonth*/
      ctx[9] && /*y*/
      ctx[48] === /*hoverYear*/
      ctx[10] ? "text-base-content-300 text-2xl -m-4 font-bold outline shadow-primary outline-2 outline-primary border-none rounded-lg z-20 shadow-2xl" : ""}`) + " svelte-13tqbdu");
      attr(div, "style", div_style_value = `background:${/*monthlyReturnColor*/
      ctx[12][`${/*y*/
      ctx[48]}${/*m*/
      ctx[51]}`]}`);
    },
    m(target, anchor) {
      insert(target, div, anchor);
      append(div, t0);
      append(div, t1);
      if (!mounted) {
        dispose = listen(div, "click", click_handler_2);
        mounted = true;
      }
    },
    p(new_ctx, dirty) {
      ctx = new_ctx;
      if (dirty[0] & /*monthlyReturn, endYear, startYear*/
      50331776 && t0_value !== (t0_value = sign$1(
        /*monthlyReturn*/
        ((ctx[7][`${/*y*/
        ctx[48]}${/*m*/
        ctx[51]}`] || 0) * 100).toFixed(1)
      ) + ""))
        set_data(t0, t0_value);
      if (dirty[0] & /*endYear, startYear, hoverYear, hoverMonth*/
      50333184 && div_class_value !== (div_class_value = null_to_empty(`cursor-pointer flex justify-center items-center hover:text-base-content-300 hover:z-20 hover:outline hover:shadow-primary hover:outline-2 hover:outline-primary hover:border-none hover:rounded-lg hover:font-bold hover:text-2xl hover:-m-3 hover:shadow-lg 
								${/*y*/
      ctx[48] === /*hoverYear*/
      ctx[10] ? "border-t-2 border-b-2 border-primary" : ""} 								${/*y*/
      ctx[48] === /*hoverYear*/
      ctx[10] && /*m*/
      ctx[51] == 1 ? "border-l-2 border-primary rounded-l-lg" : ""} 								${/*y*/
      ctx[48] === /*hoverYear*/
      ctx[10] && /*m*/
      ctx[51] == 12 ? "border-r-2 border-primary rounded-r-lg" : ""} 								${/*m*/
      ctx[51] === /*hoverMonth*/
      ctx[9] && /*y*/
      ctx[48] === /*hoverYear*/
      ctx[10] ? "text-base-content-300 text-2xl -m-4 font-bold outline shadow-primary outline-2 outline-primary border-none rounded-lg z-20 shadow-2xl" : ""}`) + " svelte-13tqbdu")) {
        attr(div, "class", div_class_value);
      }
      if (dirty[0] & /*monthlyReturnColor, endYear, startYear*/
      50335744 && div_style_value !== (div_style_value = `background:${/*monthlyReturnColor*/
      ctx[12][`${/*y*/
      ctx[48]}${/*m*/
      ctx[51]}`]}`)) {
        attr(div, "style", div_style_value);
      }
    },
    d(detaching) {
      if (detaching) {
        detach(div);
      }
      mounted = false;
      dispose();
    }
  };
}
function create_each_block$4(ctx) {
  let div0;
  let t0_value = (
    /*y*/
    ctx[48] + ""
  );
  let t0;
  let t1;
  let t2;
  let div1;
  let t3_value = (
    /*y*/
    ctx[48] + ""
  );
  let t3;
  let t4;
  let each_value_1 = ensure_array_like([1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12]);
  let each_blocks = [];
  for (let i = 0; i < 12; i += 1) {
    each_blocks[i] = create_each_block_1$4(get_each_context_1$4(ctx, each_value_1, i));
  }
  return {
    c() {
      div0 = element("div");
      t0 = text(t0_value);
      t1 = space();
      for (let i = 0; i < 12; i += 1) {
        each_blocks[i].c();
      }
      t2 = space();
      div1 = element("div");
      t3 = text(t3_value);
      t4 = space();
      attr(div0, "class", "h-7 md:h-10 flex justify-start items-center");
      attr(div1, "class", "flex justify-center items-center border border-base-content/0");
    },
    m(target, anchor) {
      insert(target, div0, anchor);
      append(div0, t0);
      insert(target, t1, anchor);
      for (let i = 0; i < 12; i += 1) {
        if (each_blocks[i]) {
          each_blocks[i].m(target, anchor);
        }
      }
      insert(target, t2, anchor);
      insert(target, div1, anchor);
      append(div1, t3);
      append(div1, t4);
    },
    p(ctx2, dirty) {
      if (dirty[0] & /*endYear, startYear*/
      50331648 && t0_value !== (t0_value = /*y*/
      ctx2[48] + ""))
        set_data(t0, t0_value);
      if (dirty[0] & /*endYear, startYear, hoverYear, hoverMonth, monthlyReturnColor, twRender, changeTWView, selectedYear, selectedMonth, selectedMonthRender, monthlyReturn*/
      520099504) {
        each_value_1 = ensure_array_like([1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12]);
        let i;
        for (i = 0; i < 12; i += 1) {
          const child_ctx = get_each_context_1$4(ctx2, each_value_1, i);
          if (each_blocks[i]) {
            each_blocks[i].p(child_ctx, dirty);
          } else {
            each_blocks[i] = create_each_block_1$4(child_ctx);
            each_blocks[i].c();
            each_blocks[i].m(t2.parentNode, t2);
          }
        }
        for (; i < 12; i += 1) {
          each_blocks[i].d(1);
        }
      }
      if (dirty[0] & /*endYear, startYear*/
      50331648 && t3_value !== (t3_value = /*y*/
      ctx2[48] + ""))
        set_data(t3, t3_value);
    },
    d(detaching) {
      if (detaching) {
        detach(div0);
        detach(t1);
        detach(t2);
        detach(div1);
      }
      destroy_each(each_blocks, detaching);
    }
  };
}
function create_if_block$3(ctx) {
  var _a, _b;
  let t0_value = (
    /*stockRangeStart*/
    ((_a = ctx[23]) == null ? void 0 : _a.toLocaleDateString()) + ""
  );
  let t0;
  let t1;
  let t2_value = (
    /*stockRangeEnd*/
    ((_b = ctx[22]) == null ? void 0 : _b.toLocaleDateString()) + ""
  );
  let t2;
  return {
    c() {
      t0 = text(t0_value);
      t1 = text("~");
      t2 = text(t2_value);
    },
    m(target, anchor) {
      insert(target, t0, anchor);
      insert(target, t1, anchor);
      insert(target, t2, anchor);
    },
    p(ctx2, dirty) {
      var _a2, _b2;
      if (dirty[0] & /*stockRangeStart*/
      8388608 && t0_value !== (t0_value = /*stockRangeStart*/
      ((_a2 = ctx2[23]) == null ? void 0 : _a2.toLocaleDateString()) + ""))
        set_data(t0, t0_value);
      if (dirty[0] & /*stockRangeEnd*/
      4194304 && t2_value !== (t2_value = /*stockRangeEnd*/
      ((_b2 = ctx2[22]) == null ? void 0 : _b2.toLocaleDateString()) + ""))
        set_data(t2, t2_value);
    },
    d(detaching) {
      if (detaching) {
        detach(t0);
        detach(t1);
        detach(t2);
      }
    }
  };
}
function create_fragment$7(ctx) {
  let div28;
  let div7;
  let div6;
  let h30;
  let t0_value = (
    /*i*/
    ctx[19]("profitability.historicalReturn") + ""
  );
  let t0;
  let t1;
  let div2;
  let div0;
  let t2;
  let div1;
  let t3;
  let t4;
  let t5_value = (
    /*selectedMonth*/
    (ctx[4] < 10 ? "0" + /*selectedMonth*/
    ctx[4] : (
      /*selectedMonth*/
      ctx[4]
    )) + ""
  );
  let t5;
  let t6;
  let div5;
  let div4;
  let t7;
  let div3;
  let button;
  let t9;
  let div14;
  let h31;
  let t10_value = (
    /*i*/
    ctx[19]("profitability.monthlyReturn") + ""
  );
  let t10;
  let t11;
  let div8;
  let span0;
  let t12_value = (
    /*i*/
    ctx[19]("profitability.avgMonthlyReturn") + ""
  );
  let t12;
  let t13;
  let t14_value = sign$1((100 * /*avgMonthlyReturn*/
  ctx[21]).toFixed(2)) + "";
  let t14;
  let t15;
  let t16;
  let span1;
  let t17_value = (
    /*i*/
    ctx[19]("profitability.monthlyWinRatio") + ""
  );
  let t17;
  let t18;
  let t19_value = (
    /*winRate*/
    ctx[20].toFixed(1) + ""
  );
  let t19;
  let t20;
  let t21;
  let div13;
  let div12;
  let div11;
  let div9;
  let t22_value = (
    /*i*/
    ctx[19]("profitability.monthlyReturn") + ""
  );
  let t22;
  let t23;
  let t24;
  let div10;
  let t25;
  let t26;
  let div17;
  let h32;
  let t27_value = (
    /*i*/
    ctx[19]("profitability.stockList") + ""
  );
  let t27;
  let t28;
  let h4;
  let t29;
  let div16;
  let div15;
  let stocks;
  let t30;
  let div23;
  let h33;
  let t31_value = (
    /*i*/
    ctx[19]("profitability.YearlyCompareWithBenchmark") + ""
  );
  let t31;
  let t32;
  let div18;
  let span2;
  let t33_value = (
    /*i*/
    ctx[19]("profitability.yearlyWinRate") + ""
  );
  let t33;
  let t34;
  let t35;
  let t36;
  let t37;
  let t38_value = (
    /*winYearCount*/
    ctx[15] + /*lossYearCount*/
    ctx[16] + ""
  );
  let t38;
  let t39;
  let t40_value = (
    /*i*/
    ctx[19]("profitability.year") + ""
  );
  let t40;
  let t41;
  let div22;
  let div21;
  let div19;
  let t42_value = (
    /*i*/
    ctx[19]("strategy") + ""
  );
  let t42;
  let t43;
  let div20;
  let t44_value = (
    /*i*/
    ctx[19]("benchmark") + ""
  );
  let t44;
  let t45;
  let canvas0;
  let t46;
  let div27;
  let h34;
  let t47_value = (
    /*i*/
    ctx[19]("profitability.exceedReturn") + ""
  );
  let t47;
  let t48;
  let div26;
  let span3;
  let t49_value = (
    /*i*/
    ctx[19]("average") + ""
  );
  let t49;
  let t50;
  let t51_value = sign$1(
    /*excessReturn*/
    (ctx[14] * 100).toFixed(2)
  ) + "";
  let t51;
  let t52;
  let div25;
  let div24;
  let t53_value = (
    /*i*/
    ctx[19]("strategy") + ""
  );
  let t53;
  let t54;
  let canvas1;
  let current;
  let mounted;
  let dispose;
  let each_value_3 = ensure_array_like(Array.from(Array(
    /*endYear*/
    ctx[24] + 1
  ).keys()).slice(
    /*startYear*/
    ctx[25]
  ));
  let each_blocks_2 = [];
  for (let i = 0; i < each_value_3.length; i += 1) {
    each_blocks_2[i] = create_each_block_3$1(get_each_context_3$1(ctx, each_value_3, i));
  }
  let each_value_2 = ensure_array_like([1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12]);
  let each_blocks_1 = [];
  for (let i = 0; i < 12; i += 1) {
    each_blocks_1[i] = create_each_block_2$4(get_each_context_2$4(ctx, each_value_2, i));
  }
  let each_value = ensure_array_like(Array.from(Array(
    /*endYear*/
    ctx[24] + 1
  ).keys()).slice(
    /*startYear*/
    ctx[25]
  ));
  let each_blocks = [];
  for (let i = 0; i < each_value.length; i += 1) {
    each_blocks[i] = create_each_block$4(get_each_context$4(ctx, each_value, i));
  }
  let if_block = (
    /*selectedYear*/
    ctx[5] && create_if_block$3(ctx)
  );
  stocks = new Stocks({
    props: {
      lang: (
        /*lang*/
        ctx[3]
      ),
      report: (
        /*report*/
        ctx[1]
      ),
      theme: (
        /*theme*/
        ctx[2]
      ),
      browser: (
        /*browser*/
        ctx[0]
      ),
      tstart: (
        /*stockRangeStart*/
        ctx[23]
      ),
      tend: (
        /*stockRangeEnd*/
        ctx[22]
      )
    }
  });
  return {
    c() {
      div28 = element("div");
      div7 = element("div");
      div6 = element("div");
      h30 = element("h3");
      t0 = text(t0_value);
      t1 = space();
      div2 = element("div");
      div0 = element("div");
      t2 = space();
      div1 = element("div");
      t3 = text(
        /*selectedYear*/
        ctx[5]
      );
      t4 = text("-");
      t5 = text(t5_value);
      t6 = space();
      div5 = element("div");
      div4 = element("div");
      for (let i = 0; i < each_blocks_2.length; i += 1) {
        each_blocks_2[i].c();
      }
      t7 = space();
      div3 = element("div");
      button = element("button");
      button.textContent = "reset";
      t9 = space();
      div14 = element("div");
      h31 = element("h3");
      t10 = text(t10_value);
      t11 = space();
      div8 = element("div");
      span0 = element("span");
      t12 = text(t12_value);
      t13 = text("：");
      t14 = text(t14_value);
      t15 = text("%");
      t16 = space();
      span1 = element("span");
      t17 = text(t17_value);
      t18 = text("：");
      t19 = text(t19_value);
      t20 = text("%");
      t21 = space();
      div13 = element("div");
      div12 = element("div");
      div11 = element("div");
      div9 = element("div");
      t22 = text(t22_value);
      t23 = space();
      for (let i = 0; i < 12; i += 1) {
        each_blocks_1[i].c();
      }
      t24 = space();
      div10 = element("div");
      t25 = space();
      for (let i = 0; i < each_blocks.length; i += 1) {
        each_blocks[i].c();
      }
      t26 = space();
      div17 = element("div");
      h32 = element("h3");
      t27 = text(t27_value);
      t28 = space();
      h4 = element("h4");
      if (if_block)
        if_block.c();
      t29 = space();
      div16 = element("div");
      div15 = element("div");
      create_component(stocks.$$.fragment);
      t30 = space();
      div23 = element("div");
      h33 = element("h3");
      t31 = text(t31_value);
      t32 = space();
      div18 = element("div");
      span2 = element("span");
      t33 = text(t33_value);
      t34 = text("：");
      t35 = space();
      t36 = text(
        /*winYearCount*/
        ctx[15]
      );
      t37 = text(" / ");
      t38 = text(t38_value);
      t39 = space();
      t40 = text(t40_value);
      t41 = space();
      div22 = element("div");
      div21 = element("div");
      div19 = element("div");
      t42 = text(t42_value);
      t43 = space();
      div20 = element("div");
      t44 = text(t44_value);
      t45 = space();
      canvas0 = element("canvas");
      t46 = space();
      div27 = element("div");
      h34 = element("h3");
      t47 = text(t47_value);
      t48 = space();
      div26 = element("div");
      span3 = element("span");
      t49 = text(t49_value);
      t50 = text("：");
      t51 = text(t51_value);
      t52 = text("%\n			");
      div25 = element("div");
      div24 = element("div");
      t53 = text(t53_value);
      t54 = space();
      canvas1 = element("canvas");
      attr(h30, "class", "text-2xl font-bold text-base-content-200");
      attr(div0, "class", "text-primary h-64 z-0");
      attr(div1, "class", "absolute bg-primary/10 rounded-lg font-bold text-center whitespace-nowrap text-base-content-100 text-sm flex justify-center items-start pt-2");
      attr(div2, "class", "relative overflow-hidden");
      attr(button, "class", "mt-6 py-1 px-2 bg-base-100");
      attr(div3, "class", "flex-l text-center text-sm");
      attr(div4, "class", "flex text-base-content-300 my-6");
      attr(div5, "class", "relative w-full overflow-x-auto no-scrollbar");
      attr(div6, "class", "");
      attr(div7, "class", "col-span-6 md:col-span-6 md:p-8 pt-8 md:border rounded-xl");
      attr(h31, "class", "text-base-content-200 text-2xl font-bold");
      attr(span1, "class", "ml-4");
      attr(div8, "class", "flex mt-2 text-base-content-100");
      attr(div9, "class", "h-5 md:h-10 flex justify-start items-center");
      attr(div10, "class", "flex justify-center items-center");
      attr(div11, "class", "grid grid-cols-14 mt-3 text-xs text-base-content-200 rounded-xl min-w-[640px] pb-4 overflow-y-hidden svelte-13tqbdu");
      attr(div12, "class", null_to_empty(`overflow-x-auto
				${isMobile() ? "no-scrollbar" : "show-scrollbar"}
			`) + " svelte-13tqbdu");
      attr(div13, "class", "relative");
      attr(div14, "class", "col-span-6 md:col-span-6 md:p-8 pt-8 md:border sm:rounded-xl");
      attr(h32, "class", "text-base-content-200 text-2xl font-bold md:text-center");
      attr(h4, "class", "mt-2 text-base-content-100 md:text-center");
      attr(div15, "class", null_to_empty(`overflow-auto max-h-72 text-base-content
				${isMobile() ? "no-scrollbar" : "show-scrollbar"}
				`) + " svelte-13tqbdu");
      attr(div16, "class", "relative");
      attr(div17, "class", "col-span-6 md:col-span-6 md:p-8 pt-8 md:border sm:rounded-xl");
      attr(h33, "class", "text-base-content-200 text-2xl font-bold md:text-center");
      attr(div18, "class", "mt-2 text-base-content-100 md:text-center");
      attr(div19, "class", "badge rounded bg-primary text-white mr-2");
      attr(div20, "class", "badge rounded bg-gray-500 text-white");
      attr(div21, "class", "text-sm mt-2 flex md:justify-center");
      attr(canvas0, "class", "h-48 mt-4");
      set_style(canvas0, "width", "580px");
      attr(div23, "class", "col-span-6 md:col-span-3 md:p-8 pt-8 md:border sm:rounded-xl");
      attr(h34, "class", "text-base-content-200 text-2xl font-bold md:text-center");
      attr(div24, "class", "badge rounded badge-primary text-white");
      attr(div25, "class", "text-sm mt-2 flex md:justify-center");
      attr(canvas1, "class", "h-48 mt-4");
      set_style(canvas1, "width", "580px");
      attr(div26, "class", "mt-2 text-base-content-100 md:text-center");
      attr(div27, "class", "col-span-6 md:col-span-3 md:p-8 pt-8 md:border sm:rounded-xl");
      attr(div28, "class", "grid grid-cols-6 mb-2 gap-4");
    },
    m(target, anchor) {
      insert(target, div28, anchor);
      append(div28, div7);
      append(div7, div6);
      append(div6, h30);
      append(h30, t0);
      append(div6, t1);
      append(div6, div2);
      append(div2, div0);
      ctx[33](div0);
      append(div2, t2);
      append(div2, div1);
      append(div1, t3);
      append(div1, t4);
      append(div1, t5);
      ctx[34](div1);
      append(div6, t6);
      append(div6, div5);
      append(div5, div4);
      for (let i = 0; i < each_blocks_2.length; i += 1) {
        if (each_blocks_2[i]) {
          each_blocks_2[i].m(div4, null);
        }
      }
      append(div4, t7);
      append(div4, div3);
      append(div3, button);
      append(div28, t9);
      append(div28, div14);
      append(div14, h31);
      append(h31, t10);
      append(div14, t11);
      append(div14, div8);
      append(div8, span0);
      append(span0, t12);
      append(span0, t13);
      append(span0, t14);
      append(span0, t15);
      append(div8, t16);
      append(div8, span1);
      append(span1, t17);
      append(span1, t18);
      append(span1, t19);
      append(span1, t20);
      append(div14, t21);
      append(div14, div13);
      append(div13, div12);
      append(div12, div11);
      append(div11, div9);
      append(div9, t22);
      append(div11, t23);
      for (let i = 0; i < 12; i += 1) {
        if (each_blocks_1[i]) {
          each_blocks_1[i].m(div11, null);
        }
      }
      append(div11, t24);
      append(div11, div10);
      append(div11, t25);
      for (let i = 0; i < each_blocks.length; i += 1) {
        if (each_blocks[i]) {
          each_blocks[i].m(div11, null);
        }
      }
      append(div28, t26);
      append(div28, div17);
      append(div17, h32);
      append(h32, t27);
      append(div17, t28);
      append(div17, h4);
      if (if_block)
        if_block.m(h4, null);
      append(div17, t29);
      append(div17, div16);
      append(div16, div15);
      mount_component(stocks, div15, null);
      append(div28, t30);
      append(div28, div23);
      append(div23, h33);
      append(h33, t31);
      append(div23, t32);
      append(div23, div18);
      append(div18, span2);
      append(span2, t33);
      append(span2, t34);
      append(div18, t35);
      append(div18, t36);
      append(div18, t37);
      append(div18, t38);
      append(div18, t39);
      append(div18, t40);
      append(div23, t41);
      append(div23, div22);
      append(div22, div21);
      append(div21, div19);
      append(div19, t42);
      append(div21, t43);
      append(div21, div20);
      append(div20, t44);
      append(div22, t45);
      append(div22, canvas0);
      ctx[38](canvas0);
      append(div28, t46);
      append(div28, div27);
      append(div27, h34);
      append(h34, t47);
      append(div27, t48);
      append(div27, div26);
      append(div26, span3);
      append(span3, t49);
      append(span3, t50);
      append(div26, t51);
      append(div26, t52);
      append(div26, div25);
      append(div25, div24);
      append(div24, t53);
      append(div26, t54);
      append(div26, canvas1);
      ctx[39](canvas1);
      current = true;
      if (!mounted) {
        dispose = listen(
          button,
          "click",
          /*click_handler_1*/
          ctx[36]
        );
        mounted = true;
      }
    },
    p(ctx2, dirty) {
      if ((!current || dirty[0] & /*i*/
      524288) && t0_value !== (t0_value = /*i*/
      ctx2[19]("profitability.historicalReturn") + ""))
        set_data(t0, t0_value);
      if (!current || dirty[0] & /*selectedYear*/
      32)
        set_data(
          t3,
          /*selectedYear*/
          ctx2[5]
        );
      if ((!current || dirty[0] & /*selectedMonth*/
      16) && t5_value !== (t5_value = /*selectedMonth*/
      (ctx2[4] < 10 ? "0" + /*selectedMonth*/
      ctx2[4] : (
        /*selectedMonth*/
        ctx2[4]
      )) + ""))
        set_data(t5, t5_value);
      if (dirty[0] & /*yearlyReturnColor, endYear, startYear, twRender, changeTWView, hoverYear, yearlyReturn*/
      452994112) {
        each_value_3 = ensure_array_like(Array.from(Array(
          /*endYear*/
          ctx2[24] + 1
        ).keys()).slice(
          /*startYear*/
          ctx2[25]
        ));
        let i;
        for (i = 0; i < each_value_3.length; i += 1) {
          const child_ctx = get_each_context_3$1(ctx2, each_value_3, i);
          if (each_blocks_2[i]) {
            each_blocks_2[i].p(child_ctx, dirty);
          } else {
            each_blocks_2[i] = create_each_block_3$1(child_ctx);
            each_blocks_2[i].c();
            each_blocks_2[i].m(div4, t7);
          }
        }
        for (; i < each_blocks_2.length; i += 1) {
          each_blocks_2[i].d(1);
        }
        each_blocks_2.length = each_value_3.length;
      }
      if ((!current || dirty[0] & /*i*/
      524288) && t10_value !== (t10_value = /*i*/
      ctx2[19]("profitability.monthlyReturn") + ""))
        set_data(t10, t10_value);
      if ((!current || dirty[0] & /*i*/
      524288) && t12_value !== (t12_value = /*i*/
      ctx2[19]("profitability.avgMonthlyReturn") + ""))
        set_data(t12, t12_value);
      if ((!current || dirty[0] & /*avgMonthlyReturn*/
      2097152) && t14_value !== (t14_value = sign$1((100 * /*avgMonthlyReturn*/
      ctx2[21]).toFixed(2)) + ""))
        set_data(t14, t14_value);
      if ((!current || dirty[0] & /*i*/
      524288) && t17_value !== (t17_value = /*i*/
      ctx2[19]("profitability.monthlyWinRatio") + ""))
        set_data(t17, t17_value);
      if ((!current || dirty[0] & /*winRate*/
      1048576) && t19_value !== (t19_value = /*winRate*/
      ctx2[20].toFixed(1) + ""))
        set_data(t19, t19_value);
      if ((!current || dirty[0] & /*i*/
      524288) && t22_value !== (t22_value = /*i*/
      ctx2[19]("profitability.monthlyReturn") + ""))
        set_data(t22, t22_value);
      if (dirty[0] & /*endYear, startYear, hoverYear, hoverMonth, monthlyReturnColor, twRender, changeTWView, selectedYear, selectedMonth, selectedMonthRender, monthlyReturn*/
      520099504) {
        each_value = ensure_array_like(Array.from(Array(
          /*endYear*/
          ctx2[24] + 1
        ).keys()).slice(
          /*startYear*/
          ctx2[25]
        ));
        let i;
        for (i = 0; i < each_value.length; i += 1) {
          const child_ctx = get_each_context$4(ctx2, each_value, i);
          if (each_blocks[i]) {
            each_blocks[i].p(child_ctx, dirty);
          } else {
            each_blocks[i] = create_each_block$4(child_ctx);
            each_blocks[i].c();
            each_blocks[i].m(div11, null);
          }
        }
        for (; i < each_blocks.length; i += 1) {
          each_blocks[i].d(1);
        }
        each_blocks.length = each_value.length;
      }
      if ((!current || dirty[0] & /*i*/
      524288) && t27_value !== (t27_value = /*i*/
      ctx2[19]("profitability.stockList") + ""))
        set_data(t27, t27_value);
      if (
        /*selectedYear*/
        ctx2[5]
      ) {
        if (if_block) {
          if_block.p(ctx2, dirty);
        } else {
          if_block = create_if_block$3(ctx2);
          if_block.c();
          if_block.m(h4, null);
        }
      } else if (if_block) {
        if_block.d(1);
        if_block = null;
      }
      const stocks_changes = {};
      if (dirty[0] & /*lang*/
      8)
        stocks_changes.lang = /*lang*/
        ctx2[3];
      if (dirty[0] & /*report*/
      2)
        stocks_changes.report = /*report*/
        ctx2[1];
      if (dirty[0] & /*theme*/
      4)
        stocks_changes.theme = /*theme*/
        ctx2[2];
      if (dirty[0] & /*browser*/
      1)
        stocks_changes.browser = /*browser*/
        ctx2[0];
      if (dirty[0] & /*stockRangeStart*/
      8388608)
        stocks_changes.tstart = /*stockRangeStart*/
        ctx2[23];
      if (dirty[0] & /*stockRangeEnd*/
      4194304)
        stocks_changes.tend = /*stockRangeEnd*/
        ctx2[22];
      stocks.$set(stocks_changes);
      if ((!current || dirty[0] & /*i*/
      524288) && t31_value !== (t31_value = /*i*/
      ctx2[19]("profitability.YearlyCompareWithBenchmark") + ""))
        set_data(t31, t31_value);
      if ((!current || dirty[0] & /*i*/
      524288) && t33_value !== (t33_value = /*i*/
      ctx2[19]("profitability.yearlyWinRate") + ""))
        set_data(t33, t33_value);
      if (!current || dirty[0] & /*winYearCount*/
      32768)
        set_data(
          t36,
          /*winYearCount*/
          ctx2[15]
        );
      if ((!current || dirty[0] & /*winYearCount, lossYearCount*/
      98304) && t38_value !== (t38_value = /*winYearCount*/
      ctx2[15] + /*lossYearCount*/
      ctx2[16] + ""))
        set_data(t38, t38_value);
      if ((!current || dirty[0] & /*i*/
      524288) && t40_value !== (t40_value = /*i*/
      ctx2[19]("profitability.year") + ""))
        set_data(t40, t40_value);
      if ((!current || dirty[0] & /*i*/
      524288) && t42_value !== (t42_value = /*i*/
      ctx2[19]("strategy") + ""))
        set_data(t42, t42_value);
      if ((!current || dirty[0] & /*i*/
      524288) && t44_value !== (t44_value = /*i*/
      ctx2[19]("benchmark") + ""))
        set_data(t44, t44_value);
      if ((!current || dirty[0] & /*i*/
      524288) && t47_value !== (t47_value = /*i*/
      ctx2[19]("profitability.exceedReturn") + ""))
        set_data(t47, t47_value);
      if ((!current || dirty[0] & /*i*/
      524288) && t49_value !== (t49_value = /*i*/
      ctx2[19]("average") + ""))
        set_data(t49, t49_value);
      if ((!current || dirty[0] & /*excessReturn*/
      16384) && t51_value !== (t51_value = sign$1(
        /*excessReturn*/
        (ctx2[14] * 100).toFixed(2)
      ) + ""))
        set_data(t51, t51_value);
      if ((!current || dirty[0] & /*i*/
      524288) && t53_value !== (t53_value = /*i*/
      ctx2[19]("strategy") + ""))
        set_data(t53, t53_value);
    },
    i(local) {
      if (current)
        return;
      transition_in(stocks.$$.fragment, local);
      current = true;
    },
    o(local) {
      transition_out(stocks.$$.fragment, local);
      current = false;
    },
    d(detaching) {
      if (detaching) {
        detach(div28);
      }
      ctx[33](null);
      ctx[34](null);
      destroy_each(each_blocks_2, detaching);
      destroy_each(each_blocks_1, detaching);
      destroy_each(each_blocks, detaching);
      if (if_block)
        if_block.d();
      destroy_component(stocks);
      ctx[38](null);
      ctx[39](null);
      mounted = false;
      dispose();
    }
  };
}
function sign$1(a2) {
  if (a2 > 0) {
    return "+" + String(a2);
  }
  return a2;
}
function sumArray(arr) {
  return arr.length === 0 ? 0 : arr[0] + sumArray(arr.slice(1));
}
function subtractAndMean(obj1, obj2) {
  const keys = Object.keys(obj1);
  const result = {};
  const mean = keys.reduce(
    (acc, key) => {
      const subtractedValue = obj1[key] - obj2[key];
      result[key] = subtractedValue;
      return acc + subtractedValue;
    },
    0
  ) / keys.length;
  return { result, mean };
}
function instance$7($$self, $$props, $$invalidate) {
  let i;
  let startYear;
  let endYear;
  let stockRangeStart;
  let stockRangeEnd;
  let monthlyReturn;
  let monthlyReturnValue;
  let maxMonthlyReturn;
  let minMonthlyReturn;
  let avgMonthlyReturn;
  let winRate;
  let yearlyReturn;
  let yearlyReturnValue;
  let minYearlyReturn;
  let maxYearlyReturn;
  let benchmarkYearlyReturn;
  Chart.register(LinearScale, BarController, CategoryScale, BarElement, plugin_tooltip);
  let { browser } = $$props;
  let { report } = $$props;
  let { theme = "light" } = $$props;
  let { showAll = true } = $$props;
  let { lang = "en" } = $$props;
  let chartDiv;
  let chart = null;
  onMount(() => {
    twRender("all");
    renderBarChart2();
  });
  let hoverMonth = null;
  let hoverYear = null;
  let selectedMonth = null;
  let selectedYear = showAll ? null : endYear;
  let rangeMarker;
  function selectedMonthRender() {
    if (selectedMonth && selectedYear && report && chart && chartDiv) {
      const sDate = `${selectedYear}-${selectedMonth < 10 ? `0${selectedMonth}` : String(selectedMonth)}-01`;
      const eDate = `${selectedYear}-${selectedMonth + 1 < 10 ? `0${selectedMonth + 1}` : String(selectedMonth + 1)}-01`;
      const sIdx = report.indexOfTimestamps(sDate);
      const eIdx = report.indexOfTimestamps(eDate);
      if (!report.timestamps[sIdx] | !report.timestamps[eIdx])
        return;
      const xs2 = chart.chart.timeScale().timeToCoordinate(report.timestamps[sIdx]);
      const xe = chart.chart.timeScale().timeToCoordinate(report.timestamps[eIdx]);
      if (xs2 && xe) {
        $$invalidate(11, rangeMarker.style.height = "80%", rangeMarker);
        $$invalidate(11, rangeMarker.style.width = xe - xs2 + "px", rangeMarker);
        $$invalidate(11, rangeMarker.style.left = xs2 + "px", rangeMarker);
        $$invalidate(11, rangeMarker.style.top = "0", rangeMarker);
      }
    }
  }
  function changeTWView(s, e2) {
    if (!chart) {
      return;
    }
    if (typeof s === "string" && typeof e2 === "string") {
      chart.setTimeScale(new Date(s), new Date(e2));
    } else {
      const i2 = report.indexOfTimestamps(s);
      const j2 = report.indexOfTimestamps(e2);
      chart.setTimeScale(new Date(report.timestamps[i2]), new Date(report.timestamps[j2]));
    }
  }
  function twRender(renderType) {
    if (!chart) {
      $$invalidate(30, chart = new TwChart(chartDiv, true));
    }
    chart.setTheme(theme);
    const viewLength = renderType === "all" ? report.timestamps.length : 100;
    const nlimit = report.timestamps.length / (viewLength / 100);
    const s1 = report.createTradingviewSeries("strategy", 0, -1, nlimit);
    const s2 = report.createTradingviewSeries("benchmark", 0, -1, nlimit);
    chart.resetAreaSeries(0);
    chart.resetAreaSeries(1);
    chart.series[0].setData(s1);
    chart.series[1].setData(s2);
    chart.chart.subscribeCrosshairMove((param) => {
      const d2 = new Date(param.time);
      $$invalidate(9, hoverMonth = d2.getMonth() + 1);
      $$invalidate(10, hoverYear = d2.getFullYear() || hoverYear);
    });
    chart.chart.subscribeClick((param) => {
      const d2 = new Date(param.time);
      $$invalidate(4, selectedMonth = d2.getMonth() + 1);
      $$invalidate(5, selectedYear = d2.getFullYear());
      selectedMonthRender();
    });
    chart.chart.timeScale().subscribeVisibleTimeRangeChange((param) => {
      selectedMonthRender();
    });
    if (renderType === "all") {
      chart.setTimeScale(new Date(report.timestamps[0]), new Date(report.timestamps[report.timestamps.length - 1]));
    }
  }
  let monthlyReturnColor = null;
  let yearlyReturnColor = null;
  function color2(p2) {
    if (!p2 || p2 == 0)
      return "rgba(0,0,0,0)";
    const bg = theme === "dark" ? 20 : 255;
    let ratio = p2 > 0 ? p2 / maxMonthlyReturn : p2 / minMonthlyReturn;
    ratio = Math.min(0.6, ratio);
    const [r2, g2, b2] = p2 > 0 ? [255, 56, 156] : [99, 102, 241];
    const [ar, ag, ab] = [
      r2 * ratio + bg * (1 - ratio),
      g2 * ratio + bg * (1 - ratio),
      b2 * ratio + bg * (1 - ratio)
    ];
    return `rgb(${ar},${ag},${ab})`;
  }
  function yearlyColor(p2) {
    if (!p2 || p2 == 0)
      return "rgba(0,0,0,0)";
    const bg = theme === "dark" ? 20 : 255;
    let ratio = p2 > 0 ? p2 / maxYearlyReturn : p2 / minYearlyReturn;
    ratio = Math.min(0.6, ratio);
    const [r2, g2, b2] = p2 > 0 ? [255, 56, 156] : [99, 102, 241];
    const [ar, ag, ab] = [
      r2 * ratio + bg * (1 - ratio),
      g2 * ratio + bg * (1 - ratio),
      b2 * ratio + bg * (1 - ratio)
    ];
    return `rgb(${ar},${ag},${ab})`;
  }
  let excessReturn = null;
  let winYearCount = null;
  let lossYearCount = null;
  let strategyCompareDiv;
  let excessReturnDiv;
  function renderBarChart2() {
    if (!browser)
      return;
    if (!yearlyReturn)
      return;
    if (!benchmarkYearlyReturn)
      return;
    const substract = subtractAndMean(yearlyReturn, benchmarkYearlyReturn);
    $$invalidate(14, excessReturn = substract.mean);
    $$invalidate(15, winYearCount = Object.values(substract.result).filter((v2) => v2 > 0).length);
    $$invalidate(16, lossYearCount = Object.values(substract.result).length - winYearCount);
    const years = Object.keys(yearlyReturn);
    const strategyCompareCtx = strategyCompareDiv.getContext("2d");
    new Chart(
      strategyCompareCtx,
      {
        type: "bar",
        data: {
          labels: years,
          datasets: [
            {
              label: i("profitability.yearlyReturn"),
              data: Object.values(yearlyReturn),
              backgroundColor: theme === "light" ? "#725bf5" : "#7a64f5",
              borderWidth: 0
            },
            {
              label: i("profitability.benchmarkYearlyReturn"),
              data: Object.values(benchmarkYearlyReturn),
              backgroundColor: "#777777AA",
              borderWidth: 0
            }
          ]
        },
        options: {
          responsive: true,
          maintainAspectRatio: true,
          scales: {
            y: {
              beginAtZero: true,
              ticks: {
                callback(value, index, values) {
                  return (value * 100).toFixed() + "%";
                },
                color: theme === "light" ? "#000000aa" : "#FFFFFFaa"
              },
              grid: {
                color: "#77777755",
                // This will set the x-axis grid color to a light red.
                tickBorderDash: [2, 2]
              }
            },
            x: {
              ticks: {
                color: theme === "light" ? "#000000aa" : "#FFFFFFaa"
              },
              grid: {
                color: "#77777755",
                // This will set the x-axis grid color to a light red.
                tickBorderDash: [2, 2]
              }
            }
          }
        }
      }
    );
    const excessReturnCtx = excessReturnDiv.getContext("2d");
    new Chart(
      excessReturnCtx,
      {
        type: "bar",
        data: {
          labels: years,
          datasets: [
            {
              label: i("profitability.exceedReturn"),
              data: Object.values(substract.result),
              backgroundColor: theme === "light" ? "#725bf5" : "#7a64f5",
              borderColor: "#725bf5",
              borderWidth: 1,
              barPercentage: 0.5
            }
          ]
        },
        options: {
          responsive: true,
          maintainAspectRatio: true,
          scales: {
            y: {
              beginAtZero: true,
              ticks: {
                callback(value, index, values) {
                  return (value * 100).toFixed() + "%";
                },
                color: theme === "light" ? "#000000aa" : "#FFFFFFaa"
              },
              grid: {
                color: "#77777755",
                // This will set the x-axis grid color to a light red.
                tickBorderDash: [2, 2]
              }
            },
            x: {
              ticks: {
                color: theme === "light" ? "#000000aa" : "#FFFFFFaa"
              },
              grid: {
                color: "#77777755",
                // This will set the x-axis grid color to a light red.
                tickBorderDash: [2, 2]
              }
            }
          }
        }
      }
    );
  }
  function div0_binding($$value) {
    binding_callbacks[$$value ? "unshift" : "push"](() => {
      chartDiv = $$value;
      $$invalidate(8, chartDiv);
    });
  }
  function div1_binding($$value) {
    binding_callbacks[$$value ? "unshift" : "push"](() => {
      rangeMarker = $$value;
      $$invalidate(11, rangeMarker);
    });
  }
  const click_handler = (y2) => {
    twRender("year");
    changeTWView(`${y2}-01-01`, `${y2 + 1}-01-01`);
    $$invalidate(10, hoverYear = y2);
  };
  const click_handler_1 = () => {
    twRender("all");
    changeTWView(0, -1);
    $$invalidate(10, hoverYear = null);
  };
  const click_handler_2 = (y2, m2) => {
    twRender("year");
    changeTWView(`${y2}-01-01`, `${y2 + 1}-01-01`);
    $$invalidate(10, hoverYear = y2);
    $$invalidate(5, selectedYear = y2);
    $$invalidate(4, selectedMonth = m2);
    selectedMonthRender();
  };
  function canvas0_binding($$value) {
    binding_callbacks[$$value ? "unshift" : "push"](() => {
      strategyCompareDiv = $$value;
      $$invalidate(17, strategyCompareDiv);
    });
  }
  function canvas1_binding($$value) {
    binding_callbacks[$$value ? "unshift" : "push"](() => {
      excessReturnDiv = $$value;
      $$invalidate(18, excessReturnDiv);
    });
  }
  $$self.$$set = ($$props2) => {
    if ("browser" in $$props2)
      $$invalidate(0, browser = $$props2.browser);
    if ("report" in $$props2)
      $$invalidate(1, report = $$props2.report);
    if ("theme" in $$props2)
      $$invalidate(2, theme = $$props2.theme);
    if ("showAll" in $$props2)
      $$invalidate(29, showAll = $$props2.showAll);
    if ("lang" in $$props2)
      $$invalidate(3, lang = $$props2.lang);
  };
  $$self.$$.update = () => {
    if ($$self.$$.dirty[0] & /*lang*/
    8) {
      $$invalidate(19, i = (key) => lang === "en" ? ien(key) : itw(key));
    }
    if ($$self.$$.dirty[0] & /*report*/
    2) {
      $$invalidate(25, startYear = new Date(report.timestamps[0]).getFullYear());
    }
    if ($$self.$$.dirty[0] & /*report*/
    2) {
      $$invalidate(24, endYear = new Date(report.timestamps[report.timestamps.length - 1]).getFullYear());
    }
    if ($$self.$$.dirty[0] & /*selectedYear, selectedMonth*/
    48) {
      $$invalidate(23, stockRangeStart = selectedYear ? new Date(new Date(selectedYear, (selectedMonth || 1) - 1)) : null);
    }
    if ($$self.$$.dirty[0] & /*selectedYear, selectedMonth*/
    48) {
      $$invalidate(22, stockRangeEnd = selectedYear ? new Date(new Date(selectedYear, selectedMonth || 12) - 864e5) : null);
    }
    if ($$self.$$.dirty[0] & /*chart, theme*/
    1073741828) {
      if (chart) {
        chart.setTheme(theme);
      }
    }
    if ($$self.$$.dirty[0] & /*report*/
    2) {
      $$invalidate(7, monthlyReturn = report.calculateMonthlyReturn("strategy"));
    }
    if ($$self.$$.dirty[0] & /*monthlyReturn*/
    128) {
      $$invalidate(32, monthlyReturnValue = Object.values(monthlyReturn).filter((v2) => v2 == v2));
    }
    if ($$self.$$.dirty[1] & /*monthlyReturnValue*/
    2) {
      maxMonthlyReturn = Math.max(...monthlyReturnValue);
    }
    if ($$self.$$.dirty[1] & /*monthlyReturnValue*/
    2) {
      minMonthlyReturn = Math.min(...monthlyReturnValue);
    }
    if ($$self.$$.dirty[1] & /*monthlyReturnValue*/
    2) {
      $$invalidate(21, avgMonthlyReturn = sumArray(monthlyReturnValue) / monthlyReturnValue.length);
    }
    if ($$self.$$.dirty[1] & /*monthlyReturnValue*/
    2) {
      $$invalidate(20, winRate = monthlyReturnValue.filter((profit) => profit > 0).length / monthlyReturnValue.length * 100);
    }
    if ($$self.$$.dirty[0] & /*report*/
    2) {
      $$invalidate(6, yearlyReturn = report.calculateAnnualReturn("strategy"));
    }
    if ($$self.$$.dirty[0] & /*yearlyReturn*/
    64) {
      $$invalidate(31, yearlyReturnValue = Object.values(yearlyReturn).filter((v2) => v2 == v2));
    }
    if ($$self.$$.dirty[1] & /*yearlyReturnValue*/
    1) {
      minYearlyReturn = Math.min(...yearlyReturnValue);
    }
    if ($$self.$$.dirty[1] & /*yearlyReturnValue*/
    1) {
      maxYearlyReturn = Math.max(...yearlyReturnValue);
    }
    if ($$self.$$.dirty[0] & /*report*/
    2) {
      benchmarkYearlyReturn = report.calculateAnnualReturn("benchmark");
    }
    if ($$self.$$.dirty[0] & /*monthlyReturn, theme*/
    132) {
      if (monthlyReturn || theme) {
        $$invalidate(12, monthlyReturnColor = Object.fromEntries(Object.keys(monthlyReturn).map((key) => [key, color2(monthlyReturn[key])])));
      }
    }
    if ($$self.$$.dirty[0] & /*yearlyReturn, theme*/
    68) {
      if (yearlyReturn || theme) {
        $$invalidate(13, yearlyReturnColor = Object.fromEntries(Object.keys(yearlyReturn).map((key) => [key, yearlyColor(yearlyReturn[key])])));
      }
    }
  };
  {
    renderBarChart2();
  }
  return [
    browser,
    report,
    theme,
    lang,
    selectedMonth,
    selectedYear,
    yearlyReturn,
    monthlyReturn,
    chartDiv,
    hoverMonth,
    hoverYear,
    rangeMarker,
    monthlyReturnColor,
    yearlyReturnColor,
    excessReturn,
    winYearCount,
    lossYearCount,
    strategyCompareDiv,
    excessReturnDiv,
    i,
    winRate,
    avgMonthlyReturn,
    stockRangeEnd,
    stockRangeStart,
    endYear,
    startYear,
    selectedMonthRender,
    changeTWView,
    twRender,
    showAll,
    chart,
    yearlyReturnValue,
    monthlyReturnValue,
    div0_binding,
    div1_binding,
    click_handler,
    click_handler_1,
    click_handler_2,
    canvas0_binding,
    canvas1_binding
  ];
}
class Profitability extends SvelteComponent {
  constructor(options) {
    super();
    init(
      this,
      options,
      instance$7,
      create_fragment$7,
      safe_not_equal,
      {
        browser: 0,
        report: 1,
        theme: 2,
        showAll: 29,
        lang: 3
      },
      add_css$1,
      [-1, -1]
    );
  }
  get browser() {
    return this.$$.ctx[0];
  }
  set browser(browser) {
    this.$$set({ browser });
    flush();
  }
  get report() {
    return this.$$.ctx[1];
  }
  set report(report) {
    this.$$set({ report });
    flush();
  }
  get theme() {
    return this.$$.ctx[2];
  }
  set theme(theme) {
    this.$$set({ theme });
    flush();
  }
  get showAll() {
    return this.$$.ctx[29];
  }
  set showAll(showAll) {
    this.$$set({ showAll });
    flush();
  }
  get lang() {
    return this.$$.ctx[3];
  }
  set lang(lang) {
    this.$$set({ lang });
    flush();
  }
}
create_custom_element(Profitability, { "browser": {}, "report": {}, "theme": {}, "showAll": { "type": "Boolean" }, "lang": {} }, [], [], true);
function create_fragment$6(ctx) {
  let div20;
  let div1;
  let h30;
  let t0_value = (
    /*i*/
    ctx[6]("metrics.ratio.sharpeRatio") + ""
  );
  let t0;
  let t1;
  let span0;
  let t2_value = (
    /*i*/
    ctx[6]("metrics.ratio.timeBetterThanBenchmark") + ""
  );
  let t2;
  let t3;
  let t4_value = (
    /*sharpeAboveRate*/
    (ctx[7] * 100).toFixed(2) + ""
  );
  let t4;
  let t5;
  let t6;
  let div0;
  let t7;
  let div7;
  let h31;
  let t8_value = (
    /*i*/
    ctx[6]("metrics.ratio.yearlySharpeRatio") + ""
  );
  let t8;
  let t9;
  let span1;
  let t10_value = (
    /*i*/
    ctx[6]("metrics.ratio.timeBetterThanBenchmark") + ""
  );
  let t10;
  let t11;
  let t12;
  let t13;
  let t14_value = (
    /*yearlyIndex*/
    ctx[10].length + ""
  );
  let t14;
  let t15;
  let t16_value = (
    /*i*/
    ctx[6]("metrics.ratio.year") + ""
  );
  let t16;
  let t17;
  let div6;
  let div5;
  let div2;
  let t18_value = (
    /*i*/
    ctx[6]("strategy") + ""
  );
  let t18;
  let t19;
  let div3;
  let t20_value = (
    /*i*/
    ctx[6]("benchmark") + ""
  );
  let t20;
  let t21;
  let div4;
  let t22_value = (
    /*i*/
    ctx[6]("metrics.ratio.worseThanBenchmark") + ""
  );
  let t22;
  let t23;
  let canvas0;
  let t24;
  let div9;
  let div8;
  let t25;
  let div11;
  let h32;
  let t26_value = (
    /*i*/
    ctx[6]("metrics.ratio.rollingTailRatio") + ""
  );
  let t26;
  let t27;
  let span2;
  let t28_value = (
    /*i*/
    ctx[6]("metrics.ratio.timeBetterThanBenchmark") + ""
  );
  let t28;
  let t29;
  let t30_value = (
    /*tailAboveRate*/
    (ctx[9] * 100).toFixed(2) + ""
  );
  let t30;
  let t31;
  let t32;
  let div10;
  let t33;
  let div17;
  let h33;
  let t34_value = (
    /*i*/
    ctx[6]("metrics.ratio.yearlyTailRatio") + ""
  );
  let t34;
  let t35;
  let span3;
  let t36_value = (
    /*i*/
    ctx[6]("metrics.ratio.timeBetterThanBenchmark") + ""
  );
  let t36;
  let t37;
  let t38;
  let t39;
  let t40_value = (
    /*yearlyIndex*/
    ctx[10].length + ""
  );
  let t40;
  let t41;
  let t42_value = (
    /*i*/
    ctx[6]("metrics.ratio.year") + ""
  );
  let t42;
  let t43;
  let div16;
  let div15;
  let div12;
  let t44_value = (
    /*i*/
    ctx[6]("strategy") + ""
  );
  let t44;
  let t45;
  let div13;
  let t46_value = (
    /*i*/
    ctx[6]("benchmark") + ""
  );
  let t46;
  let t47;
  let div14;
  let t48_value = (
    /*i*/
    ctx[6]("metrics.ratio.worseThanBenchmark") + ""
  );
  let t48;
  let t49;
  let canvas1;
  let t50;
  let div19;
  let h34;
  let t51_value = (
    /*i*/
    ctx[6]("metrics.ratio.volatility") + ""
  );
  let t51;
  let t52;
  let span4;
  let t53_value = (
    /*i*/
    ctx[6]("metrics.ratio.timeBetterThanBenchmark") + ""
  );
  let t53;
  let t54;
  let t55_value = (
    /*volatilityAboveRate*/
    (ctx[8] * 100).toFixed(2) + ""
  );
  let t55;
  let t56;
  let t57;
  let div18;
  return {
    c() {
      div20 = element("div");
      div1 = element("div");
      h30 = element("h3");
      t0 = text(t0_value);
      t1 = space();
      span0 = element("span");
      t2 = text(t2_value);
      t3 = space();
      t4 = text(t4_value);
      t5 = text("％");
      t6 = space();
      div0 = element("div");
      t7 = space();
      div7 = element("div");
      h31 = element("h3");
      t8 = text(t8_value);
      t9 = space();
      span1 = element("span");
      t10 = text(t10_value);
      t11 = space();
      t12 = text(
        /*sharpeYearlyWinrate*/
        ctx[11]
      );
      t13 = text(" / ");
      t14 = text(t14_value);
      t15 = space();
      t16 = text(t16_value);
      t17 = space();
      div6 = element("div");
      div5 = element("div");
      div2 = element("div");
      t18 = text(t18_value);
      t19 = space();
      div3 = element("div");
      t20 = text(t20_value);
      t21 = space();
      div4 = element("div");
      t22 = text(t22_value);
      t23 = space();
      canvas0 = element("canvas");
      t24 = space();
      div9 = element("div");
      div8 = element("div");
      t25 = space();
      div11 = element("div");
      h32 = element("h3");
      t26 = text(t26_value);
      t27 = space();
      span2 = element("span");
      t28 = text(t28_value);
      t29 = space();
      t30 = text(t30_value);
      t31 = text("％");
      t32 = space();
      div10 = element("div");
      t33 = space();
      div17 = element("div");
      h33 = element("h3");
      t34 = text(t34_value);
      t35 = space();
      span3 = element("span");
      t36 = text(t36_value);
      t37 = space();
      t38 = text(
        /*tailYearlyWinrate*/
        ctx[12]
      );
      t39 = text(" / ");
      t40 = text(t40_value);
      t41 = space();
      t42 = text(t42_value);
      t43 = space();
      div16 = element("div");
      div15 = element("div");
      div12 = element("div");
      t44 = text(t44_value);
      t45 = space();
      div13 = element("div");
      t46 = text(t46_value);
      t47 = space();
      div14 = element("div");
      t48 = text(t48_value);
      t49 = space();
      canvas1 = element("canvas");
      t50 = space();
      div19 = element("div");
      h34 = element("h3");
      t51 = text(t51_value);
      t52 = space();
      span4 = element("span");
      t53 = text(t53_value);
      t54 = space();
      t55 = text(t55_value);
      t56 = text("％");
      t57 = space();
      div18 = element("div");
      attr(h30, "class", "text-2xl font-bold mb-1 text-base-content-200");
      attr(div0, "class", "h-48 mt-6");
      attr(div1, "class", "col-span-6 md:col-span-3 p-2 md:p-8 pt-8 md:border rounded-xl");
      attr(h31, "class", "text-2xl font-bold mb-1 text-base-content-200");
      attr(div2, "class", "badge rounded bg-primary text-white");
      attr(div3, "class", "badge rounded bg-gray-500 text-white");
      attr(div4, "class", "badge rounded bg-[rgba(241,99,102,1)] text-white");
      attr(div5, "class", "text-sm mt-2 flex gap-2");
      attr(canvas0, "class", "h-48 mt-4");
      set_style(canvas0, "width", "580px");
      attr(div6, "class", "w-full overflow-x-auto relative");
      attr(div7, "class", "col-span-6 md:col-span-3 p-2 md:p-8 pt-8 md:border rounded-xl");
      attr(div8, "class", "h-48 hidden");
      attr(div9, "class", "col-span-6 md:col-span-3 pt-8 md:p-8 hidden");
      attr(h32, "class", "text-2xl font-bold mb-1 text-base-content-200");
      attr(div10, "class", "h-48 mt-6");
      attr(div11, "class", "col-span-6 md:col-span-3 p-2 md:p-8 pt-8 md:border rounded-xl");
      attr(h33, "class", "text-2xl font-bold mb-1 text-base-content-200");
      attr(div12, "class", "badge rounded badge-primary text-white");
      attr(div13, "class", "badge rounded bg-gray-500 text-white");
      attr(div14, "class", "badge rounded bg-[rgba(241,99,102,1)] text-white");
      attr(div15, "class", "text-sm mt-2 flex gap-2");
      attr(canvas1, "class", "h-48 mt-4");
      set_style(canvas1, "width", "580px");
      attr(div16, "class", "w-full overflow-x-auto relative");
      attr(div17, "class", "col-span-6 md:col-span-3 p-2 md:p-8 pt-8 md:border rounded-xl");
      attr(h34, "class", "text-2xl font-bold mb-1 text-base-content-200");
      attr(div18, "class", "h-48 mt-6");
      attr(div19, "class", "col-span-6 p-2 md:p-8 pt-8 md:border rounded-xl");
      attr(div20, "class", "grid grid-cols-6 gap-4 text-base-content-200");
    },
    m(target, anchor) {
      insert(target, div20, anchor);
      append(div20, div1);
      append(div1, h30);
      append(h30, t0);
      append(div1, t1);
      append(div1, span0);
      append(span0, t2);
      append(span0, t3);
      append(span0, t4);
      append(span0, t5);
      append(div1, t6);
      append(div1, div0);
      ctx[17](div0);
      append(div20, t7);
      append(div20, div7);
      append(div7, h31);
      append(h31, t8);
      append(div7, t9);
      append(div7, span1);
      append(span1, t10);
      append(span1, t11);
      append(span1, t12);
      append(span1, t13);
      append(span1, t14);
      append(span1, t15);
      append(span1, t16);
      append(div7, t17);
      append(div7, div6);
      append(div6, div5);
      append(div5, div2);
      append(div2, t18);
      append(div5, t19);
      append(div5, div3);
      append(div3, t20);
      append(div5, t21);
      append(div5, div4);
      append(div4, t22);
      append(div6, t23);
      append(div6, canvas0);
      ctx[18](canvas0);
      append(div20, t24);
      append(div20, div9);
      append(div9, div8);
      ctx[19](div8);
      append(div20, t25);
      append(div20, div11);
      append(div11, h32);
      append(h32, t26);
      append(div11, t27);
      append(div11, span2);
      append(span2, t28);
      append(span2, t29);
      append(span2, t30);
      append(span2, t31);
      append(div11, t32);
      append(div11, div10);
      ctx[20](div10);
      append(div20, t33);
      append(div20, div17);
      append(div17, h33);
      append(h33, t34);
      append(div17, t35);
      append(div17, span3);
      append(span3, t36);
      append(span3, t37);
      append(span3, t38);
      append(span3, t39);
      append(span3, t40);
      append(span3, t41);
      append(span3, t42);
      append(div17, t43);
      append(div17, div16);
      append(div16, div15);
      append(div15, div12);
      append(div12, t44);
      append(div15, t45);
      append(div15, div13);
      append(div13, t46);
      append(div15, t47);
      append(div15, div14);
      append(div14, t48);
      append(div16, t49);
      append(div16, canvas1);
      ctx[21](canvas1);
      append(div20, t50);
      append(div20, div19);
      append(div19, h34);
      append(h34, t51);
      append(div19, t52);
      append(div19, span4);
      append(span4, t53);
      append(span4, t54);
      append(span4, t55);
      append(span4, t56);
      append(div19, t57);
      append(div19, div18);
      ctx[22](div18);
    },
    p(ctx2, dirty) {
      if (dirty[0] & /*i*/
      64 && t0_value !== (t0_value = /*i*/
      ctx2[6]("metrics.ratio.sharpeRatio") + ""))
        set_data(t0, t0_value);
      if (dirty[0] & /*i*/
      64 && t2_value !== (t2_value = /*i*/
      ctx2[6]("metrics.ratio.timeBetterThanBenchmark") + ""))
        set_data(t2, t2_value);
      if (dirty[0] & /*i*/
      64 && t8_value !== (t8_value = /*i*/
      ctx2[6]("metrics.ratio.yearlySharpeRatio") + ""))
        set_data(t8, t8_value);
      if (dirty[0] & /*i*/
      64 && t10_value !== (t10_value = /*i*/
      ctx2[6]("metrics.ratio.timeBetterThanBenchmark") + ""))
        set_data(t10, t10_value);
      if (dirty[0] & /*i*/
      64 && t16_value !== (t16_value = /*i*/
      ctx2[6]("metrics.ratio.year") + ""))
        set_data(t16, t16_value);
      if (dirty[0] & /*i*/
      64 && t18_value !== (t18_value = /*i*/
      ctx2[6]("strategy") + ""))
        set_data(t18, t18_value);
      if (dirty[0] & /*i*/
      64 && t20_value !== (t20_value = /*i*/
      ctx2[6]("benchmark") + ""))
        set_data(t20, t20_value);
      if (dirty[0] & /*i*/
      64 && t22_value !== (t22_value = /*i*/
      ctx2[6]("metrics.ratio.worseThanBenchmark") + ""))
        set_data(t22, t22_value);
      if (dirty[0] & /*i*/
      64 && t26_value !== (t26_value = /*i*/
      ctx2[6]("metrics.ratio.rollingTailRatio") + ""))
        set_data(t26, t26_value);
      if (dirty[0] & /*i*/
      64 && t28_value !== (t28_value = /*i*/
      ctx2[6]("metrics.ratio.timeBetterThanBenchmark") + ""))
        set_data(t28, t28_value);
      if (dirty[0] & /*i*/
      64 && t34_value !== (t34_value = /*i*/
      ctx2[6]("metrics.ratio.yearlyTailRatio") + ""))
        set_data(t34, t34_value);
      if (dirty[0] & /*i*/
      64 && t36_value !== (t36_value = /*i*/
      ctx2[6]("metrics.ratio.timeBetterThanBenchmark") + ""))
        set_data(t36, t36_value);
      if (dirty[0] & /*i*/
      64 && t42_value !== (t42_value = /*i*/
      ctx2[6]("metrics.ratio.year") + ""))
        set_data(t42, t42_value);
      if (dirty[0] & /*i*/
      64 && t44_value !== (t44_value = /*i*/
      ctx2[6]("strategy") + ""))
        set_data(t44, t44_value);
      if (dirty[0] & /*i*/
      64 && t46_value !== (t46_value = /*i*/
      ctx2[6]("benchmark") + ""))
        set_data(t46, t46_value);
      if (dirty[0] & /*i*/
      64 && t48_value !== (t48_value = /*i*/
      ctx2[6]("metrics.ratio.worseThanBenchmark") + ""))
        set_data(t48, t48_value);
      if (dirty[0] & /*i*/
      64 && t51_value !== (t51_value = /*i*/
      ctx2[6]("metrics.ratio.volatility") + ""))
        set_data(t51, t51_value);
      if (dirty[0] & /*i*/
      64 && t53_value !== (t53_value = /*i*/
      ctx2[6]("metrics.ratio.timeBetterThanBenchmark") + ""))
        set_data(t53, t53_value);
    },
    i: noop$1,
    o: noop$1,
    d(detaching) {
      if (detaching) {
        detach(div20);
      }
      ctx[17](null);
      ctx[18](null);
      ctx[19](null);
      ctx[20](null);
      ctx[21](null);
      ctx[22](null);
    }
  };
}
function aboveProbability(series1, series2) {
  let count = 0;
  for (let i2 = 0; i2 < series1.length; i2++) {
    if (series1[i2] > series2[i2]) {
      count++;
    }
  }
  return count / series1.length;
}
function instance$6($$self, $$props, $$invalidate) {
  let i;
  Chart.register(LinearScale, BarController, CategoryScale, BarElement, plugin_tooltip);
  let { browser } = $$props;
  let { report } = $$props;
  let { theme } = $$props;
  let { lang = "en" } = $$props;
  const sharpe = report.calculateSharpe("strategy", 0, 250);
  const sharpeBenchmark = report.calculateSharpe("benchmark", 0, 250);
  const sharpeAboveRate = aboveProbability(sharpe.map((s) => s.value), sharpeBenchmark.map((s) => s.value));
  let sharpeDiv;
  let sharpeChart = null;
  let sharpeYearlyDiv;
  const sortino = report.calculateSortino("strategy", 0, 250);
  const sortinoBenchmark = report.calculateSortino("benchmark", 0, 250);
  let sortinoDiv;
  let sortinoChart = null;
  const volatility = report.calculateVolitility("strategy", 0, 10).slice(-sortino.length);
  const volatilityBenchmark = report.calculateVolitility("benchmark", 0, 10).slice(-sortino.length);
  const volatilityAboveRate = aboveProbability(volatility.map((s) => s.value), volatilityBenchmark.map((s) => s.value));
  let volatilityDiv;
  let volatilityChart = null;
  const tail = report.calculateTailRatio("strategy", 250);
  const tailBenchmark = report.calculateTailRatio("benchmark", 250);
  const tailAboveRate = aboveProbability(tail.map((s) => s.value), tailBenchmark.map((s) => s.value));
  let tailDiv;
  let tailChart = null;
  let tailYearlyDiv;
  const startYear = parseInt(sharpe[0].time.slice(0, 4));
  const endYear = parseInt(sharpe[sharpe.length - 1].time.slice(0, 4));
  const years = Array.from(Array(endYear + 1).keys()).slice(startYear);
  const yearlyIndex = years.map((y2) => {
    return Math.max(Math.min(report.indexOfTimestamps(y2 + "-12-31") - 249, sharpe.length - 1), 0);
  });
  function yearlyWinRate(series, bseries) {
    return yearlyIndex.map((i2) => {
      const s = series[i2].value;
      const b2 = bseries[i2].value;
      return s > b2 ? 1 : s < b2 ? 0 : 0.5;
    }).reduce((acc, val) => acc + val, 0);
  }
  const sharpeYearlyWinrate = yearlyWinRate(sharpe, sharpeBenchmark);
  const tailYearlyWinrate = yearlyWinRate(tail, tailBenchmark);
  onMount(() => {
    if (!browser)
      return;
    sharpeChart = new TwChart(sharpeDiv, false);
    sharpeChart.setTheme(theme);
    sharpeChart.resetAreaSeries(0);
    sharpeChart.resetAreaSeries(1);
    let s = sharpe[0].time;
    let e2 = sharpe[sharpe.length - 1].time;
    sharpeChart.series[0].setData(sharpe);
    sharpeChart.series[1].setData(sharpeBenchmark);
    sharpeChart.setTimeScale(new Date(s), new Date(e2));
    sortinoChart = new TwChart(sortinoDiv, false);
    sortinoChart.setTheme(theme);
    sortinoChart.resetAreaSeries(0);
    sortinoChart.resetAreaSeries(1);
    s = sortino[0].time;
    e2 = sortino[sharpe.length - 1].time;
    sortinoChart.series[0].setData(sortino);
    sortinoChart.series[1].setData(sortinoBenchmark);
    sortinoChart.setTimeScale(new Date(s), new Date(e2));
    volatilityChart = new TwChart(volatilityDiv, false);
    volatilityChart.setTheme(theme);
    volatilityChart.resetAreaSeries(0);
    volatilityChart.resetAreaSeries(1);
    s = volatility[0].time;
    e2 = volatility[sharpe.length - 1].time;
    volatilityChart.series[0].setData(volatility);
    volatilityChart.series[1].setData(volatilityBenchmark);
    volatilityChart.setTimeScale(new Date(s), new Date(e2));
    tailChart = new TwChart(tailDiv, false);
    tailChart.setTheme(theme);
    tailChart.resetAreaSeries(0);
    tailChart.resetAreaSeries(1);
    s = tail[0].time;
    e2 = tail[sharpe.length - 1].time;
    tailChart.series[0].setData(tail);
    tailChart.series[1].setData(tailBenchmark);
    tailChart.setTimeScale(new Date(s), new Date(e2));
    const charts = [sharpeChart, sortinoChart, volatilityChart, tailChart];
    for (let c2 in charts) {
      const chart = charts[c2].chart;
      chart.timeScale().subscribeVisibleTimeRangeChange((param) => {
        const range = chart.timeScale().getVisibleLogicalRange();
        for (let c22 in charts) {
          if (c22 !== c2) {
            charts[c22].chart.timeScale().setVisibleLogicalRange(range);
          }
        }
      });
    }
    function determineColor(data1, data2) {
      return data1.map((value, index) => {
        return value < data2[index] ? "rgba(241, 99, 102, 1)" : theme === "light" ? "#725bf5" : "#7a64f5";
      });
    }
    var sharpeYearlyCtx = sharpeYearlyDiv.getContext("2d");
    new Chart(
      sharpeYearlyCtx,
      {
        type: "bar",
        data: {
          labels: years,
          datasets: [
            {
              label: i("metrics.ratio.sharpeRatio"),
              data: yearlyIndex.map((i2) => sharpe[i2].value),
              backgroundColor: determineColor(yearlyIndex.map((i2) => sharpe[i2].value), yearlyIndex.map((i2) => sharpeBenchmark[i2].value)),
              borderWidth: 0,
              barPercentage: 0.5
            },
            {
              label: i("benchmark"),
              data: yearlyIndex.map((i2) => sharpeBenchmark[i2].value),
              backgroundColor: "#77777777",
              borderWidth: 0,
              barPercentage: 0.5
            }
          ]
        },
        options: {
          responsive: true,
          maintainAspectRatio: true,
          scales: {
            y: {
              beginAtZero: true,
              ticks: {
                color: theme === "light" ? "#000000aa" : "#FFFFFFaa"
              },
              grid: {
                color: "#77777755",
                // This will set the x-axis grid color to a light red.
                tickBorderDash: [2, 2]
              }
            },
            x: {
              ticks: {
                color: theme === "light" ? "#000000aa" : "#FFFFFFaa"
              },
              grid: {
                color: "#77777755",
                // This will set the x-axis grid color to a light red.
                tickBorderDash: [2, 2]
              }
            }
          }
        }
      }
    );
    var tailYearlyCtx = tailYearlyDiv.getContext("2d");
    new Chart(
      tailYearlyCtx,
      {
        type: "bar",
        data: {
          labels: years,
          datasets: [
            {
              label: i("metrics.ratio.tailRatio"),
              data: yearlyIndex.map((i2) => tail[i2].value),
              backgroundColor: determineColor(yearlyIndex.map((i2) => tail[i2].value), yearlyIndex.map((i2) => tailBenchmark[i2].value)),
              // backgroundColor: 'rgb(99 102 241)', // Example color
              borderWidth: 0,
              barPercentage: 0.5
            },
            {
              label: i("benchmark"),
              data: yearlyIndex.map((i2) => tailBenchmark[i2].value),
              backgroundColor: "#77777777",
              borderWidth: 0,
              barPercentage: 0.5
            }
          ]
        },
        options: {
          responsive: true,
          maintainAspectRatio: true,
          scales: {
            y: {
              beginAtZero: true,
              ticks: {
                color: theme === "light" ? "#000000aa" : "#FFFFFFaa"
              },
              grid: {
                color: "#77777755",
                // This will set the x-axis grid color to a light red.
                tickBorderDash: [2, 2]
              }
            },
            x: {
              ticks: {
                color: theme === "light" ? "#000000aa" : "#FFFFFFaa"
              },
              grid: {
                color: "#77777755",
                // This will set the x-axis grid color to a light red.
                tickBorderDash: [2, 2]
              }
            }
          }
        }
      }
    );
  });
  function div0_binding($$value) {
    binding_callbacks[$$value ? "unshift" : "push"](() => {
      sharpeDiv = $$value;
      $$invalidate(0, sharpeDiv);
    });
  }
  function canvas0_binding($$value) {
    binding_callbacks[$$value ? "unshift" : "push"](() => {
      sharpeYearlyDiv = $$value;
      $$invalidate(1, sharpeYearlyDiv);
    });
  }
  function div8_binding($$value) {
    binding_callbacks[$$value ? "unshift" : "push"](() => {
      sortinoDiv = $$value;
      $$invalidate(2, sortinoDiv);
    });
  }
  function div10_binding($$value) {
    binding_callbacks[$$value ? "unshift" : "push"](() => {
      tailDiv = $$value;
      $$invalidate(4, tailDiv);
    });
  }
  function canvas1_binding($$value) {
    binding_callbacks[$$value ? "unshift" : "push"](() => {
      tailYearlyDiv = $$value;
      $$invalidate(5, tailYearlyDiv);
    });
  }
  function div18_binding($$value) {
    binding_callbacks[$$value ? "unshift" : "push"](() => {
      volatilityDiv = $$value;
      $$invalidate(3, volatilityDiv);
    });
  }
  $$self.$$set = ($$props2) => {
    if ("browser" in $$props2)
      $$invalidate(13, browser = $$props2.browser);
    if ("report" in $$props2)
      $$invalidate(14, report = $$props2.report);
    if ("theme" in $$props2)
      $$invalidate(15, theme = $$props2.theme);
    if ("lang" in $$props2)
      $$invalidate(16, lang = $$props2.lang);
  };
  $$self.$$.update = () => {
    if ($$self.$$.dirty[0] & /*lang*/
    65536) {
      $$invalidate(6, i = (key) => lang === "en" ? ien(key) : itw(key));
    }
  };
  return [
    sharpeDiv,
    sharpeYearlyDiv,
    sortinoDiv,
    volatilityDiv,
    tailDiv,
    tailYearlyDiv,
    i,
    sharpeAboveRate,
    volatilityAboveRate,
    tailAboveRate,
    yearlyIndex,
    sharpeYearlyWinrate,
    tailYearlyWinrate,
    browser,
    report,
    theme,
    lang,
    div0_binding,
    canvas0_binding,
    div8_binding,
    div10_binding,
    canvas1_binding,
    div18_binding
  ];
}
class Ratio extends SvelteComponent {
  constructor(options) {
    super();
    init(
      this,
      options,
      instance$6,
      create_fragment$6,
      safe_not_equal,
      {
        browser: 13,
        report: 14,
        theme: 15,
        lang: 16
      },
      null,
      [-1, -1]
    );
  }
  get browser() {
    return this.$$.ctx[13];
  }
  set browser(browser) {
    this.$$set({ browser });
    flush();
  }
  get report() {
    return this.$$.ctx[14];
  }
  set report(report) {
    this.$$set({ report });
    flush();
  }
  get theme() {
    return this.$$.ctx[15];
  }
  set theme(theme) {
    this.$$set({ theme });
    flush();
  }
  get lang() {
    return this.$$.ctx[16];
  }
  set lang(lang) {
    this.$$set({ lang });
    flush();
  }
}
create_custom_element(Ratio, { "browser": {}, "report": {}, "theme": {}, "lang": {} }, [], [], true);
function get_each_context$3(ctx, list, i) {
  const child_ctx = ctx.slice();
  child_ctx[35] = list[i];
  return child_ctx;
}
function get_each_context_1$3(ctx, list, i) {
  const child_ctx = ctx.slice();
  child_ctx[35] = list[i];
  return child_ctx;
}
function get_each_context_2$3(ctx, list, i) {
  const child_ctx = ctx.slice();
  child_ctx[35] = list[i];
  return child_ctx;
}
function create_each_block_2$3(ctx) {
  let div2;
  let div0;
  let t0_value = (
    /*report*/
    ctx[2].timestamps[
      /*drawdown*/
      ctx[35].start
    ].slice(0, 4) + ""
  );
  let t0;
  let t1;
  let div1;
  let t2_value = (
    /*drawdown*/
    (ctx[35].maxDrawdown * 100).toFixed(1) + ""
  );
  let t2;
  let t3;
  let t4;
  let div2_class_value;
  let mounted;
  let dispose;
  function click_handler() {
    return (
      /*click_handler*/
      ctx[22](
        /*drawdown*/
        ctx[35]
      )
    );
  }
  return {
    c() {
      div2 = element("div");
      div0 = element("div");
      t0 = text(t0_value);
      t1 = space();
      div1 = element("div");
      t2 = text(t2_value);
      t3 = text("%");
      t4 = space();
      attr(div0, "class", "text-xs");
      attr(div1, "class", "font-bold");
      attr(div2, "class", div2_class_value = `hover:badge-primary hover:text-white p-2 mt-1 mr-3 cursor-pointer rounded-md ${/*hoverYear*/
      ctx[11] === /*drawdown*/
      ctx[35] ? "outline outline-primary" : "bg-base-100"}`);
    },
    m(target, anchor) {
      insert(target, div2, anchor);
      append(div2, div0);
      append(div0, t0);
      append(div2, t1);
      append(div2, div1);
      append(div1, t2);
      append(div1, t3);
      append(div2, t4);
      if (!mounted) {
        dispose = listen(div2, "click", click_handler);
        mounted = true;
      }
    },
    p(new_ctx, dirty) {
      ctx = new_ctx;
      if (dirty[0] & /*report, top10drawdown*/
      20 && t0_value !== (t0_value = /*report*/
      ctx[2].timestamps[
        /*drawdown*/
        ctx[35].start
      ].slice(0, 4) + ""))
        set_data(t0, t0_value);
      if (dirty[0] & /*top10drawdown*/
      16 && t2_value !== (t2_value = /*drawdown*/
      (ctx[35].maxDrawdown * 100).toFixed(1) + ""))
        set_data(t2, t2_value);
      if (dirty[0] & /*hoverYear, top10drawdown*/
      2064 && div2_class_value !== (div2_class_value = `hover:badge-primary hover:text-white p-2 mt-1 mr-3 cursor-pointer rounded-md ${/*hoverYear*/
      ctx[11] === /*drawdown*/
      ctx[35] ? "outline outline-primary" : "bg-base-100"}`)) {
        attr(div2, "class", div2_class_value);
      }
    },
    d(detaching) {
      if (detaching) {
        detach(div2);
      }
      mounted = false;
      dispose();
    }
  };
}
function create_each_block_1$3(ctx) {
  let div5;
  let div0;
  let t0_value = (
    /*report*/
    ctx[2].timestamps[
      /*drawdown*/
      ctx[35].at
    ].slice(0, 4) + ""
  );
  let t0;
  let t1;
  let br0;
  let t2;
  let t3_value = (
    /*report*/
    ctx[2].timestamps[
      /*drawdown*/
      ctx[35].at
    ].slice(5, 7) + ""
  );
  let t3;
  let t4;
  let t5;
  let div3;
  let div1;
  let div1_style_value;
  let div1_class_value;
  let t6;
  let div2;
  let div2_style_value;
  let div2_class_value;
  let div3_class_value;
  let t7;
  let div4;
  let t8_value = (
    /*drawdown*/
    (ctx[35].maxDrawdown * 100).toFixed(1) + ""
  );
  let t8;
  let br1;
  let t9;
  let br2;
  let div4_class_value;
  let t10;
  let mounted;
  let dispose;
  function click_handler_3() {
    return (
      /*click_handler_3*/
      ctx[26](
        /*drawdown*/
        ctx[35]
      )
    );
  }
  return {
    c() {
      div5 = element("div");
      div0 = element("div");
      t0 = text(t0_value);
      t1 = space();
      br0 = element("br");
      t2 = space();
      t3 = text(t3_value);
      t4 = text(" 月");
      t5 = space();
      div3 = element("div");
      div1 = element("div");
      t6 = space();
      div2 = element("div");
      t7 = space();
      div4 = element("div");
      t8 = text(t8_value);
      br1 = element("br");
      t9 = text("% ");
      br2 = element("br");
      t10 = space();
      attr(div0, "class", "mt-2 border-b border-base-content/20 pb-4 px-2 text-center w-full");
      attr(div1, "style", div1_style_value = `height:${/*drawdown*/
      (ctx[35].maxDrawdown / /*top10drawdown*/
      ctx[4][0].maxDrawdown * 160).toFixed(0)}px`);
      attr(div1, "class", div1_class_value = `w-3 rounded-b-full mx-1 ${/*rankingTarget*/
      ctx[10] === "strategy" ? "bg-primary" : "bg-gray-400"}`);
      attr(div2, "style", div2_style_value = `height:${/*rankingTarget*/
      ((ctx[10] === "strategy" ? (
        /*benchmarkDrawdown*/
        ctx[15]
      ) : (
        /*strategyDrawdown*/
        ctx[16]
      ))[
        /*drawdown*/
        ctx[35].at
      ].value / 100 / Math.max(
        /*top10drawdown*/
        ctx[4][0].maxDrawdown,
        /*top10drawdownBenchmark*/
        ctx[13][0].maxDrawdown
      ) * 160).toFixed(0)}px`);
      attr(div2, "class", div2_class_value = `w-3 rounded-b-full mx-1 ${/*rankingTarget*/
      ctx[10] === "strategy" ? "bg-gray-400" : "bg-primary"}`);
      attr(div3, "class", div3_class_value = `flex justify-center ${/*rankingTarget*/
      ctx[10] === "benchmark" ? "flex-row-reverse" : ""}`);
      attr(div4, "class", div4_class_value = `w-20 pt-2 text-center text-primary ${/*i*/
      ctx[17] === 0 ? "text-2xl font-bold" : ""} ${/*rankingTarget*/
      ctx[10] === "strategy" ? "text-primary" : "text-gray-400"}`);
      attr(div5, "class", "flex flex-col justify-center items-center text-sm rounded-full pb-4 transition-all hover:cursor-pointer hover:text-base hover:-mt-4 hover:shadow-2xl hover:shadow-primary");
    },
    m(target, anchor) {
      insert(target, div5, anchor);
      append(div5, div0);
      append(div0, t0);
      append(div0, t1);
      append(div0, br0);
      append(div0, t2);
      append(div0, t3);
      append(div0, t4);
      append(div5, t5);
      append(div5, div3);
      append(div3, div1);
      append(div3, t6);
      append(div3, div2);
      append(div5, t7);
      append(div5, div4);
      append(div4, t8);
      append(div4, br1);
      append(div4, t9);
      append(div4, br2);
      append(div5, t10);
      if (!mounted) {
        dispose = listen(div5, "click", click_handler_3);
        mounted = true;
      }
    },
    p(new_ctx, dirty) {
      ctx = new_ctx;
      if (dirty[0] & /*report, rankingTarget, top10drawdown, top10drawdownBenchmark*/
      9236 && t0_value !== (t0_value = /*report*/
      ctx[2].timestamps[
        /*drawdown*/
        ctx[35].at
      ].slice(0, 4) + ""))
        set_data(t0, t0_value);
      if (dirty[0] & /*report, rankingTarget, top10drawdown, top10drawdownBenchmark*/
      9236 && t3_value !== (t3_value = /*report*/
      ctx[2].timestamps[
        /*drawdown*/
        ctx[35].at
      ].slice(5, 7) + ""))
        set_data(t3, t3_value);
      if (dirty[0] & /*rankingTarget, top10drawdown, top10drawdownBenchmark*/
      9232 && div1_style_value !== (div1_style_value = `height:${/*drawdown*/
      (ctx[35].maxDrawdown / /*top10drawdown*/
      ctx[4][0].maxDrawdown * 160).toFixed(0)}px`)) {
        attr(div1, "style", div1_style_value);
      }
      if (dirty[0] & /*rankingTarget*/
      1024 && div1_class_value !== (div1_class_value = `w-3 rounded-b-full mx-1 ${/*rankingTarget*/
      ctx[10] === "strategy" ? "bg-primary" : "bg-gray-400"}`)) {
        attr(div1, "class", div1_class_value);
      }
      if (dirty[0] & /*rankingTarget, benchmarkDrawdown, strategyDrawdown, top10drawdown, top10drawdownBenchmark*/
      107536 && div2_style_value !== (div2_style_value = `height:${/*rankingTarget*/
      ((ctx[10] === "strategy" ? (
        /*benchmarkDrawdown*/
        ctx[15]
      ) : (
        /*strategyDrawdown*/
        ctx[16]
      ))[
        /*drawdown*/
        ctx[35].at
      ].value / 100 / Math.max(
        /*top10drawdown*/
        ctx[4][0].maxDrawdown,
        /*top10drawdownBenchmark*/
        ctx[13][0].maxDrawdown
      ) * 160).toFixed(0)}px`)) {
        attr(div2, "style", div2_style_value);
      }
      if (dirty[0] & /*rankingTarget*/
      1024 && div2_class_value !== (div2_class_value = `w-3 rounded-b-full mx-1 ${/*rankingTarget*/
      ctx[10] === "strategy" ? "bg-gray-400" : "bg-primary"}`)) {
        attr(div2, "class", div2_class_value);
      }
      if (dirty[0] & /*rankingTarget*/
      1024 && div3_class_value !== (div3_class_value = `flex justify-center ${/*rankingTarget*/
      ctx[10] === "benchmark" ? "flex-row-reverse" : ""}`)) {
        attr(div3, "class", div3_class_value);
      }
      if (dirty[0] & /*rankingTarget, top10drawdown, top10drawdownBenchmark*/
      9232 && t8_value !== (t8_value = /*drawdown*/
      (ctx[35].maxDrawdown * 100).toFixed(1) + ""))
        set_data(t8, t8_value);
      if (dirty[0] & /*i, rankingTarget*/
      132096 && div4_class_value !== (div4_class_value = `w-20 pt-2 text-center text-primary ${/*i*/
      ctx[17] === 0 ? "text-2xl font-bold" : ""} ${/*rankingTarget*/
      ctx[10] === "strategy" ? "text-primary" : "text-gray-400"}`)) {
        attr(div4, "class", div4_class_value);
      }
    },
    d(detaching) {
      if (detaching) {
        detach(div5);
      }
      mounted = false;
      dispose();
    }
  };
}
function create_each_block$3(ctx) {
  let div4;
  let div0;
  let t0_value = (
    /*report*/
    ctx[2].timestamps[
      /*drawdown*/
      ctx[35].at
    ].slice(0, 4) + ""
  );
  let t0;
  let t1;
  let br0;
  let t2;
  let t3_value = (
    /*report*/
    ctx[2].timestamps[
      /*drawdown*/
      ctx[35].at
    ].slice(5, 7) + ""
  );
  let t3;
  let t4;
  let t5;
  let div2;
  let div1;
  let div1_style_value;
  let div1_class_value;
  let t6;
  let div3;
  let t7_value = (
    /*calc_days*/
    ctx[20](
      /*drawdown*/
      ctx[35]
    ) + ""
  );
  let t7;
  let t8;
  let br1;
  let t9;
  let t10_value = (
    /*i*/
    ctx[17]("metrics.risk.days") + ""
  );
  let t10;
  let div3_class_value;
  let t11;
  let mounted;
  let dispose;
  function click_handler_6() {
    return (
      /*click_handler_6*/
      ctx[29](
        /*drawdown*/
        ctx[35]
      )
    );
  }
  return {
    c() {
      div4 = element("div");
      div0 = element("div");
      t0 = text(t0_value);
      t1 = space();
      br0 = element("br");
      t2 = space();
      t3 = text(t3_value);
      t4 = text(" 月");
      t5 = space();
      div2 = element("div");
      div1 = element("div");
      t6 = space();
      div3 = element("div");
      t7 = text(t7_value);
      t8 = space();
      br1 = element("br");
      t9 = space();
      t10 = text(t10_value);
      t11 = space();
      attr(div0, "class", "mt-2 border-b border-base-content/20 pb-4 px-2 text-center w-full");
      attr(div1, "style", div1_style_value = `height:${/*calc_days*/
      (ctx[20](
        /*drawdown*/
        ctx[35]
      ) / Math.min(
        /*calc_days*/
        ctx[20](
          /*top10days*/
          ctx[14][0]
        ),
        /*calc_days*/
        ctx[20](
          /*top10daysBenchmark*/
          ctx[12][0]
        )
      ) * 160).toFixed(0)}px`);
      attr(div1, "class", div1_class_value = `w-3 rounded-b-full mx-1 ${/*rankingTarget*/
      ctx[10] === "strategy" ? "bg-primary" : "bg-gray-400"}`);
      attr(div3, "class", div3_class_value = `w-14 pt-2 text-center ${/*i*/
      ctx[17] === 0 ? "text-2xl font-bold" : ""} ${/*rankingTarget*/
      ctx[10] === "strategy" ? "text-primary" : "text-gray-400"}`);
      attr(div4, "class", "flex flex-col justify-center items-center text-sm rounded-full pb-4 transition-all hover:cursor-pointer hover:text-base hover:-mt-4 hover:shadow-2xl hover:shadow-primary");
    },
    m(target, anchor) {
      insert(target, div4, anchor);
      append(div4, div0);
      append(div0, t0);
      append(div0, t1);
      append(div0, br0);
      append(div0, t2);
      append(div0, t3);
      append(div0, t4);
      append(div4, t5);
      append(div4, div2);
      append(div2, div1);
      append(div4, t6);
      append(div4, div3);
      append(div3, t7);
      append(div3, t8);
      append(div3, br1);
      append(div3, t9);
      append(div3, t10);
      append(div4, t11);
      if (!mounted) {
        dispose = listen(div4, "click", click_handler_6);
        mounted = true;
      }
    },
    p(new_ctx, dirty) {
      ctx = new_ctx;
      if (dirty[0] & /*report, rankingTarget, top10days, top10daysBenchmark*/
      21508 && t0_value !== (t0_value = /*report*/
      ctx[2].timestamps[
        /*drawdown*/
        ctx[35].at
      ].slice(0, 4) + ""))
        set_data(t0, t0_value);
      if (dirty[0] & /*report, rankingTarget, top10days, top10daysBenchmark*/
      21508 && t3_value !== (t3_value = /*report*/
      ctx[2].timestamps[
        /*drawdown*/
        ctx[35].at
      ].slice(5, 7) + ""))
        set_data(t3, t3_value);
      if (dirty[0] & /*rankingTarget, top10days, top10daysBenchmark*/
      21504 && div1_style_value !== (div1_style_value = `height:${/*calc_days*/
      (ctx[20](
        /*drawdown*/
        ctx[35]
      ) / Math.min(
        /*calc_days*/
        ctx[20](
          /*top10days*/
          ctx[14][0]
        ),
        /*calc_days*/
        ctx[20](
          /*top10daysBenchmark*/
          ctx[12][0]
        )
      ) * 160).toFixed(0)}px`)) {
        attr(div1, "style", div1_style_value);
      }
      if (dirty[0] & /*rankingTarget*/
      1024 && div1_class_value !== (div1_class_value = `w-3 rounded-b-full mx-1 ${/*rankingTarget*/
      ctx[10] === "strategy" ? "bg-primary" : "bg-gray-400"}`)) {
        attr(div1, "class", div1_class_value);
      }
      if (dirty[0] & /*rankingTarget, top10days, top10daysBenchmark*/
      21504 && t7_value !== (t7_value = /*calc_days*/
      ctx[20](
        /*drawdown*/
        ctx[35]
      ) + ""))
        set_data(t7, t7_value);
      if (dirty[0] & /*i*/
      131072 && t10_value !== (t10_value = /*i*/
      ctx[17]("metrics.risk.days") + ""))
        set_data(t10, t10_value);
      if (dirty[0] & /*i, rankingTarget*/
      132096 && div3_class_value !== (div3_class_value = `w-14 pt-2 text-center ${/*i*/
      ctx[17] === 0 ? "text-2xl font-bold" : ""} ${/*rankingTarget*/
      ctx[10] === "strategy" ? "text-primary" : "text-gray-400"}`)) {
        attr(div3, "class", div3_class_value);
      }
    },
    d(detaching) {
      if (detaching) {
        detach(div4);
      }
      mounted = false;
      dispose();
    }
  };
}
function create_fragment$5(ctx) {
  var _a, _b;
  let div25;
  let div6;
  let div5;
  let h30;
  let t0_value = (
    /*i*/
    ctx[17]("risk.drawdowPeriods") + ""
  );
  let t0;
  let t1;
  let div1;
  let div0;
  let t2;
  let div4;
  let div2;
  let t3;
  let div3;
  let span0;
  let t4;
  let t5;
  let t6;
  let t7;
  let div9;
  let h31;
  let t8_value = (
    /*i*/
    ctx[17]("profitability.stockList") + ""
  );
  let t8;
  let t9;
  let h4;
  let t10_value = (
    /*stockRangeStart*/
    ((_a = ctx[8]) == null ? void 0 : _a.toLocaleDateString()) + ""
  );
  let t10;
  let t11;
  let t12_value = (
    /*stockRangeEnd*/
    ((_b = ctx[9]) == null ? void 0 : _b.toLocaleDateString()) + ""
  );
  let t12;
  let t13;
  let div8;
  let div7;
  let stocks;
  let t14;
  let div16;
  let h32;
  let t15_value = (
    /*i*/
    ctx[17]("metrics.risk.worstDrawdownPeriod") + ""
  );
  let t15;
  let t16;
  let div10;
  let button0;
  let t17_value = (
    /*i*/
    ctx[17]("metrics.risk.worst10Strategy") + ""
  );
  let t17;
  let button0_class_value;
  let t18;
  let button1;
  let t19_value = (
    /*i*/
    ctx[17]("metrics.risk.worst10Benchmark") + ""
  );
  let t19;
  let button1_class_value;
  let t20;
  let div12;
  let div11;
  let t21;
  let div15;
  let div13;
  let t22_value = (
    /*i*/
    ctx[17]("benchmark") + ""
  );
  let t22;
  let t23;
  let div14;
  let t24_value = (
    /*i*/
    ctx[17]("strategy") + ""
  );
  let t24;
  let t25;
  let div22;
  let h33;
  let t26_value = (
    /*i*/
    ctx[17]("metrics.risk.newHighTimeRank") + ""
  );
  let t26;
  let t27;
  let div17;
  let span1;
  let t28_value = (
    /*i*/
    ctx[17]("metrics.risk.worst10Strategy") + ""
  );
  let t28;
  let span1_class_value;
  let t29;
  let span2;
  let t30_value = (
    /*i*/
    ctx[17]("metrics.risk.worst10Benchmark") + ""
  );
  let t30;
  let span2_class_value;
  let t31;
  let div19;
  let div18;
  let t32;
  let div21;
  let div20;
  let t33_value = (
    /*i*/
    ctx[17]("strategy") + ""
  );
  let t33;
  let t34;
  let div24;
  let h34;
  let t35_value = (
    /*i*/
    ctx[17]("risk.drawdownPercentage") + ""
  );
  let t35;
  let t36;
  let div23;
  let current;
  let mounted;
  let dispose;
  let each_value_2 = ensure_array_like(
    /*top10drawdown*/
    ctx[4]
  );
  let each_blocks_2 = [];
  for (let i = 0; i < each_value_2.length; i += 1) {
    each_blocks_2[i] = create_each_block_2$3(get_each_context_2$3(ctx, each_value_2, i));
  }
  stocks = new Stocks({
    props: {
      lang: (
        /*lang*/
        ctx[0]
      ),
      report: (
        /*report*/
        ctx[2]
      ),
      theme: (
        /*theme*/
        ctx[3]
      ),
      browser: (
        /*browser*/
        ctx[1]
      ),
      tstart: (
        /*stockRangeStart*/
        ctx[8]
      ),
      tend: (
        /*stockRangeEnd*/
        ctx[9]
      )
    }
  });
  let each_value_1 = ensure_array_like(
    /*rankingTarget*/
    ctx[10] === "strategy" ? (
      /*top10drawdown*/
      ctx[4]
    ) : (
      /*top10drawdownBenchmark*/
      ctx[13]
    )
  );
  let each_blocks_1 = [];
  for (let i = 0; i < each_value_1.length; i += 1) {
    each_blocks_1[i] = create_each_block_1$3(get_each_context_1$3(ctx, each_value_1, i));
  }
  let each_value = ensure_array_like(
    /*rankingTarget*/
    ctx[10] === "strategy" ? (
      /*top10days*/
      ctx[14]
    ) : (
      /*top10daysBenchmark*/
      ctx[12]
    )
  );
  let each_blocks = [];
  for (let i = 0; i < each_value.length; i += 1) {
    each_blocks[i] = create_each_block$3(get_each_context$3(ctx, each_value, i));
  }
  return {
    c() {
      div25 = element("div");
      div6 = element("div");
      div5 = element("div");
      h30 = element("h3");
      t0 = text(t0_value);
      t1 = space();
      div1 = element("div");
      div0 = element("div");
      for (let i = 0; i < each_blocks_2.length; i += 1) {
        each_blocks_2[i].c();
      }
      t2 = space();
      div4 = element("div");
      div2 = element("div");
      t3 = space();
      div3 = element("div");
      span0 = element("span");
      t4 = text(
        /*twChartPeriod*/
        ctx[7]
      );
      t5 = space();
      t6 = text("天");
      t7 = space();
      div9 = element("div");
      h31 = element("h3");
      t8 = text(t8_value);
      t9 = space();
      h4 = element("h4");
      t10 = text(t10_value);
      t11 = text("~");
      t12 = text(t12_value);
      t13 = space();
      div8 = element("div");
      div7 = element("div");
      create_component(stocks.$$.fragment);
      t14 = space();
      div16 = element("div");
      h32 = element("h3");
      t15 = text(t15_value);
      t16 = space();
      div10 = element("div");
      button0 = element("button");
      t17 = text(t17_value);
      t18 = space();
      button1 = element("button");
      t19 = text(t19_value);
      t20 = space();
      div12 = element("div");
      div11 = element("div");
      for (let i = 0; i < each_blocks_1.length; i += 1) {
        each_blocks_1[i].c();
      }
      t21 = space();
      div15 = element("div");
      div13 = element("div");
      t22 = text(t22_value);
      t23 = space();
      div14 = element("div");
      t24 = text(t24_value);
      t25 = space();
      div22 = element("div");
      h33 = element("h3");
      t26 = text(t26_value);
      t27 = space();
      div17 = element("div");
      span1 = element("span");
      t28 = text(t28_value);
      t29 = space();
      span2 = element("span");
      t30 = text(t30_value);
      t31 = space();
      div19 = element("div");
      div18 = element("div");
      for (let i = 0; i < each_blocks.length; i += 1) {
        each_blocks[i].c();
      }
      t32 = space();
      div21 = element("div");
      div20 = element("div");
      t33 = text(t33_value);
      t34 = space();
      div24 = element("div");
      h34 = element("h3");
      t35 = text(t35_value);
      t36 = space();
      div23 = element("div");
      attr(h30, "class", "text-2xl font-bold text-base-content-200");
      attr(div0, "class", `flex mt-2 overflow-x-auto max-w-full pb-4 pl-1 no-scrollbar`);
      attr(div1, "class", "flex");
      attr(div2, "class", "text-primary h-64 z-0");
      attr(span0, "class", "text-2xl font-bold text-primary");
      attr(div3, "class", "absolute bottom-8 left-2");
      attr(div4, "class", "relative overflow-hidden");
      attr(div5, "class", "h-full");
      attr(div6, "class", "col-span-6 md:p-8 pt-8 sm:rounded-xl md:border");
      attr(h31, "class", "text-base-content-200 text-2xl font-bold md:text-center");
      attr(h4, "class", "mt-2 text-base-content-100 md:text-center");
      attr(div7, "class", `overflow-auto max-h-72 text-base-content
				${isMobile() ? "no-scrollbar" : "show-scrollbar"}
				`);
      attr(div8, "class", "relative");
      attr(div9, "class", "col-span-6 md:col-span-6 md:p-8 pt-8 md:border sm:rounded-xl");
      attr(h32, "class", "text-2xl font-bold text-base-content-200 text-center");
      attr(button0, "class", button0_class_value = `border border-base-content/10 text-sm bg-base-100 hover:badge-primary hover:text-white px-2 py-1 rounded-xl ${/*rankingTarget*/
      ctx[10] === "strategy" ? "outline outline-primary" : ""}`);
      attr(button1, "class", button1_class_value = `border border-base-content/10 text-sm bg-base-100 hover:badge-primary hover:text-white px-2 py-1 rounded-xl ${/*rankingTarget*/
      ctx[10] === "benchmark" ? "outline outline-primary" : ""}`);
      attr(div10, "class", "flex mt-4 justify-center gap-2");
      attr(div11, "class", "grid grid-cols-5 justify-start items-start mt-4");
      attr(div13, "class", "badge rounded bg-gray-500 text-white");
      attr(div14, "class", "badge rounded bg-primary text-white");
      attr(div15, "class", "absolute inset-x-0 bottom-0 flex justify-center my-2 text-sm gap-2");
      set_style(div15, "direction", "rtl");
      attr(div16, "class", "relative col-span-6 md:col-span-3 md:p-8 pt-8 sm:rounded-xl md:border");
      attr(h33, "class", "text-2xl font-bold text-base-content-200 text-center");
      attr(span1, "class", span1_class_value = `border border-base-content/10 text-sm bg-base-100 hover:badge-primary hover:text-white px-2 py-1 cursor-pointer rounded-xl ${/*rankingTarget*/
      ctx[10] === "strategy" ? "outline outline-primary" : ""}`);
      attr(span2, "class", span2_class_value = `border border-base-content/10 text-sm bg-base-100 hover:badge-primary hover:text-white px-2 py-1 cursor-pointer rounded-xl ${/*rankingTarget*/
      ctx[10] === "benchmark" ? "outline outline-primary" : ""}`);
      attr(div17, "class", "flex mt-4 justify-center gap-2");
      attr(div18, "class", "flex justify-between items-start mt-4 text-sm");
      attr(div20, "class", "badge rounded badge-primary text-white");
      attr(div21, "class", "absolute inset-x-0 bottom-0 flex justify-center my-2 text-sm");
      set_style(div21, "direction", "rtl");
      attr(div22, "class", "relative col-span-6 md:col-span-3 md:p-8 pt-8 sm:rounded-xl md:border");
      attr(h34, "class", "text-2xl font-bold text-base-content-200");
      attr(div23, "class", "text-primary h-48 z-0");
      attr(div24, "class", "col-span-6 md:p-8 pt-8 sm:rounded-xl md:border");
      attr(div25, "class", "grid grid-cols-6 gap-4 text-base-content-300");
    },
    m(target, anchor) {
      insert(target, div25, anchor);
      append(div25, div6);
      append(div6, div5);
      append(div5, h30);
      append(h30, t0);
      append(div5, t1);
      append(div5, div1);
      append(div1, div0);
      for (let i = 0; i < each_blocks_2.length; i += 1) {
        if (each_blocks_2[i]) {
          each_blocks_2[i].m(div0, null);
        }
      }
      append(div5, t2);
      append(div5, div4);
      append(div4, div2);
      ctx[23](div2);
      append(div4, t3);
      append(div4, div3);
      append(div3, span0);
      append(span0, t4);
      append(span0, t5);
      append(div3, t6);
      append(div25, t7);
      append(div25, div9);
      append(div9, h31);
      append(h31, t8);
      append(div9, t9);
      append(div9, h4);
      append(h4, t10);
      append(h4, t11);
      append(h4, t12);
      append(div9, t13);
      append(div9, div8);
      append(div8, div7);
      mount_component(stocks, div7, null);
      append(div25, t14);
      append(div25, div16);
      append(div16, h32);
      append(h32, t15);
      append(div16, t16);
      append(div16, div10);
      append(div10, button0);
      append(button0, t17);
      append(div10, t18);
      append(div10, button1);
      append(button1, t19);
      append(div16, t20);
      append(div16, div12);
      append(div12, div11);
      for (let i = 0; i < each_blocks_1.length; i += 1) {
        if (each_blocks_1[i]) {
          each_blocks_1[i].m(div11, null);
        }
      }
      append(div16, t21);
      append(div16, div15);
      append(div15, div13);
      append(div13, t22);
      append(div15, t23);
      append(div15, div14);
      append(div14, t24);
      append(div25, t25);
      append(div25, div22);
      append(div22, h33);
      append(h33, t26);
      append(div22, t27);
      append(div22, div17);
      append(div17, span1);
      append(span1, t28);
      append(div17, t29);
      append(div17, span2);
      append(span2, t30);
      append(div22, t31);
      append(div22, div19);
      append(div19, div18);
      for (let i = 0; i < each_blocks.length; i += 1) {
        if (each_blocks[i]) {
          each_blocks[i].m(div18, null);
        }
      }
      append(div22, t32);
      append(div22, div21);
      append(div21, div20);
      append(div20, t33);
      append(div25, t34);
      append(div25, div24);
      append(div24, h34);
      append(h34, t35);
      append(div24, t36);
      append(div24, div23);
      ctx[30](div23);
      current = true;
      if (!mounted) {
        dispose = [
          listen(
            button0,
            "click",
            /*click_handler_1*/
            ctx[24]
          ),
          listen(
            button1,
            "click",
            /*click_handler_2*/
            ctx[25]
          ),
          listen(
            span1,
            "click",
            /*click_handler_4*/
            ctx[27]
          ),
          listen(
            span2,
            "click",
            /*click_handler_5*/
            ctx[28]
          )
        ];
        mounted = true;
      }
    },
    p(ctx2, dirty) {
      var _a2, _b2;
      if ((!current || dirty[0] & /*i*/
      131072) && t0_value !== (t0_value = /*i*/
      ctx2[17]("risk.drawdowPeriods") + ""))
        set_data(t0, t0_value);
      if (dirty[0] & /*hoverYear, top10drawdown, twRender, changeTWView, report*/
      788500) {
        each_value_2 = ensure_array_like(
          /*top10drawdown*/
          ctx2[4]
        );
        let i;
        for (i = 0; i < each_value_2.length; i += 1) {
          const child_ctx = get_each_context_2$3(ctx2, each_value_2, i);
          if (each_blocks_2[i]) {
            each_blocks_2[i].p(child_ctx, dirty);
          } else {
            each_blocks_2[i] = create_each_block_2$3(child_ctx);
            each_blocks_2[i].c();
            each_blocks_2[i].m(div0, null);
          }
        }
        for (; i < each_blocks_2.length; i += 1) {
          each_blocks_2[i].d(1);
        }
        each_blocks_2.length = each_value_2.length;
      }
      if (!current || dirty[0] & /*twChartPeriod*/
      128)
        set_data(
          t4,
          /*twChartPeriod*/
          ctx2[7]
        );
      if ((!current || dirty[0] & /*i*/
      131072) && t8_value !== (t8_value = /*i*/
      ctx2[17]("profitability.stockList") + ""))
        set_data(t8, t8_value);
      if ((!current || dirty[0] & /*stockRangeStart*/
      256) && t10_value !== (t10_value = /*stockRangeStart*/
      ((_a2 = ctx2[8]) == null ? void 0 : _a2.toLocaleDateString()) + ""))
        set_data(t10, t10_value);
      if ((!current || dirty[0] & /*stockRangeEnd*/
      512) && t12_value !== (t12_value = /*stockRangeEnd*/
      ((_b2 = ctx2[9]) == null ? void 0 : _b2.toLocaleDateString()) + ""))
        set_data(t12, t12_value);
      const stocks_changes = {};
      if (dirty[0] & /*lang*/
      1)
        stocks_changes.lang = /*lang*/
        ctx2[0];
      if (dirty[0] & /*report*/
      4)
        stocks_changes.report = /*report*/
        ctx2[2];
      if (dirty[0] & /*theme*/
      8)
        stocks_changes.theme = /*theme*/
        ctx2[3];
      if (dirty[0] & /*browser*/
      2)
        stocks_changes.browser = /*browser*/
        ctx2[1];
      if (dirty[0] & /*stockRangeStart*/
      256)
        stocks_changes.tstart = /*stockRangeStart*/
        ctx2[8];
      if (dirty[0] & /*stockRangeEnd*/
      512)
        stocks_changes.tend = /*stockRangeEnd*/
        ctx2[9];
      stocks.$set(stocks_changes);
      if ((!current || dirty[0] & /*i*/
      131072) && t15_value !== (t15_value = /*i*/
      ctx2[17]("metrics.risk.worstDrawdownPeriod") + ""))
        set_data(t15, t15_value);
      if ((!current || dirty[0] & /*i*/
      131072) && t17_value !== (t17_value = /*i*/
      ctx2[17]("metrics.risk.worst10Strategy") + ""))
        set_data(t17, t17_value);
      if (!current || dirty[0] & /*rankingTarget*/
      1024 && button0_class_value !== (button0_class_value = `border border-base-content/10 text-sm bg-base-100 hover:badge-primary hover:text-white px-2 py-1 rounded-xl ${/*rankingTarget*/
      ctx2[10] === "strategy" ? "outline outline-primary" : ""}`)) {
        attr(button0, "class", button0_class_value);
      }
      if ((!current || dirty[0] & /*i*/
      131072) && t19_value !== (t19_value = /*i*/
      ctx2[17]("metrics.risk.worst10Benchmark") + ""))
        set_data(t19, t19_value);
      if (!current || dirty[0] & /*rankingTarget*/
      1024 && button1_class_value !== (button1_class_value = `border border-base-content/10 text-sm bg-base-100 hover:badge-primary hover:text-white px-2 py-1 rounded-xl ${/*rankingTarget*/
      ctx2[10] === "benchmark" ? "outline outline-primary" : ""}`)) {
        attr(button1, "class", button1_class_value);
      }
      if (dirty[0] & /*twRender, changeTWView, report, rankingTarget, top10drawdown, top10drawdownBenchmark, hoverYear, i, benchmarkDrawdown, strategyDrawdown*/
      1027092) {
        each_value_1 = ensure_array_like(
          /*rankingTarget*/
          ctx2[10] === "strategy" ? (
            /*top10drawdown*/
            ctx2[4]
          ) : (
            /*top10drawdownBenchmark*/
            ctx2[13]
          )
        );
        let i;
        for (i = 0; i < each_value_1.length; i += 1) {
          const child_ctx = get_each_context_1$3(ctx2, each_value_1, i);
          if (each_blocks_1[i]) {
            each_blocks_1[i].p(child_ctx, dirty);
          } else {
            each_blocks_1[i] = create_each_block_1$3(child_ctx);
            each_blocks_1[i].c();
            each_blocks_1[i].m(div11, null);
          }
        }
        for (; i < each_blocks_1.length; i += 1) {
          each_blocks_1[i].d(1);
        }
        each_blocks_1.length = each_value_1.length;
      }
      if ((!current || dirty[0] & /*i*/
      131072) && t22_value !== (t22_value = /*i*/
      ctx2[17]("benchmark") + ""))
        set_data(t22, t22_value);
      if ((!current || dirty[0] & /*i*/
      131072) && t24_value !== (t24_value = /*i*/
      ctx2[17]("strategy") + ""))
        set_data(t24, t24_value);
      if ((!current || dirty[0] & /*i*/
      131072) && t26_value !== (t26_value = /*i*/
      ctx2[17]("metrics.risk.newHighTimeRank") + ""))
        set_data(t26, t26_value);
      if ((!current || dirty[0] & /*i*/
      131072) && t28_value !== (t28_value = /*i*/
      ctx2[17]("metrics.risk.worst10Strategy") + ""))
        set_data(t28, t28_value);
      if (!current || dirty[0] & /*rankingTarget*/
      1024 && span1_class_value !== (span1_class_value = `border border-base-content/10 text-sm bg-base-100 hover:badge-primary hover:text-white px-2 py-1 cursor-pointer rounded-xl ${/*rankingTarget*/
      ctx2[10] === "strategy" ? "outline outline-primary" : ""}`)) {
        attr(span1, "class", span1_class_value);
      }
      if ((!current || dirty[0] & /*i*/
      131072) && t30_value !== (t30_value = /*i*/
      ctx2[17]("metrics.risk.worst10Benchmark") + ""))
        set_data(t30, t30_value);
      if (!current || dirty[0] & /*rankingTarget*/
      1024 && span2_class_value !== (span2_class_value = `border border-base-content/10 text-sm bg-base-100 hover:badge-primary hover:text-white px-2 py-1 cursor-pointer rounded-xl ${/*rankingTarget*/
      ctx2[10] === "benchmark" ? "outline outline-primary" : ""}`)) {
        attr(span2, "class", span2_class_value);
      }
      if (dirty[0] & /*twRender, changeTWView, report, rankingTarget, top10days, top10daysBenchmark, hoverYear, i, calc_days*/
      1989636) {
        each_value = ensure_array_like(
          /*rankingTarget*/
          ctx2[10] === "strategy" ? (
            /*top10days*/
            ctx2[14]
          ) : (
            /*top10daysBenchmark*/
            ctx2[12]
          )
        );
        let i;
        for (i = 0; i < each_value.length; i += 1) {
          const child_ctx = get_each_context$3(ctx2, each_value, i);
          if (each_blocks[i]) {
            each_blocks[i].p(child_ctx, dirty);
          } else {
            each_blocks[i] = create_each_block$3(child_ctx);
            each_blocks[i].c();
            each_blocks[i].m(div18, null);
          }
        }
        for (; i < each_blocks.length; i += 1) {
          each_blocks[i].d(1);
        }
        each_blocks.length = each_value.length;
      }
      if ((!current || dirty[0] & /*i*/
      131072) && t33_value !== (t33_value = /*i*/
      ctx2[17]("strategy") + ""))
        set_data(t33, t33_value);
      if ((!current || dirty[0] & /*i*/
      131072) && t35_value !== (t35_value = /*i*/
      ctx2[17]("risk.drawdownPercentage") + ""))
        set_data(t35, t35_value);
    },
    i(local) {
      if (current)
        return;
      transition_in(stocks.$$.fragment, local);
      current = true;
    },
    o(local) {
      transition_out(stocks.$$.fragment, local);
      current = false;
    },
    d(detaching) {
      if (detaching) {
        detach(div25);
      }
      destroy_each(each_blocks_2, detaching);
      ctx[23](null);
      destroy_component(stocks);
      destroy_each(each_blocks_1, detaching);
      destroy_each(each_blocks, detaching);
      ctx[30](null);
      mounted = false;
      run_all(dispose);
    }
  };
}
function instance$5($$self, $$props, $$invalidate) {
  let i;
  let strategyDrawdown;
  let benchmarkDrawdown;
  let top10drawdown;
  let top10days;
  let top10drawdownBenchmark;
  let top10daysBenchmark;
  let hoverYear;
  let { lang = "en" } = $$props;
  let { browser } = $$props;
  let { report } = $$props;
  let { theme = "light" } = $$props;
  let chartDiv;
  let drawdownDiv;
  let chart = null;
  let drawdownChart = null;
  let twChartPeriod = null;
  let stockRangeStart = null;
  let stockRangeEnd = null;
  function changeTWView(s, e2) {
    if (!chart) {
      return;
    }
    if (typeof s === "string" && typeof e2 === "string") {
      const sd = new Date(s);
      const ed = new Date(e2);
      chart.setTimeScale(sd, ed);
      $$invalidate(7, twChartPeriod = calc_days({ start: s, end: e2 }));
      $$invalidate(7, twChartPeriod = ((sd - ed) / (1e3 * 3600 * 24)).toFixed(0));
      $$invalidate(8, stockRangeStart = sd);
      $$invalidate(9, stockRangeEnd = ed);
    } else {
      const i2 = report.indexOfTimestamps(s);
      const j2 = report.indexOfTimestamps(e2);
      const sd = new Date(report.timestamps[i2]);
      const ed = new Date(report.timestamps[j2]);
      chart.setTimeScale(sd, ed);
      $$invalidate(8, stockRangeStart = sd);
      $$invalidate(9, stockRangeEnd = ed);
    }
  }
  function drawdownTWRender() {
    if (!drawdownChart) {
      drawdownChart = new TwChart(drawdownDiv, false);
    }
    drawdownChart.setTheme(theme);
    report.timestamps.length;
    drawdownChart.resetAreaSeries(0);
    drawdownChart.resetAreaSeries(1);
    drawdownChart.series[0].setData(strategyDrawdown);
    drawdownChart.series[1].setData(benchmarkDrawdown);
    drawdownChart.setTimeScale(new Date(report.timestamps[0]), new Date(report.timestamps[report.timestamps.length - 1]));
  }
  function twRender(renderType) {
    if (!chart) {
      $$invalidate(21, chart = new TwChart(chartDiv, true));
    }
    chart.setTheme(theme);
    const viewLength = renderType === "all" ? report.timestamps.length : 100;
    const nlimit = report.timestamps.length / (viewLength / 100);
    const s1 = report.createTradingviewSeries("strategy", 0, -1, nlimit);
    const s2 = report.createTradingviewSeries("benchmark", 0, -1, nlimit);
    chart.resetAreaSeries(0);
    chart.resetAreaSeries(1);
    chart.series[0].setData(s1);
    chart.series[1].setData(s2);
    chart.chart.subscribeCrosshairMove((param) => {
    });
    chart.chart.subscribeClick((param) => {
    });
    chart.chart.timeScale().subscribeVisibleTimeRangeChange((param) => {
    });
    if (renderType === "all") {
      chart.setTimeScale(new Date(report.timestamps[0]), new Date(report.timestamps[report.timestamps.length - 1]));
    }
  }
  let rankingTarget = "strategy";
  const calc_days = (d2) => {
    return ((new Date(report.timestamps[d2.end]) - new Date(report.timestamps[d2.start])) / (1e3 * 3600 * 24)).toFixed(0);
  };
  onMount(() => {
    if (!browser)
      return;
    const drawdown = top10drawdown[0];
    twRender("year");
    changeTWView(report.timestamps[drawdown.start], report.timestamps[drawdown.end]);
    drawdownTWRender();
  });
  const click_handler = (drawdown) => {
    twRender("year");
    changeTWView(report.timestamps[drawdown.start], report.timestamps[drawdown.end]);
    $$invalidate(11, hoverYear = drawdown);
  };
  function div2_binding($$value) {
    binding_callbacks[$$value ? "unshift" : "push"](() => {
      chartDiv = $$value;
      $$invalidate(5, chartDiv);
    });
  }
  const click_handler_1 = () => {
    $$invalidate(10, rankingTarget = "strategy");
  };
  const click_handler_2 = () => {
    $$invalidate(10, rankingTarget = "benchmark");
  };
  const click_handler_3 = (drawdown) => {
    twRender("year");
    changeTWView(report.timestamps[drawdown.start], report.timestamps[drawdown.end]);
    $$invalidate(11, hoverYear = drawdown);
  };
  const click_handler_4 = () => {
    $$invalidate(10, rankingTarget = "strategy");
  };
  const click_handler_5 = () => {
    $$invalidate(10, rankingTarget = "benchmark");
  };
  const click_handler_6 = (drawdown) => {
    twRender("year");
    changeTWView(report.timestamps[drawdown.start], report.timestamps[drawdown.end]);
    $$invalidate(11, hoverYear = drawdown);
  };
  function div23_binding($$value) {
    binding_callbacks[$$value ? "unshift" : "push"](() => {
      drawdownDiv = $$value;
      $$invalidate(6, drawdownDiv);
    });
  }
  $$self.$$set = ($$props2) => {
    if ("lang" in $$props2)
      $$invalidate(0, lang = $$props2.lang);
    if ("browser" in $$props2)
      $$invalidate(1, browser = $$props2.browser);
    if ("report" in $$props2)
      $$invalidate(2, report = $$props2.report);
    if ("theme" in $$props2)
      $$invalidate(3, theme = $$props2.theme);
  };
  $$self.$$.update = () => {
    if ($$self.$$.dirty[0] & /*lang*/
    1) {
      $$invalidate(17, i = (key) => lang === "en" ? ien(key) : itw(key));
    }
    if ($$self.$$.dirty[0] & /*report*/
    4) {
      $$invalidate(16, strategyDrawdown = report.createTradingViewDrawdown("strategy", report.timestamps.length));
    }
    if ($$self.$$.dirty[0] & /*report*/
    4) {
      $$invalidate(15, benchmarkDrawdown = report.createTradingViewDrawdown("benchmark", report.timestamps.length));
    }
    if ($$self.$$.dirty[0] & /*chart, theme*/
    2097160) {
      if (chart) {
        chart.setTheme(theme);
      }
    }
    if ($$self.$$.dirty[0] & /*report*/
    4) {
      $$invalidate(4, [top10drawdown, top10days] = report.calculateDrawdown("strategy"), top10drawdown, ($$invalidate(14, top10days), $$invalidate(2, report)));
    }
    if ($$self.$$.dirty[0] & /*report*/
    4) {
      $$invalidate(13, [top10drawdownBenchmark, top10daysBenchmark] = report.calculateDrawdown("benchmark"), top10drawdownBenchmark, ($$invalidate(12, top10daysBenchmark), $$invalidate(2, report)));
    }
    if ($$self.$$.dirty[0] & /*top10drawdown*/
    16) {
      $$invalidate(11, hoverYear = top10drawdown[0]);
    }
  };
  return [
    lang,
    browser,
    report,
    theme,
    top10drawdown,
    chartDiv,
    drawdownDiv,
    twChartPeriod,
    stockRangeStart,
    stockRangeEnd,
    rankingTarget,
    hoverYear,
    top10daysBenchmark,
    top10drawdownBenchmark,
    top10days,
    benchmarkDrawdown,
    strategyDrawdown,
    i,
    changeTWView,
    twRender,
    calc_days,
    chart,
    click_handler,
    div2_binding,
    click_handler_1,
    click_handler_2,
    click_handler_3,
    click_handler_4,
    click_handler_5,
    click_handler_6,
    div23_binding
  ];
}
class Risk extends SvelteComponent {
  constructor(options) {
    super();
    init(this, options, instance$5, create_fragment$5, safe_not_equal, { lang: 0, browser: 1, report: 2, theme: 3 }, null, [-1, -1]);
  }
  get lang() {
    return this.$$.ctx[0];
  }
  set lang(lang) {
    this.$$set({ lang });
    flush();
  }
  get browser() {
    return this.$$.ctx[1];
  }
  set browser(browser) {
    this.$$set({ browser });
    flush();
  }
  get report() {
    return this.$$.ctx[2];
  }
  set report(report) {
    this.$$set({ report });
    flush();
  }
  get theme() {
    return this.$$.ctx[3];
  }
  set theme(theme) {
    this.$$set({ theme });
    flush();
  }
}
create_custom_element(Risk, { "lang": {}, "browser": {}, "report": {}, "theme": {} }, [], [], true);
function create_fragment$4(ctx) {
  let div14;
  let div13;
  let div1;
  let h30;
  let t0_value = (
    /*i*/
    ctx[10]("metrics.winrate.returnDistribution") + ""
  );
  let t0;
  let t1;
  let span0;
  let t2_value = (
    /*i*/
    ctx[10]("metrics.winrate.distributionInfo1") + ""
  );
  let t2;
  let t3;
  let t4_value = (
    /*varTrades*/
    (ctx[11] * 100).toFixed(1) + ""
  );
  let t4;
  let t5;
  let t6_value = (
    /*i*/
    ctx[10]("metrics.winrate.distributionInfo2") + ""
  );
  let t6;
  let t7;
  let canvas0;
  let t8;
  let div0;
  let t9_value = (
    /*i*/
    ctx[10]("metrics.winrate.return") + ""
  );
  let t9;
  let t10;
  let div5;
  let h31;
  let t11_value = (
    /*i*/
    ctx[10]("metrics.winrate.simulatedStopLoss") + ""
  );
  let t11;
  let t12;
  let span2;
  let t13_value = (
    /*i*/
    ctx[10]("metrics.winrate.stoploss") + ""
  );
  let t13;
  let t14;
  let span1;
  let t15_value = (
    /*sl*/
    (ctx[0] !== 0 ? (
      /*sl*/
      ctx[0] * 100 + "%"
    ) : (
      /*i*/
      ctx[10]("metrics.winrate.none")
    )) + ""
  );
  let t15;
  let t16;
  let br0;
  let t17;
  let span4;
  let t18_value = (
    /*i*/
    ctx[10]("metrics.winrate.extraProfitLoss") + ""
  );
  let t18;
  let t19;
  let span3;
  let t20_value = (
    /*expectStopLossExtraProfit*/
    (ctx[9] > 0 ? "+" : "") + /*expectStopLossExtraProfit*/
    (ctx[9] * 100).toFixed(1)
  );
  let t20;
  let t21;
  let t22;
  let br1;
  let t23;
  let span6;
  let t24_value = (
    /*i*/
    ctx[10]("metrics.winrate.stoplossRatio") + ""
  );
  let t24;
  let t25;
  let span5;
  let t26_value = (
    /*slRatio*/
    (ctx[8] * 100).toFixed(1) + ""
  );
  let t26;
  let t27;
  let t28;
  let input0;
  let t29;
  let div2;
  let t43;
  let h32;
  let t44_value = (
    /*i*/
    ctx[10]("metrics.winrate.maeReturn") + ""
  );
  let t44;
  let t45;
  let div3;
  let t46_value = (
    /*i*/
    ctx[10]("metrics.winrate.return") + ""
  );
  let t46;
  let t47;
  let canvas1;
  let t48;
  let div4;
  let t49_value = (
    /*i*/
    ctx[10]("metrics.winrate.mae") + ""
  );
  let t49;
  let t50;
  let div9;
  let h33;
  let t51_value = (
    /*i*/
    ctx[10]("metrics.winrate.simulatedTakeProfit") + ""
  );
  let t51;
  let t52;
  let span15;
  let t53_value = (
    /*i*/
    ctx[10]("metrics.winrate.takeProfit") + ""
  );
  let t53;
  let span14;
  let t54_value = (
    /*tp*/
    (ctx[1] !== 0 ? (
      /*tp*/
      ctx[1] * 100 + "%"
    ) : (
      /*i*/
      ctx[10]("metrics.winrate.none")
    )) + ""
  );
  let t54;
  let t55;
  let br2;
  let t56;
  let span17;
  let t57_value = (
    /*i*/
    ctx[10]("metrics.winrate.extraProfitLossTakingProfit") + ""
  );
  let t57;
  let t58;
  let span16;
  let t59_value = (
    /*expectTakeProfitExtraProfit*/
    (ctx[7] > 0 ? "+" : "") + /*expectTakeProfitExtraProfit*/
    (ctx[7] * 100).toFixed(1)
  );
  let t59;
  let t60;
  let t61;
  let t62;
  let br3;
  let t63;
  let span19;
  let t64_value = (
    /*i*/
    ctx[10]("metrics.winrate.takeProfitRatio") + ""
  );
  let t64;
  let span18;
  let t65_value = (
    /*tpRatio*/
    (ctx[6] * 100).toFixed(1) + ""
  );
  let t65;
  let t66;
  let t67;
  let input1;
  let t68;
  let div6;
  let t82;
  let h34;
  let t83_value = (
    /*i*/
    ctx[10]("metrics.winrate.mfeReturn") + ""
  );
  let t83;
  let t84;
  let div7;
  let t85_value = (
    /*i*/
    ctx[10]("metrics.winrate.return") + ""
  );
  let t85;
  let t86;
  let canvas2;
  let t87;
  let div8;
  let t88_value = (
    /*i*/
    ctx[10]("metrics.winrate.mae") + ""
  );
  let t88;
  let t89;
  let div12;
  let h35;
  let t90_value = (
    /*i*/
    ctx[10]("metrics.winrate.maemfe") + ""
  );
  let t90;
  let t91;
  let div10;
  let t92_value = (
    /*i*/
    ctx[10]("metrics.winrate.mfe") + ""
  );
  let t92;
  let t93;
  let canvas3;
  let t94;
  let div11;
  let t95_value = (
    /*i*/
    ctx[10]("metrics.winrate.mae") + ""
  );
  let t95;
  let mounted;
  let dispose;
  return {
    c() {
      div14 = element("div");
      div13 = element("div");
      div1 = element("div");
      h30 = element("h3");
      t0 = text(t0_value);
      t1 = space();
      span0 = element("span");
      t2 = text(t2_value);
      t3 = space();
      t4 = text(t4_value);
      t5 = space();
      t6 = text(t6_value);
      t7 = space();
      canvas0 = element("canvas");
      t8 = space();
      div0 = element("div");
      t9 = text(t9_value);
      t10 = space();
      div5 = element("div");
      h31 = element("h3");
      t11 = text(t11_value);
      t12 = space();
      span2 = element("span");
      t13 = text(t13_value);
      t14 = space();
      span1 = element("span");
      t15 = text(t15_value);
      t16 = space();
      br0 = element("br");
      t17 = space();
      span4 = element("span");
      t18 = text(t18_value);
      t19 = space();
      span3 = element("span");
      t20 = text(t20_value);
      t21 = text("\n				%");
      t22 = space();
      br1 = element("br");
      t23 = space();
      span6 = element("span");
      t24 = text(t24_value);
      t25 = space();
      span5 = element("span");
      t26 = text(t26_value);
      t27 = text("%");
      t28 = space();
      input0 = element("input");
      t29 = space();
      div2 = element("div");
      div2.innerHTML = `<span class="font-bold text-sm">0％</span> <span class="font-bold text-sm">5％</span> <span class="font-bold text-sm">10％</span> <span class="font-bold text-sm">15％</span> <span class="font-bold text-sm">20％</span> <span class="font-bold text-sm">25％</span> <span class="font-bold text-sm">30％</span>`;
      t43 = space();
      h32 = element("h3");
      t44 = text(t44_value);
      t45 = space();
      div3 = element("div");
      t46 = text(t46_value);
      t47 = space();
      canvas1 = element("canvas");
      t48 = space();
      div4 = element("div");
      t49 = text(t49_value);
      t50 = space();
      div9 = element("div");
      h33 = element("h3");
      t51 = text(t51_value);
      t52 = space();
      span15 = element("span");
      t53 = text(t53_value);
      span14 = element("span");
      t54 = text(t54_value);
      t55 = space();
      br2 = element("br");
      t56 = space();
      span17 = element("span");
      t57 = text(t57_value);
      t58 = space();
      span16 = element("span");
      t59 = text(t59_value);
      t60 = space();
      t61 = text("%");
      t62 = space();
      br3 = element("br");
      t63 = space();
      span19 = element("span");
      t64 = text(t64_value);
      span18 = element("span");
      t65 = text(t65_value);
      t66 = text("%");
      t67 = space();
      input1 = element("input");
      t68 = space();
      div6 = element("div");
      div6.innerHTML = `<span class="font-bold text-sm">0％</span> <span class="font-bold text-sm">5％</span> <span class="font-bold text-sm">10％</span> <span class="font-bold text-sm">15％</span> <span class="font-bold text-sm">20％</span> <span class="font-bold text-sm">25％</span> <span class="font-bold text-sm">30％</span>`;
      t82 = space();
      h34 = element("h3");
      t83 = text(t83_value);
      t84 = space();
      div7 = element("div");
      t85 = text(t85_value);
      t86 = space();
      canvas2 = element("canvas");
      t87 = space();
      div8 = element("div");
      t88 = text(t88_value);
      t89 = space();
      div12 = element("div");
      h35 = element("h3");
      t90 = text(t90_value);
      t91 = space();
      div10 = element("div");
      t92 = text(t92_value);
      t93 = space();
      canvas3 = element("canvas");
      t94 = space();
      div11 = element("div");
      t95 = text(t95_value);
      attr(h30, "class", "text-2xl font-bold mb-4 text-base-content-200");
      attr(canvas0, "class", "mt-2 max-h-[400px]");
      attr(div0, "class", "text-sm text-center pb-4 mt-2");
      attr(div1, "class", "col-span-6 text-center p-2 md:p-8 pt-8 md:border rounded-xl");
      attr(h31, "class", "text-2xl font-bold mb-4 text-center text-base-content-200");
      attr(span1, "class", "font-bold");
      attr(span3, "class", "font-bold");
      attr(span5, "class", "font-bold");
      attr(input0, "type", "range");
      attr(input0, "min", "0");
      attr(input0, "max", "0.3");
      attr(input0, "class", "range range-secondary mt-4");
      attr(input0, "step", "0.05");
      attr(div2, "class", "w-full flex justify-between text-xs px-2");
      attr(h32, "class", "text-2xl font-bold mt-6 mb-3 text-center text-base-content-200");
      attr(div3, "class", "text-base-content-100 text-sm font-bold mt-2");
      attr(canvas1, "class", "mt-2");
      attr(div4, "class", "text-base-content-100 text-sm text-center font-bold");
      attr(div5, "class", "col-span-6 md:col-span-3 p-2 md:p-8 pt-8 md:border rounded-xl");
      attr(h33, "class", "text-2xl font-bold mb-4 text-center text-base-content-200");
      attr(span14, "class", "font-bold");
      attr(span16, "class", "font-bold");
      attr(span18, "class", "font-bold");
      attr(input1, "type", "range");
      attr(input1, "min", "0");
      attr(input1, "max", "0.3");
      attr(input1, "class", "range range-primary mt-4");
      attr(input1, "step", "0.05");
      attr(div6, "class", "w-full flex justify-between text-xs px-2");
      attr(h34, "class", "text-2xl font-bold mt-6 mb-3 text-center text-base-content-200");
      attr(div7, "class", "text-base-content-100 text-sm font-bold mt-2");
      attr(canvas2, "class", "mt-2");
      attr(div8, "class", "text-base-content-100 text-sm text-center font-bold");
      attr(div9, "class", "col-span-6 md:col-span-3 p-2 md:p-8 pt-8 md:border rounded-xl");
      attr(h35, "class", "text-2xl font-bold text-center text-base-content-200");
      attr(div10, "class", "text-base-content-100 text-sm font-bold mt-4");
      attr(canvas3, "class", "mt-2");
      attr(div11, "class", "text-base-content-100 text-sm text-center font-bold");
      attr(div12, "class", "col-span-6 p-2 md:p-8 pt-8 md:border rounded-xl");
      attr(div13, "class", "grid grid-cols-6 gap-4");
      attr(div14, "class", "text-base-content-200");
    },
    m(target, anchor) {
      insert(target, div14, anchor);
      append(div14, div13);
      append(div13, div1);
      append(div1, h30);
      append(h30, t0);
      append(div1, t1);
      append(div1, span0);
      append(span0, t2);
      append(span0, t3);
      append(span0, t4);
      append(span0, t5);
      append(span0, t6);
      append(div1, t7);
      append(div1, canvas0);
      ctx[19](canvas0);
      append(div1, t8);
      append(div1, div0);
      append(div0, t9);
      append(div13, t10);
      append(div13, div5);
      append(div5, h31);
      append(h31, t11);
      append(div5, t12);
      append(div5, span2);
      append(span2, t13);
      append(span2, t14);
      append(span2, span1);
      append(span1, t15);
      append(div5, t16);
      append(div5, br0);
      append(div5, t17);
      append(div5, span4);
      append(span4, t18);
      append(span4, t19);
      append(span4, span3);
      append(span3, t20);
      append(span4, t21);
      append(div5, t22);
      append(div5, br1);
      append(div5, t23);
      append(div5, span6);
      append(span6, t24);
      append(span6, t25);
      append(span6, span5);
      append(span5, t26);
      append(span5, t27);
      append(div5, t28);
      append(div5, input0);
      set_input_value(
        input0,
        /*sl*/
        ctx[0]
      );
      append(div5, t29);
      append(div5, div2);
      append(div5, t43);
      append(div5, h32);
      append(h32, t44);
      append(div5, t45);
      append(div5, div3);
      append(div3, t46);
      append(div5, t47);
      append(div5, canvas1);
      ctx[21](canvas1);
      append(div5, t48);
      append(div5, div4);
      append(div4, t49);
      append(div13, t50);
      append(div13, div9);
      append(div9, h33);
      append(h33, t51);
      append(div9, t52);
      append(div9, span15);
      append(span15, t53);
      append(span15, span14);
      append(span14, t54);
      append(div9, t55);
      append(div9, br2);
      append(div9, t56);
      append(div9, span17);
      append(span17, t57);
      append(span17, t58);
      append(span17, span16);
      append(span16, t59);
      append(span16, t60);
      append(span17, t61);
      append(div9, t62);
      append(div9, br3);
      append(div9, t63);
      append(div9, span19);
      append(span19, t64);
      append(span19, span18);
      append(span18, t65);
      append(span18, t66);
      append(div9, t67);
      append(div9, input1);
      set_input_value(
        input1,
        /*tp*/
        ctx[1]
      );
      append(div9, t68);
      append(div9, div6);
      append(div9, t82);
      append(div9, h34);
      append(h34, t83);
      append(div9, t84);
      append(div9, div7);
      append(div7, t85);
      append(div9, t86);
      append(div9, canvas2);
      ctx[23](canvas2);
      append(div9, t87);
      append(div9, div8);
      append(div8, t88);
      append(div13, t89);
      append(div13, div12);
      append(div12, h35);
      append(h35, t90);
      append(div12, t91);
      append(div12, div10);
      append(div10, t92);
      append(div12, t93);
      append(div12, canvas3);
      ctx[24](canvas3);
      append(div12, t94);
      append(div12, div11);
      append(div11, t95);
      if (!mounted) {
        dispose = [
          listen(
            input0,
            "change",
            /*input0_change_input_handler*/
            ctx[20]
          ),
          listen(
            input0,
            "input",
            /*input0_change_input_handler*/
            ctx[20]
          ),
          listen(
            input1,
            "change",
            /*input1_change_input_handler*/
            ctx[22]
          ),
          listen(
            input1,
            "input",
            /*input1_change_input_handler*/
            ctx[22]
          )
        ];
        mounted = true;
      }
    },
    p(ctx2, dirty) {
      if (dirty[0] & /*i*/
      1024 && t0_value !== (t0_value = /*i*/
      ctx2[10]("metrics.winrate.returnDistribution") + ""))
        set_data(t0, t0_value);
      if (dirty[0] & /*i*/
      1024 && t2_value !== (t2_value = /*i*/
      ctx2[10]("metrics.winrate.distributionInfo1") + ""))
        set_data(t2, t2_value);
      if (dirty[0] & /*i*/
      1024 && t6_value !== (t6_value = /*i*/
      ctx2[10]("metrics.winrate.distributionInfo2") + ""))
        set_data(t6, t6_value);
      if (dirty[0] & /*i*/
      1024 && t9_value !== (t9_value = /*i*/
      ctx2[10]("metrics.winrate.return") + ""))
        set_data(t9, t9_value);
      if (dirty[0] & /*i*/
      1024 && t11_value !== (t11_value = /*i*/
      ctx2[10]("metrics.winrate.simulatedStopLoss") + ""))
        set_data(t11, t11_value);
      if (dirty[0] & /*i*/
      1024 && t13_value !== (t13_value = /*i*/
      ctx2[10]("metrics.winrate.stoploss") + ""))
        set_data(t13, t13_value);
      if (dirty[0] & /*sl, i*/
      1025 && t15_value !== (t15_value = /*sl*/
      (ctx2[0] !== 0 ? (
        /*sl*/
        ctx2[0] * 100 + "%"
      ) : (
        /*i*/
        ctx2[10]("metrics.winrate.none")
      )) + ""))
        set_data(t15, t15_value);
      if (dirty[0] & /*i*/
      1024 && t18_value !== (t18_value = /*i*/
      ctx2[10]("metrics.winrate.extraProfitLoss") + ""))
        set_data(t18, t18_value);
      if (dirty[0] & /*expectStopLossExtraProfit*/
      512 && t20_value !== (t20_value = /*expectStopLossExtraProfit*/
      (ctx2[9] > 0 ? "+" : "") + /*expectStopLossExtraProfit*/
      (ctx2[9] * 100).toFixed(1)))
        set_data(t20, t20_value);
      if (dirty[0] & /*i*/
      1024 && t24_value !== (t24_value = /*i*/
      ctx2[10]("metrics.winrate.stoplossRatio") + ""))
        set_data(t24, t24_value);
      if (dirty[0] & /*slRatio*/
      256 && t26_value !== (t26_value = /*slRatio*/
      (ctx2[8] * 100).toFixed(1) + ""))
        set_data(t26, t26_value);
      if (dirty[0] & /*sl*/
      1) {
        set_input_value(
          input0,
          /*sl*/
          ctx2[0]
        );
      }
      if (dirty[0] & /*i*/
      1024 && t44_value !== (t44_value = /*i*/
      ctx2[10]("metrics.winrate.maeReturn") + ""))
        set_data(t44, t44_value);
      if (dirty[0] & /*i*/
      1024 && t46_value !== (t46_value = /*i*/
      ctx2[10]("metrics.winrate.return") + ""))
        set_data(t46, t46_value);
      if (dirty[0] & /*i*/
      1024 && t49_value !== (t49_value = /*i*/
      ctx2[10]("metrics.winrate.mae") + ""))
        set_data(t49, t49_value);
      if (dirty[0] & /*i*/
      1024 && t51_value !== (t51_value = /*i*/
      ctx2[10]("metrics.winrate.simulatedTakeProfit") + ""))
        set_data(t51, t51_value);
      if (dirty[0] & /*i*/
      1024 && t53_value !== (t53_value = /*i*/
      ctx2[10]("metrics.winrate.takeProfit") + ""))
        set_data(t53, t53_value);
      if (dirty[0] & /*tp, i*/
      1026 && t54_value !== (t54_value = /*tp*/
      (ctx2[1] !== 0 ? (
        /*tp*/
        ctx2[1] * 100 + "%"
      ) : (
        /*i*/
        ctx2[10]("metrics.winrate.none")
      )) + ""))
        set_data(t54, t54_value);
      if (dirty[0] & /*i*/
      1024 && t57_value !== (t57_value = /*i*/
      ctx2[10]("metrics.winrate.extraProfitLossTakingProfit") + ""))
        set_data(t57, t57_value);
      if (dirty[0] & /*expectTakeProfitExtraProfit*/
      128 && t59_value !== (t59_value = /*expectTakeProfitExtraProfit*/
      (ctx2[7] > 0 ? "+" : "") + /*expectTakeProfitExtraProfit*/
      (ctx2[7] * 100).toFixed(1)))
        set_data(t59, t59_value);
      if (dirty[0] & /*i*/
      1024 && t64_value !== (t64_value = /*i*/
      ctx2[10]("metrics.winrate.takeProfitRatio") + ""))
        set_data(t64, t64_value);
      if (dirty[0] & /*tpRatio*/
      64 && t65_value !== (t65_value = /*tpRatio*/
      (ctx2[6] * 100).toFixed(1) + ""))
        set_data(t65, t65_value);
      if (dirty[0] & /*tp*/
      2) {
        set_input_value(
          input1,
          /*tp*/
          ctx2[1]
        );
      }
      if (dirty[0] & /*i*/
      1024 && t83_value !== (t83_value = /*i*/
      ctx2[10]("metrics.winrate.mfeReturn") + ""))
        set_data(t83, t83_value);
      if (dirty[0] & /*i*/
      1024 && t85_value !== (t85_value = /*i*/
      ctx2[10]("metrics.winrate.return") + ""))
        set_data(t85, t85_value);
      if (dirty[0] & /*i*/
      1024 && t88_value !== (t88_value = /*i*/
      ctx2[10]("metrics.winrate.mae") + ""))
        set_data(t88, t88_value);
      if (dirty[0] & /*i*/
      1024 && t90_value !== (t90_value = /*i*/
      ctx2[10]("metrics.winrate.maemfe") + ""))
        set_data(t90, t90_value);
      if (dirty[0] & /*i*/
      1024 && t92_value !== (t92_value = /*i*/
      ctx2[10]("metrics.winrate.mfe") + ""))
        set_data(t92, t92_value);
      if (dirty[0] & /*i*/
      1024 && t95_value !== (t95_value = /*i*/
      ctx2[10]("metrics.winrate.mae") + ""))
        set_data(t95, t95_value);
    },
    i: noop$1,
    o: noop$1,
    d(detaching) {
      if (detaching) {
        detach(div14);
      }
      ctx[19](null);
      ctx[21](null);
      ctx[23](null);
      ctx[24](null);
      mounted = false;
      run_all(dispose);
    }
  };
}
function calculateVaR(prices, confidenceLevel = 0.95) {
  const returns2 = prices;
  if (returns2.length === 0)
    return null;
  returns2.sort((a2, b2) => a2 - b2);
  const index = Math.floor((1 - confidenceLevel) * returns2.length);
  return returns2[index];
}
function instance$4($$self, $$props, $$invalidate) {
  let i;
  let stoppLossSelected;
  let expectStopLossExtraProfit;
  let slRatio;
  let takeProfitSelected;
  let expectTakeProfitExtraProfit;
  let tpRatio;
  let { lang = "en" } = $$props;
  Chart.register(BubbleController, LinearScale, PointElement, plugin_tooltip, CategoryScale, BarController, BarElement, LineElement, LineController);
  let { browser } = $$props;
  let { report } = $$props;
  let { theme = "light" } = $$props;
  let sl = 0;
  let tp = 0;
  const returns = report.trades.map((t) => t.return);
  const mean = returns.reduce((acc, val) => acc + val, 0) / returns.length;
  const variance = returns.reduce((acc, val) => acc + Math.pow(val - mean, 2), 0) / returns.length;
  const stdDev = Math.sqrt(variance);
  [...returns].sort((a2, b2) => a2 - b2);
  function createBins(data, binCount) {
    const min = -3 * stdDev;
    const max = 3 * stdDev;
    const range = max - min;
    const binWidth = range / binCount;
    const bins = new Array(binCount).fill(0);
    const binRanges = [];
    data.forEach((d2) => {
      const binIndex = Math.min(Math.floor((d2 - min) / binWidth), binCount - 1);
      bins[binIndex]++;
    });
    for (let i2 = 0; i2 < binCount; i2++) {
      binRanges.push([min + i2 * binWidth, min + (i2 + 1) * binWidth]);
    }
    return { bins, ranges: binRanges };
  }
  let returnHistogramDiv;
  let maeMfeDiv;
  const varTrades = calculateVaR(report.trades.map((trade) => trade.return));
  function drawHistogram(data) {
    const ctx = returnHistogramDiv;
    const labels = data.ranges.map((r2) => r2[0]);
    const backgroundColors = labels.map((label) => label >= 0 ? theme === "light" ? "#725bf5" : "#7a64f5" : "rgba(241, 99, 102, 1)");
    new Chart(
      ctx,
      {
        type: "bar",
        data: {
          labels,
          datasets: [
            {
              data: data.bins,
              backgroundColor: backgroundColors
            }
          ]
          // Dynamic colors
        },
        options: {
          responsive: true,
          maintainAspectRatio: true,
          scales: {
            x: {
              type: "category",
              ticks: {
                callback(value, index, values) {
                  return (labels[index] * 100).toFixed(1) + "%";
                },
                color: theme === "light" ? "#000000aa" : "#FFFFFFaa"
              },
              grid: {
                color: "#77777755",
                // This will set the x-axis grid color to a light red.
                tickBorderDash: [2, 2]
              }
            },
            y: {
              type: "linear",
              ticks: {
                // Callback to format the axis label
                callback(value, index, values) {
                  return value + " trades";
                },
                color: theme === "light" ? "#000000aa" : "#FFFFFFaa"
              },
              grid: {
                color: "#77777755",
                // This will set the x-axis grid color to a light red.
                tickBorderDash: [2, 2]
              }
            }
          }
        }
      }
    );
  }
  const winningTrades = report.trades.filter((trade) => trade.return > 0);
  const losingTrades = report.trades.filter((trade) => trade.return <= 0);
  function drawScatterPlot(div, xName, yName, valueName) {
    const maxX = Math.max(...report.trades.map((trade) => Math.abs(trade[xName])));
    const maxY = Math.max(...report.trades.map((trade) => Math.abs(trade[yName])));
    const logReturns = report.trades.map((trade) => Math.log(Math.abs(trade.return) + 1));
    const maxLogReturn = Math.max(...logReturns);
    const minLogReturn = Math.min(...logReturns);
    function normalize(value, min, max, rangeStart, rangeEnd) {
      return (value - min) / (max - min) * (rangeEnd - rangeStart) + rangeStart;
    }
    function simulatedReturn(value, xValue) {
      const sl_ = sl !== 0 ? sl : 1;
      if (xName === "mae") {
        if (xValue < -sl_) {
          return -sl_;
        } else {
          return value;
        }
      } else if (xName === "gmfe") {
        if (xValue > tp && tp !== 0) {
          return tp;
        } else {
          return value;
        }
      }
      return value;
    }
    const seriesWinning = winningTrades.map((trade) => ({
      x: Math.abs(trade[xName]),
      y: Math.abs(simulatedReturn(trade[yName], trade[xName])),
      r: normalize(Math.log(Math.abs(trade.return) + 1), minLogReturn, maxLogReturn, 3, 20),
      t: trade
    }));
    const seriesLosing = losingTrades.map((trade) => ({
      x: Math.abs(trade[xName]),
      y: Math.abs(simulatedReturn(trade[yName], trade[xName])),
      r: normalize(Math.log(Math.abs(trade.return) + 1), minLogReturn, maxLogReturn, 3, 20),
      t: trade
    }));
    let min45Line = 0;
    let max45Line = 0.5;
    const line45Data = [{ x: min45Line, y: min45Line }, { x: max45Line, y: max45Line }];
    const config = {
      type: "bubble",
      data: {
        datasets: [
          {
            label: "Winning",
            data: seriesWinning,
            backgroundColor: "rgba(99, 102, 241, 0.5)"
          },
          {
            label: "Losing",
            data: seriesLosing,
            backgroundColor: "rgba(241, 99, 102, 0.5)"
          },
          {
            label: "45-degree Line",
            data: line45Data,
            type: "line",
            // set the type of this dataset to line
            fill: false,
            borderColor: "rgba(125, 125, 125, 0.8)",
            pointRadius: 0,
            borderWidth: 1,
            tension: 0
          }
        ]
        // straight line
      },
      options: {
        responsive: true,
        maintainAspectRatio: true,
        animation: false,
        scales: {
          x: {
            type: "linear",
            beginAtZero: true,
            max: Math.min(0.5, maxX, maxY),
            ticks: {
              // Callback to format the axis label
              color: theme === "light" ? "#000000aa" : "#FFFFFFaa",
              callback(value, index, values) {
                return (100 * value).toFixed(1) + "%";
              }
            },
            grid: {
              color: "#77777755",
              // This will set the x-axis grid color to a light red.
              tickBorderDash: [2, 2]
            }
          },
          y: {
            type: "linear",
            beginAtZero: true,
            max: Math.min(0.5, maxY, maxX),
            ticks: {
              // Callback to format the axis label
              color: theme === "light" ? "#000000aa" : "#FFFFFFaa",
              callback(value, index, values) {
                return (100 * value).toFixed(1) + "%";
              }
            },
            grid: {
              color: "#77777755",
              // This will set the x-axis grid color to a light red.
              tickBorderDash: [2, 2]
            }
          }
        },
        plugins: {
          zoom: {
            pan: { enabled: true, mode: "xy" },
            zoom: {
              wheel: { enabled: true },
              pinch: { enabled: true },
              mode: "xy"
            }
          },
          tooltip: {
            callbacks: {
              // Custom formatting for tooltips
              title(context) {
                return context[0].raw.t.stockId + " " + context[0].dataset.label;
              },
              label(context) {
                const xValue = context.raw.x.toFixed(2);
                const yValue = context.raw.y.toFixed(2);
                context.raw.t.stock;
                return `${xName}: ${xValue}, ${yName}:${yValue}`;
              }
            }
          }
        }
      }
    };
    return new Chart(div, config);
  }
  let returnMaeDiv;
  let returnMfeDiv;
  const chart = {};
  onMount(() => {
    if (!browser)
      return;
    const histogramData = createBins(returns, 50);
    drawHistogram(histogramData);
    $$invalidate(16, chart["maemfe"] = drawScatterPlot(maeMfeDiv, "mae", "gmfe"), chart);
    $$invalidate(16, chart["mae"] = drawScatterPlot(returnMaeDiv, "mae", "return"), chart);
    $$invalidate(16, chart["mfe"] = drawScatterPlot(returnMfeDiv, "gmfe", "return"), chart);
  });
  function canvas0_binding($$value) {
    binding_callbacks[$$value ? "unshift" : "push"](() => {
      returnHistogramDiv = $$value;
      $$invalidate(4, returnHistogramDiv);
    });
  }
  function input0_change_input_handler() {
    sl = to_number(this.value);
    $$invalidate(0, sl);
  }
  function canvas1_binding($$value) {
    binding_callbacks[$$value ? "unshift" : "push"](() => {
      returnMaeDiv = $$value;
      $$invalidate(2, returnMaeDiv);
    });
  }
  function input1_change_input_handler() {
    tp = to_number(this.value);
    $$invalidate(1, tp);
  }
  function canvas2_binding($$value) {
    binding_callbacks[$$value ? "unshift" : "push"](() => {
      returnMfeDiv = $$value;
      $$invalidate(3, returnMfeDiv);
    });
  }
  function canvas3_binding($$value) {
    binding_callbacks[$$value ? "unshift" : "push"](() => {
      maeMfeDiv = $$value;
      $$invalidate(5, maeMfeDiv);
    });
  }
  $$self.$$set = ($$props2) => {
    if ("lang" in $$props2)
      $$invalidate(12, lang = $$props2.lang);
    if ("browser" in $$props2)
      $$invalidate(13, browser = $$props2.browser);
    if ("report" in $$props2)
      $$invalidate(14, report = $$props2.report);
    if ("theme" in $$props2)
      $$invalidate(15, theme = $$props2.theme);
  };
  $$self.$$.update = () => {
    if ($$self.$$.dirty[0] & /*lang*/
    4096) {
      $$invalidate(10, i = (key) => lang === "en" ? ien(key) : itw(key));
    }
    if ($$self.$$.dirty[0] & /*report, sl*/
    16385) {
      $$invalidate(18, stoppLossSelected = report.trades.filter((trade) => trade.mae < -sl).map((trade) => trade.return));
    }
    if ($$self.$$.dirty[0] & /*sl, stoppLossSelected*/
    262145) {
      $$invalidate(9, expectStopLossExtraProfit = sl === 0 ? 0 : stoppLossSelected.reduce((acc, val) => acc + val, 0) / stoppLossSelected.length + sl || 0);
    }
    if ($$self.$$.dirty[0] & /*sl, stoppLossSelected, report*/
    278529) {
      $$invalidate(8, slRatio = sl === 0 ? 0 : stoppLossSelected.length / report.trades.length);
    }
    if ($$self.$$.dirty[0] & /*report, tp*/
    16386) {
      $$invalidate(17, takeProfitSelected = report.trades.filter((trade) => trade.gmfe > tp).map((trade) => trade.return));
    }
    if ($$self.$$.dirty[0] & /*tp, takeProfitSelected*/
    131074) {
      $$invalidate(7, expectTakeProfitExtraProfit = tp === 0 ? 0 : takeProfitSelected.reduce((acc, val) => acc + val, 0) / takeProfitSelected.length - tp || 0);
    }
    if ($$self.$$.dirty[0] & /*tp, takeProfitSelected, report*/
    147458) {
      $$invalidate(6, tpRatio = tp === 0 ? 0 : takeProfitSelected.length / report.trades.length);
    }
    if ($$self.$$.dirty[0] & /*sl, chart, returnMaeDiv*/
    65541) {
      if (sl === 0 || sl) {
        if (chart["mae"]) {
          chart["mae"].destroy();
          delete chart["mae"];
          $$invalidate(16, chart["mae"] = drawScatterPlot(returnMaeDiv, "mae", "return"), chart);
        }
      }
    }
    if ($$self.$$.dirty[0] & /*tp, chart, returnMfeDiv*/
    65546) {
      if (tp === 0 || tp) {
        if (chart["mfe"]) {
          chart["mfe"].destroy();
          delete chart["mfe"];
          $$invalidate(16, chart["mfe"] = drawScatterPlot(returnMfeDiv, "gmfe", "return"), chart);
        }
      }
    }
  };
  return [
    sl,
    tp,
    returnMaeDiv,
    returnMfeDiv,
    returnHistogramDiv,
    maeMfeDiv,
    tpRatio,
    expectTakeProfitExtraProfit,
    slRatio,
    expectStopLossExtraProfit,
    i,
    varTrades,
    lang,
    browser,
    report,
    theme,
    chart,
    takeProfitSelected,
    stoppLossSelected,
    canvas0_binding,
    input0_change_input_handler,
    canvas1_binding,
    input1_change_input_handler,
    canvas2_binding,
    canvas3_binding
  ];
}
class Winrate extends SvelteComponent {
  constructor(options) {
    super();
    init(
      this,
      options,
      instance$4,
      create_fragment$4,
      safe_not_equal,
      {
        lang: 12,
        browser: 13,
        report: 14,
        theme: 15
      },
      null,
      [-1, -1]
    );
  }
  get lang() {
    return this.$$.ctx[12];
  }
  set lang(lang) {
    this.$$set({ lang });
    flush();
  }
  get browser() {
    return this.$$.ctx[13];
  }
  set browser(browser) {
    this.$$set({ browser });
    flush();
  }
  get report() {
    return this.$$.ctx[14];
  }
  set report(report) {
    this.$$set({ report });
    flush();
  }
  get theme() {
    return this.$$.ctx[15];
  }
  set theme(theme) {
    this.$$set({ theme });
    flush();
  }
}
create_custom_element(Winrate, { "lang": {}, "browser": {}, "report": {}, "theme": {} }, [], [], true);
function get_each_context$2(ctx, list, i) {
  const child_ctx = ctx.slice();
  child_ctx[14] = list[i];
  return child_ctx;
}
function get_each_context_1$2(ctx, list, i) {
  const child_ctx = ctx.slice();
  child_ctx[17] = list[i];
  return child_ctx;
}
const get_RSV_slot_changes = (dirty) => ({ row: dirty & /*sortedRows*/
2 });
const get_RSV_slot_context = (ctx) => ({ row: (
  /*row*/
  ctx[14]
) });
const get_currentWeight_slot_changes = (dirty) => ({ row: dirty & /*sortedRows*/
2 });
const get_currentWeight_slot_context = (ctx) => ({ row: (
  /*row*/
  ctx[14]
) });
const get_profit_slot_changes = (dirty) => ({ row: dirty & /*sortedRows*/
2 });
const get_profit_slot_context = (ctx) => ({ row: (
  /*row*/
  ctx[14]
) });
const get_entryDate_slot_changes = (dirty) => ({ row: dirty & /*sortedRows*/
2 });
const get_entryDate_slot_context = (ctx) => ({ row: (
  /*row*/
  ctx[14]
) });
const get_action_slot_changes = (dirty) => ({ row: dirty & /*sortedRows*/
2 });
const get_action_slot_context = (ctx) => ({ row: (
  /*row*/
  ctx[14]
) });
const get_name_slot_changes = (dirty) => ({ row: dirty & /*sortedRows*/
2 });
const get_name_slot_context = (ctx) => ({ row: (
  /*row*/
  ctx[14]
) });
function get_each_context_2$2(ctx, list, i) {
  const child_ctx = ctx.slice();
  child_ctx[17] = list[i];
  return child_ctx;
}
function create_if_block_6$2(ctx) {
  let span;
  let t_value = (
    /*sortAscending*/
    ctx[3] ? "▲" : "▼"
  );
  let t;
  return {
    c() {
      span = element("span");
      t = text(t_value);
      attr(span, "class", "pl-2");
    },
    m(target, anchor) {
      insert(target, span, anchor);
      append(span, t);
    },
    p(ctx2, dirty) {
      if (dirty & /*sortAscending*/
      8 && t_value !== (t_value = /*sortAscending*/
      ctx2[3] ? "▲" : "▼"))
        set_data(t, t_value);
    },
    d(detaching) {
      if (detaching) {
        detach(span);
      }
    }
  };
}
function create_each_block_2$2(key_1, ctx) {
  let th;
  let t0_value = (
    /*column*/
    ctx[17].name + ""
  );
  let t0;
  let t1;
  let t2;
  let th_class_value;
  let mounted;
  let dispose;
  let if_block = (
    /*sortColumn*/
    ctx[2] === /*column*/
    ctx[17].key && create_if_block_6$2(ctx)
  );
  function click_handler() {
    return (
      /*click_handler*/
      ctx[10](
        /*column*/
        ctx[17]
      )
    );
  }
  return {
    key: key_1,
    first: null,
    c() {
      th = element("th");
      t0 = text(t0_value);
      t1 = space();
      if (if_block)
        if_block.c();
      t2 = space();
      set_style(
        th,
        "width",
        /*column*/
        ctx[17].width
      );
      attr(th, "class", th_class_value = "tracking-wider cursor-pointer font-bold whitespace-nowrap " + /*column*/
      (ctx[17].key === "name" ? "pl-0 text-left sticky left-0 bg-base-200" : "text-right") + " " + /*column*/
      (ctx[17].sort ? "" : "") + " " + /*sortColumn*/
      (ctx[2] === /*column*/
      ctx[17].key ? "text-primary" : ""));
      this.first = th;
    },
    m(target, anchor) {
      insert(target, th, anchor);
      append(th, t0);
      append(th, t1);
      if (if_block)
        if_block.m(th, null);
      append(th, t2);
      if (!mounted) {
        dispose = listen(th, "click", click_handler);
        mounted = true;
      }
    },
    p(new_ctx, dirty) {
      ctx = new_ctx;
      if (dirty & /*columns*/
      1 && t0_value !== (t0_value = /*column*/
      ctx[17].name + ""))
        set_data(t0, t0_value);
      if (
        /*sortColumn*/
        ctx[2] === /*column*/
        ctx[17].key
      ) {
        if (if_block) {
          if_block.p(ctx, dirty);
        } else {
          if_block = create_if_block_6$2(ctx);
          if_block.c();
          if_block.m(th, t2);
        }
      } else if (if_block) {
        if_block.d(1);
        if_block = null;
      }
      if (dirty & /*columns*/
      1) {
        set_style(
          th,
          "width",
          /*column*/
          ctx[17].width
        );
      }
      if (dirty & /*columns, sortColumn*/
      5 && th_class_value !== (th_class_value = "tracking-wider cursor-pointer font-bold whitespace-nowrap " + /*column*/
      (ctx[17].key === "name" ? "pl-0 text-left sticky left-0 bg-base-200" : "text-right") + " " + /*column*/
      (ctx[17].sort ? "" : "") + " " + /*sortColumn*/
      (ctx[2] === /*column*/
      ctx[17].key ? "text-primary" : ""))) {
        attr(th, "class", th_class_value);
      }
    },
    d(detaching) {
      if (detaching) {
        detach(th);
      }
      if (if_block)
        if_block.d();
      mounted = false;
      dispose();
    }
  };
}
function create_else_block$2(ctx) {
  let t_value = (
    /*row*/
    (ctx[14][
      /*column*/
      ctx[17].key
    ] ? (
      /*row*/
      ctx[14][
        /*column*/
        ctx[17].key
      ]
    ) : "-") + ""
  );
  let t;
  return {
    c() {
      t = text(t_value);
    },
    m(target, anchor) {
      insert(target, t, anchor);
    },
    p(ctx2, dirty) {
      if (dirty & /*sortedRows, columns*/
      3 && t_value !== (t_value = /*row*/
      (ctx2[14][
        /*column*/
        ctx2[17].key
      ] ? (
        /*row*/
        ctx2[14][
          /*column*/
          ctx2[17].key
        ]
      ) : "-") + ""))
        set_data(t, t_value);
    },
    i: noop$1,
    o: noop$1,
    d(detaching) {
      if (detaching) {
        detach(t);
      }
    }
  };
}
function create_if_block_5$2(ctx) {
  let current;
  const RSV_slot_template = (
    /*#slots*/
    ctx[9].RSV
  );
  const RSV_slot = create_slot(
    RSV_slot_template,
    ctx,
    /*$$scope*/
    ctx[8],
    get_RSV_slot_context
  );
  const RSV_slot_or_fallback = RSV_slot || fallback_block_5(ctx);
  return {
    c() {
      if (RSV_slot_or_fallback)
        RSV_slot_or_fallback.c();
    },
    m(target, anchor) {
      if (RSV_slot_or_fallback) {
        RSV_slot_or_fallback.m(target, anchor);
      }
      current = true;
    },
    p(ctx2, dirty) {
      if (RSV_slot) {
        if (RSV_slot.p && (!current || dirty & /*$$scope, sortedRows*/
        258)) {
          update_slot_base(
            RSV_slot,
            RSV_slot_template,
            ctx2,
            /*$$scope*/
            ctx2[8],
            !current ? get_all_dirty_from_scope(
              /*$$scope*/
              ctx2[8]
            ) : get_slot_changes(
              RSV_slot_template,
              /*$$scope*/
              ctx2[8],
              dirty,
              get_RSV_slot_changes
            ),
            get_RSV_slot_context
          );
        }
      } else {
        if (RSV_slot_or_fallback && RSV_slot_or_fallback.p && (!current || dirty & /*sortedRows*/
        2)) {
          RSV_slot_or_fallback.p(ctx2, !current ? -1 : dirty);
        }
      }
    },
    i(local) {
      if (current)
        return;
      transition_in(RSV_slot_or_fallback, local);
      current = true;
    },
    o(local) {
      transition_out(RSV_slot_or_fallback, local);
      current = false;
    },
    d(detaching) {
      if (RSV_slot_or_fallback)
        RSV_slot_or_fallback.d(detaching);
    }
  };
}
function create_if_block_4$2(ctx) {
  let current;
  const currentWeight_slot_template = (
    /*#slots*/
    ctx[9].currentWeight
  );
  const currentWeight_slot = create_slot(
    currentWeight_slot_template,
    ctx,
    /*$$scope*/
    ctx[8],
    get_currentWeight_slot_context
  );
  const currentWeight_slot_or_fallback = currentWeight_slot || fallback_block_4(ctx);
  return {
    c() {
      if (currentWeight_slot_or_fallback)
        currentWeight_slot_or_fallback.c();
    },
    m(target, anchor) {
      if (currentWeight_slot_or_fallback) {
        currentWeight_slot_or_fallback.m(target, anchor);
      }
      current = true;
    },
    p(ctx2, dirty) {
      if (currentWeight_slot) {
        if (currentWeight_slot.p && (!current || dirty & /*$$scope, sortedRows*/
        258)) {
          update_slot_base(
            currentWeight_slot,
            currentWeight_slot_template,
            ctx2,
            /*$$scope*/
            ctx2[8],
            !current ? get_all_dirty_from_scope(
              /*$$scope*/
              ctx2[8]
            ) : get_slot_changes(
              currentWeight_slot_template,
              /*$$scope*/
              ctx2[8],
              dirty,
              get_currentWeight_slot_changes
            ),
            get_currentWeight_slot_context
          );
        }
      } else {
        if (currentWeight_slot_or_fallback && currentWeight_slot_or_fallback.p && (!current || dirty & /*sortedRows*/
        2)) {
          currentWeight_slot_or_fallback.p(ctx2, !current ? -1 : dirty);
        }
      }
    },
    i(local) {
      if (current)
        return;
      transition_in(currentWeight_slot_or_fallback, local);
      current = true;
    },
    o(local) {
      transition_out(currentWeight_slot_or_fallback, local);
      current = false;
    },
    d(detaching) {
      if (currentWeight_slot_or_fallback)
        currentWeight_slot_or_fallback.d(detaching);
    }
  };
}
function create_if_block_3$2(ctx) {
  let current;
  const profit_slot_template = (
    /*#slots*/
    ctx[9].profit
  );
  const profit_slot = create_slot(
    profit_slot_template,
    ctx,
    /*$$scope*/
    ctx[8],
    get_profit_slot_context
  );
  const profit_slot_or_fallback = profit_slot || fallback_block_3(ctx);
  return {
    c() {
      if (profit_slot_or_fallback)
        profit_slot_or_fallback.c();
    },
    m(target, anchor) {
      if (profit_slot_or_fallback) {
        profit_slot_or_fallback.m(target, anchor);
      }
      current = true;
    },
    p(ctx2, dirty) {
      if (profit_slot) {
        if (profit_slot.p && (!current || dirty & /*$$scope, sortedRows*/
        258)) {
          update_slot_base(
            profit_slot,
            profit_slot_template,
            ctx2,
            /*$$scope*/
            ctx2[8],
            !current ? get_all_dirty_from_scope(
              /*$$scope*/
              ctx2[8]
            ) : get_slot_changes(
              profit_slot_template,
              /*$$scope*/
              ctx2[8],
              dirty,
              get_profit_slot_changes
            ),
            get_profit_slot_context
          );
        }
      } else {
        if (profit_slot_or_fallback && profit_slot_or_fallback.p && (!current || dirty & /*sortedRows*/
        2)) {
          profit_slot_or_fallback.p(ctx2, !current ? -1 : dirty);
        }
      }
    },
    i(local) {
      if (current)
        return;
      transition_in(profit_slot_or_fallback, local);
      current = true;
    },
    o(local) {
      transition_out(profit_slot_or_fallback, local);
      current = false;
    },
    d(detaching) {
      if (profit_slot_or_fallback)
        profit_slot_or_fallback.d(detaching);
    }
  };
}
function create_if_block_2$2(ctx) {
  let current;
  const entryDate_slot_template = (
    /*#slots*/
    ctx[9].entryDate
  );
  const entryDate_slot = create_slot(
    entryDate_slot_template,
    ctx,
    /*$$scope*/
    ctx[8],
    get_entryDate_slot_context
  );
  const entryDate_slot_or_fallback = entryDate_slot || fallback_block_2(ctx);
  return {
    c() {
      if (entryDate_slot_or_fallback)
        entryDate_slot_or_fallback.c();
    },
    m(target, anchor) {
      if (entryDate_slot_or_fallback) {
        entryDate_slot_or_fallback.m(target, anchor);
      }
      current = true;
    },
    p(ctx2, dirty) {
      if (entryDate_slot) {
        if (entryDate_slot.p && (!current || dirty & /*$$scope, sortedRows*/
        258)) {
          update_slot_base(
            entryDate_slot,
            entryDate_slot_template,
            ctx2,
            /*$$scope*/
            ctx2[8],
            !current ? get_all_dirty_from_scope(
              /*$$scope*/
              ctx2[8]
            ) : get_slot_changes(
              entryDate_slot_template,
              /*$$scope*/
              ctx2[8],
              dirty,
              get_entryDate_slot_changes
            ),
            get_entryDate_slot_context
          );
        }
      } else {
        if (entryDate_slot_or_fallback && entryDate_slot_or_fallback.p && (!current || dirty & /*sortedRows*/
        2)) {
          entryDate_slot_or_fallback.p(ctx2, !current ? -1 : dirty);
        }
      }
    },
    i(local) {
      if (current)
        return;
      transition_in(entryDate_slot_or_fallback, local);
      current = true;
    },
    o(local) {
      transition_out(entryDate_slot_or_fallback, local);
      current = false;
    },
    d(detaching) {
      if (entryDate_slot_or_fallback)
        entryDate_slot_or_fallback.d(detaching);
    }
  };
}
function create_if_block_1$2(ctx) {
  let current;
  const action_slot_template = (
    /*#slots*/
    ctx[9].action
  );
  const action_slot = create_slot(
    action_slot_template,
    ctx,
    /*$$scope*/
    ctx[8],
    get_action_slot_context
  );
  const action_slot_or_fallback = action_slot || fallback_block_1(ctx);
  return {
    c() {
      if (action_slot_or_fallback)
        action_slot_or_fallback.c();
    },
    m(target, anchor) {
      if (action_slot_or_fallback) {
        action_slot_or_fallback.m(target, anchor);
      }
      current = true;
    },
    p(ctx2, dirty) {
      if (action_slot) {
        if (action_slot.p && (!current || dirty & /*$$scope, sortedRows*/
        258)) {
          update_slot_base(
            action_slot,
            action_slot_template,
            ctx2,
            /*$$scope*/
            ctx2[8],
            !current ? get_all_dirty_from_scope(
              /*$$scope*/
              ctx2[8]
            ) : get_slot_changes(
              action_slot_template,
              /*$$scope*/
              ctx2[8],
              dirty,
              get_action_slot_changes
            ),
            get_action_slot_context
          );
        }
      } else {
        if (action_slot_or_fallback && action_slot_or_fallback.p && (!current || dirty & /*sortedRows*/
        2)) {
          action_slot_or_fallback.p(ctx2, !current ? -1 : dirty);
        }
      }
    },
    i(local) {
      if (current)
        return;
      transition_in(action_slot_or_fallback, local);
      current = true;
    },
    o(local) {
      transition_out(action_slot_or_fallback, local);
      current = false;
    },
    d(detaching) {
      if (action_slot_or_fallback)
        action_slot_or_fallback.d(detaching);
    }
  };
}
function create_if_block$2(ctx) {
  let current;
  const name_slot_template = (
    /*#slots*/
    ctx[9].name
  );
  const name_slot = create_slot(
    name_slot_template,
    ctx,
    /*$$scope*/
    ctx[8],
    get_name_slot_context
  );
  const name_slot_or_fallback = name_slot || fallback_block(ctx);
  return {
    c() {
      if (name_slot_or_fallback)
        name_slot_or_fallback.c();
    },
    m(target, anchor) {
      if (name_slot_or_fallback) {
        name_slot_or_fallback.m(target, anchor);
      }
      current = true;
    },
    p(ctx2, dirty) {
      if (name_slot) {
        if (name_slot.p && (!current || dirty & /*$$scope, sortedRows*/
        258)) {
          update_slot_base(
            name_slot,
            name_slot_template,
            ctx2,
            /*$$scope*/
            ctx2[8],
            !current ? get_all_dirty_from_scope(
              /*$$scope*/
              ctx2[8]
            ) : get_slot_changes(
              name_slot_template,
              /*$$scope*/
              ctx2[8],
              dirty,
              get_name_slot_changes
            ),
            get_name_slot_context
          );
        }
      } else {
        if (name_slot_or_fallback && name_slot_or_fallback.p && (!current || dirty & /*sortedRows*/
        2)) {
          name_slot_or_fallback.p(ctx2, !current ? -1 : dirty);
        }
      }
    },
    i(local) {
      if (current)
        return;
      transition_in(name_slot_or_fallback, local);
      current = true;
    },
    o(local) {
      transition_out(name_slot_or_fallback, local);
      current = false;
    },
    d(detaching) {
      if (name_slot_or_fallback)
        name_slot_or_fallback.d(detaching);
    }
  };
}
function fallback_block_5(ctx) {
  let t_value = (
    /*row*/
    ctx[14].RSV + ""
  );
  let t;
  return {
    c() {
      t = text(t_value);
    },
    m(target, anchor) {
      insert(target, t, anchor);
    },
    p(ctx2, dirty) {
      if (dirty & /*sortedRows*/
      2 && t_value !== (t_value = /*row*/
      ctx2[14].RSV + ""))
        set_data(t, t_value);
    },
    d(detaching) {
      if (detaching) {
        detach(t);
      }
    }
  };
}
function fallback_block_4(ctx) {
  let t_value = (
    /*row*/
    ctx[14].currentWeight + ""
  );
  let t;
  return {
    c() {
      t = text(t_value);
    },
    m(target, anchor) {
      insert(target, t, anchor);
    },
    p(ctx2, dirty) {
      if (dirty & /*sortedRows*/
      2 && t_value !== (t_value = /*row*/
      ctx2[14].currentWeight + ""))
        set_data(t, t_value);
    },
    d(detaching) {
      if (detaching) {
        detach(t);
      }
    }
  };
}
function fallback_block_3(ctx) {
  let t_value = (
    /*row*/
    ctx[14].profit + ""
  );
  let t;
  return {
    c() {
      t = text(t_value);
    },
    m(target, anchor) {
      insert(target, t, anchor);
    },
    p(ctx2, dirty) {
      if (dirty & /*sortedRows*/
      2 && t_value !== (t_value = /*row*/
      ctx2[14].profit + ""))
        set_data(t, t_value);
    },
    d(detaching) {
      if (detaching) {
        detach(t);
      }
    }
  };
}
function fallback_block_2(ctx) {
  let t_value = (
    /*row*/
    ctx[14].entryDate + ""
  );
  let t;
  return {
    c() {
      t = text(t_value);
    },
    m(target, anchor) {
      insert(target, t, anchor);
    },
    p(ctx2, dirty) {
      if (dirty & /*sortedRows*/
      2 && t_value !== (t_value = /*row*/
      ctx2[14].entryDate + ""))
        set_data(t, t_value);
    },
    d(detaching) {
      if (detaching) {
        detach(t);
      }
    }
  };
}
function fallback_block_1(ctx) {
  let t_value = (
    /*row*/
    ctx[14].action + ""
  );
  let t;
  return {
    c() {
      t = text(t_value);
    },
    m(target, anchor) {
      insert(target, t, anchor);
    },
    p(ctx2, dirty) {
      if (dirty & /*sortedRows*/
      2 && t_value !== (t_value = /*row*/
      ctx2[14].action + ""))
        set_data(t, t_value);
    },
    d(detaching) {
      if (detaching) {
        detach(t);
      }
    }
  };
}
function fallback_block(ctx) {
  let t_value = (
    /*row*/
    ctx[14].name + ""
  );
  let t;
  return {
    c() {
      t = text(t_value);
    },
    m(target, anchor) {
      insert(target, t, anchor);
    },
    p(ctx2, dirty) {
      if (dirty & /*sortedRows*/
      2 && t_value !== (t_value = /*row*/
      ctx2[14].name + ""))
        set_data(t, t_value);
    },
    d(detaching) {
      if (detaching) {
        detach(t);
      }
    }
  };
}
function create_each_block_1$2(key_1, ctx) {
  let td;
  let current_block_type_index;
  let if_block;
  let td_class_value;
  let current;
  const if_block_creators = [
    create_if_block$2,
    create_if_block_1$2,
    create_if_block_2$2,
    create_if_block_3$2,
    create_if_block_4$2,
    create_if_block_5$2,
    create_else_block$2
  ];
  const if_blocks = [];
  function select_block_type(ctx2, dirty) {
    if (
      /*column*/
      ctx2[17].key === "name"
    )
      return 0;
    if (
      /*column*/
      ctx2[17].key === "action"
    )
      return 1;
    if (
      /*column*/
      ctx2[17].key === "entryDate"
    )
      return 2;
    if (
      /*column*/
      ctx2[17].key === "profit"
    )
      return 3;
    if (
      /*column*/
      ctx2[17].key === "currentWeight"
    )
      return 4;
    if (
      /*column*/
      ctx2[17].key === "RSV"
    )
      return 5;
    return 6;
  }
  current_block_type_index = select_block_type(ctx);
  if_block = if_blocks[current_block_type_index] = if_block_creators[current_block_type_index](ctx);
  return {
    key: key_1,
    first: null,
    c() {
      td = element("td");
      if_block.c();
      set_style(
        td,
        "width",
        /*column*/
        ctx[17].width
      );
      attr(td, "class", td_class_value = "whitespace-nowrap " + /*column*/
      (ctx[17].key === "name" ? "pl-0 text-left sticky left-0 z-10 bg-base-200 after:content after:absolute after:inset-0 after:shadow-lx after:rounded" : "text-right"));
      this.first = td;
    },
    m(target, anchor) {
      insert(target, td, anchor);
      if_blocks[current_block_type_index].m(td, null);
      current = true;
    },
    p(new_ctx, dirty) {
      ctx = new_ctx;
      let previous_block_index = current_block_type_index;
      current_block_type_index = select_block_type(ctx);
      if (current_block_type_index === previous_block_index) {
        if_blocks[current_block_type_index].p(ctx, dirty);
      } else {
        group_outros();
        transition_out(if_blocks[previous_block_index], 1, 1, () => {
          if_blocks[previous_block_index] = null;
        });
        check_outros();
        if_block = if_blocks[current_block_type_index];
        if (!if_block) {
          if_block = if_blocks[current_block_type_index] = if_block_creators[current_block_type_index](ctx);
          if_block.c();
        } else {
          if_block.p(ctx, dirty);
        }
        transition_in(if_block, 1);
        if_block.m(td, null);
      }
      if (!current || dirty & /*columns*/
      1) {
        set_style(
          td,
          "width",
          /*column*/
          ctx[17].width
        );
      }
      if (!current || dirty & /*columns*/
      1 && td_class_value !== (td_class_value = "whitespace-nowrap " + /*column*/
      (ctx[17].key === "name" ? "pl-0 text-left sticky left-0 z-10 bg-base-200 after:content after:absolute after:inset-0 after:shadow-lx after:rounded" : "text-right"))) {
        attr(td, "class", td_class_value);
      }
    },
    i(local) {
      if (current)
        return;
      transition_in(if_block);
      current = true;
    },
    o(local) {
      transition_out(if_block);
      current = false;
    },
    d(detaching) {
      if (detaching) {
        detach(td);
      }
      if_blocks[current_block_type_index].d();
    }
  };
}
function create_each_block$2(key_1, ctx) {
  let tr;
  let each_blocks = [];
  let each_1_lookup = /* @__PURE__ */ new Map();
  let t;
  let current;
  let each_value_1 = ensure_array_like(
    /*columns*/
    ctx[0]
  );
  const get_key = (ctx2) => (
    /*column*/
    ctx2[17].name
  );
  for (let i = 0; i < each_value_1.length; i += 1) {
    let child_ctx = get_each_context_1$2(ctx, each_value_1, i);
    let key = get_key(child_ctx);
    each_1_lookup.set(key, each_blocks[i] = create_each_block_1$2(key, child_ctx));
  }
  return {
    key: key_1,
    first: null,
    c() {
      tr = element("tr");
      for (let i = 0; i < each_blocks.length; i += 1) {
        each_blocks[i].c();
      }
      t = space();
      this.first = tr;
    },
    m(target, anchor) {
      insert(target, tr, anchor);
      for (let i = 0; i < each_blocks.length; i += 1) {
        if (each_blocks[i]) {
          each_blocks[i].m(tr, null);
        }
      }
      append(tr, t);
      current = true;
    },
    p(new_ctx, dirty) {
      ctx = new_ctx;
      if (dirty & /*columns, sortedRows, $$scope*/
      259) {
        each_value_1 = ensure_array_like(
          /*columns*/
          ctx[0]
        );
        group_outros();
        each_blocks = update_keyed_each(each_blocks, dirty, get_key, 1, ctx, each_value_1, each_1_lookup, tr, outro_and_destroy_block, create_each_block_1$2, t, get_each_context_1$2);
        check_outros();
      }
    },
    i(local) {
      if (current)
        return;
      for (let i = 0; i < each_value_1.length; i += 1) {
        transition_in(each_blocks[i]);
      }
      current = true;
    },
    o(local) {
      for (let i = 0; i < each_blocks.length; i += 1) {
        transition_out(each_blocks[i]);
      }
      current = false;
    },
    d(detaching) {
      if (detaching) {
        detach(tr);
      }
      for (let i = 0; i < each_blocks.length; i += 1) {
        each_blocks[i].d();
      }
    }
  };
}
function create_fragment$3(ctx) {
  let div3;
  let div1;
  let div0;
  let table0;
  let thead;
  let tr;
  let each_blocks_1 = [];
  let each0_lookup = /* @__PURE__ */ new Map();
  let t;
  let div2;
  let table1;
  let tbody;
  let each_blocks = [];
  let each1_lookup = /* @__PURE__ */ new Map();
  let current;
  let mounted;
  let dispose;
  let each_value_2 = ensure_array_like(
    /*columns*/
    ctx[0]
  );
  const get_key = (ctx2) => (
    /*column*/
    ctx2[17].name
  );
  for (let i = 0; i < each_value_2.length; i += 1) {
    let child_ctx = get_each_context_2$2(ctx, each_value_2, i);
    let key = get_key(child_ctx);
    each0_lookup.set(key, each_blocks_1[i] = create_each_block_2$2(key, child_ctx));
  }
  let each_value = ensure_array_like(
    /*sortedRows*/
    ctx[1]
  );
  const get_key_1 = (ctx2) => (
    /*row*/
    ctx2[14].assetId
  );
  for (let i = 0; i < each_value.length; i += 1) {
    let child_ctx = get_each_context$2(ctx, each_value, i);
    let key = get_key_1(child_ctx);
    each1_lookup.set(key, each_blocks[i] = create_each_block$2(key, child_ctx));
  }
  return {
    c() {
      div3 = element("div");
      div1 = element("div");
      div0 = element("div");
      table0 = element("table");
      thead = element("thead");
      tr = element("tr");
      for (let i = 0; i < each_blocks_1.length; i += 1) {
        each_blocks_1[i].c();
      }
      t = space();
      div2 = element("div");
      table1 = element("table");
      tbody = element("tbody");
      for (let i = 0; i < each_blocks.length; i += 1) {
        each_blocks[i].c();
      }
      attr(thead, "class", "sticky top-12 z-20 bg-base-200 h-8 pb-4");
      attr(table0, "class", "table min-w-full table-fixed");
      attr(div0, "class", "overflow-hidden");
      attr(div1, "class", "sticky top-12 z-20");
      attr(table1, "class", "table table-fixed m-0");
      attr(div2, "class", "overflow-x-auto overflow-y-hidden pb-8");
      attr(div3, "class", "relative w-full -mt-2");
    },
    m(target, anchor) {
      insert(target, div3, anchor);
      append(div3, div1);
      append(div1, div0);
      append(div0, table0);
      append(table0, thead);
      append(thead, tr);
      for (let i = 0; i < each_blocks_1.length; i += 1) {
        if (each_blocks_1[i]) {
          each_blocks_1[i].m(tr, null);
        }
      }
      ctx[11](div0);
      append(div3, t);
      append(div3, div2);
      append(div2, table1);
      append(table1, tbody);
      for (let i = 0; i < each_blocks.length; i += 1) {
        if (each_blocks[i]) {
          each_blocks[i].m(tbody, null);
        }
      }
      ctx[12](div2);
      current = true;
      if (!mounted) {
        dispose = listen(
          div2,
          "scroll",
          /*scroll_handler*/
          ctx[13]
        );
        mounted = true;
      }
    },
    p(ctx2, [dirty]) {
      if (dirty & /*columns, sortColumn, sortTable, sortAscending*/
      77) {
        each_value_2 = ensure_array_like(
          /*columns*/
          ctx2[0]
        );
        each_blocks_1 = update_keyed_each(each_blocks_1, dirty, get_key, 1, ctx2, each_value_2, each0_lookup, tr, destroy_block, create_each_block_2$2, null, get_each_context_2$2);
      }
      if (dirty & /*columns, sortedRows, $$scope*/
      259) {
        each_value = ensure_array_like(
          /*sortedRows*/
          ctx2[1]
        );
        group_outros();
        each_blocks = update_keyed_each(each_blocks, dirty, get_key_1, 1, ctx2, each_value, each1_lookup, tbody, outro_and_destroy_block, create_each_block$2, null, get_each_context$2);
        check_outros();
      }
    },
    i(local) {
      if (current)
        return;
      for (let i = 0; i < each_value.length; i += 1) {
        transition_in(each_blocks[i]);
      }
      current = true;
    },
    o(local) {
      for (let i = 0; i < each_blocks.length; i += 1) {
        transition_out(each_blocks[i]);
      }
      current = false;
    },
    d(detaching) {
      if (detaching) {
        detach(div3);
      }
      for (let i = 0; i < each_blocks_1.length; i += 1) {
        each_blocks_1[i].d();
      }
      ctx[11](null);
      for (let i = 0; i < each_blocks.length; i += 1) {
        each_blocks[i].d();
      }
      ctx[12](null);
      mounted = false;
      dispose();
    }
  };
}
function syncScroll(source, target) {
  target.scrollLeft = source.scrollLeft;
}
function instance$3($$self, $$props, $$invalidate) {
  let { $$slots: slots = {}, $$scope } = $$props;
  let { rows = [] } = $$props;
  let { columns = [] } = $$props;
  let sortedRows = [];
  let sortColumn;
  let sortAscending;
  function sortTable(column) {
    if (!column.sort)
      return;
    const key = column.key;
    if (sortColumn === key) {
      $$invalidate(3, sortAscending = !sortAscending);
    } else {
      $$invalidate(2, sortColumn = key);
      $$invalidate(3, sortAscending = true);
    }
    $$invalidate(1, sortedRows = [...rows].sort((a2, b2) => {
      const valueA = a2[key];
      const valueB = b2[key];
      if (valueA === valueB)
        return 0;
      const result = valueA < valueB ? -1 : 1;
      return sortAscending ? result : -result;
    }));
  }
  let tableHeader;
  let tableBody;
  const click_handler = (column) => sortTable(column);
  function div0_binding($$value) {
    binding_callbacks[$$value ? "unshift" : "push"](() => {
      tableHeader = $$value;
      $$invalidate(4, tableHeader);
    });
  }
  function div2_binding($$value) {
    binding_callbacks[$$value ? "unshift" : "push"](() => {
      tableBody = $$value;
      $$invalidate(5, tableBody);
    });
  }
  const scroll_handler = () => syncScroll(tableBody, tableHeader);
  $$self.$$set = ($$props2) => {
    if ("rows" in $$props2)
      $$invalidate(7, rows = $$props2.rows);
    if ("columns" in $$props2)
      $$invalidate(0, columns = $$props2.columns);
    if ("$$scope" in $$props2)
      $$invalidate(8, $$scope = $$props2.$$scope);
  };
  $$self.$$.update = () => {
    if ($$self.$$.dirty & /*rows*/
    128) {
      {
        $$invalidate(1, sortedRows = rows);
        $$invalidate(2, sortColumn = null);
        $$invalidate(3, sortAscending = true);
      }
    }
  };
  return [
    columns,
    sortedRows,
    sortColumn,
    sortAscending,
    tableHeader,
    tableBody,
    sortTable,
    rows,
    $$scope,
    slots,
    click_handler,
    div0_binding,
    div2_binding,
    scroll_handler
  ];
}
class PositionDataTable extends SvelteComponent {
  constructor(options) {
    super();
    init(this, options, instance$3, create_fragment$3, safe_not_equal, { rows: 7, columns: 0 });
  }
  get rows() {
    return this.$$.ctx[7];
  }
  set rows(rows) {
    this.$$set({ rows });
    flush();
  }
  get columns() {
    return this.$$.ctx[0];
  }
  set columns(columns) {
    this.$$set({ columns });
    flush();
  }
}
create_custom_element(PositionDataTable, { "rows": {}, "columns": {} }, ["name", "action", "entryDate", "profit", "currentWeight", "RSV"], [], true);
function hslToRgb(h3, s, l2) {
  let r2, g2, b2;
  if (s === 0) {
    r2 = g2 = b2 = l2;
  } else {
    const hue2rgb = (p22, q22, t) => {
      if (t < 0)
        t += 1;
      if (t > 1)
        t -= 1;
      if (t < 1 / 6)
        return p22 + (q22 - p22) * 6 * t;
      if (t < 1 / 2)
        return q22;
      if (t < 2 / 3)
        return p22 + (q22 - p22) * (2 / 3 - t) * 6;
      return p22;
    };
    let q2 = l2 < 0.5 ? l2 * (1 + s) : l2 + s - l2 * s;
    let p2 = 2 * l2 - q2;
    r2 = hue2rgb(p2, q2, h3 + 1 / 3);
    g2 = hue2rgb(p2, q2, h3);
    b2 = hue2rgb(p2, q2, h3 - 1 / 3);
  }
  return [Math.round(r2 * 255), Math.round(g2 * 255), Math.round(b2 * 255)];
}
function rgbToHex(r2, g2, b2) {
  const toHex = (c2) => {
    const hex2 = c2.toString(16);
    return hex2.length === 1 ? "0" + hex2 : hex2;
  };
  return `#${toHex(r2)}${toHex(g2)}${toHex(b2)}`;
}
function chineseToHue(char) {
  const codePoint = char.codePointAt(0);
  if (codePoint === void 0) {
    throw new Error("Invalid character");
  }
  return codePoint % 360;
}
function charToHex(char) {
  const hue2 = chineseToHue(char);
  const rgb = hslToRgb(hue2 / 360, 0.5, 0.5);
  const ret = rgbToHex(...rgb);
  return ret + "77";
}
function isValidPosition(obj) {
  if (typeof obj !== "object" || obj === null) {
    console.log("Invalid: obj is not an object or is null");
    return false;
  }
  const stringProps = ["assetName", "assetId"];
  const dateProps = ["entryDate", "exitDate"];
  const numberProps = [
    "entryPrice",
    "exitPrice",
    "currentPrice",
    "profit",
    "currentWeight",
    "nextWeight",
    "rsv20"
  ];
  for (const prop of stringProps) {
    if (typeof obj[prop] !== "string") {
      console.log(`Invalid: ${prop} is not a string`);
      return false;
    }
  }
  for (const prop of dateProps) {
    if (!(obj[prop] instanceof Date)) {
      console.log(`Invalid: ${prop} is not a Date`);
      return false;
    }
  }
  for (const prop of numberProps) {
    if (typeof obj[prop] !== "number") {
      console.log(`Invalid: ${prop} is not a number`);
      return false;
    }
  }
  if (obj.action !== null) {
    if (typeof obj.action !== "object" || obj.action === null) {
      console.log("Invalid: action is not an object or is null");
      return false;
    }
    const actionKeys = ["type", "reason", "date", "profit"];
    for (const key of actionKeys) {
      if (!(key in obj.action)) {
        console.log(`Invalid: ${key} is missing in action`);
        return false;
      }
    }
    if (!["entry", "exit", "hold", "entry_f", "exit_p"].includes(obj.action.type)) {
      console.log(`Invalid: action.type is not one of 'entry', 'exit', 'hold'`);
      return false;
    }
    if (!["sl", "tp", "sl_", "tp_", "_", "entry", "exit"].includes(obj.action.reason)) {
      console.log(`Invalid: action.reason is not one of 'sl', 'tp', 'sl_', 'tp_', '_'`);
      return false;
    }
    if (!(obj.action.date instanceof Date)) {
      console.log(`Invalid: action.date is not a Date`);
      return false;
    }
    if (typeof obj.action.profit !== "number") {
      console.log(`Invalid: action.profit is not a number`);
      return false;
    }
  }
  return true;
}
function add_css(target) {
  append_styles(target, "svelte-1nx0ef2", ".lining-nums.svelte-1nx0ef2{font-weight:600;font-size:18px;line-height:32px}");
}
function get_each_context$1(ctx, list, i) {
  const child_ctx = ctx.slice();
  child_ctx[16] = list[i];
  return child_ctx;
}
function get_each_context_1$1(ctx, list, i) {
  const child_ctx = ctx.slice();
  child_ctx[16] = list[i];
  return child_ctx;
}
function get_each_context_2$1(ctx, list, i) {
  const child_ctx = ctx.slice();
  child_ctx[21] = list[i][0];
  child_ctx[22] = list[i][1];
  return child_ctx;
}
function create_if_block$1(ctx) {
  let div0;
  let t0;
  let t1;
  let div1;
  let t2;
  let datatable;
  let current;
  let each_value_2 = ensure_array_like(Object.entries(
    /*positionConfigInfo*/
    ctx[7]
  ));
  let each_blocks = [];
  for (let i = 0; i < each_value_2.length; i += 1) {
    each_blocks[i] = create_each_block_2$1(get_each_context_2$1(ctx, each_value_2, i));
  }
  let if_block0 = (
    /*nextExitPositions*/
    (ctx[5].length !== 0 || /*nextEntryPositions*/
    ctx[4].length !== 0) && create_if_block_4$1(ctx)
  );
  let if_block1 = (
    /*nextExitPositions*/
    (ctx[5].length !== 0 || /*nextEntryPositions*/
    ctx[4].length !== 0) && create_if_block_3$1()
  );
  datatable = new PositionDataTable({
    props: {
      rows: (
        /*rows*/
        ctx[2]
      ),
      columns: (
        /*columns*/
        ctx[6]
      ),
      $$slots: {
        RSV: [
          create_RSV_slot,
          ({ row }) => ({ 15: row }),
          ({ row }) => row ? 32768 : 0
        ],
        currentWeight: [
          create_currentWeight_slot,
          ({ row }) => ({ 15: row }),
          ({ row }) => row ? 32768 : 0
        ],
        entryDate: [
          create_entryDate_slot,
          ({ row }) => ({ 15: row }),
          ({ row }) => row ? 32768 : 0
        ],
        profit: [
          create_profit_slot,
          ({ row }) => ({ 15: row }),
          ({ row }) => row ? 32768 : 0
        ],
        name: [
          create_name_slot,
          ({ row }) => ({ 15: row }),
          ({ row }) => row ? 32768 : 0
        ]
      },
      $$scope: { ctx }
    }
  });
  return {
    c() {
      div0 = element("div");
      for (let i = 0; i < each_blocks.length; i += 1) {
        each_blocks[i].c();
      }
      t0 = space();
      if (if_block0)
        if_block0.c();
      t1 = space();
      div1 = element("div");
      if (if_block1)
        if_block1.c();
      t2 = space();
      create_component(datatable.$$.fragment);
      attr(div0, "class", "flex gap-2 md:gap-4 my-4 stats bg-transparent sm:text-center min-w-full");
      attr(div1, "class", "rounded-2xl h-full bg-base-200 mt-4 p-4 sm:p-8 sm:border");
    },
    m(target, anchor) {
      insert(target, div0, anchor);
      for (let i = 0; i < each_blocks.length; i += 1) {
        if (each_blocks[i]) {
          each_blocks[i].m(div0, null);
        }
      }
      insert(target, t0, anchor);
      if (if_block0)
        if_block0.m(target, anchor);
      insert(target, t1, anchor);
      insert(target, div1, anchor);
      if (if_block1)
        if_block1.m(div1, null);
      append(div1, t2);
      mount_component(datatable, div1, null);
      current = true;
    },
    p(ctx2, dirty) {
      if (dirty & /*Object, positionConfigInfo, pconfig, i*/
      131) {
        each_value_2 = ensure_array_like(Object.entries(
          /*positionConfigInfo*/
          ctx2[7]
        ));
        let i;
        for (i = 0; i < each_value_2.length; i += 1) {
          const child_ctx = get_each_context_2$1(ctx2, each_value_2, i);
          if (each_blocks[i]) {
            each_blocks[i].p(child_ctx, dirty);
          } else {
            each_blocks[i] = create_each_block_2$1(child_ctx);
            each_blocks[i].c();
            each_blocks[i].m(div0, null);
          }
        }
        for (; i < each_blocks.length; i += 1) {
          each_blocks[i].d(1);
        }
        each_blocks.length = each_value_2.length;
      }
      if (
        /*nextExitPositions*/
        ctx2[5].length !== 0 || /*nextEntryPositions*/
        ctx2[4].length !== 0
      ) {
        if (if_block0) {
          if_block0.p(ctx2, dirty);
        } else {
          if_block0 = create_if_block_4$1(ctx2);
          if_block0.c();
          if_block0.m(t1.parentNode, t1);
        }
      } else if (if_block0) {
        if_block0.d(1);
        if_block0 = null;
      }
      if (
        /*nextExitPositions*/
        ctx2[5].length !== 0 || /*nextEntryPositions*/
        ctx2[4].length !== 0
      ) {
        if (if_block1)
          ;
        else {
          if_block1 = create_if_block_3$1();
          if_block1.c();
          if_block1.m(div1, t2);
        }
      } else if (if_block1) {
        if_block1.d(1);
        if_block1 = null;
      }
      const datatable_changes = {};
      if (dirty & /*rows*/
      4)
        datatable_changes.rows = /*rows*/
        ctx2[2];
      if (dirty & /*columns*/
      64)
        datatable_changes.columns = /*columns*/
        ctx2[6];
      if (dirty & /*$$scope, row, pconfig*/
      33587201) {
        datatable_changes.$$scope = { dirty, ctx: ctx2 };
      }
      datatable.$set(datatable_changes);
    },
    i(local) {
      if (current)
        return;
      transition_in(datatable.$$.fragment, local);
      current = true;
    },
    o(local) {
      transition_out(datatable.$$.fragment, local);
      current = false;
    },
    d(detaching) {
      if (detaching) {
        detach(div0);
        detach(t0);
        detach(t1);
        detach(div1);
      }
      destroy_each(each_blocks, detaching);
      if (if_block0)
        if_block0.d(detaching);
      if (if_block1)
        if_block1.d();
      destroy_component(datatable);
    }
  };
}
function create_if_block_9$1(ctx) {
  let div;
  let span0;
  let t0_value = (
    /*i*/
    ctx[1]("position." + /*key*/
    ctx[21]) + ""
  );
  let t0;
  let br;
  let t1;
  let span1;
  let t2_value = (
    /*val*/
    ctx[22].formatter(
      /*pconfig*/
      ctx[0][
        /*key*/
        ctx[21]
      ]
    ) + ""
  );
  let t2;
  let t3;
  let span2;
  let t5;
  return {
    c() {
      div = element("div");
      span0 = element("span");
      t0 = text(t0_value);
      br = element("br");
      t1 = space();
      span1 = element("span");
      t2 = text(t2_value);
      t3 = space();
      span2 = element("span");
      span2.textContent = `${/*val*/
      ctx[22].unit}`;
      t5 = space();
      attr(span0, "class", "text-base-content-100");
      attr(span1, "class", "text-base-content-200 text-2xl font-bold");
      attr(span2, "class", "text-base-content-200");
      attr(div, "class", "flex-1");
    },
    m(target, anchor) {
      insert(target, div, anchor);
      append(div, span0);
      append(span0, t0);
      append(div, br);
      append(div, t1);
      append(div, span1);
      append(span1, t2);
      append(div, t3);
      append(div, span2);
      append(div, t5);
    },
    p(ctx2, dirty) {
      if (dirty & /*i*/
      2 && t0_value !== (t0_value = /*i*/
      ctx2[1]("position." + /*key*/
      ctx2[21]) + ""))
        set_data(t0, t0_value);
      if (dirty & /*pconfig*/
      1 && t2_value !== (t2_value = /*val*/
      ctx2[22].formatter(
        /*pconfig*/
        ctx2[0][
          /*key*/
          ctx2[21]
        ]
      ) + ""))
        set_data(t2, t2_value);
    },
    d(detaching) {
      if (detaching) {
        detach(div);
      }
    }
  };
}
function create_each_block_2$1(ctx) {
  let show_if = !("shown" in /*val*/
  ctx[22]) || /*val*/
  ctx[22].shown(
    /*pconfig*/
    ctx[0][
      /*key*/
      ctx[21]
    ]
  );
  let if_block_anchor;
  let if_block = show_if && create_if_block_9$1(ctx);
  return {
    c() {
      if (if_block)
        if_block.c();
      if_block_anchor = empty();
    },
    m(target, anchor) {
      if (if_block)
        if_block.m(target, anchor);
      insert(target, if_block_anchor, anchor);
    },
    p(ctx2, dirty) {
      if (dirty & /*pconfig*/
      1)
        show_if = !("shown" in /*val*/
        ctx2[22]) || /*val*/
        ctx2[22].shown(
          /*pconfig*/
          ctx2[0][
            /*key*/
            ctx2[21]
          ]
        );
      if (show_if) {
        if (if_block) {
          if_block.p(ctx2, dirty);
        } else {
          if_block = create_if_block_9$1(ctx2);
          if_block.c();
          if_block.m(if_block_anchor.parentNode, if_block_anchor);
        }
      } else if (if_block) {
        if_block.d(1);
        if_block = null;
      }
    },
    d(detaching) {
      if (detaching) {
        detach(if_block_anchor);
      }
      if (if_block)
        if_block.d(detaching);
    }
  };
}
function create_if_block_4$1(ctx) {
  let div;
  let t0;
  let t1;
  let if_block0 = (
    /*nextEntryPositions*/
    ctx[4] && create_if_block_7$1(ctx)
  );
  let if_block1 = (
    /*nextEntryPositions*/
    ctx[4] && /*nextExitPositions*/
    ctx[5] && create_if_block_6$1()
  );
  let if_block2 = (
    /*nextExitPositions*/
    ctx[5] && create_if_block_5$1(ctx)
  );
  return {
    c() {
      div = element("div");
      if (if_block0)
        if_block0.c();
      t0 = space();
      if (if_block1)
        if_block1.c();
      t1 = space();
      if (if_block2)
        if_block2.c();
      attr(div, "class", "md:rounded-2xl h-full border bg-base-200 p-4 sm:p-8");
    },
    m(target, anchor) {
      insert(target, div, anchor);
      if (if_block0)
        if_block0.m(div, null);
      append(div, t0);
      if (if_block1)
        if_block1.m(div, null);
      append(div, t1);
      if (if_block2)
        if_block2.m(div, null);
    },
    p(ctx2, dirty) {
      if (
        /*nextEntryPositions*/
        ctx2[4]
      ) {
        if (if_block0) {
          if_block0.p(ctx2, dirty);
        } else {
          if_block0 = create_if_block_7$1(ctx2);
          if_block0.c();
          if_block0.m(div, t0);
        }
      } else if (if_block0) {
        if_block0.d(1);
        if_block0 = null;
      }
      if (
        /*nextEntryPositions*/
        ctx2[4] && /*nextExitPositions*/
        ctx2[5]
      ) {
        if (if_block1)
          ;
        else {
          if_block1 = create_if_block_6$1();
          if_block1.c();
          if_block1.m(div, t1);
        }
      } else if (if_block1) {
        if_block1.d(1);
        if_block1 = null;
      }
      if (
        /*nextExitPositions*/
        ctx2[5]
      ) {
        if (if_block2) {
          if_block2.p(ctx2, dirty);
        } else {
          if_block2 = create_if_block_5$1(ctx2);
          if_block2.c();
          if_block2.m(div, null);
        }
      } else if (if_block2) {
        if_block2.d(1);
        if_block2 = null;
      }
    },
    d(detaching) {
      if (detaching) {
        detach(div);
      }
      if (if_block0)
        if_block0.d();
      if (if_block1)
        if_block1.d();
      if (if_block2)
        if_block2.d();
    }
  };
}
function create_if_block_7$1(ctx) {
  let div0;
  let h22;
  let t0_value = { close: "收盤", open: "開盤" }[
    /*pconfig*/
    ctx[0].entryTradePrice
  ] + "";
  let t0;
  let t1;
  let t2;
  let input;
  let t3;
  let span;
  let t5;
  let div1;
  let mounted;
  let dispose;
  let each_value_1 = ensure_array_like(
    /*nextEntryPositions*/
    ctx[4]
  );
  let each_blocks = [];
  for (let i = 0; i < each_value_1.length; i += 1) {
    each_blocks[i] = create_each_block_1$1(get_each_context_1$1(ctx, each_value_1, i));
  }
  return {
    c() {
      div0 = element("div");
      h22 = element("h2");
      t0 = text(t0_value);
      t1 = text("買入");
      t2 = space();
      input = element("input");
      t3 = space();
      span = element("span");
      span.textContent = "顯示買入部位";
      t5 = space();
      div1 = element("div");
      for (let i = 0; i < each_blocks.length; i += 1) {
        each_blocks[i].c();
      }
      attr(input, "type", "checkbox");
      attr(input, "class", "ml-4 toggle toggle-sm");
      attr(span, "class", "ml-2 text-sm font-normal");
      attr(div0, "class", "text-2xl text-base-content-200 font-bold items-center flex");
      attr(div1, "class", "grid grid-cols-2 md:grid-cols-3 gap-4 pt-1 mt-4");
    },
    m(target, anchor) {
      insert(target, div0, anchor);
      append(div0, h22);
      append(h22, t0);
      append(h22, t1);
      append(div0, t2);
      append(div0, input);
      input.checked = /*showEntryPosition*/
      ctx[3];
      append(div0, t3);
      append(div0, span);
      insert(target, t5, anchor);
      insert(target, div1, anchor);
      for (let i = 0; i < each_blocks.length; i += 1) {
        if (each_blocks[i]) {
          each_blocks[i].m(div1, null);
        }
      }
      if (!mounted) {
        dispose = listen(
          input,
          "change",
          /*input_change_handler*/
          ctx[12]
        );
        mounted = true;
      }
    },
    p(ctx2, dirty) {
      if (dirty & /*pconfig*/
      1 && t0_value !== (t0_value = { close: "收盤", open: "開盤" }[
        /*pconfig*/
        ctx2[0].entryTradePrice
      ] + ""))
        set_data(t0, t0_value);
      if (dirty & /*showEntryPosition*/
      8) {
        input.checked = /*showEntryPosition*/
        ctx2[3];
      }
      if (dirty & /*nextEntryPositions, riseHex, fallHex, Math, showEntryPosition, charToHex*/
      24) {
        each_value_1 = ensure_array_like(
          /*nextEntryPositions*/
          ctx2[4]
        );
        let i;
        for (i = 0; i < each_value_1.length; i += 1) {
          const child_ctx = get_each_context_1$1(ctx2, each_value_1, i);
          if (each_blocks[i]) {
            each_blocks[i].p(child_ctx, dirty);
          } else {
            each_blocks[i] = create_each_block_1$1(child_ctx);
            each_blocks[i].c();
            each_blocks[i].m(div1, null);
          }
        }
        for (; i < each_blocks.length; i += 1) {
          each_blocks[i].d(1);
        }
        each_blocks.length = each_value_1.length;
      }
    },
    d(detaching) {
      if (detaching) {
        detach(div0);
        detach(t5);
        detach(div1);
      }
      destroy_each(each_blocks, detaching);
      mounted = false;
      dispose();
    }
  };
}
function create_if_block_8$1(ctx) {
  let div;
  let span;
  let t0_value = Math.abs(
    /*p*/
    ctx[16].nextWeight * 100
  ).toFixed(1) + "";
  let t0;
  let t1;
  return {
    c() {
      div = element("div");
      span = element("span");
      t0 = text(t0_value);
      t1 = text("%");
      set_style(
        span,
        "color",
        /*p*/
        ctx[16].nextWeight > 0 ? riseHex("red") : fallHex("red")
      );
      attr(span, "class", "font-light lining-nums ml-4 svelte-1nx0ef2");
      attr(div, "class", "flex-grow text-left");
    },
    m(target, anchor) {
      insert(target, div, anchor);
      append(div, span);
      append(span, t0);
      append(span, t1);
    },
    p(ctx2, dirty) {
      if (dirty & /*nextEntryPositions*/
      16 && t0_value !== (t0_value = Math.abs(
        /*p*/
        ctx2[16].nextWeight * 100
      ).toFixed(1) + ""))
        set_data(t0, t0_value);
      if (dirty & /*nextEntryPositions*/
      16) {
        set_style(
          span,
          "color",
          /*p*/
          ctx2[16].nextWeight > 0 ? riseHex("red") : fallHex("red")
        );
      }
    },
    d(detaching) {
      if (detaching) {
        detach(div);
      }
    }
  };
}
function create_each_block_1$1(ctx) {
  let div3;
  let div2;
  let div0;
  let t0_value = (
    /*p*/
    ctx[16].assetName[0] + ""
  );
  let t0;
  let t1;
  let div1;
  let span0;
  let t2_value = (
    /*p*/
    ctx[16].assetName + ""
  );
  let t2;
  let t3;
  let br;
  let t4;
  let span1;
  let t5_value = (
    /*p*/
    ctx[16].assetId + ""
  );
  let t5;
  let t6;
  let t7;
  let if_block = (
    /*showEntryPosition*/
    ctx[3] && create_if_block_8$1(ctx)
  );
  return {
    c() {
      div3 = element("div");
      div2 = element("div");
      div0 = element("div");
      t0 = text(t0_value);
      t1 = space();
      div1 = element("div");
      span0 = element("span");
      t2 = text(t2_value);
      t3 = space();
      br = element("br");
      t4 = space();
      span1 = element("span");
      t5 = text(t5_value);
      t6 = space();
      if (if_block)
        if_block.c();
      t7 = space();
      attr(div0, "class", "mr-3 w-8 h-8 rounded-full text-white font-bold justify-center items-center flex");
      set_style(div0, "background", charToHex(
        /*p*/
        ctx[16].assetName[0]
      ));
      attr(span0, "class", "whitespace-nowrap font-bold text-base-content-300");
      attr(span1, "class", "font-light text-base-content/30");
      attr(div2, "class", "flex flex-nowrap items-center");
      attr(div3, "class", "text-base font-bold relative text-ellipsis overflow-hidden text-left");
    },
    m(target, anchor) {
      insert(target, div3, anchor);
      append(div3, div2);
      append(div2, div0);
      append(div0, t0);
      append(div2, t1);
      append(div2, div1);
      append(div1, span0);
      append(span0, t2);
      append(div1, t3);
      append(div1, br);
      append(div1, t4);
      append(div1, span1);
      append(span1, t5);
      append(div2, t6);
      if (if_block)
        if_block.m(div2, null);
      append(div3, t7);
    },
    p(ctx2, dirty) {
      if (dirty & /*nextEntryPositions*/
      16 && t0_value !== (t0_value = /*p*/
      ctx2[16].assetName[0] + ""))
        set_data(t0, t0_value);
      if (dirty & /*nextEntryPositions*/
      16) {
        set_style(div0, "background", charToHex(
          /*p*/
          ctx2[16].assetName[0]
        ));
      }
      if (dirty & /*nextEntryPositions*/
      16 && t2_value !== (t2_value = /*p*/
      ctx2[16].assetName + ""))
        set_data(t2, t2_value);
      if (dirty & /*nextEntryPositions*/
      16 && t5_value !== (t5_value = /*p*/
      ctx2[16].assetId + ""))
        set_data(t5, t5_value);
      if (
        /*showEntryPosition*/
        ctx2[3]
      ) {
        if (if_block) {
          if_block.p(ctx2, dirty);
        } else {
          if_block = create_if_block_8$1(ctx2);
          if_block.c();
          if_block.m(div2, null);
        }
      } else if (if_block) {
        if_block.d(1);
        if_block = null;
      }
    },
    d(detaching) {
      if (detaching) {
        detach(div3);
      }
      if (if_block)
        if_block.d();
    }
  };
}
function create_if_block_6$1(ctx) {
  let hr;
  return {
    c() {
      hr = element("hr");
      attr(hr, "class", "my-6");
    },
    m(target, anchor) {
      insert(target, hr, anchor);
    },
    d(detaching) {
      if (detaching) {
        detach(hr);
      }
    }
  };
}
function create_if_block_5$1(ctx) {
  let h22;
  let t0_value = { close: "收盤", open: "開盤" }[
    /*pconfig*/
    ctx[0].entryTradePrice
  ] + "";
  let t0;
  let t1;
  let t2;
  let div;
  let each_value = ensure_array_like(
    /*nextExitPositions*/
    ctx[5]
  );
  let each_blocks = [];
  for (let i = 0; i < each_value.length; i += 1) {
    each_blocks[i] = create_each_block$1(get_each_context$1(ctx, each_value, i));
  }
  return {
    c() {
      h22 = element("h2");
      t0 = text(t0_value);
      t1 = text("賣出");
      t2 = space();
      div = element("div");
      for (let i = 0; i < each_blocks.length; i += 1) {
        each_blocks[i].c();
      }
      attr(h22, "class", "text-2xl text-base-content-200 font-bold flex items-center");
      attr(div, "class", "grid grid-cols-2 md:grid-cols-3 gap-4 pt-1 mt-4");
    },
    m(target, anchor) {
      insert(target, h22, anchor);
      append(h22, t0);
      append(h22, t1);
      insert(target, t2, anchor);
      insert(target, div, anchor);
      for (let i = 0; i < each_blocks.length; i += 1) {
        if (each_blocks[i]) {
          each_blocks[i].m(div, null);
        }
      }
    },
    p(ctx2, dirty) {
      if (dirty & /*pconfig*/
      1 && t0_value !== (t0_value = { close: "收盤", open: "開盤" }[
        /*pconfig*/
        ctx2[0].entryTradePrice
      ] + ""))
        set_data(t0, t0_value);
      if (dirty & /*nextExitPositions, charToHex*/
      32) {
        each_value = ensure_array_like(
          /*nextExitPositions*/
          ctx2[5]
        );
        let i;
        for (i = 0; i < each_value.length; i += 1) {
          const child_ctx = get_each_context$1(ctx2, each_value, i);
          if (each_blocks[i]) {
            each_blocks[i].p(child_ctx, dirty);
          } else {
            each_blocks[i] = create_each_block$1(child_ctx);
            each_blocks[i].c();
            each_blocks[i].m(div, null);
          }
        }
        for (; i < each_blocks.length; i += 1) {
          each_blocks[i].d(1);
        }
        each_blocks.length = each_value.length;
      }
    },
    d(detaching) {
      if (detaching) {
        detach(h22);
        detach(t2);
        detach(div);
      }
      destroy_each(each_blocks, detaching);
    }
  };
}
function create_each_block$1(ctx) {
  let div3;
  let div2;
  let div0;
  let t0_value = (
    /*p*/
    ctx[16].assetName[0] + ""
  );
  let t0;
  let t1;
  let div1;
  let span0;
  let t2_value = (
    /*p*/
    ctx[16].assetName + ""
  );
  let t2;
  let t3;
  let br;
  let t4;
  let span1;
  let t5_value = (
    /*p*/
    ctx[16].assetId + ""
  );
  let t5;
  let t6;
  return {
    c() {
      div3 = element("div");
      div2 = element("div");
      div0 = element("div");
      t0 = text(t0_value);
      t1 = space();
      div1 = element("div");
      span0 = element("span");
      t2 = text(t2_value);
      t3 = space();
      br = element("br");
      t4 = space();
      span1 = element("span");
      t5 = text(t5_value);
      t6 = space();
      attr(div0, "class", "mr-3 w-8 h-8 rounded-full text-white font-bold justify-center items-center flex");
      set_style(div0, "background", charToHex(
        /*p*/
        ctx[16].assetName[0]
      ));
      attr(span0, "class", "whitespace-nowrap font-bold text-base-content-300");
      attr(span1, "class", "font-light text-base-content/30");
      attr(div2, "class", "flex flex-nowrap items-center");
      attr(div3, "class", "text-base font-bold relative text-ellipsis overflow-hidden text-left");
    },
    m(target, anchor) {
      insert(target, div3, anchor);
      append(div3, div2);
      append(div2, div0);
      append(div0, t0);
      append(div2, t1);
      append(div2, div1);
      append(div1, span0);
      append(span0, t2);
      append(div1, t3);
      append(div1, br);
      append(div1, t4);
      append(div1, span1);
      append(span1, t5);
      append(div3, t6);
    },
    p(ctx2, dirty) {
      if (dirty & /*nextExitPositions*/
      32 && t0_value !== (t0_value = /*p*/
      ctx2[16].assetName[0] + ""))
        set_data(t0, t0_value);
      if (dirty & /*nextExitPositions*/
      32) {
        set_style(div0, "background", charToHex(
          /*p*/
          ctx2[16].assetName[0]
        ));
      }
      if (dirty & /*nextExitPositions*/
      32 && t2_value !== (t2_value = /*p*/
      ctx2[16].assetName + ""))
        set_data(t2, t2_value);
      if (dirty & /*nextExitPositions*/
      32 && t5_value !== (t5_value = /*p*/
      ctx2[16].assetId + ""))
        set_data(t5, t5_value);
    },
    d(detaching) {
      if (detaching) {
        detach(div3);
      }
    }
  };
}
function create_if_block_3$1(ctx) {
  let h22;
  return {
    c() {
      h22 = element("h2");
      h22.textContent = "當前部位";
      attr(h22, "class", "text-2xl text-base-content-200 font-bold mb-2");
    },
    m(target, anchor) {
      insert(target, h22, anchor);
    },
    d(detaching) {
      if (detaching) {
        detach(h22);
      }
    }
  };
}
function create_name_slot(ctx) {
  let div3;
  let div2;
  let div0;
  let t0_value = (
    /*row*/
    ctx[15].assetName[0] + ""
  );
  let t0;
  let t1;
  let div1;
  let span0;
  let t2_value = (
    /*row*/
    ctx[15].assetName + ""
  );
  let t2;
  let t3;
  let br;
  let t4;
  let span1;
  let t5_value = (
    /*row*/
    ctx[15].assetId + ""
  );
  let t5;
  return {
    c() {
      div3 = element("div");
      div2 = element("div");
      div0 = element("div");
      t0 = text(t0_value);
      t1 = space();
      div1 = element("div");
      span0 = element("span");
      t2 = text(t2_value);
      t3 = space();
      br = element("br");
      t4 = space();
      span1 = element("span");
      t5 = text(t5_value);
      attr(div0, "class", "mr-3 w-8 h-8 rounded-full text-white font-bold justify-center items-center flex");
      set_style(div0, "background", charToHex(
        /*row*/
        ctx[15].assetName[0]
      ));
      attr(span0, "class", "whitespace-nowrap font-bold text-base-content-300");
      attr(span1, "class", "font-light text-base-content/30");
      attr(div2, "class", "flex flex-nowrap items-center");
      attr(div3, "slot", "name");
      attr(div3, "class", "text-base font-bold relative text-ellipsis overflow-hidden text-left");
    },
    m(target, anchor) {
      insert(target, div3, anchor);
      append(div3, div2);
      append(div2, div0);
      append(div0, t0);
      append(div2, t1);
      append(div2, div1);
      append(div1, span0);
      append(span0, t2);
      append(div1, t3);
      append(div1, br);
      append(div1, t4);
      append(div1, span1);
      append(span1, t5);
    },
    p(ctx2, dirty) {
      if (dirty & /*row*/
      32768 && t0_value !== (t0_value = /*row*/
      ctx2[15].assetName[0] + ""))
        set_data(t0, t0_value);
      if (dirty & /*row*/
      32768) {
        set_style(div0, "background", charToHex(
          /*row*/
          ctx2[15].assetName[0]
        ));
      }
      if (dirty & /*row*/
      32768 && t2_value !== (t2_value = /*row*/
      ctx2[15].assetName + ""))
        set_data(t2, t2_value);
      if (dirty & /*row*/
      32768 && t5_value !== (t5_value = /*row*/
      ctx2[15].assetId + ""))
        set_data(t5, t5_value);
    },
    d(detaching) {
      if (detaching) {
        detach(div3);
      }
    }
  };
}
function create_profit_slot(ctx) {
  let div;
  let span;
  let t0_value = sign(
    /*row*/
    ctx[15].profit
  ) + "";
  let t0;
  let t1_value = (
    /*row*/
    (ctx[15].profit * 100).toFixed(2) + ""
  );
  let t1;
  let t2;
  return {
    c() {
      div = element("div");
      span = element("span");
      t0 = text(t0_value);
      t1 = text(t1_value);
      t2 = text("%");
      set_style(
        span,
        "color",
        /*row*/
        ctx[15].profit > 0 ? riseHex("red") : fallHex("red")
      );
      attr(div, "slot", "profit");
      attr(div, "class", "lining-nums svelte-1nx0ef2");
    },
    m(target, anchor) {
      insert(target, div, anchor);
      append(div, span);
      append(span, t0);
      append(span, t1);
      append(span, t2);
    },
    p(ctx2, dirty) {
      if (dirty & /*row*/
      32768 && t0_value !== (t0_value = sign(
        /*row*/
        ctx2[15].profit
      ) + ""))
        set_data(t0, t0_value);
      if (dirty & /*row*/
      32768 && t1_value !== (t1_value = /*row*/
      (ctx2[15].profit * 100).toFixed(2) + ""))
        set_data(t1, t1_value);
      if (dirty & /*row*/
      32768) {
        set_style(
          span,
          "color",
          /*row*/
          ctx2[15].profit > 0 ? riseHex("red") : fallHex("red")
        );
      }
    },
    d(detaching) {
      if (detaching) {
        detach(div);
      }
    }
  };
}
function create_if_block_2$1(ctx) {
  let br;
  let t_value = (
    /*row*/
    ctx[15].entryDate.toLocaleTimeString() + ""
  );
  let t;
  return {
    c() {
      br = element("br");
      t = text(t_value);
    },
    m(target, anchor) {
      insert(target, br, anchor);
      insert(target, t, anchor);
    },
    p(ctx2, dirty) {
      if (dirty & /*row*/
      32768 && t_value !== (t_value = /*row*/
      ctx2[15].entryDate.toLocaleTimeString() + ""))
        set_data(t, t_value);
    },
    d(detaching) {
      if (detaching) {
        detach(br);
        detach(t);
      }
    }
  };
}
function create_entryDate_slot(ctx) {
  let div;
  let span0;
  let t0_value = (
    /*row*/
    ctx[15].currentPrice.toFixed(2) + ""
  );
  let t0;
  let br;
  let t1;
  let span1;
  let t2_value = (
    /*row*/
    ctx[15].entryDate.toLocaleDateString() + ""
  );
  let t2;
  let t3;
  let if_block = !/*pconfig*/
  ctx[0].isDailyStrategy && create_if_block_2$1(ctx);
  return {
    c() {
      div = element("div");
      span0 = element("span");
      t0 = text(t0_value);
      br = element("br");
      t1 = space();
      span1 = element("span");
      t2 = text(t2_value);
      t3 = space();
      if (if_block)
        if_block.c();
      attr(span0, "class", "lining-nums svelte-1nx0ef2");
      attr(span1, "class", "text-sm");
      attr(div, "slot", "entryDate");
    },
    m(target, anchor) {
      insert(target, div, anchor);
      append(div, span0);
      append(span0, t0);
      append(div, br);
      append(div, t1);
      append(div, span1);
      append(span1, t2);
      append(div, t3);
      if (if_block)
        if_block.m(div, null);
    },
    p(ctx2, dirty) {
      if (dirty & /*row*/
      32768 && t0_value !== (t0_value = /*row*/
      ctx2[15].currentPrice.toFixed(2) + ""))
        set_data(t0, t0_value);
      if (dirty & /*row*/
      32768 && t2_value !== (t2_value = /*row*/
      ctx2[15].entryDate.toLocaleDateString() + ""))
        set_data(t2, t2_value);
      if (!/*pconfig*/
      ctx2[0].isDailyStrategy) {
        if (if_block) {
          if_block.p(ctx2, dirty);
        } else {
          if_block = create_if_block_2$1(ctx2);
          if_block.c();
          if_block.m(div, null);
        }
      } else if (if_block) {
        if_block.d(1);
        if_block = null;
      }
    },
    d(detaching) {
      if (detaching) {
        detach(div);
      }
      if (if_block)
        if_block.d();
    }
  };
}
function create_currentWeight_slot(ctx) {
  let div;
  let span;
  let t0_value = (
    /*row*/
    (ctx[15].currentWeight * 100).toFixed(1) + ""
  );
  let t0;
  let t1;
  return {
    c() {
      div = element("div");
      span = element("span");
      t0 = text(t0_value);
      t1 = text("%");
      set_style(
        span,
        "color",
        /*row*/
        ctx[15].currentWeight > 0 ? riseHex("red") : fallHex("red")
      );
      attr(div, "slot", "currentWeight");
      attr(div, "class", "lining-nums svelte-1nx0ef2");
    },
    m(target, anchor) {
      insert(target, div, anchor);
      append(div, span);
      append(span, t0);
      append(span, t1);
    },
    p(ctx2, dirty) {
      if (dirty & /*row*/
      32768 && t0_value !== (t0_value = /*row*/
      (ctx2[15].currentWeight * 100).toFixed(1) + ""))
        set_data(t0, t0_value);
      if (dirty & /*row*/
      32768) {
        set_style(
          span,
          "color",
          /*row*/
          ctx2[15].currentWeight > 0 ? riseHex("red") : fallHex("red")
        );
      }
    },
    d(detaching) {
      if (detaching) {
        detach(div);
      }
    }
  };
}
function create_else_block$1(ctx) {
  let t;
  return {
    c() {
      t = text("-");
    },
    m(target, anchor) {
      insert(target, t, anchor);
    },
    p: noop$1,
    d(detaching) {
      if (detaching) {
        detach(t);
      }
    }
  };
}
function create_if_block_1$1(ctx) {
  let t0_value = (
    /*row*/
    (ctx[15].rsv20 * 100).toFixed(2) + ""
  );
  let t0;
  let t1;
  let br;
  let t2;
  let progress;
  let progress_value_value;
  return {
    c() {
      t0 = text(t0_value);
      t1 = text("%");
      br = element("br");
      t2 = space();
      progress = element("progress");
      attr(progress, "class", "progress progress-primary w-32");
      progress.value = progress_value_value = /*row*/
      ctx[15].rsv20;
      attr(progress, "max", "1");
    },
    m(target, anchor) {
      insert(target, t0, anchor);
      insert(target, t1, anchor);
      insert(target, br, anchor);
      insert(target, t2, anchor);
      insert(target, progress, anchor);
    },
    p(ctx2, dirty) {
      if (dirty & /*row*/
      32768 && t0_value !== (t0_value = /*row*/
      (ctx2[15].rsv20 * 100).toFixed(2) + ""))
        set_data(t0, t0_value);
      if (dirty & /*row*/
      32768 && progress_value_value !== (progress_value_value = /*row*/
      ctx2[15].rsv20)) {
        progress.value = progress_value_value;
      }
    },
    d(detaching) {
      if (detaching) {
        detach(t0);
        detach(t1);
        detach(br);
        detach(t2);
        detach(progress);
      }
    }
  };
}
function create_RSV_slot(ctx) {
  let div;
  let show_if;
  function select_block_type(ctx2, dirty) {
    if (dirty & /*row*/
    32768)
      show_if = null;
    if (show_if == null)
      show_if = !!isFinite(
        /*row*/
        ctx2[15].rsv20
      );
    if (show_if)
      return create_if_block_1$1;
    return create_else_block$1;
  }
  let current_block_type = select_block_type(ctx, -1);
  let if_block = current_block_type(ctx);
  return {
    c() {
      div = element("div");
      if_block.c();
      attr(div, "slot", "RSV");
      attr(div, "class", "text-base-content-100");
    },
    m(target, anchor) {
      insert(target, div, anchor);
      if_block.m(div, null);
    },
    p(ctx2, dirty) {
      if (current_block_type === (current_block_type = select_block_type(ctx2, dirty)) && if_block) {
        if_block.p(ctx2, dirty);
      } else {
        if_block.d(1);
        if_block = current_block_type(ctx2);
        if (if_block) {
          if_block.c();
          if_block.m(div, null);
        }
      }
    },
    d(detaching) {
      if (detaching) {
        detach(div);
      }
      if_block.d();
    }
  };
}
function create_fragment$2(ctx) {
  let div;
  let current;
  let if_block = (
    /*pconfig*/
    ctx[0] && create_if_block$1(ctx)
  );
  return {
    c() {
      div = element("div");
      if (if_block)
        if_block.c();
      attr(div, "class", "text-base-content w-full relative");
    },
    m(target, anchor) {
      insert(target, div, anchor);
      if (if_block)
        if_block.m(div, null);
      current = true;
    },
    p(ctx2, [dirty]) {
      if (
        /*pconfig*/
        ctx2[0]
      ) {
        if (if_block) {
          if_block.p(ctx2, dirty);
          if (dirty & /*pconfig*/
          1) {
            transition_in(if_block, 1);
          }
        } else {
          if_block = create_if_block$1(ctx2);
          if_block.c();
          transition_in(if_block, 1);
          if_block.m(div, null);
        }
      } else if (if_block) {
        group_outros();
        transition_out(if_block, 1, 1, () => {
          if_block = null;
        });
        check_outros();
      }
    },
    i(local) {
      if (current)
        return;
      transition_in(if_block);
      current = true;
    },
    o(local) {
      transition_out(if_block);
      current = false;
    },
    d(detaching) {
      if (detaching) {
        detach(div);
      }
      if (if_block)
        if_block.d();
    }
  };
}
function sign(a2) {
  if (a2 > 0) {
    return "+";
  }
  return "";
}
function marketCloseAtTimestamp(timestamp = null) {
  const taipeiOffset = 480;
  if (timestamp && !(timestamp instanceof Date)) {
    timestamp = new Date(timestamp);
  }
  if (!timestamp) {
    timestamp = /* @__PURE__ */ new Date();
  }
  const utc = timestamp.getTime() + timestamp.getTimezoneOffset() * 6e4;
  const taipeiTime = new Date(utc + 36e5 * taipeiOffset / 60);
  taipeiTime.setHours(15, 0, 0, 0);
  return taipeiTime;
}
function instance$2($$self, $$props, $$invalidate) {
  let i;
  let sortedPositions;
  let columns;
  let nextExitPositions;
  let nextEntryPositions;
  let { reportPosition = null } = $$props;
  let { lang = "en" } = $$props;
  let pconfig = null;
  let positions2 = [];
  onMount(async () => {
    let docData = null;
    docData = reportPosition;
    console.log("Document data:", docData);
    $$invalidate(10, positions2 = []);
    if (docData) {
      $$invalidate(0, pconfig = docData.positionConfig);
      if (pconfig !== null) {
        $$invalidate(0, pconfig.created = new Date(pconfig.created), pconfig);
        $$invalidate(0, pconfig.scheduled = new Date(pconfig.scheduled), pconfig);
      }
      docData.positions.forEach((position2) => {
        position2.entryDate = new Date(position2.entryDate);
        position2.exitDate = new Date(position2.exitDate);
        position2.entrySigDate = new Date(position2.entrySigDate);
        position2.exitSigDate = new Date(position2.exitSigDate);
        if (position2.action) {
          position2.action.date = new Date(position2.action.date);
        }
        if (!isValidPosition(position2)) {
          console.log("Invalid position:", position2);
        } else {
          positions2.push(position2);
        }
      });
    } else {
      console.log("No such document!");
    }
    window.positions = positions2;
  });
  const positionConfigInfo = {
    resample: {
      formatter: (value) => {
        return i("position.resampleValue." + value) || value;
      },
      unit: ""
    },
    // entryTradePrice: {
    // 	formatter: (value: string) => i(`position.${value}`) || value,
    // 	unit: '進場'
    // },
    // exitTradePrice: {
    // 	formatter: (value: string) => i(`position.${value}`) || value,
    // 	unit: '出場'
    // },
    created: {
      formatter: (value) => pconfig.isDailyStrategy ? value.toLocaleDateString() : value.toLocaleString(),
      // 'YYYY-MM-DD'
      unit: ""
    },
    // scheduled: {
    // 	formatter: (value: Date) =>
    // 		pconfig.isDailyStrategy ? value.toLocaleDateString() : value.toLocaleString(), // 'YYYY-MM-DD'
    // 	unit: ''
    // },
    sl: {
      shown(value) {
        return value != 1;
      },
      formatter: (value) => value == 100 ? -(value * 100).toFixed() : "無",
      unit: "%"
    },
    tp: {
      shown(value) {
        return value < 1e5;
      },
      formatter: (value) => "+" + (value * 100).toFixed(),
      unit: "%"
    }
  };
  let rows;
  const now = /* @__PURE__ */ new Date();
  let showEntryPosition = false;
  function input_change_handler() {
    showEntryPosition = this.checked;
    $$invalidate(3, showEntryPosition);
  }
  $$self.$$set = ($$props2) => {
    if ("reportPosition" in $$props2)
      $$invalidate(8, reportPosition = $$props2.reportPosition);
    if ("lang" in $$props2)
      $$invalidate(9, lang = $$props2.lang);
  };
  $$self.$$.update = () => {
    if ($$self.$$.dirty & /*lang*/
    512) {
      $$invalidate(1, i = (key) => lang === "en" ? ien(key) : itw(key));
    }
    if ($$self.$$.dirty & /*positions*/
    1024) {
      $$invalidate(11, sortedPositions = positions2.sort((a2, b2) => {
        var _a, _b, _c, _d, _e, _f, _g, _h;
        if (((_a = a2.action) == null ? void 0 : _a.type) === "entry" && ((_b = b2.action) == null ? void 0 : _b.type) !== "entry")
          return -1;
        if (((_c = a2.action) == null ? void 0 : _c.type) !== "entry" && ((_d = b2.action) == null ? void 0 : _d.type) === "entry")
          return 1;
        if (((_e = a2.action) == null ? void 0 : _e.type) === "exit" && ((_f = b2.action) == null ? void 0 : _f.type) !== "exit")
          return -1;
        if (((_g = a2.action) == null ? void 0 : _g.type) !== "exit" && ((_h = b2.action) == null ? void 0 : _h.type) === "exit")
          return 1;
        return b2.entryDate.getTime() - a2.entryDate.getTime();
      }));
    }
    if ($$self.$$.dirty & /*sortedPositions*/
    2048) {
      {
        $$invalidate(2, rows = sortedPositions.filter((p2) => p2.action.type == "hold" || p2.action.type == "exit"));
      }
    }
    if ($$self.$$.dirty & /*i*/
    2) {
      $$invalidate(6, columns = [
        {
          key: "name",
          name: i("position.assetName"),
          sort: false,
          width: "160px"
        },
        // { key: 'action', name: i('position.action'), sort: true, width: '160px' },
        {
          key: "profit",
          name: i("position.profit"),
          sort: true,
          width: "160px"
        },
        {
          key: "entryDate",
          name: i("position.entryDate"),
          sort: true,
          width: "180px"
        },
        // { key: 'currentPrice', name: i('position.currentPrice'), sort: true, width: '180px' },
        {
          key: "currentWeight",
          name: i("position.currentWeight"),
          sort: true,
          width: "160px"
        },
        {
          key: "RSV",
          name: i("position.RSV"),
          sort: false,
          width: "240px"
        }
      ]);
    }
    if ($$self.$$.dirty & /*sortedPositions, pconfig*/
    2049) {
      $$invalidate(5, nextExitPositions = sortedPositions.filter((p2) => p2.exitSigDate >= new Date(pconfig.lastTimestamp) && now > marketCloseAtTimestamp(p2.exitSigDate) && p2.nextWeight === 0));
    }
    if ($$self.$$.dirty & /*sortedPositions, pconfig*/
    2049) {
      $$invalidate(4, nextEntryPositions = sortedPositions.filter((p2) => p2.entrySigDate >= new Date(pconfig.lastTimestamp) && now > marketCloseAtTimestamp(p2.entrySigDate) && p2.nextWeight !== 0));
    }
  };
  return [
    pconfig,
    i,
    rows,
    showEntryPosition,
    nextEntryPositions,
    nextExitPositions,
    columns,
    positionConfigInfo,
    reportPosition,
    lang,
    positions2,
    sortedPositions,
    input_change_handler
  ];
}
class Position extends SvelteComponent {
  constructor(options) {
    super();
    init(this, options, instance$2, create_fragment$2, safe_not_equal, { reportPosition: 8, lang: 9 }, add_css);
  }
  get reportPosition() {
    return this.$$.ctx[8];
  }
  set reportPosition(reportPosition) {
    this.$$set({ reportPosition });
    flush();
  }
  get lang() {
    return this.$$.ctx[9];
  }
  set lang(lang) {
    this.$$set({ lang });
    flush();
  }
}
create_custom_element(Position, { "reportPosition": {}, "lang": {} }, [], [], true);
if (typeof window !== "undefined") {
  let loadSvg = function() {
    var body = document.body;
    var svgDom = document.getElementById("__svg__icons__dom__");
    if (!svgDom) {
      svgDom = document.createElementNS("http://www.w3.org/2000/svg", "svg");
      svgDom.style.position = "absolute";
      svgDom.style.width = "0";
      svgDom.style.height = "0";
      svgDom.id = "__svg__icons__dom__";
      svgDom.setAttribute("xmlns", "http://www.w3.org/2000/svg");
      svgDom.setAttribute("xmlns:link", "http://www.w3.org/1999/xlink");
    }
    svgDom.innerHTML = '<symbol  viewBox="0 0 48 48" id="icon-chinese"><g fill="none" stroke="currentColor" stroke-linecap="round" stroke-width="4"><rect width="36" height="36" x="6" y="6" stroke-linejoin="round" rx="3" /><path stroke-linejoin="round" d="M14 18h20v10H14z" /><path d="M24 14v21" /></g></symbol><symbol  viewBox="0 0 24 24" id="icon-close"><path d="M19 6.41 17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z" /></symbol><symbol  viewBox="0 0 24 24" id="icon-code"><path d="M9.4 16.6 4.8 12l4.6-4.6L8 6l-6 6 6 6 1.4-1.4zm5.2 0 4.6-4.6-4.6-4.6L16 6l6 6-6 6-1.4-1.4z" /></symbol><symbol viewBox="0 0 24 24" fill="none"  id="icon-dark-mode"><path opacity=".1" d="M20.867 15.316c.052-.118-.066-.238-.188-.194-3.362 1.215-7.23.498-9.767-2.038-2.525-2.525-3.243-6.367-2.05-9.718.049-.139-.088-.273-.222-.213l-.027.012c-1.855.838-3.506 2.252-4.476 4.032a9.335 9.335 0 0 0 2.255 11.664A9.344 9.344 0 0 0 12.332 21a9.344 9.344 0 0 0 5.23-1.601c1.427-.964 2.557-2.423 3.27-4.003l.035-.08Z" /><path d="M20.867 15.316c.052-.118-.066-.238-.188-.194-3.362 1.215-7.23.498-9.767-2.038-2.525-2.525-3.243-6.367-2.05-9.718.049-.139-.088-.273-.222-.213l-.027.012c-1.855.838-3.506 2.252-4.476 4.032a9.335 9.335 0 0 0 2.255 11.664A9.344 9.344 0 0 0 12.332 21a9.344 9.344 0 0 0 5.23-1.601c1.427-.964 2.557-2.423 3.27-4.003l.035-.08Z" /></symbol><symbol viewBox="0 0 24 24" fill="none"  id="icon-diamond"><path d="M12 21v-9m0 9 3-3m-3 3-3-3m3-6V3m0 9H3m9 0h9m-9-9L9 6m3-3 3 3M3 12l3 3m-3-3 3-3m15 3-3-3m3 3-3 3" stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" /></symbol><symbol  viewBox="0 0 48 48" id="icon-english"><g fill="none" stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" stroke-width="4"><rect width="36" height="36" x="6" y="6" rx="3" /><path d="M13 31V17h8m-8 7h7.5M13 31h7.5m5.5 0V19m0 12v-6.5a4.5 4.5 0 0 1 4.5-4.5v0a4.5 4.5 0 0 1 4.5 4.5V31" /></g></symbol><symbol viewBox="0 0 24 24" fill="none"  id="icon-fail"><circle cx="12" cy="12" r="10" /><path d="m14.5 9.5-5 5m0-5 5 5" /></symbol><symbol  viewBox="0 0 248 348" id="icon-finlab"><path d="M145.3 28.8c-7.4 2.7-11.9 6-15.7 11.7-6.2 9.4-7.1 18.9-2.6 29.3 5.5 12.8 21.6 20.8 34.7 17.2 18.4-5.1 28.6-26.2 20.3-42.3-7.2-13.9-23-20.8-36.7-15.9zM104.5 90.5c-4.7 2.5-6.4 4.5-7.6 8.6-1.7 5.4-.4 10.4 3.6 14.4 8.7 8.6 22.9 3.5 24.2-8.8.5-4.9-1.8-10-5.8-13-3.7-2.6-10.6-3.2-14.4-1.2zM114.6 135.7l-2.9.5.7 14.6c.3 8.1 1.1 18.4 1.6 23l.9 8.2-36.7 55.3c-42 63-46.7 70.5-45.7 71.5.3.4 45.4.8 100.1 1 82.3.2 99.4 0 99.4-1.1 0-2.2-11.3-21-45.4-75.7l-32.7-52.5.5-7.5c.4-4.1.9-14.1 1.3-22.1l.6-14.6-3.9-.6c-4.2-.7-33-.7-37.8 0zm32.7 72.3c26.8 42.7 47.7 77.1 47.7 78.6 0 1.6-54.3 2.7-93.3 1.8l-31.6-.7 1.6-3.1c2.6-4.9 47.2-72.7 51-77.4l3.5-4.3 9.1.3 9.2.3 2.8 4.5z" /><path d="M116.3 242.2c-5.4 5.9-21.3 30.3-21.3 32.6 0 .9 9.1 1.2 35.3 1.2 34.7 0 39.7-.3 39.7-2.2 0-2.4-17-25.8-18.8-25.8-.8 0-3.7 2-6.4 4.5-2.8 2.5-5.6 4.5-6.4 4.5-.8 0-5.4-3.8-10.3-8.5-5-4.7-9.2-8.5-9.4-8.5-.2 0-1.3 1-2.4 2.2z" /></symbol><symbol  viewBox="0 0 24 24" id="icon-info"><path d="M11 7h2v2h-2zm0 4h2v6h-2zm1-9C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8z" /></symbol><symbol viewBox="0 0 24 24" fill="none"  id="icon-light-mode"><path opacity=".1" d="M15 12a3 3 0 1 1-6 0 3 3 0 0 1 6 0Z" /><path d="M15 12a3 3 0 1 1-6 0 3 3 0 0 1 6 0ZM12 5V3M17 7l2-2M19 12h2M17 17l2 2M12 19v2M7 17l-2 2M5 12H3M5 5l2 2" /></symbol><symbol  class="h-5 w-5" fill="none" viewBox="0 0 24 24" stroke="currentColor" id="icon-menu"><path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M4 6h16M4 12h8m-8 6h16" /></symbol><symbol  class="h-5 w-5" fill="none" viewBox="0 0 24 24" stroke="currentColor" id="icon-notification"><path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M15 17h5l-1.405-1.405A2.032 2.032 0 0 1 18 14.158V11a6.002 6.002 0 0 0-4-5.659V5a2 2 0 1 0-4 0v.341C7.67 6.165 6 8.388 6 11v3.159c0 .538-.214 1.055-.595 1.436L4 17h5m6 0v1a3 3 0 1 1-6 0v-1m6 0H9" /></symbol><symbol viewBox="0 0 24 24" fill="none"  id="icon-pass"><circle cx="12" cy="12" r="10" /><path d="m8.5 12.5 2 2 5-5" /></symbol><symbol class="w-4 h-4 text-gray-500 dark:text-gray-400" aria-hidden="true"  fill="none" viewBox="0 0 20 20" id="icon-search"><path stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="m19 19-4-4m0-7A7 7 0 1 1 1 8a7 7 0 0 1 14 0Z" /></symbol><symbol viewBox="0 0 24 24" fill="none"  id="icon-shield"><path d="m15 9-4 4-2-2m11-.835c0 6.568-4.968 9.513-7.074 10.466l-.003.002c-.221.1-.332.15-.584.193-.16.028-.518.028-.677 0a2.01 2.01 0 0 1-.588-.195C8.968 19.678 4 16.733 4 10.165V6.2c0-1.12 0-1.68.218-2.108.192-.377.497-.682.874-.874C5.52 3 6.08 3 7.2 3h9.6c1.12 0 1.68 0 2.107.218.377.192.683.497.875.874.218.427.218.987.218 2.105v3.968Z" stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" /></symbol><symbol viewBox="0 0 24 24" fill="none"  id="icon-trophy"><path d="M15 13V9m0 0h-4m4 0-6 6m12-3a9 9 0 1 0-18 0 9 9 0 0 0 18 0Z" stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" /></symbol>';
    body.insertBefore(svgDom, body.lastChild);
  };
  if (document.readyState === "loading") {
    document.addEventListener("DOMContentLoaded", loadSvg);
  } else {
    loadSvg();
  }
}
function get_each_context_2(ctx, list, i) {
  const child_ctx = ctx.slice();
  child_ctx[23] = list[i][0];
  child_ctx[24] = list[i][1];
  child_ctx[27] = list;
  child_ctx[28] = i;
  return child_ctx;
}
function get_each_context(ctx, list, i) {
  const child_ctx = ctx.slice();
  child_ctx[9] = list[i][0];
  child_ctx[20] = list[i][1];
  return child_ctx;
}
function get_each_context_1(ctx, list, i) {
  const child_ctx = ctx.slice();
  child_ctx[23] = list[i][0];
  child_ctx[24] = list[i][1];
  return child_ctx;
}
function get_each_context_3(ctx, list, i) {
  const child_ctx = ctx.slice();
  child_ctx[23] = list[i][0];
  child_ctx[20] = list[i][1];
  return child_ctx;
}
function get_each_context_4(ctx, list, i) {
  const child_ctx = ctx.slice();
  child_ctx[31] = list[i];
  child_ctx[10] = i;
  return child_ctx;
}
function get_each_context_5(ctx, list, i) {
  const child_ctx = ctx.slice();
  child_ctx[33] = list[i];
  return child_ctx;
}
function create_if_block_12(ctx) {
  let div1;
  let div0;
  let svgicon;
  let t_1;
  let current;
  svgicon = new Svgicon$1({
    props: {
      name: "finlab",
      className: "w-8 h-12",
      color: (
        /*theme*/
        ctx[2] === "light" || /*theme*/
        ctx[2] === null ? "rgb(31 41 55)" : "rgb(209 213 219)"
      )
    }
  });
  let each_value_5 = ensure_array_like(
    /*tabs*/
    ctx[12]
  );
  let each_blocks = [];
  for (let i = 0; i < each_value_5.length; i += 1) {
    each_blocks[i] = create_each_block_5(get_each_context_5(ctx, each_value_5, i));
  }
  return {
    c() {
      div1 = element("div");
      div0 = element("div");
      create_component(svgicon.$$.fragment);
      t_1 = space();
      for (let i = 0; i < each_blocks.length; i += 1) {
        each_blocks[i].c();
      }
      attr(div0, "class", "flex gap-4 h-8 items-end");
      attr(div1, "class", "sticky top-0 z-[21] bg-base-200 mb-4");
    },
    m(target, anchor) {
      insert(target, div1, anchor);
      append(div1, div0);
      mount_component(svgicon, div0, null);
      append(div0, t_1);
      for (let i = 0; i < each_blocks.length; i += 1) {
        if (each_blocks[i]) {
          each_blocks[i].m(div0, null);
        }
      }
      current = true;
    },
    p(ctx2, dirty) {
      const svgicon_changes = {};
      if (dirty[0] & /*theme*/
      4)
        svgicon_changes.color = /*theme*/
        ctx2[2] === "light" || /*theme*/
        ctx2[2] === null ? "rgb(31 41 55)" : "rgb(209 213 219)";
      svgicon.$set(svgicon_changes);
      if (dirty[0] & /*currentPanelTab, tabs, sendMessage*/
      12352) {
        each_value_5 = ensure_array_like(
          /*tabs*/
          ctx2[12]
        );
        let i;
        for (i = 0; i < each_value_5.length; i += 1) {
          const child_ctx = get_each_context_5(ctx2, each_value_5, i);
          if (each_blocks[i]) {
            each_blocks[i].p(child_ctx, dirty);
          } else {
            each_blocks[i] = create_each_block_5(child_ctx);
            each_blocks[i].c();
            each_blocks[i].m(div0, null);
          }
        }
        for (; i < each_blocks.length; i += 1) {
          each_blocks[i].d(1);
        }
        each_blocks.length = each_value_5.length;
      }
    },
    i(local) {
      if (current)
        return;
      transition_in(svgicon.$$.fragment, local);
      current = true;
    },
    o(local) {
      transition_out(svgicon.$$.fragment, local);
      current = false;
    },
    d(detaching) {
      if (detaching) {
        detach(div1);
      }
      destroy_component(svgicon);
      destroy_each(each_blocks, detaching);
    }
  };
}
function create_each_block_5(ctx) {
  let button;
  let mounted;
  let dispose;
  function click_handler() {
    return (
      /*click_handler*/
      ctx[14](
        /*t*/
        ctx[33]
      )
    );
  }
  return {
    c() {
      button = element("button");
      button.textContent = `${/*t*/
      ctx[33]}`;
      attr(button, "class", "tab h-12 text-base-content-200");
      toggle_class(
        button,
        "border-b",
        /*currentPanelTab*/
        ctx[6] === /*t*/
        ctx[33]
      );
    },
    m(target, anchor) {
      insert(target, button, anchor);
      if (!mounted) {
        dispose = listen(button, "click", click_handler);
        mounted = true;
      }
    },
    p(new_ctx, dirty) {
      ctx = new_ctx;
      if (dirty[0] & /*currentPanelTab, tabs*/
      4160) {
        toggle_class(
          button,
          "border-b",
          /*currentPanelTab*/
          ctx[6] === /*t*/
          ctx[33]
        );
      }
    },
    d(detaching) {
      if (detaching) {
        detach(button);
      }
      mounted = false;
      dispose();
    }
  };
}
function create_else_block_4(ctx) {
  let div;
  let position2;
  let current;
  position2 = new Position({
    props: {
      reportPosition: (
        /*reportPosition*/
        ctx[4]
      ),
      lang: (
        /*lang*/
        ctx[0]
      )
    }
  });
  return {
    c() {
      div = element("div");
      create_component(position2.$$.fragment);
      attr(div, "class", "pb-8");
    },
    m(target, anchor) {
      insert(target, div, anchor);
      mount_component(position2, div, null);
      current = true;
    },
    p(ctx2, dirty) {
      const position_changes = {};
      if (dirty[0] & /*reportPosition*/
      16)
        position_changes.reportPosition = /*reportPosition*/
        ctx2[4];
      if (dirty[0] & /*lang*/
      1)
        position_changes.lang = /*lang*/
        ctx2[0];
      position2.$set(position_changes);
    },
    i(local) {
      if (current)
        return;
      transition_in(position2.$$.fragment, local);
      current = true;
    },
    o(local) {
      transition_out(position2.$$.fragment, local);
      current = false;
    },
    d(detaching) {
      if (detaching) {
        detach(div);
      }
      destroy_component(position2);
    }
  };
}
function create_if_block(ctx) {
  let if_block_anchor;
  let current;
  let if_block = (
    /*report*/
    ctx[1] && create_if_block_1(ctx)
  );
  return {
    c() {
      if (if_block)
        if_block.c();
      if_block_anchor = empty();
    },
    m(target, anchor) {
      if (if_block)
        if_block.m(target, anchor);
      insert(target, if_block_anchor, anchor);
      current = true;
    },
    p(ctx2, dirty) {
      if (
        /*report*/
        ctx2[1]
      ) {
        if (if_block) {
          if_block.p(ctx2, dirty);
          if (dirty[0] & /*report*/
          2) {
            transition_in(if_block, 1);
          }
        } else {
          if_block = create_if_block_1(ctx2);
          if_block.c();
          transition_in(if_block, 1);
          if_block.m(if_block_anchor.parentNode, if_block_anchor);
        }
      } else if (if_block) {
        group_outros();
        transition_out(if_block, 1, 1, () => {
          if_block = null;
        });
        check_outros();
      }
    },
    i(local) {
      if (current)
        return;
      transition_in(if_block);
      current = true;
    },
    o(local) {
      transition_out(if_block);
      current = false;
    },
    d(detaching) {
      if (detaching) {
        detach(if_block_anchor);
      }
      if (if_block)
        if_block.d(detaching);
    }
  };
}
function create_if_block_1(ctx) {
  let div3;
  let div1;
  let t0;
  let div0;
  let button;
  let t1;
  let button_class_value;
  let t2;
  let current_block_type_index;
  let if_block0;
  let t3;
  let div2;
  let current_block_type_index_1;
  let if_block1;
  let current;
  let mounted;
  let dispose;
  let each_value_3 = ensure_array_like(Object.entries(
    /*report*/
    ctx[1].metrics
  ).filter(func));
  let each_blocks = [];
  for (let i = 0; i < each_value_3.length; i += 1) {
    each_blocks[i] = create_each_block_3(get_each_context_3(ctx, each_value_3, i));
  }
  const if_block_creators = [create_if_block_7, create_else_block_1];
  const if_blocks = [];
  function select_block_type_2(ctx2, dirty) {
    if (
      /*tab*/
      ctx2[9] === "all"
    )
      return 0;
    return 1;
  }
  current_block_type_index = select_block_type_2(ctx);
  if_block0 = if_blocks[current_block_type_index] = if_block_creators[current_block_type_index](ctx);
  const if_block_creators_1 = [
    create_if_block_2,
    create_if_block_3,
    create_if_block_4,
    create_if_block_5,
    create_if_block_6
  ];
  const if_blocks_1 = [];
  function select_block_type_5(ctx2, dirty) {
    if (
      /*tab*/
      ctx2[9] === "profitability"
    )
      return 0;
    if (
      /*tab*/
      ctx2[9] === "risk"
    )
      return 1;
    if (
      /*tab*/
      ctx2[9] === "ratio"
    )
      return 2;
    if (
      /*tab*/
      ctx2[9] === "winrate"
    )
      return 3;
    if (
      /*tab*/
      ctx2[9] === "liquidity"
    )
      return 4;
    return -1;
  }
  if (~(current_block_type_index_1 = select_block_type_5(ctx))) {
    if_block1 = if_blocks_1[current_block_type_index_1] = if_block_creators_1[current_block_type_index_1](ctx);
  }
  return {
    c() {
      div3 = element("div");
      div1 = element("div");
      for (let i = 0; i < each_blocks.length; i += 1) {
        each_blocks[i].c();
      }
      t0 = space();
      div0 = element("div");
      button = element("button");
      t1 = text("指標");
      t2 = space();
      if_block0.c();
      t3 = space();
      div2 = element("div");
      if (if_block1)
        if_block1.c();
      attr(button, "class", button_class_value = "rounded-xl py-2 px-4 " + /*tab*/
      (ctx[9] === "all" ? "bg-primary text-white" : "text-base-content-200 hover:text-base-content-300"));
      attr(div0, "class", "pl-2");
      attr(div1, "class", "items-center flex overflow-x-auto no-scrollbar divide-x gap-2 -ml-2 -mr-2");
      attr(div2, "class", "pb-8");
      attr(div3, "class", "relative ml-4 md:ml-0 h-auto");
    },
    m(target, anchor) {
      insert(target, div3, anchor);
      append(div3, div1);
      for (let i = 0; i < each_blocks.length; i += 1) {
        if (each_blocks[i]) {
          each_blocks[i].m(div1, null);
        }
      }
      append(div1, t0);
      append(div1, div0);
      append(div0, button);
      append(button, t1);
      append(div3, t2);
      if_blocks[current_block_type_index].m(div3, null);
      append(div3, t3);
      append(div3, div2);
      if (~current_block_type_index_1) {
        if_blocks_1[current_block_type_index_1].m(div2, null);
      }
      current = true;
      if (!mounted) {
        dispose = listen(
          button,
          "click",
          /*click_handler_2*/
          ctx[16]
        );
        mounted = true;
      }
    },
    p(ctx2, dirty) {
      if (dirty[0] & /*tab, report, sendMessage, scores, i*/
      9986) {
        each_value_3 = ensure_array_like(Object.entries(
          /*report*/
          ctx2[1].metrics
        ).filter(func));
        let i;
        for (i = 0; i < each_value_3.length; i += 1) {
          const child_ctx = get_each_context_3(ctx2, each_value_3, i);
          if (each_blocks[i]) {
            each_blocks[i].p(child_ctx, dirty);
          } else {
            each_blocks[i] = create_each_block_3(child_ctx);
            each_blocks[i].c();
            each_blocks[i].m(div1, t0);
          }
        }
        for (; i < each_blocks.length; i += 1) {
          each_blocks[i].d(1);
        }
        each_blocks.length = each_value_3.length;
      }
      if (!current || dirty[0] & /*tab*/
      512 && button_class_value !== (button_class_value = "rounded-xl py-2 px-4 " + /*tab*/
      (ctx2[9] === "all" ? "bg-primary text-white" : "text-base-content-200 hover:text-base-content-300"))) {
        attr(button, "class", button_class_value);
      }
      let previous_block_index = current_block_type_index;
      current_block_type_index = select_block_type_2(ctx2);
      if (current_block_type_index === previous_block_index) {
        if_blocks[current_block_type_index].p(ctx2, dirty);
      } else {
        group_outros();
        transition_out(if_blocks[previous_block_index], 1, 1, () => {
          if_blocks[previous_block_index] = null;
        });
        check_outros();
        if_block0 = if_blocks[current_block_type_index];
        if (!if_block0) {
          if_block0 = if_blocks[current_block_type_index] = if_block_creators[current_block_type_index](ctx2);
          if_block0.c();
        } else {
          if_block0.p(ctx2, dirty);
        }
        transition_in(if_block0, 1);
        if_block0.m(div3, t3);
      }
      let previous_block_index_1 = current_block_type_index_1;
      current_block_type_index_1 = select_block_type_5(ctx2);
      if (current_block_type_index_1 === previous_block_index_1) {
        if (~current_block_type_index_1) {
          if_blocks_1[current_block_type_index_1].p(ctx2, dirty);
        }
      } else {
        if (if_block1) {
          group_outros();
          transition_out(if_blocks_1[previous_block_index_1], 1, 1, () => {
            if_blocks_1[previous_block_index_1] = null;
          });
          check_outros();
        }
        if (~current_block_type_index_1) {
          if_block1 = if_blocks_1[current_block_type_index_1];
          if (!if_block1) {
            if_block1 = if_blocks_1[current_block_type_index_1] = if_block_creators_1[current_block_type_index_1](ctx2);
            if_block1.c();
          } else {
            if_block1.p(ctx2, dirty);
          }
          transition_in(if_block1, 1);
          if_block1.m(div2, null);
        } else {
          if_block1 = null;
        }
      }
    },
    i(local) {
      if (current)
        return;
      transition_in(if_block0);
      transition_in(if_block1);
      current = true;
    },
    o(local) {
      transition_out(if_block0);
      transition_out(if_block1);
      current = false;
    },
    d(detaching) {
      if (detaching) {
        detach(div3);
      }
      destroy_each(each_blocks, detaching);
      if_blocks[current_block_type_index].d();
      if (~current_block_type_index_1) {
        if_blocks_1[current_block_type_index_1].d();
      }
      mounted = false;
      dispose();
    }
  };
}
function create_else_block_3(ctx) {
  let input;
  return {
    c() {
      input = element("input");
      attr(input, "type", "radio");
      input.readOnly = true;
      attr(input, "name", "rating-2");
      attr(input, "class", "pointer-events-none mask mask-star-2 bg-base-content/10");
    },
    m(target, anchor) {
      insert(target, input, anchor);
    },
    p: noop$1,
    d(detaching) {
      if (detaching) {
        detach(input);
      }
    }
  };
}
function create_if_block_11(ctx) {
  let input;
  let input_class_value;
  return {
    c() {
      input = element("input");
      attr(input, "type", "radio");
      input.readOnly = true;
      attr(input, "name", "rating-2");
      attr(input, "class", input_class_value = "pointer-events-none mask mask-star-2 " + /*tab*/
      (ctx[9] == /*key*/
      ctx[23] ? "bg-white" : "bg-primary"));
    },
    m(target, anchor) {
      insert(target, input, anchor);
    },
    p(ctx2, dirty) {
      if (dirty[0] & /*tab, report*/
      514 && input_class_value !== (input_class_value = "pointer-events-none mask mask-star-2 " + /*tab*/
      (ctx2[9] == /*key*/
      ctx2[23] ? "bg-white" : "bg-primary"))) {
        attr(input, "class", input_class_value);
      }
    },
    d(detaching) {
      if (detaching) {
        detach(input);
      }
    }
  };
}
function create_each_block_4(ctx) {
  let if_block_anchor;
  function select_block_type_1(ctx2, dirty) {
    if (
      /*i*/
      ctx2[10] * 0.2 < /*scores*/
      ctx2[8][
        /*key*/
        ctx2[23]
      ]
    )
      return create_if_block_11;
    return create_else_block_3;
  }
  let current_block_type = select_block_type_1(ctx);
  let if_block = current_block_type(ctx);
  return {
    c() {
      if_block.c();
      if_block_anchor = empty();
    },
    m(target, anchor) {
      if_block.m(target, anchor);
      insert(target, if_block_anchor, anchor);
    },
    p(ctx2, dirty) {
      if (current_block_type === (current_block_type = select_block_type_1(ctx2)) && if_block) {
        if_block.p(ctx2, dirty);
      } else {
        if_block.d(1);
        if_block = current_block_type(ctx2);
        if (if_block) {
          if_block.c();
          if_block.m(if_block_anchor.parentNode, if_block_anchor);
        }
      }
    },
    d(detaching) {
      if (detaching) {
        detach(if_block_anchor);
      }
      if_block.d(detaching);
    }
  };
}
function create_each_block_3(ctx) {
  let div2;
  let button;
  let span;
  let t0_value = (
    /*i*/
    ctx[10](`tabs.${/*key*/
    ctx[23]}`) + ""
  );
  let t0;
  let t1;
  let div1;
  let div0;
  let button_class_value;
  let mounted;
  let dispose;
  let each_value_4 = ensure_array_like(Array.from({ length: 5 }));
  let each_blocks = [];
  for (let i = 0; i < each_value_4.length; i += 1) {
    each_blocks[i] = create_each_block_4(get_each_context_4(ctx, each_value_4, i));
  }
  function click_handler_1() {
    return (
      /*click_handler_1*/
      ctx[15](
        /*key*/
        ctx[23]
      )
    );
  }
  return {
    c() {
      div2 = element("div");
      button = element("button");
      span = element("span");
      t0 = text(t0_value);
      t1 = space();
      div1 = element("div");
      div0 = element("div");
      for (let i = 0; i < each_blocks.length; i += 1) {
        each_blocks[i].c();
      }
      attr(div0, "class", "rating rating-sm");
      attr(button, "class", button_class_value = `py-2 px-4 ml-2 hover:text-base-content-300 rounded-md ${/*tab*/
      ctx[9] === /*key*/
      ctx[23] ? "bg-primary text-white" : "text-base-content-200"}`);
    },
    m(target, anchor) {
      insert(target, div2, anchor);
      append(div2, button);
      append(button, span);
      append(span, t0);
      append(button, t1);
      append(button, div1);
      append(div1, div0);
      for (let i = 0; i < each_blocks.length; i += 1) {
        if (each_blocks[i]) {
          each_blocks[i].m(div0, null);
        }
      }
      if (!mounted) {
        dispose = listen(button, "click", click_handler_1);
        mounted = true;
      }
    },
    p(new_ctx, dirty) {
      ctx = new_ctx;
      if (dirty[0] & /*i, report*/
      1026 && t0_value !== (t0_value = /*i*/
      ctx[10](`tabs.${/*key*/
      ctx[23]}`) + ""))
        set_data(t0, t0_value);
      if (dirty[0] & /*tab, report, scores*/
      770) {
        each_value_4 = ensure_array_like(Array.from({ length: 5 }));
        let i;
        for (i = 0; i < each_value_4.length; i += 1) {
          const child_ctx = get_each_context_4(ctx, each_value_4, i);
          if (each_blocks[i]) {
            each_blocks[i].p(child_ctx, dirty);
          } else {
            each_blocks[i] = create_each_block_4(child_ctx);
            each_blocks[i].c();
            each_blocks[i].m(div0, null);
          }
        }
        for (; i < each_blocks.length; i += 1) {
          each_blocks[i].d(1);
        }
        each_blocks.length = each_value_4.length;
      }
      if (dirty[0] & /*tab, report*/
      514 && button_class_value !== (button_class_value = `py-2 px-4 ml-2 hover:text-base-content-300 rounded-md ${/*tab*/
      ctx[9] === /*key*/
      ctx[23] ? "bg-primary text-white" : "text-base-content-200"}`)) {
        attr(button, "class", button_class_value);
      }
    },
    d(detaching) {
      if (detaching) {
        detach(div2);
      }
      destroy_each(each_blocks, detaching);
      mounted = false;
      dispose();
    }
  };
}
function create_else_block_1(ctx) {
  let div;
  let current;
  let each_value_2 = ensure_array_like(Object.entries(
    /*report*/
    ctx[1].metrics[
      /*tab*/
      ctx[9]
    ]
  ).splice(0, 6));
  let each_blocks = [];
  for (let i = 0; i < each_value_2.length; i += 1) {
    each_blocks[i] = create_each_block_2(get_each_context_2(ctx, each_value_2, i));
  }
  const out = (i) => transition_out(each_blocks[i], 1, 1, () => {
    each_blocks[i] = null;
  });
  return {
    c() {
      div = element("div");
      for (let i = 0; i < each_blocks.length; i += 1) {
        each_blocks[i].c();
      }
      attr(div, "class", "my-4 flex overflow-x-auto sm:justify-center stats bg-transparent no-scrollbar mb-4 border p-4 min-w-full");
    },
    m(target, anchor) {
      insert(target, div, anchor);
      for (let i = 0; i < each_blocks.length; i += 1) {
        if (each_blocks[i]) {
          each_blocks[i].m(div, null);
        }
      }
      current = true;
    },
    p(ctx2, dirty) {
      if (dirty[0] & /*dialogs, report, tab, i, formatter*/
      3618) {
        each_value_2 = ensure_array_like(Object.entries(
          /*report*/
          ctx2[1].metrics[
            /*tab*/
            ctx2[9]
          ]
        ).splice(0, 6));
        let i;
        for (i = 0; i < each_value_2.length; i += 1) {
          const child_ctx = get_each_context_2(ctx2, each_value_2, i);
          if (each_blocks[i]) {
            each_blocks[i].p(child_ctx, dirty);
            transition_in(each_blocks[i], 1);
          } else {
            each_blocks[i] = create_each_block_2(child_ctx);
            each_blocks[i].c();
            transition_in(each_blocks[i], 1);
            each_blocks[i].m(div, null);
          }
        }
        group_outros();
        for (i = each_value_2.length; i < each_blocks.length; i += 1) {
          out(i);
        }
        check_outros();
      }
    },
    i(local) {
      if (current)
        return;
      for (let i = 0; i < each_value_2.length; i += 1) {
        transition_in(each_blocks[i]);
      }
      current = true;
    },
    o(local) {
      each_blocks = each_blocks.filter(Boolean);
      for (let i = 0; i < each_blocks.length; i += 1) {
        transition_out(each_blocks[i]);
      }
      current = false;
    },
    d(detaching) {
      if (detaching) {
        detach(div);
      }
      destroy_each(each_blocks, detaching);
    }
  };
}
function create_if_block_7(ctx) {
  let div;
  let current;
  let each_value = ensure_array_like(Object.entries(
    /*report*/
    ctx[1].metrics
  ).filter(func_1));
  let each_blocks = [];
  for (let i = 0; i < each_value.length; i += 1) {
    each_blocks[i] = create_each_block(get_each_context(ctx, each_value, i));
  }
  const out = (i) => transition_out(each_blocks[i], 1, 1, () => {
    each_blocks[i] = null;
  });
  return {
    c() {
      div = element("div");
      for (let i = 0; i < each_blocks.length; i += 1) {
        each_blocks[i].c();
      }
      attr(div, "class", "text-base-content-200 grid grid-cols-5 gap-4 p-4 border rounded-xl mt-4");
    },
    m(target, anchor) {
      insert(target, div, anchor);
      for (let i = 0; i < each_blocks.length; i += 1) {
        if (each_blocks[i]) {
          each_blocks[i].m(div, null);
        }
      }
      current = true;
    },
    p(ctx2, dirty) {
      if (dirty[0] & /*report, formatter, i*/
      3074) {
        each_value = ensure_array_like(Object.entries(
          /*report*/
          ctx2[1].metrics
        ).filter(func_1));
        let i;
        for (i = 0; i < each_value.length; i += 1) {
          const child_ctx = get_each_context(ctx2, each_value, i);
          if (each_blocks[i]) {
            each_blocks[i].p(child_ctx, dirty);
            transition_in(each_blocks[i], 1);
          } else {
            each_blocks[i] = create_each_block(child_ctx);
            each_blocks[i].c();
            transition_in(each_blocks[i], 1);
            each_blocks[i].m(div, null);
          }
        }
        group_outros();
        for (i = each_value.length; i < each_blocks.length; i += 1) {
          out(i);
        }
        check_outros();
      }
    },
    i(local) {
      if (current)
        return;
      for (let i = 0; i < each_value.length; i += 1) {
        transition_in(each_blocks[i]);
      }
      current = true;
    },
    o(local) {
      each_blocks = each_blocks.filter(Boolean);
      for (let i = 0; i < each_blocks.length; i += 1) {
        transition_out(each_blocks[i]);
      }
      current = false;
    },
    d(detaching) {
      if (detaching) {
        detach(div);
      }
      destroy_each(each_blocks, detaching);
    }
  };
}
function create_if_block_9(ctx) {
  let button1;
  let div3;
  let div0;
  let show_if;
  let current_block_type_index;
  let if_block;
  let t0;
  let div1;
  let t1_value = (
    /*i*/
    ctx[10](`metrics.${/*tab*/
    ctx[9]}.${/*key*/
    ctx[23]}`) + ""
  );
  let t1;
  let t2;
  let div2;
  let span0;
  let t3_value = (
    /*formatter*/
    ctx[11].format(
      /*key*/
      ctx[23],
      /*val*/
      ctx[24]
    ) + ""
  );
  let t3;
  let t4;
  let span1;
  let t5_value = (
    /*formatter*/
    ctx[11].getUnit(
      /*key*/
      ctx[23]
    ) + ""
  );
  let t5;
  let t6;
  let dialog;
  let form0;
  let h30;
  let t7_value = (
    /*i*/
    ctx[10](`metrics.${/*tab*/
    ctx[9]}.${/*key*/
    ctx[23]}`) + ""
  );
  let t7;
  let t8;
  let p0;
  let t9_value = (
    /*i*/
    ctx[10](`metric.description.${/*tab*/
    ctx[9]}.${/*key*/
    ctx[23]}`) + ""
  );
  let t9;
  let t10;
  let h31;
  let t11_value = (
    /*i*/
    ctx[10]("metrics.condition") + ""
  );
  let t11;
  let t12;
  let p1;
  let t13_value = qualityMetrics[
    /*tab*/
    ctx[9]
  ][
    /*key*/
    ctx[23]
  ].toString().split("=>")[1] + "";
  let t13;
  let t14;
  let form1;
  let key = (
    /*key*/
    ctx[23]
  );
  let t16;
  let current;
  let mounted;
  let dispose;
  const if_block_creators = [create_if_block_10, create_else_block_2];
  const if_blocks = [];
  function select_block_type_4(ctx2, dirty) {
    if (dirty[0] & /*tab, report*/
    514)
      show_if = null;
    if (show_if == null)
      show_if = !!qualityMetrics[
        /*tab*/
        ctx2[9]
      ][
        /*key*/
        ctx2[23]
      ](
        /*val*/
        ctx2[24]
      );
    if (show_if)
      return 0;
    return 1;
  }
  current_block_type_index = select_block_type_4(ctx, [-1, -1]);
  if_block = if_blocks[current_block_type_index] = if_block_creators[current_block_type_index](ctx);
  const assign_dialog = () => (
    /*dialog_binding*/
    ctx[17](dialog, key)
  );
  const unassign_dialog = () => (
    /*dialog_binding*/
    ctx[17](null, key)
  );
  function click_handler_3() {
    return (
      /*click_handler_3*/
      ctx[18](
        /*key*/
        ctx[23]
      )
    );
  }
  return {
    c() {
      button1 = element("button");
      div3 = element("div");
      div0 = element("div");
      if_block.c();
      t0 = space();
      div1 = element("div");
      t1 = text(t1_value);
      t2 = space();
      div2 = element("div");
      span0 = element("span");
      t3 = text(t3_value);
      t4 = space();
      span1 = element("span");
      t5 = text(t5_value);
      t6 = space();
      dialog = element("dialog");
      form0 = element("form");
      h30 = element("h3");
      t7 = text(t7_value);
      t8 = space();
      p0 = element("p");
      t9 = text(t9_value);
      t10 = space();
      h31 = element("h3");
      t11 = text(t11_value);
      t12 = space();
      p1 = element("p");
      t13 = text(t13_value);
      t14 = space();
      form1 = element("form");
      form1.innerHTML = `<button>close</button>`;
      t16 = space();
      attr(div0, "class", "flex justify-center w-full");
      attr(div1, "class", "mt-1 text-base-content-300 text-sm whitespace-no-wrap break-keep whitespace-nowrap overflow-hidden truncate stat-title");
      attr(span0, "class", "font-bold");
      attr(span1, "class", "text-sm");
      attr(div2, "class", "stat-value text-base-content-200 mt-2");
      attr(div3, "class", "text-center px-4");
      attr(h30, "class", "font-bold text-lg");
      attr(h31, "class", "font-bold text-lg mt-4");
      attr(form0, "method", "dialog");
      attr(form0, "class", "modal-box border border-base-content/30");
      attr(form1, "method", "dialog");
      attr(form1, "class", "modal-backdrop");
      attr(dialog, "class", "modal text-base-content-300 text-left");
      attr(button1, "class", "flex-1 border-base-content/10");
    },
    m(target, anchor) {
      insert(target, button1, anchor);
      append(button1, div3);
      append(div3, div0);
      if_blocks[current_block_type_index].m(div0, null);
      append(div3, t0);
      append(div3, div1);
      append(div1, t1);
      append(div3, t2);
      append(div3, div2);
      append(div2, span0);
      append(span0, t3);
      append(div2, t4);
      append(div2, span1);
      append(span1, t5);
      append(button1, t6);
      append(button1, dialog);
      append(dialog, form0);
      append(form0, h30);
      append(h30, t7);
      append(form0, t8);
      append(form0, p0);
      append(p0, t9);
      append(form0, t10);
      append(form0, h31);
      append(h31, t11);
      append(form0, t12);
      append(form0, p1);
      append(p1, t13);
      append(dialog, t14);
      append(dialog, form1);
      assign_dialog();
      append(button1, t16);
      current = true;
      if (!mounted) {
        dispose = listen(button1, "click", click_handler_3);
        mounted = true;
      }
    },
    p(new_ctx, dirty) {
      ctx = new_ctx;
      let previous_block_index = current_block_type_index;
      current_block_type_index = select_block_type_4(ctx, dirty);
      if (current_block_type_index === previous_block_index) {
        if_blocks[current_block_type_index].p(ctx, dirty);
      } else {
        group_outros();
        transition_out(if_blocks[previous_block_index], 1, 1, () => {
          if_blocks[previous_block_index] = null;
        });
        check_outros();
        if_block = if_blocks[current_block_type_index];
        if (!if_block) {
          if_block = if_blocks[current_block_type_index] = if_block_creators[current_block_type_index](ctx);
          if_block.c();
        } else {
          if_block.p(ctx, dirty);
        }
        transition_in(if_block, 1);
        if_block.m(div0, null);
      }
      if ((!current || dirty[0] & /*i, tab, report*/
      1538) && t1_value !== (t1_value = /*i*/
      ctx[10](`metrics.${/*tab*/
      ctx[9]}.${/*key*/
      ctx[23]}`) + ""))
        set_data(t1, t1_value);
      if ((!current || dirty[0] & /*report, tab*/
      514) && t3_value !== (t3_value = /*formatter*/
      ctx[11].format(
        /*key*/
        ctx[23],
        /*val*/
        ctx[24]
      ) + ""))
        set_data(t3, t3_value);
      if ((!current || dirty[0] & /*report, tab*/
      514) && t5_value !== (t5_value = /*formatter*/
      ctx[11].getUnit(
        /*key*/
        ctx[23]
      ) + ""))
        set_data(t5, t5_value);
      if ((!current || dirty[0] & /*i, tab, report*/
      1538) && t7_value !== (t7_value = /*i*/
      ctx[10](`metrics.${/*tab*/
      ctx[9]}.${/*key*/
      ctx[23]}`) + ""))
        set_data(t7, t7_value);
      if ((!current || dirty[0] & /*i, tab, report*/
      1538) && t9_value !== (t9_value = /*i*/
      ctx[10](`metric.description.${/*tab*/
      ctx[9]}.${/*key*/
      ctx[23]}`) + ""))
        set_data(t9, t9_value);
      if ((!current || dirty[0] & /*i*/
      1024) && t11_value !== (t11_value = /*i*/
      ctx[10]("metrics.condition") + ""))
        set_data(t11, t11_value);
      if ((!current || dirty[0] & /*tab, report*/
      514) && t13_value !== (t13_value = qualityMetrics[
        /*tab*/
        ctx[9]
      ][
        /*key*/
        ctx[23]
      ].toString().split("=>")[1] + ""))
        set_data(t13, t13_value);
      if (key !== /*key*/
      ctx[23]) {
        unassign_dialog();
        key = /*key*/
        ctx[23];
        assign_dialog();
      }
    },
    i(local) {
      if (current)
        return;
      transition_in(if_block);
      current = true;
    },
    o(local) {
      transition_out(if_block);
      current = false;
    },
    d(detaching) {
      if (detaching) {
        detach(button1);
      }
      if_blocks[current_block_type_index].d();
      unassign_dialog();
      mounted = false;
      dispose();
    }
  };
}
function create_else_block_2(ctx) {
  let svgicon;
  let current;
  svgicon = new Svgicon$1({
    props: {
      name: "fail",
      className: "w-6 h-6",
      strokeColor: riseHex("red")
    }
  });
  return {
    c() {
      create_component(svgicon.$$.fragment);
    },
    m(target, anchor) {
      mount_component(svgicon, target, anchor);
      current = true;
    },
    p: noop$1,
    i(local) {
      if (current)
        return;
      transition_in(svgicon.$$.fragment, local);
      current = true;
    },
    o(local) {
      transition_out(svgicon.$$.fragment, local);
      current = false;
    },
    d(detaching) {
      destroy_component(svgicon, detaching);
    }
  };
}
function create_if_block_10(ctx) {
  let svgicon;
  let current;
  svgicon = new Svgicon$1({
    props: {
      name: "pass",
      className: "w-6 h-6",
      strokeColor: riseHex("green")
    }
  });
  return {
    c() {
      create_component(svgicon.$$.fragment);
    },
    m(target, anchor) {
      mount_component(svgicon, target, anchor);
      current = true;
    },
    p: noop$1,
    i(local) {
      if (current)
        return;
      transition_in(svgicon.$$.fragment, local);
      current = true;
    },
    o(local) {
      transition_out(svgicon.$$.fragment, local);
      current = false;
    },
    d(detaching) {
      destroy_component(svgicon, detaching);
    }
  };
}
function create_each_block_2(ctx) {
  var _a;
  let if_block_anchor;
  let current;
  let if_block = ((_a = qualityMetrics[
    /*tab*/
    ctx[9]
  ]) == null ? void 0 : _a[
    /*key*/
    ctx[23]
  ]) && create_if_block_9(ctx);
  return {
    c() {
      if (if_block)
        if_block.c();
      if_block_anchor = empty();
    },
    m(target, anchor) {
      if (if_block)
        if_block.m(target, anchor);
      insert(target, if_block_anchor, anchor);
      current = true;
    },
    p(ctx2, dirty) {
      var _a2;
      if ((_a2 = qualityMetrics[
        /*tab*/
        ctx2[9]
      ]) == null ? void 0 : _a2[
        /*key*/
        ctx2[23]
      ]) {
        if (if_block) {
          if_block.p(ctx2, dirty);
          if (dirty[0] & /*tab, report*/
          514) {
            transition_in(if_block, 1);
          }
        } else {
          if_block = create_if_block_9(ctx2);
          if_block.c();
          transition_in(if_block, 1);
          if_block.m(if_block_anchor.parentNode, if_block_anchor);
        }
      } else if (if_block) {
        group_outros();
        transition_out(if_block, 1, 1, () => {
          if_block = null;
        });
        check_outros();
      }
    },
    i(local) {
      if (current)
        return;
      transition_in(if_block);
      current = true;
    },
    o(local) {
      transition_out(if_block);
      current = false;
    },
    d(detaching) {
      if (detaching) {
        detach(if_block_anchor);
      }
      if (if_block)
        if_block.d(detaching);
    }
  };
}
function create_else_block(ctx) {
  let svgicon;
  let current;
  svgicon = new Svgicon$1({
    props: {
      name: "fail",
      className: "w-6 h-6",
      strokeColor: riseHex("red")
    }
  });
  return {
    c() {
      create_component(svgicon.$$.fragment);
    },
    m(target, anchor) {
      mount_component(svgicon, target, anchor);
      current = true;
    },
    p: noop$1,
    i(local) {
      if (current)
        return;
      transition_in(svgicon.$$.fragment, local);
      current = true;
    },
    o(local) {
      transition_out(svgicon.$$.fragment, local);
      current = false;
    },
    d(detaching) {
      destroy_component(svgicon, detaching);
    }
  };
}
function create_if_block_8(ctx) {
  let svgicon;
  let current;
  svgicon = new Svgicon$1({
    props: {
      name: "pass",
      className: "w-6 h-6",
      strokeColor: riseHex("green")
    }
  });
  return {
    c() {
      create_component(svgicon.$$.fragment);
    },
    m(target, anchor) {
      mount_component(svgicon, target, anchor);
      current = true;
    },
    p: noop$1,
    i(local) {
      if (current)
        return;
      transition_in(svgicon.$$.fragment, local);
      current = true;
    },
    o(local) {
      transition_out(svgicon.$$.fragment, local);
      current = false;
    },
    d(detaching) {
      destroy_component(svgicon, detaching);
    }
  };
}
function create_each_block_1(ctx) {
  let div3;
  let div0;
  let show_if;
  let current_block_type_index;
  let if_block;
  let t0;
  let div1;
  let t1_value = (
    /*i*/
    ctx[10](`metrics.${/*tab*/
    ctx[9]}.${/*key*/
    ctx[23]}`) + ""
  );
  let t1;
  let t2;
  let div2;
  let span0;
  let t3_value = (
    /*formatter*/
    ctx[11].format(
      /*key*/
      ctx[23],
      /*val*/
      ctx[24]
    ) + ""
  );
  let t3;
  let span1;
  let t4_value = (
    /*formatter*/
    ctx[11].getUnit(
      /*key*/
      ctx[23]
    ) + ""
  );
  let t4;
  let t5;
  let current;
  const if_block_creators = [create_if_block_8, create_else_block];
  const if_blocks = [];
  function select_block_type_3(ctx2, dirty) {
    if (dirty[0] & /*report*/
    2)
      show_if = null;
    if (show_if == null)
      show_if = !!/*tab*/
      (ctx2[9] in qualityMetrics && /*key*/
      ctx2[23] in qualityMetrics[
        /*tab*/
        ctx2[9]
      ] && qualityMetrics[
        /*tab*/
        ctx2[9]
      ][
        /*key*/
        ctx2[23]
      ](
        /*val*/
        ctx2[24]
      ));
    if (show_if)
      return 0;
    return 1;
  }
  current_block_type_index = select_block_type_3(ctx, [-1, -1]);
  if_block = if_blocks[current_block_type_index] = if_block_creators[current_block_type_index](ctx);
  return {
    c() {
      div3 = element("div");
      div0 = element("div");
      if_block.c();
      t0 = space();
      div1 = element("div");
      t1 = text(t1_value);
      t2 = space();
      div2 = element("div");
      span0 = element("span");
      t3 = text(t3_value);
      span1 = element("span");
      t4 = text(t4_value);
      t5 = space();
      attr(div0, "class", "flex justify-center w-full");
      attr(div1, "class", "mt-1 text-base-content-300 text-sm whitespace-no-wrap break-keep whitespace-nowrap overflow-hidden truncate stat-title");
      attr(span0, "class", "font-bold");
      attr(span1, "class", "text-sm");
      attr(div2, "class", "text-2xl text-base-content-200 mt-2");
      attr(div3, "class", "text-center px-4");
    },
    m(target, anchor) {
      insert(target, div3, anchor);
      append(div3, div0);
      if_blocks[current_block_type_index].m(div0, null);
      append(div3, t0);
      append(div3, div1);
      append(div1, t1);
      append(div3, t2);
      append(div3, div2);
      append(div2, span0);
      append(span0, t3);
      append(div2, span1);
      append(span1, t4);
      append(div3, t5);
      current = true;
    },
    p(ctx2, dirty) {
      let previous_block_index = current_block_type_index;
      current_block_type_index = select_block_type_3(ctx2, dirty);
      if (current_block_type_index === previous_block_index) {
        if_blocks[current_block_type_index].p(ctx2, dirty);
      } else {
        group_outros();
        transition_out(if_blocks[previous_block_index], 1, 1, () => {
          if_blocks[previous_block_index] = null;
        });
        check_outros();
        if_block = if_blocks[current_block_type_index];
        if (!if_block) {
          if_block = if_blocks[current_block_type_index] = if_block_creators[current_block_type_index](ctx2);
          if_block.c();
        } else {
          if_block.p(ctx2, dirty);
        }
        transition_in(if_block, 1);
        if_block.m(div0, null);
      }
      if ((!current || dirty[0] & /*i, report*/
      1026) && t1_value !== (t1_value = /*i*/
      ctx2[10](`metrics.${/*tab*/
      ctx2[9]}.${/*key*/
      ctx2[23]}`) + ""))
        set_data(t1, t1_value);
      if ((!current || dirty[0] & /*report*/
      2) && t3_value !== (t3_value = /*formatter*/
      ctx2[11].format(
        /*key*/
        ctx2[23],
        /*val*/
        ctx2[24]
      ) + ""))
        set_data(t3, t3_value);
      if ((!current || dirty[0] & /*report*/
      2) && t4_value !== (t4_value = /*formatter*/
      ctx2[11].getUnit(
        /*key*/
        ctx2[23]
      ) + ""))
        set_data(t4, t4_value);
    },
    i(local) {
      if (current)
        return;
      transition_in(if_block);
      current = true;
    },
    o(local) {
      transition_out(if_block);
      current = false;
    },
    d(detaching) {
      if (detaching) {
        detach(div3);
      }
      if_blocks[current_block_type_index].d();
    }
  };
}
function create_each_block(ctx) {
  let each_1_anchor;
  let current;
  let each_value_1 = ensure_array_like(Object.entries(
    /*report*/
    ctx[1].metrics[
      /*tab*/
      ctx[9]
    ]
  ).splice(0, 6));
  let each_blocks = [];
  for (let i = 0; i < each_value_1.length; i += 1) {
    each_blocks[i] = create_each_block_1(get_each_context_1(ctx, each_value_1, i));
  }
  const out = (i) => transition_out(each_blocks[i], 1, 1, () => {
    each_blocks[i] = null;
  });
  return {
    c() {
      for (let i = 0; i < each_blocks.length; i += 1) {
        each_blocks[i].c();
      }
      each_1_anchor = empty();
    },
    m(target, anchor) {
      for (let i = 0; i < each_blocks.length; i += 1) {
        if (each_blocks[i]) {
          each_blocks[i].m(target, anchor);
        }
      }
      insert(target, each_1_anchor, anchor);
      current = true;
    },
    p(ctx2, dirty) {
      if (dirty[0] & /*formatter, report, i*/
      3074) {
        each_value_1 = ensure_array_like(Object.entries(
          /*report*/
          ctx2[1].metrics[
            /*tab*/
            ctx2[9]
          ]
        ).splice(0, 6));
        let i;
        for (i = 0; i < each_value_1.length; i += 1) {
          const child_ctx = get_each_context_1(ctx2, each_value_1, i);
          if (each_blocks[i]) {
            each_blocks[i].p(child_ctx, dirty);
            transition_in(each_blocks[i], 1);
          } else {
            each_blocks[i] = create_each_block_1(child_ctx);
            each_blocks[i].c();
            transition_in(each_blocks[i], 1);
            each_blocks[i].m(each_1_anchor.parentNode, each_1_anchor);
          }
        }
        group_outros();
        for (i = each_value_1.length; i < each_blocks.length; i += 1) {
          out(i);
        }
        check_outros();
      }
    },
    i(local) {
      if (current)
        return;
      for (let i = 0; i < each_value_1.length; i += 1) {
        transition_in(each_blocks[i]);
      }
      current = true;
    },
    o(local) {
      each_blocks = each_blocks.filter(Boolean);
      for (let i = 0; i < each_blocks.length; i += 1) {
        transition_out(each_blocks[i]);
      }
      current = false;
    },
    d(detaching) {
      if (detaching) {
        detach(each_1_anchor);
      }
      destroy_each(each_blocks, detaching);
    }
  };
}
function create_if_block_6(ctx) {
  let liquidity;
  let current;
  liquidity = new Liquidity({
    props: {
      report: (
        /*report*/
        ctx[1]
      ),
      browser: (
        /*browser*/
        ctx[3]
      ),
      theme: (
        /*theme*/
        ctx[2]
      ),
      lang: (
        /*lang*/
        ctx[0]
      )
    }
  });
  return {
    c() {
      create_component(liquidity.$$.fragment);
    },
    m(target, anchor) {
      mount_component(liquidity, target, anchor);
      current = true;
    },
    p(ctx2, dirty) {
      const liquidity_changes = {};
      if (dirty[0] & /*report*/
      2)
        liquidity_changes.report = /*report*/
        ctx2[1];
      if (dirty[0] & /*browser*/
      8)
        liquidity_changes.browser = /*browser*/
        ctx2[3];
      if (dirty[0] & /*theme*/
      4)
        liquidity_changes.theme = /*theme*/
        ctx2[2];
      if (dirty[0] & /*lang*/
      1)
        liquidity_changes.lang = /*lang*/
        ctx2[0];
      liquidity.$set(liquidity_changes);
    },
    i(local) {
      if (current)
        return;
      transition_in(liquidity.$$.fragment, local);
      current = true;
    },
    o(local) {
      transition_out(liquidity.$$.fragment, local);
      current = false;
    },
    d(detaching) {
      destroy_component(liquidity, detaching);
    }
  };
}
function create_if_block_5(ctx) {
  let winrate;
  let current;
  winrate = new Winrate({
    props: {
      report: (
        /*report*/
        ctx[1]
      ),
      browser: (
        /*browser*/
        ctx[3]
      ),
      theme: (
        /*theme*/
        ctx[2]
      ),
      lang: (
        /*lang*/
        ctx[0]
      )
    }
  });
  return {
    c() {
      create_component(winrate.$$.fragment);
    },
    m(target, anchor) {
      mount_component(winrate, target, anchor);
      current = true;
    },
    p(ctx2, dirty) {
      const winrate_changes = {};
      if (dirty[0] & /*report*/
      2)
        winrate_changes.report = /*report*/
        ctx2[1];
      if (dirty[0] & /*browser*/
      8)
        winrate_changes.browser = /*browser*/
        ctx2[3];
      if (dirty[0] & /*theme*/
      4)
        winrate_changes.theme = /*theme*/
        ctx2[2];
      if (dirty[0] & /*lang*/
      1)
        winrate_changes.lang = /*lang*/
        ctx2[0];
      winrate.$set(winrate_changes);
    },
    i(local) {
      if (current)
        return;
      transition_in(winrate.$$.fragment, local);
      current = true;
    },
    o(local) {
      transition_out(winrate.$$.fragment, local);
      current = false;
    },
    d(detaching) {
      destroy_component(winrate, detaching);
    }
  };
}
function create_if_block_4(ctx) {
  let ratio;
  let current;
  ratio = new Ratio({
    props: {
      report: (
        /*report*/
        ctx[1]
      ),
      browser: (
        /*browser*/
        ctx[3]
      ),
      theme: (
        /*theme*/
        ctx[2]
      ),
      lang: (
        /*lang*/
        ctx[0]
      )
    }
  });
  return {
    c() {
      create_component(ratio.$$.fragment);
    },
    m(target, anchor) {
      mount_component(ratio, target, anchor);
      current = true;
    },
    p(ctx2, dirty) {
      const ratio_changes = {};
      if (dirty[0] & /*report*/
      2)
        ratio_changes.report = /*report*/
        ctx2[1];
      if (dirty[0] & /*browser*/
      8)
        ratio_changes.browser = /*browser*/
        ctx2[3];
      if (dirty[0] & /*theme*/
      4)
        ratio_changes.theme = /*theme*/
        ctx2[2];
      if (dirty[0] & /*lang*/
      1)
        ratio_changes.lang = /*lang*/
        ctx2[0];
      ratio.$set(ratio_changes);
    },
    i(local) {
      if (current)
        return;
      transition_in(ratio.$$.fragment, local);
      current = true;
    },
    o(local) {
      transition_out(ratio.$$.fragment, local);
      current = false;
    },
    d(detaching) {
      destroy_component(ratio, detaching);
    }
  };
}
function create_if_block_3(ctx) {
  let risk;
  let current;
  risk = new Risk({
    props: {
      report: (
        /*report*/
        ctx[1]
      ),
      browser: (
        /*browser*/
        ctx[3]
      ),
      theme: (
        /*theme*/
        ctx[2]
      ),
      lang: (
        /*lang*/
        ctx[0]
      )
    }
  });
  return {
    c() {
      create_component(risk.$$.fragment);
    },
    m(target, anchor) {
      mount_component(risk, target, anchor);
      current = true;
    },
    p(ctx2, dirty) {
      const risk_changes = {};
      if (dirty[0] & /*report*/
      2)
        risk_changes.report = /*report*/
        ctx2[1];
      if (dirty[0] & /*browser*/
      8)
        risk_changes.browser = /*browser*/
        ctx2[3];
      if (dirty[0] & /*theme*/
      4)
        risk_changes.theme = /*theme*/
        ctx2[2];
      if (dirty[0] & /*lang*/
      1)
        risk_changes.lang = /*lang*/
        ctx2[0];
      risk.$set(risk_changes);
    },
    i(local) {
      if (current)
        return;
      transition_in(risk.$$.fragment, local);
      current = true;
    },
    o(local) {
      transition_out(risk.$$.fragment, local);
      current = false;
    },
    d(detaching) {
      destroy_component(risk, detaching);
    }
  };
}
function create_if_block_2(ctx) {
  let profitability2;
  let current;
  profitability2 = new Profitability({
    props: {
      report: (
        /*report*/
        ctx[1]
      ),
      browser: (
        /*browser*/
        ctx[3]
      ),
      theme: (
        /*theme*/
        ctx[2]
      ),
      lang: (
        /*lang*/
        ctx[0]
      )
    }
  });
  return {
    c() {
      create_component(profitability2.$$.fragment);
    },
    m(target, anchor) {
      mount_component(profitability2, target, anchor);
      current = true;
    },
    p(ctx2, dirty) {
      const profitability_changes = {};
      if (dirty[0] & /*report*/
      2)
        profitability_changes.report = /*report*/
        ctx2[1];
      if (dirty[0] & /*browser*/
      8)
        profitability_changes.browser = /*browser*/
        ctx2[3];
      if (dirty[0] & /*theme*/
      4)
        profitability_changes.theme = /*theme*/
        ctx2[2];
      if (dirty[0] & /*lang*/
      1)
        profitability_changes.lang = /*lang*/
        ctx2[0];
      profitability2.$set(profitability_changes);
    },
    i(local) {
      if (current)
        return;
      transition_in(profitability2.$$.fragment, local);
      current = true;
    },
    o(local) {
      transition_out(profitability2.$$.fragment, local);
      current = false;
    },
    d(detaching) {
      destroy_component(profitability2, detaching);
    }
  };
}
function create_fragment$1(ctx) {
  let div;
  let t_1;
  let current_block_type_index;
  let if_block1;
  let current;
  let if_block0 = (
    /*reportPosition*/
    ctx[4] && create_if_block_12(ctx)
  );
  const if_block_creators = [create_if_block, create_else_block_4];
  const if_blocks = [];
  function select_block_type(ctx2, dirty) {
    if (
      /*currentPanelTab*/
      ctx2[6] === "分析"
    )
      return 0;
    return 1;
  }
  current_block_type_index = select_block_type(ctx);
  if_block1 = if_blocks[current_block_type_index] = if_block_creators[current_block_type_index](ctx);
  return {
    c() {
      div = element("div");
      if (if_block0)
        if_block0.c();
      t_1 = space();
      if_block1.c();
    },
    m(target, anchor) {
      insert(target, div, anchor);
      if (if_block0)
        if_block0.m(div, null);
      append(div, t_1);
      if_blocks[current_block_type_index].m(div, null);
      ctx[19](div);
      current = true;
    },
    p(ctx2, dirty) {
      if (
        /*reportPosition*/
        ctx2[4]
      ) {
        if (if_block0) {
          if_block0.p(ctx2, dirty);
          if (dirty[0] & /*reportPosition*/
          16) {
            transition_in(if_block0, 1);
          }
        } else {
          if_block0 = create_if_block_12(ctx2);
          if_block0.c();
          transition_in(if_block0, 1);
          if_block0.m(div, t_1);
        }
      } else if (if_block0) {
        group_outros();
        transition_out(if_block0, 1, 1, () => {
          if_block0 = null;
        });
        check_outros();
      }
      let previous_block_index = current_block_type_index;
      current_block_type_index = select_block_type(ctx2);
      if (current_block_type_index === previous_block_index) {
        if_blocks[current_block_type_index].p(ctx2, dirty);
      } else {
        group_outros();
        transition_out(if_blocks[previous_block_index], 1, 1, () => {
          if_blocks[previous_block_index] = null;
        });
        check_outros();
        if_block1 = if_blocks[current_block_type_index];
        if (!if_block1) {
          if_block1 = if_blocks[current_block_type_index] = if_block_creators[current_block_type_index](ctx2);
          if_block1.c();
        } else {
          if_block1.p(ctx2, dirty);
        }
        transition_in(if_block1, 1);
        if_block1.m(div, null);
      }
    },
    i(local) {
      if (current)
        return;
      transition_in(if_block0);
      transition_in(if_block1);
      current = true;
    },
    o(local) {
      transition_out(if_block0);
      transition_out(if_block1);
      current = false;
    },
    d(detaching) {
      if (detaching) {
        detach(div);
      }
      if (if_block0)
        if_block0.d();
      if_blocks[current_block_type_index].d();
      ctx[19](null);
    }
  };
}
const func = (v2) => v2[0] !== "backtest";
const func_1 = (v2) => v2[0] !== "backtest";
function instance$1($$self, $$props, $$invalidate) {
  let i;
  let scores;
  let { lang = "en" } = $$props;
  let { report = null } = $$props;
  let { theme = "light" } = $$props;
  let { browser = true } = $$props;
  let { reportPosition = null } = $$props;
  const formatter = new MetricDisplay();
  let tab = localStorage.getItem("strategyAnalyticTab") || "profitability";
  let dialogs = {};
  let tabs2 = ["分析", "選股"];
  let currentPanelTab = "分析";
  onMount(async () => {
    await sendMessage();
  });
  async function sendMessage() {
    await tick();
    await new Promise((resolve2) => setTimeout(resolve2, 500));
    let targetHeight = analyticDom.scrollHeight;
    window.parent.postMessage(
      {
        frameHeight: targetHeight,
        tab: currentPanelTab + " " + tab
      },
      "*"
    );
  }
  let analyticDom;
  const click_handler = (t) => {
    $$invalidate(6, currentPanelTab = t);
    sendMessage();
  };
  const click_handler_1 = (key) => {
    $$invalidate(9, tab = key);
    localStorage.setItem("strategyAnalyticTab", key);
    sendMessage();
  };
  const click_handler_2 = () => {
    $$invalidate(9, tab = "all");
    localStorage.setItem("strategyAnalyticTab", "all");
    sendMessage();
  };
  function dialog_binding($$value, key) {
    binding_callbacks[$$value ? "unshift" : "push"](() => {
      dialogs[key] = $$value;
      $$invalidate(5, dialogs);
    });
  }
  const click_handler_3 = (key) => {
    dialogs[key].showModal();
  };
  function div_binding($$value) {
    binding_callbacks[$$value ? "unshift" : "push"](() => {
      analyticDom = $$value;
      $$invalidate(7, analyticDom);
    });
  }
  $$self.$$set = ($$props2) => {
    if ("lang" in $$props2)
      $$invalidate(0, lang = $$props2.lang);
    if ("report" in $$props2)
      $$invalidate(1, report = $$props2.report);
    if ("theme" in $$props2)
      $$invalidate(2, theme = $$props2.theme);
    if ("browser" in $$props2)
      $$invalidate(3, browser = $$props2.browser);
    if ("reportPosition" in $$props2)
      $$invalidate(4, reportPosition = $$props2.reportPosition);
  };
  $$self.$$.update = () => {
    if ($$self.$$.dirty[0] & /*lang*/
    1) {
      $$invalidate(10, i = (key) => lang === "en" ? ien(key) : itw(key));
    }
    if ($$self.$$.dirty[0] & /*report*/
    2) {
      $$invalidate(8, scores = report ? calculateScores(report.metrics) : {});
    }
  };
  return [
    lang,
    report,
    theme,
    browser,
    reportPosition,
    dialogs,
    currentPanelTab,
    analyticDom,
    scores,
    tab,
    i,
    formatter,
    tabs2,
    sendMessage,
    click_handler,
    click_handler_1,
    click_handler_2,
    dialog_binding,
    click_handler_3,
    div_binding
  ];
}
class StrategyAnalytic extends SvelteComponent {
  constructor(options) {
    super();
    init(
      this,
      options,
      instance$1,
      create_fragment$1,
      safe_not_equal,
      {
        lang: 0,
        report: 1,
        theme: 2,
        browser: 3,
        reportPosition: 4
      },
      null,
      [-1, -1]
    );
  }
  get lang() {
    return this.$$.ctx[0];
  }
  set lang(lang) {
    this.$$set({ lang });
    flush();
  }
  get report() {
    return this.$$.ctx[1];
  }
  set report(report) {
    this.$$set({ report });
    flush();
  }
  get theme() {
    return this.$$.ctx[2];
  }
  set theme(theme) {
    this.$$set({ theme });
    flush();
  }
  get browser() {
    return this.$$.ctx[3];
  }
  set browser(browser) {
    this.$$set({ browser });
    flush();
  }
  get reportPosition() {
    return this.$$.ctx[4];
  }
  set reportPosition(reportPosition) {
    this.$$set({ reportPosition });
    flush();
  }
}
customElements.define("strategy-analytic", create_custom_element(StrategyAnalytic, { "lang": {}, "report": { "type": "Object", "reflect": true }, "theme": { "type": "String", "reflect": true }, "browser": { "type": "Boolean", "reflect": true }, "reportPosition": {} }, [], [], false));
function create_fragment(ctx) {
  let svg;
  let use;
  return {
    c() {
      svg = svg_element("svg");
      use = svg_element("use");
      attr(
        use,
        "href",
        /*symbolId*/
        ctx[3]
      );
      attr(
        use,
        "fill",
        /*color*/
        ctx[0]
      );
      attr(
        use,
        "stroke",
        /*strokeColor*/
        ctx[1]
      );
      attr(
        svg,
        "class",
        /*className*/
        ctx[2]
      );
      attr(svg, "aria-hidden", "true");
    },
    m(target, anchor) {
      insert(target, svg, anchor);
      append(svg, use);
    },
    p(ctx2, [dirty]) {
      if (dirty & /*symbolId*/
      8) {
        attr(
          use,
          "href",
          /*symbolId*/
          ctx2[3]
        );
      }
      if (dirty & /*color*/
      1) {
        attr(
          use,
          "fill",
          /*color*/
          ctx2[0]
        );
      }
      if (dirty & /*strokeColor*/
      2) {
        attr(
          use,
          "stroke",
          /*strokeColor*/
          ctx2[1]
        );
      }
      if (dirty & /*className*/
      4) {
        attr(
          svg,
          "class",
          /*className*/
          ctx2[2]
        );
      }
    },
    i: noop$1,
    o: noop$1,
    d(detaching) {
      if (detaching) {
        detach(svg);
      }
    }
  };
}
function instance($$self, $$props, $$invalidate) {
  let symbolId;
  let { prefix = "icon" } = $$props;
  let { name = "" } = $$props;
  let { color: color2 = "#333" } = $$props;
  let { strokeColor = "" } = $$props;
  let { className = "" } = $$props;
  $$self.$$set = ($$props2) => {
    if ("prefix" in $$props2)
      $$invalidate(4, prefix = $$props2.prefix);
    if ("name" in $$props2)
      $$invalidate(5, name = $$props2.name);
    if ("color" in $$props2)
      $$invalidate(0, color2 = $$props2.color);
    if ("strokeColor" in $$props2)
      $$invalidate(1, strokeColor = $$props2.strokeColor);
    if ("className" in $$props2)
      $$invalidate(2, className = $$props2.className);
  };
  $$self.$$.update = () => {
    if ($$self.$$.dirty & /*prefix, name*/
    48) {
      $$invalidate(3, symbolId = `#${prefix}-${name}`);
    }
  };
  return [color2, strokeColor, className, symbolId, prefix, name];
}
class Svgicon2 extends SvelteComponent {
  constructor(options) {
    super();
    init(this, options, instance, create_fragment, safe_not_equal, {
      prefix: 4,
      name: 5,
      color: 0,
      strokeColor: 1,
      className: 2
    });
  }
  get prefix() {
    return this.$$.ctx[4];
  }
  set prefix(prefix) {
    this.$$set({ prefix });
    flush();
  }
  get name() {
    return this.$$.ctx[5];
  }
  set name(name) {
    this.$$set({ name });
    flush();
  }
  get color() {
    return this.$$.ctx[0];
  }
  set color(color2) {
    this.$$set({ color: color2 });
    flush();
  }
  get strokeColor() {
    return this.$$.ctx[1];
  }
  set strokeColor(strokeColor) {
    this.$$set({ strokeColor });
    flush();
  }
  get className() {
    return this.$$.ctx[2];
  }
  set className(className) {
    this.$$set({ className });
    flush();
  }
}
create_custom_element(Svgicon2, { "prefix": {}, "name": {}, "color": {}, "strokeColor": {}, "className": {} }, [], [], true);
export {
  IMetricsKeysOrder as I,
  Liquidity as L,
  MetricDisplay as M,
  Profitability as P,
  Report as R,
  Stocks as S,
  Winrate as W,
  Ratio as a,
  Risk as b,
  calculateScores as c,
  StrategyAnalytic as d,
  Svgicon2 as e,
  orderMetricsByKeys as o,
  qualityMetrics as q
};
